using ..GenericCharacterTables
import ..GenericCharacterTables: ExtendableMatrix, SimpleCharTable
using Oscar
R, q = polynomial_ring(QQ, "q")

order = q^15*(q-1)^6*(q+1)^3*(q^2+q+1)^2*(q^2+1)*(q^2-q+1)*(q^4+q^3+q^2+q+1)
table = QQPolyRingElem[[
	(q+1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q+1)^2*(q^2+q+1)*(q^2+1),
	(q+1)*(5*q^3+4*q^2+2*q+1),
	(q+1)^2*(q^2+q+1),
	(q+1)*(3*q^2+2*q+1),
	(q+1)*(3*q+1),
	(q+1)*(2*q+1),
	4*q+1,
	2*q+1,
	R(1),
	R(1)] [
	-(q-1)*(q+1)^2*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	-(q-1)*(q+1)*(q^2+q+1)*(q^2+1),
	(q+1)*(-q^3+2*q^2+1),
	-(q-1)*(q+1)*(q^2+q+1),
	-q^3+q^2+q+1,
	(q+1)^2,
	(q+1),
	2*q+1,
	R(1),
	R(1),
	R(1)] [
	-(q-1)*(q+1)^2*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q+1)^2*(q^2+1)*(q^2-q+1),
	-(q-1)*(3*q^3+2*q^2+2*q+1),
	(q+1)*(q^3+2*q^2+1),
	(q+1)*(q^2+1),
	-(q-1)*(q+1),
	2*q^2+q+1,
	R(1),
	2*q+1,
	R(1),
	R(1)] [
	(q-1)^2*(q+1)*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q^2+q+1)*(q^2+1),
	(q-1)*(q^3-2*q^2-1),
	-(q+1)*(3*q^3-2*q^2+2*q-1),
	-(q-1)*(q^2+1),
	-(q-1)*(q+1),
	2*q^2-q+1,
	R(1),
	-2*q+1,
	R(1),
	R(1)] [
	(q-1)^2*(q+1)^3*(q^2+q+1)*(q^2-q+1),
	-(q-1)*(q+1)^3*(q^2-q+1),
	(q-1)*(q+1)*(q^2-q-1),
	(q+1)^2*(q^2-q+1),
	-(q-1)*(q+1)^2,
	-(q-1)*(q+1),
	(q+1),
	R(1),
	2*q+1,
	R(1),
	R(1)] [
	(q-1)^2*(q+1)*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	-(q-1)*(q+1)*(q^2+1)*(q^2-q+1),
	-(q-1)*(q+1)*(q^2-q+1),
	-(q-1)*(q^3+2*q^2+1),
	q^3+q^2-q+1,
	(q-1)^2,
	-(q-1),
	-2*q+1,
	R(1),
	R(1),
	R(1)] [
	(q-1)^2*(q+1)^3*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q+1)^2*(q^2+1),
	-(q-1)*(q+1)*(q^2+1),
	(q-1)^2*(q+1)^2,
	-(q-1)*(q+1),
	(q+1),
	-(q-1)*(q+1),
	(q+1),
	-(q-1),
	R(1),
	R(1)] [
	-(q-1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q^2-q+1),
	(q-1)*(5*q^3-4*q^2+2*q-1),
	-(q-1)*(3*q^2-2*q+1),
	(q-1)*(3*q-1),
	(q-1)*(2*q-1),
	-4*q+1,
	-2*q+1,
	R(1),
	R(1)] [
	-(q-1)^3*(q+1)^2*(q^2+q+1)*(q^2-q+1),
	-(q-1)^3*(q+1)*(q^2+q+1),
	(q-1)^2*(q^2+q+1),
	(q-1)*(q+1)*(q^2+q-1),
	(q-1)^2*(q+1),
	-(q-1)*(q+1),
	-(q-1),
	R(1),
	-2*q+1,
	R(1),
	R(1)] [
	-(q-1)^3*(q+1)^2*(q^2+q+1)*(q^2+1),
	(q-1)^2*(q+1)^2*(q^2+1),
	(q-1)^2*(q+1)^2,
	-(q-1)*(q+1)*(q^2+1),
	-(q-1)*(q+1),
	-(q-1),
	-(q-1)*(q+1),
	-(q-1),
	(q+1),
	R(1),
	R(1)]]
classinfo = Vector{Any}[["u_1"], ["u_2"], ["u_3"], ["u_4"], ["u_5"], ["u_6"], ["u_7"], ["u_8"], ["u_9"], ["u_{10}"], ["u_{11}"]]
classlength = R.([
	1,
	q^6-1,
	1//2*q*(q+1)*(q^2+1)*(q^6-1),
	1//2*q*(q-1)*(q^2+1)*(q^6-1),
	q^2*(q^4-1)*(q^6-1),
	q^4*(q^4-1)*(q^6-1),
	q^4*(q^4-1)*(q^6-1),
	1//2*q^4*(q^2-1)*(q^4-1)*(q^6-1),
	1//2*q^4*(q^2-1)*(q^4-1)*(q^6-1),
	1//2*q^6*(q^2-1)*(q^4-1)*(q^6-1),
	1//2*q^6*(q^2-1)*(q^4-1)*(q^6-1)])
classtypeorder = R.([1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1])
charinfo = Vector{Any}[
	[[1,1,1],[]],
	[[2,1],[]],
	[[1,1],[1]],
	[[2],[1]],
	[[1],[2]],
	[[1],[1,1]],
	[[3],[]],
	[[],[1,1,1]],
	[[],[2,1]],
	[[],[3]]]
chardegree = R.([
	(q+1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	-(q-1)*(q+1)^2*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	-(q-1)*(q+1)^2*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q+1)*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q+1)^3*(q^2+q+1)*(q^2-q+1),
	(q-1)^2*(q+1)*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q+1)^3*(q^2+1)*(q^2-q+1),
	-(q-1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	-(q-1)^3*(q+1)^2*(q^2+q+1)*(q^2-q+1),
	-(q-1)^3*(q+1)^2*(q^2+q+1)*(q^2+1)])

information = "- Information about the Green functions of \$GL_6(2^n):2\$.

- CHEVIE-name of the table: ``GL6e2green``

- The table was first computed in:
  {\\sc G. Malle}, Generalized Deligne-Lusztig characters,
    {\\em J. Algebra \\bf159} (1993), 64--97.
"

TABLE=SimpleCharTable(order,ExtendableMatrix(permutedims(table)),classinfo,classlength,classtypeorder,charinfo,chardegree,R,information)
