using ..GenericCharacterTables
import ..GenericCharacterTables: ExtendableMatrix, SimpleCharTable
using Oscar
R, q = polynomial_ring(QQ, "q")

order = q^12*(q-1)^4*(q+1)^4*(q^2+1)^2*(q^2+q+1)*(q^2-q+1)
table = QQPolyRingElem[[
	(q+1)^4*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	(q+1)^3*(4*q^4+3*q^3+3*q^2+q+1),
	(q+1)^2*(q^2+1)*(3*q^2+2*q+1),
	(q+1)^2*(q^2+1)*(3*q^2+2*q+1),
	(q+1)^2*(q^2+1)*(3*q^2+2*q+1),
	(q+1)*(2*q^3+6*q^2+3*q+1),
	14*q^3+13*q^2+4*q+1,
	(q+1)^2*(2*q+1),
	(q+1)*(3*q+1),
	(q+1)*(3*q+1),
	(q+1)*(3*q+1),
	4*q+1,
	R(1),
	R(1)] [
	-(q-1)*(q+1)^3*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	-(q+1)^2*(2*q^5-q^4-2*q^2-1),
	-(q+1)*(q^2+1)*(q^3-q^2-q-1),
	-(q+1)*(q^2+1)*(q^3-q^2-q-1),
	-(q+1)*(q^2+1)*(q^3-q^2-q-1),
	3*q^2+2*q+1,
	5*q^2+2*q+1,
	(q+1)^2,
	(q+1)^2,
	(q+1)^2,
	(q+1)^2,
	2*q+1,
	R(1),
	R(1)] [
	(q-1)^2*(q+1)^4*(q^2+1)^2*(q^2-q+1),
	(q-1)*(q+1)^3*(q^3-2*q^2+q-1),
	-(q-1)*(q+1)^2*(q^2+1),
	-(q-1)*(q+1)^2*(q^2+1),
	-(q-1)*(q+1)^2*(q^2+1),
	-(q-1)*(q+1)*(q^2+q+1),
	-q^3+q^2+q+1,
	-(q-1)*(q+1)^2,
	q+1,
	q+1,
	q+1,
	q+1,
	R(1),
	R(1)] [
	(q-1)^2*(q+1)^2*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	-(q-1)*(q+1)*(q^2+1)^2,
	-(q-1)*(q+1)*(q^2+1)^2,
	-(q-1)*(q+1)*(q^2+1)^2,
	(q^2+1)*(3*q^4+1),
	2*q^4+q^2+1,
	-(q-1)*(2*q^2+q+1),
	(q+1)*(2*q^2-q+1),
	-(q-1)*(q+1),
	3*q^2+1,
	-(q-1)*(q+1),
	R(1),
	R(1),
	R(1)] [
	-(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q+1)^2*(q^2+1),
	(q-1)^2*(q+1)^2*(q^2+1),
	(q-1)^2*(q+1)^2*(q^2+1),
	-(q-1)*(q+1)*(q^4+1),
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	q^2+1,
	-(q-1)*(q+1),
	R(1),
	R(1),
	R(1)] [
	(q-1)^2*(q+1)^2*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	-(q-1)*(q+1)*(q^2+1)^2,
	-(q-1)*(q+1)*(q^2+1)^2,
	(q^2+1)*(3*q^4+1),
	-(q-1)*(q+1)*(q^2+1)^2,
	2*q^4+q^2+1,
	-(q-1)*(2*q^2+q+1),
	(q+1)*(2*q^2-q+1),
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	3*q^2+1,
	R(1),
	R(1),
	R(1)] [
	-(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q+1)^2*(q^2+1),
	(q-1)^2*(q+1)^2*(q^2+1),
	-(q-1)*(q+1)*(q^4+1),
	(q-1)^2*(q+1)^2*(q^2+1),
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	q^2+1,
	R(1),
	R(1),
	R(1)] [
	(q-1)^2*(q+1)^2*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	-(q-1)*(q+1)*(q^2+1)^2,
	(q^2+1)*(3*q^4+1),
	-(q-1)*(q+1)*(q^2+1)^2,
	-(q-1)*(q+1)*(q^2+1)^2,
	2*q^4+q^2+1,
	-(q-1)*(2*q^2+q+1),
	(q+1)*(2*q^2-q+1),
	3*q^2+1,
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	R(1),
	R(1),
	R(1)] [
	-(q-1)^3*(q+1)*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	(q-1)^2*(2*q^5+q^4+2*q^2+1),
	-(q-1)*(q^2+1)*(q^3+q^2-q+1),
	-(q-1)*(q^2+1)*(q^3+q^2-q+1),
	-(q-1)*(q^2+1)*(q^3+q^2-q+1),
	3*q^2-2*q+1,
	(q-1)^2,
	5*q^2-2*q+1,
	(q-1)^2,
	(q-1)^2,
	(q-1)^2,
	-2*q+1,
	R(1),
	R(1)] [
	-(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q+1)^2*(q^2+1),
	-(q-1)*(q+1)*(q^4+1),
	(q-1)^2*(q+1)^2*(q^2+1),
	(q-1)^2*(q+1)^2*(q^2+1),
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	q^2+1,
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	R(1),
	R(1),
	R(1)] [
	(q-1)^4*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	-(q-1)^3*(4*q^4-3*q^3+3*q^2-q+1),
	(q-1)^2*(q^2+1)*(3*q^2-2*q+1),
	(q-1)^2*(q^2+1)*(3*q^2-2*q+1),
	(q-1)^2*(q^2+1)*(3*q^2-2*q+1),
	(q-1)*(2*q^3-6*q^2+3*q-1),
	-(q-1)^2*(2*q-1),
	-14*q^3+13*q^2-4*q+1,
	(q-1)*(3*q-1),
	(q-1)*(3*q-1),
	(q-1)*(3*q-1),
	-4*q+1,
	R(1),
	R(1)] [
	(q-1)^4*(q+1)^4*(q^2+q+1)*(q^2-q+1),
	-(q-1)^3*(q+1)^3,
	-(q-1)^3*(q+1)^3,
	-(q-1)^3*(q+1)^3,
	-(q-1)^3*(q+1)^3,
	(q-1)*(q+1)*(2*q^2-1),
	(q-1)^2*(2*q+1),
	-(q+1)^2*(2*q-1),
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	R(1),
	R(1),
	R(1)] [
	(q-1)^4*(q+1)^2*(q^2+q+1)*(q^2+1)^2,
	-(q-1)^3*(q+1)*(q^3+2*q^2+q+1),
	(q-1)^2*(q+1)*(q^2+1),
	(q-1)^2*(q+1)*(q^2+1),
	(q-1)^2*(q+1)*(q^2+1),
	-(q-1)*(q+1)*(q^2-q+1),
	(q-1)^2*(q+1),
	q^3+q^2-q+1,
	-q+1,
	-q+1,
	-q+1,
	-q+1,
	R(1),
	R(1)]]
classinfo = Vector{Any}[
	["1^8"],
	["2_0^21^4"],
	["2_0^4"],
	["2_0^4"],
	["2^21^4"],
	["2^4"],
	["3^21^2"],
	["3^21^2"],
	["4_0^2"],
	["4_0^2"],
	["421^2"],
	["4^2"],
	["62"],
	["62"]]
classlength = R.([
	1,
	(q-1)*(q+1)*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	q^2*(q-1)^2*(q+1)^2*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	q^2*(q-1)^2*(q+1)^2*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	q^2*(q-1)^2*(q+1)^2*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	q^2*(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	1//2*q^4*(q-1)^2*(q+1)^4*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	1//2*q^4*(q-1)^4*(q+1)^2*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	q^6*(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	q^6*(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	q^6*(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	q^6*(q-1)^4*(q+1)^4*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	1//2*q^8*(q-1)^4*(q+1)^4*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	1//2*q^8*(q-1)^4*(q+1)^4*(q^2+q+1)*(q^2+1)^2*(q^2-q+1)])
classtypeorder = R.([1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1])
charinfo = Vector{Any}[
	[[[1,1,1,1],[]]],
	[[[2,1,1],[]]],
	[[[3,1],[]]],
	[[[2,2],["+"]]],
	[[[4],["+"]]],
	[[[2,2],["-"]]],
	[[[4],["-"]]],
	[[[1,1],[1,1]]],
	[[[2],[1,1]]],
	[[[1],[2,1]]],
	[[[],[1,1,1,1]]],
	[[[],[2,2]]],
	[[[],[3,1]]]]
chardegree = R.([
	(q+1)^4*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	-(q-1)*(q+1)^3*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	(q-1)^2*(q+1)^4*(q^2+1)^2*(q^2-q+1),
	(q-1)^2*(q+1)^2*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	-(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q+1)^2*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	-(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q+1)^2*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	-(q-1)^3*(q+1)*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	-(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^4*(q^2+q+1)*(q^2+1)^2*(q^2-q+1),
	(q-1)^4*(q+1)^4*(q^2+q+1)*(q^2-q+1),
	(q-1)^4*(q+1)^2*(q^2+q+1)*(q^2+1)^2])

information = "- Information about the Green functions of \$O_8^+(q)\$.

- CHEVIE-name of the table: ``D4p2green``

- The table was published in:
  {\\sc G. Malle}, Green functions for groups of types E_6 and F_4 in
    characteristic 2, {\\em Comm. Algebra \\bf21} (1993), 747--798.

- The notation for the unipotent classes is taken from:
  {\\sc N. Spaltenstein}, Classes unipotents et sous-groupes de Borel,
    Springer Lecture Notes 946, Berlin  - Heidelberg - New York 1982.
"

TABLE=SimpleCharTable(order,ExtendableMatrix(permutedims(table)),classinfo,classlength,classtypeorder,charinfo,chardegree,R,information)
