using ..GenericCharacterTables
import ..GenericCharacterTables: ExtendableMatrix, SimpleCharTable
using Oscar
R, q = polynomial_ring(QQ, "q")

order = q^20*(q-1)^5*(q+1)^4*(q^2+1)^2*(q^2+q+1)*(q^2-q+1)*(q^4+1)*(q^4+q^3+q^2+q+1)
table = QQPolyRingElem[[
	(q+1)^4*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	(q+1)^3*(q^2+q+1)*(q^2+1)*(5*q^6+4*q^5+4*q^4+3*q^3+2*q^2+q+1),
	(q+1)^2*(q^2+1)*(10*q^6+15*q^5+15*q^4+10*q^3+6*q^2+3*q+1),
	(q+1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1)*(4*q^3+3*q^2+2*q+1),
	(q+1)^2*(5*q^6+15*q^5+16*q^4+13*q^3+7*q^2+3*q+1),
	(q+1)^2*(25*q^5+26*q^4+18*q^3+7*q^2+3*q+1),
	(q+1)^2*(q^2+1)*(5*q^3+6*q^2+3*q+1),
	(q+1)*(20*q^5+25*q^4+20*q^3+10*q^2+4*q+1),
	(q+1)*(10*q^4+15*q^3+10*q^2+4*q+1),
	(q+1)^2*(q^2+1)*(6*q^2+3*q+1),
	(q+1)*(5*q^3+10*q^2+4*q+1),
	25*q^3+19*q^2+5*q+1,
	(q+1)*(5*q^2+4*q+1),
	(q+1)*(20*q^3+15*q^2+4*q+1),
	10*q^2+5*q+1,
	(q+1)*(4*q+1),
	(q+1)*(4*q+1),
	5*q+1,
	R(1),
	R(1)] [
	-(q-1)*(q+1)^3*(q^2+q+1)*(q^2+1)^2*(q^2-q+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	-(q^2+q+1)*(3*q^7-q^6-q^4-q^3-q^2-1)*(q^2+1)*(q+1)^2,
	-(q+1)*(q^2+1)*(4*q^7+q^6-2*q^5-5*q^4-4*q^3-3*q^2-2*q-1),
	-(q^2+q+1)*(q^2-q+1)*(2*q^4-q^3-q^2-q-1)*(q^2+1)*(q+1)^2,
	-(q+1)*(q^7+2*q^6-3*q^5-5*q^4-6*q^3-4*q^2-2*q-1),
	-(q+1)*(5*q^6-5*q^5-8*q^4-9*q^3-4*q^2-2*q-1),
	-(q^3-2*q^2-q-1)*(q^2+1)*(q+1)^2,
	-2*q^6+9*q^4+10*q^3+6*q^2+3*q+1+5*q^5,
	(3*q^2+q+1)*(q+1)^2,
	(q+1)*(q^2+1)*(3*q^2+2*q+1),
	6*q^2+3*q+1+q^4+3*q^3,
	9*q^2+3*q+1+5*q^3,
	(q+1)^3,
	(q+1)*(2*q^3+7*q^2+2*q+1),
	4*q^2+3*q+1,
	(q+1)*(2*q+1),
	(q+1)*(2*q+1),
	3*q+1,
	R(1),
	R(1)] [
	(q-1)^2*(q+1)^2*(q^2+q+1)*(q^2+1)^2*(q^2-q+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	(q-1)*(q+1)*(q^5-q^4-q^3-1)*(q^2+q+1)*(q^2+1)^2,
	(2*q^8-q^7-q^6-q^5+q^4+q^3+q^2+q+1)*(q^2+1),
	-(q-1)*(q^2-q+1)*(q^2+q+1)*(q+1)^2*(q^2+1)^2,
	(q+1)*(q^7-q^5+q^4+2*q^2+1),
	-(q-1)*(3*q^4+q^3+3*q^2+1)*(q+1)^2,
	(q+1)*(q^4-q^3+q^2+1)*(q^2+1),
	(q+1)*(q^2+1)^2,
	(q+1)*(2*q^2+q+1)*(q^2-q+1),
	-(q-1)*(q+1)*(2*q^2+q+1)*(q^2+1),
	q^4+2*q^2+1-q^3+q,
	-3*q^3+3*q^2+1+q,
	(q+1)*(q^2+1),
	-q^3+3*q^2+q+1,
	2*q^2+q+1,
	q+1,
	q+1,
	q+1,
	R(1),
	R(1)] [
	(q-1)^2*(q+1)^4*(q^2+1)^2*(q^2-q+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	(q-1)*(2*q^7-q^6-q^4-q^3-q^2-1)*(q^2+1)*(q+1)^3,
	(q-1)*(q^5-2*q^4-2*q^3-q^2-q-1)*(q^2+1)*(q+1)^2,
	(q-1)*(q^2-q+1)*(q^2+1)*(q^4-q^3-q^2-q-1)*(q+1)^3,
	-(q-1)*(q^5+q^4+3*q^3+2*q^2+q+1)*(q+1)^2,
	(q^3-3*q^2+q-1)*(q^2-q-1)*(q+1)^2,
	-(q-1)*(q^2+q+1)*(q^2+1)*(q+1)^2,
	-(q+1)*(q^5+2*q^4-2*q^3-q^2-q-1),
	-(q+1)*(2*q^4-q^2-q-1),
	(q^2+1)*(q+1)^2,
	-(q+1)*(q^3-q^2-q-1),
	q^3+4*q^2+2*q+1,
	-(q+1)*(q^2-q-1),
	-(q+1)*(q^3-3*q^2-q-1),
	(q+1)^2,
	(q+1)^2,
	(q+1)^2,
	2*q+1,
	R(1),
	R(1)] [
	-(q-1)^3*(q+1)^3*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	(q-1)^2*(q+1)^2*(q^2+1)*(q^4+q^3+q^2+q+1)*(q^2-q+1),
	-(q-1)*(q+1)*(q^2+1)*(q^6-q^5+q^3+1),
	(q-1)^2*(q+1)^2*(q^2+1)*(q^4+q^3+q^2+q+1)*(q^2-q+1),
	-(q-1)*(q+1)*(q^6+q^3+q^2+1),
	(q-1)*(q+1)*(q^5-q^3-q^2-1),
	-(q-1)*(q+1)^2*(q^2+1)*(q^2-q+1),
	q^6-q^5+q^3+1,
	(q+1)*(q^2-q+1),
	-(q-1)*(q+1)*(q^2+1),
	q^4+1,
	-(q-1)*(q^2+q+1),
	(q+1)*(q^2-q+1),
	-(q-1)*(q+1)*(q^2+1),
	q^2+1,
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	R(1),
	R(1),
	R(1)] [
	-(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	-(q^2+1)*(q^5-q^4-q^3-1)*(q^2+q+1)*(q-1)^2*(q+1)^2,
	(q-1)*(q+1)*(q^7+q^6+q^5-q^4-q^3-q^2-q-1),
	(q^2+1)*(q^2-q+1)*(q^2+q+1)*(q-1)^2*(q+1)^3,
	(q-1)*(q^5-q^2-1)*(q+1)^2,
	(q-1)*(q+1)^3*(q^3-2*q^2+q-1),
	(q-1)*(q+1)*(q^3-q-1)*(q^2+1),
	-(q-1)*(q+1)^2*(q^2+1),
	-(q-1)*(q+1)*(q^2+q+1),
	-(q-1)*(q+1)^2*(q^2+1),
	-(q-1)*(q+1)*(q^2+q+1),
	-q^3+q^2+q+1,
	-(q-1)*(q+1)^2,
	-q^3+q^2+q+1,
	q+1,
	q+1,
	q+1,
	q+1,
	R(1),
	R(1)] [
	(q-1)^4*(q+1)^4*(q^2+q+1)*(q^2+1)^2*(q^2-q+1)*(q^4+1),
	-(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q+1)^2*(q^2+1),
	-(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q+1)^2*(q^2+1),
	(q-1)^2*(q+1)^2*(q^2+1),
	(q-1)^2*(q+1)^2*(q^2+1),
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	(q-1)^2*(q+1)^2*(q^2+1),
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	R(1),
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	R(1),
	R(1),
	R(1)] [
	(q-1)^2*(q+1)^2*(q^2+q+1)*(q^2+1)^2*(q^2-q+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	(q-1)*(q+1)*(q^5-q^4-q^3-1)*(q^2+q+1)*(q^2+1)^2,
	-(q-1)*(q+1)*(2*q^4+q^3+q^2+q+1)*(q^2+1)^2,
	(q+1)*(q^2-q+1)*(q^2+q+1)*(4*q^5-q^4+1)*(q^2+1),
	(q+1)*(5*q^7+3*q^5+q^4+2*q^2+1),
	(q-1)*(q^6-7*q^5-4*q^4-7*q^3-4*q^2-2*q-1),
	(q+1)*(q^2+1)*(5*q^4-q^3+q^2+1),
	-(q-1)*(4*q^3+3*q^2+2*q+1)*(q^2+1),
	(q+1)*(2*q^2+q+1)*(q^2-q+1),
	(6*q^4+3*q^3+q^2+q+1)*(q^2+1),
	5*q^4+2*q^2+1+3*q^3+q,
	q^3+3*q^2+1+q,
	5*q^3+q^2+1+q,
	-(q-1)*(q+1)*(4*q^2+1+q),
	-(2*q+1)*(q-1),
	4*q^2+1+q,
	4*q^2+1+q,
	q+1,
	R(1),
	R(1)] [
	(q-1)^4*(q^2+q+1)*(q^2+1)^2*(q^2-q+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	-(q^2+q+1)*(3*q^6-2*q^5+2*q^4-q^3+2*q^2-q+1)*(q^2+1)*(q-1)^3,
	(2*q^4-q^3+q^2-q+1)*(q-1)^2*(q^2+1)^2,
	(q^2+1)*(q^2+q+1)*(4*q^4-q^3+q^2-q+1)*(q^2-q+1)*(q-1)^2,
	(q-1)*(5*q^7-10*q^6+9*q^5-11*q^4+6*q^3-4*q^2+2*q-1),
	-(7*q^5-6*q^4+6*q^3-3*q^2+q-1)*(q-1)^2,
	-(11*q^5-8*q^4+4*q^3-5*q^2+3*q-1)*(q^2+1),
	(4*q^4-3*q^3+3*q^2-q+1)*(q-1)^2,
	-(q-1)*(6*q^4-3*q^3+4*q^2-2*q+1),
	(q-1)*(2*q-1)*(3*q^2+1)*(q^2+1),
	(q-1)*(5*q^3-4*q^2+2*q-1),
	-7*q^3+3*q^2-3*q+1,
	-11*q^3+9*q^2-3*q+1,
	(q-1)*(4*q^3-q^2+2*q-1),
	(q-1)*(2*q-1),
	4*q^2-3*q+1,
	4*q^2-3*q+1,
	-3*q+1,
	R(1),
	R(1)] [
	-(q-1)^3*(q+1)*(q^2+q+1)*(q^2+1)^2*(q^2-q+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	(q^2+1)*(q^2+q+1)*(q^3+q^2+1)*(q^4+1)*(q-1)^2,
	-(q-1)*(q^4+1)*(q^2+1)^2,
	-(q-1)*(q+1)*(q^2+q+1)*(q^2-q+1)*(2*q^4-q^3+q^2-q+1)*(q^2+1),
	-(q^6-q^5-2*q^4+q^3-q^2+q-1)*(q^2+1),
	(q+1)*(3*q^4-q^3+3*q^2+1)*(q-1)^2,
	-(q^5-4*q^4-q^2+q-1)*(q^2+1),
	-(q-1)*(2*q^5+q^4+2*q^2+1),
	-q^3+2*q^2-q+1+3*q^4,
	-(q-1)*(q^2+1)^2,
	(q^2-q+1)*(q^2+1),
	q^2-q+1-3*q^3,
	3*q^2-q+1+q^3,
	(2*q^2+q+1)*(q-1)^2,
	-q+1,
	2*q^2-q+1,
	2*q^2-q+1,
	-q+1,
	R(1),
	R(1)] [
	(q-1)^4*(q+1)^2*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	-(q-1)^3*(q+1)*(q^2+1)*(2*q^7+q^6+q^4+q^3+q^2+1),
	(q-1)^2*(q+1)*(q^2+1)^2*(q^3-q+1),
	(q-1)^2*(q+1)*(q^2+1)*(q^2-q+1)*(q^5+2*q^4+1),
	-(q-1)*(q+1)*(q^6-2*q^5+4*q^4-3*q^3+3*q^2-2*q+1),
	(q-1)^2*(q^5-q^3+q^2+1),
	-(q-1)*(q+1)*(q^2+1)*(q^3+2*q^2-2*q+1),
	-(q-1)*(q^2+1)*(q^3-q+1),
	(q+1)*(q^2-q+1)*(2*q^2-2*q+1),
	(q-1)^2*(q^2+1),
	-(q-1)*(q^3+q^2-q+1),
	(q-1)*(q^2+q-1),
	-q^3+4*q^2-2*q+1,
	-(q-1)^3*(q+1),
	(q-1)^2,
	(q-1)^2,
	(q-1)^2,
	-2*q+1,
	R(1),
	R(1)] [
	-(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	-(q^2+1)*(q^5-q^4-q^3-1)*(q^2+q+1)*(q-1)^2*(q+1)^2,
	(2*q^4+q^3+q^2+q+1)*(q^2+1)*(q-1)^2*(q+1)^2,
	-(q-1)*(q^2-q+1)*(2*q^5-q^4+1)*(q^2+q+1)*(q+1)^2,
	-(q-1)*(q^5+q^2+1)*(q+1)^2,
	-(q-1)*(q+1)*(q^5-2*q^4+2*q^3+q^2+q+1),
	-(q-1)*(q+1)*(q^5+2*q^4+q^2+q+1),
	(q-1)*(q+1)*(2*q^4-q^3-q^2-q-1),
	-(q-1)*(q+1)*(q^2+q+1),
	(q^3+q^2-q+1)*(q+1)^2,
	(q^2-q+1)*(q+1)^2,
	(q+1)*(q^2+1),
	-q^2+1+q^3+q,
	-(q-1)*(q+1)*(2*q^2+q+1),
	-(2*q+1)*(q-1),
	2*q^2+q+1,
	2*q^2+q+1,
	q+1,
	R(1),
	R(1)] [
	(q-1)^4*(q+1)^2*(q^2+q+1)*(q^2+1)*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	-(q-1)^3*(q+1)*(q^2+q+1)*(q^4+1)*(q^3+q^2+1),
	(q-1)^2*(q+1)*(q^2+1)*(q^4+1),
	(q-1)^2*(q+1)*(q^2+q+1)*(q^2-q+1)*(q^4+1),
	(q-1)*(q^7-q^5-q^4-1),
	(q-1)^2*(q+1)*(q^4-q^3+q^2+1),
	(q-1)*(q+1)*(q^5-2*q^4-q^2+q-1),
	-(q-1)*(q^4+1),
	-(q-1)*(2*q^4+q^3+1),
	-(q-1)*(q+1)*(2*q^4-q^3+q^2-q+1),
	q^4+q^3-q+1,
	(q-1)^2*(q+1),
	q^3+q^2-q+1,
	(q-1)^2*(q+1),
	-q+1,
	-q+1,
	-q+1,
	-q+1,
	R(1),
	R(1)] [
	(q-1)^4*(q+1)^2*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^4+1),
	-(q+1)*(q^2+q+1)*(q^4+q^3+q^2+q+1)*(q^2+1)*(q-1)^3,
	-(q+1)*(q^3-q-1)*(q-1)^2*(q^2+1)^2,
	(q^2+q+1)*(q^4-q^3+q^2-q+1)*(q^2+1)*(q-1)^2*(q+1)^2,
	-(q-1)*(q+1)*(q^6-q^3+q^2+1),
	-(q^3-2*q^2-1)*(q-1)^2*(q+1)^2,
	(q^5+2*q^4-q^3-q^2+1)*(q^2+1),
	(q+1)*(q^3+2*q^2+q+1)*(q-1)^2,
	-(q-1)*(q^2+q+1),
	-(q-1)*(q+1)*(q^2+1),
	-(q-1)*(q+1)*(q^2+1),
	-(q-1)*(q^2+q+1),
	(q+1)*(q^2-q+1),
	(q-1)*(q^3-q^2-q-1),
	-(q-1)*(q+1),
	q^2+1,
	q^2+1,
	R(1),
	R(1),
	R(1)] [
	(q-1)^4*(q+1)^4*(q^2+q+1)*(q^2-q+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	(q^5-q^4-q^3-1)*(q^2+q+1)*(q-1)^3*(q+1)^3,
	-(2*q^4+q^3+q^2+q+1)*(q-1)^3*(q+1)^3,
	-(q^2+q+1)*(q^2-q+1)*(q-1)^3*(q+1)^4,
	(q-1)*(q^5+q^2-1)*(q+1)^2,
	(q^3+q+1)*(q-1)^2*(q+1)^2,
	-(3*q^5-2*q^4+q^2+q-1)*(q+1)^2,
	(q-1)^2*(q+1)^3,
	(q-1)*(q+1)*(2*q^3+q^2-q-1),
	-(q-1)*(2*q^3-q^2+1)*(q+1)^2,
	(q-1)*(q+1)*(q^2-q-1),
	-q^2+1+q^3+q,
	-(q+1)*(3*q^2-1),
	-(q-1)*(q+1)^2,
	-(2*q+1)*(q-1),
	q+1,
	q+1,
	q+1,
	R(1),
	R(1)] [
	-(q-1)^5*(q+1)*(q^2+q+1)*(q^2+1)*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	(q-1)^4*(q+1)*(q^2+q+1)*(3*q^6-2*q^5+2*q^4-q^3+2*q^2-q+1),
	-(q-1)^3*(q+1)*(q^2+1)*(2*q^4-q^3+q^2-q+1),
	-(q-1)^3*(q^2+q+1)*(q^2-q+1)*(2*q^5+3*q^4+1),
	-(q-1)^2*(q^6-q^5-4*q^4+q^3-q^2+q-1),
	-(q-1)^4*(q^3-2*q^2-q-1),
	(q-1)*(q+1)*(7*q^5-6*q^4+4*q^3-5*q^2+3*q-1),
	(q-1)^2*(2*q^4-q^3+q^2-q+1),
	-(q-1)*(q^3+2*q^2-2*q+1),
	-(q-1)^2*(3*q^3-q^2+q-1),
	(q-1)^2*(q^2-q+1),
	(q-1)*(q^2+2*q-1),
	-7*q^3+7*q^2-3*q+1,
	-(q-1)^2*(q+1)*(2*q-1),
	(q-1)*(2*q-1),
	(q-1)*(2*q-1),
	(q-1)*(2*q-1),
	-3*q+1,
	R(1),
	R(1)] [
	-(q-1)^5*(q+1)^3*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1),
	(q-1)^4*(q+1)^2*(q^2+q+1)*(q^2+1)*(q^3+q^2+1),
	-(q-1)^3*(q+1)^2*(q^2+1)^2,
	-(q-1)^3*(q+1)^2*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q+1)*(q^5+q^2+1),
	-(q-1)^3*(q+1)*(q^3+2*q^2+q+1),
	-(q-1)*(q+1)*(q^2+1)*(q^3-q+1),
	(q-1)^2*(q+1)*(q^2+1),
	-(q-1)*(q+1)*(q^2-q+1),
	(q-1)^2*(q+1)*(q^2+1),
	-(q-1)*(q+1)*(q^2-q+1),
	(q-1)^2*(q+1),
	q^3+q^2-q+1,
	(q-1)^2*(q+1),
	-q+1,
	-q+1,
	-q+1,
	-q+1,
	R(1),
	R(1)] [
	-(q-1)^5*(q+1)^3*(q^2+q+1)*(q^2+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	(q-1)^4*(q+1)^2*(q^2+q+1)*(q^4+q^3+q^2+q+1),
	(q-1)^3*(q+1)^2*(q^2+1)*(q^3-q-1),
	(q-1)^4*(q+1)^2*(q^2+q+1)*(q^4+q^3+q^2+q+1),
	-(q-1)^2*(q+1)*(q^5+q^4+q^3-q-1),
	-(q-1)^3*(q+1)^2*(q^2+q+1),
	(q-1)*(q+1)*(q^5+q^3+q^2-1),
	-(q-1)^2*(q+1)*(q^3-q-1),
	(q-1)*(2*q^3+q^2-q-1),
	(q-1)^2*(q+1)^2,
	(q-1)^2*(q+1)^2,
	(q-1)*(q^2-q-1),
	-(q+1)*(q^2+q-1),
	(q-1)^2*(q+1)^2,
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	-(q-1)*(q+1),
	R(1),
	R(1),
	R(1)]]
classinfo = Vector{Any}[
	["1^{10}"],
	["2_0^21^6"],
	["2_0^41^2"],
	["2^21^6"],
	["2^41^2"],
	["3^21^4"],
	["3^21^4"],
	["3^22_0^2"],
	["3^22^2"],
	["421^4"],
	["42^3"],
	["4_0^21^2"],
	["4^21^2"],
	["4^21^2"],
	["5^2"],
	["621^2"],
	["621^2"],
	["64"],
	["82"],
	["82"]]
classlength = R.([
	1,
	(q-1)*(q+1)*(q^2+1)*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	q^2*(q-1)^2*(q+1)^2*(q^2+q+1)*(q^2+1)*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	q^3*(q-1)^2*(q+1)*(q^2+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	q^3*(q-1)^3*(q+1)^2*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	1//2*q^6*(q-1)^2*(q+1)^2*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	1//2*q^6*(q-1)^4*(q+1)^2*(q^2+q+1)*(q^2+1)*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	q^6*(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	q^7*(q-1)^4*(q+1)^3*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	q^9*(q-1)^3*(q+1)^2*(q^2+q+1)*(q^2+1)*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	q^9*(q-1)^4*(q+1)^3*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	1//2*q^10*(q-1)^4*(q+1)^4*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	1//2*q^10*(q-1)^5*(q+1)^3*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	q^10*(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	q^12*(q-1)^4*(q+1)^4*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	1//2*q^13*(q-1)^4*(q+1)^3*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	1//2*q^13*(q-1)^4*(q+1)^3*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	q^13*(q-1)^5*(q+1)^4*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	1//2*q^15*(q-1)^5*(q+1)^4*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	1//2*q^15*(q-1)^5*(q+1)^4*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1)])
classtypeorder = R.([1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1])
charinfo = Vector{Any}[
	[[1,1,1,1,1],[]],
	[[2,1,1,1],[]],
	[[2,2,1],[]],
	[[3,1,1],[]],
	[[3,2],[]],
	[[4,1],[]],
	[[5],[]],
	[[1,1,1],[1,1]],
	[[1],[1,1,1,1]],
	[[2,1],[1,1]],
	[[3],[1,1]],
	[[1,1],[2,1]],
	[[2],[2,1]],
	[[1],[3,1]],
	[[1],[2,2]],
	[[],[2,1,1,1]],
	[[],[4,1]],
	[[],[3,2]]]
chardegree = R.([
	(q+1)^4*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	-(q-1)*(q+1)^3*(q^2+q+1)*(q^2+1)^2*(q^2-q+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	(q-1)^2*(q+1)^2*(q^2+q+1)*(q^2+1)^2*(q^2-q+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	(q-1)^2*(q+1)^4*(q^2+1)^2*(q^2-q+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	-(q-1)^3*(q+1)^3*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	-(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	(q-1)^4*(q+1)^4*(q^2+q+1)*(q^2+1)^2*(q^2-q+1)*(q^4+1),
	(q-1)^2*(q+1)^2*(q^2+q+1)*(q^2+1)^2*(q^2-q+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	(q-1)^4*(q^2+q+1)*(q^2+1)^2*(q^2-q+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	-(q-1)^3*(q+1)*(q^2+q+1)*(q^2+1)^2*(q^2-q+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	(q-1)^4*(q+1)^2*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	-(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	(q-1)^4*(q+1)^2*(q^2+q+1)*(q^2+1)*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	(q-1)^4*(q+1)^2*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^4+1),
	(q-1)^4*(q+1)^4*(q^2+q+1)*(q^2-q+1)*(q^4+q^3+q^2+q+1)*(q^4+1),
	-(q-1)^5*(q+1)*(q^2+q+1)*(q^2+1)*(q^4+q^3+q^2+q+1)*(q^2-q+1)*(q^4+1),
	-(q-1)^5*(q+1)^3*(q^2+q+1)*(q^2+1)^2*(q^4+q^3+q^2+q+1)*(q^2-q+1),
	-(q-1)^5*(q+1)^3*(q^2+q+1)*(q^2+1)*(q^4+q^3+q^2+q+1)*(q^4+1)])

information = "- Information about the Green functions of \$O_10^+(2^n)\$.

- CHEVIE-name of the table: ``D5p2green``

- The table was published in:
  {\\sc G. Malle}, Green functions for groups of types E_6 and F_4 in
    characteristic 2, {\\em Comm. Algebra \\bf21} (1993), 747--798.

- The notation for the unipotent classes is taken from:
  {\\sc N. Spaltenstein}, Classes unipotents et sous-groupes de Borel,
    Springer Lecture Notes 946, Berlin  - Heidelberg - New York 1982.
"

TABLE=SimpleCharTable(order,ExtendableMatrix(permutedims(table)),classinfo,classlength,classtypeorder,charinfo,chardegree,R,information)
