using ..GenericCharacterTables
import ..GenericCharacterTables: Cyclotomic, Parameters, Parameter, ParameterException, ParameterSubstitution, ExtendableMatrix, CharTable
using Oscar
R, q = polynomial_ring(QQ, "q")
Q = fraction_field(R)
S = UniversalPolynomialRing(Q, cached=false)
a,b,k,l, _...=gens(S, ["a", "b", "k", "l", "a1", "b1", "k1", "l1", "a2", "b2", "k2", "l2", "a3", "b3", "k3", "l3", "at1", "bt1", "kt1", "lt1", "at2", "bt2", "kt2", "lt2"])

order = q^12*(q^8+q^4+1)*(q^6-1)*(q^2-1)
table = Cyclotomic{QQPolyRingElem}[[
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0))] [
	(q^5-q^3+q)*e2p(S(0)),
	(-q^3+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(-q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^2+q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-q^2+q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0))] [
	(q^3*(q+1)^2*(q^4-q^2+1)*1//2)*e2p(S(0)),
	(q^3*(-q^3+2*q+1)*1//2)*e2p(S(0)),
	(q^3*(q+1)*1//2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	((q^4+q^3+q+1)*1//2)*e2p(S(0)),
	((q^3+1)*1//2)*e2p(S(0)),
	((q+1)*1//2)*e2p(S(0)),
	((-q^2+1)*1//2)*e2p(S(0)),
	((1+q^2)*1//2)*e2p(S(0)),
	(q^3+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3+q^2-q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^3*(q^3+1)^2*1//2)*e2p(S(0)),
	(q^3*(q^3+1)*1//2)*e2p(S(0)),
	(q^3*(q+1)*1//2)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	((q^4+q^3+q+1)*1//2)*e2p(S(0)),
	((q^3+1)*1//2)*e2p(S(0)),
	((q+1)*1//2)*e2p(S(0)),
	((q^2+1)*1//2)*e2p(S(0)),
	((1-q^2)*1//2)*e2p(S(0)),
	(q^3+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^3+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^3*(q^3-1)^2*1//2)*e2p(S(0)),
	(q^3*(-q^3+1)*1//2)*e2p(S(0)),
	(q^3*(-q+1)*1//2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	((-q^4+q^3+q-1)*1//2)*e2p(S(0)),
	((q^3-1)*1//2)*e2p(S(0)),
	((q-1)*1//2)*e2p(S(0)),
	((q^2-1)*1//2)*e2p(S(0)),
	((-1-q^2)*1//2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-2)*e2p(S(0))] [
	(q^3*(q-1)^2*(q^4-q^2+1)*1//2)*e2p(S(0)),
	(q^3*(q^3-2*q+1)*1//2)*e2p(S(0)),
	(q^3*(-q+1)*1//2)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	((-q^4+q^3+q-1)*1//2)*e2p(S(0)),
	((q^3-1)*1//2)*e2p(S(0)),
	((q-1)*1//2)*e2p(S(0)),
	((-q^2-1)*1//2)*e2p(S(0)),
	((q^2-1)*1//2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3-q^2-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(3)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-2)*e2p(S(0))] [
	(q^11-q^9+q^7)*e2p(S(0)),
	(q^7)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^3+q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-q^3-q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0))] [
	(q^12)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0))] [
	(q^8+q^4+1)*e2p(S(0)),
	(q^4+1)*e2p(S(0)),
	(q^4+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^3+q+1)*e2p(S(0)),
	(q^3+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	q^3*e2p(a*S(1//(2)))+1+e2p(a*S(1//(2))),
	1+e2p(a*S(1//(2))),
	(q^2+q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	q*e2p(a*S(1//(2)))+1+e2p(a*S(1//(2))),
	1+e2p(a*S(1//(2))),
	e2p(a*S(1//(2)))+e2p(b*S(1//(2)))+e2p((a+b)*S(1//(2))),
	1-q^3*e2p(a*S(1//(2)))+e2p(a*S(1//(2))),
	1+e2p(a*S(1//(2))),
	e2p(a*S(1//(2))),
	(q^2-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	1-q*e2p(a*S(1//(2)))+e2p(a*S(1//(2))),
	1+e2p(a*S(1//(2))),
	e2p(a*S(1//(2))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p(a*S(1//(2)))+e2p(b*S(1//(2)))+e2p((a+b)*S(1//(2)))] [
	(q^9+q^5+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q^3+q)*e2p(S(0)),
	(q^3+q^2+q)*e2p(S(0)),
	(q^3-q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4+q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	q^3*e2p(a*S(1//(2)))+1+e2p(a*S(1//(2))),
	1+e2p(a*S(1//(2))),
	(q^3+q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	q+q*e2p(a*S(1//(2)))+e2p(a*S(1//(2))),
	e2p(a*S(1//(2))),
	e2p(a*S(1//(2)))+e2p(b*S(1//(2)))+e2p((a+b)*S(1//(2))),
	-1+q^3*e2p(a*S(1//(2)))-e2p(a*S(1//(2))),
	-1-e2p(a*S(1//(2))),
	-e2p(a*S(1//(2))),
	(q^3-q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	q+q*e2p(a*S(1//(2)))-e2p(a*S(1//(2))),
	-e2p(a*S(1//(2))),
	e2p(a*S(1//(2))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p(a*S(1//(2)))-e2p(b*S(1//(2)))-e2p((a+b)*S(1//(2)))] [
	(q^11+q^7+q^3)*e2p(S(0)),
	(q^7+q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4+q^3+1)*e2p(S(0)),
	(q^3+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	q^3+q^3*e2p(a*S(1//(2)))+e2p(a*S(1//(2))),
	e2p(a*S(1//(2))),
	(q^2+q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	q*e2p(a*S(1//(2)))+1+e2p(a*S(1//(2))),
	1+e2p(a*S(1//(2))),
	e2p(a*S(1//(2)))+e2p(b*S(1//(2)))+e2p((a+b)*S(1//(2))),
	q^3+q^3*e2p(a*S(1//(2)))-e2p(a*S(1//(2))),
	-e2p(a*S(1//(2))),
	e2p(a*S(1//(2))),
	(-1-q^2+q)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-1+q*e2p(a*S(1//(2)))-e2p(a*S(1//(2))),
	-1-e2p(a*S(1//(2))),
	-e2p(a*S(1//(2))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p(a*S(1//(2)))-e2p(b*S(1//(2)))-e2p((a+b)*S(1//(2)))] [
	(q^12+q^8+q^4)*e2p(S(0)),
	(q^4)*e2p(S(0)),
	(q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4+q^3+q)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^3+q^3*e2p(a*S(1//(2)))+e2p(a*S(1//(2))),
	e2p(a*S(1//(2))),
	(q^3+q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	q+q*e2p(a*S(1//(2)))+e2p(a*S(1//(2))),
	e2p(a*S(1//(2))),
	e2p(a*S(1//(2)))+e2p(b*S(1//(2)))+e2p((a+b)*S(1//(2))),
	-q^3-q^3*e2p(a*S(1//(2)))+e2p(a*S(1//(2))),
	e2p(a*S(1//(2))),
	-e2p(a*S(1//(2))),
	(-q^3+q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q-q*e2p(a*S(1//(2)))+e2p(a*S(1//(2))),
	e2p(a*S(1//(2))),
	-e2p(a*S(1//(2))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p(a*S(1//(2)))+e2p(b*S(1//(2)))+e2p((a+b)*S(1//(2)))] [
	((q+1)*(q^2+q+1)*(q^2-q+1)*(q^4-q^2+1))*e2p(S(0)),
	(q^4+q+1)*e2p(S(0)),
	((q^2-q+1)*(q+1)^2)*e2p(S(0)),
	((q+1)*(q^2+1))*e2p(S(0)),
	(q^3-q^2+q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q+1)*(e2p(k*S(1//(2)))*q^3+1+e2p(k*S(1//(2)))),
	e2p(k*S(1//(2)))*q^3+1+e2p(k*S(1//(2))),
	(1+e2p(k*S(1//(2))))*(q+1),
	1+e2p(k*S(1//(2))),
	1+e2p(k*S(1//(2))),
	e2p((2*a*k)*S(1//(q-1)))+e2p((-a*k)*S(1//(q-1)))*q^3+e2p((-a*k)*S(1//(q-1)))+q^3*e2p((a*k)*S(1//(q-1)))+e2p((a*k)*S(1//(q-1)))+e2p((-2*a*k)*S(1//(q-1))),
	e2p((2*a*k)*S(1//(q-1)))+e2p((-a*k)*S(1//(q-1)))+e2p((a*k)*S(1//(q-1)))+e2p((-2*a*k)*S(1//(q-1))),
	((q+1)*(q^2+q+1))*e2p(S(0)),
	(2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1+e2p((a*k)*S(1//(q-1)))+e2p((-a*k)*S(1//(q-1))))*(q+1),
	1+e2p((a*k)*S(1//(q-1)))+e2p((-a*k)*S(1//(q-1))),
	e2p((b*k)*S(1//(q-1)))+e2p((-b*k)*S(1//(q-1)))+e2p(((a-b)*k)*S(1//(q-1)))+e2p((-(a-b)*k)*S(1//(q-1)))+e2p((-(a-2*b)*k)*S(1//(q-1)))+e2p(((a-2*b)*k)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	((q+1)*(q^2-q+1))*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((a*k)*S(1//(q-1)))+e2p((-a*k)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^3*(q+1)*(q^2-q+1)*(q^2+q+1)*(q^4-q^2+1))*e2p(S(0)),
	(q^3*(q^4+q+1))*e2p(S(0)),
	(q^3*(q+1))*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q+1)*(e2p(k*S(1//(2)))*q^3+q^3+e2p(k*S(1//(2)))),
	e2p(k*S(1//(2)))*q^3+q^3+e2p(k*S(1//(2))),
	e2p(k*S(1//(2)))*(q+1),
	e2p(k*S(1//(2))),
	e2p(k*S(1//(2))),
	e2p((2*a*k)*S(1//(q-1)))*q^3+e2p((-a*k)*S(1//(q-1)))*q^3+e2p((-a*k)*S(1//(q-1)))+q^3*e2p((a*k)*S(1//(q-1)))+e2p((a*k)*S(1//(q-1)))+e2p((-2*a*k)*S(1//(q-1)))*q^3,
	e2p((a*k)*S(1//(q-1)))+e2p((-a*k)*S(1//(q-1))),
	((q+1)*(q^2+q+1))*e2p(S(0)),
	(2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1+e2p((a*k)*S(1//(q-1)))+e2p((-a*k)*S(1//(q-1))))*(q+1),
	1+e2p((a*k)*S(1//(q-1)))+e2p((-a*k)*S(1//(q-1))),
	e2p((b*k)*S(1//(q-1)))+e2p((-b*k)*S(1//(q-1)))+e2p(((a-b)*k)*S(1//(q-1)))+e2p((-(a-b)*k)*S(1//(q-1)))+e2p((-(a-2*b)*k)*S(1//(q-1)))+e2p(((a-2*b)*k)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-(q+1)*(q^2-q+1))*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-e2p((a*k)*S(1//(q-1)))-e2p((-a*k)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q+1)*(q^4-q^2+1)*(q^2-q+1)^2)*e2p(S(0)),
	((q+1)*(q^2-q+1)*(q^3-q+1))*e2p(S(0)),
	(q^3-q+1)*e2p(S(0)),
	(2*q^3-q^2-q+1)*e2p(S(0)),
	(q^2-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	((q+1)*(q^2-q+1))*e2p(S(0)),
	((q+1)*(q^2-q+1))*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	((q+1)*(q^2-q+1))*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((-a*k)*S(1//(q^2+q+1)))*q^3-e2p((-a*k)*S(1//(q^2+q+1)))*q^2-e2p((-a*k)*S(1//(q^2+q+1)))*q+e2p((-a*k)*S(1//(q^2+q+1)))+e2p(((2*q+1)*a*k)*S(1//(q^2+q+1)))+e2p((a*k)*S(1//(q^2+q+1)))*q^3-e2p((a*k)*S(1//(q^2+q+1)))*q^2-e2p((a*k)*S(1//(q^2+q+1)))*q+e2p((a*k)*S(1//(q^2+q+1)))+e2p((-(2*q+1)*a*k)*S(1//(q^2+q+1))),
	e2p((-(2*q+1)*a*k)*S(1//(q^2+q+1)))+e2p(((2*q+1)*a*k)*S(1//(q^2+q+1)))-e2p((-a*k)*S(1//(q^2+q+1)))*q+e2p((-a*k)*S(1//(q^2+q+1)))-e2p((a*k)*S(1//(q^2+q+1)))*q+e2p((a*k)*S(1//(q^2+q+1))),
	e2p((-(2*q+1)*a*k)*S(1//(q^2+q+1)))+e2p(((2*q+1)*a*k)*S(1//(q^2+q+1)))+e2p((-a*k)*S(1//(q^2+q+1)))+e2p((a*k)*S(1//(q^2+q+1))),
	e2p((-a*k*q)*S(1//(q^2+q+1)))+e2p((a*k*q)*S(1//(q^2+q+1))),
	e2p((-a*k*q)*S(1//(q^2+q+1)))+e2p((a*k*q)*S(1//(q^2+q+1))),
	e2p((-a*k*q)*S(1//(q^2+q+1)))+e2p((a*k*q)*S(1//(q^2+q+1))),
	((q+1)*(q^2-q+1))*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((-(q+1)*a*k)*S(1//(q^2+q+1)))+e2p(((q+1)*a*k)*S(1//(q^2+q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((a*k)*S(1//(q^2+q+1)))+e2p((-a*k)*S(1//(q^2+q+1)))+e2p((-b*k)*S(1//(q^2+q+1)))+e2p((b*k)*S(1//(q^2+q+1)))+e2p((-k*(a*q+a-b*q))*S(1//(q^2+q+1)))+e2p((-k*(a*q+b*q+b))*S(1//(q^2+q+1)))+e2p((k*(a*q+a-b*q))*S(1//(q^2+q+1)))+e2p((k*(a*q+b*q+b))*S(1//(q^2+q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q*(q^4-q^2+1)*(q+1)^2*(q^2-q+1)^2)*e2p(S(0)),
	(q*(q+1)*(q^2-q+1)*(q^3-q^2+1))*e2p(S(0)),
	(q*(q+1)*(q^2-q+1))*e2p(S(0)),
	(-q*(q^2-q-1))*e2p(S(0)),
	(q*(q^2-q+1))*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	((q^2-q+1)*(q+1)^2)*e2p(S(0)),
	((q+1)*(q^2-q+1))*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(2*(q+1)*(q^2-q+1))*e2p(S(0)),
	(2)*e2p(S(0)),
	-(q+1)*(e2p((-a*k)*S(1//(q^2+q+1)))*q^2+e2p((a*k)*S(1//(q^2+q+1)))*q^2-e2p((-(2*q+1)*a*k)*S(1//(q^2+q+1)))*q-e2p(((2*q+1)*a*k)*S(1//(q^2+q+1)))*q-2*e2p((-a*k)*S(1//(q^2+q+1)))*q-2*e2p((a*k)*S(1//(q^2+q+1)))*q+e2p((-a*k)*S(1//(q^2+q+1)))+e2p((a*k)*S(1//(q^2+q+1)))),
	e2p((-(2*q+1)*a*k)*S(1//(q^2+q+1)))*q+e2p(((2*q+1)*a*k)*S(1//(q^2+q+1)))*q+e2p((-a*k)*S(1//(q^2+q+1)))*q-e2p((-a*k)*S(1//(q^2+q+1)))+e2p((a*k)*S(1//(q^2+q+1)))*q-e2p((a*k)*S(1//(q^2+q+1))),
	-e2p((a*k)*S(1//(q^2+q+1)))-e2p((-a*k)*S(1//(q^2+q+1))),
	(e2p((-a*k*q)*S(1//(q^2+q+1)))+e2p((a*k*q)*S(1//(q^2+q+1))))*(q+1),
	e2p((-a*k*q)*S(1//(q^2+q+1)))+e2p((a*k*q)*S(1//(q^2+q+1))),
	2*e2p((-a*k*q)*S(1//(q^2+q+1)))+2*e2p((a*k*q)*S(1//(q^2+q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((a*k)*S(1//(q^2+q+1)))-e2p((-a*k)*S(1//(q^2+q+1)))-e2p((-b*k)*S(1//(q^2+q+1)))-e2p((b*k)*S(1//(q^2+q+1)))-e2p((-k*(a*q+a-b*q))*S(1//(q^2+q+1)))-e2p((-k*(a*q+b*q+b))*S(1//(q^2+q+1)))-e2p((k*(a*q+a-b*q))*S(1//(q^2+q+1)))-e2p((k*(a*q+b*q+b))*S(1//(q^2+q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^3*(q+1)*(q^4-q^2+1)*(q^2-q+1)^2)*e2p(S(0)),
	(-q^3*(q-1)*(q+1)*(q^2-q+1))*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(2*q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q*(q+1)*(q^2-q+1))*e2p(S(0)),
	(0)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	((q+1)*(q^2-q+1))*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((-a*k)*S(1//(q^2+q+1)))*q^3-e2p((-a*k)*S(1//(q^2+q+1)))*q^2-e2p((-a*k)*S(1//(q^2+q+1)))*q+e2p((-a*k)*S(1//(q^2+q+1)))+e2p((a*k)*S(1//(q^2+q+1)))*q^3-e2p((a*k)*S(1//(q^2+q+1)))*q^2-e2p((a*k)*S(1//(q^2+q+1)))*q+e2p((a*k)*S(1//(q^2+q+1)))+e2p((-(2*q+1)*a*k)*S(1//(q^2+q+1)))*q^3+e2p(((2*q+1)*a*k)*S(1//(q^2+q+1)))*q^3,
	-(e2p((a*k)*S(1//(q^2+q+1)))+e2p((-a*k)*S(1//(q^2+q+1))))*(q-1),
	e2p((a*k)*S(1//(q^2+q+1)))+e2p((-a*k)*S(1//(q^2+q+1))),
	q*(e2p((-a*k*q)*S(1//(q^2+q+1)))+e2p((a*k*q)*S(1//(q^2+q+1)))),
	(0)*e2p(S(0)),
	e2p((-a*k*q)*S(1//(q^2+q+1)))+e2p((a*k*q)*S(1//(q^2+q+1))),
	(-(q+1)*(q^2-q+1))*e2p(S(0)),
	(-1)*e2p(S(0)),
	-e2p((-(q+1)*a*k)*S(1//(q^2+q+1)))-e2p(((q+1)*a*k)*S(1//(q^2+q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((a*k)*S(1//(q^2+q+1)))+e2p((-a*k)*S(1//(q^2+q+1)))+e2p((-b*k)*S(1//(q^2+q+1)))+e2p((b*k)*S(1//(q^2+q+1)))+e2p((-k*(a*q+a-b*q))*S(1//(q^2+q+1)))+e2p((-k*(a*q+b*q+b))*S(1//(q^2+q+1)))+e2p((k*(a*q+a-b*q))*S(1//(q^2+q+1)))+e2p((k*(a*q+b*q+b))*S(1//(q^2+q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q+1)*(q^2+q+1)*(q^4-q^2+1)*(q^2-q+1)^2)*e2p(S(0)),
	((q+1)*(q^2-q+1)*(q^4+1))*e2p(S(0)),
	(q^4+q^3+1)*e2p(S(0)),
	((q+1)*(q^2-q+1))*e2p(S(0)),
	((q+1)*(q^2-q+1))*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q+1)*(q^2-q+1)*(e2p(k*S(1//(2)))*q+1+e2p(k*S(1//(2)))),
	(q+1)*(q^2-q+1)*(1+e2p(k*S(1//(2)))),
	e2p(k*S(1//(2)))*q+1+e2p(k*S(1//(2))),
	1+e2p(k*S(1//(2))),
	1+e2p(k*S(1//(2))),
	(q+1)*(q^2-q+1)*(1+e2p((a*k)*S(1//(q-1)))+e2p((-a*k)*S(1//(q-1)))),
	1+e2p((a*k)*S(1//(q-1)))+e2p((-a*k)*S(1//(q-1))),
	(q^2+q+1)*(e2p((a*k)*S(1//(q^2+q+1)))+e2p((-a*k)*S(1//(q^2+q+1)))),
	(e2p((a*k)*S(1//(q^2+q+1)))+e2p((-a*k)*S(1//(q^2+q+1))))*(q+1),
	e2p((a*k)*S(1//(q^2+q+1)))+e2p((-a*k)*S(1//(q^2+q+1))),
	q*e2p((a*k)*S(1//(q^3-1)))+e2p((-a*k)*S(1//(q^3-1)))*q+e2p((a*k)*S(1//(q^3-1)))+e2p((-a*k)*S(1//(q^3-1)))+e2p((a*(q+1)*k*q)*S(1//(q^3-1)))+e2p((-a*(q+1)*k*q)*S(1//(q^3-1))),
	e2p((a*(q+1)*k*q)*S(1//(q^3-1)))+e2p((a*k)*S(1//(q^3-1)))+e2p((-a*k)*S(1//(q^3-1)))+e2p((-a*(q+1)*k*q)*S(1//(q^3-1))),
	e2p((a*k)*S(1//(q^3-1)))+e2p((-a*k)*S(1//(q^3-1)))+e2p(((-a+b*q^2+b*q+b)*k)*S(1//(q^3-1)))+e2p((k*(-b*q^2-b*q-b+a*q^2+a*q))*S(1//(q^3-1)))+e2p((-k*(-b*q^2-b*q-b+a*q^2+a*q))*S(1//(q^3-1)))+e2p((-(-a+b*q^2+b*q+b)*k)*S(1//(q^3-1))),
	((q+1)*(q^2-q+1))*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((-a*k*q)*S(1//(q^3-1)))+e2p((a*k*q)*S(1//(q^3-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q*(q+1)*(q^2+q+1)*(q^4-q^2+1)*(q^2-q+1)^2)*e2p(S(0)),
	(q*(q+1)*(q^2-q+1))*e2p(S(0)),
	(q*(q^3+1+q^2))*e2p(S(0)),
	(q*(q^2+q+1))*e2p(S(0)),
	(q*(q^2-q+1))*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q+1)*(q^2-q+1)*(q+e2p(k*S(1//(2)))*q+e2p(k*S(1//(2)))),
	(q+1)*(q^2-q+1)*e2p(k*S(1//(2))),
	q+e2p(k*S(1//(2)))*q+e2p(k*S(1//(2))),
	e2p(k*S(1//(2))),
	e2p(k*S(1//(2))),
	(q+1)*(q^2-q+1)*(1+e2p((a*k)*S(1//(q-1)))+e2p((-a*k)*S(1//(q-1)))),
	1+e2p((a*k)*S(1//(q-1)))+e2p((-a*k)*S(1//(q-1))),
	q*(q^2+q+1)*(e2p((a*k)*S(1//(q^2+q+1)))+e2p((-a*k)*S(1//(q^2+q+1)))),
	q*(e2p((a*k)*S(1//(q^2+q+1)))+e2p((-a*k)*S(1//(q^2+q+1)))),
	(0)*e2p(S(0)),
	q*e2p((a*k)*S(1//(q^3-1)))+e2p((-a*k)*S(1//(q^3-1)))*q+q*e2p((a*(q+1)*k*q)*S(1//(q^3-1)))+e2p((-a*(q+1)*k*q)*S(1//(q^3-1)))*q+e2p((a*k)*S(1//(q^3-1)))+e2p((-a*k)*S(1//(q^3-1))),
	e2p((a*k)*S(1//(q^3-1)))+e2p((-a*k)*S(1//(q^3-1))),
	e2p((a*k)*S(1//(q^3-1)))+e2p((-a*k)*S(1//(q^3-1)))+e2p(((-a+b*q^2+b*q+b)*k)*S(1//(q^3-1)))+e2p((k*(-b*q^2-b*q-b+a*q^2+a*q))*S(1//(q^3-1)))+e2p((-k*(-b*q^2-b*q-b+a*q^2+a*q))*S(1//(q^3-1)))+e2p((-(-a+b*q^2+b*q+b)*k)*S(1//(q^3-1))),
	(-(q+1)*(q^2-q+1))*e2p(S(0)),
	(-1)*e2p(S(0)),
	-e2p((-a*k*q)*S(1//(q^3-1)))-e2p((a*k*q)*S(1//(q^3-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q^2+q+1)*(q^4-q^2+1)*(q+1)^2*(q^2-q+1)^2)*e2p(S(0)),
	((q+1)*(q^2-q+1)*(q^4+q+1))*e2p(S(0)),
	((q+1)*(2*q^3+1))*e2p(S(0)),
	(2*q^3+q^2+q+1)*e2p(S(0)),
	((2*q+1)*(q^2-q+1))*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q+1)*(q^3+1)*(e2p((l)*S(1//(2)))+e2p((k+l)*S(1//(2)))+e2p((k)*S(1//(2)))),
	(q^3+1)*(e2p((l)*S(1//(2)))+e2p((k+l)*S(1//(2)))+e2p((k)*S(1//(2)))),
	(q+1)*(e2p((l)*S(1//(2)))+e2p((k+l)*S(1//(2)))+e2p((k)*S(1//(2)))),
	e2p((l)*S(1//(2)))+e2p((k+l)*S(1//(2)))+e2p((k)*S(1//(2))),
	e2p((l)*S(1//(2)))+e2p((k+l)*S(1//(2)))+e2p((k)*S(1//(2))),
	(q^3+1)*(e2p((a*l)*S(1//(q-1)))+e2p((-a*l)*S(1//(q-1)))+e2p((a*k+a*l)*S(1//(q-1)))+e2p((a*k+2*a*l)*S(1//(q-1)))+e2p((-a*k-a*l)*S(1//(q-1)))+e2p((-a*k-2*a*l)*S(1//(q-1)))),
	e2p((a*l)*S(1//(q-1)))+e2p((-a*l)*S(1//(q-1)))+e2p((a*k+a*l)*S(1//(q-1)))+e2p((a*k+2*a*l)*S(1//(q-1)))+e2p((-a*k-a*l)*S(1//(q-1)))+e2p((-a*k-2*a*l)*S(1//(q-1))),
	(q+1)*(q^2+q+1)*(e2p((a*k)*S(1//(q^2+q+1)))+e2p((-a*k)*S(1//(q^2+q+1)))),
	(2*q+1)*(e2p((a*k)*S(1//(q^2+q+1)))+e2p((-a*k)*S(1//(q^2+q+1)))),
	e2p((a*k)*S(1//(q^2+q+1)))+e2p((-a*k)*S(1//(q^2+q+1))),
	(q+1)*(e2p((a*k)*S(1//(q^3-1)))+e2p((-a*k)*S(1//(q^3-1)))+e2p((a*k)*S(1//(q^3-1)))*e2p((a*l)*S(1//(q-1)))+e2p((-a*k)*S(1//(q^3-1)))*e2p((-a*l)*S(1//(q-1)))+e2p(((a*q^2+a*q)*k)*S(1//(q^3-1)))*e2p((a*l)*S(1//(q-1)))+e2p(((-a*q^2-a*q)*k)*S(1//(q^3-1)))*e2p((-a*l)*S(1//(q-1)))),
	e2p((a*k)*S(1//(q^3-1)))+e2p((-a*k)*S(1//(q^3-1)))+e2p((a*k)*S(1//(q^3-1)))*e2p((a*l)*S(1//(q-1)))+e2p((-a*k)*S(1//(q^3-1)))*e2p((-a*l)*S(1//(q-1)))+e2p(((a*q^2+a*q)*k)*S(1//(q^3-1)))*e2p((a*l)*S(1//(q-1)))+e2p(((-a*q^2-a*q)*k)*S(1//(q^3-1)))*e2p((-a*l)*S(1//(q-1))),
	e2p((a*k)*S(1//(q^3-1)))*e2p((b*l)*S(1//(q-1)))+e2p((-a*k)*S(1//(q^3-1)))*e2p((-b*l)*S(1//(q-1)))+e2p((a*k)*S(1//(q^3-1)))*e2p(((a-b)*l)*S(1//(q-1)))+e2p((-a*k)*S(1//(q^3-1)))*e2p(((-a+b)*l)*S(1//(q-1)))+e2p(((-a+b*q^2+b*q+b)*k)*S(1//(q^3-1)))*e2p((b*l)*S(1//(q-1)))+e2p(((-a+b*q^2+b*q+b)*k)*S(1//(q^3-1)))*e2p(((-a+2*b)*l)*S(1//(q-1)))+e2p((((a-b)*q^2+(a-b)*q-b)*k)*S(1//(q^3-1)))*e2p(((a-b)*l)*S(1//(q-1)))+e2p((((a-b)*q^2+(a-b)*q-b)*k)*S(1//(q^3-1)))*e2p(((a-2*b)*l)*S(1//(q-1)))+e2p((((-a+b)*q^2+(-a+b)*q+b)*k)*S(1//(q^3-1)))*e2p(((-a+2*b)*l)*S(1//(q-1)))+e2p((((-a+b)*q^2+(-a+b)*q+b)*k)*S(1//(q^3-1)))*e2p(((-a+b)*l)*S(1//(q-1)))+e2p(((a-b*q^2-b*q-b)*k)*S(1//(q^3-1)))*e2p(((a-2*b)*l)*S(1//(q-1)))+e2p(((a-b*q^2-b*q-b)*k)*S(1//(q^3-1)))*e2p((-b*l)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q-1)*(q^2+q+1)*(q^2-q+1)*(q^4-q^2+1))*e2p(S(0)),
	(-q^4+q-1)*e2p(S(0)),
	(-(q^2+q+1)*(q-1)^2)*e2p(S(0)),
	(q^2+q-1+q^3)*e2p(S(0)),
	((q-1)*(q^2+1))*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-(q-1)*(e2p(k*S(1//(2)))*q^3-1-e2p(k*S(1//(2)))),
	e2p(k*S(1//(2)))*q^3-1-e2p(k*S(1//(2))),
	(1+e2p(k*S(1//(2))))*(q-1),
	-1-e2p(k*S(1//(2))),
	-1-e2p(k*S(1//(2))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	((q-1)*(q^2+q+1))*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^3*e2p((-a*k)*S(1//(q+1)))-e2p((-a*k)*S(1//(q+1)))-e2p((2*a*k)*S(1//(q+1)))+q^3*e2p((a*k)*S(1//(q+1)))-e2p((a*k)*S(1//(q+1)))-e2p((-2*a*k)*S(1//(q+1))),
	-e2p((-a*k)*S(1//(q+1)))-e2p((2*a*k)*S(1//(q+1)))-e2p((a*k)*S(1//(q+1)))-e2p((-2*a*k)*S(1//(q+1))),
	-e2p((a*k)*S(1//(q+1)))-e2p((-a*k)*S(1//(q+1))),
	((q-1)*(q^2-q+1))*e2p(S(0)),
	(2*q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(1+e2p((a*k)*S(1//(q+1)))+e2p((-a*k)*S(1//(q+1))))*(q-1),
	-1-e2p((a*k)*S(1//(q+1)))-e2p((-a*k)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((b*k)*S(1//(q+1)))-e2p((-b*k)*S(1//(q+1)))-e2p(((a-b)*k)*S(1//(q+1)))-e2p((-(a-b)*k)*S(1//(q+1)))-e2p((-(a-2*b)*k)*S(1//(q+1)))-e2p(((a-2*b)*k)*S(1//(q+1)))] [
	(q^3*(q-1)*(q^2-q+1)*(q^2+q+1)*(q^4-q^2+1))*e2p(S(0)),
	(-q^3*(q^4-q+1))*e2p(S(0)),
	(q^3*(q-1))*e2p(S(0)),
	(-q^3)*e2p(S(0)),
	(-q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*(e2p(k*S(1//(2)))*q^3+q^3-e2p(k*S(1//(2)))),
	-q^3-e2p(k*S(1//(2)))*q^3+e2p(k*S(1//(2))),
	-(q-1)*e2p(k*S(1//(2))),
	e2p(k*S(1//(2))),
	e2p(k*S(1//(2))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	((q-1)*(q^2+q+1))*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q^3*e2p((-a*k)*S(1//(q+1)))+e2p((-a*k)*S(1//(q+1)))-q^3*e2p((2*a*k)*S(1//(q+1)))-q^3*e2p((a*k)*S(1//(q+1)))+e2p((a*k)*S(1//(q+1)))-q^3*e2p((-2*a*k)*S(1//(q+1))),
	e2p((a*k)*S(1//(q+1)))+e2p((-a*k)*S(1//(q+1))),
	-e2p((a*k)*S(1//(q+1)))-e2p((-a*k)*S(1//(q+1))),
	(-(q-1)*(q^2-q+1))*e2p(S(0)),
	(-2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	-(1+e2p((a*k)*S(1//(q+1)))+e2p((-a*k)*S(1//(q+1))))*(q-1),
	1+e2p((a*k)*S(1//(q+1)))+e2p((-a*k)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((b*k)*S(1//(q+1)))+e2p((-b*k)*S(1//(q+1)))+e2p(((a-b)*k)*S(1//(q+1)))+e2p((-(a-b)*k)*S(1//(q+1)))+e2p((-(a-2*b)*k)*S(1//(q+1)))+e2p(((a-2*b)*k)*S(1//(q+1)))] [
	((q^4-q^2+1)*(q^2-q+1)^2*(q+1)*(q^2+q+1)*(q-1))*e2p(S(0)),
	(-q^7-q^3+q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(q^2+q-1)*e2p(S(0)),
	(-q^2+q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q^3+1)*(q-1)*e2p(k*S(1//(2))),
	-(q^3+1)*e2p(k*S(1//(2))),
	e2p(k*S(1//(2)))*(q-1),
	-e2p(k*S(1//(2))),
	-e2p(k*S(1//(2))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3-1)*(e2p((a*k)*S(1//(q^2+q+1)))+e2p((-a*k)*S(1//(q^2+q+1)))),
	-e2p((a*k)*S(1//(q^2+q+1)))-e2p((-a*k)*S(1//(q^2+q+1))),
	-e2p((a*k)*S(1//(q^2+q+1)))-e2p((-a*k)*S(1//(q^2+q+1))),
	(q-1)*(e2p((a*k)*S(1//(q^3-1)))+e2p((-a*k)*S(1//(q^3-1)))),
	-e2p((a*k)*S(1//(q^3-1)))-e2p((-a*k)*S(1//(q^3-1))),
	(0)*e2p(S(0)),
	-(q^3+1)*(e2p((a*k)*S(1//(q+1)))+e2p((-a*k)*S(1//(q+1)))),
	-e2p((a*k)*S(1//(q+1)))-e2p((-a*k)*S(1//(q+1))),
	-e2p((a*k)*S(1//((q+1)*(q^3-1))))-e2p((-a*k)*S(1//((q+1)*(q^3-1))))-e2p((a*k*q^3)*S(1//((q+1)*(q^3-1))))-e2p((-a*k*q^3)*S(1//((q+1)*(q^3-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q-1)*(q^4-q^2+1)*(q^2+q+1)^2)*e2p(S(0)),
	(-(q-1)*(q^2+q+1)*(q^3-q-1))*e2p(S(0)),
	(q^3-q-1)*e2p(S(0)),
	(-q^2-q-1)*e2p(S(0)),
	(2*q^3+q^2-q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	((q-1)*(q^2+q+1))*e2p(S(0)),
	((q-1)*(q^2+q+1))*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	((q-1)*(q^2+q+1))*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	((q-1)*(q^2+q+1))*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-a*(2*q-1)*k)*S(1//(q^2-q+1)))-e2p((a*(2*q-1)*k)*S(1//(q^2-q+1)))+e2p((a*k)*S(1//(q^2-q+1)))*q^3+e2p((a*k)*S(1//(q^2-q+1)))*q^2-e2p((a*k)*S(1//(q^2-q+1)))*q-e2p((a*k)*S(1//(q^2-q+1)))+e2p((-a*k)*S(1//(q^2-q+1)))*q^3+e2p((-a*k)*S(1//(q^2-q+1)))*q^2-e2p((-a*k)*S(1//(q^2-q+1)))*q-e2p((-a*k)*S(1//(q^2-q+1))),
	-e2p((-a*(2*q-1)*k)*S(1//(q^2-q+1)))-e2p((a*(2*q-1)*k)*S(1//(q^2-q+1)))-e2p((a*k)*S(1//(q^2-q+1)))*q-e2p((a*k)*S(1//(q^2-q+1)))-e2p((-a*k)*S(1//(q^2-q+1)))*q-e2p((-a*k)*S(1//(q^2-q+1))),
	-e2p((-a*(2*q-1)*k)*S(1//(q^2-q+1)))-e2p((a*(2*q-1)*k)*S(1//(q^2-q+1)))-e2p((a*k)*S(1//(q^2-q+1)))-e2p((-a*k)*S(1//(q^2-q+1))),
	-e2p((-a*k*q)*S(1//(q^2-q+1)))-e2p((a*k*q)*S(1//(q^2-q+1))),
	-e2p((-a*k*q)*S(1//(q^2-q+1)))-e2p((a*k*q)*S(1//(q^2-q+1))),
	-e2p(((q-1)*a*k)*S(1//(q^2-q+1)))-e2p((-(q-1)*a*k)*S(1//(q^2-q+1))),
	(0)*e2p(S(0)),
	-e2p((a*k)*S(1//(q^2-q+1)))-e2p((-a*k)*S(1//(q^2-q+1)))-e2p((-b*k)*S(1//(q^2-q+1)))-e2p((b*k)*S(1//(q^2-q+1)))-e2p((k*(-a-b*q+a*q))*S(1//(q^2-q+1)))-e2p((k*(-b+b*q+a*q))*S(1//(q^2-q+1)))-e2p((-k*(-a-b*q+a*q))*S(1//(q^2-q+1)))-e2p((-k*(-b+b*q+a*q))*S(1//(q^2-q+1))),
	(0)*e2p(S(0)),
	-e2p((-a*k*q)*S(1//(q^2-q+1)))-e2p((a*k*q)*S(1//(q^2-q+1)))] [
	(q*(q^4-q^2+1)*(q-1)^2*(q^2+q+1)^2)*e2p(S(0)),
	(q*(q-1)*(q^2+q+1)*(q^3+q^2-1))*e2p(S(0)),
	(-q*(q-1)*(q^2+q+1))*e2p(S(0)),
	(q*(q^2+q+1))*e2p(S(0)),
	(-q*(q^2+q-1))*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-(q^2+q+1)*(q-1)^2)*e2p(S(0)),
	((q-1)*(q^2+q+1))*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(2*(q-1)*(q^2+q+1))*e2p(S(0)),
	(-2)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q-1)*(e2p((a*k)*S(1//(q^2-q+1)))*q^2+e2p((-a*k)*S(1//(q^2-q+1)))*q^2+q*e2p((a*(2*q-1)*k)*S(1//(q^2-q+1)))+q*e2p((-a*(2*q-1)*k)*S(1//(q^2-q+1)))+2*e2p((-a*k)*S(1//(q^2-q+1)))*q+2*e2p((a*k)*S(1//(q^2-q+1)))*q+e2p((a*k)*S(1//(q^2-q+1)))+e2p((-a*k)*S(1//(q^2-q+1)))),
	e2p((a*k)*S(1//(q^2-q+1)))*q+e2p((a*k)*S(1//(q^2-q+1)))+q*e2p((a*(2*q-1)*k)*S(1//(q^2-q+1)))+e2p((-a*k)*S(1//(q^2-q+1)))*q+e2p((-a*k)*S(1//(q^2-q+1)))+q*e2p((-a*(2*q-1)*k)*S(1//(q^2-q+1))),
	e2p((a*k)*S(1//(q^2-q+1)))+e2p((-a*k)*S(1//(q^2-q+1))),
	(e2p((-a*k*q)*S(1//(q^2-q+1)))+e2p((a*k*q)*S(1//(q^2-q+1))))*(q-1),
	-e2p((-a*k*q)*S(1//(q^2-q+1)))-e2p((a*k*q)*S(1//(q^2-q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((a*k)*S(1//(q^2-q+1)))+e2p((-a*k)*S(1//(q^2-q+1)))+e2p((-b*k)*S(1//(q^2-q+1)))+e2p((b*k)*S(1//(q^2-q+1)))+e2p((k*(-a-b*q+a*q))*S(1//(q^2-q+1)))+e2p((k*(-b+b*q+a*q))*S(1//(q^2-q+1)))+e2p((-k*(-a-b*q+a*q))*S(1//(q^2-q+1)))+e2p((-k*(-b+b*q+a*q))*S(1//(q^2-q+1))),
	(0)*e2p(S(0)),
	-2*e2p((-a*k*q)*S(1//(q^2-q+1)))-2*e2p((a*k*q)*S(1//(q^2-q+1)))] [
	(q^3*(q-1)*(q^4-q^2+1)*(q^2+q+1)^2)*e2p(S(0)),
	(q^3*(q-1)*(q+1)*(q^2+q+1))*e2p(S(0)),
	(-q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-2*q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q*(q-1)*(q^2+q+1))*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	((q-1)*(q^2+q+1))*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-(q-1)*(q^2+q+1))*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((a*k)*S(1//(q^2-q+1)))*q^2+e2p((a*k)*S(1//(q^2-q+1)))-e2p((a*k)*S(1//(q^2-q+1)))*q^3+e2p((a*k)*S(1//(q^2-q+1)))*q-e2p((-a*k)*S(1//(q^2-q+1)))*q^2+e2p((-a*k)*S(1//(q^2-q+1)))-e2p((-a*k)*S(1//(q^2-q+1)))*q^3+e2p((-a*k)*S(1//(q^2-q+1)))*q-e2p((a*(2*q-1)*k)*S(1//(q^2-q+1)))*q^3-e2p((-a*(2*q-1)*k)*S(1//(q^2-q+1)))*q^3,
	(e2p((a*k)*S(1//(q^2-q+1)))+e2p((-a*k)*S(1//(q^2-q+1))))*(q+1),
	e2p((a*k)*S(1//(q^2-q+1)))+e2p((-a*k)*S(1//(q^2-q+1))),
	-q*(e2p((-a*k*q)*S(1//(q^2-q+1)))+e2p((a*k*q)*S(1//(q^2-q+1)))),
	(0)*e2p(S(0)),
	-e2p(((q-1)*a*k)*S(1//(q^2-q+1)))-e2p((-(q-1)*a*k)*S(1//(q^2-q+1))),
	(0)*e2p(S(0)),
	e2p((a*k)*S(1//(q^2-q+1)))+e2p((-a*k)*S(1//(q^2-q+1)))+e2p((-b*k)*S(1//(q^2-q+1)))+e2p((b*k)*S(1//(q^2-q+1)))+e2p((k*(-a-b*q+a*q))*S(1//(q^2-q+1)))+e2p((k*(-b+b*q+a*q))*S(1//(q^2-q+1)))+e2p((-k*(-a-b*q+a*q))*S(1//(q^2-q+1)))+e2p((-k*(-b+b*q+a*q))*S(1//(q^2-q+1))),
	(0)*e2p(S(0)),
	e2p((-a*k*q)*S(1//(q^2-q+1)))+e2p((a*k*q)*S(1//(q^2-q+1)))] [
	((q-1)*(q^2-q+1)*(q^4-q^2+1)*(q^2+q+1)^2)*e2p(S(0)),
	((q-1)*(q^2+q+1)*(q^4+1))*e2p(S(0)),
	(-1-q^4+q^3)*e2p(S(0)),
	((q-1)*(q^2+q+1))*e2p(S(0)),
	((q-1)*(q^2+q+1))*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-(q-1)*(q^2+q+1)*(e2p(k*S(1//(2)))*q-e2p(k*S(1//(2)))-1),
	(q-1)*(q^2+q+1)*(1+e2p(k*S(1//(2)))),
	e2p(k*S(1//(2)))*q-e2p(k*S(1//(2)))-1,
	-1-e2p(k*S(1//(2))),
	-1-e2p(k*S(1//(2))),
	((q-1)*(q^2+q+1))*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*(q^2+q+1)*(1+e2p((a*k)*S(1//(q+1)))+e2p((-a*k)*S(1//(q+1)))),
	-1-e2p((a*k)*S(1//(q+1)))-e2p((-a*k)*S(1//(q+1))),
	(0)*e2p(S(0)),
	-(q^2-q+1)*(e2p((a*k)*S(1//(q^2-q+1)))+e2p((-a*k)*S(1//(q^2-q+1)))),
	(e2p((a*k)*S(1//(q^2-q+1)))+e2p((-a*k)*S(1//(q^2-q+1))))*(q-1),
	-e2p((a*k)*S(1//(q^2-q+1)))-e2p((-a*k)*S(1//(q^2-q+1))),
	-e2p((-a*(q-1)*q*k)*S(1//(q^3+1)))-e2p((a*(q-1)*q*k)*S(1//(q^3+1)))+q*e2p((a*k)*S(1//(q^3+1)))+q*e2p((-a*k)*S(1//(q^3+1)))-e2p((a*k)*S(1//(q^3+1)))-e2p((-a*k)*S(1//(q^3+1))),
	-e2p((a*(q-1)*q*k)*S(1//(q^3+1)))-e2p((a*k)*S(1//(q^3+1)))-e2p((-a*k)*S(1//(q^3+1)))-e2p((-a*(q-1)*q*k)*S(1//(q^3+1))),
	-e2p((a*k*q)*S(1//(q^3+1)))-e2p((-a*k*q)*S(1//(q^3+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((a*k)*S(1//(q^3+1)))-e2p((-a*k)*S(1//(q^3+1)))-e2p(((-a+b*q^2-b*q+b)*k)*S(1//(q^3+1)))-e2p((k*(b*q-b*q^2-a*q-b+a*q^2))*S(1//(q^3+1)))-e2p((-k*(b*q-b*q^2-a*q-b+a*q^2))*S(1//(q^3+1)))-e2p((-(-a+b*q^2-b*q+b)*k)*S(1//(q^3+1)))] [
	(q*(q-1)*(q^2-q+1)*(q^4-q^2+1)*(q^2+q+1)^2)*e2p(S(0)),
	(q*(q-1)*(q^2+q+1))*e2p(S(0)),
	(q*(-1+q^3-q^2))*e2p(S(0)),
	(-q*(q^2+q+1))*e2p(S(0)),
	(-q*(q^2-q+1))*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*(q^2+q+1)*(e2p(k*S(1//(2)))*q+q-e2p(k*S(1//(2)))),
	-(q-1)*(q^2+q+1)*e2p(k*S(1//(2))),
	-q-e2p(k*S(1//(2)))*q+e2p(k*S(1//(2))),
	e2p(k*S(1//(2))),
	e2p(k*S(1//(2))),
	((q-1)*(q^2+q+1))*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q-1)*(q^2+q+1)*(1+e2p((a*k)*S(1//(q+1)))+e2p((-a*k)*S(1//(q+1)))),
	1+e2p((a*k)*S(1//(q+1)))+e2p((-a*k)*S(1//(q+1))),
	(0)*e2p(S(0)),
	-q*(q^2-q+1)*(e2p((a*k)*S(1//(q^2-q+1)))+e2p((-a*k)*S(1//(q^2-q+1)))),
	-q*(e2p((a*k)*S(1//(q^2-q+1)))+e2p((-a*k)*S(1//(q^2-q+1)))),
	(0)*e2p(S(0)),
	-q*e2p((-a*(q-1)*q*k)*S(1//(q^3+1)))-q*e2p((a*(q-1)*q*k)*S(1//(q^3+1)))-q*e2p((a*k)*S(1//(q^3+1)))-q*e2p((-a*k)*S(1//(q^3+1)))+e2p((a*k)*S(1//(q^3+1)))+e2p((-a*k)*S(1//(q^3+1))),
	e2p((a*k)*S(1//(q^3+1)))+e2p((-a*k)*S(1//(q^3+1))),
	-e2p((a*k*q)*S(1//(q^3+1)))-e2p((-a*k*q)*S(1//(q^3+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((a*k)*S(1//(q^3+1)))+e2p((-a*k)*S(1//(q^3+1)))+e2p(((-a+b*q^2-b*q+b)*k)*S(1//(q^3+1)))+e2p((k*(a*q^2-b*q^2-a*q+b*q-b))*S(1//(q^3+1)))+e2p((-k*(a*q^2-b*q^2-a*q+b*q-b))*S(1//(q^3+1)))+e2p((-(-a+b*q^2-b*q+b)*k)*S(1//(q^3+1)))] [
	((q^4-q^2+1)*(q^2+q+1)^2*(q-1)*(q^2-q+1)*(q+1))*e2p(S(0)),
	(q^7+q^3-q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-q^2-q-1)*e2p(S(0)),
	(q^2-q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	e2p(k*S(1//(2)))*(q^3-1)*(q+1),
	e2p(k*S(1//(2)))*(q^3-1),
	-e2p(k*S(1//(2)))*(q+1),
	-e2p(k*S(1//(2))),
	-e2p(k*S(1//(2))),
	(q^3-1)*(e2p((k*a)*S(1//(q-1)))+e2p((-k*a)*S(1//(q-1)))),
	-e2p((k*a)*S(1//(q-1)))-e2p((-k*a)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q^3+1)*(e2p((k*a)*S(1//(q^2-q+1)))+e2p((-k*a)*S(1//(q^2-q+1)))),
	-e2p((k*a)*S(1//(q^2-q+1)))-e2p((-k*a)*S(1//(q^2-q+1))),
	-e2p((k*a)*S(1//(q^2-q+1)))-e2p((-k*a)*S(1//(q^2-q+1))),
	-(q+1)*(e2p((k*a)*S(1//(q^3+1)))+e2p((-k*a)*S(1//(q^3+1)))),
	-e2p((k*a)*S(1//(q^3+1)))-e2p((-k*a)*S(1//(q^3+1))),
	-e2p((k*a)*S(1//((q-1)*(q^3+1))))-e2p((-k*a)*S(1//((q-1)*(q^3+1))))-e2p((k*a*q^3)*S(1//((q-1)*(q^3+1))))-e2p((-k*a*q^3)*S(1//((q-1)*(q^3+1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q-1)^2*(q+1)^2*(q^2-q+1)^2*(q^4-q^2+1))*e2p(S(0)),
	(-(q-1)*(q+1)*(q^2-q+1)*(2*q^3-q^2-q+1))*e2p(S(0)),
	(-(q+1)*(q-1)^3)*e2p(S(0)),
	(5*q^3-2*q^2-2*q+1)*e2p(S(0)),
	(-(q-1)*(q^2-q+1))*e2p(S(0)),
	(-2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)^2*(q+1)*(e2p((a*(k+l))*S(1//(q^2+q+1)))+e2p((-a*(k+l))*S(1//(q^2+q+1)))+e2p((a*(k-l))*S(1//(q^2+q+1)))+e2p((a*(l-k))*S(1//(q^2+q+1)))+e2p((a*(k+(2*q+1)*l))*S(1//(q^2+q+1)))+e2p((a*((-2*q-1)*k+l))*S(1//(q^2+q+1)))+e2p((a*((2*q+1)*k-l))*S(1//(q^2+q+1)))+e2p((a*(-k+(-2*q-1)*l))*S(1//(q^2+q+1)))),
	-(q-1)*(e2p((a*(k+l))*S(1//(q^2+q+1)))+e2p((-a*(k+l))*S(1//(q^2+q+1)))+e2p((a*(k-l))*S(1//(q^2+q+1)))+e2p((a*(l-k))*S(1//(q^2+q+1)))+e2p((a*(k+(2*q+1)*l))*S(1//(q^2+q+1)))+e2p((a*((-2*q-1)*k+l))*S(1//(q^2+q+1)))+e2p((a*((2*q+1)*k-l))*S(1//(q^2+q+1)))+e2p((a*(-k+(-2*q-1)*l))*S(1//(q^2+q+1)))),
	e2p((a*(k+l))*S(1//(q^2+q+1)))+e2p((-a*(k+l))*S(1//(q^2+q+1)))+e2p((a*(k-l))*S(1//(q^2+q+1)))+e2p((a*(l-k))*S(1//(q^2+q+1)))+e2p((a*(k+(2*q+1)*l))*S(1//(q^2+q+1)))+e2p((a*((-2*q-1)*k+l))*S(1//(q^2+q+1)))+e2p((a*((2*q+1)*k-l))*S(1//(q^2+q+1)))+e2p((a*(-k+(-2*q-1)*l))*S(1//(q^2+q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((a*k+b*l)*S(1//(q^2+q+1)))+e2p((-a*k-b*l)*S(1//(q^2+q+1)))+e2p((-b*k+a*l)*S(1//(q^2+q+1)))+e2p((b*k-a*l)*S(1//(q^2+q+1)))+e2p((a*k+((a+b)*q+b)*l)*S(1//(q^2+q+1)))+e2p((a*k+(-(a-b)*q-a)*l)*S(1//(q^2+q+1)))+e2p(((-(a-b)*q-a)*k+b*l)*S(1//(q^2+q+1)))+e2p(((-(a+b)*q-b)*k+b*l)*S(1//(q^2+q+1)))+e2p(((-(a+b)*q-b)*k+a*l)*S(1//(q^2+q+1)))+e2p((b*k+((a+b)*q+b)*l)*S(1//(q^2+q+1)))+e2p(((-(a-b)*q-a)*k-a*l)*S(1//(q^2+q+1)))+e2p((b*k+((a-b)*q+a)*l)*S(1//(q^2+q+1)))+e2p((-b*k+((-a+b)*q-a)*l)*S(1//(q^2+q+1)))+e2p((((a-b)*q+a)*k+a*l)*S(1//(q^2+q+1)))+e2p((-b*k+(-(a+b)*q-b)*l)*S(1//(q^2+q+1)))+e2p((((a+b)*q+b)*k-a*l)*S(1//(q^2+q+1)))+e2p((((a+b)*q+b)*k-b*l)*S(1//(q^2+q+1)))+e2p((((a-b)*q+a)*k-b*l)*S(1//(q^2+q+1)))+e2p((-a*k+((a-b)*q+a)*l)*S(1//(q^2+q+1)))+e2p((-a*k+(-(a+b)*q-b)*l)*S(1//(q^2+q+1)))+e2p((((a+b)*q+b)*k+((-a+b)*q-a)*l)*S(1//(q^2+q+1)))+e2p(((-(a-b)*q-a)*k+(-(a+b)*q-b)*l)*S(1//(q^2+q+1)))+e2p((((a-b)*q+a)*k+((a+b)*q+b)*l)*S(1//(q^2+q+1)))+e2p(((-(a+b)*q-b)*k+((a-b)*q+a)*l)*S(1//(q^2+q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q-1)^2*(q+1)^2*(q^2+q+1)^2*(q^4-q^2+1))*e2p(S(0)),
	((q-1)*(q+1)*(q^2+q+1)*(2*q^3+q^2-q-1))*e2p(S(0)),
	(-(q-1)*(q+1)^3)*e2p(S(0)),
	((q+1)*(q^2+q+1))*e2p(S(0)),
	(-5*q^3-2*q^2+2*q+1)*e2p(S(0)),
	(2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q-1)*(q+1)^2*(e2p((a*(k+l))*S(1//(q^2-q+1)))+e2p((-a*(k+l))*S(1//(q^2-q+1)))+e2p((a*(k-l))*S(1//(q^2-q+1)))+e2p((a*(l-k))*S(1//(q^2-q+1)))+e2p((a*(k+(-2*q+1)*l))*S(1//(q^2-q+1)))+e2p((a*((2*q-1)*k+l))*S(1//(q^2-q+1)))+e2p((a*((-2*q+1)*k-l))*S(1//(q^2-q+1)))+e2p((a*(-k+(2*q-1)*l))*S(1//(q^2-q+1)))),
	(q+1)*(e2p((a*(k+l))*S(1//(q^2-q+1)))+e2p((-a*(k+l))*S(1//(q^2-q+1)))+e2p((a*(k-l))*S(1//(q^2-q+1)))+e2p((a*(l-k))*S(1//(q^2-q+1)))+e2p((a*(k+(-2*q+1)*l))*S(1//(q^2-q+1)))+e2p((a*((2*q-1)*k+l))*S(1//(q^2-q+1)))+e2p((a*((-2*q+1)*k-l))*S(1//(q^2-q+1)))+e2p((a*(-k+(2*q-1)*l))*S(1//(q^2-q+1)))),
	e2p((a*(k+l))*S(1//(q^2-q+1)))+e2p((-a*(k+l))*S(1//(q^2-q+1)))+e2p((a*(k-l))*S(1//(q^2-q+1)))+e2p((a*(l-k))*S(1//(q^2-q+1)))+e2p((a*(k+(-2*q+1)*l))*S(1//(q^2-q+1)))+e2p((a*((2*q-1)*k+l))*S(1//(q^2-q+1)))+e2p((a*((-2*q+1)*k-l))*S(1//(q^2-q+1)))+e2p((a*(-k+(2*q-1)*l))*S(1//(q^2-q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((a*k+b*l)*S(1//(q^2-q+1)))+e2p((-a*k-b*l)*S(1//(q^2-q+1)))+e2p((-b*k+a*l)*S(1//(q^2-q+1)))+e2p((b*k-a*l)*S(1//(q^2-q+1)))+e2p((a*k+((-a-b)*q+b)*l)*S(1//(q^2-q+1)))+e2p((a*k+((a-b)*q-a)*l)*S(1//(q^2-q+1)))+e2p((((a-b)*q-a)*k+b*l)*S(1//(q^2-q+1)))+e2p((((a+b)*q-b)*k+b*l)*S(1//(q^2-q+1)))+e2p((((a+b)*q-b)*k+a*l)*S(1//(q^2-q+1)))+e2p((b*k+((-a-b)*q+b)*l)*S(1//(q^2-q+1)))+e2p((((a-b)*q-a)*k-a*l)*S(1//(q^2-q+1)))+e2p((b*k+((-a+b)*q+a)*l)*S(1//(q^2-q+1)))+e2p((-b*k+((a-b)*q-a)*l)*S(1//(q^2-q+1)))+e2p((((-a+b)*q+a)*k+a*l)*S(1//(q^2-q+1)))+e2p((-b*k+((a+b)*q-b)*l)*S(1//(q^2-q+1)))+e2p((((-a-b)*q+b)*k-a*l)*S(1//(q^2-q+1)))+e2p((((-a-b)*q+b)*k-b*l)*S(1//(q^2-q+1)))+e2p((((-a+b)*q+a)*k-b*l)*S(1//(q^2-q+1)))+e2p((-a*k+((-a+b)*q+a)*l)*S(1//(q^2-q+1)))+e2p((-a*k+((a+b)*q-b)*l)*S(1//(q^2-q+1)))+e2p((((a-b)*q-a)*k+((a+b)*q-b)*l)*S(1//(q^2-q+1)))+e2p((((-a-b)*q+b)*k+((a-b)*q-a)*l)*S(1//(q^2-q+1)))+e2p((((-a+b)*q+a)*k+((-a-b)*q+b)*l)*S(1//(q^2-q+1)))+e2p((((a+b)*q-b)*k+((-a+b)*q+a)*l)*S(1//(q^2-q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q+1)^2*(q-1)^2*(q^2-q+1)^2*(q^2+q+1)^2)*e2p(S(0)),
	(-q^6+1)*e2p(S(0)),
	(-q^4+1)*e2p(S(0)),
	(-q^3+1)*e2p(S(0)),
	(q^3+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((a*k)*S(1//(q^4-q^2+1)))+e2p((-a*k)*S(1//(q^4-q^2+1)))+e2p((a*k*q^3)*S(1//(q^4-q^2+1)))+e2p((-a*k*q^3)*S(1//(q^4-q^2+1))),
	(0)*e2p(S(0))] [
	((q^2-q+1)*(q^4-q^2+1)*(q-1)^2*(q^2+q+1)^2)*e2p(S(0)),
	(-(q-1)*(q^2+q+1)*(q^4-q+1))*e2p(S(0)),
	((q-1)*(2*q^3-1))*e2p(S(0)),
	(-(2*q-1)*(q^2+q+1))*e2p(S(0)),
	(-2*q^3+q^2-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q-1)*(q^3-1)*(e2p((l)*S(1//(2)))+e2p((k+l)*S(1//(2)))+e2p((k)*S(1//(2)))),
	(-q^3+1)*(e2p((l)*S(1//(2)))+e2p((k+l)*S(1//(2)))+e2p((k)*S(1//(2)))),
	(-q+1)*(e2p((l)*S(1//(2)))+e2p((k+l)*S(1//(2)))+e2p((k)*S(1//(2)))),
	e2p((l)*S(1//(2)))+e2p((k+l)*S(1//(2)))+e2p((k)*S(1//(2))),
	e2p((l)*S(1//(2)))+e2p((k+l)*S(1//(2)))+e2p((k)*S(1//(2))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q^3-1)*(e2p((a*l)*S(1//(q+1)))+e2p((-a*l)*S(1//(q+1)))+e2p((a*k+a*l)*S(1//(q+1)))+e2p((a*k+2*a*l)*S(1//(q+1)))+e2p((-a*k-a*l)*S(1//(q+1)))+e2p((-a*k-2*a*l)*S(1//(q+1)))),
	e2p((a*l)*S(1//(q+1)))+e2p((-a*l)*S(1//(q+1)))+e2p((a*k+a*l)*S(1//(q+1)))+e2p((a*k+2*a*l)*S(1//(q+1)))+e2p((-a*k-a*l)*S(1//(q+1)))+e2p((-a*k-2*a*l)*S(1//(q+1))),
	(0)*e2p(S(0)),
	-(q-1)*(q^2-q+1)*(e2p((a*k)*S(1//(q^2-q+1)))+e2p((-a*k)*S(1//(q^2-q+1)))),
	(-2*q+1)*(e2p((a*k)*S(1//(q^2-q+1)))+e2p((-a*k)*S(1//(q^2-q+1)))),
	e2p((a*k)*S(1//(q^2-q+1)))+e2p((-a*k)*S(1//(q^2-q+1))),
	-(q-1)*(e2p((a*k)*S(1//(q^3+1)))+e2p((-a*k)*S(1//(q^3+1)))+e2p((a*k)*S(1//(q^3+1)))*e2p((a*l)*S(1//(q+1)))+e2p((-a*k)*S(1//(q^3+1)))*e2p((-a*l)*S(1//(q+1)))+e2p((a*(q^2-q)*k)*S(1//(q^3+1)))*e2p((a*l)*S(1//(q+1)))+e2p((-a*(q^2-q)*k)*S(1//(q^3+1)))*e2p((-a*l)*S(1//(q+1)))),
	e2p((a*k)*S(1//(q^3+1)))+e2p((-a*k)*S(1//(q^3+1)))+e2p((a*k)*S(1//(q^3+1)))*e2p((a*l)*S(1//(q+1)))+e2p((-a*k)*S(1//(q^3+1)))*e2p((-a*l)*S(1//(q+1)))+e2p((a*(q^2-q)*k)*S(1//(q^3+1)))*e2p((a*l)*S(1//(q+1)))+e2p((-a*(q^2-q)*k)*S(1//(q^3+1)))*e2p((-a*l)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((a*k)*S(1//(q^3+1)))*e2p((b*l)*S(1//(q+1)))+e2p((-a*k)*S(1//(q^3+1)))*e2p((-b*l)*S(1//(q+1)))+e2p((a*k)*S(1//(q^3+1)))*e2p(((a-b)*l)*S(1//(q+1)))+e2p((-a*k)*S(1//(q^3+1)))*e2p(((-a+b)*l)*S(1//(q+1)))+e2p(((-a+b*q^2-b*q+b)*k)*S(1//(q^3+1)))*e2p((b*l)*S(1//(q+1)))+e2p(((-a+b*q^2-b*q+b)*k)*S(1//(q^3+1)))*e2p(((-a+2*b)*l)*S(1//(q+1)))+e2p((((a-b)*q^2+(-a+b)*q-b)*k)*S(1//(q^3+1)))*e2p(((a-b)*l)*S(1//(q+1)))+e2p((((a-b)*q^2+(-a+b)*q-b)*k)*S(1//(q^3+1)))*e2p(((a-2*b)*l)*S(1//(q+1)))+e2p((((-a+b)*q^2+(a-b)*q+b)*k)*S(1//(q^3+1)))*e2p(((-a+2*b)*l)*S(1//(q+1)))+e2p((((-a+b)*q^2+(a-b)*q+b)*k)*S(1//(q^3+1)))*e2p(((-a+b)*l)*S(1//(q+1)))+e2p(((a-b*q^2+b*q-b)*k)*S(1//(q^3+1)))*e2p(((a-2*b)*l)*S(1//(q+1)))+e2p(((a-b*q^2+b*q-b)*k)*S(1//(q^3+1)))*e2p((-b*l)*S(1//(q+1)))]]
classinfo = Vector{Any}[
	["",[1,0],["^3D_4","u_0"]],
	["",[1,1],["^3D_4","u_1"]],
	["",[1,2],["^3D_4","u_2"]],
	["",[1,3],["^3D_4","u_3"]],
	["",[1,4],["^3D_4","u_4"]],
	["",[1,5],["^3D_4","u_5"]],
	["",[1,6],["^3D_4","u_6"]],
	["",[2,0],["A_1+A_1","u_0"]],
	["",[2,1],["A_1+A_1","u_1"]],
	["",[2,2],["A_1+A_1","u_2"]],
	["",[2,3],["A_1+A_1","u_3"]],
	["",[2,4],["A_1+A_1","u_4"]],
	["",[3,0],["A_1",[1,1]]],
	["",[3,1],["A_1",[2]]],
	["",[4,0],["A_2",[1,1,1]]],
	["",[4,1],["A_2",[2,1]]],
	["",[4,2],["A_2",[3]]],
	["",[5,0],["A_1",[1,1]]],
	["",[5,1],["A_1",[2]]],
	["",[6,0],["A_0",[1]]],
	["",[7,0],["A_1",[1,1]]],
	["",[7,1],["A_1",[2]]],
	["",[8,0],["A_0",[1]]],
	["",[9,0],["A_2",[1,1,1]]],
	["",[9,1],["A_2",[2,1]]],
	["",[9,2],["A_2",[3]]],
	["",[10,0],["A_1",[1,1]]],
	["",[10,1],["A_1",[2]]],
	["",[11,0],["A_0",[1]]],
	["",[12,0],["A_0",[1]]],
	["",[13,0],["A_0",[1]]],
	["",[14,0],["A_0",[1]]],
	["",[15,0],["A_0",[1]]]]
classlength = R.([
	1,
	(q^2-1)*(q^8+q^4+1),
	q^2*(q^6-1)*(q^8+q^4+1),
	q^4*(q^8+q^4+1)*(q^2-1)^2*(q^2-q+1)*1//2,
	q^4*(q^8+q^4+1)*(q^2-1)^2*(q^2+q+1)*1//2,
	q^6*(q^2-1)*(q^6-1)*(q^8+q^4+1),
	q^8*(q^2-1)*(q^6-1)*(q^8+q^4+1),
	q^8*(q^8+q^4+1),
	q^8*(q^2-1)*(q^8+q^4+1),
	q^8*(q^6-1)*(q^8+q^4+1),
	q^8*(q^2-1)*(q^6-1)*(q^8+q^4+1)*1//2,
	q^8*(q^2-1)*(q^6-1)*(q^8+q^4+1)*1//2,
	q^9*(q+1)*(q^8+q^4+1),
	q^9*(q+1)*(q^6-1)*(q^8+q^4+1),
	q^9*(q^3+1)*(q^2-q+1)*(q^4-q^2+1),
	q^9*(q^2-1)*(q^3+1)*(q^8+q^4+1),
	q^10*(q^2-1)*(q-1)*(q^3+1)*(q^8+q^4+1),
	q^11*(q^3+1)*(q^8+q^4+1),
	q^11*(q^3+1)*(q^2-1)*(q^8+q^4+1),
	q^12*(q+1)*(q^3+1)*(q^8+q^4+1),
	q^9*(q-1)*(q^8+q^4+1),
	q^9*(q-1)*(q^6-1)*(q^8+q^4+1),
	q^12*(q-1)*(q^3+1)*(q^8+q^4+1),
	q^9*(q^3-1)*(q^2+q+1)*(q^4-q^2+1),
	q^9*(q^2-1)*(q^3-1)*(q^8+q^4+1),
	q^10*(q^2-1)*(q^3-1)*(q+1)*(q^8+q^4+1),
	q^11*(q^3-1)*(q^8+q^4+1),
	q^11*(q^2-1)*(q^3-1)*(q^8+q^4+1),
	q^12*(q+1)*(q^3-1)*(q^8+q^4+1),
	q^12*(q^2-1)*(q-1)*(q^3+1)*(q^2-q+1)*(q^4-q^2+1),
	q^12*(q^2-1)*(q+1)*(q^3-1)*(q^2+q+1)*(q^4-q^2+1),
	q^12*(q^2-1)*(q^6-1)*(q^4+q^2+1),
	q^12*(q-1)*(q^3-1)*(q^8+q^4+1)])
charinfo = Vector{Any}[
	["",[1,0],["^3D_4","\\phi_{1,0}"]],
	["",[1,1],["^3D_4","\\phi_{1,3}'"]],
	["",[1,2],["^3D_4","\\phi_{2,2}"]],
	["",[1,3],["^3D_4","\\phi_{2,1}"]],
	["",[1,4],["^3D_4","^3D_4[-1]"]],
	["",[1,5],["^3D_4","^3D_4[1]"]],
	["",[1,6],["^3D_4","\\phi_{1,3}''"]],
	["",[1,7],["^3D_4","\\phi_{1,6}"]],
	["",[2,0],["A_1+A_1",[[2],[2]]]],
	["",[2,1],["A_1+A_1",[[2],[1,1]]]],
	["",[2,2],["A_1+A_1",[[1,1],[2]]]],
	["",[2,3],["A_1+A_1",[[1,1],[1,1]]]],
	["",[3,0],["A_1",[2]]],
	["",[3,1],["A_1",[1,1]]],
	["",[4,0],["A_2",[3]]],
	["",[4,1],["A_2",[2,1]]],
	["",[4,2],["A_2",[1,1,1]]],
	["",[5,0],["A_1",[2]]],
	["",[5,1],["A_1",[1,1]]],
	["",[6,0],["A_0",[1]]],
	["",[7,0],["A_1",[2]]],
	["",[7,1],["A_1",[1,1]]],
	["",[8,0],["A_0",[1]]],
	["",[9,0],["A_2",[3]]],
	["",[9,1],["A_2",[2,1]]],
	["",[9,2],["A_2",[1,1,1]]],
	["",[10,0],["A_1",[2]]],
	["",[10,1],["A_1",[1,1]]],
	["",[11,0],["A_0",[1]]],
	["",[12,0],["A_0",[1]]],
	["",[13,0],["A_0",[1]]],
	["",[14,0],["A_0",[1]]],
	["",[15,0],["A_0",[1]]]]
chardegree = R.([
	1,
	q^5-q^3+q,
	q^3*(q+1)^2*(q^4-q^2+1)*1//2,
	q^3*(q^3+1)^2*1//2,
	q^3*(q^3-1)^2*1//2,
	q^3*(q-1)^2*(q^4-q^2+1)*1//2,
	q^11-q^9+q^7,
	q^12,
	q^8+q^4+1,
	q^9+q^5+q,
	q^11+q^7+q^3,
	q^12+q^8+q^4,
	(q+1)*(q^2+q+1)*(q^2-q+1)*(q^4-q^2+1),
	q^3*(q+1)*(q^2-q+1)*(q^2+q+1)*(q^4-q^2+1),
	(q+1)*(q^4-q^2+1)*(q^2-q+1)^2,
	q*(q^4-q^2+1)*(q+1)^2*(q^2-q+1)^2,
	q^3*(q+1)*(q^4-q^2+1)*(q^2-q+1)^2,
	(q+1)*(q^2+q+1)*(q^4-q^2+1)*(q^2-q+1)^2,
	q*(q+1)*(q^2+q+1)*(q^4-q^2+1)*(q^2-q+1)^2,
	(q^2+q+1)*(q^4-q^2+1)*(q+1)^2*(q^2-q+1)^2,
	(q-1)*(q^2+q+1)*(q^2-q+1)*(q^4-q^2+1),
	q^3*(q-1)*(q^2-q+1)*(q^2+q+1)*(q^4-q^2+1),
	(q^4-q^2+1)*(q^2-q+1)^2*(q+1)*(q^2+q+1)*(q-1),
	(q-1)*(q^4-q^2+1)*(q^2+q+1)^2,
	q*(q^4-q^2+1)*(q-1)^2*(q^2+q+1)^2,
	q^3*(q-1)*(q^4-q^2+1)*(q^2+q+1)^2,
	(q-1)*(q^2-q+1)*(q^4-q^2+1)*(q^2+q+1)^2,
	q*(q-1)*(q^2-q+1)*(q^4-q^2+1)*(q^2+q+1)^2,
	(q^4-q^2+1)*(q^2+q+1)^2*(q-1)*(q^2-q+1)*(q+1),
	(q-1)^2*(q+1)^2*(q^2-q+1)^2*(q^4-q^2+1),
	(q-1)^2*(q+1)^2*(q^2+q+1)^2*(q^4-q^2+1),
	(q+1)^2*(q-1)^2*(q^2-q+1)^2*(q^2+q+1)^2,
	(q^2-q+1)*(q^4-q^2+1)*(q-1)^2*(q^2+q+1)^2])

classsums=[
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, (q-2), congruence)
	tt1=eesubs(tt, [a], [(q-1)*1//2])
	(1//2*s1-1//2*tt1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, (q-2), congruence)
	tt1=eesubs(tt, [a], [(q-1)*1//2])
	(1//2*s1-1//2*tt1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2+q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2+q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2+q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 0, q^3-2, congruence)
	tt1=eesubs(tt, [a], [(q-1)*a])
	s2,e2=nesum(tt1, a, 0, q^2+q, congruence)
	s3=eesubs(tt, [a], [(q^3-1)*1//2])
	(1//2*s1-1//2*s2-1//2*s3, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 0, q^3-2, congruence)
	tt1=eesubs(tt, [a], [(q-1)*a])
	s2,e2=nesum(tt1, a, 0, q^2+q, congruence)
	s3=eesubs(tt, [a], [(q^3-1)*1//2])
	(1//2*s1-1//2*s2-1//2*s3, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 0, q^3-2, congruence)
	s2,e2=nesum(s1, b, 1, q-2, congruence)
	tt1=eesubs(tt, [a,b], S.([(q^2+q+1)*a,2*a]))
	s3,e3=nesum(tt1, a, 0, q-2, congruence)
	tt1=eesubs(tt, [a,b], S.([2*a,a]))
	s4,e4=nesum(tt1, a, 0, q^3-2, congruence)
	tt1=eesubs(tt, [b], [a])
	s5,e5=nesum(tt1, a, 0, q^3-2, congruence)
	tt1=eesubs(tt, [a,b], S.([(q-1)*a,0]))
	s6,e6=nesum(tt1, a, 0, q^2+q, congruence)
	tt1=eesubs(tt, [a,b], S.([(q^3-1)*1//2,0]))
	tt2=eesubs(tt, [a,b], S.([(q^3-1),0]))
	(1//12*s2-1//4*s3-1//12*s4-1//12*s5+1//6*s6+1//4*tt1+1//4*tt2, union(e1,e2,e3,e4,e5,e6))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q, congruence)
	tt1=eesubs(tt, [a], [(q+1)*1//2])
	(1//2*s1-1//2*tt1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q, congruence)
	tt1=eesubs(tt, [a], [(q+1)*1//2])
	(1//2*s1-1//2*tt1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 0, q^4+q^3-q-2, congruence)
	tt1=eesubs(tt, [a], [(q+1)*a])
	s2,e2=nesum(tt1, a, 0, q^3-2, congruence)
	tt1=eesubs(tt, [a], [(q^3-1)*a])
	s3,e3=nesum(tt1, a, 0, q, congruence)
	tt1=eesubs(tt, [a], [(q^3-1)*(q+1)*1//2])
	tt2=eesubs(tt, [a], [(q^3-1)*(q+1)])
	(1//4*s1-1//4*s2-1//4*s3+1//4*tt1+1//4*tt2, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2-q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2-q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2-q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 0, q^3, congruence)
	tt1=eesubs(tt, [a], [(q+1)*a])
	s2,e2=nesum(tt1, a, 0, q^2-q, congruence)
	s3=eesubs(tt, [a], [(q^3+1)*1//2])
	(1//2*s1-1//2*s2-1//2*s3, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 0, q^3, congruence)
	tt1=eesubs(tt, [a], [(q+1)*a])
	s2,e2=nesum(tt1, a, 0, q^2-q, congruence)
	s3=eesubs(tt, [a], [(q^3+1)*1//2])
	(1//2*s1-1//2*s2-1//2*s3, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 0, q^4-q^3+q-2, congruence)
	tt1=eesubs(tt, [a], [(q-1)*a])
	s2,e2=nesum(tt1, a, 0, q^3, congruence)
	tt1=eesubs(tt, [a], [(q^3+1)*a])
	s3,e3=nesum(tt1, a, 0, q-2, congruence)
	tt1=eesubs(tt, [a], [(q^3+1)*(q-1)*1//2])
	tt2=eesubs(tt, [a], [(q^3+1)*(q-1)])
	(1//4*s1-1//4*s2-1//4*s3+1//4*tt1+1//4*tt2, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 0, q^2+q, congruence)
	s2,e2=nesum(s1, b, 0, q^2+q, congruence)
	tt1=eesubs(tt, [b], [a])
	s3,e3=nesum(tt1, a, 0, q^2+q, congruence)
	tt1=eesubs(tt, [a,b], S.([0,0]))
	(1//24*s2-1//6*s3+1//8*tt1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 0, q^2-q, congruence)
	s2,e2=nesum(s1, b, 0, q^2-q, congruence)
	tt1=eesubs(tt, [b], [a])
	s3,e3=nesum(tt1, a, 0, q^2-q, congruence)
	tt1=eesubs(tt, [a,b], S.([0,0]))
	(1//24*s2-1//6*s3+1//8*tt1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^4-q^2, congruence)
	(1//4*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 0, q^3, congruence)
	s2,e2=nesum(s1, b, 1, q, congruence)
	tt1=eesubs(tt, [a,b], S.([(q^2-q+1)*a,2*a]))
	s3,e3=nesum(tt1, a, 0, q, congruence)
	tt1=eesubs(tt, [a,b], S.([2*a,a]))
	s4,e4=nesum(tt1, a, 0, q^3, congruence)
	tt1=eesubs(tt, [b], [a])
	s5,e5=nesum(tt1, a, 0, q^3, congruence)
	tt1=eesubs(tt, [a,b], S.([(q+1)*a,0]))
	s6,e6=nesum(tt1, a, 0, q^2-q, congruence)
	tt1=eesubs(tt, [a,b], S.([(q^3+1)*1//2,0]))
	tt2=eesubs(tt, [a,b], S.([(q^3+1),0]))
	(1//12*s2-1//4*s3-1//12*s4-1//12*s5+1//6*s6+1//4*tt1+1//4*tt2, union(e1,e2,e3,e4,e5,e6))
end
]

charsums=[
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, (q-2), congruence)
	tt1=eesubs(tt, [k], [(q-1)*1//2])
	(1//2*s1-1//2*tt1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, (q-2), congruence)
	tt1=eesubs(tt, [k], [(q-1)*1//2])
	(1//2*s1-1//2*tt1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^2+q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^2+q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^2+q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 0, q^3-2, congruence)
	tt1=eesubs(tt, [k], [(q-1)*k])
	s2,e2=nesum(tt1, k, 0, q^2+q, congruence)
	s3=eesubs(tt, [k], [(q^3-1)*1//2])
	(1//2*s1-1//2*s2-1//2*s3, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 0, q^3-2, congruence)
	tt1=eesubs(tt, [k], [(q-1)*k])
	s2,e2=nesum(tt1, k, 0, q^2+q, congruence)
	s3=eesubs(tt, [k], [(q^3-1)*1//2])
	(1//2*s1-1//2*s2-1//2*s3, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 0, q^3-2, congruence)
	s2,e2=nesum(s1, l, 0, q-2, congruence)
	tt1=eesubs(tt, [l], [0])
	s3,e3=nesum(tt1, k, 0, q^3-2, congruence)
	tt1=eesubs(tt, [k,l], S.([(q-1)*k,0]))
	s4,e4=nesum(tt1, k, 0, q^2+q, congruence)
	tt1=eesubs(tt, [k], [0])
	s5,e5=nesum(tt1, l, 1, q-2, congruence)
	tt1=eesubs(tt, [k,l], S.([(q^3-1)*1//2,0]))
	(1//12*s2-1//4*s3+1//6*s4-1//4*s5+1//4*tt1, union(e1,e2,e3,e4,e5))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q, congruence)
	tt1=eesubs(tt, [k], [(q+1)*1//2])
	(1//2*s1-1//2*tt1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q, congruence)
	tt1=eesubs(tt, [k], [(q+1)*1//2])
	(1//2*s1-1//2*tt1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 0, q^4+q^3-q-2, congruence)
	tt1=eesubs(tt, [k], [(q+1)*k])
	s2,e2=nesum(tt1, k, 0, q^3-2, congruence)
	tt1=eesubs(tt, [k], [(q^3-1)*k])
	s3,e3=nesum(tt1, k, 0, q, congruence)
	tt1=eesubs(tt, [k], [(q^3-1)*(q+1)*1//2])
	tt2=eesubs(tt, [k], [(q^3-1)*(q+1)])
	(1//4*s1-1//4*s2-1//4*s3+1//4*tt1+1//4*tt2, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^2-q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^2-q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^2-q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 0, q^3, congruence)
	tt1=eesubs(tt, [k], [(q+1)*k])
	s2,e2=nesum(tt1, k, 0, q^2-q, congruence)
	s3=eesubs(tt, [k], [(q^3+1)*1//2])
	(1//2*s1-1//2*s2-1//2*s3, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 0, q^3, congruence)
	tt1=eesubs(tt, [k], [(q+1)*k])
	s2,e2=nesum(tt1, k, 0, q^2-q, congruence)
	s3=eesubs(tt, [k], [(q^3+1)*1//2])
	(1//2*s1-1//2*s2-1//2*s3, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 0, q^4-q^3+q-2, congruence)
	tt1=eesubs(tt, [k], [(q-1)*k])
	s2,e2=nesum(tt1, k, 0, q^3, congruence)
	tt1=eesubs(tt, [k], [(q^3+1)*k])
	s3,e3=nesum(tt1, k, 0, q-2, congruence)
	tt1=eesubs(tt, [k], [(q^3+1)*(q-1)*1//2])
	tt2=eesubs(tt, [k], [(q^3+1)*(q-1)])
	(1//4*s1-1//4*s2-1//4*s3+1//4*tt1+1//4*tt2, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 0, q^2+q, congruence)
	s2,e2=nesum(s1, l, 0, q^2+q, congruence)
	tt1=eesubs(tt, [l], [0])
	s3,e3=nesum(tt1, k, 0, q^2+q, congruence)
	tt1=eesubs(tt, [k,l], S.([0,0]))
	(1//24*s2-1//6*s3+1//8*tt1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 0, q^2-q, congruence)
	s2,e2=nesum(s1, l, 0, q^2-q, congruence)
	tt1=eesubs(tt, [l], [0])
	s3,e3=nesum(tt1, k, 0, q^2-q, congruence)
	tt1=eesubs(tt, [k,l], S.([0,0]))
	(1//24*s2-1//6*s3+1//8*tt1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^4-q^2, congruence)
	(1//4*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^3, congruence)
	s2,e2=nesum(s1, l, 1, q, congruence)
	tt1=eesubs(tt, [l], [0])
	s3,e3=nesum(tt1, k, 1, q^3, congruence)
	tt1=eesubs(tt, [k,l], S.([(q+1)*k,0]))
	s4,e4=nesum(tt1, k, 1, q^2-q, congruence)
	tt1=eesubs(tt, [k], [0])
	s5,e5=nesum(tt1, l, 1, q, congruence)
	tt1=eesubs(tt, [k,l], S.([(q^3+1)*1//2,0]))
	(1//12*s2-1//6*s3+1//6*s4-1//6*s5+1//4*tt1, union(e1,e2,e3,e4,e5))
end
]

classparams=[
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q-1)], [ParameterException((a)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q-1)], [ParameterException((a)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q^2+q+1)], [ParameterException((a)*1//(q^2+q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q^2+q+1)], [ParameterException((a)*1//(q^2+q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q^2+q+1)], [ParameterException((a)*1//(q^2+q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q^3-1)], [ParameterException((a)*1//(q-1)), ParameterException((a)*1//((q^3-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q^3-1)], [ParameterException((a)*1//(q-1)), ParameterException((a)*1//((q^3-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q^3-1), Parameter(b, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q+1)], [ParameterException((a)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q+1)], [ParameterException((a)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, (q^3-1)*(q+1))], [ParameterException((a)*1//(q+1)), ParameterException((a)*1//(q^3-1)), ParameterException((a)*1//((q^3-1)*(q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q^2-q+1)], [ParameterException((a)*1//(q^2-q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q^2-q+1)], [ParameterException((a)*1//(q^2-q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q^2-q+1)], [ParameterException((a)*1//(q^2-q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q^3+1)], [ParameterException((a)*1//(q+1)), ParameterException((a)*1//((q^3+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q^3+1)], [ParameterException((a)*1//(q+1)), ParameterException((a)*1//((q^3+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, (q^3+1)*(q-1))], [ParameterException((a)*1//(q-1)), ParameterException((a)*1//(q^3+1)), ParameterException((a)*1//((q^3+1)*(q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q^2+q+1), Parameter(b, q^2+q+1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q^2-q+1), Parameter(b, q^2-q+1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q^4-q^2+1)], [ParameterException((a)*1//(q^4-q^2+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(a, q^3+1), Parameter(b, q+1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[])
]

charparams=[
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q-1)], [ParameterException((k)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q-1)], [ParameterException((k)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q^2+q+1)], [ParameterException((k)*1//(q^2+q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q^2+q+1)], [ParameterException((k)*1//(q^2+q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q^2+q+1)], [ParameterException((k)*1//(q^2+q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q^3-1)], [ParameterException((k)*1//(q-1)), ParameterException((k)*1//((q^3-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q^3-1)], [ParameterException((k)*1//(q-1)), ParameterException((k)*1//((q^3-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q^3-1), Parameter(l, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q+1)], [ParameterException((k)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q+1)], [ParameterException((k)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, (q^3-1)*(q+1))], [ParameterException((k)*1//(q+1)), ParameterException((k)*1//(q^3-1)), ParameterException((k)*1//((q^3-1)*(q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q^2-q+1)], [ParameterException((k)*1//(q^2-q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q^2-q+1)], [ParameterException((k)*1//(q^2-q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q^2-q+1)], [ParameterException((k)*1//(q^2-q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q^3+1)], [ParameterException((k)*1//(q+1)), ParameterException((k)*1//((q^3+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q^3+1)], [ParameterException((k)*1//(q+1)), ParameterException((k)*1//((q^3+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, (q^3+1)*(q-1))], [ParameterException((k)*1//(q-1)), ParameterException((k)*1//(q^3+1)), ParameterException((k)*1//((q^3+1)*(q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q^2+q+1), Parameter(l, q^2+q+1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q^2-q+1), Parameter(l, q^2-q+1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q^4-q^2+1)], [ParameterException((k)*1//(q^4-q^2+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k, q^3+1), Parameter(l, q+1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[])
]

classparamindex=var_index.([a,b])
charparamindex=var_index.([k,l])
congruence=R.((1,4))

information = "- Information about the generic character table of \$^3D_4(q)\$,
  \$p>2\$, congruent to \$1\$ modulo \$4\$.

- CHEVIE-name of the table: ``3D4.1``

- The table was first computed in:
  {\\sc D. I. Deriziotis, G. O. Michler}, Character table and blocks
    of finite simple triality groups \$^3D_4(q)\$, {\\em Trans. Am. Math. Soc.
    \\bf303} (1987), 39--70.
"

TABLE=CharTable(order,ExtendableMatrix(permutedims(table)),classinfo,classlength,charinfo,chardegree,
	classsums,charsums,classparamindex,charparamindex,classparams,charparams,congruence,R,S,information)
