using ..GenericCharacterTables
import ..GenericCharacterTables: ExtendableMatrix, SimpleCharTable
using Oscar
R, q = polynomial_ring(QQ, "q")

order = (q-1)^3*(q+1)^2*(q^2+1)*q^4
table = QQPolyRingElem[[
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1),
	R(1)] [
	1//2*q*(q+1)^2,
	1//2*q*(q+1),
	q,
	R(0),
	R(0),
	1//2*(q+1)^2,
	1//2*q+1//2,
	1//2*q+1//2,
	1//2*q+1//2,
	1//2-1//2*q,
	1//2*(q-1)*(q+1),
	1//2*q-1//2,
	-1//2-1//2*q,
	q+1,
	R(1),
	R(0),
	R(0),
	q+1,
	R(1),
	R(0),
	R(0),
	R(2),
	R(0),
	R(0),
	R(-1),
	R(0)] [
	1//2*q*(q^2+1),
	1//2*q*(q+1),
	R(0),
	q,
	R(0),
	-1//2*q^2+q+1//2,
	1//2*q+1//2,
	1//2*q+1//2,
	1//2-1//2*q,
	1//2*q+1//2,
	-1//2*q^2-1//2,
	-1//2-1//2*q,
	1//2*q-1//2,
	q,
	R(0),
	R(-1),
	R(-1),
	R(1),
	R(1),
	q,
	R(0),
	R(1),
	R(-1),
	R(1),
	R(0),
	R(-1)] [
	1//2*q*(q^2+1),
	-1//2*(q-1)*q,
	q,
	R(0),
	R(0),
	1//2*q^2+q-1//2,
	1//2*q-1//2,
	1//2*q-1//2,
	-1//2-1//2*q,
	1//2*q-1//2,
	1//2*q^2+1//2,
	1//2-1//2*q,
	1//2*q+1//2,
	R(1),
	R(1),
	q,
	R(0),
	q,
	R(0),
	R(-1),
	R(-1),
	R(1),
	R(1),
	R(-1),
	R(0),
	R(-1)] [
	1//2*q*(q-1)^2,
	-1//2*(q-1)*q,
	R(0),
	q,
	R(0),
	-1//2*(q-1)^2,
	1//2*q-1//2,
	1//2*q-1//2,
	1//2*q-1//2,
	-1//2-1//2*q,
	-1//2*(q-1)*(q+1),
	1//2*q+1//2,
	1//2-1//2*q,
	R(0),
	R(0),
	q-1,
	R(-1),
	R(0),
	R(0),
	q-1,
	R(-1),
	R(0),
	R(0),
	R(0),
	R(1),
	R(-2)] [
	q^4,
	R(0),
	R(0),
	R(0),
	R(0),
	q^2,
	R(0),
	R(0),
	R(0),
	R(0),
	-q^2,
	R(0),
	R(0),
	q,
	R(0),
	-q,
	R(0),
	q,
	R(0),
	-q,
	R(0),
	R(1),
	R(-1),
	R(-1),
	R(1),
	R(1)]]
classinfo = Vector{Any}[
	["",[1,0],["C_2",["A0"]],"A0(i)"],
	["",[1,1],["C_2",["A1"]],"A1(i)"],
	["",[1,2],["C_2",["A2"]],"A21(i)"],
	["",[1,3],["C_2",["A22"]],"A22(i)"],
	["",[1,4],["C_2",["A3"]],"A3(i)"],
	["",[2,0],["\\tilde{A}_1+\\tilde{A}_1",[]],"B0(i)"],
	["",[2,1],["\\tilde{A}_1+\\tilde{A}_1",[]],"B1(i)"],
	["",[2,2],["\\tilde{A}_1+\\tilde{A}_1",[]],"B2(i)"],
	["",[2,3],["\\tilde{A}_1+\\tilde{A}_1",[]],"B31(i)"],
	["",[2,4],["\\tilde{A}_1+\\tilde{A}_1",[]],"B32(i)"],
	["",[3,0],["^2(\\tilde{A}_1+\\tilde{A}_1)",[1,1]],"C0(i)"],
	["",[3,1],["^2(\\tilde{A}_1+\\tilde{A}_1)",[2]],"C11(i)"],
	["",[3,2],["^2(\\tilde{A}_1+\\tilde{A}_1)",[2]],"C12(i)"],
	["",[4,0],["A_1",[1,1]],"D0(i,j)"],
	["",[4,1],["A_1",[2]],"D1(i,j)"],
	["",[5,0],["A_1",[1,1]],"F0(i)"],
	["",[5,1],["A_1",[2]],"F1(i)"],
	["",[6,0],["\\tilde{A}_1",[1,1]],"E0(i,j)"],
	["",[6,1],["\\tilde{A}_1",[2]],"E1(i,j)"],
	["",[7,0],["\\tilde{A}_1",[1,1]],"G0(i,j)"],
	["",[7,1],["\\tilde{A}_1",[2]],"G1(i,j)"],
	["",[8,0],["A_0",[1]],"H0(i,j,h)"],
	["",[9,0],["A_0",[1]],"I0(i,j)"],
	["",[10,0],["A_0",[1]],"J0(i,j)"],
	["",[11,0],["A_0",[1]],"K0(i)"],
	["",[12,0],["A_0",[1]],"L0(i,j)"]]
classlength = R.([
	1,
	(q-1)*(q+1)*(q^2+1),
	1//2*q*(q-1)*(q+1)^2*(q^2+1),
	1//2*q*(q-1)^2*(q+1)*(q^2+1),
	q^2*(q-1)^2*(q+1)^2*(q^2+1),
	(q^2+1)*q^2,
	(q-1)*(q+1)*(q^2+1)*q^2,
	(q-1)*(q+1)*(q^2+1)*q^2,
	1//2*q^2*(q-1)^2*(q+1)^2*(q^2+1),
	1//2*q^2*(q-1)^2*(q+1)^2*(q^2+1),
	(q-1)*(q+1)*q^2,
	1//2*(q^2-1)*(q^2+1)*(q-1)*(q+1)*q^2,
	1//2*(q^2-1)*(q^2+1)*(q-1)*(q+1)*q^2,
	(q+1)*(q^2+1)*q^3,
	(q-1)*(q+1)^2*(q^2+1)*q^3,
	(q-1)*(q^2+1)*q^3,
	(q-1)^2*(q+1)*(q^2+1)*q^3,
	(q+1)*(q^2+1)*q^3,
	(q-1)*(q+1)^2*(q^2+1)*q^3,
	(q-1)*(q^2+1)*q^3,
	(q-1)^2*(q+1)*(q^2+1)*q^3,
	(q+1)^2*(q^2+1)*q^4,
	(q-1)*(q+1)*(q^2+1)*q^4,
	(q-1)*(q+1)*(q^2+1)*q^4,
	(q-1)^2*(q+1)^2*q^4,
	(q-1)^2*(q^2+1)*q^4])
classtypeorder = R.([
	q-1,
	q-1,
	q-1,
	q-1,
	q-1,
	1//2*q-1//2,
	1//2*q-1//2,
	1//2*q-1//2,
	1//2*q-1//2,
	1//2*q-1//2,
	1//2*q-1//2,
	1//2*q-1//2,
	1//2*q-1//2,
	1//2*(q-2)*(q-1),
	1//2*(q-2)*(q-1),
	1//2*(q-1)*q,
	1//2*(q-1)*q,
	1//2*(q-3)*(q-1),
	1//2*(q-3)*(q-1),
	1//2*(q-1)^2,
	1//2*(q-1)^2,
	1//8*(q-3)^2*(q-1),
	1//4*(q-1)*(q^2-2*q-1),
	1//4*(q-1)^3,
	1//4*(q-1)^2*(q+1),
	1//8*(q-1)^3])
charinfo = Vector{Any}[[], [], [], [], [], []]
chardegree = R.([1, 1//2*q*(q+1)^2, 1//2*q*(q^2+1), 1//2*q*(q^2+1), 1//2*q*(q-1)^2, q^4])

information = "- Information about the generic character table of \$CSp_4(q)\$ with odd \$q\$
  (unipotent characters).

- CHEVIE-name of the table: ``uniCSp4.1``

- The generic character table for \$CSp_4(q)\$ was computed in:
  {\\sc K.~Shinoda}, The Characters of the Finite Conformal Symplectic,
  Group CSp(4,q) {\\em Comm.~Alg.} {\\bf 10(13)} (1982), 1369--1419.

- The name of the i-th class type in the cited paper can be found by:
  > ``uniCSp4.1``[-1,i][4];
  or with 'PrintInfoClass'.

- This release of CHEVIE only contains the unipotent characters.
  We have a preliminary version of the complete table, but it contains
  a few errors.

- We are developing programs for computing (parts of) generic character tables
  and we will use the group \$CSp_4(q)\$ as \"test example\". This is the reason
  that we did not try to find the errors in the above mentioned table for 
  this  release.
"

TABLE=SimpleCharTable(order,ExtendableMatrix(permutedims(table)),classinfo,classlength,classtypeorder,charinfo,chardegree,R,information)
