using ..GenericCharacterTables
import ..GenericCharacterTables: Cyclotomic, Parameters, Parameter, ParameterException, ParameterSubstitution, ExtendableMatrix, CharTable
using Oscar
R, q = polynomial_ring(QQ, "q")
Q = fraction_field(R)
S = UniversalPolynomialRing(Q, cached=false)

order = q^24*(q^4-q^2+1)*(q^4+1)*(q^2+q+1)^2*(q^2-q+1)^2*(q^2+1)^2*(q-1)^4*(q+1)^4
table = Cyclotomic{QQPolyRingElem}[[
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0))] [
	(1//2*q*(q^4+1)*(q+1)^2*(q^2-q+1)^2)*e2p(S(0)),
	(1//2*q*(q+1)*(q^2-q+1)*(q^4+q^3+1))*e2p(S(0)),
	(1//2*q*(q+1)*(q^2-q+1)*(q^4+q^3+1))*e2p(S(0)),
	(1//2*(q^6+q^4+2*q^3+1)*q)*e2p(S(0)),
	(1//2*q*(q+1)*(q^3+q^2-q+1))*e2p(S(0)),
	(1//2*(2*q^4+q^3+1)*q)*e2p(S(0)),
	(1//2*q*(q+1)*(q^2-q+1))*e2p(S(0)),
	(1//2*(2*q^4+q^3+1)*q)*e2p(S(0)),
	(1//2*q*(q+1)*(q^2-q+1))*e2p(S(0)),
	(1//2*(q^4+2*q^3+q^2+1)*q)*e2p(S(0)),
	(-1//2*(q^4-2*q^3-q^2-1)*q)*e2p(S(0)),
	(1//2*q*(q+1)*(q^2-q+1))*e2p(S(0)),
	(1//2*q*(q+1)*(q^2-q+1))*e2p(S(0)),
	(1//2*(q^3+q^2+1)*q)*e2p(S(0)),
	(1//2*(q^3+q^2+1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q*(q^2+1))*e2p(S(0)),
	(1//2*(2*q^2+1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q*(q-1)*(q+1))*e2p(S(0)),
	(1//2*(2*q+1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*(2*q+1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*(4*q+1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*(2*q-1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0))] [
	(1//2*q*(q^2+1)*(q^4-q^2+1)*(q^4+1))*e2p(S(0)),
	(-1//2*(q^7-q^6-q^4-1)*q)*e2p(S(0)),
	(1//2*(q^7+q^6+q^4+1)*q)*e2p(S(0)),
	(1//2*(q^6+q^4+1)*q)*e2p(S(0)),
	(1//2*q*(q^4+1))*e2p(S(0)),
	(1//2*(2*q^4+q^3+1)*q)*e2p(S(0)),
	(1//2*q*(q+1)*(q^2-q+1))*e2p(S(0)),
	(-1//2*q*(q-1)*(q^2+q+1))*e2p(S(0)),
	(1//2*(2*q^4-q^3+1)*q)*e2p(S(0)),
	(-1//2*(q^4-q^2-1)*q)*e2p(S(0)),
	(1//2*q*(q^2-q+1)*(q^2+q+1))*e2p(S(0)),
	(1//2*q*(q+1)*(q^2-q+1))*e2p(S(0)),
	(-1//2*q*(q-1)*(q^2+q+1))*e2p(S(0)),
	(1//2*(q^3+q^2+1)*q)*e2p(S(0)),
	(-1//2*(q^3-q^2-1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q*(q^2+1))*e2p(S(0)),
	(1//2*(2*q^2+1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q*(q-1)*(q+1))*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*(2*q+1)*q)*e2p(S(0)),
	(-1//2*(2*q-1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*(2*q-1)*q)*e2p(S(0)),
	(1//2*(2*q+1)*q)*e2p(S(0)),
	(1//2*(2*q+1)*q)*e2p(S(0)),
	(-1//2*(2*q-1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0))] [
	(1//2*q*(q^2+1)*(q^4-q^2+1)*(q^4+1))*e2p(S(0)),
	(1//2*(q^7+q^6+q^4+1)*q)*e2p(S(0)),
	(-1//2*(q^7-q^6-q^4-1)*q)*e2p(S(0)),
	(1//2*(q^6+q^4+1)*q)*e2p(S(0)),
	(1//2*q*(q^4+1))*e2p(S(0)),
	(-1//2*q*(q-1)*(q^2+q+1))*e2p(S(0)),
	(1//2*(2*q^4-q^3+1)*q)*e2p(S(0)),
	(1//2*(2*q^4+q^3+1)*q)*e2p(S(0)),
	(1//2*q*(q+1)*(q^2-q+1))*e2p(S(0)),
	(-1//2*(q^4-q^2-1)*q)*e2p(S(0)),
	(1//2*q*(q^2-q+1)*(q^2+q+1))*e2p(S(0)),
	(-1//2*q*(q-1)*(q^2+q+1))*e2p(S(0)),
	(1//2*q*(q+1)*(q^2-q+1))*e2p(S(0)),
	(-1//2*(q^3-q^2-1)*q)*e2p(S(0)),
	(1//2*(q^3+q^2+1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q*(q^2+1))*e2p(S(0)),
	(1//2*(2*q^2+1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q*(q-1)*(q+1))*e2p(S(0)),
	(-1//2*(2*q-1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*(2*q+1)*q)*e2p(S(0)),
	(-1//2*(2*q-1)*q)*e2p(S(0)),
	(-1//2*(2*q-1)*q)*e2p(S(0)),
	(1//2*(2*q+1)*q)*e2p(S(0)),
	(1//2*(2*q+1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0))] [
	(1//2*q*(q^4+1)*(q-1)^2*(q^2+q+1)^2)*e2p(S(0)),
	(-1//2*q*(q-1)*(q^2+q+1)*(q^4-q^3+1))*e2p(S(0)),
	(-1//2*q*(q-1)*(q^2+q+1)*(q^4-q^3+1))*e2p(S(0)),
	(1//2*(q^6+q^4-2*q^3+1)*q)*e2p(S(0)),
	(1//2*q*(q-1)*(q^3-q^2-q-1))*e2p(S(0)),
	(-1//2*q*(q-1)*(q^2+q+1))*e2p(S(0)),
	(1//2*(2*q^4-q^3+1)*q)*e2p(S(0)),
	(-1//2*q*(q-1)*(q^2+q+1))*e2p(S(0)),
	(1//2*(2*q^4-q^3+1)*q)*e2p(S(0)),
	(1//2*(q^4-2*q^3+q^2+1)*q)*e2p(S(0)),
	(-1//2*(q^4+2*q^3-q^2-1)*q)*e2p(S(0)),
	(-1//2*q*(q-1)*(q^2+q+1))*e2p(S(0)),
	(-1//2*q*(q-1)*(q^2+q+1))*e2p(S(0)),
	(-1//2*(q^3-q^2-1)*q)*e2p(S(0)),
	(-1//2*(q^3-q^2-1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q*(q^2+1))*e2p(S(0)),
	(1//2*(2*q^2+1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q*(q-1)*(q+1))*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*(2*q-1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*(2*q-1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*(4*q-1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*(2*q+1)*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0))] [
	(q^2*(q^4-q^2+1)*(q^2-q+1)^2*(q^2+q+1)^2)*e2p(S(0)),
	(q^2*(q^2-q+1)*(q^2+q+1)*(q^4+1))*e2p(S(0)),
	(q^2*(q^2-q+1)*(q^2+q+1)*(q^4+1))*e2p(S(0)),
	((q^6+2*q^4+q^2+1)*q^2)*e2p(S(0)),
	((2*q^4+q^2+1)*q^2)*e2p(S(0)),
	(q^2*(q^2-q+1)*(q^2+q+1))*e2p(S(0)),
	(q^2*(q^2-q+1)*(q^2+q+1))*e2p(S(0)),
	(q^2*(q^2-q+1)*(q^2+q+1))*e2p(S(0)),
	(q^2*(q^2-q+1)*(q^2+q+1))*e2p(S(0)),
	(q^2*(q^2-q+1)*(q^2+q+1))*e2p(S(0)),
	(q^2*(q^2-q+1)*(q^2+q+1))*e2p(S(0)),
	(q^2*(q^2+1))*e2p(S(0)),
	(q^2*(q^2+1))*e2p(S(0)),
	(q^2*(q^2+1))*e2p(S(0)),
	(q^2*(q^2+1))*e2p(S(0)),
	(q^2*(q^2+1))*e2p(S(0)),
	(q^2*(q^2+1))*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^3*(q^4-q^2+1)*(q^4+1)*(q^2+1)^2)*e2p(S(0)),
	(q^3*(q^2+1)*(q^6+q^4+1))*e2p(S(0)),
	(q^3*(q^2+1)*(q^4+1))*e2p(S(0)),
	(q^3*(q^2+1)*(q^4+1))*e2p(S(0)),
	(q^3*(q^2-q+1)*(q^2+q+1))*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	((q^4+q^3+q^2+1)*q^3)*e2p(S(0)),
	((q^4-q^3+q^2+1)*q^3)*e2p(S(0)),
	(q^3*(q^2+1))*e2p(S(0)),
	(q^3*(q^2+1))*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3*(q^2+1))*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3*(q^2+1))*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^3*(q^4-q^2+1)*(q^4+1)*(q^2+1)^2)*e2p(S(0)),
	(q^3*(q^2+1)*(q^4+1))*e2p(S(0)),
	(q^3*(q^2+1)*(q^6+q^4+1))*e2p(S(0)),
	(q^3*(q^2+1)*(q^4+1))*e2p(S(0)),
	(q^3*(q^2-q+1)*(q^2+q+1))*e2p(S(0)),
	((q^4+q^3+q^2+1)*q^3)*e2p(S(0)),
	((q^4-q^3+q^2+1)*q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3*(q^2+1))*e2p(S(0)),
	(q^3*(q^2+1))*e2p(S(0)),
	(q^3*(q^2+1))*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3*(q^2+1))*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//24*q^4*(q^4+1)*(q^4-q^2+1)*(q^2+q+1)^2*(q+1)^4)*e2p(S(0)),
	(1//24*q^4*(q^2+q+1)*(3*q^5-q^3+q^2+2*q+1)*(q+1)^3)*e2p(S(0)),
	(1//24*q^4*(q^2+q+1)*(3*q^5-q^3+q^2+2*q+1)*(q+1)^3)*e2p(S(0)),
	(1//24*q^4*(2*q^5+2*q^3+4*q^2+3*q+1)*(q+1)^3)*e2p(S(0)),
	(1//24*q^4*(2*q+1)*(3*q^2+2*q+1)*(q+1)^2)*e2p(S(0)),
	(1//24*q^4*(3*q+1)*(q^2+q+1)*(q+1)^2)*e2p(S(0)),
	(-1//24*q^4*(3*q^3-4*q^2-4*q-1)*(q+1)^2)*e2p(S(0)),
	(1//24*q^4*(3*q+1)*(q^2+q+1)*(q+1)^2)*e2p(S(0)),
	(-1//24*q^4*(3*q^3-4*q^2-4*q-1)*(q+1)^2)*e2p(S(0)),
	(1//8*q^4*(3*q^2+1)*(q+1)^2)*e2p(S(0)),
	(-1//8*q^4*(q-1)*(q+1)^3)*e2p(S(0)),
	(1//24*q^4*(2*q+1)*(3*q+1)*(q+1))*e2p(S(0)),
	(1//24*q^4*(2*q+1)*(3*q+1)*(q+1))*e2p(S(0)),
	(1//8*q^4*(q+1)^2)*e2p(S(0)),
	(1//8*q^4*(q+1)^2)*e2p(S(0)),
	(1//24*(2*q+1)*(4*q+1)*q^4)*e2p(S(0)),
	(1//8*(2*q+1)*q^4)*e2p(S(0)),
	(1//24*(q^2+5)*q^4)*e2p(S(0)),
	(-1//24*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//24*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^3*(q+1))*e2p(S(0)),
	(-1//4*q^3*(q+1))*e2p(S(0)),
	(1//4*q^3*(q+1))*e2p(S(0)),
	(-1//4*q^3*(q+1))*e2p(S(0)),
	(1//8*(q+4)*q^3)*e2p(S(0)),
	(-1//8*q^4)*e2p(S(0)),
	(1//8*(q-4)*q^3)*e2p(S(0)),
	(-1//8*q^4)*e2p(S(0)),
	(1//8*q^4)*e2p(S(0)),
	(1//4*q^3)*e2p(S(0)),
	(-1//4*q^3)*e2p(S(0)),
	(1//2*q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//2*q^2)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//8*q^4*(q^4+1)*(q^4-q^2+1)*(q^2+q+1)^2*(q^2+1)^2)*e2p(S(0)),
	(-1//8*q^4*(q+1)*(q^2-q+1)*(q^2+q+1)*(q^3-q^2-q-1)*(q^2+1))*e2p(S(0)),
	(1//8*q^4*(q^2+q+1)*(q^2+1)*(3*q^6+q^5+q^4+q^2+q+1))*e2p(S(0)),
	(1//8*q^4*(q^2+1)*(2*q^6+2*q^5+2*q^4+2*q^3+3*q^2+2*q+1))*e2p(S(0)),
	(1//8*q^4*(q+1)*(q^2+1)*(2*q^2+q+1))*e2p(S(0)),
	(1//8*q^4*(q+1)*(q^2+q+1)*(3*q^2+1))*e2p(S(0)),
	(-1//8*(3*q^5-2*q^4-q^3-5*q^2-2*q-1)*q^4)*e2p(S(0)),
	(-1//8*q^4*(q-1)*(q^2+q+1)*(q+1)^2)*e2p(S(0)),
	(1//8*q^4*(q^2-q+1)*(q+1)^3)*e2p(S(0)),
	(-1//8*q^4*(q^2+1)*(3*q^2-2*q-3))*e2p(S(0)),
	(1//8*q^4*(q^2+1)*(q^2+2*q+3))*e2p(S(0)),
	(1//8*q^4*(q+1)*(2*q^2+q+1))*e2p(S(0)),
	(-1//8*q^4*(q-1)*(2*q+1)*(q+1))*e2p(S(0)),
	(1//8*(3*q^2+2*q+3)*q^4)*e2p(S(0)),
	(-1//8*q^4*(q+1)*(q-3))*e2p(S(0)),
	(1//8*(2*q+1)*q^4)*e2p(S(0)),
	(1//8*(2*q+3)*q^4)*e2p(S(0)),
	(1//8*(q^2+5)*q^4)*e2p(S(0)),
	(-1//8*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//8*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^3*(q-1))*e2p(S(0)),
	(-1//4*q^3*(q-1))*e2p(S(0)),
	(-1//4*q^3*(q+1))*e2p(S(0)),
	(1//4*q^3*(q+1))*e2p(S(0)),
	(-1//8*(q+4)*q^3)*e2p(S(0)),
	(1//8*q^4)*e2p(S(0)),
	(-1//8*(q-4)*q^3)*e2p(S(0)),
	(1//8*q^4)*e2p(S(0)),
	(-1//8*q^4)*e2p(S(0)),
	(1//4*q^3)*e2p(S(0)),
	(-1//4*q^3)*e2p(S(0)),
	(-1//2*q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//2*q^2)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//8*q^4*(q^4+1)*(q^4-q^2+1)*(q^2+q+1)^2*(q^2+1)^2)*e2p(S(0)),
	(1//8*q^4*(q^2+q+1)*(q^2+1)*(3*q^6+q^5+q^4+q^2+q+1))*e2p(S(0)),
	(-1//8*q^4*(q+1)*(q^2-q+1)*(q^2+q+1)*(q^3-q^2-q-1)*(q^2+1))*e2p(S(0)),
	(1//8*q^4*(q^2+1)*(2*q^6+2*q^5+2*q^4+2*q^3+3*q^2+2*q+1))*e2p(S(0)),
	(1//8*q^4*(q+1)*(q^2+1)*(2*q^2+q+1))*e2p(S(0)),
	(-1//8*q^4*(q-1)*(q^2+q+1)*(q+1)^2)*e2p(S(0)),
	(1//8*q^4*(q^2-q+1)*(q+1)^3)*e2p(S(0)),
	(1//8*q^4*(q+1)*(q^2+q+1)*(3*q^2+1))*e2p(S(0)),
	(-1//8*(3*q^5-2*q^4-q^3-5*q^2-2*q-1)*q^4)*e2p(S(0)),
	(-1//8*q^4*(q^2+1)*(3*q^2-2*q-3))*e2p(S(0)),
	(1//8*q^4*(q^2+1)*(q^2+2*q+3))*e2p(S(0)),
	(-1//8*q^4*(q-1)*(2*q+1)*(q+1))*e2p(S(0)),
	(1//8*q^4*(q+1)*(2*q^2+q+1))*e2p(S(0)),
	(-1//8*q^4*(q+1)*(q-3))*e2p(S(0)),
	(1//8*(3*q^2+2*q+3)*q^4)*e2p(S(0)),
	(1//8*(2*q+1)*q^4)*e2p(S(0)),
	(1//8*(2*q+3)*q^4)*e2p(S(0)),
	(1//8*(q^2+5)*q^4)*e2p(S(0)),
	(-1//8*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//8*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//4*q^3*(q+1))*e2p(S(0)),
	(1//4*q^3*(q+1))*e2p(S(0)),
	(1//4*q^3*(q-1))*e2p(S(0)),
	(-1//4*q^3*(q-1))*e2p(S(0)),
	(-1//8*(q+4)*q^3)*e2p(S(0)),
	(1//8*q^4)*e2p(S(0)),
	(-1//8*(q-4)*q^3)*e2p(S(0)),
	(1//8*q^4)*e2p(S(0)),
	(-1//8*q^4)*e2p(S(0)),
	(1//4*q^3)*e2p(S(0)),
	(-1//4*q^3)*e2p(S(0)),
	(-1//2*q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//2*q^2)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//8*q^4*(q^4+1)*(q^4-q^2+1)*(q^2-q+1)^2*(q^2+1)^2)*e2p(S(0)),
	(-1//8*q^4*(q-1)*(q^2-q+1)*(q^2+q+1)*(q^3+q^2-q+1)*(q^2+1))*e2p(S(0)),
	(1//8*q^4*(q^2-q+1)*(q^2+1)*(3*q^6-q^5+q^4+q^2-q+1))*e2p(S(0)),
	(1//8*q^4*(q^2+1)*(2*q^6-2*q^5+2*q^4-2*q^3+3*q^2-2*q+1))*e2p(S(0)),
	(-1//8*q^4*(q-1)*(q^2+1)*(2*q^2-q+1))*e2p(S(0)),
	(1//8*(3*q^5+2*q^4-q^3+5*q^2-2*q+1)*q^4)*e2p(S(0)),
	(-1//8*q^4*(q-1)*(q^2-q+1)*(3*q^2+1))*e2p(S(0)),
	(-1//8*q^4*(q^2+q+1)*(q-1)^3)*e2p(S(0)),
	(1//8*q^4*(q+1)*(q^2-q+1)*(q-1)^2)*e2p(S(0)),
	(-1//8*q^4*(q^2+1)*(3*q^2+2*q-3))*e2p(S(0)),
	(1//8*q^4*(q^2+1)*(q^2-2*q+3))*e2p(S(0)),
	(-1//8*q^4*(q-1)*(2*q^2-q+1))*e2p(S(0)),
	(1//8*q^4*(q-1)*(2*q-1)*(q+1))*e2p(S(0)),
	(1//8*(3*q^2-2*q+3)*q^4)*e2p(S(0)),
	(-1//8*q^4*(q+3)*(q-1))*e2p(S(0)),
	(-1//8*(2*q-1)*q^4)*e2p(S(0)),
	(-1//8*(2*q-3)*q^4)*e2p(S(0)),
	(1//8*(q^2+5)*q^4)*e2p(S(0)),
	(-1//8*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//8*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//4*q^3*(q+1))*e2p(S(0)),
	(1//4*q^3*(q+1))*e2p(S(0)),
	(1//4*q^3*(q-1))*e2p(S(0)),
	(-1//4*q^3*(q-1))*e2p(S(0)),
	(-1//8*(q+4)*q^3)*e2p(S(0)),
	(1//8*q^4)*e2p(S(0)),
	(-1//8*(q-4)*q^3)*e2p(S(0)),
	(1//8*q^4)*e2p(S(0)),
	(-1//8*q^4)*e2p(S(0)),
	(-1//4*q^3)*e2p(S(0)),
	(1//4*q^3)*e2p(S(0)),
	(1//2*q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//2*q^2)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//8*q^4*(q^4+1)*(q^4-q^2+1)*(q^2-q+1)^2*(q^2+1)^2)*e2p(S(0)),
	(1//8*q^4*(q^2-q+1)*(q^2+1)*(3*q^6-q^5+q^4+q^2-q+1))*e2p(S(0)),
	(-1//8*q^4*(q-1)*(q^2-q+1)*(q^2+q+1)*(q^3+q^2-q+1)*(q^2+1))*e2p(S(0)),
	(1//8*q^4*(q^2+1)*(2*q^6-2*q^5+2*q^4-2*q^3+3*q^2-2*q+1))*e2p(S(0)),
	(-1//8*q^4*(q-1)*(q^2+1)*(2*q^2-q+1))*e2p(S(0)),
	(-1//8*q^4*(q^2+q+1)*(q-1)^3)*e2p(S(0)),
	(1//8*q^4*(q+1)*(q^2-q+1)*(q-1)^2)*e2p(S(0)),
	(1//8*(3*q^5+2*q^4-q^3+5*q^2-2*q+1)*q^4)*e2p(S(0)),
	(-1//8*q^4*(q-1)*(q^2-q+1)*(3*q^2+1))*e2p(S(0)),
	(-1//8*q^4*(q^2+1)*(3*q^2+2*q-3))*e2p(S(0)),
	(1//8*q^4*(q^2+1)*(q^2-2*q+3))*e2p(S(0)),
	(1//8*q^4*(q-1)*(2*q-1)*(q+1))*e2p(S(0)),
	(-1//8*q^4*(q-1)*(2*q^2-q+1))*e2p(S(0)),
	(-1//8*q^4*(q+3)*(q-1))*e2p(S(0)),
	(1//8*(3*q^2-2*q+3)*q^4)*e2p(S(0)),
	(-1//8*(2*q-1)*q^4)*e2p(S(0)),
	(-1//8*(2*q-3)*q^4)*e2p(S(0)),
	(1//8*(q^2+5)*q^4)*e2p(S(0)),
	(-1//8*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//8*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^3*(q-1))*e2p(S(0)),
	(-1//4*q^3*(q-1))*e2p(S(0)),
	(-1//4*q^3*(q+1))*e2p(S(0)),
	(1//4*q^3*(q+1))*e2p(S(0)),
	(-1//8*(q+4)*q^3)*e2p(S(0)),
	(1//8*q^4)*e2p(S(0)),
	(-1//8*(q-4)*q^3)*e2p(S(0)),
	(1//8*q^4)*e2p(S(0)),
	(-1//8*q^4)*e2p(S(0)),
	(-1//4*q^3)*e2p(S(0)),
	(1//4*q^3)*e2p(S(0)),
	(1//2*q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//2*q^2)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//4*q^4*(q^2+1)*(q^4+1)*(q^4-q^2+1)*(q+1)^2*(q^2-q+1)^2)*e2p(S(0)),
	(-1//4*q^4*(q+1)*(q^7-q^4-q^3-1)*(q^2-q+1))*e2p(S(0)),
	(1//4*q^4*(q+1)*(q^2-q+1)*(q^7+2*q^6+q^4+q^3+1))*e2p(S(0)),
	(1//4*(2*q^6+q^4+2*q^3+1)*q^4)*e2p(S(0)),
	(1//4*q^4*(q+1)*(q^3+q^2-q+1))*e2p(S(0)),
	(-1//4*(q^5-4*q^4-3*q^3-q^2-1)*q^4)*e2p(S(0)),
	(1//4*q^4*(q+1)*(q^2-q+1)*(q^2+1))*e2p(S(0)),
	(1//4*q^4*(q+1)*(q^2+q+1)*(q-1)^2)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q^2-q+1)*(q+1)^2)*e2p(S(0)),
	(-1//4*(q^4+2*q^3-1)*q^4)*e2p(S(0)),
	(-1//4*(q^4-2*q^3-1)*q^4)*e2p(S(0)),
	(1//4*q^4*(q+1)*(2*q^2-q+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4*(q^2+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4*(q^2+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//2*q^4)*e2p(S(0)),
	(1//2*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//4*q^4*(q^2+1)*(q^4+1)*(q^4-q^2+1)*(q+1)^2*(q^2-q+1)^2)*e2p(S(0)),
	(1//4*q^4*(q+1)*(q^2-q+1)*(q^7+2*q^6+q^4+q^3+1))*e2p(S(0)),
	(-1//4*q^4*(q+1)*(q^7-q^4-q^3-1)*(q^2-q+1))*e2p(S(0)),
	(1//4*(2*q^6+q^4+2*q^3+1)*q^4)*e2p(S(0)),
	(1//4*q^4*(q+1)*(q^3+q^2-q+1))*e2p(S(0)),
	(1//4*q^4*(q+1)*(q^2+q+1)*(q-1)^2)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q^2-q+1)*(q+1)^2)*e2p(S(0)),
	(-1//4*(q^5-4*q^4-3*q^3-q^2-1)*q^4)*e2p(S(0)),
	(1//4*q^4*(q+1)*(q^2-q+1)*(q^2+1))*e2p(S(0)),
	(-1//4*(q^4+2*q^3-1)*q^4)*e2p(S(0)),
	(-1//4*(q^4-2*q^3-1)*q^4)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4*(q+1)*(2*q^2-q+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4*(q^2+1))*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4*(q^2+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//2*q^4)*e2p(S(0)),
	(1//2*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//8*q^4*(q^4-q^2+1)*(q^4+1)*(q^2-q+1)^2*(q+1)^4)*e2p(S(0)),
	(-1//8*q^4*(q^2-q+1)*(q^5-2*q^4-q^3+q^2-1)*(q+1)^3)*e2p(S(0)),
	(-1//8*q^4*(q^2-q+1)*(q^5-2*q^4-q^3+q^2-1)*(q+1)^3)*e2p(S(0)),
	(1//8*q^4*(2*q^6-2*q^5+2*q^4+2*q^3-q^2+1)*(q+1)^2)*e2p(S(0)),
	(1//8*q^4*(2*q^3-q^2+1)*(q+1)^2)*e2p(S(0)),
	(-1//8*q^4*(q-1)*(q^2+q+1)*(q+1)^2)*e2p(S(0)),
	(1//8*q^4*(q^2-q+1)*(q+1)^3)*e2p(S(0)),
	(-1//8*q^4*(q-1)*(q^2+q+1)*(q+1)^2)*e2p(S(0)),
	(1//8*q^4*(q^2-q+1)*(q+1)^3)*e2p(S(0)),
	(1//8*q^4*(q-1)*(q-3)*(q+1)^2)*e2p(S(0)),
	(1//8*q^4*(5*q^2-4*q+3)*(q+1)^2)*e2p(S(0)),
	(-1//8*q^4*(q-1)*(2*q+1)*(q+1))*e2p(S(0)),
	(-1//8*q^4*(q-1)*(2*q+1)*(q+1))*e2p(S(0)),
	(-1//8*q^4*(q+1)*(q-3))*e2p(S(0)),
	(-1//8*q^4*(q+1)*(q-3))*e2p(S(0)),
	(1//8*(2*q+1)*q^4)*e2p(S(0)),
	(1//8*(2*q+3)*q^4)*e2p(S(0)),
	(1//8*(q^2+5)*q^4)*e2p(S(0)),
	(-1//8*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//8*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//4*q^3*(q+1))*e2p(S(0)),
	(1//4*q^3*(q+1))*e2p(S(0)),
	(-1//4*q^3*(q+1))*e2p(S(0)),
	(1//4*q^3*(q+1))*e2p(S(0)),
	(1//8*(3*q-4)*q^3)*e2p(S(0)),
	(-3//8*q^4)*e2p(S(0)),
	(1//8*(3*q+4)*q^3)*e2p(S(0)),
	(-3//8*q^4)*e2p(S(0)),
	(3//8*q^4)*e2p(S(0)),
	(1//4*q^3)*e2p(S(0)),
	(-1//4*q^3)*e2p(S(0)),
	(1//2*q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//2*q^2)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//3*q^4*(q^4-q^2+1)*(q^4+1)*(q^2-q+1)^2*(q^2+q+1)^2)*e2p(S(0)),
	(1//3*q^4*(q^2-q+1)*(q^2+q+1)*(2*q^4+1))*e2p(S(0)),
	(1//3*q^4*(q^2-q+1)*(q^2+q+1)*(2*q^4+1))*e2p(S(0)),
	(-1//3*q^4*(q^2+1)*(q^6-3*q^4-1))*e2p(S(0)),
	(1//3*(4*q^4+q^2+1)*q^4)*e2p(S(0)),
	(1//3*q^4*(q^2-q+1)*(q^2+q+1))*e2p(S(0)),
	(1//3*q^4*(q^2-q+1)*(q^2+q+1))*e2p(S(0)),
	(1//3*q^4*(q^2-q+1)*(q^2+q+1))*e2p(S(0)),
	(1//3*q^4*(q^2-q+1)*(q^2+q+1))*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//3*(2*q^2+1)*q^4)*e2p(S(0)),
	(1//3*(2*q^2+1)*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//3*(2*q^2+1)*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//3*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//3*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//3*(q^2+2)*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//12*q^4*(q^4+1)*(q^2+1)^2*(q^2+q+1)^2*(q^2-q+1)^2)*e2p(S(0)),
	(1//12*q^4*(q^2+1)*(q^2+q+1)*(q^2-q+1)*(3*q^4+2*q^2+1))*e2p(S(0)),
	(1//12*q^4*(q^2+1)*(q^2+q+1)*(q^2-q+1)*(3*q^4+2*q^2+1))*e2p(S(0)),
	(1//12*q^4*(q^2+1)*(2*q^6+6*q^4+3*q^2+1))*e2p(S(0)),
	(1//12*(7*q^4+4*q^2+1)*q^4)*e2p(S(0)),
	(1//12*q^4*(q+1)*(3*q^2-2*q+1)*(q^2+q+1))*e2p(S(0)),
	(-1//12*q^4*(q-1)*(q^2-q+1)*(3*q^2+2*q+1))*e2p(S(0)),
	(1//12*q^4*(q+1)*(3*q^2-2*q+1)*(q^2+q+1))*e2p(S(0)),
	(-1//12*q^4*(q-1)*(q^2-q+1)*(3*q^2+2*q+1))*e2p(S(0)),
	(1//4*q^4*(q^2+1)*(3*q^2+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1)*(q^2+1))*e2p(S(0)),
	(-1//12*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//12*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4*(q^2+1))*e2p(S(0)),
	(1//4*q^4*(q^2+1))*e2p(S(0)),
	(-1//12*(2*q-1)*(2*q+1)*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(1//12*(q^2+5)*q^4)*e2p(S(0)),
	(-1//12*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//12*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//2*q^3)*e2p(S(0)),
	(-1//2*q^3)*e2p(S(0)),
	(1//2*q^3)*e2p(S(0)),
	(-1//2*q^3)*e2p(S(0)),
	(1//4*(q+4)*q^3)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*(q-4)*q^3)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//4*q^4*(q^4-q^2+1)*(q^2-q+1)^2*(q^2+1)^2*(q+1)^4)*e2p(S(0)),
	(1//4*q^4*(q^2+1)*(q^2-q+1)^2*(q+1)^4)*e2p(S(0)),
	(1//4*q^4*(q^2+1)*(q^2-q+1)^2*(q+1)^4)*e2p(S(0)),
	(1//4*q^4*(q^2+1)*(2*q^3+1)*(q+1)^2)*e2p(S(0)),
	(1//4*q^4*(2*q^2-q+1)*(q+1)^3)*e2p(S(0)),
	(-1//4*q^4*(q+1)*(q^4-3*q^3-q-1))*e2p(S(0)),
	(1//4*q^4*(q^2-q+1)*(q+1)^3)*e2p(S(0)),
	(-1//4*q^4*(q+1)*(q^4-3*q^3-q-1))*e2p(S(0)),
	(1//4*q^4*(q^2-q+1)*(q+1)^3)*e2p(S(0)),
	(1//4*q^4*(q^2+1)*(q+1)^2)*e2p(S(0)),
	(1//4*q^4*(q^2+1)*(q+1)^2)*e2p(S(0)),
	(1//4*q^4*(q+1)^2)*e2p(S(0)),
	(1//4*q^4*(q+1)^2)*e2p(S(0)),
	(1//4*q^4*(q+1)^2)*e2p(S(0)),
	(1//4*q^4*(q+1)^2)*e2p(S(0)),
	(1//4*(2*q+1)*q^4)*e2p(S(0)),
	(1//4*(2*q+1)*q^4)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4*(q^2+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(-1//2*q^3)*e2p(S(0)),
	(1//2*q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//4*q^4*(q^4+1)*(q-1)^2*(q+1)^2*(q^2+q+1)^2*(q^2-q+1)^2)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1)*(q^2+q+1)*(q^2-q+1)*(q^4+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1)*(q^2+q+1)*(q^2-q+1)*(q^4+1))*e2p(S(0)),
	(1//4*(2*q^8+q^4+1)*q^4)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1)*(q^2+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q^2+q+1)*(q^2+1))*e2p(S(0)),
	(1//4*q^4*(q+1)*(q^2-q+1)*(q^2+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q^2+q+1)*(q^2+1))*e2p(S(0)),
	(1//4*q^4*(q+1)*(q^2-q+1)*(q^2+1))*e2p(S(0)),
	(1//4*(q^4+3)*q^4)*e2p(S(0)),
	(-1//4*(3*q^4+4*q^2-3)*q^4)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//4*(q^2-3)*q^4)*e2p(S(0)),
	(-1//4*(q^2-3)*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(3//4*q^4)*e2p(S(0)),
	(1//4*(q^2+5)*q^4)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//2*q^3)*e2p(S(0)),
	(-1//2*q^3)*e2p(S(0)),
	(1//2*q^3)*e2p(S(0)),
	(-1//2*q^3)*e2p(S(0)),
	(-1//4*(q-4)*q^3)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*(q+4)*q^3)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//4*q^4*(q^2+1)*(q^4+1)*(q^4-q^2+1)*(q-1)^2*(q^2+q+1)^2)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q^7+q^4-q^3+1)*(q^2+q+1))*e2p(S(0)),
	(1//4*q^4*(q-1)*(q^2+q+1)*(q^7-2*q^6-q^4+q^3-1))*e2p(S(0)),
	(1//4*(2*q^6+q^4-2*q^3+1)*q^4)*e2p(S(0)),
	(1//4*q^4*(q-1)*(q^3-q^2-q-1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q^2+q+1)*(q^2+1))*e2p(S(0)),
	(1//4*(q^5+4*q^4-3*q^3+q^2+1)*q^4)*e2p(S(0)),
	(1//4*q^4*(q+1)*(q^2+q+1)*(q-1)^2)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q^2-q+1)*(q+1)^2)*e2p(S(0)),
	(-1//4*(q^4-2*q^3-1)*q^4)*e2p(S(0)),
	(-1//4*(q^4+2*q^3-1)*q^4)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(2*q^2+q+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4*(q^2+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4*(q^2+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//2*q^4)*e2p(S(0)),
	(-1//2*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//4*q^4*(q^2+1)*(q^4+1)*(q^4-q^2+1)*(q-1)^2*(q^2+q+1)^2)*e2p(S(0)),
	(1//4*q^4*(q-1)*(q^2+q+1)*(q^7-2*q^6-q^4+q^3-1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q^7+q^4-q^3+1)*(q^2+q+1))*e2p(S(0)),
	(1//4*(2*q^6+q^4-2*q^3+1)*q^4)*e2p(S(0)),
	(1//4*q^4*(q-1)*(q^3-q^2-q-1))*e2p(S(0)),
	(1//4*q^4*(q+1)*(q^2+q+1)*(q-1)^2)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q^2-q+1)*(q+1)^2)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q^2+q+1)*(q^2+1))*e2p(S(0)),
	(1//4*(q^5+4*q^4-3*q^3+q^2+1)*q^4)*e2p(S(0)),
	(-1//4*(q^4-2*q^3-1)*q^4)*e2p(S(0)),
	(-1//4*(q^4+2*q^3-1)*q^4)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(2*q^2+q+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4*(q^2+1))*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4*(q^2+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//2*q^4)*e2p(S(0)),
	(-1//2*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//3*q^4*(q^4+1)*(q^2+1)^2*(q-1)^4*(q+1)^4)*e2p(S(0)),
	(-1//3*q^4*(q^2+1)*(q-1)^3*(q+1)^3)*e2p(S(0)),
	(-1//3*q^4*(q^2+1)*(q-1)^3*(q+1)^3)*e2p(S(0)),
	(-1//3*q^4*(q^2+1)*(q-1)^3*(q+1)^3)*e2p(S(0)),
	(1//3*q^4*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(1//3*q^4*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(1//3*q^4*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(1//3*q^4*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(1//3*q^4*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//3*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//3*q^4*(q-1)*(q+1))*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//3*q^4*(q-1)*(q+1))*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//3*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//3*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//3*(q^2+2)*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//3*q^4*(q^4+1)*(q^2+1)^2*(q-1)^4*(q+1)^4)*e2p(S(0)),
	(-1//3*q^4*(q^2+1)*(q-1)^3*(q+1)^3)*e2p(S(0)),
	(-1//3*q^4*(q^2+1)*(q-1)^3*(q+1)^3)*e2p(S(0)),
	(-1//3*q^4*(q^2+1)*(q-1)^3*(q+1)^3)*e2p(S(0)),
	(1//3*q^4*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(1//3*q^4*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(1//3*q^4*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(1//3*q^4*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(1//3*q^4*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//3*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//3*q^4*(q-1)*(q+1))*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//3*q^4*(q-1)*(q+1))*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//3*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//3*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//3*(q^2+2)*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//4*q^4*(q^2+q+1)^2*(q^2-q+1)^2*(q-1)^4*(q+1)^4)*e2p(S(0)),
	(-1//4*q^4*(q^2+q+1)*(q^2-q+1)*(q-1)^3*(q+1)^3)*e2p(S(0)),
	(-1//4*q^4*(q^2+q+1)*(q^2-q+1)*(q-1)^3*(q+1)^3)*e2p(S(0)),
	(1//4*q^4*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(1//4*q^4*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(1//4*q^4*(q+1)*(q^2+q+1)*(q-1)^2)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q^2-q+1)*(q+1)^2)*e2p(S(0)),
	(1//4*q^4*(q+1)*(q^2+q+1)*(q-1)^2)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q^2-q+1)*(q+1)^2)*e2p(S(0)),
	(1//4*q^4*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(1//4*q^4*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4*(q^2+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p(S(1//(4)))*q^2,
	(0)*e2p(S(0)),
	-e2p(S(1//(4)))*q^2] [
	(1//4*q^4*(q^2+q+1)^2*(q^2-q+1)^2*(q-1)^4*(q+1)^4)*e2p(S(0)),
	(-1//4*q^4*(q^2+q+1)*(q^2-q+1)*(q-1)^3*(q+1)^3)*e2p(S(0)),
	(-1//4*q^4*(q^2+q+1)*(q^2-q+1)*(q-1)^3*(q+1)^3)*e2p(S(0)),
	(1//4*q^4*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(1//4*q^4*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(1//4*q^4*(q+1)*(q^2+q+1)*(q-1)^2)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q^2-q+1)*(q+1)^2)*e2p(S(0)),
	(1//4*q^4*(q+1)*(q^2+q+1)*(q-1)^2)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q^2-q+1)*(q+1)^2)*e2p(S(0)),
	(1//4*q^4*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(1//4*q^4*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4*(q^2+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p(S(1//(4)))*q^2,
	(0)*e2p(S(0)),
	e2p(S(1//(4)))*q^2] [
	(1//8*q^4*(q^4+1)*(q^4-q^2+1)*(q^2+q+1)^2*(q-1)^4)*e2p(S(0)),
	(-1//8*q^4*(q^2+q+1)*(q^5+2*q^4-q^3-q^2+1)*(q-1)^3)*e2p(S(0)),
	(-1//8*q^4*(q^2+q+1)*(q^5+2*q^4-q^3-q^2+1)*(q-1)^3)*e2p(S(0)),
	(1//8*q^4*(2*q^6+2*q^5+2*q^4-2*q^3-q^2+1)*(q-1)^2)*e2p(S(0)),
	(-1//8*q^4*(2*q^3+q^2-1)*(q-1)^2)*e2p(S(0)),
	(-1//8*q^4*(q^2+q+1)*(q-1)^3)*e2p(S(0)),
	(1//8*q^4*(q+1)*(q^2-q+1)*(q-1)^2)*e2p(S(0)),
	(-1//8*q^4*(q^2+q+1)*(q-1)^3)*e2p(S(0)),
	(1//8*q^4*(q+1)*(q^2-q+1)*(q-1)^2)*e2p(S(0)),
	(1//8*q^4*(q+3)*(q+1)*(q-1)^2)*e2p(S(0)),
	(1//8*q^4*(5*q^2+4*q+3)*(q-1)^2)*e2p(S(0)),
	(1//8*q^4*(q-1)*(2*q-1)*(q+1))*e2p(S(0)),
	(1//8*q^4*(q-1)*(2*q-1)*(q+1))*e2p(S(0)),
	(-1//8*q^4*(q+3)*(q-1))*e2p(S(0)),
	(-1//8*q^4*(q+3)*(q-1))*e2p(S(0)),
	(-1//8*(2*q-1)*q^4)*e2p(S(0)),
	(-1//8*(2*q-3)*q^4)*e2p(S(0)),
	(1//8*(q^2+5)*q^4)*e2p(S(0)),
	(-1//8*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//8*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^3*(q-1))*e2p(S(0)),
	(-1//4*q^3*(q-1))*e2p(S(0)),
	(1//4*q^3*(q-1))*e2p(S(0)),
	(-1//4*q^3*(q-1))*e2p(S(0)),
	(1//8*(3*q-4)*q^3)*e2p(S(0)),
	(-3//8*q^4)*e2p(S(0)),
	(1//8*(3*q+4)*q^3)*e2p(S(0)),
	(-3//8*q^4)*e2p(S(0)),
	(3//8*q^4)*e2p(S(0)),
	(-1//4*q^3)*e2p(S(0)),
	(1//4*q^3)*e2p(S(0)),
	(-1//2*q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//2*q^2)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//24*q^4*(q^4+1)*(q^4-q^2+1)*(q^2-q+1)^2*(q-1)^4)*e2p(S(0)),
	(1//24*q^4*(q^2-q+1)*(3*q^5-q^3-q^2+2*q-1)*(q-1)^3)*e2p(S(0)),
	(1//24*q^4*(q^2-q+1)*(3*q^5-q^3-q^2+2*q-1)*(q-1)^3)*e2p(S(0)),
	(1//24*q^4*(2*q^5+2*q^3-4*q^2+3*q-1)*(q-1)^3)*e2p(S(0)),
	(-1//24*q^4*(2*q-1)*(3*q^2-2*q+1)*(q-1)^2)*e2p(S(0)),
	(1//24*q^4*(3*q^3+4*q^2-4*q+1)*(q-1)^2)*e2p(S(0)),
	(-1//24*q^4*(3*q-1)*(q^2-q+1)*(q-1)^2)*e2p(S(0)),
	(1//24*q^4*(3*q^3+4*q^2-4*q+1)*(q-1)^2)*e2p(S(0)),
	(-1//24*q^4*(3*q-1)*(q^2-q+1)*(q-1)^2)*e2p(S(0)),
	(1//8*q^4*(3*q^2+1)*(q-1)^2)*e2p(S(0)),
	(-1//8*q^4*(q+1)*(q-1)^3)*e2p(S(0)),
	(-1//24*q^4*(q-1)*(3*q-1)*(2*q-1))*e2p(S(0)),
	(-1//24*q^4*(q-1)*(3*q-1)*(2*q-1))*e2p(S(0)),
	(1//8*q^4*(q-1)^2)*e2p(S(0)),
	(1//8*q^4*(q-1)^2)*e2p(S(0)),
	(1//24*(4*q-1)*(2*q-1)*q^4)*e2p(S(0)),
	(-1//8*(2*q-1)*q^4)*e2p(S(0)),
	(1//24*(q^2+5)*q^4)*e2p(S(0)),
	(-1//24*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//24*q^4*(q-1)*(q+1))*e2p(S(0)),
	(-1//4*q^3*(q-1))*e2p(S(0)),
	(1//4*q^3*(q-1))*e2p(S(0)),
	(-1//4*q^3*(q-1))*e2p(S(0)),
	(1//4*q^3*(q-1))*e2p(S(0)),
	(1//8*(q+4)*q^3)*e2p(S(0)),
	(-1//8*q^4)*e2p(S(0)),
	(1//8*(q-4)*q^3)*e2p(S(0)),
	(-1//8*q^4)*e2p(S(0)),
	(1//8*q^4)*e2p(S(0)),
	(-1//4*q^3)*e2p(S(0)),
	(1//4*q^3)*e2p(S(0)),
	(-1//2*q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//2*q^2)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//4*q^4*(q^4-q^2+1)*(q^2+q+1)^2*(q^2+1)^2*(q-1)^4)*e2p(S(0)),
	(1//4*q^4*(q^2+1)*(q^2+q+1)^2*(q-1)^4)*e2p(S(0)),
	(1//4*q^4*(q^2+1)*(q^2+q+1)^2*(q-1)^4)*e2p(S(0)),
	(-1//4*q^4*(q^2+1)*(2*q^3-1)*(q-1)^2)*e2p(S(0)),
	(-1//4*q^4*(2*q^2+q+1)*(q-1)^3)*e2p(S(0)),
	(-1//4*q^4*(q^2+q+1)*(q-1)^3)*e2p(S(0)),
	(1//4*q^4*(q-1)*(q^4+3*q^3+q-1))*e2p(S(0)),
	(-1//4*q^4*(q^2+q+1)*(q-1)^3)*e2p(S(0)),
	(1//4*q^4*(q-1)*(q^4+3*q^3+q-1))*e2p(S(0)),
	(1//4*q^4*(q^2+1)*(q-1)^2)*e2p(S(0)),
	(1//4*q^4*(q^2+1)*(q-1)^2)*e2p(S(0)),
	(1//4*q^4*(q-1)^2)*e2p(S(0)),
	(1//4*q^4*(q-1)^2)*e2p(S(0)),
	(1//4*q^4*(q-1)^2)*e2p(S(0)),
	(1//4*q^4*(q-1)^2)*e2p(S(0)),
	(-1//4*(2*q-1)*q^4)*e2p(S(0)),
	(-1//4*(2*q-1)*q^4)*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(1//4*q^4*(q^2+1))*e2p(S(0)),
	(-1//4*q^4*(q-1)*(q+1))*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//2*q^3)*e2p(S(0)),
	(-1//2*q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9*(q^4+1)*(q^4-q^2+1)*(q^2+1)^2)*e2p(S(0)),
	(q^9*(q^2+1)*(q^4+1))*e2p(S(0)),
	(q^9*(q^2+1))*e2p(S(0)),
	(q^9*(q^2+1))*e2p(S(0)),
	(q^9)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^9)*e2p(S(0)),
	(q^9)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9*(q^4+1)*(q^4-q^2+1)*(q^2+1)^2)*e2p(S(0)),
	(q^9*(q^2+1))*e2p(S(0)),
	(q^9*(q^2+1)*(q^4+1))*e2p(S(0)),
	(q^9*(q^2+1))*e2p(S(0)),
	(q^9)*e2p(S(0)),
	(q^9)*e2p(S(0)),
	(q^9)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^10*(q^4-q^2+1)*(q^2+q+1)^2*(q^2-q+1)^2)*e2p(S(0)),
	(q^10*(q^2+q+1)*(q^2-q+1))*e2p(S(0)),
	(q^10*(q^2+q+1)*(q^2-q+1))*e2p(S(0)),
	(q^10*(q^2+1))*e2p(S(0)),
	(q^10)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//2*q^13*(q^4+1)*(q+1)^2*(q^2-q+1)^2)*e2p(S(0)),
	(1//2*q^13*(q+1)*(q^2-q+1))*e2p(S(0)),
	(1//2*q^13*(q+1)*(q^2-q+1))*e2p(S(0)),
	(1//2*q^13)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//2*q^9)*e2p(S(0)),
	(-1//2*q^9)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//2*q^13*(q^2+1)*(q^4+1)*(q^4-q^2+1))*e2p(S(0)),
	(1//2*q^13*(q+1)*(q^2-q+1))*e2p(S(0)),
	(-1//2*q^13*(q-1)*(q^2+q+1))*e2p(S(0)),
	(1//2*q^13)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//2*q^9)*e2p(S(0)),
	(1//2*q^9)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//2*q^13*(q^2+1)*(q^4+1)*(q^4-q^2+1))*e2p(S(0)),
	(-1//2*q^13*(q-1)*(q^2+q+1))*e2p(S(0)),
	(1//2*q^13*(q+1)*(q^2-q+1))*e2p(S(0)),
	(1//2*q^13)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//2*q^9)*e2p(S(0)),
	(1//2*q^9)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//2*q^13*(q^4+1)*(q-1)^2*(q^2+q+1)^2)*e2p(S(0)),
	(-1//2*q^13*(q-1)*(q^2+q+1))*e2p(S(0)),
	(-1//2*q^13*(q-1)*(q^2+q+1))*e2p(S(0)),
	(1//2*q^13)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//2*q^9)*e2p(S(0)),
	(-1//2*q^9)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^24)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))]]
classinfo = Vector{Any}[
	[["\\emptyset"],"x0",[]],
	[["(\\tildeA_1)_2"],"x1",[]],
	[["A_1"],"x2",[]],
	[["\\tildeA_1"],"x3",[]],
	[["A_1+\\tildeA_1"],"x4",[]],
	[[["A_2"],2],"x5",[]],
	[[["A_2"],1],"x6",[]],
	[[["\\tildeA_2"],2],"x7",[]],
	[[["\\tildeA_2"],1],"x8",[]],
	[[["(B_2)_2"],2],"x9",[]],
	[[["(B_2)_2"],1],"x10",[]],
	[["A_2+\\tildeA_1"],"x11",[]],
	[["(\\tildeA_2+A_1)_2"],"x12",[]],
	[["B_2"],"x13",[]],
	[["C_3(a_1)_2"],"x14",[]],
	[["\\tildeA_2+A_1"],"x15",[]],
	[["C_3(a_1)"],"x16",[]],
	[[["F_4(a_3)"],3],"x17",[]],
	[[["F_4(a_3)"],1],"x18",[]],
	[[["F_4(a_3)"],2],"x19",[]],
	[[["B_3"],2],"x20",[]],
	[[["B_3"],1],"x21",[]],
	[[["C_3"],2],"x22",[]],
	[[["C_3"],1],"x23",[]],
	[[["F_4(a_2)"],5],"x24",[]],
	[[["F_4(a_2)"],2],"x25",[]],
	[[["F_4(a_2)"],4],"x26",[]],
	[[["F_4(a_2)"],1],"x27",[]],
	[[["F_4(a_2)"],3],"x28",[]],
	[[["F_4(a_1)"],2],"x29",[]],
	[[["F_4(a_1)"],1],"x30",[]],
	[[["F_4"],2],"x31",[]],
	[[["F_4"],4],"x32",[]],
	[[["F_4"],1],"x33",[]],
	[[["F_4"],3],"x34",[]]]
classlength = R.([
	1,
	q^16+q^12-q^4-1,
	q^16+q^12-q^4-1,
	q^22+q^18-q^16-q^12-q^10-q^6+q^4+1,
	q^28+q^26+q^24-q^20-q^18-2*q^16-q^14-q^12+q^8+q^6+q^4,
	1//2*q^30+1//2*q^27-1//2*q^22-1//2*q^19-1//2*q^18-1//2*q^15+1//2*q^10+1//2*q^7,
	1//2*q^30-1//2*q^27-1//2*q^22+1//2*q^19-1//2*q^18+1//2*q^15+1//2*q^10-1//2*q^7,
	1//2*q^30+1//2*q^27-1//2*q^22-1//2*q^19-1//2*q^18-1//2*q^15+1//2*q^10+1//2*q^7,
	1//2*q^30-1//2*q^27-1//2*q^22+1//2*q^19-1//2*q^18+1//2*q^15+1//2*q^10-1//2*q^7,
	1//2*q^32+1//2*q^28-1//2*q^26-1//2*q^22-1//2*q^20-1//2*q^16+1//2*q^14+1//2*q^10,
	1//2*q^32+1//2*q^28-1//2*q^26-1//2*q^22-1//2*q^20-1//2*q^16+1//2*q^14+1//2*q^10,
	q^34-q^28-q^26-q^22+q^20+q^16+q^14-q^8,
	q^34-q^28-q^26-q^22+q^20+q^16+q^14-q^8,
	q^36-q^30-q^28-q^24+q^22+q^18+q^16-q^10,
	q^36-q^30-q^28-q^24+q^22+q^18+q^16-q^10,
	q^36-q^34-q^30+q^26-q^24+2*q^22-q^20+q^18-q^14-q^10+q^8,
	q^38-q^36-q^32+q^28-q^26+2*q^24-q^22+q^20-q^16-q^12+q^10,
	1//6*q^40-1//6*q^38-1//6*q^34+1//6*q^30-1//6*q^28+1//3*q^26-1//6*q^24+1//6*q^22-1//6*q^18-1//6*q^14+1//6*q^12,
	1//2*q^40-1//2*q^38-1//2*q^34+1//2*q^30-1//2*q^28+q^26-1//2*q^24+1//2*q^22-1//2*q^18-1//2*q^14+1//2*q^12,
	1//3*q^40-1//3*q^38-1//3*q^34+1//3*q^30-1//3*q^28+2//3*q^26-1//3*q^24+1//3*q^22-1//3*q^18-1//3*q^14+1//3*q^12,
	1//2*q^42-1//2*q^36-1//2*q^34-1//2*q^30+1//2*q^28+1//2*q^24+1//2*q^22-1//2*q^16,
	1//2*q^42-1//2*q^36-1//2*q^34-1//2*q^30+1//2*q^28+1//2*q^24+1//2*q^22-1//2*q^16,
	1//2*q^42-1//2*q^36-1//2*q^34-1//2*q^30+1//2*q^28+1//2*q^24+1//2*q^22-1//2*q^16,
	1//2*q^42-1//2*q^36-1//2*q^34-1//2*q^30+1//2*q^28+1//2*q^24+1//2*q^22-1//2*q^16,
	1//8*q^44-1//8*q^42-1//8*q^38+1//8*q^34-1//8*q^32+1//4*q^30-1//8*q^28+1//8*q^26-1//8*q^22-1//8*q^18+1//8*q^16,
	1//4*q^44-1//4*q^42-1//4*q^38+1//4*q^34-1//4*q^32+1//2*q^30-1//4*q^28+1//4*q^26-1//4*q^22-1//4*q^18+1//4*q^16,
	1//8*q^44-1//8*q^42-1//8*q^38+1//8*q^34-1//8*q^32+1//4*q^30-1//8*q^28+1//8*q^26-1//8*q^22-1//8*q^18+1//8*q^16,
	1//4*q^44-1//4*q^42-1//4*q^38+1//4*q^34-1//4*q^32+1//2*q^30-1//4*q^28+1//4*q^26-1//4*q^22-1//4*q^18+1//4*q^16,
	1//4*q^44-1//4*q^42-1//4*q^38+1//4*q^34-1//4*q^32+1//2*q^30-1//4*q^28+1//4*q^26-1//4*q^22-1//4*q^18+1//4*q^16,
	1//2*q^46-1//2*q^44-1//2*q^40+1//2*q^36-1//2*q^34+q^32-1//2*q^30+1//2*q^28-1//2*q^24-1//2*q^20+1//2*q^18,
	1//2*q^46-1//2*q^44-1//2*q^40+1//2*q^36-1//2*q^34+q^32-1//2*q^30+1//2*q^28-1//2*q^24-1//2*q^20+1//2*q^18,
	1//4*q^48-1//4*q^46-1//4*q^42+1//4*q^38-1//4*q^36+1//2*q^34-1//4*q^32+1//4*q^30-1//4*q^26-1//4*q^22+1//4*q^20,
	1//4*q^48-1//4*q^46-1//4*q^42+1//4*q^38-1//4*q^36+1//2*q^34-1//4*q^32+1//4*q^30-1//4*q^26-1//4*q^22+1//4*q^20,
	1//4*q^48-1//4*q^46-1//4*q^42+1//4*q^38-1//4*q^36+1//2*q^34-1//4*q^32+1//4*q^30-1//4*q^26-1//4*q^22+1//4*q^20,
	1//4*q^48-1//4*q^46-1//4*q^42+1//4*q^38-1//4*q^36+1//2*q^34-1//4*q^32+1//4*q^30-1//4*q^26-1//4*q^22+1//4*q^20])
charinfo = Vector{Any}[
	["phi_{1,0}"],
	["phi_{4,1}"],
	["phi_{2,4}''"],
	["phi_{2,4}'"],
	[[2],[]],
	["phi_{9,2}"],
	["phi_{8,3}'"],
	["phi_{8,3}''"],
	["phi_{12,4}"],
	["phi_{9,6}''"],
	["phi_{9,6}'"],
	["phi_{1,12}''"],
	["phi_{1,12}'"],
	["phi_{4,7}''"],
	["phi_{4,7}'"],
	["phi_{4,8}"],
	["phi_{6,6}'"],
	["phi_{6,6}''"],
	["phi_{16,5}"],
	[[1],[1]],
	[[1,1],[]],
	[[],[2]],
	["F_4[theta]"],
	["F_4[theta^2]"],
	["F_4[i]"],
	["F_4[-i]"],
	["F_4^I[1]"],
	["F_4^II[1]"],
	["F_4[-1]"],
	["phi_{8,9}'"],
	["phi_{8,9}''"],
	["phi_{9,10}"],
	["phi_{4,13}"],
	["phi_{2,16}'"],
	["phi_{2,16}''"],
	[[],[1,1]],
	["phi_{1,24}"]]
chardegree = R.([
	1,
	1//2*q*(q^4+1)*(q+1)^2*(q^2-q+1)^2,
	1//2*q*(q^2+1)*(q^4-q^2+1)*(q^4+1),
	1//2*q*(q^2+1)*(q^4-q^2+1)*(q^4+1),
	1//2*q*(q^4+1)*(q-1)^2*(q^2+q+1)^2,
	q^2*(q^4-q^2+1)*(q^2-q+1)^2*(q^2+q+1)^2,
	q^3*(q^4-q^2+1)*(q^4+1)*(q^2+1)^2,
	q^3*(q^4-q^2+1)*(q^4+1)*(q^2+1)^2,
	1//24*q^4*(q^4+1)*(q^4-q^2+1)*(q^2+q+1)^2*(q+1)^4,
	1//8*q^4*(q^4+1)*(q^4-q^2+1)*(q^2+q+1)^2*(q^2+1)^2,
	1//8*q^4*(q^4+1)*(q^4-q^2+1)*(q^2+q+1)^2*(q^2+1)^2,
	1//8*q^4*(q^4+1)*(q^4-q^2+1)*(q^2-q+1)^2*(q^2+1)^2,
	1//8*q^4*(q^4+1)*(q^4-q^2+1)*(q^2-q+1)^2*(q^2+1)^2,
	1//4*q^4*(q^2+1)*(q^4+1)*(q^4-q^2+1)*(q+1)^2*(q^2-q+1)^2,
	1//4*q^4*(q^2+1)*(q^4+1)*(q^4-q^2+1)*(q+1)^2*(q^2-q+1)^2,
	1//8*q^4*(q^4-q^2+1)*(q^4+1)*(q^2-q+1)^2*(q+1)^4,
	1//3*q^4*(q^4-q^2+1)*(q^4+1)*(q^2-q+1)^2*(q^2+q+1)^2,
	1//12*q^4*(q^4+1)*(q^2+1)^2*(q^2+q+1)^2*(q^2-q+1)^2,
	1//4*q^4*(q^4-q^2+1)*(q^2-q+1)^2*(q^2+1)^2*(q+1)^4,
	1//4*q^4*(q^4+1)*(q-1)^2*(q+1)^2*(q^2+q+1)^2*(q^2-q+1)^2,
	1//4*q^4*(q^2+1)*(q^4+1)*(q^4-q^2+1)*(q-1)^2*(q^2+q+1)^2,
	1//4*q^4*(q^2+1)*(q^4+1)*(q^4-q^2+1)*(q-1)^2*(q^2+q+1)^2,
	1//3*q^4*(q^4+1)*(q^2+1)^2*(q-1)^4*(q+1)^4,
	1//3*q^4*(q^4+1)*(q^2+1)^2*(q-1)^4*(q+1)^4,
	1//4*q^4*(q^2+q+1)^2*(q^2-q+1)^2*(q-1)^4*(q+1)^4,
	1//4*q^4*(q^2+q+1)^2*(q^2-q+1)^2*(q-1)^4*(q+1)^4,
	1//8*q^4*(q^4+1)*(q^4-q^2+1)*(q^2+q+1)^2*(q-1)^4,
	1//24*q^4*(q^4+1)*(q^4-q^2+1)*(q^2-q+1)^2*(q-1)^4,
	1//4*q^4*(q^4-q^2+1)*(q^2+q+1)^2*(q^2+1)^2*(q-1)^4,
	q^9*(q^4+1)*(q^4-q^2+1)*(q^2+1)^2,
	q^9*(q^4+1)*(q^4-q^2+1)*(q^2+1)^2,
	q^10*(q^4-q^2+1)*(q^2+q+1)^2*(q^2-q+1)^2,
	1//2*q^13*(q^4+1)*(q+1)^2*(q^2-q+1)^2,
	1//2*q^13*(q^2+1)*(q^4+1)*(q^4-q^2+1),
	1//2*q^13*(q^2+1)*(q^4+1)*(q^4-q^2+1),
	1//2*q^13*(q^4+1)*(q-1)^2*(q^2+q+1)^2,
	q^24])

classsums=[
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end
]

charsums=[
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end
]

classparams=[
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[])
]

charparams=[
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[])
]

classparamindex=Int64[]
charparamindex=Int64[]
congruence=nothing

information = "- Information about the table of unipotent characters of \$F_4(2^n)\$
  on unipotent classes.

- CHEVIE-name of the table: ``uniuniF4p2``

- The table was computed by Marcelo and Shinoda. This is explained in:
  {\\sc R.M.~Marcelo and K.~Shinoda}, Values of the unipotent characters
  of the Chevalley group of type \$F_4\$ at unipotent elements, Preprint,
  Tokyo (1994)

- PrintInfoClass shows the geometric unipotent classes in the notation of:
  {\\sc N.~Spaltenstein}, Classes unipotentes et sous-groupes de Borel,
  LNM {\bf 946}, Springer (1982), p.~29.
  and also Shinoda's notation from the cited preprint.

- PrintInfoChar shows the unipotent characters in the notation of:
  {\\sc R.~Carter}, Finite Groups of Lie Type, Wiley (1985), p.~479.
  (but for the characters of a Weyl group of type B_2 we use the
  notation with pairs of partitions.)
"

TABLE=CharTable(order,ExtendableMatrix(permutedims(table)),classinfo,classlength,charinfo,chardegree,
	classsums,charsums,classparamindex,charparamindex,classparams,charparams,congruence,R,S,information)
