using ..GenericCharacterTables
import ..GenericCharacterTables: Cyclotomic, Parameters, Parameter, ParameterException, ParameterSubstitution, ExtendableMatrix, CharTable
using Oscar
K, d = number_field(polynomial(QQ,[1,0,-10,0,1]), "(sqrt(2)+sqrt(3))")
sqrt2 = 1//2*d^3 - 9//2*d
sqrt3 = -1//2*d^3 + 11//2*d
R, q = polynomial_ring(K, "q")
Q = fraction_field(R)
S = UniversalPolynomialRing(Q, cached=false)
a,b,k,l, _...=gens(S, ["a", "b", "k", "l", "a1", "b1", "k1", "l1", "a2", "b2", "k2", "l2", "a3", "b3", "k3", "l3", "at1", "bt1", "kt1", "lt1", "at2", "bt2", "kt2", "lt2"])

order = q^24*(q^12+1)*(q^8-1)*(q^6+1)*(q^2-1)
table = Cyclotomic{Generic.Poly{nf_elem}}[[
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0))] [
	(1//2*(q^2-1)*(q^2+1)^2*(q^4-q^2+1)*sqrt2*q)*e2p(S(0)),
	(-1//2*sqrt2*q*(q^6-q^4+1))*e2p(S(0)),
	(1//2*q*sqrt2*(q^2-1)*(q^2+1))*e2p(S(0)),
	1//2*e2p(S(1//(4)))*sqrt2*q^5+1//2*sqrt2*q^3-1//2*sqrt2*q,
	1//2*sqrt2*q^3-1//2*sqrt2*q-1//2*e2p(S(1//(4)))*sqrt2*q^5,
	(-1//2*sqrt2*q)*e2p(S(0)),
	(1//2*(q^2-1)*sqrt2*q)*e2p(S(0)),
	(sqrt2*q^3-1//2*sqrt2*q)*e2p(S(0)),
	(-1//2*sqrt2*q)*e2p(S(0)),
	(-1//2*(q^2+1)*sqrt2*q)*e2p(S(0)),
	(-1//2*sqrt2*q)*e2p(S(0)),
	e2p(S(1//(4)))*q^2-1//2*sqrt2*q,
	-1//2*sqrt2*q-e2p(S(1//(4)))*q^2,
	(-1//2*sqrt2*q)*e2p(S(0)),
	(-1//2*sqrt2*q)*e2p(S(0)),
	1//2*e2p(S(1//(4)))*sqrt2*q,
	-1//2*e2p(S(1//(4)))*sqrt2*q,
	1//2*e2p(S(1//(4)))*sqrt2*q,
	-1//2*e2p(S(1//(4)))*sqrt2*q,
	(1//2*(q^2-1)*sqrt2*q)*e2p(S(0)),
	(-1//2*sqrt2*q)*e2p(S(0)),
	1//2*e2p(S(1//(4)))*sqrt2*q,
	-1//2*e2p(S(1//(4)))*sqrt2*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//2*sqrt2*q^3-1//2*sqrt2*q-1)*e2p(S(0)),
	(-1//2*sqrt2*q-1)*e2p(S(0)),
	-1//2*e2p(S(1//(4)))*sqrt2*q-1,
	-1+1//2*e2p(S(1//(4)))*sqrt2*q,
	(-1)*e2p(S(0)),
	(1//2*sqrt2*q^3-1//2*sqrt2*q+1)*e2p(S(0)),
	(-1//2*sqrt2*q+1)*e2p(S(0)),
	-1//2*e2p(S(1//(4)))*sqrt2*q+1,
	1+1//2*e2p(S(1//(4)))*sqrt2*q,
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(1)*e2p(S(0))] [
	(1//2*(q^2-1)*(q^2+1)^2*(q^4-q^2+1)*sqrt2*q)*e2p(S(0)),
	(-1//2*sqrt2*q*(q^6-q^4+1))*e2p(S(0)),
	(1//2*(q^2-1)*(q^2+1)*sqrt2*q)*e2p(S(0)),
	-1//2*e2p(S(1//(4)))*sqrt2*q^5+1//2*sqrt2*q^3-1//2*sqrt2*q,
	1//2*e2p(S(1//(4)))*sqrt2*q^5+1//2*sqrt2*q^3-1//2*sqrt2*q,
	(-1//2*sqrt2*q)*e2p(S(0)),
	(1//2*(q^2-1)*sqrt2*q)*e2p(S(0)),
	(sqrt2*q^3-1//2*sqrt2*q)*e2p(S(0)),
	(-1//2*sqrt2*q)*e2p(S(0)),
	(-1//2*(q^2+1)*sqrt2*q)*e2p(S(0)),
	(-1//2*sqrt2*q)*e2p(S(0)),
	-e2p(S(1//(4)))*q^2-1//2*sqrt2*q,
	e2p(S(1//(4)))*q^2-1//2*sqrt2*q,
	(-1//2*sqrt2*q)*e2p(S(0)),
	(-1//2*sqrt2*q)*e2p(S(0)),
	-1//2*e2p(S(1//(4)))*sqrt2*q,
	1//2*e2p(S(1//(4)))*sqrt2*q,
	-1//2*e2p(S(1//(4)))*sqrt2*q,
	1//2*e2p(S(1//(4)))*sqrt2*q,
	(1//2*(q^2-1)*sqrt2*q)*e2p(S(0)),
	(-1//2*sqrt2*q)*e2p(S(0)),
	-1//2*e2p(S(1//(4)))*sqrt2*q,
	1//2*e2p(S(1//(4)))*sqrt2*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//2*sqrt2*q^3-1//2*sqrt2*q-1)*e2p(S(0)),
	(-1//2*sqrt2*q-1)*e2p(S(0)),
	1//2*e2p(S(1//(4)))*sqrt2*q-1,
	-1//2*e2p(S(1//(4)))*sqrt2*q-1,
	(-1)*e2p(S(0)),
	(1//2*sqrt2*q^3-1//2*sqrt2*q+1)*e2p(S(0)),
	(-1//2*sqrt2*q+1)*e2p(S(0)),
	1//2*e2p(S(1//(4)))*sqrt2*q+1,
	-1//2*e2p(S(1//(4)))*sqrt2*q+1,
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(1)*e2p(S(0))] [
	((q^4-q^2+1)*(q^8-q^4+1)*q^2)*e2p(S(0)),
	(q^8-q^4+q^2)*e2p(S(0)),
	(-(q^2-1)*q^2)*e2p(S(0)),
	((q^4-q^2+1)*q^2)*e2p(S(0)),
	((q^4-q^2+1)*q^2)*e2p(S(0)),
	(-(q^2-1)*q^2)*e2p(S(0)),
	(-(q^2-1)*q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-q^4+q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q^2-2)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-sqrt2*q^3+sqrt2*q+1)*e2p(S(0)),
	(sqrt2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(sqrt2*q^3-sqrt2*q+1)*e2p(S(0)),
	(-sqrt2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(3)*e2p(S(0)),
	(3)*e2p(S(0)),
	(-3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//4*(q^2+1)^2*(q^2-sqrt2*q+1)^2*(q^4-q^2+1)*(q^4+sqrt2*q^3+q^2+sqrt2*q+1)*q^4)*e2p(S(0)),
	(1//4*(q^2-sqrt2*q+1)*(2*q^10+sqrt2*q^9+sqrt2*q^7+q^6+q^4))*e2p(S(0)),
	(1//4*(q^2+1)*(sqrt2*q^7+q^6-sqrt2*q^5+q^4))*e2p(S(0)),
	(1//4*(q^2-sqrt2*q+1)*(q^6+2*sqrt2*q^5+3*q^4))*e2p(S(0)),
	(1//4*(q^2-sqrt2*q+1)*(q^6+2*sqrt2*q^5+3*q^4))*e2p(S(0)),
	(-1//4*sqrt2*q^5+1//4*q^4)*e2p(S(0)),
	(-1//4*sqrt2*q^5+3//4*q^4)*e2p(S(0)),
	(-1//4*q^6+5//4*q^4)*e2p(S(0)),
	(1//4*(q^2+1)*q^4)*e2p(S(0)),
	(-1//4*(q^2+1)*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*sqrt2*q^3)*e2p(S(0)),
	(-1//4*sqrt2*q^3)*e2p(S(0)),
	(1//2*q^2)*e2p(S(0)),
	(1//2*q^2)*e2p(S(0)),
	(-1//2*q^2)*e2p(S(0)),
	(-1//2*q^2)*e2p(S(0)),
	(q^4+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^2+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	((q^2-1)*(q^2-sqrt2*q+1))*e2p(S(0)),
	(sqrt2*q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//4*(q^2+1)^2*(q^2+sqrt2*q+1)^2*(q^4-q^2+1)*(q^4-sqrt2*q^3+q^2-sqrt2*q+1)*q^4)*e2p(S(0)),
	(1//4*(q^2+sqrt2*q+1)*(2*q^10-sqrt2*q^9-sqrt2*q^7+q^6+q^4))*e2p(S(0)),
	(1//4*(q^2+1)*(-sqrt2*q^7+q^6+sqrt2*q^5+q^4))*e2p(S(0)),
	(1//4*(q^2+sqrt2*q+1)*(q^6-2*sqrt2*q^5+3*q^4))*e2p(S(0)),
	(1//4*(q^2+sqrt2*q+1)*(q^6-2*sqrt2*q^5+3*q^4))*e2p(S(0)),
	(1//4*sqrt2*q^5+1//4*q^4)*e2p(S(0)),
	(1//4*sqrt2*q^5+3//4*q^4)*e2p(S(0)),
	(-1//4*q^6+5//4*q^4)*e2p(S(0)),
	(1//4*(q^2+1)*q^4)*e2p(S(0)),
	(-1//4*(q^2+1)*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(-1//4*sqrt2*q^3)*e2p(S(0)),
	(1//4*sqrt2*q^3)*e2p(S(0)),
	(-1//2*q^2)*e2p(S(0)),
	(-1//2*q^2)*e2p(S(0)),
	(1//2*q^2)*e2p(S(0)),
	(1//2*q^2)*e2p(S(0)),
	(q^4+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^2+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	((q^2-1)*(q^2+sqrt2*q+1))*e2p(S(0)),
	(-sqrt2*q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0))] [
	(1//2*(q^4+1)^2*(q^8-q^4+1)*q^4)*e2p(S(0)),
	(1//2*(q^4+1)*q^4)*e2p(S(0)),
	(1//2*(q^2+sqrt2*q+1)*(q^2-sqrt2*q+1)*q^4)*e2p(S(0)),
	(1//2*(q^4+1)*q^4)*e2p(S(0)),
	(1//2*(q^4+1)*q^4)*e2p(S(0)),
	(1//2*q^4)*e2p(S(0)),
	(1//2*q^4)*e2p(S(0)),
	(1//2*(q^2+1)*q^4)*e2p(S(0)),
	(-1//2*(q^2-1)*q^4)*e2p(S(0)),
	(1//2*(q^2+1)*q^4)*e2p(S(0)),
	(-1//2*q^4)*e2p(S(0)),
	(1//2*q^4)*e2p(S(0)),
	(1//2*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^2+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(2)*e2p(S(0)),
	((q^2-1)*q^2)*e2p(S(0)),
	(-q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(2)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//12*(q^2-1)^2*(q^2+sqrt2*q+1)^2*(q^4-q^2+1)*(q^4+sqrt2*q^3+q^2+sqrt2*q+1)*q^4)*e2p(S(0)),
	(1//12*(q^2-1)*(q^2+sqrt2*q+1)*(2*q^8+sqrt2*q^7-2*q^6-2*sqrt2*q^5-q^4))*e2p(S(0)),
	(1//12*(q^2-1)*(-3*sqrt2*q^7-7*q^6-3*sqrt2*q^5-q^4))*e2p(S(0)),
	(-1//4*(q^2-1)*(q^2+sqrt2*q+1)*q^4)*e2p(S(0)),
	(-1//4*(q^2-1)*(q^2+sqrt2*q+1)*q^4)*e2p(S(0)),
	(1//3*q^6+1//4*sqrt2*q^5+1//12*q^4)*e2p(S(0)),
	(1//4*sqrt2*q^5+1//4*q^4)*e2p(S(0)),
	(-1//12*q^6+5//12*q^4)*e2p(S(0)),
	(1//12*(q^2+1)*q^4)*e2p(S(0)),
	(-1//12*(q^2+1)*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(-1//4*sqrt2*q^3)*e2p(S(0)),
	(1//4*sqrt2*q^3)*e2p(S(0)),
	(1//2*q^2)*e2p(S(0)),
	(1//2*q^2)*e2p(S(0)),
	(-1//2*q^2)*e2p(S(0)),
	(-1//2*q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//3*(q^2-1)*(q^4-q^2+1))*e2p(S(0)),
	(2//3*q^2-1//3)*e2p(S(0)),
	(2//3*q^2-1//3)*e2p(S(0)),
	(-1//3*q^2-1//3)*e2p(S(0)),
	(-1//3*q^2-1//3)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	((q^2-1)*(q^2+sqrt2*q+1))*e2p(S(0)),
	(-sqrt2*q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//12*(q^2-1)^2*(q^2-sqrt2*q+1)^2*(q^4-q^2+1)*(q^4-sqrt2*q^3+q^2-sqrt2*q+1)*q^4)*e2p(S(0)),
	(1//12*(q^2-1)*(q^2-sqrt2*q+1)*(2*q^8-sqrt2*q^7-2*q^6+2*sqrt2*q^5-q^4))*e2p(S(0)),
	(1//12*(q^2-1)*(3*sqrt2*q^7-7*q^6+3*sqrt2*q^5-q^4))*e2p(S(0)),
	(-1//4*(q^2-1)*(q^2-sqrt2*q+1)*q^4)*e2p(S(0)),
	(-1//4*(q^2-1)*(q^2-sqrt2*q+1)*q^4)*e2p(S(0)),
	(1//3*q^6-1//4*sqrt2*q^5+1//12*q^4)*e2p(S(0)),
	(-1//4*sqrt2*q^5+1//4*q^4)*e2p(S(0)),
	(-1//12*q^6+5//12*q^4)*e2p(S(0)),
	(1//12*(q^2+1)*q^4)*e2p(S(0)),
	(-1//12*(q^2+1)*q^4)*e2p(S(0)),
	(-1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	(1//4*sqrt2*q^3)*e2p(S(0)),
	(-1//4*sqrt2*q^3)*e2p(S(0)),
	(-1//2*q^2)*e2p(S(0)),
	(-1//2*q^2)*e2p(S(0)),
	(1//2*q^2)*e2p(S(0)),
	(1//2*q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//3*(q^2-1)*(q^4-q^2+1))*e2p(S(0)),
	(2//3*q^2-1//3)*e2p(S(0)),
	(2//3*q^2-1//3)*e2p(S(0)),
	(-1//3*q^2-1//3)*e2p(S(0)),
	(-1//3*q^2-1//3)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	((q^2-1)*(q^2-sqrt2*q+1))*e2p(S(0)),
	(sqrt2*q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-4)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0))] [
	(1//6*(q^4-1)^2*(q^8-q^4+1)*q^4)*e2p(S(0)),
	(1//6*(q^4-1)*(2*q^8-q^4))*e2p(S(0)),
	(-1//6*(q^4-1)*q^4)*e2p(S(0)),
	(-1//2*(q^4-1)*q^4)*e2p(S(0)),
	(-1//2*(q^4-1)*q^4)*e2p(S(0)),
	(-1//3*q^6+1//6*q^4)*e2p(S(0)),
	(1//2*q^4)*e2p(S(0)),
	(-1//6*q^6+5//6*q^4)*e2p(S(0)),
	(1//6*(q^2+1)*q^4)*e2p(S(0)),
	(-1//6*(q^2+1)*q^4)*e2p(S(0)),
	(-1//2*q^4)*e2p(S(0)),
	(1//2*q^4)*e2p(S(0)),
	(1//2*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//3*(q^4-1)*(q^2+1))*e2p(S(0)),
	(1//3*q^2+1//3)*e2p(S(0)),
	(-2//3*q^2+1//3)*e2p(S(0)),
	(1//3*q^2+1//3)*e2p(S(0)),
	(1//3*q^2+1//3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	((q^4-1))*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	((q^4-1))*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//4*(q^4-1)^2*(q^4-q^2+1)*(q^4-sqrt2*q^3+q^2-sqrt2*q+1)*q^4)*e2p(S(0)),
	(1//4*(q^2-1)*(-sqrt2*q^9+sqrt2*q^7-q^6+sqrt2*q^5-q^4))*e2p(S(0)),
	(1//4*(q^4-1)*(sqrt2*q^5-q^4))*e2p(S(0)),
	1//4*(q^2-1)*((-1+2*e2p(S(1//(4))))*q^6+sqrt2*q^5-q^4),
	1//4*(q^2-1)*(-q^6+sqrt2*q^5-q^4)-1//2*(q^2-1)*q^6*e2p(S(1//(4))),
	(-1//4*sqrt2*q^5+1//4*q^4)*e2p(S(0)),
	(-1//4*sqrt2*q^5+1//4*q^4)*e2p(S(0)),
	(1//4*(q^2+1)*q^4)*e2p(S(0)),
	(-1//4*(q^2-1)*q^4)*e2p(S(0)),
	(1//4*(q^2+1)*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	-1//4*q^4-1//2*e2p(S(1//(4)))*sqrt2*q^3,
	-1//4*q^4+1//2*e2p(S(1//(4)))*sqrt2*q^3,
	(-1//4*sqrt2*q^3)*e2p(S(0)),
	(1//4*sqrt2*q^3)*e2p(S(0)),
	1//2*e2p(S(1//(4)))*q^2,
	-1//2*e2p(S(1//(4)))*q^2,
	-1//2*e2p(S(1//(4)))*q^2,
	1//2*e2p(S(1//(4)))*q^2,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//2*(q^2-1)*sqrt2*q)*e2p(S(0)),
	(1//2*sqrt2*q)*e2p(S(0)),
	1//2*e2p(S(1//(4)))*sqrt2*q,
	-1//2*e2p(S(1//(4)))*sqrt2*q,
	(0)*e2p(S(0)),
	(1//2*(q^2-1)*(2*q^2-sqrt2*q+2))*e2p(S(0)),
	(1//2*sqrt2*q-1)*e2p(S(0)),
	-1//2*e2p(S(1//(4)))*sqrt2*q-1,
	-1+1//2*e2p(S(1//(4)))*sqrt2*q,
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0))] [
	(1//4*(q^4-1)^2*(q^4-q^2+1)*(q^4-sqrt2*q^3+q^2-sqrt2*q+1)*q^4)*e2p(S(0)),
	(1//4*(q^2-1)*(-sqrt2*q^9+sqrt2*q^7-q^6+sqrt2*q^5-q^4))*e2p(S(0)),
	(1//4*(q^4-1)*(sqrt2*q^5-q^4))*e2p(S(0)),
	1//4*(q^2-1)*((-1-2*e2p(S(1//(4))))*q^6+sqrt2*q^5-q^4),
	1//4*(q^2-1)*(-q^6+sqrt2*q^5-q^4)+1//2*(q^2-1)*q^6*e2p(S(1//(4))),
	(-1//4*sqrt2*q^5+1//4*q^4)*e2p(S(0)),
	(-1//4*sqrt2*q^5+1//4*q^4)*e2p(S(0)),
	(1//4*(q^2+1)*q^4)*e2p(S(0)),
	(-1//4*(q^2-1)*q^4)*e2p(S(0)),
	(1//4*(q^2+1)*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	-1//4*q^4+1//2*e2p(S(1//(4)))*sqrt2*q^3,
	-1//4*q^4-1//2*e2p(S(1//(4)))*sqrt2*q^3,
	(-1//4*sqrt2*q^3)*e2p(S(0)),
	(1//4*sqrt2*q^3)*e2p(S(0)),
	-1//2*e2p(S(1//(4)))*q^2,
	1//2*e2p(S(1//(4)))*q^2,
	1//2*e2p(S(1//(4)))*q^2,
	-1//2*e2p(S(1//(4)))*q^2,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//2*(q^2-1)*sqrt2*q)*e2p(S(0)),
	(1//2*sqrt2*q)*e2p(S(0)),
	-1//2*e2p(S(1//(4)))*sqrt2*q,
	1//2*e2p(S(1//(4)))*sqrt2*q,
	(0)*e2p(S(0)),
	(1//2*(q^2-1)*(2*q^2-sqrt2*q+2))*e2p(S(0)),
	(1//2*sqrt2*q-1)*e2p(S(0)),
	1//2*e2p(S(1//(4)))*sqrt2*q-1,
	-1//2*e2p(S(1//(4)))*sqrt2*q-1,
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0))] [
	(1//4*(q^4-1)^2*(q^4-q^2+1)*(q^4+sqrt2*q^3+q^2+sqrt2*q+1)*q^4)*e2p(S(0)),
	(1//4*(q^2-1)*(sqrt2*q^9-sqrt2*q^7-q^6-sqrt2*q^5-q^4))*e2p(S(0)),
	(1//4*(q^4-1)*(-sqrt2*q^5-q^4))*e2p(S(0)),
	1//4*(q^2-1)*((-1+2*e2p(S(1//(4))))*q^6-sqrt2*q^5-q^4),
	1//4*(q^2-1)*(-q^6-sqrt2*q^5-q^4)-1//2*(q^2-1)*q^6*e2p(S(1//(4))),
	(1//4*sqrt2*q^5+1//4*q^4)*e2p(S(0)),
	(1//4*sqrt2*q^5+1//4*q^4)*e2p(S(0)),
	(1//4*(q^2+1)*q^4)*e2p(S(0)),
	(-1//4*(q^2-1)*q^4)*e2p(S(0)),
	(1//4*(q^2+1)*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	-1//4*q^4-1//2*e2p(S(1//(4)))*sqrt2*q^3,
	-1//4*q^4+1//2*e2p(S(1//(4)))*sqrt2*q^3,
	(1//4*sqrt2*q^3)*e2p(S(0)),
	(-1//4*sqrt2*q^3)*e2p(S(0)),
	-1//2*e2p(S(1//(4)))*q^2,
	1//2*e2p(S(1//(4)))*q^2,
	1//2*e2p(S(1//(4)))*q^2,
	-1//2*e2p(S(1//(4)))*q^2,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//2*(q^2-1)*(2*q^2+sqrt2*q+2))*e2p(S(0)),
	(-1//2*sqrt2*q-1)*e2p(S(0)),
	1//2*e2p(S(1//(4)))*sqrt2*q-1,
	-1//2*e2p(S(1//(4)))*sqrt2*q-1,
	(0)*e2p(S(0)),
	(1//2*(q^2-1)*sqrt2*q)*e2p(S(0)),
	(-1//2*sqrt2*q)*e2p(S(0)),
	-1//2*e2p(S(1//(4)))*sqrt2*q,
	1//2*e2p(S(1//(4)))*sqrt2*q,
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-3)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//4*(q^4-1)^2*(q^4-q^2+1)*(q^4+sqrt2*q^3+q^2+sqrt2*q+1)*q^4)*e2p(S(0)),
	(1//4*(q^2-1)*(sqrt2*q^9-sqrt2*q^7-q^6-sqrt2*q^5-q^4))*e2p(S(0)),
	(1//4*(q^4-1)*(-sqrt2*q^5-q^4))*e2p(S(0)),
	1//4*(q^2-1)*((-1-2*e2p(S(1//(4))))*q^6-sqrt2*q^5-q^4),
	1//4*(q^2-1)*(-q^6-sqrt2*q^5-q^4)+1//2*(q^2-1)*q^6*e2p(S(1//(4))),
	(1//4*sqrt2*q^5+1//4*q^4)*e2p(S(0)),
	(1//4*sqrt2*q^5+1//4*q^4)*e2p(S(0)),
	(1//4*(q^2+1)*q^4)*e2p(S(0)),
	(-1//4*(q^2-1)*q^4)*e2p(S(0)),
	(1//4*(q^2+1)*q^4)*e2p(S(0)),
	(1//4*q^4)*e2p(S(0)),
	-1//4*q^4+1//2*e2p(S(1//(4)))*sqrt2*q^3,
	-1//4*q^4-1//2*e2p(S(1//(4)))*sqrt2*q^3,
	(1//4*sqrt2*q^3)*e2p(S(0)),
	(-1//4*sqrt2*q^3)*e2p(S(0)),
	1//2*e2p(S(1//(4)))*q^2,
	-1//2*e2p(S(1//(4)))*q^2,
	-1//2*e2p(S(1//(4)))*q^2,
	1//2*e2p(S(1//(4)))*q^2,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//2*(q^2-1)*(2*q^2+sqrt2*q+2))*e2p(S(0)),
	(-1//2*sqrt2*q-1)*e2p(S(0)),
	-1//2*e2p(S(1//(4)))*sqrt2*q-1,
	-1+1//2*e2p(S(1//(4)))*sqrt2*q,
	(0)*e2p(S(0)),
	(1//2*(q^2-1)*sqrt2*q)*e2p(S(0)),
	(-1//2*sqrt2*q)*e2p(S(0)),
	1//2*e2p(S(1//(4)))*sqrt2*q,
	-1//2*e2p(S(1//(4)))*sqrt2*q,
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-3)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//3*(q^8-1)^2*q^4)*e2p(S(0)),
	(-1//3*q^4*(q^8-1))*e2p(S(0)),
	(-1//3*(q^4-1)*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//3*(q^2+1)*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//3*(q^2+1)*q^4)*e2p(S(0)),
	(1//3*(q^2+1)*q^4)*e2p(S(0)),
	(-1//3*q^4*(q^2-2))*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//3*(q^4-1)*(q^2+1))*e2p(S(0)),
	(-1//3*q^2-1//3)*e2p(S(0)),
	(-1//3*q^2-1//3)*e2p(S(0)),
	1//6*q^2+1//2*e2p(S(1//(4)))*sqrt3*q^2-1//3,
	1//6*q^2-1//2*e2p(S(1//(4)))*sqrt3*q^2-1//3,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0))] [
	(1//3*(q^8-1)^2*q^4)*e2p(S(0)),
	(-1//3*q^4*(q^8-1))*e2p(S(0)),
	(-1//3*(q^4-1)*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//3*(q^2+1)*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//3*(q^2+1)*q^4)*e2p(S(0)),
	(1//3*(q^2+1)*q^4)*e2p(S(0)),
	(-1//3*q^4*(q^2-2))*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//3*(q^4-1)*(q^2+1))*e2p(S(0)),
	(-1//3*q^2-1//3)*e2p(S(0)),
	(-1//3*q^2-1//3)*e2p(S(0)),
	1//6*q^2-1//2*e2p(S(1//(4)))*sqrt3*q^2-1//3,
	1//6*q^2+1//2*e2p(S(1//(4)))*sqrt3*q^2-1//3,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0))] [
	(1//3*(q^2-1)^2*(q^4-q^2+1)*(q^8-q^4+1)*q^4)*e2p(S(0)),
	(1//3*(q^2-1)*(-q^10-q^8+2*q^6-q^4))*e2p(S(0)),
	(1//3*(q^2-1)*(2*q^6-q^4))*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-2//3*q^6+1//3*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//3*(q^2+1)*q^4)*e2p(S(0)),
	(1//3*(q^2+1)*q^4)*e2p(S(0)),
	(-1//3*q^6+2//3*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-2//3*(q^2-1)*(q^4-q^2+1))*e2p(S(0)),
	(-4//3*q^2+2//3)*e2p(S(0)),
	(2//3*q^2+2//3)*e2p(S(0)),
	(-1//3*q^2+2//3)*e2p(S(0)),
	(-1//3*q^2+2//3)*e2p(S(0)),
	(-2*q^2+2)*e2p(S(0)),
	(2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-(q^2-1)*sqrt2*q)*e2p(S(0)),
	(sqrt2*q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	((q^2-1)*sqrt2*q)*e2p(S(0)),
	(-sqrt2*q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(2)*e2p(S(0)),
	(2)*e2p(S(0)),
	(4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q^4-q^2+1)*(q^8-q^4+1)*q^10)*e2p(S(0)),
	(-(q^2-1)*q^10)*e2p(S(0)),
	(q^10)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	((q^4-q^2+1)*q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(2*q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-q^4-sqrt2*q^3+sqrt2*q)*e2p(S(0)),
	(sqrt2*q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-q^4+sqrt2*q^3-sqrt2*q)*e2p(S(0)),
	(-sqrt2*q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(3)*e2p(S(0)),
	(3)*e2p(S(0)),
	(-3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//2*(q^2-1)*(q^2+1)^2*(q^4-q^2+1)*sqrt2*q^13)*e2p(S(0)),
	(-1//2*sqrt2*q^13)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p(S(1//(4)))*sqrt2*q^9,
	-1//2*e2p(S(1//(4)))*sqrt2*q^9,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//2*(q^2-1)*sqrt2*q)*e2p(S(0)),
	(-1//2*sqrt2*q)*e2p(S(0)),
	1//2*e2p(S(1//(4)))*sqrt2*q,
	-1//2*e2p(S(1//(4)))*sqrt2*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^4-1//2*sqrt2*q^3+1//2*sqrt2*q)*e2p(S(0)),
	(1//2*sqrt2*q)*e2p(S(0)),
	1//2*e2p(S(1//(4)))*sqrt2*q,
	-1//2*e2p(S(1//(4)))*sqrt2*q,
	(-1)*e2p(S(0)),
	(q^4-1//2*sqrt2*q^3+1//2*sqrt2*q)*e2p(S(0)),
	(1//2*sqrt2*q)*e2p(S(0)),
	1//2*e2p(S(1//(4)))*sqrt2*q,
	-1//2*e2p(S(1//(4)))*sqrt2*q,
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(2)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0))] [
	(1//2*(q^2-1)*(q^2+1)^2*(q^4-q^2+1)*sqrt2*q^13)*e2p(S(0)),
	(-1//2*sqrt2*q^13)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*e2p(S(1//(4)))*sqrt2*q^9,
	1//2*e2p(S(1//(4)))*sqrt2*q^9,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//2*(q^2-1)*sqrt2*q)*e2p(S(0)),
	(-1//2*sqrt2*q)*e2p(S(0)),
	-1//2*e2p(S(1//(4)))*sqrt2*q,
	1//2*e2p(S(1//(4)))*sqrt2*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^4-1//2*sqrt2*q^3+1//2*sqrt2*q)*e2p(S(0)),
	(1//2*sqrt2*q)*e2p(S(0)),
	-1//2*e2p(S(1//(4)))*sqrt2*q,
	1//2*e2p(S(1//(4)))*sqrt2*q,
	(-1)*e2p(S(0)),
	(q^4-1//2*sqrt2*q^3+1//2*sqrt2*q)*e2p(S(0)),
	(1//2*sqrt2*q)*e2p(S(0)),
	-1//2*e2p(S(1//(4)))*sqrt2*q,
	1//2*e2p(S(1//(4)))*sqrt2*q,
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(2)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0))] [
	(q^24)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-q^6)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0))] [
	((q^4-q^2+1)*(q^4+1)*(q^8-q^4+1)*(q^2+1)^2)*e2p(S(0)),
	(1+q^8+q^12+q^6+q^2)*e2p(S(0)),
	((q^4-q^2+1)*(q^2+1)^2)*e2p(S(0)),
	((1+q^4+q^3+q+q^2)*(q^4-q^3+q^2-q+1))*e2p(S(0)),
	((1+q^4+q^3+q+q^2)*(q^4-q^3+q^2-q+1))*e2p(S(0)),
	(q^2+1)*e2p(S(0)),
	((q^2-q+1)*(q^2+q+1))*e2p(S(0)),
	(3*q^4+q^2+1)*e2p(S(0)),
	((q^2-q+1)*(q^2+q+1))*e2p(S(0)),
	(q^2+1)*e2p(S(0)),
	(q^2+1)*e2p(S(0)),
	(q^2+1)*e2p(S(0)),
	(q^2+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	1+q^4+e2p((a*k*(1-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-1))*S(1//(q^2-1)))+e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*k*(1-q*sqrt2))*S(1//(q^2-1)))*q^4+e2p((a*k*(q*sqrt2-1))*S(1//(q^2-1)))*q^4,
	1+e2p((a*k*(1-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-1))*S(1//(q^2-1)))+e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1))),
	1+e2p((a*k*(1-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-1))*S(1//(q^2-1)))+e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1))),
	1+e2p((a*k*(1-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-1))*S(1//(q^2-1)))+e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1))),
	(q^2+1)*(e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*k*(4-3*q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(3*q*sqrt2-4))*S(1//(q^2-1)))),
	e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*k*(4-3*q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(3*q*sqrt2-4))*S(1//(q^2-1))),
	e2p((k*b*(2-sqrt2*q))*S(1//(q^2-1)))+e2p((k*b*(sqrt2*q-2))*S(1//(q^2-1)))+e2p((k*(b+a-b*sqrt2*q-a*q*sqrt2))*S(1//(q^2-1)))+e2p((-k*(b+a-b*sqrt2*q-a*q*sqrt2))*S(1//(q^2-1)))+e2p((k*(b-a-b*sqrt2*q+a*q*sqrt2))*S(1//(q^2-1)))+e2p((-k*(b-a-b*sqrt2*q+a*q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((a*k)*S(1//(q^2-1)))+e2p((-a*k)*S(1//(q^2-1))),
	(q^4+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((a*k*(3-2*q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(2*q*sqrt2-3))*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//2*sqrt2*q*(q^2-1)*(q^2+1)^2*(q^8-q^4+1)*(q^4-q^2+1)*(q^4+1))*e2p(S(0)),
	(-1//2*sqrt2*q*(q^2+1)*(q^10-q^8+q^6-q^2+1))*e2p(S(0)),
	(1//2*sqrt2*q*(q^2-1)*(q^2+1))*e2p(S(0)),
	1//2*sqrt2*q*(q^2-1)+sqrt2*q^5*1//2*e2p(S(1//(4)))*(q^4+1),
	1//2*sqrt2*q*(q^2-1)-sqrt2*q^5*1//2*e2p(S(1//(4)))*(q^4+1),
	(-1//2*sqrt2*q)*e2p(S(0)),
	(1//2*sqrt2*q*(q^2-1))*e2p(S(0)),
	(1//2*sqrt2*(2*q^2-1)*q)*e2p(S(0)),
	(-1//2*sqrt2*q)*e2p(S(0)),
	(-1//2*sqrt2*q*(q^2+1))*e2p(S(0)),
	(-1//2*sqrt2*q)*e2p(S(0)),
	-1//2*sqrt2*q+q^2*e2p(S(1//(4))),
	-1//2*sqrt2*q-q^2*e2p(S(1//(4))),
	(-1//2*sqrt2*q)*e2p(S(0)),
	(-1//2*sqrt2*q)*e2p(S(0)),
	sqrt2*q*1//2*e2p(S(1//(4))),
	-sqrt2*q*1//2*e2p(S(1//(4))),
	sqrt2*q*1//2*e2p(S(1//(4))),
	-sqrt2*q*1//2*e2p(S(1//(4))),
	1//2*sqrt2*q*(q^2-1)*(e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))),
	-1//2*sqrt2*q*(e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))),
	q*sqrt2//2*e2p(S(1//(4)))*(e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))),
	-q*sqrt2//2*e2p(S(1//(4)))*(e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^4-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-e2p((a*k)*S(1//(q^2-1)))-e2p((-a*k)*S(1//(q^2-1))),
	(q^4+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((a*k*(3-2*q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(2*q*sqrt2-3))*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//2*sqrt2*q*(q^2-1)*(q^2+1)^2*(q^8-q^4+1)*(q^4-q^2+1)*(q^4+1))*e2p(S(0)),
	(-1//2*sqrt2*q*(q^2+1)*(q^10-q^8+q^6-q^2+1))*e2p(S(0)),
	(1//2*sqrt2*q*(q^2-1)*(q^2+1))*e2p(S(0)),
	1//2*sqrt2*q*(q^2-1)-sqrt2*q^5*1//2*e2p(S(1//(4)))*(q^4+1),
	1//2*sqrt2*q*(q^2-1)+sqrt2*q^5*1//2*e2p(S(1//(4)))*(q^4+1),
	(-1//2*sqrt2*q)*e2p(S(0)),
	(1//2*sqrt2*q*(q^2-1))*e2p(S(0)),
	(1//2*sqrt2*(2*q^2-1)*q)*e2p(S(0)),
	(-1//2*sqrt2*q)*e2p(S(0)),
	(-1//2*sqrt2*q*(q^2+1))*e2p(S(0)),
	(-1//2*sqrt2*q)*e2p(S(0)),
	-1//2*sqrt2*q-q^2*e2p(S(1//(4))),
	-1//2*sqrt2*q+q^2*e2p(S(1//(4))),
	(-1//2*sqrt2*q)*e2p(S(0)),
	(-1//2*sqrt2*q)*e2p(S(0)),
	-sqrt2*q*1//2*e2p(S(1//(4))),
	sqrt2*q*1//2*e2p(S(1//(4))),
	-sqrt2*q*1//2*e2p(S(1//(4))),
	sqrt2*q*1//2*e2p(S(1//(4))),
	1//2*sqrt2*q*(q^2-1)*(e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))),
	-1//2*sqrt2*q*(e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))),
	-q*sqrt2//2*e2p(S(1//(4)))*(e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))),
	q*sqrt2//2*e2p(S(1//(4)))*(e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^4-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-e2p((a*k)*S(1//(q^2-1)))-e2p((-a*k)*S(1//(q^2-1))),
	(q^4+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((a*k*(3-2*q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(2*q*sqrt2-3))*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^4*(q^4-q^2+1)*(q^4+1)*(q^8-q^4+1)*(q^2+1)^2)*e2p(S(0)),
	(q^4*(q^2+1+q^6))*e2p(S(0)),
	(q^4*(q^2+1)*(q^4+1))*e2p(S(0)),
	(q^4*(2+q^4))*e2p(S(0)),
	(q^4*(2+q^4))*e2p(S(0)),
	(q^4)*e2p(S(0)),
	(2*q^4)*e2p(S(0)),
	(3*q^4)*e2p(S(0)),
	(q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((a*k*(q*sqrt2-1))*S(1//(q^2-1)))*q^4+e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))*q^4+e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))*q^4+1+e2p((a*k*(1-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-1))*S(1//(q^2-1)))+q^4+e2p((a*k*(1-q*sqrt2))*S(1//(q^2-1)))*q^4,
	1+e2p((a*k*(1-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-1))*S(1//(q^2-1))),
	1+e2p((a*k*(1-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-1))*S(1//(q^2-1))),
	1+e2p((a*k*(1-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-1))*S(1//(q^2-1))),
	(q^2+1)*(e2p((a*k*(3*q*sqrt2-4))*S(1//(q^2-1)))+e2p((a*k*(4-3*q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))),
	e2p((a*k*(3*q*sqrt2-4))*S(1//(q^2-1)))+e2p((a*k*(4-3*q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1))),
	e2p((k*b*sqrt2*q-2*k*b)*S(1//(q^2-1)))+e2p((2*k*b-k*b*sqrt2*q)*S(1//(q^2-1)))+e2p((k*b*sqrt2*q-k*b-a*q*sqrt2*k+a*k)*S(1//(q^2-1)))+e2p((-k*b*sqrt2*q+k*b-a*q*sqrt2*k+a*k)*S(1//(q^2-1)))+e2p((k*b*sqrt2*q-k*b+a*q*sqrt2*k-a*k)*S(1//(q^2-1)))+e2p((-k*b*sqrt2*q+k*b+a*q*sqrt2*k-a*k)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k+2*a*k)*S(1//(q^2-1)))+e2p((a*q*sqrt2*k-2*a*k)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^4-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-e2p((a*k)*S(1//(q^2-1)))-e2p((-a*k)*S(1//(q^2-1))),
	(-q^4-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-e2p((a*k*(2*q*sqrt2-3))*S(1//(q^2-1)))-e2p((a*k*(3-2*q*sqrt2))*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q^2+1)*(q^4-q^2+1)*(q^8-q^4+1)*(q^4+1)^2)*e2p(S(0)),
	((q^2+1)*(q^4+1)*(q^4-q^2+1))*e2p(S(0)),
	(1+q^8+q^6+q^4+q^10)*e2p(S(0)),
	((q^4+1)^2)*e2p(S(0)),
	((q^4+1)^2)*e2p(S(0)),
	(q^4+1)*e2p(S(0)),
	(2*q^4+1)*e2p(S(0)),
	(3*q^4+1)*e2p(S(0)),
	(q^4+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^4+1)*(e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*q*sqrt2*k)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k)*S(1//(q^2-1)))),
	e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*q*sqrt2*k)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k)*S(1//(q^2-1))),
	e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*q*sqrt2*k)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k)*S(1//(q^2-1))),
	e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*q*sqrt2*k)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k)*S(1//(q^2-1))),
	q^2+1+e2p((a*k*(4-4*q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(4*q*sqrt2-4))*S(1//(q^2-1)))+e2p((a*k*(4-2*q*sqrt2))*S(1//(q^2-1)))*q^2+e2p((a*k*(2*q*sqrt2-4))*S(1//(q^2-1)))*q^2+e2p((a*k*(4-2*q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(2*q*sqrt2-4))*S(1//(q^2-1))),
	1+e2p((a*k*(4-4*q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(4*q*sqrt2-4))*S(1//(q^2-1)))+e2p((a*k*(4-2*q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(2*q*sqrt2-4))*S(1//(q^2-1))),
	e2p((a*q*sqrt2*k+k*b*sqrt2*q-2*a*k)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k-k*b*sqrt2*q+2*a*k)*S(1//(q^2-1)))+e2p((a*q*sqrt2*k-k*b*sqrt2*q-2*a*k)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k+k*b*sqrt2*q+2*a*k)*S(1//(q^2-1)))+e2p((a*q*sqrt2*k+k*b*sqrt2*q-2*k*b)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k-k*b*sqrt2*q+2*k*b)*S(1//(q^2-1)))+e2p((a*q*sqrt2*k-k*b*sqrt2*q+2*k*b)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k+k*b*sqrt2*q-2*k*b)*S(1//(q^2-1))),
	((q^2+1)*(q^4-q^2+1))*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^2+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((a*k*(2-2*q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(2*q*sqrt2-2))*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^2*(q^2+1)*(q^4-q^2+1)*(q^8-q^4+1)*(q^4+1)^2)*e2p(S(0)),
	(q^2*(q^2+1)*(q^4-q^2+1)*(q^4+1))*e2p(S(0)),
	(q^2*(1+q^4+q^6))*e2p(S(0)),
	(q^2*(q^2+1)*(q^4+1))*e2p(S(0)),
	(q^2*(q^2+1)*(q^4+1))*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2*(q^2+1))*e2p(S(0)),
	(q^2*(3*q^2+1))*e2p(S(0)),
	(q^2*(q^2+1))*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4+1)*(e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*q*sqrt2*k)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k)*S(1//(q^2-1)))),
	e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*q*sqrt2*k)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k)*S(1//(q^2-1))),
	e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*q*sqrt2*k)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k)*S(1//(q^2-1))),
	e2p((a*k*(2-q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(q*sqrt2-2))*S(1//(q^2-1)))+e2p((a*q*sqrt2*k)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k)*S(1//(q^2-1))),
	1+q^2+e2p((a*k*(4-2*q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(2*q*sqrt2-4))*S(1//(q^2-1)))+e2p((a*k*(4-4*q*sqrt2))*S(1//(q^2-1)))*q^2+e2p((a*k*(4*q*sqrt2-4))*S(1//(q^2-1)))*q^2+e2p((a*k*(4-2*q*sqrt2))*S(1//(q^2-1)))*q^2+e2p((a*k*(2*q*sqrt2-4))*S(1//(q^2-1)))*q^2,
	1+e2p((a*k*(4-2*q*sqrt2))*S(1//(q^2-1)))+e2p((a*k*(2*q*sqrt2-4))*S(1//(q^2-1))),
	e2p((a*q*sqrt2*k+k*b*sqrt2*q-2*a*k)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k-k*b*sqrt2*q+2*a*k)*S(1//(q^2-1)))+e2p((a*q*sqrt2*k-k*b*sqrt2*q+2*k*b)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k+k*b*sqrt2*q-2*k*b)*S(1//(q^2-1)))+e2p((a*q*sqrt2*k+k*b*sqrt2*q-2*k*b)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k-k*b*sqrt2*q+2*k*b)*S(1//(q^2-1)))+e2p((a*q*sqrt2*k-k*b*sqrt2*q-2*a*k)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k+k*b*sqrt2*q+2*a*k)*S(1//(q^2-1))),
	(-(q^2+1)*(q^4-q^2+1))*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-e2p((a*k*(2-2*q*sqrt2))*S(1//(q^2-1)))-e2p((a*k*(2*q*sqrt2-2))*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q^2+1)^2*(q^4+1)^2*(q^4-q^2+1)*(q^8-q^4+1))*e2p(S(0)),
	((q^2+1)^2*(q^4+1)*(q^4-q^2+1))*e2p(S(0)),
	((q^2+1)*(q^8+q^6+q^4+1))*e2p(S(0)),
	((q^4+1)*(2*q^4+q^2+1))*e2p(S(0)),
	((q^4+1)*(2*q^4+q^2+1))*e2p(S(0)),
	(q^4+q^2+1)*e2p(S(0)),
	(3*q^4+q^2+1)*e2p(S(0)),
	(6*q^4+q^2+1)*e2p(S(0)),
	(2*q^4+q^2+1)*e2p(S(0)),
	(q^2+1)*e2p(S(0)),
	(q^2+1)*e2p(S(0)),
	(q^2+1)*e2p(S(0)),
	(q^2+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^4+1)*(e2p((a*(k+l))*S(1//(q^2-1)))+e2p((a*q*sqrt2*k)*S(1//(q^2-1)))+e2p((a*(k-l))*S(1//(q^2-1)))+e2p((a*q*sqrt2*l)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*l)*S(1//(q^2-1)))+e2p((-a*(k-l))*S(1//(q^2-1)))+e2p((-a*(k+l))*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k)*S(1//(q^2-1)))),
	e2p((a*(k+l))*S(1//(q^2-1)))+e2p((a*q*sqrt2*k)*S(1//(q^2-1)))+e2p((a*(k-l))*S(1//(q^2-1)))+e2p((a*q*sqrt2*l)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*l)*S(1//(q^2-1)))+e2p((-a*(k-l))*S(1//(q^2-1)))+e2p((-a*(k+l))*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k)*S(1//(q^2-1))),
	e2p((a*(k+l))*S(1//(q^2-1)))+e2p((a*q*sqrt2*k)*S(1//(q^2-1)))+e2p((a*(k-l))*S(1//(q^2-1)))+e2p((a*q*sqrt2*l)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*l)*S(1//(q^2-1)))+e2p((-a*(k-l))*S(1//(q^2-1)))+e2p((-a*(k+l))*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k)*S(1//(q^2-1))),
	e2p((a*(k+l))*S(1//(q^2-1)))+e2p((a*q*sqrt2*k)*S(1//(q^2-1)))+e2p((a*(k-l))*S(1//(q^2-1)))+e2p((a*q*sqrt2*l)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*l)*S(1//(q^2-1)))+e2p((-a*(k-l))*S(1//(q^2-1)))+e2p((-a*(k+l))*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k)*S(1//(q^2-1))),
	(q^2+1)*(e2p((a*q*sqrt2*k+(2*a-a*q*sqrt2)*l)*S(1//(q^2-1)))+e2p((a*q*sqrt2*k+(-2*a+a*q*sqrt2)*l)*S(1//(q^2-1)))+e2p(((2*a-a*q*sqrt2)*k+a*q*sqrt2*l)*S(1//(q^2-1)))+e2p(((2*a-a*q*sqrt2)*k-a*q*sqrt2*l)*S(1//(q^2-1)))+e2p(((-2*a+a*q*sqrt2)*k+a*q*sqrt2*l)*S(1//(q^2-1)))+e2p(((-2*a+a*q*sqrt2)*k-a*q*sqrt2*l)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k+(2*a-a*q*sqrt2)*l)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k+(-2*a+a*q*sqrt2)*l)*S(1//(q^2-1)))),
	e2p((a*q*sqrt2*k+(2*a-a*q*sqrt2)*l)*S(1//(q^2-1)))+e2p((a*q*sqrt2*k+(-2*a+a*q*sqrt2)*l)*S(1//(q^2-1)))+e2p(((2*a-a*q*sqrt2)*k+a*q*sqrt2*l)*S(1//(q^2-1)))+e2p(((2*a-a*q*sqrt2)*k-a*q*sqrt2*l)*S(1//(q^2-1)))+e2p(((-2*a+a*q*sqrt2)*k+a*q*sqrt2*l)*S(1//(q^2-1)))+e2p(((-2*a+a*q*sqrt2)*k-a*q*sqrt2*l)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k+(2*a-a*q*sqrt2)*l)*S(1//(q^2-1)))+e2p((-a*q*sqrt2*k+(-2*a+a*q*sqrt2)*l)*S(1//(q^2-1))),
	e2p(((a+b)*k+(a-b)*l)*S(1//(q^2-1)))+e2p((sqrt2*q*a*k+sqrt2*q*b*l)*S(1//(q^2-1)))+e2p(((a+b)*k+(-a+b)*l)*S(1//(q^2-1)))+e2p((sqrt2*q*b*k+sqrt2*q*a*l)*S(1//(q^2-1)))+e2p((sqrt2*q*a*k-sqrt2*q*b*l)*S(1//(q^2-1)))+e2p(((a-b)*k+(a+b)*l)*S(1//(q^2-1)))+e2p((sqrt2*q*b*k-sqrt2*q*a*l)*S(1//(q^2-1)))+e2p(((-a+b)*k+(a+b)*l)*S(1//(q^2-1)))+e2p(((a-b)*k+(-a-b)*l)*S(1//(q^2-1)))+e2p((-sqrt2*q*b*k+sqrt2*q*a*l)*S(1//(q^2-1)))+e2p(((-a+b)*k+(-a-b)*l)*S(1//(q^2-1)))+e2p((-sqrt2*q*a*k+sqrt2*q*b*l)*S(1//(q^2-1)))+e2p((-sqrt2*q*b*k-sqrt2*q*a*l)*S(1//(q^2-1)))+e2p(((-a-b)*k+(a-b)*l)*S(1//(q^2-1)))+e2p((-sqrt2*q*a*k-sqrt2*q*b*l)*S(1//(q^2-1)))+e2p(((-a-b)*k+(-a+b)*l)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q^2-1)*(q^8-q^4+1)*(q^4+1)^2)*e2p(S(0)),
	((q^2-1)*(q^4+1))*e2p(S(0)),
	(-1+q^2-q^4-q^8+q^6)*e2p(S(0)),
	((q^2-1)*(q^4+1))*e2p(S(0)),
	((q^2-1)*(q^4+1))*e2p(S(0)),
	((q^2-1)*(q^4+1))*e2p(S(0)),
	(-q^4+q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^2-q^4-e2p(((2*sqrt2*q+1)*1//3)*S(1//(3)))*q^4+e2p(((2*sqrt2*q+1)*1//3)*S(1//(3)))*q^2-e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))*q^4+e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))*q^2-e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))-e2p(((2*sqrt2*q+1)*1//3)*S(1//(3))),
	q^2+e2p(((2*sqrt2*q+1)*1//3)*S(1//(3)))*q^2+e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))*q^2-e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))-e2p(((2*sqrt2*q+1)*1//3)*S(1//(3))),
	-e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))-e2p(((2*sqrt2*q+1)*1//3)*S(1//(3))),
	-e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))-e2p(((2*sqrt2*q+1)*1//3)*S(1//(3))),
	-e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))-e2p(((2*sqrt2*q+1)*1//3)*S(1//(3))),
	-1+q^2+e2p((-a)*S(1//(3)))*q^2-2*e2p((-a)*S(1//(3)))+e2p(a*S(1//(3)))*q^2-2*e2p(a*S(1//(3))),
	-2*e2p((-a)*S(1//(3)))-2*e2p(a*S(1//(3)))-1,
	-e2p(a*S(1//(3)))-e2p((-a)*S(1//(3))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((b-a)*S(1//(3)))-e2p((-a-b)*S(1//(3)))-e2p(b*S(1//(3)))-e2p(a*S(1//(3)))-e2p((-a)*S(1//(3)))-e2p((-b)*S(1//(3)))-e2p((a+b)*S(1//(3)))-e2p((a-b)*S(1//(3))),
	-e2p(a*S(1//(3)))-e2p((-a)*S(1//(3))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^2*(q^8-q^4+1)*(q^2-1)^2*(q^4+1)^2)*e2p(S(0)),
	(q^2*(q^4+1)*(q^2-1)^2)*e2p(S(0)),
	(q^2*(q^4+1)*(q^2-1)^2)*e2p(S(0)),
	(-q^2*(q^2-1)*(q^4+1))*e2p(S(0)),
	(-q^2*(q^2-1)*(q^4+1))*e2p(S(0)),
	(q^2*(q^2-1)^2)*e2p(S(0)),
	(-q^2*(q^2-1))*e2p(S(0)),
	(q^2*(q^2+1))*e2p(S(0)),
	(-q^2*(q^2-1))*e2p(S(0)),
	(-q^2*(2*q^2-1))*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q^2-1)*(-q^4-e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))*q^4-e2p(((2*sqrt2*q+1)*1//3)*S(1//(3)))*q^4+e2p(((2*sqrt2*q+1)*1//3)*S(1//(3)))*q^2+e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))*q^2-1-e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))-e2p(((2*sqrt2*q+1)*1//3)*S(1//(3)))),
	q^2-1+2*e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))*q^2+2*e2p(((2*sqrt2*q+1)*1//3)*S(1//(3)))*q^2-e2p(((2*sqrt2*q+1)*1//3)*S(1//(3)))-e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3))),
	-e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))-1-e2p(((2*sqrt2*q+1)*1//3)*S(1//(3))),
	-e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))-1-e2p(((2*sqrt2*q+1)*1//3)*S(1//(3))),
	-e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))-1-e2p(((2*sqrt2*q+1)*1//3)*S(1//(3))),
	(q^2-1)*(2+3*e2p((-a)*S(1//(3)))+3*e2p(a*S(1//(3)))),
	-2-3*e2p((-a)*S(1//(3)))-3*e2p(a*S(1//(3))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((-a)*S(1//(3)))-2*e2p((a-b)*S(1//(3)))-2*e2p(b*S(1//(3)))-2*e2p((-b)*S(1//(3)))-2*e2p((b-a)*S(1//(3)))-2*e2p((-a-b)*S(1//(3)))-2*e2p((a+b)*S(1//(3)))-2*e2p(a*S(1//(3))),
	e2p(a*S(1//(3)))+e2p((-a)*S(1//(3))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^6*(q^2-1)*(q^8-q^4+1)*(q^4+1)^2)*e2p(S(0)),
	(q^6*(q^2-1)*(q^4+1))*e2p(S(0)),
	(-q^6*(q^4-q^2+1))*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^6)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^2*(-1+q^2-e2p(((2*sqrt2*q+1)*1//3)*S(1//(3)))*q^4-e2p(((2*sqrt2*q+1)*1//3)*S(1//(3)))+e2p(((2*sqrt2*q+1)*1//3)*S(1//(3)))*q^2-e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))*q^4-e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))+e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))*q^2),
	-q^2*(1+e2p(((2*sqrt2*q+1)*1//3)*S(1//(3)))+e2p(((-1-2*sqrt2*q)*1//3)*S(1//(3)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q^2+1+e2p((-a)*S(1//(3)))-2*e2p((-a)*S(1//(3)))*q^2+e2p(a*S(1//(3)))-2*e2p(a*S(1//(3)))*q^2,
	1+e2p((-a)*S(1//(3)))+e2p(a*S(1//(3))),
	-e2p((-a)*S(1//(3)))-e2p(a*S(1//(3))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-a)*S(1//(3)))+e2p((-b+a)*S(1//(3)))+e2p(b*S(1//(3)))+e2p((-b)*S(1//(3)))+e2p((b-a)*S(1//(3)))+e2p((-b-a)*S(1//(3)))+e2p((a+b)*S(1//(3)))+e2p(a*S(1//(3))),
	e2p((-a)*S(1//(3)))+e2p(a*S(1//(3))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q^2-1)*(q^4-q^2+1)*(q^8-q^4+1)*(q^4+1)^2)*e2p(S(0)),
	((q^2-1)*(q^4+1)*(q^4-q^2+1))*e2p(S(0)),
	((q^5+q^4-q^3-q^2+1)*(q^5-q^4-q^3+q^2-1))*e2p(S(0)),
	(-(q^4+1)*(q-1)^2*(q+1)^2)*e2p(S(0)),
	(-(q^4+1)*(q-1)^2*(q+1)^2)*e2p(S(0)),
	((q^2-1)*(2*q^4-q^2+1))*e2p(S(0)),
	(-2*q^4+2*q^2-1)*e2p(S(0)),
	(2*q^2-1+q^4)*e2p(S(0)),
	(-(q-1)^2*(q+1)^2)*e2p(S(0)),
	(-2*q^4+2*q^2-1)*e2p(S(0)),
	(2*q^2-1)*e2p(S(0)),
	(2*q^2-1)*e2p(S(0)),
	(2*q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4-q^2+1)*(q^2+e2p(k*S(1//(3)))*q^2+e2p((-k)*S(1//(3)))*q^2-1-2*e2p((-k)*S(1//(3)))-2*e2p(k*S(1//(3)))),
	3*e2p(k*S(1//(3)))*q^2-2*e2p(k*S(1//(3)))+3*e2p((-k)*S(1//(3)))*q^2-2*e2p((-k)*S(1//(3)))+2*q^2-1,
	-2*e2p(k*S(1//(3)))-2*e2p((-k)*S(1//(3)))-1,
	-2*e2p(k*S(1//(3)))-2*e2p((-k)*S(1//(3)))-1,
	-2*e2p(k*S(1//(3)))-2*e2p((-k)*S(1//(3)))-1,
	-1+q^2-2*e2p((a*k)*S(1//(q^2+1)))-2*e2p((-a*k)*S(1//(q^2+1)))-e2p((2*a*k)*S(1//(q^2+1)))-e2p((-2*a*k)*S(1//(q^2+1)))-e2p((a*k*sqrt2*q)*S(1//(q^2+1)))-e2p((-a*k*sqrt2*q)*S(1//(q^2+1)))+2*e2p((a*k)*S(1//(q^2+1)))*q^2+2*e2p((-a*k)*S(1//(q^2+1)))*q^2+e2p((a*k*sqrt2*q)*S(1//(q^2+1)))*q^2+e2p((-a*k*sqrt2*q)*S(1//(q^2+1)))*q^2-e2p((a*k*(1+sqrt2*q))*S(1//(q^2+1)))-e2p((-a*k*(1+sqrt2*q))*S(1//(q^2+1)))+e2p((a*k*(1-sqrt2*q))*S(1//(q^2+1)))*q^2+e2p((a*k*(sqrt2*q-1))*S(1//(q^2+1)))*q^2+e2p((a*k*(1+sqrt2*q))*S(1//(q^2+1)))*q^2+e2p((-a*k*(1+sqrt2*q))*S(1//(q^2+1)))*q^2-e2p((a*k*(1-sqrt2*q))*S(1//(q^2+1)))-e2p((a*k*(sqrt2*q-1))*S(1//(q^2+1))),
	-1-e2p((2*a*k)*S(1//(q^2+1)))-e2p((-2*a*k)*S(1//(q^2+1)))-e2p((a*k*sqrt2*q)*S(1//(q^2+1)))-e2p((-a*k*sqrt2*q)*S(1//(q^2+1)))-2*e2p((a*k)*S(1//(q^2+1)))-2*e2p((-a*k)*S(1//(q^2+1)))-e2p((a*k*(1-sqrt2*q))*S(1//(q^2+1)))-e2p((a*k*(sqrt2*q-1))*S(1//(q^2+1)))-e2p((a*k*(1+sqrt2*q))*S(1//(q^2+1)))-e2p((-a*k*(1+sqrt2*q))*S(1//(q^2+1))),
	-e2p((a*k)*S(1//(q^2+1)))-e2p((-a*k)*S(1//(q^2+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*k*b)*S(1//(q^2+1)))-e2p((-2*k*b)*S(1//(q^2+1)))-e2p((2*a*k)*S(1//(q^2+1)))-e2p((-2*a*k)*S(1//(q^2+1)))-e2p((k*sqrt2*q*(a-b))*S(1//(q^2+1)))-e2p((k*sqrt2*q*(b-a))*S(1//(q^2+1)))-e2p((k*sqrt2*q*(a+b))*S(1//(q^2+1)))-e2p((-k*sqrt2*q*(a+b))*S(1//(q^2+1)))-e2p((k*b+a*k*sqrt2*q-a*k)*S(1//(q^2+1)))-e2p((a*k-k*b-a*k*sqrt2*q)*S(1//(q^2+1)))-e2p((k*b+a*k*sqrt2*q+a*k)*S(1//(q^2+1)))-e2p((-k*b-a*k*sqrt2*q-a*k)*S(1//(q^2+1)))-e2p((k*b*sqrt2*q+k*b+a*k)*S(1//(q^2+1)))-e2p((-k*b*sqrt2*q-k*b-a*k)*S(1//(q^2+1)))-e2p((k*b+a*k-k*b*sqrt2*q)*S(1//(q^2+1)))-e2p((k*b*sqrt2*q-k*b-a*k)*S(1//(q^2+1)))-e2p((k*b-a*k*sqrt2*q-a*k)*S(1//(q^2+1)))-e2p((a*k*sqrt2*q+a*k-k*b)*S(1//(q^2+1)))-e2p((k*b-a*k+k*b*sqrt2*q)*S(1//(q^2+1)))-e2p((a*k-k*b*sqrt2*q-k*b)*S(1//(q^2+1)))-e2p((k*b-a*k*sqrt2*q+a*k)*S(1//(q^2+1)))-e2p((a*k*sqrt2*q-a*k-k*b)*S(1//(q^2+1)))-e2p((k*b-a*k-k*b*sqrt2*q)*S(1//(q^2+1)))-e2p((a*k+k*b*sqrt2*q-k*b)*S(1//(q^2+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^2*(q^2-1)*(q^4-q^2+1)*(q^8-q^4+1)*(q^4+1)^2)*e2p(S(0)),
	(q^2*(q^2-1)*(q^4-q^2+1)*(q^4+1))*e2p(S(0)),
	(-q^2*(2*q^8-2*q^2+1-3*q^6+3*q^4))*e2p(S(0)),
	(q^2*(q^2-1)*(q^4+1))*e2p(S(0)),
	(q^2*(q^2-1)*(q^4+1))*e2p(S(0)),
	(-q^2*(2*q^4-2*q^2+1))*e2p(S(0)),
	(q^2*(q^2-1))*e2p(S(0)),
	(-q^2*(q^2+1))*e2p(S(0)),
	(q^2*(q^2-1))*e2p(S(0)),
	(q^2*(2*q^2-1))*e2p(S(0)),
	(-q^2)*e2p(S(0)),
	(-q^2)*e2p(S(0)),
	(-q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	((q^2-1))*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q^4-q^2+1)*(q^2+2*e2p(k*S(1//(3)))*q^2+2*e2p((-k)*S(1//(3)))*q^2-1-e2p((-k)*S(1//(3)))-e2p(k*S(1//(3)))),
	e2p(k*S(1//(3)))-3*e2p(k*S(1//(3)))*q^2+e2p((-k)*S(1//(3)))-3*e2p((-k)*S(1//(3)))*q^2+1-2*q^2,
	e2p(k*S(1//(3)))+e2p((-k)*S(1//(3)))+1,
	e2p(k*S(1//(3)))+e2p((-k)*S(1//(3)))+1,
	e2p(k*S(1//(3)))+e2p((-k)*S(1//(3)))+1,
	1-q^2+2*e2p((a*k)*S(1//(q^2+1)))+2*e2p((-a*k)*S(1//(q^2+1)))+e2p((a*k*(1+sqrt2*q))*S(1//(q^2+1)))+e2p((-a*k*(1+sqrt2*q))*S(1//(q^2+1)))-e2p((a*k*sqrt2*q)*S(1//(q^2+1)))*q^2-e2p((-a*k*sqrt2*q)*S(1//(q^2+1)))*q^2+e2p((a*k*sqrt2*q)*S(1//(q^2+1)))+e2p((-a*k*sqrt2*q)*S(1//(q^2+1)))-2*e2p((a*k)*S(1//(q^2+1)))*q^2-2*e2p((-a*k)*S(1//(q^2+1)))*q^2-e2p((2*a*k)*S(1//(q^2+1)))*q^2-e2p((-2*a*k)*S(1//(q^2+1)))*q^2-e2p((a*k*(1+sqrt2*q))*S(1//(q^2+1)))*q^2-e2p((-a*k*(1+sqrt2*q))*S(1//(q^2+1)))*q^2+e2p((a*k*(1-sqrt2*q))*S(1//(q^2+1)))+e2p((a*k*(sqrt2*q-1))*S(1//(q^2+1)))-e2p((a*k*(1-sqrt2*q))*S(1//(q^2+1)))*q^2-e2p((a*k*(sqrt2*q-1))*S(1//(q^2+1)))*q^2,
	1+2*e2p((a*k)*S(1//(q^2+1)))+2*e2p((-a*k)*S(1//(q^2+1)))+e2p((a*k*sqrt2*q)*S(1//(q^2+1)))+e2p((-a*k*sqrt2*q)*S(1//(q^2+1)))+e2p((a*k*(1-sqrt2*q))*S(1//(q^2+1)))+e2p((a*k*(sqrt2*q-1))*S(1//(q^2+1)))+e2p((a*k*(1+sqrt2*q))*S(1//(q^2+1)))+e2p((-a*k*(1+sqrt2*q))*S(1//(q^2+1))),
	-e2p((a*k)*S(1//(q^2+1)))-e2p((-a*k)*S(1//(q^2+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*k*b)*S(1//(q^2+1)))+e2p((-2*k*b)*S(1//(q^2+1)))+e2p((2*a*k)*S(1//(q^2+1)))+e2p((-2*a*k)*S(1//(q^2+1)))+e2p((k*sqrt2*q*(a-b))*S(1//(q^2+1)))+e2p((k*sqrt2*q*(b-a))*S(1//(q^2+1)))+e2p((k*sqrt2*q*(a+b))*S(1//(q^2+1)))+e2p((-k*sqrt2*q*(a+b))*S(1//(q^2+1)))+e2p((k*b+a*k*sqrt2*q-a*k)*S(1//(q^2+1)))+e2p((a*k-k*b-a*k*sqrt2*q)*S(1//(q^2+1)))+e2p((k*b+a*k*sqrt2*q+a*k)*S(1//(q^2+1)))+e2p((-k*b-a*k*sqrt2*q-a*k)*S(1//(q^2+1)))+e2p((k*b*sqrt2*q+k*b+a*k)*S(1//(q^2+1)))+e2p((-k*b*sqrt2*q-k*b-a*k)*S(1//(q^2+1)))+e2p((k*b+a*k-k*b*sqrt2*q)*S(1//(q^2+1)))+e2p((k*b*sqrt2*q-k*b-a*k)*S(1//(q^2+1)))+e2p((k*b-a*k*sqrt2*q-a*k)*S(1//(q^2+1)))+e2p((a*k*sqrt2*q+a*k-k*b)*S(1//(q^2+1)))+e2p((k*b-a*k+k*b*sqrt2*q)*S(1//(q^2+1)))+e2p((a*k-k*b*sqrt2*q-k*b)*S(1//(q^2+1)))+e2p((k*b-a*k*sqrt2*q+a*k)*S(1//(q^2+1)))+e2p((a*k*sqrt2*q-a*k-k*b)*S(1//(q^2+1)))+e2p((k*b-a*k-k*b*sqrt2*q)*S(1//(q^2+1)))+e2p((a*k+k*b*sqrt2*q-k*b)*S(1//(q^2+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q^2-1)*(q^2+1)*(q^4+1)^2*(q^4-q^2+1)*(q^8-q^4+1))*e2p(S(0)),
	((q^2-1)*(q^2+1)*(q^4+1)*(q^4-q^2+1))*e2p(S(0)),
	(-(q^10+q^4-q^2+1))*e2p(S(0)),
	((q^2-1)*(q^4+1))*e2p(S(0)),
	((q^2-1)*(q^4+1))*e2p(S(0)),
	(-q^4+q^2-1)*e2p(S(0)),
	(-q^4+q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2-1)*(e2p((a*k)*S(1//(q^2-1)))+e2p((-a*k)*S(1//(q^2-1)))),
	-e2p((a*k)*S(1//(q^2-1)))-e2p((-a*k)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-(q^2+1)*(q^4-q^2+1)*(e2p(k*S(1//(3)))+e2p((-k)*S(1//(3)))),
	-e2p(k*S(1//(3)))-e2p((-k)*S(1//(3))),
	-e2p(k*S(1//(3)))-e2p((-k)*S(1//(3))),
	-e2p(k*S(1//(3)))-e2p((-k)*S(1//(3))),
	-e2p(k*S(1//(3)))-e2p((-k)*S(1//(3))),
	-(q^2+1)*(e2p((a*k)*S(1//(q^2+1)))+e2p((-a*k)*S(1//(q^2+1)))),
	-e2p((a*k)*S(1//(q^2+1)))-e2p((-a*k)*S(1//(q^2+1))),
	-e2p((a*k)*S(1//(q^4-1)))-e2p((-a*k)*S(1//(q^4-1)))-e2p((a*k*q^2)*S(1//(q^4-1)))-e2p((-a*k*q^2)*S(1//(q^4-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q^2-1)*(q^2+1)^2*(q^2+sqrt2*q+1)*(q^4+1)*(q^4-q^2+1)*(q^8-q^4+1))*e2p(S(0)),
	(-(q^2+sqrt2*q+1)*(sqrt2*q^11-q^10+q^6-q^4+1))*e2p(S(0)),
	((q^2-1)*(q^2+1)*(q^6+q^2+sqrt2*q+1))*e2p(S(0)),
	(-q^6+q^4+sqrt2*q^3-q^2-sqrt2*q-1)*e2p(S(0)),
	(-q^6+q^4+sqrt2*q^3-q^2-sqrt2*q-1)*e2p(S(0)),
	(q^4-q^2-sqrt2*q-1)*e2p(S(0)),
	(q^4+sqrt2*q^3-q^2-sqrt2*q-1)*e2p(S(0)),
	(2*sqrt2*q^3-q^2-sqrt2*q-1)*e2p(S(0)),
	(-q^2-sqrt2*q-1)*e2p(S(0)),
	(-(q^2+1)*(sqrt2*q+1))*e2p(S(0)),
	(-q^2-sqrt2*q-1)*e2p(S(0)),
	(-q^2-sqrt2*q-1)*e2p(S(0)),
	(-q^2-sqrt2*q-1)*e2p(S(0)),
	(-sqrt2*q-1)*e2p(S(0)),
	(-sqrt2*q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q^2+sqrt2*q+1)*(q^2-1)*(e2p((a*k)*S(1//(q^2-1)))+e2p((-a*k)*S(1//(q^2-1)))),
	-(sqrt2*q+1)*(e2p((a*k)*S(1//(q^2-1)))+e2p((-a*k)*S(1//(q^2-1)))),
	-e2p((a*k)*S(1//(q^2-1)))-e2p((-a*k)*S(1//(q^2-1))),
	-e2p((a*k)*S(1//(q^2-1)))-e2p((-a*k)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q^4+1)*(e2p((a*k)*S(1//(q^2-sqrt2*q+1)))+e2p((-a*k)*S(1//(q^2-sqrt2*q+1)))+e2p((a*k*(sqrt2*q-1))*S(1//(q^2-sqrt2*q+1)))+e2p((-a*k*(sqrt2*q-1))*S(1//(q^2-sqrt2*q+1)))),
	-e2p((a*k)*S(1//(q^2-sqrt2*q+1)))-e2p((-a*k)*S(1//(q^2-sqrt2*q+1)))-e2p((a*k*(sqrt2*q-1))*S(1//(q^2-sqrt2*q+1)))-e2p((-a*k*(sqrt2*q-1))*S(1//(q^2-sqrt2*q+1))),
	-e2p((a*k)*S(1//(q^2-sqrt2*q+1)))-e2p((-a*k)*S(1//(q^2-sqrt2*q+1)))-e2p((a*k*(sqrt2*q-1))*S(1//(q^2-sqrt2*q+1)))-e2p((-a*k*(sqrt2*q-1))*S(1//(q^2-sqrt2*q+1))),
	-e2p((a*k)*S(1//(q^2-sqrt2*q+1)))-e2p((-a*k)*S(1//(q^2-sqrt2*q+1)))-e2p((a*k*(sqrt2*q-1))*S(1//(q^2-sqrt2*q+1)))-e2p((-a*k*(sqrt2*q-1))*S(1//(q^2-sqrt2*q+1))),
	-e2p((a*k)*S(1//((q^2-sqrt2*q+1)*(q^2-1))))-e2p((-a*k)*S(1//((q^2-sqrt2*q+1)*(q^2-1))))-e2p((a*k*q^2)*S(1//((q^2-sqrt2*q+1)*(q^2-1))))-e2p((-a*k*q^2)*S(1//((q^2-sqrt2*q+1)*(q^2-1))))-e2p((a*k*(sqrt2*q^3-sqrt2*q+1))*S(1//((q^2-sqrt2*q+1)*(q^2-1))))-e2p((-a*k*(sqrt2*q^3-sqrt2*q+1))*S(1//((q^2-sqrt2*q+1)*(q^2-1))))-e2p((a*k*(sqrt2*q^3-q^2-sqrt2*q+2))*S(1//((q^2-sqrt2*q+1)*(q^2-1))))-e2p((-a*k*(sqrt2*q^3-q^2-sqrt2*q+2))*S(1//((q^2-sqrt2*q+1)*(q^2-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q^2-1)*(q^2+1)^2*(q^2-sqrt2*q+1)*(q^4+1)*(q^4-q^2+1)*(q^8-q^4+1))*e2p(S(0)),
	(-(q^2-sqrt2*q+1)*(-sqrt2*q^11-q^10+q^6-q^4+1))*e2p(S(0)),
	((q^2-1)*(q^2+1)*(q^6+q^2-sqrt2*q+1))*e2p(S(0)),
	(-q^6+q^4-sqrt2*q^3-q^2+sqrt2*q-1)*e2p(S(0)),
	(-q^6+q^4-sqrt2*q^3-q^2+sqrt2*q-1)*e2p(S(0)),
	(q^4-q^2+sqrt2*q-1)*e2p(S(0)),
	(q^4-sqrt2*q^3-q^2+sqrt2*q-1)*e2p(S(0)),
	(-2*sqrt2*q^3-q^2+sqrt2*q-1)*e2p(S(0)),
	(-q^2+sqrt2*q-1)*e2p(S(0)),
	(-(q^2+1)*(-sqrt2*q+1))*e2p(S(0)),
	(-q^2+sqrt2*q-1)*e2p(S(0)),
	(-q^2+sqrt2*q-1)*e2p(S(0)),
	(-q^2+sqrt2*q-1)*e2p(S(0)),
	(sqrt2*q-1)*e2p(S(0)),
	(sqrt2*q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q^2-sqrt2*q+1)*(q^2-1)*(e2p((a*k)*S(1//(q^2-1)))+e2p((-a*k)*S(1//(q^2-1)))),
	(sqrt2*q-1)*(e2p((a*k)*S(1//(q^2-1)))+e2p((-a*k)*S(1//(q^2-1)))),
	-e2p((a*k)*S(1//(q^2-1)))-e2p((-a*k)*S(1//(q^2-1))),
	-e2p((a*k)*S(1//(q^2-1)))-e2p((-a*k)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q^4+1)*(e2p((a*k)*S(1//(q^2+sqrt2*q+1)))+e2p((-a*k)*S(1//(q^2+sqrt2*q+1)))+e2p((a*k*(sqrt2*q+1))*S(1//(q^2+sqrt2*q+1)))+e2p((-a*k*(sqrt2*q+1))*S(1//(q^2+sqrt2*q+1)))),
	-e2p((a*k)*S(1//(q^2+sqrt2*q+1)))-e2p((-a*k)*S(1//(q^2+sqrt2*q+1)))-e2p((a*k*(sqrt2*q+1))*S(1//(q^2+sqrt2*q+1)))-e2p((-a*k*(sqrt2*q+1))*S(1//(q^2+sqrt2*q+1))),
	-e2p((a*k)*S(1//(q^2+sqrt2*q+1)))-e2p((-a*k)*S(1//(q^2+sqrt2*q+1)))-e2p((a*k*(sqrt2*q+1))*S(1//(q^2+sqrt2*q+1)))-e2p((-a*k*(sqrt2*q+1))*S(1//(q^2+sqrt2*q+1))),
	-e2p((a*k)*S(1//(q^2+sqrt2*q+1)))-e2p((-a*k)*S(1//(q^2+sqrt2*q+1)))-e2p((a*k*(sqrt2*q+1))*S(1//(q^2+sqrt2*q+1)))-e2p((-a*k*(sqrt2*q+1))*S(1//(q^2+sqrt2*q+1))),
	-e2p((a*k)*S(1//((q^2+sqrt2*q+1)*(q^2-1))))-e2p((-a*k)*S(1//((q^2+sqrt2*q+1)*(q^2-1))))-e2p((a*k*q^2)*S(1//((q^2+sqrt2*q+1)*(q^2-1))))-e2p((-a*k*q^2)*S(1//((q^2+sqrt2*q+1)*(q^2-1))))-e2p((a*k*(sqrt2*q^3-sqrt2*q-1))*S(1//((q^2+sqrt2*q+1)*(q^2-1))))-e2p((-a*k*(sqrt2*q^3-sqrt2*q-1))*S(1//((q^2+sqrt2*q+1)*(q^2-1))))-e2p((a*k*(sqrt2*q^3+q^2-sqrt2*q-2))*S(1//((q^2+sqrt2*q+1)*(q^2-1))))-e2p((-a*k*(sqrt2*q^3+q^2-sqrt2*q-2))*S(1//((q^2+sqrt2*q+1)*(q^2-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q^2-1)^2*(q^2+1)^2*(q^4+1)*(q^4-q^2+1)*(q^8-q^4+1))*e2p(S(0)),
	((q^2-1)^2*(q^2+1)^2*(q^4-q^2+1))*e2p(S(0)),
	((q^2-1)*(q^2+1)*(-q^6+q^2-1))*e2p(S(0)),
	(2*q^8-q^6-q^4-q^2+1)*e2p(S(0)),
	(2*q^8-q^6-q^4-q^2+1)*e2p(S(0)),
	(2*q^6-q^4-q^2+1)*e2p(S(0)),
	(-q^4-q^2+1)*e2p(S(0)),
	(-2*q^4-q^2+1)*e2p(S(0)),
	(-2*q^4-q^2+1)*e2p(S(0)),
	(-2*q^4-q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q^2-sqrt2*q+1)*(q^2-1)*(e2p((a*k)*S(1//(q^2-sqrt2*q+1)))+e2p((-a*k)*S(1//(q^2-sqrt2*q+1)))+e2p((a*k*(1-q*sqrt2))*S(1//(q^2-sqrt2*q+1)))+e2p((-a*k*(1-q*sqrt2))*S(1//(q^2-sqrt2*q+1)))),
	-1//2*sqrt2*(2*q-sqrt2)*(e2p((a*k)*S(1//(q^2-sqrt2*q+1)))+e2p((-a*k)*S(1//(q^2-sqrt2*q+1)))+e2p((a*k*(1-q*sqrt2))*S(1//(q^2-sqrt2*q+1)))+e2p((a*k*(q*sqrt2-1))*S(1//(q^2-sqrt2*q+1)))),
	e2p((a*k)*S(1//(q^2-sqrt2*q+1)))+e2p((-a*k)*S(1//(q^2-sqrt2*q+1)))+e2p((a*k*(1-q*sqrt2))*S(1//(q^2-sqrt2*q+1)))+e2p((a*k*(q*sqrt2-1))*S(1//(q^2-sqrt2*q+1))),
	e2p((a*k)*S(1//(q^2-sqrt2*q+1)))+e2p((-a*k)*S(1//(q^2-sqrt2*q+1)))+e2p((a*k*(1-q*sqrt2))*S(1//(q^2-sqrt2*q+1)))+e2p((a*k*(q*sqrt2-1))*S(1//(q^2-sqrt2*q+1))),
	(0)*e2p(S(0)),
	-(q^2+sqrt2*q+1)*(q^2-1)*(e2p((a*l)*S(1//(q^2+sqrt2*q+1)))+e2p((-a*l)*S(1//(q^2+sqrt2*q+1)))+e2p((a*l*(1+q*sqrt2))*S(1//(q^2+sqrt2*q+1)))+e2p((-a*l*(q*sqrt2+1))*S(1//(q^2+sqrt2*q+1)))),
	1//2*sqrt2*(2*q+sqrt2)*(e2p((a*l)*S(1//(q^2+sqrt2*q+1)))+e2p((-a*l)*S(1//(q^2+sqrt2*q+1)))+e2p((a*l*(1+q*sqrt2))*S(1//(q^2+sqrt2*q+1)))+e2p((-a*l*(q*sqrt2+1))*S(1//(q^2+sqrt2*q+1)))),
	e2p((a*l)*S(1//(q^2+sqrt2*q+1)))+e2p((-a*l)*S(1//(q^2+sqrt2*q+1)))+e2p((a*l*(1+q*sqrt2))*S(1//(q^2+sqrt2*q+1)))+e2p((-a*l*(q*sqrt2+1))*S(1//(q^2+sqrt2*q+1))),
	e2p((a*l)*S(1//(q^2+sqrt2*q+1)))+e2p((-a*l)*S(1//(q^2+sqrt2*q+1)))+e2p((a*l*(1+q*sqrt2))*S(1//(q^2+sqrt2*q+1)))+e2p((-a*l*(q*sqrt2+1))*S(1//(q^2+sqrt2*q+1))),
	(0)*e2p(S(0)),
	(e2p((a*k)*S(1//(q^2-sqrt2*q+1)))+e2p((-a*k)*S(1//(q^2-sqrt2*q+1)))+e2p((a*k*(sqrt2*q-1))*S(1//(q^2-sqrt2*q+1)))+e2p((-a*k*(sqrt2*q-1))*S(1//(q^2-sqrt2*q+1))))*(e2p((b*l)*S(1//(q^2+sqrt2*q+1)))+e2p((-b*l)*S(1//(q^2+sqrt2*q+1)))+e2p((b*l*(sqrt2*q+1))*S(1//(q^2+sqrt2*q+1)))+e2p((-b*l*(sqrt2*q+1))*S(1//(q^2+sqrt2*q+1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q^2-1)^2*(q^4+1)^2*(q^4-q^2+1)*(q^8-q^4+1))*e2p(S(0)),
	((q^2-1)^2*(q^4+1)*(q^4-q^2+1))*e2p(S(0)),
	(-(q^2-1)*(3*q^8-3*q^6+3*q^4-2*q^2+1))*e2p(S(0)),
	((q^2-1)*(q^4+1)*(2*q^2-1))*e2p(S(0)),
	((q^2-1)*(q^4+1)*(2*q^2-1))*e2p(S(0)),
	(-4*q^6+5*q^4-3*q^2+1)*e2p(S(0)),
	(3*q^4-3*q^2+1)*e2p(S(0)),
	(-2*q^4-3*q^2+1)*e2p(S(0)),
	((q^2-1)*(2*q^2-1))*e2p(S(0)),
	(4*q^4-3*q^2+1)*e2p(S(0)),
	(-3*q^2+1)*e2p(S(0)),
	(-3*q^2+1)*e2p(S(0)),
	(-3*q^2+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q^2-1)*(q^4-q^2+1)*(e2p((k-l)*S(1//(3)))+e2p((k+l)*S(1//(3)))+e2p((l-k)*S(1//(3)))+e2p(l*S(1//(3)))+e2p((-l)*S(1//(3)))+e2p((-k)*S(1//(3)))+e2p((-k-l)*S(1//(3)))+e2p(k*S(1//(3)))),
	-(2*q^2-1)*(e2p((k-l)*S(1//(3)))+e2p((k+l)*S(1//(3)))+e2p((l-k)*S(1//(3)))+e2p(l*S(1//(3)))+e2p((-l)*S(1//(3)))+e2p((-k)*S(1//(3)))+e2p((-k-l)*S(1//(3)))+e2p(k*S(1//(3)))),
	e2p((k-l)*S(1//(3)))+e2p((k+l)*S(1//(3)))+e2p((l-k)*S(1//(3)))+e2p(l*S(1//(3)))+e2p((-l)*S(1//(3)))+e2p((-k)*S(1//(3)))+e2p((-k-l)*S(1//(3)))+e2p(k*S(1//(3))),
	e2p((k-l)*S(1//(3)))+e2p((k+l)*S(1//(3)))+e2p((l-k)*S(1//(3)))+e2p(l*S(1//(3)))+e2p((-l)*S(1//(3)))+e2p((-k)*S(1//(3)))+e2p((-k-l)*S(1//(3)))+e2p(k*S(1//(3))),
	e2p((k-l)*S(1//(3)))+e2p((k+l)*S(1//(3)))+e2p((l-k)*S(1//(3)))+e2p(l*S(1//(3)))+e2p((-l)*S(1//(3)))+e2p((-k)*S(1//(3)))+e2p((-k-l)*S(1//(3)))+e2p(k*S(1//(3))),
	(-q^2+1)*(e2p((a*k+a*l)*S(1//(q^2+1)))+e2p((-a*k-a*l)*S(1//(q^2+1)))+e2p(((a+sqrt2*q*a*1//2)*k+sqrt2*q*a*1//2*l)*S(1//(q^2+1)))+e2p(((a-sqrt2*q*a*1//2)*k-sqrt2*q*a*1//2*l)*S(1//(q^2+1)))+e2p((a*k-a*l)*S(1//(q^2+1)))+e2p((-a*k+a*l)*S(1//(q^2+1)))+e2p(((a+sqrt2*q*a*1//2)*k-sqrt2*q*a*1//2*l)*S(1//(q^2+1)))+e2p(((a-sqrt2*q*a*1//2)*k+sqrt2*q*a*1//2*l)*S(1//(q^2+1)))+e2p((-sqrt2*q*a*1//2*k+(a+sqrt2*q*a*1//2)*l)*S(1//(q^2+1)))+e2p((sqrt2*q*a*1//2*k+(a+sqrt2*q*a*1//2)*l)*S(1//(q^2+1)))+e2p((sqrt2*q*a*1//2*k+(a-sqrt2*q*a*1//2)*l)*S(1//(q^2+1)))+e2p((-sqrt2*q*a*1//2*k+(a-sqrt2*q*a*1//2)*l)*S(1//(q^2+1)))+e2p((sqrt2*q*a*k)*S(1//(q^2+1)))+e2p((-sqrt2*q*a*k)*S(1//(q^2+1)))+e2p(((sqrt2*q*a*1//2)*k+(-a+sqrt2*q*a*1//2)*l)*S(1//(q^2+1)))+e2p(((-sqrt2*q*a*1//2)*k+(-a+sqrt2*q*a*1//2)*l)*S(1//(q^2+1)))+e2p((sqrt2*q*a*l)*S(1//(q^2+1)))+e2p((-sqrt2*q*a*l)*S(1//(q^2+1)))+e2p(((sqrt2*q*a*1//2)*k+(-a-sqrt2*q*a*1//2)*l)*S(1//(q^2+1)))+e2p(((-sqrt2*q*a*1//2)*k+(-a-sqrt2*q*a*1//2)*l)*S(1//(q^2+1)))+e2p(((-a+sqrt2*q*a*1//2)*k+sqrt2*q*a*1//2*l)*S(1//(q^2+1)))+e2p(((-a-sqrt2*q*a*1//2)*k-sqrt2*q*a*1//2*l)*S(1//(q^2+1)))+e2p(((-a-sqrt2*q*a*1//2)*k+sqrt2*q*a*1//2*l)*S(1//(q^2+1)))+e2p(((-a+sqrt2*q*a*1//2)*k-sqrt2*q*a*1//2*l)*S(1//(q^2+1)))),
	e2p((a*k+a*l)*S(1//(q^2+1)))+e2p((-a*k-a*l)*S(1//(q^2+1)))+e2p(((a+sqrt2*q*a*1//2)*k+sqrt2*q*a*1//2*l)*S(1//(q^2+1)))+e2p(((a-sqrt2*q*a*1//2)*k-sqrt2*q*a*1//2*l)*S(1//(q^2+1)))+e2p((a*k-a*l)*S(1//(q^2+1)))+e2p((-a*k+a*l)*S(1//(q^2+1)))+e2p(((a+sqrt2*q*a*1//2)*k-sqrt2*q*a*1//2*l)*S(1//(q^2+1)))+e2p(((a-sqrt2*q*a*1//2)*k+sqrt2*q*a*1//2*l)*S(1//(q^2+1)))+e2p((-sqrt2*q*a*1//2*k+(a+sqrt2*q*a*1//2)*l)*S(1//(q^2+1)))+e2p((sqrt2*q*a*1//2*k+(a+sqrt2*q*a*1//2)*l)*S(1//(q^2+1)))+e2p((sqrt2*q*a*1//2*k+(a-sqrt2*q*a*1//2)*l)*S(1//(q^2+1)))+e2p((-sqrt2*q*a*1//2*k+(a-sqrt2*q*a*1//2)*l)*S(1//(q^2+1)))+e2p((sqrt2*q*a*k)*S(1//(q^2+1)))+e2p((-sqrt2*q*a*k)*S(1//(q^2+1)))+e2p(((sqrt2*q*a*1//2)*k+(-a+sqrt2*q*a*1//2)*l)*S(1//(q^2+1)))+e2p(((-sqrt2*q*a*1//2)*k+(-a+sqrt2*q*a*1//2)*l)*S(1//(q^2+1)))+e2p((sqrt2*q*a*l)*S(1//(q^2+1)))+e2p((-sqrt2*q*a*l)*S(1//(q^2+1)))+e2p(((sqrt2*q*a*1//2)*k+(-a-sqrt2*q*a*1//2)*l)*S(1//(q^2+1)))+e2p(((-sqrt2*q*a*1//2)*k+(-a-sqrt2*q*a*1//2)*l)*S(1//(q^2+1)))+e2p(((-a+sqrt2*q*a*1//2)*k+sqrt2*q*a*1//2*l)*S(1//(q^2+1)))+e2p(((-a-sqrt2*q*a*1//2)*k-sqrt2*q*a*1//2*l)*S(1//(q^2+1)))+e2p(((-a-sqrt2*q*a*1//2)*k+sqrt2*q*a*1//2*l)*S(1//(q^2+1)))+e2p(((-a+sqrt2*q*a*1//2)*k-sqrt2*q*a*1//2*l)*S(1//(q^2+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p(((a+b)*k+(a-b)*l)*S(1//(q^2+1)))+e2p(((a+b)*k+(-a+b)*l)*S(1//(q^2+1)))+e2p(((-(a+b)*q*1//sqrt2+a)*k+((-a+b)*q*1//sqrt2+b)*l)*S(1//(q^2+1)))+e2p((((a+b)*q*1//sqrt2+a)*k+((a-b)*q*1//sqrt2+b)*l)*S(1//(q^2+1)))+e2p((((a+b)*q*1//sqrt2+a)*k+((-a+b)*q*1//sqrt2-b)*l)*S(1//(q^2+1)))+e2p((((a-b)*q*1//sqrt2+a)*k+(-(a+b)*q*1//sqrt2+b)*l)*S(1//(q^2+1)))+e2p((((-a+b)*q*1//sqrt2+a)*k+((a+b)*q*1//sqrt2+b)*l)*S(1//(q^2+1)))+e2p(((a-b)*k+(a+b)*l)*S(1//(q^2+1)))+e2p(((a-b)*k+(-a-b)*l)*S(1//(q^2+1)))+e2p((((-a+b)*q*1//sqrt2+a)*k+(-(a+b)*q*1//sqrt2-b)*l)*S(1//(q^2+1)))+e2p(((-(a+b)*q*1//sqrt2+b)*k+((a-b)*q*1//sqrt2+a)*l)*S(1//(q^2+1)))+e2p((((a-b)*q*1//sqrt2+b)*k+((a+b)*q*1//sqrt2+a)*l)*S(1//(q^2+1)))+e2p((((a-b)*q*1//sqrt2+a)*k+((a+b)*q*1//sqrt2-b)*l)*S(1//(q^2+1)))+e2p(((-(a+b)*q*1//sqrt2+a)*k+((a-b)*q*1//sqrt2-b)*l)*S(1//(q^2+1)))+e2p((((a+b)*q*1//sqrt2+b)*k+((-a+b)*q*1//sqrt2+a)*l)*S(1//(q^2+1)))+e2p((((-a+b)*q*1//sqrt2+b)*k+(-(a+b)*q*1//sqrt2+a)*l)*S(1//(q^2+1)))+e2p(((sqrt2*q*a)*k+(sqrt2*q*b)*l)*S(1//(q^2+1)))+e2p(((-sqrt2*q*a)*k+(-sqrt2*q*b)*l)*S(1//(q^2+1)))+e2p((((a+b)*q*1//sqrt2+b)*k+((a-b)*q*1//sqrt2-a)*l)*S(1//(q^2+1)))+e2p((((-a+b)*q*1//sqrt2+b)*k+((a+b)*q*1//sqrt2-a)*l)*S(1//(q^2+1)))+e2p(((sqrt2*q*b)*k+(sqrt2*q*a)*l)*S(1//(q^2+1)))+e2p(((sqrt2*q*a)*k+(-sqrt2*q*b)*l)*S(1//(q^2+1)))+e2p((((a-b)*q*1//sqrt2+b)*k+(-(a+b)*q*1//sqrt2-a)*l)*S(1//(q^2+1)))+e2p(((-(a+b)*q*1//sqrt2+b)*k+((-a+b)*q*1//sqrt2-a)*l)*S(1//(q^2+1)))+e2p(((sqrt2*q*b)*k+(-sqrt2*q*a)*l)*S(1//(q^2+1)))+e2p((((a+b)*q*1//sqrt2-b)*k+((a-b)*q*1//sqrt2+a)*l)*S(1//(q^2+1)))+e2p((((a-b)*q*1//sqrt2-b)*k+(-(a+b)*q*1//sqrt2+a)*l)*S(1//(q^2+1)))+e2p(((-a+b)*k+(a+b)*l)*S(1//(q^2+1)))+e2p(((-sqrt2*q*b)*k+(-sqrt2*q*a)*l)*S(1//(q^2+1)))+e2p(((-(a+b)*q*1//sqrt2-b)*k+((-a+b)*q*1//sqrt2+a)*l)*S(1//(q^2+1)))+e2p(((-sqrt2*q*a)*k+(sqrt2*q*b)*l)*S(1//(q^2+1)))+e2p((((-a+b)*q*1//sqrt2-b)*k+((a+b)*q*1//sqrt2+a)*l)*S(1//(q^2+1)))+e2p(((-sqrt2*q*b)*k+(sqrt2*q*a)*l)*S(1//(q^2+1)))+e2p((((a+b)*q*1//sqrt2-b)*k+((-a+b)*q*1//sqrt2-a)*l)*S(1//(q^2+1)))+e2p((((-a+b)*q*1//sqrt2-b)*k+(-(a+b)*q*1//sqrt2-a)*l)*S(1//(q^2+1)))+e2p((((a+b)*q*1//sqrt2-a)*k+((a-b)*q*1//sqrt2-b)*l)*S(1//(q^2+1)))+e2p((((a-b)*q*1//sqrt2-a)*k+((a+b)*q*1//sqrt2+b)*l)*S(1//(q^2+1)))+e2p(((-(a+b)*q*1//sqrt2-a)*k+((-a+b)*q*1//sqrt2-b)*l)*S(1//(q^2+1)))+e2p(((-(a+b)*q*1//sqrt2-a)*k+((a-b)*q*1//sqrt2+b)*l)*S(1//(q^2+1)))+e2p(((-a+b)*k+(-a-b)*l)*S(1//(q^2+1)))+e2p((((a-b)*q*1//sqrt2-b)*k+((a+b)*q*1//sqrt2-a)*l)*S(1//(q^2+1)))+e2p(((-(a+b)*q*1//sqrt2-b)*k+((a-b)*q*1//sqrt2-a)*l)*S(1//(q^2+1)))+e2p((((a+b)*q*1//sqrt2-a)*k+((-a+b)*q*1//sqrt2+b)*l)*S(1//(q^2+1)))+e2p((((a-b)*q*1//sqrt2-a)*k+(-(a+b)*q*1//sqrt2-b)*l)*S(1//(q^2+1)))+e2p((((-a+b)*q*1//sqrt2-a)*k+(-(a+b)*q*1//sqrt2+b)*l)*S(1//(q^2+1)))+e2p(((-a-b)*k+(a-b)*l)*S(1//(q^2+1)))+e2p((((-a+b)*q*1//sqrt2-a)*k+((a+b)*q*1//sqrt2-b)*l)*S(1//(q^2+1)))+e2p(((-a-b)*k+(-a+b)*l)*S(1//(q^2+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q^2-1)^2*(q^2+1)^2*(q^4+1)^2*(q^8-q^4+1))*e2p(S(0)),
	((q^2-1)^2*(q^2+1)^2*(q^4+1))*e2p(S(0)),
	(-(q^2-1)*(q^2+1))*e2p(S(0)),
	(-(q^2-1)*(q^2+1)*(q^4+1))*e2p(S(0)),
	(-(q^2-1)*(q^2+1)*(q^4+1))*e2p(S(0)),
	(-q^6-q^4+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^4+1)*e2p(S(0)),
	(-(q^2-1)*(q^2+1))*e2p(S(0)),
	(-2*q^4+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q^2-1)*(q^2+1)^2*(e2p(k*S(1//(3)))+e2p((-k)*S(1//(3)))),
	(q^2+1)*(e2p(k*S(1//(3)))+e2p((-k)*S(1//(3)))),
	e2p(k*S(1//(3)))+e2p((-k)*S(1//(3))),
	e2p(k*S(1//(3)))+e2p((-k)*S(1//(3))),
	e2p(k*S(1//(3)))+e2p((-k)*S(1//(3))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((a*k)*S(1//(q^4-q^2+1)))+e2p((-a*k)*S(1//(q^4-q^2+1)))+e2p((a*k*q^2)*S(1//(q^4-q^2+1)))+e2p((-a*k*q^2)*S(1//(q^4-q^2+1)))+e2p((a*k*(q^2-1))*S(1//(q^4-q^2+1)))+e2p((a*k*(1-q^2))*S(1//(q^4-q^2+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	((q^2+1)^2*(q^2-1)^2*(q^4+1)^2*(q^4-q^2+1)*(q^4+sqrt2*q^3+q^2+sqrt2*q+1))*e2p(S(0)),
	(-1//2*(q^2-1)*(q^4+1)*(2*q^7+q^6*sqrt2+sqrt2*q^4+2*q^3+sqrt2*q^2+2*q+sqrt2)*sqrt2)*e2p(S(0)),
	((q^2+1)*(q^2-1)*(-sqrt2*q^5-2*q^4-sqrt2*q-1))*e2p(S(0)),
	(-(q^2+sqrt2*q+1)^2*(q^2-1)*(q^2-sqrt2*q+1))*e2p(S(0)),
	(-(q^2+sqrt2*q+1)^2*(q^2-1)*(q^2-sqrt2*q+1))*e2p(S(0)),
	(q^6+q^5*sqrt2+q^4+sqrt2*q+1)*e2p(S(0)),
	(sqrt2*q^5-sqrt2*q^3+sqrt2*q+1)*e2p(S(0)),
	(-q^4-2*sqrt2*q^3+sqrt2*q+1)*e2p(S(0)),
	(q^4+sqrt2*q+1)*e2p(S(0)),
	(2*q^4+sqrt2*q+sqrt2*q^3+1)*e2p(S(0)),
	(sqrt2*q+1)*e2p(S(0)),
	(sqrt2*q+1)*e2p(S(0)),
	(sqrt2*q+1)*e2p(S(0)),
	(sqrt2*q+1)*e2p(S(0)),
	(sqrt2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((a*k)*S(1//(q^4-sqrt2*q^3+q^2-sqrt2*q+1)))+e2p((-a*k)*S(1//(q^4-sqrt2*q^3+q^2-sqrt2*q+1)))+e2p((a*k*q^2)*S(1//(q^4-sqrt2*q^3+q^2-sqrt2*q+1)))+e2p((-a*k*q^2)*S(1//(q^4-sqrt2*q^3+q^2-sqrt2*q+1)))+e2p((a*k*(sqrt2*q^3-1))*S(1//(q^4-sqrt2*q^3+q^2-sqrt2*q+1)))+e2p((-a*k*(sqrt2*q^3-1))*S(1//(q^4-sqrt2*q^3+q^2-sqrt2*q+1)))+e2p((a*k*(sqrt2*q^3-q^2-1))*S(1//(q^4-sqrt2*q^3+q^2-sqrt2*q+1)))+e2p((-a*k*(sqrt2*q^3-q^2-1))*S(1//(q^4-sqrt2*q^3+q^2-sqrt2*q+1)))+e2p((a*k*(sqrt2*q^3-q^2+sqrt2*q-1))*S(1//(q^4-sqrt2*q^3+q^2-sqrt2*q+1)))+e2p((-a*k*(sqrt2*q^3-q^2+sqrt2*q-1))*S(1//(q^4-sqrt2*q^3+q^2-sqrt2*q+1)))+e2p((a*k*(sqrt2*q^3-q^2+sqrt2*q-2))*S(1//(q^4-sqrt2*q^3+q^2-sqrt2*q+1)))+e2p((a*k*(2-sqrt2*q^3+q^2-sqrt2*q))*S(1//(q^4-sqrt2*q^3+q^2-sqrt2*q+1))),
	(0)*e2p(S(0))] [
	((q^2+1)^2*(q^2-1)^2*(q^4+1)^2*(q^4-q^2+1)*(q^4-sqrt2*q^3+q^2-sqrt2*q+1))*e2p(S(0)),
	(1//2*(q^2-1)*(q^4+1)*(2*q^7-q^6*sqrt2-sqrt2*q^4+2*q^3-sqrt2*q^2+2*q-sqrt2)*sqrt2)*e2p(S(0)),
	((q^2+1)*(q^2-1)*(sqrt2*q^5-2*q^4+sqrt2*q-1))*e2p(S(0)),
	(-(q^2-sqrt2*q+1)^2*(q^2-1)*(q^2+sqrt2*q+1))*e2p(S(0)),
	(-(q^2-sqrt2*q+1)^2*(q^2-1)*(q^2+sqrt2*q+1))*e2p(S(0)),
	(q^6-q^5*sqrt2+q^4-sqrt2*q+1)*e2p(S(0)),
	(-sqrt2*q^5+sqrt2*q^3-sqrt2*q+1)*e2p(S(0)),
	(-q^4+2*sqrt2*q^3-sqrt2*q+1)*e2p(S(0)),
	(q^4-sqrt2*q+1)*e2p(S(0)),
	(2*q^4-sqrt2*q-sqrt2*q^3+1)*e2p(S(0)),
	(-sqrt2*q+1)*e2p(S(0)),
	(-sqrt2*q+1)*e2p(S(0)),
	(-sqrt2*q+1)*e2p(S(0)),
	(-sqrt2*q+1)*e2p(S(0)),
	(-sqrt2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((a*k)*S(1//(q^4+sqrt2*q^3+q^2+sqrt2*q+1)))+e2p((-a*k)*S(1//(q^4+sqrt2*q^3+q^2+sqrt2*q+1)))+e2p((a*k*q^2)*S(1//(q^4+sqrt2*q^3+q^2+sqrt2*q+1)))+e2p((-a*k*q^2)*S(1//(q^4+sqrt2*q^3+q^2+sqrt2*q+1)))+e2p((a*k*(sqrt2*q^3+1))*S(1//(q^4+sqrt2*q^3+q^2+sqrt2*q+1)))+e2p((-a*k*(sqrt2*q^3+1))*S(1//(q^4+sqrt2*q^3+q^2+sqrt2*q+1)))+e2p((a*k*(sqrt2*q^3+q^2+1))*S(1//(q^4+sqrt2*q^3+q^2+sqrt2*q+1)))+e2p((-a*k*(sqrt2*q^3+q^2+1))*S(1//(q^4+sqrt2*q^3+q^2+sqrt2*q+1)))+e2p((a*k*(sqrt2*q^3+q^2+sqrt2*q+1))*S(1//(q^4+sqrt2*q^3+q^2+sqrt2*q+1)))+e2p((-a*k*(sqrt2*q^3+q^2+sqrt2*q+1))*S(1//(q^4+sqrt2*q^3+q^2+sqrt2*q+1)))+e2p((a*k*(sqrt2*q^3+q^2+sqrt2*q+2))*S(1//(q^4+sqrt2*q^3+q^2+sqrt2*q+1)))+e2p((-a*k*(sqrt2*q^3+q^2+sqrt2*q+2))*S(1//(q^4+sqrt2*q^3+q^2+sqrt2*q+1)))]]
classinfo = Vector{Any}[
	["",[1,0],["^2F_4","u_0"]],
	["",[1,1],["^2F_4","u_1"]],
	["",[1,2],["^2F_4","u_2"]],
	["",[1,3],["^2F_4","u_3"]],
	["",[1,4],["^2F_4","u_4"]],
	["",[1,5],["^2F_4","u_5"]],
	["",[1,6],["^2F_4","u_6"]],
	["",[1,7],["^2F_4","u_7"]],
	["",[1,8],["^2F_4","u_8"]],
	["",[1,9],["^2F_4","u_9"]],
	["",[1,10],["^2F_4","u_{10}"]],
	["",[1,11],["^2F_4","u_{11}"]],
	["",[1,12],["^2F_4","u_{12}"]],
	["",[1,13],["^2F_4","u_{13}"]],
	["",[1,14],["^2F_4","u_{14}"]],
	["",[1,15],["^2F_4","u_{15}"]],
	["",[1,16],["^2F_4","u_{16}"]],
	["",[1,17],["^2F_4","u_{17}"]],
	["",[1,18],["^2F_4","u_{18}"]],
	["",[2,0],["^2B_2","u_0"],"t_1,1"],
	["",[2,1],["^2B_2","u_1"],"t_1,u_1"],
	["",[2,2],["^2B_2","u_2"],"t_1,u_2"],
	["",[2,3],["^2B_2","u_3"],"t_1,u_3"],
	["",[3,0],["A_1",[2]],"t_2,1"],
	["",[3,1],["A_1",[1,1]],"t_2,u"],
	["",[4,0],["A_0",[1]],"t_3,1"],
	["",[5,0],["^2A_2","u_0"],"t_4,1"],
	["",[5,1],["^2A_2","u_1"],"t_4,u_1"],
	["",[5,2],["^2A_2","u_2"],"t_4,u_2"],
	["",[5,3],["^2A_2","u_3"],"t_4,u_3"],
	["",[5,4],["^2A_2","u_4"],"t_4,u_4"],
	["",[6,0],["A_1",[2]],"t_5,1"],
	["",[6,1],["A_1",[1,1]],"t_5,u"],
	["",[7,0],["A_0",[1]],"t_6,1"],
	["",[8,0],["^2B_2","u_0"],"t_7,1"],
	["",[8,1],["^2B_2","u_1"],"t_7,u_1"],
	["",[8,2],["^2B_2","u_2"],"t_7,u_2"],
	["",[8,3],["^2B_2","u_3"],"t_7,u_3"],
	["",[9,0],["A_0",[1]],"t_8,1"],
	["",[10,0],["^2B_2","u_0"],"t_9,1"],
	["",[10,1],["^2B_2","u_1"],"t_9,u_1"],
	["",[10,2],["^2B_2","u_2"],"t_9,u_2"],
	["",[10,3],["^2B_2","u_3"],"t_9,u_3"],
	["",[11,0],["A_0",[1]],"t_{10},1"],
	["",[12,0],["A_0",[1]],"t_{11},1"],
	["",[13,0],["A_0",[1]],"t_{12},1"],
	["",[14,0],["A_0",[1]],"t_{13},1"],
	["",[15,0],["A_0",[1]],"t_{14},1"],
	["",[16,0],["A_0",[1]],"t_{15},1"],
	["",[17,0],["A_0",[1]],"t_{16},1"],
	["",[18,0],["A_0",[1]],"t_{17},1"]]
classlength = R.([
	1,
	(q^4-q^2+1)*(q^4+1)*(q^8-q^4+1)*(q^2-1)*(q^2+1)^2,
	q^4*(q^2+1)*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)*(q^4+1)^2,
	1//2*q^10*(q^4-q^2+1)*(q^4+1)*(q^8-q^4+1)*(q^2-1)*(q^2+1)^2,
	1//2*q^10*(q^4-q^2+1)*(q^4+1)*(q^8-q^4+1)*(q^2-1)*(q^2+1)^2,
	q^8*(q^4-q^2+1)*(q^8-q^4+1)*(q-1)^2*(q+1)^2*(q^2+1)^2*(q^4+1)^2,
	q^10*(q^4-q^2+1)*(q^8-q^4+1)*(q-1)^2*(q+1)^2*(q^2+1)^2*(q^4+1)^2,
	1//6*q^12*(q^4-q^2+1)*(q^8-q^4+1)*(q-1)^2*(q+1)^2*(q^2+1)^2*(q^4+1)^2,
	1//2*q^12*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^4+1)^2,
	1//3*q^12*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^4+1)^2,
	1//2*q^16*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^4+1)^2,
	1//4*q^16*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^4+1)^2,
	1//4*q^16*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^4+1)^2,
	1//2*q^18*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^4+1)^2,
	1//2*q^18*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^4+1)^2,
	1//4*q^20*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^4+1)^2,
	1//4*q^20*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^4+1)^2,
	1//4*q^20*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^4+1)^2,
	1//4*q^20*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^4+1)^2,
	q^20*(q^4-q^2+1)*(q^4+1)*(q^8-q^4+1)*(q^2+1)^2,
	q^20*(q^4-q^2+1)*(q^8-q^4+1)*(q-1)*(q+1)*(q^2+1)^2*(q^4+1)^2,
	1//2*q^22*(q^4-q^2+1)*(q^8-q^4+1)*(q-1)*(q+1)*(q^2+1)^2*(q^4+1)^2,
	1//2*q^22*(q^4-q^2+1)*(q^8-q^4+1)*(q-1)*(q+1)*(q^2+1)^2*(q^4+1)^2,
	q^22*(q^2+1)*(q^4-q^2+1)*(q^8-q^4+1)*(q^4+1)^2,
	q^22*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)*(q^2+1)^2*(q^4+1)^2,
	q^24*(q^4-q^2+1)*(q^8-q^4+1)*(q^2+1)^2*(q^4+1)^2,
	q^18*(q^8-q^4+1)*(q-1)*(q+1)*(q^4+1)^2,
	q^18*(q^2+1)*(q^4-q^2+1)*(q^8-q^4+1)*(q-1)^2*(q+1)^2*(q^4+1)^2,
	1//3*q^20*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^4+1)^2,
	1//3*q^20*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^4+1)^2,
	1//3*q^20*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^4+1)^2,
	q^22*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)*(q^4+1)^2,
	q^22*(q^2+1)*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)^2*(q^4+1)^2,
	q^24*(q^2+1)*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)*(q^4+1)^2,
	q^20*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)*(q^2+1)^2*(q^2+sqrt2*q+1),
	q^20*(q^4-q^2+1)*(q^4+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^2+sqrt2*q+1),
	1//2*q^22*(q^4-q^2+1)*(q^4+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^2+sqrt2*q+1),
	1//2*q^22*(q^4-q^2+1)*(q^4+1)*(q^8-q^4+1)*(q-1)^2*(q+1)^2*(q^2+1)^2*(q^2+sqrt2*q+1),
	q^24*(q^4-q^2+1)*(q^4+1)*(q^8-q^4+1)*(q^2-1)*(q^2+1)^2*(q^2+sqrt2*q+1),
	q^20*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)*(q^2+1)^2*(q^2-sqrt2*q+1),
	q^20*(q^4+1)*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^2-sqrt2*q+1),
	1//2*q^22*(q^4-q^2+1)*(q^4+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^2-sqrt2*q+1),
	1//2*q^22*(q^4-q^2+1)*(q^4+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^2-sqrt2*q+1),
	q^24*(q^4-q^2+1)*(q^4+1)*(q^8-q^4+1)*(q^2-1)*(q^2+1)^2*(q^2-sqrt2*q+1),
	q^24*(q^4-q^2+1)*(q^4+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2,
	q^24*(q^4-q^2+1)*(q^8-q^4+1)*(q-1)^2*(q+1)^2*(q^2+1)^2*(q^4+2*sqrt2*q^3+4*q^2+2*sqrt2*q+1),
	q^24*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^4-2*sqrt2*q^3+4*q^2-2*sqrt2*q+1),
	q^24*(q^4-q^2+1)*(q^8-q^4+1)*(q^2-1)^2*(q^4+1)^2,
	q^24*(q^8-q^4+1)*(q^2-1)^2*(q^2+1)^2*(q^4+1)^2,
	q^24*(q^4-q^2+1)*(q^2-1)^2*(q^2+1)^2*(q^4+1)^2*(q^4+sqrt2*q^3+q^2+sqrt2*q+1),
	q^24*(q^4-q^2+1)*(q^2-1)^2*(q^2+1)^2*(q^4+1)^2*(q^4-sqrt2*q^3+q^2-sqrt2*q+1)])
charinfo = Vector{Any}[
	["",[1,0],["^2F_4","1"]],
	["",[1,1],["^2F_4","^2B_2[a],1"]],
	["",[1,2],["^2F_4","^2B_2[b],1"]],
	["",[1,3],["^2F_4","\\epsilon'"]],
	["",[1,4],["^2F_4","\\rho_2'"]],
	["",[1,5],["^2F_4","\\rho_2''"]],
	["",[1,6],["^2F_4","\\rho_2"]],
	["",[1,7],["^2F_4","\\chi_8"]],
	["",[1,8],["^2F_4","\\chi_9"]],
	["",[1,9],["^2F_4","\\chi_{10}"]],
	["",[1,10],["^2F_4","\\chi_{11}"]],
	["",[1,11],["^2F_4","\\chi_{12}"]],
	["",[1,12],["^2F_4","\\chi_{13}"]],
	["",[1,13],["^2F_4","\\chi_{14}"]],
	["",[1,14],["^2F_4","\\chi_{15}"]],
	["",[1,15],["^2F_4","\\chi_{16}"]],
	["",[1,16],["^2F_4","\\chi_{17}"]],
	["",[1,17],["^2F_4","\\epsilon''"]],
	["",[1,18],["^2F_4","^2B_2[a],\\epsilon"]],
	["",[1,19],["^2F_4","^2B_2[b],\\epsilon"]],
	["",[1,20],["^2F_4","\\epsilon"]],
	["",[2,0],["^2B_2","1"]],
	["",[2,1],["^2B_2","^2B_2[a]"]],
	["",[2,2],["^2B_2","^2B_2[b]"]],
	["",[2,3],["^2B_2","\\epsilon"]],
	["",[3,0],["A_1",[2]]],
	["",[3,1],["A_1",[1,1]]],
	["",[4,0],["A_0",[1]]],
	["",[5,0],["^2A_2",[3]]],
	["",[5,1],["^2A_2",[2,1]]],
	["",[5,2],["^2A_2",[1,1,1]]],
	["",[6,0],["A_1",[2]]],
	["",[6,1],["A_1",[1,1]]],
	["",[7,0],["A_0",[1]]],
	["",[9,0],["A_0",[1]]],
	["",[11,0],["A_0",[1]]],
	["",[12,0],["A_0",[1]]],
	["",[15,0],["A_0",[1]]],
	["",[16,0],["A_0",[1]]],
	["",[17,0],["A_0",[1]]],
	["",[18,0],["A_0",[1]]]]
chardegree = R.([
	1,
	1//2*(q^2-1)*(q^2+1)^2*(q^4-q^2+1)*sqrt2*q,
	1//2*(q^2-1)*(q^2+1)^2*(q^4-q^2+1)*sqrt2*q,
	(q^4-q^2+1)*(q^8-q^4+1)*q^2,
	q^4*1//4*(q^2+1)^2*(q^2-sqrt2*q+1)^2*(q^4-q^2+1)*(q^4+sqrt2*q^3+q^2+sqrt2*q+1),
	q^4*1//4*(q^2+1)^2*(q^2+sqrt2*q+1)^2*(q^4-q^2+1)*(q^4-sqrt2*q^3+q^2-sqrt2*q+1),
	1//2*(q^4+1)^2*(q^8-q^4+1)*q^4,
	q^4*1//12*(q^2-1)^2*(q^2+sqrt2*q+1)^2*(q^4-q^2+1)*(q^4+sqrt2*q^3+q^2+sqrt2*q+1),
	q^4*1//12*(q^2-1)^2*(q^2-sqrt2*q+1)^2*(q^4-q^2+1)*(q^4-sqrt2*q^3+q^2-sqrt2*q+1),
	1//6*(q^4-1)^2*(q^8-q^4+1)*q^4,
	1//4*(q^4-1)^2*(q^4-q^2+1)*(q^4-sqrt2*q^3+q^2-sqrt2*q+1)*q^4,
	1//4*(q^4-1)^2*(q^4-q^2+1)*(q^4-sqrt2*q^3+q^2-sqrt2*q+1)*q^4,
	1//4*(q^4-1)^2*(q^4-q^2+1)*(q^4+sqrt2*q^3+q^2+sqrt2*q+1)*q^4,
	1//4*(q^4-1)^2*(q^4-q^2+1)*(q^4+sqrt2*q^3+q^2+sqrt2*q+1)*q^4,
	1//3*(q^8-1)^2*q^4,
	1//3*(q^8-1)^2*q^4,
	1//3*(q^2-1)^2*(q^4-q^2+1)*(q^8-q^4+1)*q^4,
	(q^4-q^2+1)*(q^8-q^4+1)*q^10,
	1//2*(q^2-1)*(q^2+1)^2*(q^4-q^2+1)*sqrt2*q^13,
	1//2*(q^2-1)*(q^2+1)^2*(q^4-q^2+1)*sqrt2*q^13,
	q^24,
	(q^4-q^2+1)*(q^4+1)*(q^8-q^4+1)*(q^2+1)^2,
	1//2*sqrt2*q*(q^2-1)*(q^2+1)^2*(q^8-q^4+1)*(q^4-q^2+1)*(q^4+1),
	1//2*sqrt2*q*(q^2-1)*(q^2+1)^2*(q^8-q^4+1)*(q^4-q^2+1)*(q^4+1),
	q^4*(q^4-q^2+1)*(q^4+1)*(q^8-q^4+1)*(q^2+1)^2,
	(q^2+1)*(q^4-q^2+1)*(q^8-q^4+1)*(q^4+1)^2,
	q^2*(q^2+1)*(q^4-q^2+1)*(q^8-q^4+1)*(q^4+1)^2,
	(q^2+1)^2*(q^4+1)^2*(q^4-q^2+1)*(q^8-q^4+1),
	(q^2-1)*(q^8-q^4+1)*(q^4+1)^2,
	q^2*(q^8-q^4+1)*(q^2-1)^2*(q^4+1)^2,
	q^6*(q^2-1)*(q^8-q^4+1)*(q^4+1)^2,
	(q^2-1)*(q^4-q^2+1)*(q^8-q^4+1)*(q^4+1)^2,
	q^2*(q^2-1)*(q^4-q^2+1)*(q^8-q^4+1)*(q^4+1)^2,
	(q^2-1)*(q^2+1)*(q^4+1)^2*(q^4-q^2+1)*(q^8-q^4+1),
	(q^2-1)*(q^2+1)^2*(q^2+sqrt2*q+1)*(q^4+1)*(q^4-q^2+1)*(q^8-q^4+1),
	(q^2-1)*(q^2+1)^2*(q^2-sqrt2*q+1)*(q^4+1)*(q^4-q^2+1)*(q^8-q^4+1),
	(q^2-1)^2*(q^2+1)^2*(q^4+1)*(q^4-q^2+1)*(q^8-q^4+1),
	(q^2-1)^2*(q^4+1)^2*(q^4-q^2+1)*(q^8-q^4+1),
	(q^2-1)^2*(q^2+1)^2*(q^4+1)^2*(q^8-q^4+1),
	(q^2+1)^2*(q^2-1)^2*(q^4+1)^2*(q^4-q^2+1)*(q^4+sqrt2*q^3+q^2+sqrt2*q+1),
	(q^2+1)^2*(q^2-1)^2*(q^4+1)^2*(q^4-q^2+1)*(q^4-sqrt2*q^3+q^2-sqrt2*q+1)])

classsums=[
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2-2, congruence)
	s2,e2=nesum(s1, b, 1, q^2-2, congruence)
	tt1=eesubs(tt, [b], [a])
	s3,e3=nesum(tt1, a, 1, q^2-2, congruence)
	tt1=eesubs(tt, [b], [-a])
	s4,e4=nesum(tt1, a, 1, q^2-2, congruence)
	tt1=eesubs(tt, [a], [-(q*sqrt2-1)*b])
	s5,e5=nesum(tt1, b, 1, q^2-2, congruence)
	tt1=eesubs(tt, [a], [(q*sqrt2-1)*b])
	s6,e6=nesum(tt1, b, 1, q^2-2, congruence)
	tt1=eesubs(tt, [b], [-(q*sqrt2-1)*a])
	s7,e7=nesum(tt1, a, 1, q^2-2, congruence)
	tt1=eesubs(tt, [b], [(q*sqrt2-1)*a])
	s8,e8=nesum(tt1, a, 1, q^2-2, congruence)
	(1//16*s2-1//16*s3-1//16*s4-1//16*s5-1//16*s6-1//16*s7-1//16*s8, union(e1,e2,e3,e4,e5,e6,e7,e8))
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2, congruence)
	s2=eesubs(tt, [a], [(q^2+1)*1//3])
	s3=eesubs(tt, [a], [2*(q^2+1)*1//3])
	(1//2*s1-1//2*s2-1//2*s3, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2, congruence)
	s2=eesubs(tt, [a], [(q^2+1)*1//3])
	s3=eesubs(tt, [a], [2*(q^2+1)*1//3])
	(1//2*s1-1//2*s2-1//2*s3, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^4-2, congruence)
	tt1=eesubs(tt, [a], [(q^2-1)*a])
	s2,e2=nesum(tt1, a, 1, q^2, congruence)
	tt1=eesubs(tt, [a], [(q^2+1)*a])
	s3,e3=nesum(tt1, a, 1, q^2-2, congruence)
	(1//4*s1-1//4*s2-1//4*s3, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2-sqrt2*q, congruence)
	(1//4*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2-sqrt2*q, congruence)
	(1//4*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2-sqrt2*q, congruence)
	(1//4*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2-sqrt2*q, congruence)
	(1//4*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^4-sqrt2*q^3+sqrt2*q-2, congruence)
	tt1=eesubs(tt, [a], [(q^2-1)*a])
	s2,e2=nesum(tt1, a, 1, q^2-sqrt2*q, congruence)
	tt1=eesubs(tt, [a], [(q^2-sqrt2*q+1)*a])
	s3,e3=nesum(tt1, a, 1, q^2-2, congruence)
	(1//8*s1-1//8*s2-1//8*s3, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2+sqrt2*q, congruence)
	(1//4*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2+sqrt2*q, congruence)
	(1//4*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2+sqrt2*q, congruence)
	(1//4*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2+sqrt2*q, congruence)
	(1//4*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^4+sqrt2*q^3-sqrt2*q-2, congruence)
	tt1=eesubs(tt, [a], [(q^2-1)*a])
	s2,e2=nesum(tt1, a, 1, q^2+sqrt2*q, congruence)
	tt1=eesubs(tt, [a], [(q^2+sqrt2*q+1)*a])
	s3,e3=nesum(tt1, a, 1, q^2-2, congruence)
	(1//8*s1-1//8*s2-1//8*s3, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2-sqrt2*q, congruence)
	s2,e2=nesum(s1, b, 1, q^2+sqrt2*q, congruence)
	(1//16*s2, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, (q^2-sqrt2*q-4)*(q^2-sqrt2*q), congruence)
	(1//96*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, (q^2+sqrt2*q-4)*(q^2+sqrt2*q), congruence)
	(1//96*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^2, congruence)
	s2,e2=nesum(s1, b, 1, q^2, congruence)
	tt1=eesubs(tt, [a], [b])
	s3,e3=nesum(tt1, b, 1, q^2, congruence)
	tt1=eesubs(tt, [a], [-b])
	s4,e4=nesum(tt1, b, 1, q^2, congruence)
	tt1=eesubs(tt, [a], [(q*sqrt2-1)*b])
	s5,e5=nesum(tt1, b, 1, q^2, congruence)
	tt1=eesubs(tt, [a], [-(q*sqrt2-1)*b])
	s6,e6=nesum(tt1, b, 1, q^2, congruence)
	tt1=eesubs(tt, [a], [(q*sqrt2+1)*b])
	s7,e7=nesum(tt1, b, 1, q^2, congruence)
	tt1=eesubs(tt, [a], [-(q*sqrt2+1)*b])
	s8,e8=nesum(tt1, b, 1, q^2, congruence)
	tt1=eesubs(tt, [b], [(q*sqrt2-1)*a])
	s9,e9=nesum(tt1, a, 1, q^2, congruence)
	tt1=eesubs(tt, [b], [-(q*sqrt2-1)*a])
	s10,e10=nesum(tt1, a, 1, q^2, congruence)
	tt1=eesubs(tt, [b], [(q*sqrt2+1)*a])
	s11,e11=nesum(tt1, a, 1, q^2, congruence)
	tt1=eesubs(tt, [b], [-(q*sqrt2+1)*a])
	s12,e12=nesum(tt1, a, 1, q^2, congruence)
	s13=eesubs(tt, [a,b], S.([b,(q^2+1)*1//3]))
	s14=eesubs(tt, [a,b], S.([-b,(q^2+1)*1//3]))
	s15=eesubs(tt, [a,b], S.([b,2*(q^2+1)*1//3]))
	s16=eesubs(tt, [a,b], S.([-b,2*(q^2+1)*1//3]))
	(1//48*s2-1//48*s3-1//48*s4-1//48*s5-1//48*s6-1//48*s7-1//48*s8-1//48*s9-1//48*s10-1//48*s11-1//48*s12+1//12*s13+1//12*s14+1//12*s15+1//12*s16, union(e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^4-q^2, congruence)
	s2=eesubs(tt, [a], [(q^4-q^2+1)*1//3])
	s3=eesubs(tt, [a], [2*(q^4-q^2+1)*1//3])
	(1//6*s1-1//6*s2-1//6*s3, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^4-sqrt2*q^3+q^2-sqrt2*q, congruence)
	(1//12*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, a, 1, q^4+sqrt2*q^3+q^2+sqrt2*q, congruence)
	(1//12*s1, e1)
end
]

charsums=[
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^2-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^2-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^2-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^2-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^2-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^2-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^2-2, congruence)
	s2,e2=nesum(s1, l, 1, q^2-2, congruence)
	tt1=eesubs(tt, [l], [k])
	s3,e3=nesum(tt1, k, 1, q^2-2, congruence)
	tt1=eesubs(tt, [l], [-k])
	s4,e4=nesum(tt1, k, 1, q^2-2, congruence)
	tt1=eesubs(tt, [k], [-(q*sqrt2-1)*l])
	s5,e5=nesum(tt1, l, 1, q^2-2, congruence)
	tt1=eesubs(tt, [k], [(q*sqrt2-1)*l])
	s6,e6=nesum(tt1, l, 1, q^2-2, congruence)
	tt1=eesubs(tt, [l], [-(q*sqrt2-1)*k])
	s7,e7=nesum(tt1, k, 1, q^2-2, congruence)
	tt1=eesubs(tt, [l], [(q*sqrt2-1)*k])
	s8,e8=nesum(tt1, k, 1, q^2-2, congruence)
	(1//16*s2-1//16*s3-1//16*s4-1//16*s5-1//16*s6-1//16*s7-1//16*s8, union(e1,e2,e3,e4,e5,e6,e7,e8))
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{Generic.Poly{nf_elem}}}())
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^2, congruence)
	s2=eesubs(tt, [k], [(q^2+1)*1//3])
	s3=eesubs(tt, [k], [2*(q^2+1)*1//3])
	(1//2*s1-1//2*s2-1//2*s3, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^2, congruence)
	s2=eesubs(tt, [k], [(q^2+1)*1//3])
	s3=eesubs(tt, [k], [2*(q^2+1)*1//3])
	(1//2*s1-1//2*s2-1//2*s3, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^4-2, congruence)
	tt1=eesubs(tt, [k], [(q^2-1)*k])
	s2,e2=nesum(tt1, k, 1, q^2, congruence)
	tt1=eesubs(tt, [k], [(q^2+1)*k])
	s3,e3=nesum(tt1, k, 1, q^2-2, congruence)
	(1//4*s1-1//4*s2-1//4*s3, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^4-sqrt2*q^3+sqrt2*q-2, congruence)
	tt1=eesubs(tt, [k], [(q^2-1)*k])
	s2,e2=nesum(tt1, k, 1, q^2-sqrt2*q, congruence)
	tt1=eesubs(tt, [k], [(q^2-sqrt2*q+1)*k])
	s3,e3=nesum(tt1, k, 1, q^2-2, congruence)
	(1//8*s1-1//8*s2-1//8*s3, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^4+sqrt2*q^3-sqrt2*q-2, congruence)
	tt1=eesubs(tt, [k], [(q^2-1)*k])
	s2,e2=nesum(tt1, k, 1, q^2+sqrt2*q, congruence)
	tt1=eesubs(tt, [k], [(q^2+sqrt2*q+1)*k])
	s3,e3=nesum(tt1, k, 1, q^2-2, congruence)
	(1//8*s1-1//8*s2-1//8*s3, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^2-sqrt2*q, congruence)
	s2,e2=nesum(s1, l, 1, q^2+sqrt2*q, congruence)
	(1//16*s2, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^2, congruence)
	s2,e2=nesum(s1, l, 1, q^2, congruence)
	tt1=eesubs(tt, [k], [l])
	s3,e3=nesum(tt1, l, 1, q^2, congruence)
	tt1=eesubs(tt, [k], [-l])
	s4,e4=nesum(tt1, l, 1, q^2, congruence)
	tt1=eesubs(tt, [k], [(q*sqrt2-1)*l])
	s5,e5=nesum(tt1, l, 1, q^2, congruence)
	tt1=eesubs(tt, [k], [-(q*sqrt2-1)*l])
	s6,e6=nesum(tt1, l, 1, q^2, congruence)
	tt1=eesubs(tt, [k], [(q*sqrt2+1)*l])
	s7,e7=nesum(tt1, l, 1, q^2, congruence)
	tt1=eesubs(tt, [k], [-(q*sqrt2+1)*l])
	s8,e8=nesum(tt1, l, 1, q^2, congruence)
	tt1=eesubs(tt, [l], [(q*sqrt2-1)*k])
	s9,e9=nesum(tt1, k, 1, q^2, congruence)
	tt1=eesubs(tt, [l], [-(q*sqrt2-1)*k])
	s10,e10=nesum(tt1, k, 1, q^2, congruence)
	tt1=eesubs(tt, [l], [(q*sqrt2+1)*k])
	s11,e11=nesum(tt1, k, 1, q^2, congruence)
	tt1=eesubs(tt, [l], [-(q*sqrt2+1)*k])
	s12,e12=nesum(tt1, k, 1, q^2, congruence)
	s13=eesubs(tt, [k,l], S.([l,(q^2+1)*1//3]))
	s14=eesubs(tt, [k,l], S.([-l,(q^2+1)*1//3]))
	s15=eesubs(tt, [k,l], S.([l,2*(q^2+1)*1//3]))
	s16=eesubs(tt, [k,l], S.([-l,2*(q^2+1)*1//3]))
	(1//48*s2-1//48*s3-1//48*s4-1//48*s5-1//48*s6-1//48*s7-1//48*s8-1//48*s9-1//48*s10-1//48*s11-1//48*s12+1//12*s13+1//12*s14+1//12*s15+1//12*s16, union(e1,e2,e3,e4,e5,e6,e7,e8,e9,e10,e11,e12))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^4-q^2, congruence)
	s2=eesubs(tt, [k], [(q^4-q^2+1)*1//3])
	s3=eesubs(tt, [k], [2*(q^4-q^2+1)*1//3])
	(1//6*s1-1//6*s2-1//6*s3, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^4-sqrt2*q^3+q^2-sqrt2*q, congruence)
	(1//12*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k, 1, q^4+sqrt2*q^3+q^2+sqrt2*q, congruence)
	(1//12*s1, e1)
end
]

classparams=[
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2-1)], [ParameterException((a)*1//(q^2-1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2-1)], [ParameterException((a)*1//(q^2-1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2-1)], [ParameterException((a)*1//(q^2-1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2-1)], [ParameterException((a)*1//(q^2-1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2-1)], [ParameterException((a)*1//(q^2-1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2-1)], [ParameterException((a)*1//(q^2-1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2-1), Parameter(b, q^2-1)], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2+1)], [ParameterException((a)*1//((q^2+1)*1//3))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2+1)], [ParameterException((a)*1//((q^2+1)*1//3))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^4-1)], [ParameterException((a)*1//(q^2-1)), ParameterException((a)*1//(q^2+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2-sqrt2*q+1)], [ParameterException((a)*1//(q^2-sqrt2*q+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2-sqrt2*q+1)], [ParameterException((a)*1//(q^2-sqrt2*q+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2-sqrt2*q+1)], [ParameterException((a)*1//(q^2-sqrt2*q+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2-sqrt2*q+1)], [ParameterException((a)*1//(q^2-sqrt2*q+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, (q^2-1)*(q^2-sqrt2*q+1))], [ParameterException((a)*1//(q^2-1)), ParameterException((a)*1//(q^2-sqrt2*q+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2+sqrt2*q+1)], [ParameterException((a)*1//(q^2+sqrt2*q+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2+sqrt2*q+1)], [ParameterException((a)*1//(q^2+sqrt2*q+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2+sqrt2*q+1)], [ParameterException((a)*1//(q^2+sqrt2*q+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2+sqrt2*q+1)], [ParameterException((a)*1//(q^2+sqrt2*q+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, (q^2-1)*(q^2+sqrt2*q+1))], [ParameterException((a)*1//(q^2-1)), ParameterException((a)*1//(q^2+sqrt2*q+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2-sqrt2*q+1), Parameter(b, q^2+sqrt2*q+1)], [ParameterException((a)*1//(q^2-sqrt2*q+1)), ParameterException((b)*1//(q^2+sqrt2*q+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2-sqrt2*q+1), Parameter(b, q^2-sqrt2*q+1)], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2+sqrt2*q+1), Parameter(b, q^2+sqrt2*q+1)], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^2+1), Parameter(b, q^2+1)], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^4-q^2+1)], [ParameterException((a)*1//((q^4-q^2+1)*1//3))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^4-sqrt2*q^3+q^2-sqrt2*q+1)], [ParameterException((a)*1//(q^4-sqrt2*q^3+q^2-sqrt2*q+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(a, q^4+sqrt2*q^3+q^2+sqrt2*q+1)], [ParameterException((a)*1//(q^4+sqrt2*q^3+q^2+sqrt2*q+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[])
]

charparams=[
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(k, q^2-1)], [ParameterException((k)*1//(q^2-1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(k, q^2-1)], [ParameterException((k)*1//(q^2-1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(k, q^2-1)], [ParameterException((k)*1//(q^2-1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(k, q^2-1)], [ParameterException((k)*1//(q^2-1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(k, q^2-1)], [ParameterException((k)*1//(q^2-1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(k, q^2-1)], [ParameterException((k)*1//(q^2-1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(k, q^2-1), Parameter(l, q^2-1)], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters(Parameter{Generic.Poly{nf_elem}}[], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(k, q^2+1)], [ParameterException((k)*1//((q^2+1)*1//3))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(k, q^2+1)], [ParameterException((k)*1//((q^2+1)*1//3))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(k, q^4-1)], [ParameterException((k)*1//(q^2-1)), ParameterException((k)*1//(q^2+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(k, (q^2-1)*(q^2-sqrt2*q+1))], [ParameterException((k)*1//(q^2-1)), ParameterException((k)*1//(q^2-sqrt2*q+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(k, (q^2-1)*(q^2+sqrt2*q+1))], [ParameterException((k)*1//(q^2-1)), ParameterException((k)*1//(q^2+sqrt2*q+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(k, q^2-sqrt2*q+1), Parameter(l, q^2+sqrt2*q+1)], [ParameterException((k)*1//(q^2-sqrt2*q+1)), ParameterException((l)*1//(q^2+sqrt2*q+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(k, q^2+1), Parameter(l, q^2+1)], ParameterException{Generic.Poly{nf_elem}}[], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(k, q^4-q^2+1)], [ParameterException((k)*1//((q^4-q^2+1)*1//3))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(k, q^4-sqrt2*q^3+q^2-sqrt2*q+1)], [ParameterException((k)*1//(q^4-sqrt2*q^3+q^2-sqrt2*q+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[]),
Parameters([Parameter(k, q^4+sqrt2*q^3+q^2+sqrt2*q+1)], [ParameterException((k)*1//(q^4+sqrt2*q^3+q^2+sqrt2*q+1))], ParameterSubstitution{Generic.Poly{nf_elem}}[])
]

classparamindex=var_index.([a,b])
charparamindex=var_index.([k,l])
congruence=R.((-sqrt2, 3*sqrt2))

information = "- Information about the generic character table of \$^2F_4(q^2)\$,
  \$\\frac{q}{\\sqrt{2}}\$ congruent to \$2\$ modulo \$3\$.

- CHEVIE-name of the table: ``Ree``

- The unipotent characters were first computed in:
  {\\sc G. Malle}, Die unipotenten Charaktere von \$^2F_4(q^2)\$,
    {\\em Comm. Algebra \\bf18} (1990), 2361--2381.

- The other irreducible characters were added by G. Malle
"

TABLE=CharTable(order,ExtendableMatrix(permutedims(table)),classinfo,classlength,charinfo,chardegree,
	classsums,charsums,classparamindex,charparamindex,classparams,charparams,congruence,R,S,information)
