using ..GenericCharacterTables
import ..GenericCharacterTables: Cyclotomic, Parameters, Parameter, ParameterException, ParameterSubstitution, ExtendableMatrix, CharTable
using Oscar
R, q = polynomial_ring(QQ, "q")
Q = fraction_field(R)
S = UniversalPolynomialRing(Q, cached=false)
i1,i2,i3,i4,k1,k2,k3,k4,i11, _...=gens(S, ["i1", "i2", "i3", "i4", "k1", "k2", "k3", "k4", "i11", "i21", "i31", "i41", "k11", "k21", "k31", "k41", "i12", "i22", "i32", "i42", "k12", "k22", "k32", "k42", "i13", "i23", "i33", "i43", "k13", "k23", "k33", "k43", "i1t1", "i2t1", "i3t1", "i4t1", "k1t1", "k2t1", "k3t1", "k4t1", "i1t2", "i2t2", "i3t2", "i4t2", "k1t2", "k2t2", "k3t2", "k4t2"])

order = q^9*(q^6-1)*(q^4-1)*(q^2-1)*(q-1)
table = Cyclotomic{QQPolyRingElem}[[
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((k1+2*i1*k1)*S(1//(q-1))),
	e2p((k1+2*i1*k1)*S(1//(q-1))),
	e2p((k1+2*i1*k1)*S(1//(q-1))),
	e2p((k1+2*i1*k1)*S(1//(q-1))),
	e2p((k1+2*i1*k1)*S(1//(q-1))),
	e2p((k1+2*i1*k1)*S(1//(q-1))),
	e2p((2*i3*k1)*S(1//(q-1))),
	e2p((2*i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((2*i3*k1)*S(1//(q-1))),
	e2p((2*i3*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((2*i3*k1)*S(1//(q-1))),
	e2p((2*i3*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((i4*k1)*S(1//(q-1))),
	e2p((i4*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((i4*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1))),
	e2p((i4*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1)))] [
	1//2*q*(q^4+q^3+2*q^2+q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*q*(q^2+q+1+q^3)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*q*(q^2+2*q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*q*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*q*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*q*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*(2*q^3+q^2+2*q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q^2+q+1+q^3)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q^2+2*q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q^2+2*q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q^2-2*q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(2*q^2+q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q^3+2*q^2+q+2)*e2p((2*i2*k1)*S(1//(q-1))),
	1//2*(q^2+q+2)*e2p((2*i2*k1)*S(1//(q-1))),
	(q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	1//2*q*(q^2+1)*e2p((2*i2*k1)*S(1//(q-1))),
	1//2*q*(q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(q^2+q+1)*e2p((i2*k1)*S(1//(q-1))),
	(q+1)*e2p((i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1))),
	-e2p((i2*k1)*S(1//(q-1))),
	-e2p((i2*k1)*S(1//(q-1))),
	-e2p((i2*k1)*S(1//(q-1))),
	1//2*(2*q+3+q^2)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(3+q)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(3+q)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(3+q)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-3)*e2p((2*i1*k1)*S(1//(q-1))),
	(2*q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	(q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	(q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	-1//2*(q^2-2*q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*(q^2+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	-1//2*e2p((k1+2*i1*k1)*S(1//(q-1)))*(q-1),
	-1//2*(q^2+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	-1//2*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((k1+2*i1*k1)*S(1//(q-1)))*(q-1),
	(q+2)*e2p((2*i3*k1)*S(1//(q-1))),
	2*e2p((2*i3*k1)*S(1//(q-1))),
	(q+2)*e2p((i3*k1)*S(1//(q-1))),
	2*e2p((i3*k1)*S(1//(q-1))),
	e2p((2*i3*k1)*S(1//(q-1))),
	e2p((2*i3*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	q*e2p((2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	3*e2p((i4*k1)*S(1//(q-1))),
	e2p((i4*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((i4*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((i2*k1)*S(1//(q-1)))] [
	1//2*q*(q^4-q^3+2*q^2-q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*q*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*q*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)^2*q*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*q*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*q*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*(-q^2+2*q-1+2*q^3)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)^2*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q^2+2*q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)^2*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(2*q^2-q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*q*(q^2+1)*e2p((2*i2*k1)*S(1//(q-1))),
	-1//2*(q-1)*q*e2p((2*i2*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*(q^3-2*q^2+q-2)*e2p((2*i2*k1)*S(1//(q-1))),
	-1//2*(-q+2+q^2)*e2p((2*i2*k1)*S(1//(q-1))),
	-e2p((2*i2*k1)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1)*S(1//(q-1))),
	-e2p((2*i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1))),
	-(q^2-q+1)*e2p((i2*k1)*S(1//(q-1))),
	(q-1)*e2p((i2*k1)*S(1//(q-1))),
	-e2p((i2*k1)*S(1//(q-1))),
	1//2*(q^2+2*q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*(3+q^2-2*q)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-3)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-3)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-3)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(3+q)*e2p((2*i1*k1)*S(1//(q-1))),
	(2*q-1)*e2p((2*i2*k1)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1)*S(1//(q-1))),
	-e2p((2*i2*k1)*S(1//(q-1))),
	1//2*(q^2+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	-1//2*e2p((k1+2*i1*k1)*S(1//(q-1)))*(q-1),
	1//2*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	-1//2*(q^2+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((k1+2*i1*k1)*S(1//(q-1)))*(q-1),
	-1//2*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	-e2p((2*i3*k1)*S(1//(q-1))),
	-e2p((2*i3*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((i3*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	q*e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(q-2)*e2p((2*i3*k1)*S(1//(q-1))),
	-2*e2p((2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-2)*e2p((i3*k1)*S(1//(q-1))),
	-2*e2p((i3*k1)*S(1//(q-1))),
	e2p((i4*k1)*S(1//(q-1))),
	-e2p((i4*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	-e2p((i4*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i2*k1)*S(1//(q-1))),
	-3*e2p((i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	1//2*q*(q^4+q^3+q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*q*(q^2+q+1+q^3)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*q*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*q*(q^2+2*q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*q*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	1//2*q*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	1//2*(q^2+2*q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q^2+q+1+q^3)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q^2+2*q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q^2-2*q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q^2+2*q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(2*q^2+q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+q^3+2)*e2p((2*i2*k1)*S(1//(q-1))),
	1//2*(q^2+q+2)*e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	(q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	1//2*q*(q^2+2*q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	1//2*q*(q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*(q+1)*e2p((i2*k1)*S(1//(q-1))),
	q*e2p((i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*(q^2-2*q-3)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(3+q)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(3+q)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-3)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(3+q)*e2p((2*i1*k1)*S(1//(q-1))),
	(q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	(q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	1//2*(q^2+2*q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*(q-1)*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	-1//2*e2p((k1+2*i1*k1)*S(1//(q-1)))*(q-1),
	1//2*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((k1+2*i1*k1)*S(1//(q-1)))*(q-1),
	-1//2*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	2*e2p((2*i3*k1)*S(1//(q-1))),
	2*e2p((2*i3*k1)*S(1//(q-1))),
	(q+1)*e2p((i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	(q+1)*e2p((2*i3*k1)*S(1//(q-1))),
	e2p((2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q+1)*e2p((i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((i4*k1)*S(1//(q-1))),
	2*e2p((i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1)*S(1//(q-1))),
	-e2p((i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0))] [
	1//2*(q-1)^2*q*(q^2+q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*q*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)^2*q*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*q*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*q*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-1//2*(q-1)*q*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-1//2*(q-1)^2*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)^2*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)^2*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q^2+2*q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(2*q^2-q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)^2*q*e2p((2*i2*k1)*S(1//(q-1))),
	-1//2*(q-1)*q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	1//2*(q-1)*(q^2+q+2)*e2p((2*i2*k1)*S(1//(q-1))),
	-1//2*(-q+2+q^2)*e2p((2*i2*k1)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1)*S(1//(q-1))),
	-e2p((2*i2*k1)*S(1//(q-1))),
	-e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q-1)*q*e2p((i2*k1)*S(1//(q-1))),
	q*e2p((i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-1//2*(q-1)^2*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*(q-1)*(3+q)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-3)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-3)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(3+q)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-3)*e2p((2*i1*k1)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1)*S(1//(q-1))),
	-e2p((2*i2*k1)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1)*S(1//(q-1))),
	-e2p((2*i2*k1)*S(1//(q-1))),
	-1//2*(q-1)*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	-1//2*e2p((k1+2*i1*k1)*S(1//(q-1)))*(q-1),
	1//2*(q-1)*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	-1//2*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((k1+2*i1*k1)*S(1//(q-1)))*(q-1),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p((2*i3*k1)*S(1//(q-1))),
	-e2p((2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p((i3*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	-2*e2p((2*i3*k1)*S(1//(q-1))),
	-2*e2p((2*i3*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(q-1)*e2p((i3*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-2*e2p((i4*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1)))] [
	q^2*(1+q^2+q^4)*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-(q-1)*q^2*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^2*(2+q^2)*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i1*k1)*S(1//(q-1))),
	q*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	(q-1)*q*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	-q*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*(q^2+q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	2*q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*(q^2-q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	-q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-2*q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(q^2+q+1)*e2p((i2*k1)*S(1//(q-1))),
	(q+1)*e2p((i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1))),
	(q^2-q+1)*e2p((i2*k1)*S(1//(q-1))),
	-(q-1)*e2p((i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1))),
	q*(q+2)*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2+q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	(q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	q*(q-2)*e2p((2*i1*k1)*S(1//(q-1))),
	-q*e2p((2*i1*k1)*S(1//(q-1))),
	-q*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2-q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	-(q-1)*e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	q^2*e2p((k1+2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^2*e2p((k1+2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(2*q+1)*e2p((2*i3*k1)*S(1//(q-1))),
	e2p((2*i3*k1)*S(1//(q-1))),
	(q+2)*e2p((i3*k1)*S(1//(q-1))),
	2*e2p((i3*k1)*S(1//(q-1))),
	-e2p((2*i3*k1)*S(1//(q-1))),
	-e2p((2*i3*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	-q*e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-(2*q-1)*e2p((2*i3*k1)*S(1//(q-1))),
	e2p((2*i3*k1)*S(1//(q-1))),
	-e2p((2*i2*k1)*S(1//(q-1))),
	-e2p((2*i2*k1)*S(1//(q-1))),
	-(q-2)*e2p((i3*k1)*S(1//(q-1))),
	2*e2p((i3*k1)*S(1//(q-1))),
	3*e2p((i4*k1)*S(1//(q-1))),
	-e2p((i4*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	-e2p((i4*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	3*e2p((i4*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0))] [
	q^3*(1+q^2+q^4)*e2p((2*i1*k1)*S(1//(q-1))),
	q^3*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q^3*e2p((2*i1*k1)*S(1//(q-1))),
	q^3*e2p((2*i1*k1)*S(1//(q-1))),
	q^3*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*(2*q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*(q^2+q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	q*(q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*(q^2-q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	-(q-1)*q*e2p((2*i2*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*(q^2+q+1)*e2p((i2*k1)*S(1//(q-1))),
	q*e2p((i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*(q^2-q+1)*e2p((i2*k1)*S(1//(q-1))),
	q*e2p((i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(2*q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	(q^2+q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	(q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	(2*q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	-e2p((2*i1*k1)*S(1//(q-1))),
	-e2p((2*i1*k1)*S(1//(q-1))),
	-(q^2-q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	-e2p((2*i2*k1)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1)*S(1//(q-1))),
	-e2p((2*i2*k1)*S(1//(q-1))),
	-e2p((k1+2*i1*k1)*S(1//(q-1))),
	-e2p((k1+2*i1*k1)*S(1//(q-1))),
	-e2p((k1+2*i1*k1)*S(1//(q-1))),
	e2p((k1+2*i1*k1)*S(1//(q-1))),
	e2p((k1+2*i1*k1)*S(1//(q-1))),
	e2p((k1+2*i1*k1)*S(1//(q-1))),
	(q+2)*e2p((2*i3*k1)*S(1//(q-1))),
	2*e2p((2*i3*k1)*S(1//(q-1))),
	(2*q+1)*e2p((i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	q*e2p((2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	(q-2)*e2p((2*i3*k1)*S(1//(q-1))),
	-2*e2p((2*i3*k1)*S(1//(q-1))),
	-q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(2*q-1)*e2p((i3*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	3*e2p((i4*k1)*S(1//(q-1))),
	e2p((i4*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	-e2p((i4*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-3*e2p((i4*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0))] [
	1//2*q^4*(q^4+q^3+2*q^2+q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*q^4*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q^4*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*q^2*(q^3+2*q^2+q+2)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*q^2*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*q^2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*q^2*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*q*(2*q^3+q^2+2*q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	1//2*q*(q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*q*(q^2+1)*e2p((2*i2*k1)*S(1//(q-1))),
	1//2*(q-1)*q*e2p((2*i2*k1)*S(1//(q-1))),
	-q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*(q^2+q+1)*e2p((i2*k1)*S(1//(q-1))),
	q*e2p((i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q^3*e2p((i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*(3*q^2+2*q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*(q+2)*e2p((2*i2*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-1//2*(q^2+2*q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	-q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-1//2*(q^2+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((k1+2*i1*k1)*S(1//(q-1)))*(q-1),
	-1//2*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	-1//2*(q^2+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((k1+2*i1*k1)*S(1//(q-1)))*(q-1),
	-1//2*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	(2*q+1)*e2p((2*i3*k1)*S(1//(q-1))),
	e2p((2*i3*k1)*S(1//(q-1))),
	(2*q+1)*e2p((i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	-q*e2p((2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((2*i2*k1)*S(1//(q-1))),
	-e2p((2*i2*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	-q*e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((2*i3*k1)*S(1//(q-1))),
	e2p((2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	3*e2p((i4*k1)*S(1//(q-1))),
	-e2p((i4*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	e2p((i4*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i2*k1)*S(1//(q-1)))] [
	1//2*q^4*(q^4+q^3+q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*q^4*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q^4*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*q^3*(q^2+2*q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*q^2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q^2*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*q^2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*q^2*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*q*(2*q^3+q^2+1)*e2p((2*i2*k1)*S(1//(q-1))),
	-1//2*(q-1)*q*e2p((2*i2*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*q*(q^2+2*q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	-1//2*q*(q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	-q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*(q+1)*e2p((i2*k1)*S(1//(q-1))),
	q*e2p((i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*(2*q-1+3*q^2)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*(q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*(q^2+2*q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*(q-1)*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	-1//2*e2p((k1+2*i1*k1)*S(1//(q-1)))*(q-1),
	1//2*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	-1//2*e2p((k1+2*i1*k1)*S(1//(q-1)))*(q-1),
	1//2*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	2*q*e2p((2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(q+1)*e2p((i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	-(q+1)*e2p((2*i3*k1)*S(1//(q-1))),
	-e2p((2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q+1)*e2p((i3*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((i4*k1)*S(1//(q-1))),
	-2*e2p((i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1)*S(1//(q-1))),
	-e2p((i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0))] [
	1//2*q^4*(q^4-q^3+2*q^2-q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*q^4*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q^4*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*q^2*(q^3-2*q^2+q-2)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*q^2*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q^2*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-1//2*(q-1)*q^2*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*q^2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*q*(q^2+1)*e2p((2*i2*k1)*S(1//(q-1))),
	1//2*q*(q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	1//2*q*(-q^2+2*q-1+2*q^3)*e2p((2*i2*k1)*S(1//(q-1))),
	1//2*(q-1)*q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q^3*e2p((i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*(q^2-q+1)*e2p((i2*k1)*S(1//(q-1))),
	-q*e2p((i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-1//2*(q^2-2*q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	1//2*(3*q^2-2*q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*(q-2)*e2p((2*i2*k1)*S(1//(q-1))),
	-q*e2p((2*i2*k1)*S(1//(q-1))),
	-q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-1//2*(q^2+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	-1//2*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((k1+2*i1*k1)*S(1//(q-1)))*(q-1),
	-1//2*(q^2+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	-1//2*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((k1+2*i1*k1)*S(1//(q-1)))*(q-1),
	e2p((2*i3*k1)*S(1//(q-1))),
	e2p((2*i3*k1)*S(1//(q-1))),
	q*e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*e2p((2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((2*i2*k1)*S(1//(q-1))),
	-e2p((2*i2*k1)*S(1//(q-1))),
	q*e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((i3*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	-(2*q-1)*e2p((2*i3*k1)*S(1//(q-1))),
	e2p((2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(2*q-1)*e2p((i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((i4*k1)*S(1//(q-1))),
	e2p((i4*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	-e2p((i4*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i2*k1)*S(1//(q-1))),
	3*e2p((i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	1//2*(q-1)^2*q^4*(q^2+q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q-1)*q^4*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q^4*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*(q-1)^2*q^3*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*q^2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^2*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	1//2*(q-1)*q^2*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*q^2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*(q-1)^2*q*e2p((2*i2*k1)*S(1//(q-1))),
	-1//2*(q-1)*q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	1//2*(q-1)*q*(2*q^2+q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	-1//2*q*(q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*q*e2p((i2*k1)*S(1//(q-1))),
	-q*e2p((i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-1//2*(q-1)^2*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*(q-1)*(3*q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*(q-1)*e2p((2*i1*k1)*S(1//(q-1))),
	-1//2*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	(q-1)*q*e2p((2*i2*k1)*S(1//(q-1))),
	-q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*(q-1)*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	-1//2*e2p((k1+2*i1*k1)*S(1//(q-1)))*(q-1),
	-1//2*(q-1)*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	1//2*(q+1)*e2p((k1+2*i1*k1)*S(1//(q-1))),
	-1//2*e2p((k1+2*i1*k1)*S(1//(q-1)))*(q-1),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p((2*i3*k1)*S(1//(q-1))),
	-e2p((2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p((i3*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	-2*q*e2p((2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	-(q-1)*e2p((i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	2*e2p((i4*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	-e2p((i2*k1)*S(1//(q-1)))] [
	q^9*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^5*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^4*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q^4*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^3*e2p((i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^3*e2p((i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^2*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^2*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q^2*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q^2*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q^2*e2p((k1+2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^2*e2p((k1+2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q*e2p((2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q*e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q*e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*e2p((2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*e2p((i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i4*k1)*S(1//(q-1))),
	-e2p((i4*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	e2p((i4*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1))),
	-e2p((i4*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1))),
	-e2p((i2*k1)*S(1//(q-1)))] [
	(q^3+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	(q^2+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^3-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2-e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	(q^2+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0))] [
	q*(1+q^4+q^2+q+q^3+q^5)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	q*(q^2+q+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	q*(2*q^2+q+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	q*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	q*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	q*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q,
	e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q,
	e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^4+3//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^3+3//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+3//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^3,
	e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+3//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	3//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2+e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	3//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q,
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	(2*q^3+q^2+2*q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	(2*q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	(3*q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	3//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+3*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+3//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	3//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+3//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	3//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+3//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	3//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	3//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q^2+3*q+2)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	2*(q+1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	(q+2)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	2*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*(q+1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	3*(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	3*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+2*e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+2*e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	2*e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	3*e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+3*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0))] [
	q^2*(q^3+1+q^2+q^5)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	q^2*(q^2+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	q^2*(q^2+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	-(q-1)*q^2*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2,
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^5-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^4+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^4+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^5,
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^4+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^4,
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^3+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2-e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1))),
	(q^4+2*q^2+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	(q^2+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	-(q-1)*(q^2+q+1+q^3)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	(q^2+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q,
	e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q^2+2*q+1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2,
	e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	-2*(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	2*(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q^3*(1+q^4+q^2+q+q^3+q^5)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	q^3*(q^2+q+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	q^3*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	q^3*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^3,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	3//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^5-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^5+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^4+e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+3//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+3//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^4-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^3,
	e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^4+e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^4-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2,
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^3+3//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^3-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2,
	q*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	q*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2,
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2,
	e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q,
	e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*(q^3+2*q^2+q+2)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	q*(q+2)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	2*q*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	2*q*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(q-1)*q^2*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	-q^2*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q^3+e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q^3+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q,
	e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	3//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+3*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+3//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	3//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+3//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	3//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+3//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	3//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	3//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(2*q^2+3*q+1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	(2*q+1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	3*(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	3*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	2*e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	3*e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+3*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0))] [
	q^6*(q^3+1)*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	q^6*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^3-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^4+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^4+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^5+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^5,
	1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^4+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^4,
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^3+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2,
	1//2*e2p((1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1-1//2*i1)*S(1//(q-1)))*q^2,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^2*(q^2+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	q^2*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q-1)*q^2*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	q^2*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q^3+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))*q^3,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*(q+1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-q*(q+1)*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q*e2p((1//2*q*i2-1//2*i2+2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	-1//2*e2p((1//2*q*i2-1//2*i2+1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i2-1//2*i2+k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0))] [
	(q-1)*(q^2+q+1)*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-(q^2+1)*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	(q-1)*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	(q-1)*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-(q+1)*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^3-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^3+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q,
	1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q,
	-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q,
	-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-(q^2+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1))))-e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1)))),
	-e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1))))-e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1)))),
	-e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1))))-e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1)))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))*q^2-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))*q^2-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))*q^2-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))*q^2-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	-e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	-e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	-e2p((i4*q+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	-e2p((i4*q+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	-e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1))))-e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1))))] [
	(q-1)*q*(1+q^2+q^4)*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-q*(q^2-q+1)*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	(q-1)*q*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-q*(2*q^2-q+1)*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	(q-1)*q*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	(q-1)*q*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q,
	-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q,
	-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^4-3//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^3+3//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-3//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^3+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^3+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-3//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q,
	1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	3//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q,
	-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-3//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q,
	1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-(-q^2+2*q-1+2*q^3)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-(2*q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-(3*q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1))))*q^2-e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1))))*q+e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1))))+e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1))))*q^2-e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1))))*q+e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1)))),
	-e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1))))*q+e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1))))-e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1))))*q+e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1)))),
	e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1))))+e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1)))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q-1)*q*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+3//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-3*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+3//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-3//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+3//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-3//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+3//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+3//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+3//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q-1)*(q-2)*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-2*(q-1)*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-(q-2)*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	2*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))*q^2-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))*q^2-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))*q^2+1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))*q^2+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q-e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-3*(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	3*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q+2*e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q+2*e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	2*e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))+2*e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	-e2p((i4*q+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))+e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	3*e2p((i4*q+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))+3*e2p((i4+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*q^2*(q^4+q^3+2*q^2+q+1)*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-q^2*(q^2+1)*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	(q-1)*q^2*(q+1)*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-q^2*(q^2+1)*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2,
	(0)*e2p(S(0)),
	-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^3-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^4+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^5-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^4+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^5,
	-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^4+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^4,
	-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^3-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^3-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q,
	-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q,
	-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	(q-1)*(q^2+q+1+q^3)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-(q^2+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-(q^4+2*q^2+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-(q^2+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1))))*q^2+e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1))))*q-e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1))))*q^2+e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1))))*q,
	e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1))))*q+e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1))))*q,
	(0)*e2p(S(0)),
	e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-(q+1)*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-(q-1)^2*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q-e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q-e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	-e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q-e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))+e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q-e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	-e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	-2*e2p((i4+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-2*e2p((i4*q+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((i4+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-2*e2p((i4*q+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1))))+e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1))))] [
	(q-1)*q^3*(1+q^2+q^4)*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-q^3*(q^2-q+1)*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	(q-1)*q^3*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	(q-1)*q^3*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^3,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^4-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^5+3//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^4+3//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^5-3//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^3-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^3-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q,
	1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^4+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^4+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^3-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q,
	-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^3-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^3+3//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q,
	(q-1)*q*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	(q-1)*q*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q,
	-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q,
	-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q,
	-e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*q^2*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-q^2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*(q^3-2*q^2+q-2)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	q*(q-2)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-2*q*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-2*q*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1))))*q^2-e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1))))*q-e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1))))*q^3+e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1))))*q^2-e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1))))*q-e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1))))*q^3,
	-e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1))))*q-e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1))))*q,
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+3//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-3*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+3//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-3//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+3//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-3//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+3//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+3//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+3//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q-1)*(2*q-1)*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-(q-1)*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-(2*q-1)*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))*q^2+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))*q^2+1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))*q^2-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))*q^2-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	-e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-3*(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	3*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-2*e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q+e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-2*e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q+e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))+e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	-e2p((i4*q+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))+e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	3*e2p((i4*q+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))+3*e2p((i4+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*q^6*(q^2+q+1)*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	-q^6*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^3-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^3-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^4+1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^5-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^4+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^5,
	-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^4-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2+1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^4,
	1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^3-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^3,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2,
	-1//2*e2p((2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2-1//2*e2p((1//2*q-1//2+2*i1*k1+1//2*q*i1+1//2*i1)*S(1//(q-1)))*q^2,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*q^2*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-q^2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q^2*(q^2+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-q^2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1))))*q^3+e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1))))*q^3,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q-1)*q*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-(q-1)*q*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*e2p((2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))*q^2+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))*q^2+1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))*q^2+1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))*q^2+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+q*i2-i2+2*k1)*S(1//(2*(q-1)))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q-e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q+e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i4*q+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))+e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))+e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	-e2p((i4*q+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4+2*i4*k1+q*i1-i1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	-e2p((q*i1-i1+2*i2*k1+q*i2)*S(1//(2*(q-1))))-e2p((q*i1-i1+2*i2*k1+i2)*S(1//(2*(q-1))))] [
	(1+2*q^2+2*q^4+q^6)*e2p((2*i1*k1)*S(1//(q-1))),
	(q^4+2*q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	(q^3+2*q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-(q^3-2*q^2-1)*e2p((2*i1*k1)*S(1//(q-1))),
	(2*q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+q^2*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^4-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2,
	e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+q^2*e2p((2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2,
	e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3,
	q*e2p((2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	-q*e2p((2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	-q*e2p((2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i2*k1)*S(1//(q-1)))+e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^3+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q^2*e2p((2*i2*k1)*S(1//(q-1)))+e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^3+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))*q^2+q*e2p((i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))+q*e2p((i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^2-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))*q^2-q*e2p((i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))-q*e2p((i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	2*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	2*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	2*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	2*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	2*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	2*e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	2*e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	2*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	2*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	2*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q*(1+2*q^2+2*q^4+q^6)*e2p((2*i1*k1)*S(1//(q-1))),
	q*(q^4+2*q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*(2*q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*(2*q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q^3*e2p((2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^4+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^4+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1))),
	q^3*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1)))*q^3+q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^3+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1)))*q^3+q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^3-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^3+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+e2p((i2*k1)*S(1//(q-1)))*q^2+q*e2p((i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+q*e2p((i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^3-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q-e2p((i2*k1)*S(1//(q-1)))*q^2+q*e2p((i2*k1)*S(1//(q-1)))-e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+q*e2p((i2*k1)*S(1//(q-1)))-e2p((i2*k1)*S(1//(q-1))),
	-e2p((i2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))-e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))-e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1)))*q,
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1)))*q,
	e2p((i3*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1)))*q,
	-e2p((i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1)))*q,
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))-e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))-e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q*(1+2*q^2+2*q^4+q^6)*e2p((2*i1*k1)*S(1//(q-1))),
	q*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*(q^2+q+1+q^3)*e2p((2*i1*k1)*S(1//(q-1))),
	-(q-1)*q*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	2*q*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	2*q*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^5+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^4+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+q^3*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^5-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^4+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	q^2*e2p((2*i1*k1)*S(1//(q-1)))+q*e2p((2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q,
	-q^2*e2p((2*i1*k1)*S(1//(q-1)))+q*e2p((2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	q*e2p((2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q,
	e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^2*e2p((2*i2*k1)*S(1//(q-1)))+e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^4+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^3+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((2*i2*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	-(q-1)*e2p((2*i2*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1))),
	-q^2*e2p((2*i2*k1)*S(1//(q-1)))-e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^4+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^3-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	-e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	-(q+1)*e2p((2*i2*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))-e2p((2*i2*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	-e2p((2*i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))*q^2+q*e2p((i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))+q*e2p((i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))-e2p((i2*k1)*S(1//(q-1)))*q^2+q*e2p((i2*k1)*S(1//(q-1)))-e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))+q*e2p((i2*k1)*S(1//(q-1)))-e2p((i2*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))-e2p((i2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	2*q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	2*q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	2*q*e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	2*q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	2*q*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	-e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))-e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))-e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q*(1+2*q^2+2*q^4+q^6)*e2p((2*i1*k1)*S(1//(q-1))),
	q*(q^4+2*q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*(2*q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*(2*q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q^3*e2p((2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^4+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^4+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1))),
	q^3*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1)))*q^3+q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^3+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1)))*q^3+q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^3-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))+q^3*e2p((i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))*q^2+q*e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))+q*e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))+q^3*e2p((i2*k1)*S(1//(q-1)))-e2p((i2*k1)*S(1//(q-1)))*q^2+q*e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))+q*e2p((i2*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))-e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))-e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+q*e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	q*e2p((i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+q*e2p((i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))-e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))-e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q^2*(1+2*q^2+2*q^4+q^6)*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*(q^2+q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*(q^2-q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^2*e2p((2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^5+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^5+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^4+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+q^4*e2p((2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^4,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^4,
	q^2*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	q^2*e2p((2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q,
	q^2*e2p((2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q,
	-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^4+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^3+e2p((2*i2*k1)*S(1//(q-1)))*q^3+q*e2p((2*i2*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	q*e2p((2*i2*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((2*i2*k1)*S(1//(q-1)))*q^3-q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^4-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^3+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	-q*e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	-q*e2p((2*i2*k1)*S(1//(q-1))),
	-q*e2p((2*i2*k1)*S(1//(q-1)))-2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^3+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+e2p((i2*k1)*S(1//(q-1)))*q^2+q*e2p((i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+q*e2p((i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^2-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^3+e2p((i2*k1)*S(1//(q-1)))*q^2-q*e2p((i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q-q*e2p((i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i2*k1)*S(1//(q-1)))+q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i2*k1)*S(1//(q-1)))-q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-q*e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1)))*q,
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1)))*q,
	-e2p((i3*k1)*S(1//(q-1))),
	-e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1)))*q,
	-e2p((i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1)))*q,
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	-e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q^2*(1+2*q^2+2*q^4+q^6)*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*(q^4+2*q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q^2*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^4*e2p((2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+q^2*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^4+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q,
	q^4*e2p((2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+q^2*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q,
	-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+q^2*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^3+q^4*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	q^2*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q^4*e2p((2*i2*k1)*S(1//(q-1)))+q^2*e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^3+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q^2*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^3+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+q^3*e2p((i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))*q^2+q*e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+q*e2p((i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^2-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^3+e2p((i2*k1)*S(1//(q-1)))*q^2-q*e2p((i2*k1)*S(1//(q-1)))-q^3*e2p((i2*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q-q*e2p((i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	2*q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	2*q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	-2*q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-2*q*e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+q*e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1)))*q,
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	q*e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-q*e2p((i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-q*e2p((i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1)))*q,
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q^2*(1+2*q^2+2*q^4+q^6)*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*(q^2+q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*(q^2-q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^2*e2p((2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^5+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^5+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^4+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+q^4*e2p((2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^4,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^4,
	q^2*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	q^2*e2p((2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q,
	q^2*e2p((2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q,
	-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^4+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^3+e2p((2*i2*k1)*S(1//(q-1)))*q^3+q*e2p((2*i2*k1)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	q*e2p((2*i2*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	q*e2p((2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((2*i2*k1)*S(1//(q-1)))*q^3-q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^4-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^3+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	-q*e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	-q*e2p((2*i2*k1)*S(1//(q-1))),
	-q*e2p((2*i2*k1)*S(1//(q-1)))-2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))+q^3*e2p((i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))*q^2+q*e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))+q*e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^2-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))*q^2-q*e2p((i2*k1)*S(1//(q-1)))-q^3*e2p((i2*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))-q*e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i2*k1)*S(1//(q-1)))+q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	q^2*e2p((2*i2*k1)*S(1//(q-1)))-q*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-q*e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+q*e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*e2p((i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	q*e2p((i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-q*e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	-e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q^3*(1+2*q^2+2*q^4+q^6)*e2p((2*i1*k1)*S(1//(q-1))),
	q^3*(q^2+1)*e2p((2*i1*k1)*S(1//(q-1))),
	q^3*(q+1)*e2p((2*i1*k1)*S(1//(q-1))),
	-(q-1)*q^3*e2p((2*i1*k1)*S(1//(q-1))),
	q^3*e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^3*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^5+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^4+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+q^5*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^5-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^4+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	q^3*e2p((2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	q*(q+1)*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1))),
	-(q-1)*q*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q,
	e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^4*e2p((2*i2*k1)*S(1//(q-1)))+q^2*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^3+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^4+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2,
	q^2*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q^4*e2p((2*i2*k1)*S(1//(q-1)))-q^2*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^3-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^4+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2,
	-q^2*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^3+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+q^3*e2p((i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))*q^2+q*e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+q*e2p((i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^3-e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+q^3*e2p((i2*k1)*S(1//(q-1)))-e2p((i2*k1)*S(1//(q-1)))*q^2+q*e2p((i2*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1)*S(1//(q-1)))*q+q*e2p((i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	2*q^2*e2p((2*i2*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1)*S(1//(q-1))),
	-2*q^2*e2p((2*i2*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2-1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+q*e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1)))*q,
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-2*q*e2p((1//2*q*i1-1//2*i1+2*i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q*e2p((i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-q*e2p((i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))+q*e2p((i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1)))*q,
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	-e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+i3*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+i3*k1)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))-e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1)*S(1//(q-1)))-e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*(1+q^4+q^2+q+q^3+q^5)*e2p((2*i1*k1+i1)*S(1//(q-1))),
	-(q^4+1)*e2p((2*i1*k1+i1)*S(1//(q-1))),
	(q-1)*(q^2+q+1)*e2p((2*i1*k1+i1)*S(1//(q-1))),
	-(q^3+1)*e2p((2*i1*k1+i1)*S(1//(q-1))),
	-e2p((2*i1*k1+i1)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((2*i1*k1+i1)*S(1//(q-1))),
	-(q^2+1)*e2p((2*i1*k1+i1)*S(1//(q-1))),
	-e2p((2*i1*k1+i1)*S(1//(q-1))),
	-e2p((2*i1*k1+i1)*S(1//(q-1))),
	-e2p((2*i1*k1+i1)*S(1//(q-1))),
	-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^4+e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^4,
	e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q^2-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^3-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))+e2p((2*i2*k1+i2)*S(1//(q-1)))*q^2-e2p((2*i2*k1+i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))-e2p((2*i2*k1+i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))+e2p((2*i2*k1+i2)*S(1//(q-1)))*q-e2p((2*i2*k1+i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))-e2p((2*i2*k1+i2)*S(1//(q-1)))*q-e2p((2*i2*k1+i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))-e2p((2*i2*k1+i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^3-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^2-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))+e2p((2*i2*k1+i2)*S(1//(q-1)))*q^2-e2p((2*i2*k1+i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^2-e2p((2*i2*k1+i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))+e2p((2*i2*k1+i2)*S(1//(q-1)))*q-e2p((2*i2*k1+i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))-e2p((2*i2*k1+i2)*S(1//(q-1)))*q-e2p((2*i2*k1+i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))-e2p((2*i2*k1+i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))*q^2-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))*q^2-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))*q^2-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))*q^2-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))-2*e2p((1//2*q*i1-1//2*i1+i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))-2*e2p((1//2*q*i1-1//2*i1+i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))+e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i4+2*i4*k1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4+2*i4*k1+q*i1-i1+q*i3-i3)*S(1//(2*(q-1))))-e2p((i4*q+2*i4*k1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4*q+2*i4*k1+q*i1-i1+q*i3-i3)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	-e2p((i4+2*i4*k1+q*i1-i1+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4+2*i4*k1+q*i1-i1+q*i3-i3)*S(1//(2*(q-1))))-e2p((i4*q+2*i4*k1+q*i1-i1+q*i3-i3)*S(1//(2*(q-1))))-e2p((i4*q+2*i4*k1+q*i1-i1+q*i2-i2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	-e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1-i1+i3+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i1-i1+q*i3+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0))] [
	(q-1)*q*(1+q^4+q^2+q+q^3+q^5)*e2p((2*i1*k1+i1)*S(1//(q-1))),
	-q*(q^2+1)*e2p((2*i1*k1+i1)*S(1//(q-1))),
	(q-1)*q*(q^2+1)*e2p((2*i1*k1+i1)*S(1//(q-1))),
	-q*(q^2+q+1+q^3)*e2p((2*i1*k1+i1)*S(1//(q-1))),
	-q*e2p((2*i1*k1+i1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q*e2p((2*i1*k1+i1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-2*q*e2p((2*i1*k1+i1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^5-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^5-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q+e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q^3,
	1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^4-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^4-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2,
	-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q^2-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q^2-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	-e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i2*k1+i2)*S(1//(q-1)))*q^2-e2p((2*i2*k1+i2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^4-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^3+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^2-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q,
	-e2p((2*i2*k1+i2)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q,
	e2p((2*i2*k1+i2)*S(1//(q-1)))*(q-1),
	-e2p((2*i2*k1+i2)*S(1//(q-1)))*q-e2p((2*i2*k1+i2)*S(1//(q-1)))-2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q,
	-e2p((2*i2*k1+i2)*S(1//(q-1))),
	e2p((2*i2*k1+i2)*S(1//(q-1)))-e2p((2*i2*k1+i2)*S(1//(q-1)))*q^2-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^4-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^3-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^2-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q,
	e2p((2*i2*k1+i2)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q,
	-e2p((2*i2*k1+i2)*S(1//(q-1)))*q+e2p((2*i2*k1+i2)*S(1//(q-1)))-2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q,
	(q+1)*e2p((2*i2*k1+i2)*S(1//(q-1))),
	e2p((2*i2*k1+i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))*q^2-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))*q^2-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))*q^2+1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))*q^2+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((1//2*q*i1-1//2*i1+i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q+e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q+e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))+e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-2*q*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i4+2*i4*k1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4+2*i4*k1+q*i1-i1+q*i3-i3)*S(1//(2*(q-1))))-e2p((i4*q+2*i4*k1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4*q+2*i4*k1+q*i1-i1+q*i3-i3)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	e2p((i4+2*i4*k1+q*i1-i1+q*i2-i2)*S(1//(2*(q-1))))+e2p((i4+2*i4*k1+q*i1-i1+q*i3-i3)*S(1//(2*(q-1))))+e2p((i4*q+2*i4*k1+q*i1-i1+q*i3-i3)*S(1//(2*(q-1))))+e2p((i4*q+2*i4*k1+q*i1-i1+q*i2-i2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	-e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((q*i1-i1+i3+2*i3*k1)*S(1//(2*(q-1))))+e2p((q*i1-i1+q*i3+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0))] [
	(q-1)*q^2*(1+q^4+q^2+q+q^3+q^5)*e2p((2*i1*k1+i1)*S(1//(q-1))),
	-q^2*(q^4+1)*e2p((2*i1*k1+i1)*S(1//(q-1))),
	(q-1)*q^2*(q+1)*e2p((2*i1*k1+i1)*S(1//(q-1))),
	(q-1)*q^2*(q+1)*e2p((2*i1*k1+i1)*S(1//(q-1))),
	-q^2*e2p((2*i1*k1+i1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q^2*e2p((2*i1*k1+i1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^4+e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q^4-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q^2,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^3+e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q^4-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q^2,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^3-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q^2,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	e2p((2*i2*k1+i2)*S(1//(q-1)))*q^4-e2p((2*i2*k1+i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^3-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((2*i2*k1+i2)*S(1//(q-1)))*q^2-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^2+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	e2p((2*i2*k1+i2)*S(1//(q-1)))*q^4-e2p((2*i2*k1+i2)*S(1//(q-1)))*q^2-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^3-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^2-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((2*i2*k1+i2)*S(1//(q-1)))*q^2-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^2,
	-(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))*q^2+1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))*q^2+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))*q^2+1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))*q^2+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))-2*e2p((1//2*q*i1-1//2*i1+i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))-2*e2p((1//2*q*i1-1//2*i1+i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))+e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i4+2*i4*k1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4+2*i4*k1+q*i1-i1+q*i3-i3)*S(1//(2*(q-1))))-e2p((i4*q+2*i4*k1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4*q+2*i4*k1+q*i1-i1+q*i3-i3)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	-e2p((i4+2*i4*k1+q*i1-i1+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4+2*i4*k1+q*i1-i1+q*i3-i3)*S(1//(2*(q-1))))-e2p((i4*q+2*i4*k1+q*i1-i1+q*i3-i3)*S(1//(2*(q-1))))-e2p((i4*q+2*i4*k1+q*i1-i1+q*i2-i2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))+e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((q*i1-i1+i3+2*i3*k1)*S(1//(2*(q-1))))+e2p((q*i1-i1+q*i3+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0))] [
	(q-1)*q^3*(1+q^4+q^2+q+q^3+q^5)*e2p((2*i1*k1+i1)*S(1//(q-1))),
	-q^3*(q^2+1)*e2p((2*i1*k1+i1)*S(1//(q-1))),
	(q-1)*q^3*e2p((2*i1*k1+i1)*S(1//(q-1))),
	-q^3*(q+1)*e2p((2*i1*k1+i1)*S(1//(q-1))),
	-q^3*e2p((2*i1*k1+i1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q^5-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^5+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^5-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^4-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^4-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2,
	-e2p((1//2*q-1//2+2*i1*k1+i1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	(q-1)*q*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1))),
	-q*(q+1)*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	-e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^4-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^3+e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^2-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q-e2p((2*i2*k1+i2)*S(1//(q-1)))*q^2+e2p((2*i2*k1+i2)*S(1//(q-1)))*q^4,
	-e2p((2*i2*k1+i2)*S(1//(q-1)))*q^2-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^4-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^3-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q^2-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q+e2p((2*i2*k1+i2)*S(1//(q-1)))*q^2-e2p((2*i2*k1+i2)*S(1//(q-1)))*q^4,
	e2p((2*i2*k1+i2)*S(1//(q-1)))*q^2-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q,
	-2*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))+e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q+e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//4*q^2-1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q^2-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-(q-1)*e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+2*i2*k1+1//2*q*i2+1//2*i2)*S(1//(q-1))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))*q^2+1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))*q^2+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))*q^2-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))*q^2-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1+2*k1)*S(1//(2*(q-1)))),
	e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((1//2*q*i1-1//2*i1+i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))-e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	-e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	-e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q+e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))*q+e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	e2p((q*i1-i1+i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))+e2p((q*i1-i1+q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1)))*q+e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	e2p((1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1)*S(1//(q-1)))+e2p((1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k1)*S(1//(q-1))),
	2*q*e2p((1//2*q*i1-1//2*i1+2*i2*k1+i2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i4+2*i4*k1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4+2*i4*k1+q*i1-i1+q*i3-i3)*S(1//(2*(q-1))))-e2p((i4*q+2*i4*k1+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4*q+2*i4*k1+q*i1-i1+q*i3-i3)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	e2p((i4+2*i4*k1+q*i1-i1+q*i2-i2)*S(1//(2*(q-1))))+e2p((i4+2*i4*k1+q*i1-i1+q*i3-i3)*S(1//(2*(q-1))))+e2p((i4*q+2*i4*k1+q*i1-i1+q*i3-i3)*S(1//(2*(q-1))))+e2p((i4*q+2*i4*k1+q*i1-i1+q*i2-i2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	e2p((i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1))))+e2p((q*i3+q*i2-i2+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1-i1+i3+2*i3*k1)*S(1//(2*(q-1))))-e2p((q*i1-i1+q*i3+2*i3*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0))] [
	(1+q^4+q^2+q+q^3+q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^4+q^3+q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^2+q+1+q^3)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^2+q+1+q^3)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(q^2+q+1+q^3)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(q^2+q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))+e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))+e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))+e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1))),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1))),
	(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1))),
	(q+1)*e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i4*k1-i3*k1+i4*k2)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((i2*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i4*k2)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((i3*k1+i4*k2)*S(1//(q-1))),
	e2p((i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((i2*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i4*k2)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i4*k2)*S(1//(q-1))),
	e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1))),
	e2p((i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i4*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	1//2*q*(1+4*q^4+4*q^2+3*q+q^7+4*q^3+3*q^6+4*q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*q*(1+2*q^4+3*q^2+3*q+2*q^3+q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*q*(2*q^3+5*q^2+4*q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*q*(q^2+2*q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*q*(2*q^2+3*q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*q*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5+3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4+3//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+3//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*(q^2+2*q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^4+2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+1//2*e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+1//2*e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+1//2*e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	1//2*e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+1//2*e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+1//2*e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+3*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i2*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^3+2*e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^2+2*e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	2*e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))+2*e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i3*k2)*S(1//(q-1)))+2*e2p((i3*k1+2*i3*k2)*S(1//(q-1)))*q+2*e2p((i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i2*k1+2*i3*k2)*S(1//(q-1)))+2*e2p((i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1))),
	2*e2p((i1*k1+i3*k2)*S(1//(q-1)))*q+2*e2p((i1*k1+i3*k2)*S(1//(q-1)))+2*e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+2*e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i3*k2)*S(1//(q-1))),
	2*e2p((i1*k1+i3*k2)*S(1//(q-1)))+2*e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((i4*k1-i3*k1+i4*k2)*S(1//(q-1)))+2*e2p((i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+2*e2p((i2*k1+i4*k2)*S(1//(q-1)))+2*e2p((i1*k1+i4*k2)*S(1//(q-1)))+2*e2p((i4*k1-i2*k1+i4*k2)*S(1//(q-1)))+2*e2p((i3*k1+i4*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1+i3*k2)*S(1//(q-1)))-e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	1//2*q*(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*q*(1+2*q^4+3*q^2+q+2*q^3+q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*q*(3*q^2+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*q*(2*q^3+3*q^2+2*q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*q*(2*q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	1//2*q*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*(q^2-4*q-1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*(3*q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	1//2*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+1//2*e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+1//2*e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+1//2*e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	1//2*e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+1//2*e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+1//2*e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	q*(q^2+q+1+q^3)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^3+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i3*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q,
	e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))-e2p((i2*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))-e2p((i2*k1+i3*k2)*S(1//(q-1))),
	-(q+1)*e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i4*k1-i3*k1+i4*k2)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((i2*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i4*k2)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((i3*k1+i4*k2)*S(1//(q-1))),
	e2p((i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((i2*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i4*k2)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i4*k2)*S(1//(q-1))),
	-e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))-e2p((i2*k1+i3*k2)*S(1//(q-1))),
	-e2p((i4*k1-i1*k1+i4*k2)*S(1//(q-1)))-e2p((i1*k1+i4*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	1//2*q*(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*q*(-1-q^2-q+q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*q*(2*q^3+3*q^2+2*q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*(q-1)*q*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*q*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*(q-1)*q*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5+3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	1//2*(q-1)*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^4+1//2*e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+1//2*e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+1//2*e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^3,
	-1//2*e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q-1//2*e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+1//2*e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q^2+q+1+q^3)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q^2+q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q,
	1//2*q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	q*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))*q,
	e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1))),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i3*k2)*S(1//(q-1)))-e2p((i3*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i3*k2)*S(1//(q-1)))-e2p((i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1))),
	(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+i3*k2)*S(1//(q-1)))*q-e2p((i1*k1+i3*k2)*S(1//(q-1)))-e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q-e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	-e2p((i1*k1+i3*k2)*S(1//(q-1)))-e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i3*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-(q+1)*e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i4*k1-i3*k1+i4*k2)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((i2*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i4*k2)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((i3*k1+i4*k2)*S(1//(q-1))),
	-e2p((i4*k1-i1*k1+i4*k2)*S(1//(q-1)))-e2p((i2*k1+i4*k2)*S(1//(q-1)))-e2p((i1*k1+i4*k2)*S(1//(q-1)))-e2p((i4*k1-i2*k1+i4*k2)*S(1//(q-1))),
	e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1))),
	-e2p((i4*k1-i1*k1+i4*k2)*S(1//(q-1)))-e2p((i1*k1+i4*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	1//2*(q-1)^2*q*(1+q^4+q^2+q+q^3+q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*(q-1)*q*(q^4+q^3+q^2+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*(q-1)^2*q*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*q*(2*q^3+q^2+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*(q-1)*q*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-1//2*(q-1)*q*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5,
	1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1)^2,
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	-1//2*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^3-e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+1//2*e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^3-e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+1//2*e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	-1//2*e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q-1//2*e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+1//2*e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(q-1)*(q^2+q+1+q^3)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q^2+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*q*e2p((i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i3*k2)*S(1//(q-1)))-e2p((2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q-e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1)))*q-e2p((i2*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))-e2p((i2*k1+i3*k2)*S(1//(q-1))),
	-2*(q+1)*e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	-2*e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((i4*k1-i1*k1+i4*k2)*S(1//(q-1)))-2*e2p((i1*k1+i4*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q^4*(1+q^4+q^2+q+q^3+q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4,
	2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^5+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5,
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4,
	e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^4+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^4+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^4+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2,
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*(q^2+q+1+q^3)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^3+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-e2p((i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q^2-e2p((-i2*k1+k1+k2+2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))*q,
	e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i3*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((i3*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q,
	-e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+i3*k2)*S(1//(q-1)))*q-e2p((i1*k1+i3*k2)*S(1//(q-1)))-e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q-e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	-e2p((i1*k1+i3*k2)*S(1//(q-1)))-e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q-e2p((i2*k1+i3*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(q+1)*e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i4*k1-i3*k1+i4*k2)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((i2*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i4*k2)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((i3*k1+i4*k2)*S(1//(q-1))),
	-e2p((i4*k1-i1*k1+i4*k2)*S(1//(q-1)))-e2p((i2*k1+i4*k2)*S(1//(q-1)))-e2p((i1*k1+i4*k2)*S(1//(q-1)))-e2p((i4*k1-i2*k1+i4*k2)*S(1//(q-1))),
	-e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))-e2p((i2*k1+i3*k2)*S(1//(q-1))),
	e2p((i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i4*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*(1+q^2+q^4)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q^4-q^3+q^2-q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q^2+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q^2+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q^2-q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	-(q^2-q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q^2+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q^2-q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^3-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	-e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	-e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	(q-1)*e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i3*k2*q+i3*k2+i3*k1)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+i3*k2*q+i3*k2+i3*k1)*S(1//(q^2-1))),
	-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i3*k2*q+i3*k2+i3*k1)*S(1//(q^2-1))),
	-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k2+2*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k2+2*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))-e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i2*k1*q-i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i2*k1*q-i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-e2p((-i3*k1*q+i3*k1+i4*k1*q+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-e2p((-i3*k1*q+i3*k1+i4*k1*q+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((i2*k1*q-i2*k1+i4*k2*q+i4*k2+i4*k1)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k1*q+i4*k2*q+i4*k2)*S(1//(q^2-1))),
	-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i3*k1*q+i3*k1+i4*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+q*i1*k1-i1*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i2*k1*q-i2*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1))),
	-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0))] [
	1//2*(q-1)*q*(1+2*q^4+2*q^2+2*q+2*q^3+q^6+2*q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*q*(1+q^2+q+q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*(q-1)*q*(2*q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*q*(q^2+2*q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*q*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-1//2*q*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*(q^2+2*q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	-1//2*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q^2+q+1+q^3)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q^2+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-1//2*e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-1//2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	-1//2*e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-1//2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q^2-e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2-e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q,
	-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q,
	-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q,
	1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2+1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2+1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	-1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	2*(q-1)*e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	-2*e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((-i3*k1*q+i3*k1+i4*k1*q+i4*k2*q+i4*k2)*S(1//(q^2-1)))-2*e2p((i4*k1+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0))] [
	1//2*(q-1)*q*(1+2*q^2+2*q^4+q^6)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*q*(1+q^2-q+q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*(q-1)*q*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*(q-1)*q*(2*q^2-q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*(q-1)*q*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*q*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*(q-1)*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	-1//2*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	(q-1)*(q^2+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q^2-q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^4-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-1//2*e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3-1//2*e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-1//2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3-1//2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q-1//2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-1//2*e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	(0)*e2p(S(0)),
	-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2-e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q^2-e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q,
	e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2+1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2+1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	-1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	(q-1)*e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q,
	(0)*e2p(S(0)),
	e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i3*k2*q+i3*k2+i3*k1)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+i3*k2*q+i3*k2+i3*k1)*S(1//(q^2-1))),
	-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i3*k2*q+i3*k2+i3*k1)*S(1//(q^2-1))),
	-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i3*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k2+2*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q,
	e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i2*k1*q-i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((i3*k1-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i2*k1*q-i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-e2p((-i3*k1*q+i3*k1+i4*k1*q+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-e2p((-i3*k1*q+i3*k1+i4*k1*q+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((i2*k1*q-i2*k1+i4*k2*q+i4*k2+i4*k1)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k1*q+i4*k2*q+i4*k2)*S(1//(q^2-1))),
	e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i4*k1*q+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((-i3*k1*q+i3*k1+i4*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((i4*k1*q+q*i1*k1-i1*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((i4*k1*q+i2*k1*q-i2*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i4*k1+i4*k2*q+i4*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	1//2*(q-1)*q*(1+2*q^2+2*q^4+q^6)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*q*(-1-2*q^4-3*q^2+q+2*q^3+q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*(q-1)*q*(2*q^2-q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*q*(3*q^2+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*q*(2*q^2-q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	1//2*(q-1)*q*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4,
	-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*(q^2+4*q-1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*(3*q-1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	1//2*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*(q^2+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-1//2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^3-1//2*e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3-1//2*e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-1//2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+1//2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+1//2*e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3,
	-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2-e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q^2-e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	-1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q,
	(q-1)*e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q,
	e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((q*i1*k1-i1*k1+i3*k2*q+i3*k2+i3*k1)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+i3*k2*q+i3*k2+i3*k1)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((q*i1*k1-i1*k1+i3*k2*q+i3*k2+i3*k1)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((i3*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k2*q+2*i3*k2+2*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k2*q+2*i3*k2+2*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q-i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q,
	e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-e2p((-i3*k1*q+i3*k1+i4*k1*q+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	e2p((-i2*k1*q+i2*k1+i4*k1*q+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((i2*k1*q-i2*k1+i4*k2*q+i4*k2+i4*k1)*S(1//(q^2-1)))+e2p((-i3*k1*q+i3*k1+i4*k1*q+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((i4*k1+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1))),
	-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i4*k1*q+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((-i3*k1*q+i3*k1+i4*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((i4*k1*q+q*i1*k1-i1*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((i4*k1*q+i2*k1*q-i2*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i4*k1+i4*k2*q+i4*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	1//2*(q-1)^3*q*(1+q^2+q^4)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*(q-1)^2*q*(q^3+q-1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*(q-1)^2*q*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*(q-1)^2*q*(2*q-1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*(q-1)*q*(2*q-1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	1//2*(q-1)*q*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4-3//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+3//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5+3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4-2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1)^2,
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-3//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^4-1//2*e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3+e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+1//2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+1//2*e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-3*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3+2*e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3+2*e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-2*e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-2*e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2-e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q^2-e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+1//2*e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	-1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q,
	1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((i3*k1+2*i3*k2)*S(1//(q-1)))*q+2*e2p((i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k2+2*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k2*q+2*i3*k2+2*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	2*e2p((i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k2*q+2*i3*k2+2*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-2*e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+2*e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i2*k1*q-i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q-i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-2*e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+2*e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	2*e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i2*k1*q-i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+2*e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((i4*k1*q+q*i1*k1-i1*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+2*e2p((-i3*k1*q+i3*k1+i4*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+2*e2p((i4*k1*q+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+2*e2p((-i2*k1*q+i2*k1+i4*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+2*e2p((i4*k1*q+i2*k1*q-i2*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+2*e2p((-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i4*k2)*S(1//(q^2-1))),
	-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0))] [
	(q-1)*q^4*(1+q^2+q^4)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4,
	(0)*e2p(S(0)),
	-2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^5-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4,
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4,
	-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	(0)*e2p(S(0)),
	-2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*q*(q^2+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^4+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^4-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^4,
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*q*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*q*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2-e2p((2*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q^2,
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i2*k1*q+i2*k1+q*k1+k2*q+k2+2*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2+e2p((k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q,
	e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q,
	(0)*e2p(S(0)),
	-e2p((q*i1*k1-i1*k1+i3*k2*q+i3*k2+i3*k1)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+i3*k2*q+i3*k2+i3*k1)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((q*i1*k1-i1*k1+i3*k2*q+i3*k2+i3*k1)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k2*q+2*i3*k2+2*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q+e2p((i3*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i3*k1-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q-i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-e2p((-i3*k1*q+i3*k1+i4*k1*q+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	e2p((-i2*k1*q+i2*k1+i4*k1*q+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((i2*k1*q-i2*k1+i4*k2*q+i4*k2+i4*k1)*S(1//(q^2-1)))+e2p((-i3*k1*q+i3*k1+i4*k1*q+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((i4*k1+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1))),
	e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i3*k1*q+i3*k1+i4*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+q*i1*k1-i1*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i2*k1*q-i2*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1))),
	-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0))] [
	(q+q^5+2*q^3+q^2+q^4+1+q^6)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^2+q+1+q^3)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(2*q^3+2*q^2+q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^2+q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^2+2*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(2*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^4+2*q^3+2*q^2+2*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^2+q+1+q^3)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^2+2*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(2*q^2+3*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(2*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	2*e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))+2*e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i2*k2)*S(1//(q-1)))+e2p((3*i1*k1+i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-3*i1*k1+i2*k2)*S(1//(q-1))),
	e2p((2*i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i2*k2)*S(1//(q-1)))+e2p((3*i1*k1+i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-3*i1*k1+i2*k2)*S(1//(q-1))),
	e2p((2*i2*k1-i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i2*k2)*S(1//(q-1)))+e2p((3*i1*k1+i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-3*i1*k1+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((5*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((5*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((2*i1*k1+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((5*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((5*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((2*i1*k1+i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((5*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((2*i1*k1+i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((5*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2+2*q+1)*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1))),
	(q+1)*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1))),
	(q+1)*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((3*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((4*i1*k1-i2*k1+k2+2*i1*k2+3//2*k1+1//2*q*k1)*S(1//(q-1)))*q^2+e2p((4*i1*k1-i2*k1+k2+2*i1*k2+3//2*k1+1//2*q*k1)*S(1//(q-1)))+e2p((i2*k1+2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1)))*q^2+e2p((i2*k1+2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	e2p((4*i1*k1-i2*k1+k2+2*i1*k2+3//2*k1+1//2*q*k1)*S(1//(q-1)))+e2p((i2*k1+2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	e2p((4*i1*k1-i2*k1+k2+2*i1*k2+3//2*k1+1//2*q*k1)*S(1//(q-1)))+e2p((i2*k1+2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((5*i3*k1-i2*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((5*i3*k1-i2*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i1*k1+3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i1*k1+3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((3*i3*k1-i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i3*k1+2*i3*k2)*S(1//(q-1))),
	e2p((5*i3*k1-i2*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i1*k1+3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k1+2*i3*k2)*S(1//(q-1))),
	e2p((2*i1*k1+i2*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-2*i1*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1+i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i2*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i2*k1+2*i1*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-2*i1*k1+i2*k1+i3*k2)*S(1//(q-1))),
	e2p((2*i1*k1+i2*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-2*i1*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1+i2*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i2*k1+2*i1*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-2*i1*k1+i2*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i1*k1+5*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((-i1*k1+5*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((-i1*k1+5*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1+i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i2*k1+i3*k2)*S(1//(q-1))),
	e2p((2*i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1+i2*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+i3*k1+i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i1*k1-i3*k1+i2*k1+i4*k2)*S(1//(q-1)))+e2p((3*i4*k1-i3*k1-i2*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i2*k1-i1*k1+i3*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i4*k1-i3*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i3*k1-i2*k1+i1*k1+i4*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k1+i4*k1-i2*k1+i4*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((-i1*k1-i2*k1+3*i3*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i3*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k1+2*i3*k1+i3*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1+i3*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i1*k1+3*i2*k1+i2*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q*(1+3*q^4+2*q^2+2*q+q^7+3*q^3+2*q^6+2*q^5)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^4+2*q^3+2*q^2+2*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(2*q^3+3*q^2+2*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^2+2*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^2+2*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(q^5+3*q^4+4*q^3+4*q^2+3*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^4+2*q^3+2*q^2+2*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^3+3*q^2+3*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(3*q^2+4*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^2+2*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^2+2*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^2+2*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(3*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^4+2*e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+2*e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^4,
	e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	3*e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))+3*e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i2*k1-i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-3*i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((3*i2*k1-3*i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((3*i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((3*i1*k1+i2*k2)*S(1//(q-1)))*q+2*e2p((i2*k1+i1*k1+i2*k2)*S(1//(q-1)))*q+2*e2p((i2*k1+i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k1+i2*k2)*S(1//(q-1)))*q^3+2*e2p((2*i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^2+2*e2p((2*i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^3,
	2*e2p((2*i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2)*S(1//(q-1)))+2*e2p((i2*k1+i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i2*k2)*S(1//(q-1)))+e2p((3*i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-3*i1*k1+i2*k2)*S(1//(q-1)))*q,
	e2p((2*i2*k1-i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+4*e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+2*e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+2*e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+4*e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+2*e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	2*e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+2*e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+2*e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+2*e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	2*e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+2*e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+2*e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+2*e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	2*e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+2*e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	2*e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+2*e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k1+2*i2*k2)*S(1//(q-1)))+2*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+4*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((5*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((5*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((5*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((2*i1*k1+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k1+2*i2*k2)*S(1//(q-1)))+2*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((5*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((5*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((2*i1*k1+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k1+2*i2*k2)*S(1//(q-1)))+2*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((5*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((5*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((2*i1*k1+i2*k1+2*i2*k2)*S(1//(q-1)))+2*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((5*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((5*i3*k1-i2*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q+2*e2p((5*i3*k1-i2*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+2*e2p((i1*k1+3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))*q+2*e2p((i1*k1+3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+2*e2p((3*i3*k1-i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))*q+2*e2p((3*i3*k1-i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))+2*e2p((i1*k1+i2*k1+i3*k1+2*i3*k2)*S(1//(q-1)))*q+2*e2p((i1*k1+i2*k1+i3*k1+2*i3*k2)*S(1//(q-1))),
	2*e2p((5*i3*k1-i2*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+2*e2p((i1*k1+3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+2*e2p((3*i3*k1-i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))+2*e2p((i1*k1+i2*k1+i3*k1+2*i3*k2)*S(1//(q-1))),
	e2p((2*i1*k1+i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k1+i3*k2)*S(1//(q-1)))+2*e2p((2*i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q+2*e2p((2*i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-2*i1*k1-i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((3*i3*k1-2*i1*k1-i2*k1+i3*k2)*S(1//(q-1)))+2*e2p((i3*k1+i2*k1+i3*k2)*S(1//(q-1)))*q+2*e2p((i3*k1+i2*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i2*k1+2*i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1-i2*k1+2*i1*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-2*i1*k1+i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((2*i3*k1-2*i1*k1+i2*k1+i3*k2)*S(1//(q-1))),
	e2p((2*i1*k1+i2*k1+i3*k2)*S(1//(q-1)))+2*e2p((2*i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-2*i1*k1-i2*k1+i3*k2)*S(1//(q-1)))+2*e2p((i3*k1+i2*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i2*k1+2*i1*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-2*i1*k1+i2*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((i2*k1+i3*k1+i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+2*e2p((2*i4*k1-i1*k1-i3*k1+i2*k1+i4*k2)*S(1//(q-1)))+2*e2p((3*i4*k1-i3*k1-i2*k1-i1*k1+i4*k2)*S(1//(q-1)))+2*e2p((2*i4*k1-i2*k1-i1*k1+i3*k1+i4*k2)*S(1//(q-1)))+2*e2p((i1*k1+i2*k1+i3*k1+i4*k2)*S(1//(q-1)))+2*e2p((i1*k1+i2*k1+i4*k1-i3*k1+i4*k2)*S(1//(q-1)))+2*e2p((2*i4*k1-i3*k1-i2*k1+i1*k1+i4*k2)*S(1//(q-1)))+2*e2p((i3*k1+i1*k1+i4*k1-i2*k1+i4*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i1*k1+3*i2*k1+i2*k2)*S(1//(q-1)))-e2p((i1*k1+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q^3*(q+q^5+2*q^3+q^2+q^4+1+q^6)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q^3*(q^2+q+1+q^3)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q^3*(q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q^3*(q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q^3*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*(q^4+2*q^3+2*q^2+2*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^2+q+1+q^3)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^2+2*q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q*(q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^4+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^4,
	e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+i1*k1+i2*k2)*S(1//(q-1)))*q^3+e2p((2*i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^3+e2p((3*i2*k1-3*i1*k1+i2*k2)*S(1//(q-1)))*q^3+e2p((3*i1*k1+i2*k2)*S(1//(q-1)))*q^3+e2p((i2*k1+i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i2*k2)*S(1//(q-1)))*q^2,
	e2p((2*i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((4*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((5*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((5*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	(q+1)*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((2*i1*k1+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((5*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((3*i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q^2+2*q+1)*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q+1)*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q+1)*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((3*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((4*i1*k1-i2*k1+k2+2*i1*k2+3//2*k1+1//2*q*k1)*S(1//(q-1)))*q^2-e2p((4*i1*k1-i2*k1+k2+2*i1*k2+3//2*k1+1//2*q*k1)*S(1//(q-1)))-e2p((i2*k1+2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1)))*q^2-e2p((i2*k1+2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((4*i1*k1-i2*k1+k2+2*i1*k2+3//2*k1+1//2*q*k1)*S(1//(q-1)))-e2p((i2*k1+2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((4*i1*k1-i2*k1+k2+2*i1*k2+3//2*k1+1//2*q*k1)*S(1//(q-1)))-e2p((i2*k1+2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((5*i3*k1-i2*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((5*i3*k1-i2*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i1*k1+3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i1*k1+3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((3*i3*k1-i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i3*k1+2*i3*k2)*S(1//(q-1))),
	e2p((5*i3*k1-i2*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i1*k1+3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k1+2*i3*k2)*S(1//(q-1))),
	e2p((2*i1*k1+i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-2*i1*k1-i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i2*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i2*k1+2*i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((2*i3*k1-2*i1*k1+i2*k1+i3*k2)*S(1//(q-1)))*q,
	e2p((2*i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1+i2*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i1*k1+5*i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((-i1*k1+5*i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((-i1*k1+5*i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q-e2p((2*i3*k1-i2*k1+i3*k2)*S(1//(q-1)))-e2p((i3*k1+i2*k1+i3*k2)*S(1//(q-1)))*q-e2p((i3*k1+i2*k1+i3*k2)*S(1//(q-1))),
	-e2p((2*i3*k1-i2*k1+i3*k2)*S(1//(q-1)))-e2p((i3*k1+i2*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+i3*k1+i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i1*k1-i3*k1+i2*k1+i4*k2)*S(1//(q-1)))+e2p((3*i4*k1-i3*k1-i2*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i2*k1-i1*k1+i3*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i4*k1-i3*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i3*k1-i2*k1+i1*k1+i4*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k1+i4*k1-i2*k1+i4*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((-i1*k1-i2*k1+3*i3*k1+i3*k2)*S(1//(q-1)))-e2p((i2*k1+i1*k1+i3*k2)*S(1//(q-1)))-e2p((-i1*k1+i2*k1+2*i3*k1+i3*k2)*S(1//(q-1)))-e2p((i1*k1-i2*k1+i3*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i1*k1+3*i2*k1+i2*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)^2*(q^4+q^3+2*q^2+q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*(q^2+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*(2*q^2+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^2-q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)^2*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(2*q-1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)^2*(q^2+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*(q^2+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)^2*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(2*q-1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(2*q-1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3+e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3+e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-2*e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-2*e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((3*q*i1*k1-3*i1*k1+3*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-3*q*i1*k1+3*i1*k1+3*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((3*q*i1*k1-3*i1*k1+3*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-3*q*i1*k1+3*i1*k1+3*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((3*q*i1*k1-3*i1*k1+3*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-3*q*i1*k1+3*i1*k1+3*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1)^2,
	-e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	e2p((3*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2-2*e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q^2-2*e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-2*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-2*q*i1*k1+2*i1*k1+5*i2*k1*q+i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+5*i2*k1*q+i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+i2*k1*q+5*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+i2*k1*q+5*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-2*q*i1*k1+2*i1*k1+5*i2*k1*q+i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+5*i2*k1*q+i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+i2*k1*q+5*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+i2*k1*q+5*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((-2*q*i1*k1+2*i1*k1+5*i2*k1*q+i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1+i2*k1*q+5*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((-2*q*i1*k1+2*i1*k1+5*i2*k1*q+i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1+i2*k1*q+5*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*q*i1*k1+4*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1+3//2*k1+1//2*k1*q^2)*S(1//(q^2-1)))*q^2+e2p((2*q*i1*k1+4*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1+3//2*k1+1//2*k1*q^2)*S(1//(q^2-1)))+e2p((4*q*i1*k1+2*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+2*q*k1+1//2*k1+1//2*k1*q^2)*S(1//(q^2-1)))*q^2+e2p((4*q*i1*k1+2*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+2*q*k1+1//2*k1+1//2*k1*q^2)*S(1//(q^2-1))),
	e2p((2*q*i1*k1+4*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1+3//2*k1+1//2*k1*q^2)*S(1//(q^2-1)))+e2p((4*q*i1*k1+2*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+2*q*k1+1//2*k1+1//2*k1*q^2)*S(1//(q^2-1))),
	e2p((2*q*i1*k1+4*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1+3//2*k1+1//2*k1*q^2)*S(1//(q^2-1)))+e2p((4*q*i1*k1+2*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+2*q*k1+1//2*k1+1//2*k1*q^2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-q*i1*k1+i1*k1+3*i2*k1*q+3*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+3*i2*k1*q+3*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+3*i2*k1*q+3*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+3*i2*k1*q+3*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+3*i2*k1*q+3*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+3*i2*k1*q+3*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((-i2*k1*q+i2*k1+2*i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-i2*k1*q+i2*k1+2*i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i2*k1*q-i2*k1+i3*k1*q+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q-i2*k1+i3*k1*q+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((-i2*k1*q+i2*k1+2*i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i2*k1*q-i2*k1+i3*k1*q+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((5*i3*k1*q+i3*k1+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))*q+e2p((5*i3*k1*q+i3*k1+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))-e2p((3*i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((3*i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((i3*k1*q+5*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q+e2p((i3*k1*q+5*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))-e2p((3*i3*k1+2*i3*k2*q+2*i3*k2+3*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((3*i3*k1+2*i3*k2*q+2*i3*k2+3*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	e2p((5*i3*k1*q+i3*k1+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))+e2p((3*i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((i3*k1*q+5*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((3*i3*k1+2*i3*k2*q+2*i3*k2+3*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*q*i1*k1-2*i1*k1+i2*k1*q-i2*k1+3*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((2*i3*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1+i2*k1*q-i2*k1+i3*k1*q+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1-i2*k1*q+i2*k1+2*i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((2*i3*k1*q+i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1-i2*k1*q+i2*k1+3*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((2*q*i1*k1-2*i1*k1+i2*k1*q-i2*k1+3*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((2*i3*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1+i2*k1*q-i2*k1+i3*k1*q+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1-i2*k1*q+i2*k1+2*i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((2*i3*k1*q+i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1-i2*k1*q+i2*k1+3*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1-i2*k1*q+i2*k1+2*i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i2*k1*q-i2*k1+i3*k1*q+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q-i2*k1+i3*k1*q+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i3*k1*q+i3*k1+2*i4*k1-q*i1*k1+i1*k1+i4*k1*q+i2*k1*q-i2*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((2*i4*k1*q+i4*k1+q*i1*k1-i1*k1+i2*k1*q-i2*k1-i3*k1*q+i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((i4*k1*q+2*i4*k1+i3*k1*q-i3*k1-i2*k1*q+i2*k1-q*i1*k1+i1*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+3*i4*k1-q*i1*k1+i1*k1-i3*k1*q+i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+2*i4*k1-i3*k1*q+i3*k1+i4*k1*q+q*i1*k1-i1*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((3*i4*k1*q+i2*k1*q-i2*k1+i3*k1*q-i3*k1+q*i1*k1-i1*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((2*i4*k1*q+i4*k1+q*i1*k1-i1*k1+i3*k1*q-i3*k1-i2*k1*q+i2*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i4*k1+2*i4*k1*q+i2*k1*q-i2*k1+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))] [
	(q-1)^3*q*(q^4+q^3+2*q^2+q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)^2*q*(q^2+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)^2*q*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*(2*q^2-q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)^2*q*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-q*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-q*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-(q-1)^3*(q^2+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)^2*(q^2+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)^3*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)^2*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(3*q-1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)^2*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)^2*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(3*q-1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^4-2*e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3+2*e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^4-2*e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3+2*e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-3*e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-3*e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((3*q*i1*k1-3*i1*k1+3*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((3*q*i1*k1-3*i1*k1+3*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3+2*e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3+2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-3*q*i1*k1+3*i1*k1+3*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((-3*q*i1*k1+3*i1*k1+3*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	-2*e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-2*e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-3*q*i1*k1+3*i1*k1+3*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((3*q*i1*k1-3*i1*k1+3*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q^2-4*e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+2*e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+2*e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2-4*e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+2*e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	-2*e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+2*e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-2*e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+2*e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	-2*e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+2*e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-2*e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+2*e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	2*e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+2*e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	2*e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+2*e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	2*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-4*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*q*i1*k1-2*i1*k1+i2*k1*q+5*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((2*q*i1*k1-2*i1*k1+i2*k1*q+5*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+i2*k1*q+5*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1+5*i2*k1*q+i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((-2*q*i1*k1+2*i1*k1+5*i2*k1*q+i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+5*i2*k1*q+i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-2*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((2*q*i1*k1-2*i1*k1+i2*k1*q+5*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+i2*k1*q+5*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1+5*i2*k1*q+i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+5*i2*k1*q+i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-2*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((2*q*i1*k1-2*i1*k1+i2*k1*q+5*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+i2*k1*q+5*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1+5*i2*k1*q+i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+5*i2*k1*q+i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	2*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*q*i1*k1-2*i1*k1+i2*k1*q+5*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1+5*i2*k1*q+i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((3*i3*k1+2*i3*k2*q+2*i3*k2+3*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+2*e2p((3*i3*k1+2*i3*k2*q+2*i3*k2+3*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))-2*e2p((5*i3*k1*q+i3*k1+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))*q+2*e2p((5*i3*k1*q+i3*k1+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))-2*e2p((i3*k1*q+5*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q+2*e2p((i3*k1*q+5*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))-2*e2p((3*i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+2*e2p((3*i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	2*e2p((3*i3*k1+2*i3*k2*q+2*i3*k2+3*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))+2*e2p((5*i3*k1*q+i3*k1+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))+2*e2p((i3*k1*q+5*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))+2*e2p((3*i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*q*i1*k1-2*i1*k1-i2*k1*q+i2*k1+2*i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1-i2*k1*q+i2*k1+2*i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1-i2*k1*q+i2*k1+3*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1-i2*k1*q+i2*k1+3*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+i2*k1*q-i2*k1+3*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+i2*k1*q-i2*k1+3*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-2*e2p((2*i3*k1*q+i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+2*e2p((2*i3*k1*q+i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1+i2*k1*q-i2*k1+i3*k1*q+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+i2*k1*q-i2*k1+i3*k1*q+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-2*e2p((2*i3*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+2*e2p((2*i3*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((2*q*i1*k1-2*i1*k1-i2*k1*q+i2*k1+2*i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1-i2*k1*q+i2*k1+3*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1+i2*k1*q-i2*k1+3*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+2*e2p((2*i3*k1*q+i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1+i2*k1*q-i2*k1+i3*k1*q+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+2*e2p((2*i3*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((-i3*k1*q+i3*k1+2*i4*k1-q*i1*k1+i1*k1+i4*k1*q+i2*k1*q-i2*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+2*e2p((2*i4*k1*q+i4*k1+q*i1*k1-i1*k1+i2*k1*q-i2*k1-i3*k1*q+i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+2*e2p((i4*k1*q+2*i4*k1+i3*k1*q-i3*k1-i2*k1*q+i2*k1-q*i1*k1+i1*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+2*e2p((-i2*k1*q+i2*k1+3*i4*k1-q*i1*k1+i1*k1-i3*k1*q+i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+2*e2p((-i2*k1*q+i2*k1+2*i4*k1-i3*k1*q+i3*k1+i4*k1*q+q*i1*k1-i1*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+2*e2p((2*i4*k1*q+i4*k1+q*i1*k1-i1*k1+i3*k1*q-i3*k1-i2*k1*q+i2*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+2*e2p((3*i4*k1*q+i2*k1*q-i2*k1+i3*k1*q-i3*k1+q*i1*k1-i1*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+2*e2p((-q*i1*k1+i1*k1+i4*k1+2*i4*k1*q+i2*k1*q-i2*k1+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))] [
	(q-1)^2*q^3*(q^4+q^3+2*q^2+q+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*q^3*(q^2+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*q^3*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*q^3*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q^3*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)^2*q*(q^2+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*q*(q^2+1)*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)^2*q*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*q*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*q*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-(q-1)*q*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*q*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*e2p((3*i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^4+e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3-e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3-e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^4,
	-e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	e2p((q*i1*k1-i1*k1+2*i2*k1*q+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+4*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((3*q*i1*k1-3*i1*k1+3*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3+e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3-e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-3*q*i1*k1+3*i1*k1+3*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3,
	e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1)^2,
	-e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	e2p((3*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((1//2*k1*q^2-1//2*k1+4*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+4*i1*k1+2*q*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((2*q*i1*k1-2*i1*k1+i2*k1*q+5*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+e2p((2*q*i1*k1-2*i1*k1+i2*k1*q+5*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-2*q*i1*k1+2*i1*k1+5*i2*k1*q+i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+e2p((-2*q*i1*k1+2*i1*k1+5*i2*k1*q+i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((3*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*q*i1*k1-2*i1*k1+i2*k1*q+5*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+5*i2*k1*q+i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	-e2p((3*i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*q*i1*k1+4*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1+3//2*k1+1//2*k1*q^2)*S(1//(q^2-1)))*q^2+e2p((2*q*i1*k1+4*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1+3//2*k1+1//2*k1*q^2)*S(1//(q^2-1)))+e2p((4*q*i1*k1+2*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+2*q*k1+1//2*k1+1//2*k1*q^2)*S(1//(q^2-1)))*q^2+e2p((4*q*i1*k1+2*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+2*q*k1+1//2*k1+1//2*k1*q^2)*S(1//(q^2-1))),
	e2p((2*q*i1*k1+4*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1+3//2*k1+1//2*k1*q^2)*S(1//(q^2-1)))+e2p((4*q*i1*k1+2*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+2*q*k1+1//2*k1+1//2*k1*q^2)*S(1//(q^2-1))),
	e2p((2*q*i1*k1+4*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1+3//2*k1+1//2*k1*q^2)*S(1//(q^2-1)))+e2p((4*q*i1*k1+2*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+2*q*k1+1//2*k1+1//2*k1*q^2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-q*i1*k1+i1*k1+3*i2*k1*q+3*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+3*i2*k1*q+3*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+3*i2*k1*q+3*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+3*i2*k1*q+3*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+3*i2*k1*q+3*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+3*i2*k1*q+3*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((-i2*k1*q+i2*k1+2*i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-i2*k1*q+i2*k1+2*i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i2*k1*q-i2*k1+i3*k1*q+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q-i2*k1+i3*k1*q+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((-i2*k1*q+i2*k1+2*i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i2*k1*q-i2*k1+i3*k1*q+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((5*i3*k1*q+i3*k1+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))*q-e2p((5*i3*k1*q+i3*k1+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))+e2p((3*i3*k1+2*i3*k2*q+2*i3*k2+3*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((3*i3*k1+2*i3*k2*q+2*i3*k2+3*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i3*k1*q+5*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q-e2p((i3*k1*q+5*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((3*i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((3*i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((5*i3*k1*q+i3*k1+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))-e2p((3*i3*k1+2*i3*k2*q+2*i3*k2+3*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i3*k1*q+5*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))-e2p((3*i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*q*i1*k1-2*i1*k1+i2*k1*q-i2*k1+3*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+i2*k1*q-i2*k1+i3*k1*q+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k1*q+i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1-i2*k1*q+i2*k1+2*i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1-i2*k1*q+i2*k1+3*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q,
	-e2p((2*i3*k1*q+i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((2*i3*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1-i2*k1*q+i2*k1+2*i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i2*k1*q-i2*k1+i3*k1*q+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q-i2*k1+i3*k1*q+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((3*i4*k1*q+i2*k1*q-i2*k1+i3*k1*q-i3*k1+q*i1*k1-i1*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k1+2*i4*k1*q+i2*k1*q-i2*k1+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+2*i4*k1-i3*k1*q+i3*k1+i4*k1*q+q*i1*k1-i1*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+2*i4*k1+i3*k1*q-i3*k1-i2*k1*q+i2*k1-q*i1*k1+i1*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+3*i4*k1-q*i1*k1+i1*k1-i3*k1*q+i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((2*i4*k1*q+i4*k1+q*i1*k1-i1*k1+i3*k1*q-i3*k1-i2*k1*q+i2*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((2*i4*k1*q+i4*k1+q*i1*k1-i1*k1+i2*k1*q-i2*k1-i3*k1*q+i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((-i3*k1*q+i3*k1+2*i4*k1-q*i1*k1+i1*k1+i4*k1*q+i2*k1*q-i2*k1+i4*k2*q+i4*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-e2p((q*i1*k1-i1*k1+i2*k1*q+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))] [
	(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^4+q^3+2*q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^4+2*q^3+3*q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(-q-1-q^2+q^4)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(2*q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^2+2*q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(2*q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^5-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^4+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^2,
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	3*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	-(q-1)*(q^2+q+1+q^3)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	(q^2+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q+2*e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q^2,
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	2*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	2*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	2*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	2*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))*q+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1))),
	2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i2*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1-i2*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i2*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1-i2*k1+i3*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1))),
	2*(q+1)*e2p((1//2*q*i1-1//2*i1+i2*k1+2*i2*k2)*S(1//(q-1))),
	2*e2p((1//2*q*i1-1//2*i1+i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i2*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1-i2*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i2*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1-i2*k1+i3*k2)*S(1//(q-1))),
	2*(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1))),
	2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1-i3*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i2*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1-i3*k1+i4*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+i2*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1-i2*k1+i3*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1-i2*k1+1//2*q*i3-1//2*i3+i3*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+i3*k2)*S(1//(q-1))),
	e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1-i1*k1+i4*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q*(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^4+q^3+2*q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^3+3*q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^2+q+1+q^3)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5+2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^5+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^4+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	3*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	(q-1)*(q^2+q+1+q^3)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q^2+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1)))*q^3+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^3+e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+2*e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))*q+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1))),
	2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q,
	e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))-e2p((i2*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q,
	-e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))-e2p((i2*k1+i3*k2)*S(1//(q-1))),
	-2*(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1-i3*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i2*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1-i3*k1+i4*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+i2*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1-i2*k1+i3*k1+i3*k2)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1-i2*k1+1//2*q*i3-1//2*i3+i3*k1+i3*k2)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+i3*k2)*S(1//(q-1))),
	-e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i1*k1+i4*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i1*k1+i4*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1-i1*k1+i4*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1-i1*k1+i4*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q*(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^4+q^3+2*q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^3+3*q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^2+q+1+q^3)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5+2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^5+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^4+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	3*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	(q-1)*(q^2+q+1+q^3)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q^2+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^3+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q^3+e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+2*e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))*q+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1))),
	2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i2*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1-i2*k1+i3*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i2*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1-i2*k1+i3*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i3*k2)*S(1//(q-1)))*q-e2p((1//2*q*i3-1//2*i3+i2*k1+i3*k2)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+i3*k1-i2*k1+i3*k2)*S(1//(q-1))),
	-e2p((1//2*q*i3-1//2*i3+i2*k1+i3*k2)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+i3*k1-i2*k1+i3*k2)*S(1//(q-1))),
	-2*(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1-i3*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i2*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1-i3*k1+i4*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i1-1//2*i1+i2*k1+i3*k2)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1-i2*k1+i3*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1-i2*k1+1//2*q*i3-1//2*i3+i3*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+i3*k2)*S(1//(q-1))),
	-e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i1*k1+i4*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i1*k1+i4*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1-i1*k1+i4*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1-i1*k1+i4*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q^2*(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q^2*(q^4+q^3+2*q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q^2*(2*q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q^2*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q^2*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^5+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^5-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4,
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4,
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3,
	3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^4+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^4+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^4+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^2,
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2,
	(3*q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q-1)*(q^2+q+1+q^3)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	(q^2+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^3+e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1)))*q^3+e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^3+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^2,
	e2p((1//2*q*i2-1//2*i2+i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+i1*k1+i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q+2*e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q,
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q^2,
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	-2*q*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1-i2*k1+k2+2*i1*k2+k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i2*k1+k2+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))*q+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1))),
	2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i2*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q,
	e2p((1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i1*k1+i3*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+2*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i1*k1+2*i3*k2)*S(1//(q-1))),
	-2*(q+1)*e2p((1//2*q*i1-1//2*i1+i2*k1+2*i2*k2)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q-e2p((i2*k1+i3*k2)*S(1//(q-1)))*q-e2p((1//2*q*i3-1//2*i3+i2*k1+i3*k2)*S(1//(q-1)))*q-e2p((1//2*q*i3-1//2*i3+i3*k1-i2*k1+i3*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	2*(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1))),
	2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1-i3*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i4*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i4*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i3-1//2*i3+i2*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*i4*q-1//2*i4+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i4*k1-i3*k1+i4*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((1//2*q*i1-1//2*i1+i2*k1+i3*k2)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1-i2*k1+i3*k1+i3*k2)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1-i2*k1+1//2*q*i3-1//2*i3+i3*k1+i3*k2)*S(1//(q-1)))-e2p((1//2*q*i3-1//2*i3+1//2*q*i1-1//2*i1+i2*k1+i3*k2)*S(1//(q-1))),
	e2p((1//2*q*i3-1//2*i3+1//2*q*i2-1//2*i2+i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i3-1//2*i3+i4*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*i4*q-1//2*i4+1//2*q*i3-1//2*i3+i4*k1-i1*k1+i4*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^5+q^4+2*q^3+2*q^2+q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(3*q^3+2*q^2+q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^3+2*q^2+q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^3+2*q^2+q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^2+q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^2+q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+2*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+2*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q^2,
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+2*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	(q^2+q+1+q^3)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	(q+1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	(2*q+1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+i2*k2)*S(1//(q-1)))*q^3+2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k2)*S(1//(q-1))),
	2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k2)*S(1//(q-1))),
	e2p((i2*k1+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2)*S(1//(q-1))),
	(q^3+1)*e2p((i2*k1+i2*k2)*S(1//(q-1))),
	e2p((i2*k1+i2*k2)*S(1//(q-1))),
	e2p((i2*k1+i2*k2)*S(1//(q-1))),
	e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((4*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((4*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((4*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((4*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	(q^2+2*q+1)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	(q+1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	(q^2+1)*e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	(q^2+1)*e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	e2p((3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((4*i3*k1-i1*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i1*k1+2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1))),
	e2p((3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((4*i3*k1-i1*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i1*k1+2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-2*i1*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i3*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1+i3*k1+i3*k2)*S(1//(q-1)))*q+e2p((i1*k1-i2*k1+i3*k1+i3*k2)*S(1//(q-1)))+e2p((2*i1*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-2*i1*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i3*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1+i3*k1+i3*k2)*S(1//(q-1)))+e2p((2*i1*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i3*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-2*i1*k1+i3*k2)*S(1//(q-1)))+e2p((2*i1*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-2*i1*k1+i3*k2)*S(1//(q-1)))+e2p((2*i1*k1+i3*k2)*S(1//(q-1))),
	(q+1)*e2p((i3*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q+1)*e2p((i3*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i3*k2)*S(1//(q-1))),
	e2p((i4*k1-i3*k1+i1*k1+i4*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1+i4*k2)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i3*k1+i4*k2)*S(1//(q-1)))+e2p((i2*k1+i4*k1-i3*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i1*k1-i3*k1+i4*k2)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i2*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i2*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i3*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((i3*k1+i4*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i4*k1-i2*k1+i4*k2)*S(1//(q-1))),
	e2p((i4*k1-i1*k1+i2*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i2*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i4*k1-i2*k1+i4*k2)*S(1//(q-1))),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((-i1*k1+2*i3*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((-i1*k1+2*i3*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q*(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^2+q+1+q^3)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(2*q^3+2*q^2+2*q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	q*(q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q+2)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	2*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^4+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	q*(q^2+q+1+q^3)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+2*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^4+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q^4+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	2*e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q^2+q+1+q^3)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q+1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-(2*q+1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+i2*k2)*S(1//(q-1)))*q^3+2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k2)*S(1//(q-1))),
	2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k2)*S(1//(q-1))),
	e2p((i2*k1+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2)*S(1//(q-1))),
	-(q^3+1)*e2p((i2*k1+i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2)*S(1//(q-1))),
	2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((4*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((4*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	-(q^2+2*q+1)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-(q+1)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-(q+1)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	q*(q+1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2+1)*e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-(q^2+1)*e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	e2p((3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((4*i3*k1-i1*k1-i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i3*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))*q,
	e2p((3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-2*i1*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i3*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1+i3*k1+i3*k2)*S(1//(q-1)))*q+e2p((i1*k1-i2*k1+i3*k1+i3*k2)*S(1//(q-1)))+e2p((2*i1*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-2*i1*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i3*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1+i3*k1+i3*k2)*S(1//(q-1)))+e2p((2*i1*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))-e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))-e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-e2p((i3*k1+i3*k2)*S(1//(q-1)))*q-e2p((i3*k1+i3*k2)*S(1//(q-1)))-e2p((2*i3*k1-2*i1*k1+i3*k2)*S(1//(q-1)))-e2p((2*i1*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+i3*k2)*S(1//(q-1)))-e2p((2*i3*k1-2*i1*k1+i3*k2)*S(1//(q-1)))-e2p((2*i1*k1+i3*k2)*S(1//(q-1))),
	(q+1)*e2p((i3*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q+1)*e2p((i3*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+i3*k2)*S(1//(q-1))),
	e2p((i4*k1-i3*k1+i1*k1+i4*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1+i4*k2)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i3*k1+i4*k2)*S(1//(q-1)))+e2p((i2*k1+i4*k1-i3*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i1*k1-i3*k1+i4*k2)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i2*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i2*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i3*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((i3*k1+i4*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i4*k1-i2*k1+i4*k2)*S(1//(q-1))),
	-e2p((i4*k1-i1*k1+i2*k1+i4*k2)*S(1//(q-1)))-e2p((i1*k1+i2*k1+i4*k2)*S(1//(q-1)))-e2p((2*i4*k1-i2*k1-i1*k1+i4*k2)*S(1//(q-1)))-e2p((i1*k1+i4*k1-i2*k1+i4*k2)*S(1//(q-1))),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((-i1*k1+2*i3*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((i1*k1+i3*k2)*S(1//(q-1)))-e2p((-i1*k1+2*i3*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q*(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^5+q^4+2*q^3+2*q^2+q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^3+2*q^2+q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^3+2*q^2+q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^2+q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	q*(q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^4+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^4+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(q+1)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^4+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2,
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	q*(q^2+q+1+q^3)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	q*(q+1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	e2p((i2*k1+i2*k2)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k2)*S(1//(q-1)))*q^3+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))*q^3+2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2)*S(1//(q-1)))*q^3+2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q^2,
	2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k2)*S(1//(q-1)))*q,
	e2p((i2*k1+i2*k2)*S(1//(q-1))),
	-(q^3+1)*e2p((i2*k1+i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2)*S(1//(q-1))),
	e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((4*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((4*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	(q^2+2*q+1)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-(q+1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q+1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q^2+1)*e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-(q^2+1)*e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	e2p((3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((4*i3*k1-i1*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i1*k1+2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1))),
	e2p((3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((4*i3*k1-i1*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i1*k1+2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-2*i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i3*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1+i3*k1+i3*k2)*S(1//(q-1)))*q+e2p((i1*k1-i2*k1+i3*k1+i3*k2)*S(1//(q-1)))+e2p((2*i1*k1+i3*k2)*S(1//(q-1)))*q,
	e2p((i3*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i3*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1+i3*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k2)*S(1//(q-1)))-e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k2)*S(1//(q-1)))-e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i3*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-2*i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i3*k2)*S(1//(q-1)))*q,
	e2p((i3*k1+i3*k2)*S(1//(q-1))),
	-(q+1)*e2p((i3*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q+1)*e2p((i3*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+i3*k2)*S(1//(q-1))),
	e2p((i4*k1-i3*k1+i1*k1+i4*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1+i4*k2)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i3*k1+i4*k2)*S(1//(q-1)))+e2p((i2*k1+i4*k1-i3*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i1*k1-i3*k1+i4*k2)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i2*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i2*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i3*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((i3*k1+i4*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i4*k1-i2*k1+i4*k2)*S(1//(q-1))),
	e2p((i4*k1-i1*k1+i2*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i2*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i4*k1-i2*k1+i4*k2)*S(1//(q-1))),
	-e2p((i1*k1+i3*k2)*S(1//(q-1)))-e2p((-i1*k1+2*i3*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((i1*k1+i3*k2)*S(1//(q-1)))-e2p((-i1*k1+2*i3*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q^2*(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	q^2*(q^2+q+1+q^3)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	q^2*(2*q^2+2*q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	q^2*(q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^5+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^4+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	q*(q^2+q+1+q^3)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	(0)*e2p(S(0)),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q^4+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^4+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^4+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^3,
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	2*e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-q*(q^2+q+1+q^3)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-q*(q+1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	e2p((i2*k1+i2*k2)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k2)*S(1//(q-1)))*q^3+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))*q^3+2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2)*S(1//(q-1)))*q^3+2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q^2,
	2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-2*i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k2)*S(1//(q-1)))*q,
	e2p((i2*k1+i2*k2)*S(1//(q-1))),
	(q^3+1)*e2p((i2*k1+i2*k2)*S(1//(q-1))),
	e2p((i2*k1+i2*k2)*S(1//(q-1))),
	e2p((i2*k1+i2*k2)*S(1//(q-1))),
	2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i2*k1+i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((3*i1*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((4*i2*k1-2*i1*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2,
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	-(q^2+2*q+1)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-(q+1)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-(q+1)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-q*(q+1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q^2+1)*e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	(q^2+1)*e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	e2p((3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((4*i3*k1-i1*k1-i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i3*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i2*k1+2*i3*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))*q,
	e2p((3*i3*k1-i2*k1+2*i3*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-2*i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i3*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1+i3*k1+i3*k2)*S(1//(q-1)))*q+e2p((i1*k1-i2*k1+i3*k1+i3*k2)*S(1//(q-1)))+e2p((2*i1*k1+i3*k2)*S(1//(q-1)))*q,
	e2p((i3*k1+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i3*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1+i3*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))-e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+i1*k1+2*i3*k2)*S(1//(q-1)))-e2p((3*i3*k1-i1*k1+2*i3*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((4*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-e2p((i3*k1+i3*k2)*S(1//(q-1)))*q-e2p((i3*k1+i3*k2)*S(1//(q-1)))-e2p((2*i3*k1-2*i1*k1+i3*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+i3*k2)*S(1//(q-1)))*q,
	-e2p((i3*k1+i3*k2)*S(1//(q-1))),
	-(q+1)*e2p((i3*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q+1)*e2p((i3*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i3*k2)*S(1//(q-1))),
	e2p((i4*k1-i3*k1+i1*k1+i4*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1+i4*k2)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i3*k1+i4*k2)*S(1//(q-1)))+e2p((i2*k1+i4*k1-i3*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i1*k1-i3*k1+i4*k2)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i2*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i2*k1-i1*k1+i4*k2)*S(1//(q-1)))+e2p((2*i4*k1-i3*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((i3*k1+i4*k1-i2*k1+i4*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k1+i4*k2)*S(1//(q-1)))+e2p((i1*k1+i4*k1-i2*k1+i4*k2)*S(1//(q-1))),
	-e2p((i4*k1-i1*k1+i2*k1+i4*k2)*S(1//(q-1)))-e2p((i1*k1+i2*k1+i4*k2)*S(1//(q-1)))-e2p((2*i4*k1-i2*k1-i1*k1+i4*k2)*S(1//(q-1)))-e2p((i1*k1+i4*k1-i2*k1+i4*k2)*S(1//(q-1))),
	-e2p((i1*k1+i3*k2)*S(1//(q-1)))-e2p((-i1*k1+2*i3*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((-i1*k1+2*i3*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*(1+2*q^2+2*q^4+q^6)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q^4-q^3+2*q^2-q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q^3+q^2+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(3*q^2-q+1-2*q^3+q^4)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(2*q^2-q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*(q-1)^2,
	-(q^2-q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(2*q-1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^5-3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3-3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))+3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	(q-1)*(q^2+q+1+q^3)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q^2+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^4+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^3-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	3*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2+e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2+e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))*q^2+2*e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))*q-e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+2*e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))*q-e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))*q-e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))*q^2-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))*q^2-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))*q^2-1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))*q^2-1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1))),
	-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1))),
	-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1))),
	2*(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	2*(q-1)*e2p((1//2*q*i1-1//2*i1+i2*k1+2*i2*k2)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i3*k1+1//2*i3*q^2-1//2*i3+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+1//2*i3*q^2-1//2*i3-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((i3*k1+1//2*i3*q^2-1//2*i3+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+1//2*i3*q^2-1//2*i3-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))*q-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1))),
	-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i2*k1*q-i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i2*k1*q-i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-e2p((1//2*q^2*i2-1//2*i2+i4*k1*q+1//2*q^2*i1-1//2*i1-i3*k1*q+i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((1//2*i4*q^2-1//2*i4+i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((1//2*q^2*i2-1//2*i2+i4*k1+1//2*q^2*i1-1//2*i1+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((1//2*i4*q^2-1//2*i4+i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2-i3*k1*q+i3*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*i4*q^2-1//2*i4+q*i1*k1-i1*k1+i4*k1*q+i4*k2*q+i4*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2)*S(1//(q^2-1)))-e2p((i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2-i3*k1*q+i3*k1)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))-e2p((1//2*i4*q^2-1//2*i4-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i4*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i4*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2)*S(1//(q^2-1)))-e2p((i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))-e2p((1//2*i4*q^2-1//2*i4+i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((1//2*i4*q^2-1//2*i4+i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2-i3*k1*q+i3*k1)*S(1//(q^2-1)))-e2p((1//2*i4*q^2-1//2*i4+i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((1//2*i4*q^2-1//2*i4+i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i4*k1*q+i4*k2*q+i4*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*q*(1+2*q^2+2*q^4+q^6)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-q*(q^4-q^3+2*q^2-q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*(q^2+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^3-3*q^2+q-1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-q*(q^2-q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^5+3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3-3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2,
	1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3-e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3+3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	(q-1)*(q^2+q+1+q^3)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q^2+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^4-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3,
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	-3*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3+e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3,
	-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-2*e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q^2-2*e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))*q^2-2*e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))*q+e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))*q+e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))*q+e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))*q^2-1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))*q^2-1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))*q^2+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))*q^2+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1))),
	-1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1))),
	-1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1))),
	2*(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1+1//2*i3*q^2-1//2*i3+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+1//2*i3*q^2-1//2*i3-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))*q+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1))),
	2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i2*k1*q-i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i2*k1*q-i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-e2p((1//2*q^2*i2-1//2*i2+i4*k1*q+1//2*q^2*i1-1//2*i1-i3*k1*q+i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((1//2*i4*q^2-1//2*i4+i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((1//2*q^2*i2-1//2*i2+i4*k1+1//2*q^2*i1-1//2*i1+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((1//2*i4*q^2-1//2*i4+i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2-i3*k1*q+i3*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*i4*q^2-1//2*i4+i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i4*k1*q+i4*k2*q+i4*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2)*S(1//(q^2-1)))+e2p((i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))+e2p((1//2*i4*q^2-1//2*i4+q*i1*k1-i1*k1+i4*k1*q+i4*k2*q+i4*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2)*S(1//(q^2-1)))+e2p((1//2*i4*q^2-1//2*i4+i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((1//2*i4*q^2-1//2*i4+i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))+e2p((1//2*i4*q^2-1//2*i4-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i4*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))+e2p((1//2*i4*q^2-1//2*i4+i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i4*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*q*(1+2*q^2+2*q^4+q^6)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-q*(q^4-q^3+2*q^2-q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*(q^2+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q^3-3*q^2+q-1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-q*(q^2-q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^5+3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3-3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2,
	1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3-e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3+3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q-3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	(q-1)*(q^2+q+1+q^3)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q^2+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^4-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3,
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	-3*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3+e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-2*e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q^2-2*e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))*q^2-2*e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))*q+e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))*q+e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))*q+e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))*q^2-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))*q^2-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))*q^2+1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))*q^2+1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1))),
	-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1))),
	-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1))),
	2*(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1*q+1//2*i3*q^2-1//2*i3-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1+1//2*i3*q^2-1//2*i3+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q,
	-e2p((i3*k1*q+1//2*i3*q^2-1//2*i3-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1+1//2*i3*q^2-1//2*i3+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))*q+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1))),
	2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i2*k1*q-i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((i3*k1-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-e2p((1//2*q^2*i2-1//2*i2+i4*k1*q+1//2*q^2*i1-1//2*i1-i3*k1*q+i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((1//2*i4*q^2-1//2*i4+i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((1//2*q^2*i2-1//2*i2+i4*k1+1//2*q^2*i1-1//2*i1+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((1//2*i4*q^2-1//2*i4+i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2-i3*k1*q+i3*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*i4*q^2-1//2*i4+i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i4*k1*q+i4*k2*q+i4*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2)*S(1//(q^2-1)))+e2p((i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))+e2p((1//2*i4*q^2-1//2*i4+q*i1*k1-i1*k1+i4*k1*q+i4*k2*q+i4*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2)*S(1//(q^2-1)))+e2p((1//2*i4*q^2-1//2*i4+i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((1//2*i4*q^2-1//2*i4+i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))+e2p((1//2*i4*q^2-1//2*i4-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i4*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))+e2p((1//2*i4*q^2-1//2*i4+i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i4*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*q^2*(1+2*q^2+2*q^4+q^6)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-q^2*(q^4-q^3+2*q^2-q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q^2*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-q^2*(2*q^2-q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q^2*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3-3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^5-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^5-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4,
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^4,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^3-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3-3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+3//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	(q-1)*(q^2+q+1+q^3)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q^2+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-(q+1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^4-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^3-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^4-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^4-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2,
	-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	(3*q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3-e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3-e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3+e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+i2*k1+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i2*k1*q+1//2*q^2*i2-1//2*i2+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	(0)*e2p(S(0)),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))+e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+1//4*q^2-1//2*q+1//4+i1*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	2*(q-1)*q*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2+e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2+e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	-e2p((1//2*q*i2-1//2*i2+1//2*q*i1-1//2*i1+i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q-2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))*q^2+2*e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))*q-e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+2*e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))*q-e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	2*e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))*q-e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((-1//2*i2+1//2*q^2*i1-1//2*i1+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2+1//2*q^2*i2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+1//2*q^2*i2-1//2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))*q^2+1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))*q^2+1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))*q^2+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))*q^2+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1))),
	1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1))),
	1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3+1//4*q^2-1//4*q-1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1-i2*k1*q+i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+q*k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1))),
	2*(q-1)*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	-2*(q-1)*e2p((1//2*q*i1-1//2*i1+i2*k1+2*i2*k2)*S(1//(q-1))),
	2*e2p((1//2*q*i1-1//2*i1+i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((i3*k1+1//2*i3*q^2-1//2*i3+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((i3*k1+i2*k1*q-i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((i3*k1*q+1//2*i3*q^2-1//2*i3-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))*q-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1))),
	-2*e2p((1//2*q*i1-1//2*i1+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((2*i3*k1+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+2*i3*k1+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i2*k1*q-i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1-i2*k1*q+i2*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-e2p((1//2*q^2*i2-1//2*i2+i4*k1*q+1//2*q^2*i1-1//2*i1-i3*k1*q+i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((1//2*i4*q^2-1//2*i4+i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((1//2*q^2*i2-1//2*i2+i4*k1+1//2*q^2*i1-1//2*i1+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))-e2p((1//2*i4*q^2-1//2*i4+i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2-i3*k1*q+i3*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*i4*q^2-1//2*i4+q*i1*k1-i1*k1+i4*k1*q+i4*k2*q+i4*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2)*S(1//(q^2-1)))-e2p((i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2-i3*k1*q+i3*k1)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))-e2p((1//2*i4*q^2-1//2*i4-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i4*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i4*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2)*S(1//(q^2-1)))-e2p((i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))-e2p((1//2*i4*q^2-1//2*i4+i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((1//2*i4*q^2-1//2*i4+i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2-i3*k1*q+i3*k1)*S(1//(q^2-1)))-e2p((1//2*i4*q^2-1//2*i4+i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((1//2*i4*q^2-1//2*i4+i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i4*k1*q+i4*k2*q+i4*k2+1//2*i3*q^2-1//2*i3+1//2*q^2*i2-1//2*i2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*(1+2*q^2+2*q^4+q^6)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q^4+2*q^2+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(-2*q^2+q-1+q^3)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(3*q^3-2*q^2+q-1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(-2*q^2+q-1+q^3)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q^2-q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q^2-q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^3-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^3-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+2*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+2*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q^2+1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	(2*q-1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^3-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	2*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(q-1)*(q^2+q+1)*e2p((i2*k1+i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2)*S(1//(q-1))),
	e2p((i2*k1+i2*k2)*S(1//(q-1)))*q^3-2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q-e2p((i2*k1+i2*k2)*S(1//(q-1)))-e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q-e2p((i2*k1+i2*k2)*S(1//(q-1)))+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+i2*k2)*S(1//(q-1)))-e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1)^2,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1))),
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+2*e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+2*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-(q^2+1)*e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-(q^2+1)*e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p((i3*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(q-1)*e2p((i3*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i3*k2)*S(1//(q-1)))*q-e2p((i3*k1+i3*k2)*S(1//(q-1)))-e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((i3*k1+i3*k2)*S(1//(q-1)))-e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((2*i3*k2*q+2*i3*k2+i3*k1*q+3*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k2+i3*k1*q+3*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k2*q+2*i3*k2+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k2+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))-e2p((4*i3*k1*q+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1+2*i3*k1*q+2*i3*k2*q+2*i3*k2+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k1+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((4*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((2*i3*k2*q+2*i3*k2+i3*k1*q+3*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k2+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))-e2p((4*i3*k1*q+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1+2*i3*k1*q+2*i3*k2*q+2*i3*k2+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k1+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((4*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))-e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1+i3*k2)*S(1//(q-1)))*q-e2p((i3*k1+i3*k2)*S(1//(q-1)))+e2p((-q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q-i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i2*k1*q-i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i2*k1*q-i2*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+i2*k1*q-i2*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((i3*k1+i3*k2)*S(1//(q-1)))-e2p((-q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i2*k1*q-i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i2*k1*q-i2*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1-i3*k1*q+i3*k1)*S(1//(q^2-1)))-e2p((2*i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((2*i4*k1*q+i4*k2*q+i4*k2-i2*k1*q+i2*k1-i3*k1*q+i3*k1)*S(1//(q^2-1))),
	-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-q*i1*k1+i1*k1+2*i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k1*q+i4*k1+i4*k2*q+i4*k2+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((2*i4*k1*q+i4*k2*q+i4*k2+i2*k1*q-i2*k1+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i4*k1+i4*k2*q+i4*k2-i3*k1*q+i3*k1)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i4*k1*q+i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i4*k1*q+i4*k1+i4*k2*q+i4*k2-i3*k1*q+i3*k1)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k1*q+i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1-i3*k1*q+i3*k1)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i4*k1*q+i4*k2*q+i4*k2+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i4*k1*q+i4*k2*q+i4*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1-i3*k1*q+i3*k1)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1+i3*k1*q-i3*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*q*(1+2*q^2+2*q^4+q^6)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*(q^4+2*q^2+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(-2*q^2+q-1+q^3)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(-2*q^2+q-1+q^3)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-q*(q^2-q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(q-1)*q*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^4-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^3-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4,
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^4-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*(q^2+1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	(q-1)*q*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^4-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(q-1)*(q^2+q+1)*e2p((i2*k1+i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2)*S(1//(q-1))),
	e2p((i2*k1+i2*k2)*S(1//(q-1)))+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3-2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q-e2p((i2*k1+i2*k2)*S(1//(q-1)))*q^3+2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q^2-e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	-2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2)*S(1//(q-1)))-e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	e2p((i2*k1+i2*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1)^2,
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q^2+1)*e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-(q^2+1)*e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p((i3*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(q-1)*e2p((i3*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i3*k2)*S(1//(q-1)))-e2p((2*q*i1*k1-2*i1*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q,
	e2p((i3*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k1+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((4*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((4*i3*k1*q+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k1*q+2*i3*k2*q+2*i3*k2+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k2+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k2*q+2*i3*k2+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k2+i3*k1*q+3*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k2*q+2*i3*k2+i3*k1*q+3*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1))),
	e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k1+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((4*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((4*i3*k1*q+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k1*q+2*i3*k2*q+2*i3*k2+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k2*q+2*i3*k2+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k2*q+2*i3*k2+i3*k1*q+3*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i3*k2)*S(1//(q-1)))-e2p((q*i1*k1-i1*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i2*k1*q-i2*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+i2*k1*q-i2*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i2*k1*q-i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i2*k1*q-i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((2*q*i1*k1-2*i1*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q,
	e2p((i3*k1+i3*k2)*S(1//(q-1)))+e2p((q*i1*k1-i1*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i2*k1*q-i2*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q-i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((2*i4*k1*q+i4*k2*q+i4*k2-i2*k1*q+i2*k1-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((2*i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1+i3*k1*q-i3*k1)*S(1//(q^2-1))),
	-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i4*k1*q+i4*k1+i4*k2*q+i4*k2-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+2*i4*k1*q+i4*k2*q+i4*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i4*k1*q+i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+2*i4*k1*q+i4*k2*q+i4*k2+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+2*i4*k1+i4*k2*q+i4*k2-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((2*i4*k1*q+i4*k2*q+i4*k2+i2*k1*q-i2*k1+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((2*i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i4*k1*q+i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i4*k1*q+i4*k1+i4*k2*q+i4*k2+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+2*i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*q*(1+2*q^2+2*q^4+q^6)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*(q^2+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	q*(2*q^3-2*q^2+2*q-1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q-2)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-2*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^4-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3,
	(q-1)*q*(q^2+1)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+2*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*(q^2+1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	(q-1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	(2*q-1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^4-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^3+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^4-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-2*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))-2*e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-2*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	(q-1)*(q^2+q+1)*e2p((i2*k1+i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2)*S(1//(q-1)))*q^3+2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q^2-2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2)*S(1//(q-1)))+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2)*S(1//(q-1)))-e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1+i2*k2)*S(1//(q-1)))+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1)^2,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q^2-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q^2-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q+e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q^2-e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q,
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q,
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-(q^2+1)*e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	(q^2+1)*e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p((i3*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((q*i1*k1-i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	(0)*e2p(S(0)),
	-(q-1)*e2p((i3*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i3*k2)*S(1//(q-1)))*q-e2p((i3*k1+i3*k2)*S(1//(q-1)))-e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((i3*k1+i3*k2)*S(1//(q-1)))-e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((4*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1*q+2*i3*k1+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((4*i3*k1*q+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1+2*i3*k1*q+2*i3*k2*q+2*i3*k2+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k2+i3*k1*q+3*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k2*q+2*i3*k2+i3*k1*q+3*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k2+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k2*q+2*i3*k2+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))-e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	e2p((2*i3*k2*q+2*i3*k2+i3*k1*q+3*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k2*q+2*i3*k2+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))+e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i3*k2)*S(1//(q-1)))+e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i2*k1*q-i2*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+i2*k1*q-i2*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i2*k1*q-i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i2*k1*q-i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((i3*k1+i3*k2)*S(1//(q-1)))+e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i2*k1*q-i2*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q-i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1-i3*k1*q+i3*k1)*S(1//(q^2-1)))-e2p((2*i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((2*i4*k1*q+i4*k2*q+i4*k2-i2*k1*q+i2*k1-i3*k1*q+i3*k1)*S(1//(q^2-1))),
	e2p((q*i1*k1-i1*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i4*k1*q+i4*k1+i4*k2*q+i4*k2-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+2*i4*k1*q+i4*k2*q+i4*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i4*k1*q+i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+2*i4*k1*q+i4*k2*q+i4*k2+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+2*i4*k1+i4*k2*q+i4*k2-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((2*i4*k1*q+i4*k2*q+i4*k2+i2*k1*q-i2*k1+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((2*i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i4*k1*q+i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i4*k1*q+i4*k1+i4*k2*q+i4*k2+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+2*i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*q^2*(1+2*q^2+2*q^4+q^6)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q^2*(q^2+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	-q^2*(2*q^2-2*q+1)*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q^2*e2p((2*i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^5-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^4+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^3-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^3-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^4+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^5,
	-(q-1)*q*(q^2+1)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^3-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((2*i1*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	(0)*e2p(S(0)),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*q*(q^2+1)*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	(q-1)*q*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^3-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^4-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^4+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^3-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^4,
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+2*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+2*e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	(0)*e2p(S(0)),
	(q-1)*(q^2+q+1)*e2p((i2*k1+i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2)*S(1//(q-1)))+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3-e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3-e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q-2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+i2*k2)*S(1//(q-1)))*q^3,
	2*e2p((i2*k1+i2*k2)*S(1//(q-1)))*q-e2p((i2*k1+i2*k2)*S(1//(q-1)))+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	-e2p((i2*k1+i2*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1)^2,
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*e2p((2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))-e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2+e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q^2+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q-e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q^2+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((-i2*k1*q+i2*k1+i1*k1+3*q*i1*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1+3*i1*k1+2*i1*k2*q+2*i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q,
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+2*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+2*e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((2*i2*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-(q^2+1)*e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	-e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	(q^2+1)*e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	e2p((2*i1*k1+k2+2*i1*k2+1//2*q*k1+1//2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p((i3*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	-e2p((q*i1*k1-i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	(0)*e2p(S(0)),
	-(q-1)*e2p((i3*k1+i3*k2)*S(1//(q-1))),
	e2p((i3*k1+i3*k2)*S(1//(q-1))),
	-e2p((i3*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1+i3*k2)*S(1//(q-1)))-e2p((2*q*i1*k1-2*i1*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q,
	e2p((i3*k1+i3*k2)*S(1//(q-1))),
	e2p((2*i3*k2*q+2*i3*k2+i3*k1*q+3*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k2+i3*k1*q+3*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k2*q+2*i3*k2+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k2+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1)*S(1//(q^2-1)))+e2p((4*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q+e2p((4*i3*k1*q+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+2*i3*k1*q+2*i3*k2*q+2*i3*k2+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+2*i3*k1+2*i3*k2*q+2*i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q,
	-e2p((2*i3*k2*q+2*i3*k2+i3*k1*q+3*i3*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))-e2p((i3*k1*q+3*i3*k1+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((i3*k1+3*i3*k1*q+2*i3*k2*q+2*i3*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k2+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1+i3*k2)*S(1//(q-1)))*q-e2p((i3*k1+i3*k2)*S(1//(q-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q-i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i2*k1*q-i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i2*k1*q-i2*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+i2*k1*q-i2*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q,
	-e2p((i3*k1+i3*k2)*S(1//(q-1)))-e2p((-q*i1*k1+i1*k1+i2*k1*q-i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i2*k1*q-i2*k1+2*i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1-i2*k1*q+i2*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((2*i4*k1*q+i4*k2*q+i4*k2-i2*k1*q+i2*k1-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((2*i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1+i3*k1*q-i3*k1)*S(1//(q^2-1))),
	e2p((q*i1*k1-i1*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-q*i1*k1+i1*k1+2*i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k1*q+i4*k1+i4*k2*q+i4*k2+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((2*i4*k1*q+i4*k2*q+i4*k2+i2*k1*q-i2*k1+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i4*k1+i4*k2*q+i4*k2-i3*k1*q+i3*k1)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i4*k1*q+i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i4*k1*q+i4*k1+i4*k2*q+i4*k2-i3*k1*q+i3*k1)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k1*q+i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1-i3*k1*q+i3*k1)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i4*k1*q+i4*k2*q+i4*k2+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i4*k1*q+i4*k2*q+i4*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1-i3*k1*q+i3*k1)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1+i3*k1*q-i3*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*(1+2*q^4+2*q^2+2*q+2*q^3+q^6+2*q^5)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-(q^4+q^3+q+1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q^3+q^2+2*q+1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-(q^4+2*q^3+q^2+q+1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-(q+1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-(q^2+q+1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-(2*q+1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^5-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^5-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-2*e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^2,
	-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	e2p((-i1*k1+2*i2*k1+i2+2*i2*k2)*S(1//(q-1)))*q^2-e2p((-i1*k1+2*i2*k1+i2+2*i2*k2)*S(1//(q-1)))+e2p((i1*k1+i2+2*i2*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+i2+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))*q^4-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	-e2p((-i1*k1+2*i2*k1+i2+2*i2*k2)*S(1//(q-1)))-e2p((i1*k1+i2+2*i2*k2)*S(1//(q-1)))-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))*q^2-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	e2p((-i1*k1+2*i2*k1+i2+2*i2*k2)*S(1//(q-1)))*q-e2p((-i1*k1+2*i2*k1+i2+2*i2*k2)*S(1//(q-1)))+e2p((i1*k1+i2+2*i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+i2+2*i2*k2)*S(1//(q-1)))+e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))*q-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	-e2p((-i1*k1+2*i2*k1+i2+2*i2*k2)*S(1//(q-1)))*q-e2p((-i1*k1+2*i2*k1+i2+2*i2*k2)*S(1//(q-1)))-e2p((i1*k1+i2+2*i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+i2+2*i2*k2)*S(1//(q-1)))-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))*q-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	-e2p((-i1*k1+2*i2*k1+i2+2*i2*k2)*S(1//(q-1)))-e2p((i1*k1+i2+2*i2*k2)*S(1//(q-1)))-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	-(q^4+2*q^3+2*q^2+2*q+1)*e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	-(q^2+2*q+1)*e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	-(3*q+1)*e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	-(q+1)*e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2+1//2*i2+2*i2*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2+1//2*i2+2*i2*k2)*S(1//(q-1)))+e2p((-i1*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-e2p((-i1*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2+1//2*i2+2*i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2+1//2*i2+2*i2*k2)*S(1//(q-1)))+e2p((-i1*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((-i1*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2+1//2*i2+2*i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2+1//2*i2+2*i2*k2)*S(1//(q-1)))-e2p((-i1*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((-i1*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2+1//2*i2+2*i2*k2)*S(1//(q-1)))-e2p((-i1*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-2*e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q^2,
	-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1-2*i2*k1+2*k2+4*i1*k2+2*k1)*S(1//(2*(q-1))))*q^2-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1-2*i2*k1+2*k2+4*i1*k2+2*k1)*S(1//(2*(q-1))))+1//2*e2p((3//2+1//2*q^2-q+2*i1+2*i2*k1+2*k2+4*i1*k2)*S(1//(2*(q-1))))*q^2-1//2*e2p((3//2+1//2*q^2-q+2*i1+2*i2*k1+2*k2+4*i1*k2)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+2*i1+2*i2*k1+2*k2+4*i1*k2)*S(1//(2*(q-1))))*q^2-1//2*e2p((1//2*q^2+1//2+2*i1+2*i2*k1+2*k2+4*i1*k2)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1-2*i2*k1+2*k2+4*i1*k2+2*k1)*S(1//(2*(q-1))))*q^2-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1-2*i2*k1+2*k2+4*i1*k2+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1-2*i2*k1+2*k2+4*i1*k2+2*k1)*S(1//(2*(q-1))))-1//2*e2p((3//2+1//2*q^2-q+2*i1+2*i2*k1+2*k2+4*i1*k2)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+2*i1+2*i2*k1+2*k2+4*i1*k2)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1-2*i2*k1+2*k2+4*i1*k2+2*k1)*S(1//(2*(q-1)))),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1-2*i2*k1+2*k2+4*i1*k2+2*k1)*S(1//(2*(q-1))))-1//2*e2p((3//2+1//2*q^2-q+2*i1+2*i2*k1+2*k2+4*i1*k2)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+2*i1+2*i2*k1+2*k2+4*i1*k2)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1-2*i2*k1+2*k2+4*i1*k2+2*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k2)*S(1//(q-1)))+e2p((-i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((-i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1-i2*k1+1//2*q*i3+1//2*i3+2*i3*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1-i2*k1+1//2*q*i3+1//2*i3+2*i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((i2*k1+1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k2)*S(1//(q-1)))*q-e2p((i2*k1+1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k2)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k2)*S(1//(q-1)))-e2p((-i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1-i2*k1+1//2*q*i3+1//2*i3+2*i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((i2*k1+1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((1//2*q*i1-1//2*i1+i3+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))*q-2*e2p((1//2*q*i1-1//2*i1+i3+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k2)*S(1//(q-1)))-e2p((-i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((-i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1+2*i3*k2)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+i3+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k2)*S(1//(q-1)))-e2p((-i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-2*i1*k1+q*i1-i1+i3+q*i2-i2+2*i3*k1+2*i3*k2)*S(1//(2*(q-1))))*q-e2p((-2*i1*k1+q*i1-i1+i3+q*i2-i2+2*i3*k1+2*i3*k2)*S(1//(2*(q-1))))-e2p((2*i1*k1+q*i1-i1+i3+q*i2-i2+2*i3*k2)*S(1//(2*(q-1))))*q-e2p((2*i1*k1+q*i1-i1+i3+q*i2-i2+2*i3*k2)*S(1//(2*(q-1))))-e2p((2*i1*k1+q*i1-i1+q*i3+q*i2-i2+2*i3*k2)*S(1//(2*(q-1))))*q-e2p((2*i1*k1+q*i1-i1+q*i3+q*i2-i2+2*i3*k2)*S(1//(2*(q-1))))-e2p((-2*i1*k1+q*i1-i1+q*i3+q*i2-i2+2*i3*k1+2*i3*k2)*S(1//(2*(q-1))))*q-e2p((-2*i1*k1+q*i1-i1+q*i3+q*i2-i2+2*i3*k1+2*i3*k2)*S(1//(2*(q-1)))),
	-e2p((-2*i1*k1+q*i1-i1+i3+q*i2-i2+2*i3*k1+2*i3*k2)*S(1//(2*(q-1))))-e2p((2*i1*k1+q*i1-i1+i3+q*i2-i2+2*i3*k2)*S(1//(2*(q-1))))-e2p((2*i1*k1+q*i1-i1+q*i3+q*i2-i2+2*i3*k2)*S(1//(2*(q-1))))-e2p((-2*i1*k1+q*i1-i1+q*i3+q*i2-i2+2*i3*k1+2*i3*k2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*(q+1)*e2p((1//2*q*i1-1//2*i1+i2*k1+i2+2*i2*k2)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+i2*k1+i2+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i4-2*i1*k1+2*i4*k1+2*i4*k2+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4+2*i4*k2+q*i1-i1+2*i2*k1+q*i3-i3)*S(1//(2*(q-1))))-e2p((i4+2*i4*k1+2*i4*k2+q*i1-i1-2*i2*k1+q*i3-i3)*S(1//(2*(q-1))))-e2p((i4+2*i1*k1+2*i4*k2+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4*q+2*i4*k1+2*i4*k2+q*i1-i1-2*i2*k1+q*i3-i3)*S(1//(2*(q-1))))-e2p((i4*q+2*i1*k1+2*i4*k2+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4*q-2*i1*k1+2*i4*k1+2*i4*k2+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4*q+2*i4*k2+q*i1-i1+2*i2*k1+q*i3-i3)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-2*i1*k1+i3+q*i2-i2+2*i3*k1+2*i3*k2)*S(1//(2*(q-1))))-e2p((2*i1*k1+i3+q*i2-i2+2*i3*k2)*S(1//(2*(q-1))))-e2p((2*i1*k1+q*i3+q*i2-i2+2*i3*k2)*S(1//(2*(q-1))))-e2p((-2*i1*k1+q*i3+q*i2-i2+2*i3*k1+2*i3*k2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*q^2*(1+2*q^4+2*q^2+2*q+2*q^3+q^6+2*q^5)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-q^2*(q^4+q^3+q+1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q^2*(2*q+1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-q^2*(q+1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-q^2*(q+1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q^2*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^5+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^5+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^5+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^4-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^3,
	-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4-e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3-e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^4,
	-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^3,
	3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-3//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))-e2p((-i1*k1+2*i2*k1+i2+2*i2*k2)*S(1//(q-1)))*q^2+e2p((-i1*k1+2*i2*k1+i2+2*i2*k2)*S(1//(q-1)))*q^4-e2p((i1*k1+i2+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+i2+2*i2*k2)*S(1//(q-1)))*q^4+e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))*q^4,
	-e2p((-i1*k1+2*i2*k1+i2+2*i2*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+i2+2*i2*k2)*S(1//(q-1)))*q^2-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))*q^2-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-(q+1)*e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	-(q^4+2*q^3+2*q^2+2*q+1)*e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	-(q^2+2*q+1)*e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	-(3*q+1)*e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	-(q+1)*e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))*q^2+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))*q^2,
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//2*q+1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+2*i1*k1+i1-i2*k1+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//4+i1+i2*k1+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2+1//2*i2+2*i2*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2+1//2*i2+2*i2*k2)*S(1//(q-1)))+e2p((-i1*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q^2-e2p((-i1*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2+1//2*i2+2*i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2+1//2*i2+2*i2*k2)*S(1//(q-1)))+e2p((-i1*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((-i1*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2+1//2*i2+2*i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2+1//2*i2+2*i2*k2)*S(1//(q-1)))-e2p((-i1*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((-i1*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*i1-1//2*i1+1//2*q*i2+1//2*i2+2*i2*k2)*S(1//(q-1)))-e2p((-i1*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k1+2*i2*k2)*S(1//(q-1))),
	-2*e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q^2,
	-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1-2*i2*k1+2*k2+4*i1*k2+2*k1)*S(1//(2*(q-1))))*q^2+1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1-2*i2*k1+2*k2+4*i1*k2+2*k1)*S(1//(2*(q-1))))-1//2*e2p((3//2+1//2*q^2-q+2*i1+2*i2*k1+2*k2+4*i1*k2)*S(1//(2*(q-1))))*q^2+1//2*e2p((3//2+1//2*q^2-q+2*i1+2*i2*k1+2*k2+4*i1*k2)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1-2*i2*k1+2*k2+4*i1*k2+2*k1)*S(1//(2*(q-1))))*q^2+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1-2*i2*k1+2*k2+4*i1*k2+2*k1)*S(1//(2*(q-1))))-1//2*e2p((1//2*q^2+1//2+2*i1+2*i2*k1+2*k2+4*i1*k2)*S(1//(2*(q-1))))*q^2+1//2*e2p((1//2*q^2+1//2+2*i1+2*i2*k1+2*k2+4*i1*k2)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1-2*i2*k1+2*k2+4*i1*k2+2*k1)*S(1//(2*(q-1))))+1//2*e2p((3//2+1//2*q^2-q+2*i1+2*i2*k1+2*k2+4*i1*k2)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1-2*i2*k1+2*k2+4*i1*k2+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+2*i1+2*i2*k1+2*k2+4*i1*k2)*S(1//(2*(q-1)))),
	1//2*e2p((3//2+1//2*q^2-q+4*i1*k1+2*i1-2*i2*k1+2*k2+4*i1*k2+2*k1)*S(1//(2*(q-1))))+1//2*e2p((3//2+1//2*q^2-q+2*i1+2*i2*k1+2*k2+4*i1*k2)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+4*i1*k1+2*i1-2*i2*k1+2*k2+4*i1*k2+2*k1)*S(1//(2*(q-1))))+1//2*e2p((1//2*q^2+1//2+2*i1+2*i2*k1+2*k2+4*i1*k2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k2)*S(1//(q-1)))+e2p((-i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((-i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((1//2*q*i1-1//2*i1-i2*k1+1//2*q*i3+1//2*i3+2*i3*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((1//2*q*i1-1//2*i1-i2*k1+1//2*q*i3+1//2*i3+2*i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((i2*k1+1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k2)*S(1//(q-1)))*q-e2p((i2*k1+1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k2)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k2)*S(1//(q-1)))-e2p((-i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((1//2*q*i1-1//2*i1-i2*k1+1//2*q*i3+1//2*i3+2*i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((i2*k1+1//2*q*i3+1//2*i3+1//2*q*i1-1//2*i1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((1//2*q*i1-1//2*i1+i3+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))*q-2*e2p((1//2*q*i1-1//2*i1+i3+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k2)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k2)*S(1//(q-1)))-e2p((-i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1+2*i3*k2)*S(1//(q-1)))*q-e2p((-i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1+2*i3*k2)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+i3+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k2)*S(1//(q-1)))-e2p((-i1*k1+1//2*q*i3+1//2*i3+1//2*q*i2-1//2*i2+2*i3*k1+2*i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-2*i1*k1+q*i1-i1+i3+q*i2-i2+2*i3*k1+2*i3*k2)*S(1//(2*(q-1))))*q-e2p((-2*i1*k1+q*i1-i1+i3+q*i2-i2+2*i3*k1+2*i3*k2)*S(1//(2*(q-1))))-e2p((2*i1*k1+q*i1-i1+i3+q*i2-i2+2*i3*k2)*S(1//(2*(q-1))))*q-e2p((2*i1*k1+q*i1-i1+i3+q*i2-i2+2*i3*k2)*S(1//(2*(q-1))))-e2p((2*i1*k1+q*i1-i1+q*i3+q*i2-i2+2*i3*k2)*S(1//(2*(q-1))))*q-e2p((2*i1*k1+q*i1-i1+q*i3+q*i2-i2+2*i3*k2)*S(1//(2*(q-1))))-e2p((-2*i1*k1+q*i1-i1+q*i3+q*i2-i2+2*i3*k1+2*i3*k2)*S(1//(2*(q-1))))*q-e2p((-2*i1*k1+q*i1-i1+q*i3+q*i2-i2+2*i3*k1+2*i3*k2)*S(1//(2*(q-1)))),
	-e2p((-2*i1*k1+q*i1-i1+i3+q*i2-i2+2*i3*k1+2*i3*k2)*S(1//(2*(q-1))))-e2p((2*i1*k1+q*i1-i1+i3+q*i2-i2+2*i3*k2)*S(1//(2*(q-1))))-e2p((2*i1*k1+q*i1-i1+q*i3+q*i2-i2+2*i3*k2)*S(1//(2*(q-1))))-e2p((-2*i1*k1+q*i1-i1+q*i3+q*i2-i2+2*i3*k1+2*i3*k2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*(q+1)*e2p((1//2*q*i1-1//2*i1+i2*k1+i2+2*i2*k2)*S(1//(q-1))),
	2*e2p((1//2*q*i1-1//2*i1+i2*k1+i2+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i4-2*i1*k1+2*i4*k1+2*i4*k2+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4+2*i4*k2+q*i1-i1+2*i2*k1+q*i3-i3)*S(1//(2*(q-1))))-e2p((i4+2*i4*k1+2*i4*k2+q*i1-i1-2*i2*k1+q*i3-i3)*S(1//(2*(q-1))))-e2p((i4+2*i1*k1+2*i4*k2+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4*q+2*i4*k1+2*i4*k2+q*i1-i1-2*i2*k1+q*i3-i3)*S(1//(2*(q-1))))-e2p((i4*q+2*i1*k1+2*i4*k2+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4*q-2*i1*k1+2*i4*k1+2*i4*k2+q*i3-i3+q*i2-i2)*S(1//(2*(q-1))))-e2p((i4*q+2*i4*k2+q*i1-i1+2*i2*k1+q*i3-i3)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-2*i1*k1+i3+q*i2-i2+2*i3*k1+2*i3*k2)*S(1//(2*(q-1))))+e2p((-2*i1*k1+q*i3+q*i2-i2+2*i3*k1+2*i3*k2)*S(1//(2*(q-1))))+e2p((2*i1*k1+q*i3+q*i2-i2+2*i3*k2)*S(1//(2*(q-1))))+e2p((2*i1*k1+i3+q*i2-i2+2*i3*k2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)^2*(1+q^4+q^2+q+q^3+q^5)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	(q-1)^2*(q^2+q+1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q^3-q^2-1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-(q^4+q^2+q-1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	(q^2-q+1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-(2*q-1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^5-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^5-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^2,
	1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4-e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4-e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^2,
	1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^2-2*e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-3//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^2,
	1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-3//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	(q-1)^2*(q^2+1)*e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	(q-1)^2*e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-(3*q-1)*e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	e2p((q*i1*k1-i1*k1+2*i2*k1+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+2*i2*k1+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))*q^4+e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	e2p((q*i1*k1-i1*k1+2*i2*k1+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	-e2p((q*i1*k1-i1*k1+2*i2*k1+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+2*i2*k1+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	e2p((q*i1*k1-i1*k1+2*i2*k1+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+2*i2*k1+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	e2p((q*i1*k1-i1*k1+2*i2*k1+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q^2-2*e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2,
	e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2,
	e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*e2p((1//4*q+i1+1//4*q^3-1//4*q^2+q*i1+2*q*i1*k1+q*k1+k2+i2*k1+2*i1*k2-i2*k1*q+k2*q+2*i1*k2*q+3//4)*S(1//(q^2-1)))*q^2+1//2*e2p((1//4*q+i1+1//4*q^3-1//4*q^2+q*i1+2*q*i1*k1+q*k1+k2+i2*k1+2*i1*k2-i2*k1*q+k2*q+2*i1*k2*q+3//4)*S(1//(q^2-1)))-1//2*e2p((1//4*q+1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))*q^2+1//2*e2p((1//4*q+1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q+3//4+1//4*q^3-1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))*q^2+1//2*e2p((1//4*q+3//4+1//4*q^3-1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q+i1+1//4*q^3+1//4*q^2+q*i1+1//4+2*q*i1*k1+q*k1+k2+i2*k1+2*i1*k2-i2*k1*q+k2*q+2*i1*k2*q)*S(1//(q^2-1)))*q^2+1//2*e2p((1//4*q+i1+1//4*q^3+1//4*q^2+q*i1+1//4+2*q*i1*k1+q*k1+k2+i2*k1+2*i1*k2-i2*k1*q+k2*q+2*i1*k2*q)*S(1//(q^2-1))),
	1//2*e2p((1//4*q+i1+1//4*q^3-1//4*q^2+q*i1+2*q*i1*k1+q*k1+k2+i2*k1+2*i1*k2-i2*k1*q+k2*q+2*i1*k2*q+3//4)*S(1//(q^2-1)))+1//2*e2p((1//4*q+1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q+3//4+1//4*q^3-1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q+i1+1//4*q^3+1//4*q^2+q*i1+1//4+2*q*i1*k1+q*k1+k2+i2*k1+2*i1*k2-i2*k1*q+k2*q+2*i1*k2*q)*S(1//(q^2-1))),
	1//2*e2p((1//4*q+i1+1//4*q^3-1//4*q^2+q*i1+2*q*i1*k1+q*k1+k2+i2*k1+2*i1*k2-i2*k1*q+k2*q+2*i1*k2*q+3//4)*S(1//(q^2-1)))+1//2*e2p((1//4*q+1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q+3//4+1//4*q^3-1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q+i1+1//4*q^3+1//4*q^2+q*i1+1//4+2*q*i1*k1+q*k1+k2+i2*k1+2*i1*k2-i2*k1*q+k2*q+2*i1*k2*q)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((1//2*q*i1-1//2*i1+i3+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))*q+2*e2p((1//2*q*i1-1//2*i1+i3+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((2*i3*k1+1//2*i3*q^2+q*i3+1//2*i3+2*i3*k2*q+2*i3*k2-1//2*i1+1//2*q^2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+1//2*i3*q^2+q*i3+1//2*i3+2*i3*k2*q+2*i3*k2-1//2*i1+1//2*q^2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+q*i3+1//2*i3+1//2*i3*q^2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))*q+e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+q*i3+1//2*i3+1//2*i3*q^2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1))),
	2*e2p((1//2*q*i1-1//2*i1+i3+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1+1//2*i3*q^2+q*i3+1//2*i3+2*i3*k2*q+2*i3*k2-1//2*i1+1//2*q^2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+q*i3+1//2*i3+1//2*i3*q^2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2+1//2*q*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2+1//2*q*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((1//2*q^2*i2-1//2*i2+1//2*q*i3+1//2*i3+i3*k1-1//2*i1+1//2*q^2*i1+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((1//2*q^2*i2-1//2*i2+1//2*q*i3+1//2*i3+i3*k1-1//2*i1+1//2*q^2*i1+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2+1//2*q*i3+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2+1//2*q*i3+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2+1//2*q*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((1//2*q^2*i2-1//2*i2+1//2*q*i3+1//2*i3+i3*k1-1//2*i1+1//2*q^2*i1+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2+1//2*q*i3+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+q*i3+1//2*i3+1//2*i3*q^2+1//2*q^2*i2-1//2*i2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+q*i3+1//2*i3+1//2*i3*q^2+1//2*q^2*i2-1//2*i2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+q*i3+1//2*i3+1//2*i3*q^2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))*q+e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+q*i3+1//2*i3+1//2*i3*q^2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))+e2p((2*i3*k1+1//2*i3*q^2+q*i3+1//2*i3+2*i3*k2*q+2*i3*k2-1//2*i1+1//2*q^2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+1//2*i3*q^2+q*i3+1//2*i3+2*i3*k2*q+2*i3*k2-1//2*i1+1//2*q^2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+1//2*i3*q^2+q*i3+1//2*i3+2*i3*k2*q+2*i3*k2-1//2*i2+1//2*q^2*i2+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+1//2*i3*q^2+q*i3+1//2*i3+2*i3*k2*q+2*i3*k2-1//2*i2+1//2*q^2*i2+q*i1*k1-i1*k1)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+q*i3+1//2*i3+1//2*i3*q^2+1//2*q^2*i2-1//2*i2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+q*i3+1//2*i3+1//2*i3*q^2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))+e2p((2*i3*k1+1//2*i3*q^2+q*i3+1//2*i3+2*i3*k2*q+2*i3*k2-1//2*i1+1//2*q^2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+1//2*i3*q^2+q*i3+1//2*i3+2*i3*k2*q+2*i3*k2-1//2*i2+1//2*q^2*i2+q*i1*k1-i1*k1)*S(1//(q^2-1))),
	-2*(q-1)*e2p((1//2*q*i1-1//2*i1+i2*k1+i2+2*i2*k2)*S(1//(q-1))),
	2*e2p((1//2*q*i1-1//2*i1+i2*k1+i2+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*i4*q^2+1//2*i4*q+i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))+e2p((1//2*i4*q+1//2*i4+i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1+1//2*i4*q+1//2*i4-1//2*i3+1//2*i3*q^2-i2*k1*q+i2*k1+i4*k1*q+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1+1//2*i4*q+1//2*i4+i4*k1-1//2*i3+1//2*i3*q^2+i2*k1*q-i2*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((1//2*i4*q^2+1//2*i4*q+i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1+1//2*i4*q+1//2*i4+i4*k1-1//2*i2+1//2*q^2*i2+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((1//2*i4*q^2+1//2*i4*q+i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((1//2*i4*q^2+1//2*i4*q+i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2-i3*k1*q+i3*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+1//2*i3*q^2+1//2*q*i3+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+1//2*q*i3+1//2*i3+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+1//2*i3*q^2+1//2*q*i3+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+1//2*q*i3+1//2*i3+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0))] [
	(q-1)^2*q^2*(1+q^4+q^2+q+q^3+q^5)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	(q-1)^2*q^2*(q^2+q+1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*q^2*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-q^2*(2*q^2+q-1)*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*q^2*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	q^2*e2p((i1*k1+i1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^5-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^5-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^5-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^2,
	-e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3+e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^4-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^4+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^2,
	1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^3+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q-e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^3+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^2,
	-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-3//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^2,
	1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+e2p((1//2*q-1//2+i1*k1+i1+2*i1*k2)*S(1//(q-1)))*q^2,
	-1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-3//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	1//2*e2p((1//4*q^2-1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((1//4*q^2-1//2*q+1//4+i1*k1+i1+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	(q-1)^2*(q^2+1)*e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	(q-1)^2*e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-(3*q-1)*e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))*q^4-e2p((q*i1*k1-i1*k1+2*i2*k1+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^4-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^4+e2p((q*i1*k1-i1*k1+2*i2*k1+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2,
	e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1-i1*k1+2*i2*k1+q*i2+i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2,
	-e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1)))*(q-1),
	(q+1)*e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+1//2*q*i2+1//2*i2+1//2*q*i1-1//2*i1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q^2-2*e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	-e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	e2p((1//4*q^2-1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q^2-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q^2+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q^2,
	e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))-e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	-e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))*q+e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))-1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))*q+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	e2p((1//4*q^2-1//2*q+1//4+i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2)*S(1//(q-1)))+e2p((i1*k1+1//2*q*i1+1//2*i1+1//2*q*i2-1//2*i2+2*i1*k2+1//2*q*k1-1//2*k1)*S(1//(q-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((-1//4*q-1//4+1//4*q^3+1//4*q^2+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*q*i1*k1+q*i1+i1-i2*k1*q+i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1)))+1//2*e2p((1//4*q^3-1//4*q^2-1//4*q+1//4+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+2*i1*k2*q+2*i1*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2,
	e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1*q+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+2*i2*k1+q*i2+1//2*i2+1//2*q^2*i2+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	1//2*e2p((1//4*q+1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))*q^2-1//2*e2p((1//4*q+1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))+1//2*e2p((1//4*q+i1+1//4*q^3-1//4*q^2+q*i1+2*q*i1*k1+q*k1+k2+i2*k1+2*i1*k2-i2*k1*q+k2*q+2*i1*k2*q+3//4)*S(1//(q^2-1)))*q^2-1//2*e2p((1//4*q+i1+1//4*q^3-1//4*q^2+q*i1+2*q*i1*k1+q*k1+k2+i2*k1+2*i1*k2-i2*k1*q+k2*q+2*i1*k2*q+3//4)*S(1//(q^2-1)))+1//2*e2p((1//4*q+i1+1//4*q^3+1//4*q^2+q*i1+1//4+2*q*i1*k1+q*k1+k2+i2*k1+2*i1*k2-i2*k1*q+k2*q+2*i1*k2*q)*S(1//(q^2-1)))*q^2-1//2*e2p((1//4*q+i1+1//4*q^3+1//4*q^2+q*i1+1//4+2*q*i1*k1+q*k1+k2+i2*k1+2*i1*k2-i2*k1*q+k2*q+2*i1*k2*q)*S(1//(q^2-1)))+1//2*e2p((1//4*q+3//4+1//4*q^3-1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))*q^2-1//2*e2p((1//4*q+3//4+1//4*q^3-1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1))),
	-1//2*e2p((1//4*q+1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q+i1+1//4*q^3-1//4*q^2+q*i1+2*q*i1*k1+q*k1+k2+i2*k1+2*i1*k2-i2*k1*q+k2*q+2*i1*k2*q+3//4)*S(1//(q^2-1)))-1//2*e2p((1//4*q+i1+1//4*q^3+1//4*q^2+q*i1+1//4+2*q*i1*k1+q*k1+k2+i2*k1+2*i1*k2-i2*k1*q+k2*q+2*i1*k2*q)*S(1//(q^2-1)))-1//2*e2p((1//4*q+3//4+1//4*q^3-1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1))),
	-1//2*e2p((1//4*q+1//4+1//4*q^3+1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1)))-1//2*e2p((1//4*q+i1+1//4*q^3-1//4*q^2+q*i1+2*q*i1*k1+q*k1+k2+i2*k1+2*i1*k2-i2*k1*q+k2*q+2*i1*k2*q+3//4)*S(1//(q^2-1)))-1//2*e2p((1//4*q+i1+1//4*q^3+1//4*q^2+q*i1+1//4+2*q*i1*k1+q*k1+k2+i2*k1+2*i1*k2-i2*k1*q+k2*q+2*i1*k2*q)*S(1//(q^2-1)))-1//2*e2p((1//4*q+3//4+1//4*q^3-1//4*q^2+2*i1*k1+q*i1+i1+i2*k1*q-i2*k1+k2*q+k2+2*i1*k2*q+2*i1*k2+k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((1//2*q*i1-1//2*i1+i3+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))*q+2*e2p((1//2*q*i1-1//2*i1+i3+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))-e2p((2*i3*k1+1//2*i3*q^2+q*i3+1//2*i3+2*i3*k2*q+2*i3*k2-1//2*i1+1//2*q^2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+1//2*i3*q^2+q*i3+1//2*i3+2*i3*k2*q+2*i3*k2-1//2*i1+1//2*q^2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+q*i3+1//2*i3+1//2*i3*q^2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))*q+e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+q*i3+1//2*i3+1//2*i3*q^2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1))),
	2*e2p((1//2*q*i1-1//2*i1+i3+1//2*q*i2-1//2*i2+i3*k1+2*i3*k2)*S(1//(q-1)))+e2p((2*i3*k1+1//2*i3*q^2+q*i3+1//2*i3+2*i3*k2*q+2*i3*k2-1//2*i1+1//2*q^2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+q*i3+1//2*i3+1//2*i3*q^2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2+1//2*q*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2+1//2*q*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((1//2*q^2*i2-1//2*i2+1//2*q*i3+1//2*i3+i3*k1-1//2*i1+1//2*q^2*i1+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((1//2*q^2*i2-1//2*i2+1//2*q*i3+1//2*i3+i3*k1-1//2*i1+1//2*q^2*i1+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2+1//2*q*i3+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2+1//2*q*i3+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2+1//2*q*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((1//2*q^2*i2-1//2*i2+1//2*q*i3+1//2*i3+i3*k1-1//2*i1+1//2*q^2*i1+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+1//2*q^2*i1-1//2*i1+1//2*q*i3+1//2*i3+1//2*q^2*i2-1//2*i2+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+1//2*q^2*i1-1//2*i1+1//2*i3*q^2+1//2*q*i3+1//2*q^2*i2-1//2*i2+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+q*i3+1//2*i3+1//2*i3*q^2+1//2*q^2*i2-1//2*i2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+q*i3+1//2*i3+1//2*i3*q^2+1//2*q^2*i2-1//2*i2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+q*i3+1//2*i3+1//2*i3*q^2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))*q+e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+q*i3+1//2*i3+1//2*i3*q^2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))+e2p((2*i3*k1+1//2*i3*q^2+q*i3+1//2*i3+2*i3*k2*q+2*i3*k2-1//2*i1+1//2*q^2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+1//2*i3*q^2+q*i3+1//2*i3+2*i3*k2*q+2*i3*k2-1//2*i1+1//2*q^2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+1//2*i3*q^2+q*i3+1//2*i3+2*i3*k2*q+2*i3*k2-1//2*i2+1//2*q^2*i2+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+1//2*i3*q^2+q*i3+1//2*i3+2*i3*k2*q+2*i3*k2-1//2*i2+1//2*q^2*i2+q*i1*k1-i1*k1)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+q*i3+1//2*i3+1//2*i3*q^2+1//2*q^2*i2-1//2*i2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+q*i3+1//2*i3+1//2*i3*q^2+2*i3*k1*q+2*i3*k2*q+2*i3*k2)*S(1//(q^2-1)))+e2p((2*i3*k1+1//2*i3*q^2+q*i3+1//2*i3+2*i3*k2*q+2*i3*k2-1//2*i1+1//2*q^2*i1+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+1//2*i3*q^2+q*i3+1//2*i3+2*i3*k2*q+2*i3*k2-1//2*i2+1//2*q^2*i2+q*i1*k1-i1*k1)*S(1//(q^2-1))),
	2*(q-1)*e2p((1//2*q*i1-1//2*i1+i2*k1+i2+2*i2*k2)*S(1//(q-1))),
	-2*e2p((1//2*q*i1-1//2*i1+i2*k1+i2+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*i4*q^2+1//2*i4*q+i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))+e2p((1//2*i4*q+1//2*i4+i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1+1//2*i4*q+1//2*i4-1//2*i3+1//2*i3*q^2-i2*k1*q+i2*k1+i4*k1*q+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1+1//2*i4*q+1//2*i4+i4*k1-1//2*i3+1//2*i3*q^2+i2*k1*q-i2*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((1//2*i4*q^2+1//2*i4*q+i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+1//2*i3*q^2-1//2*i3)*S(1//(q^2-1)))+e2p((1//2*q^2*i1-1//2*i1+1//2*i4*q+1//2*i4+i4*k1-1//2*i2+1//2*q^2*i2+i3*k1*q-i3*k1+i4*k2*q+i4*k2)*S(1//(q^2-1)))+e2p((1//2*i4*q^2+1//2*i4*q+i4*k1+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((1//2*i4*q^2+1//2*i4*q+i4*k1*q+i4*k2*q+i4*k2+1//2*q^2*i1-1//2*i1+1//2*q^2*i2-1//2*i2-i3*k1*q+i3*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+1//2*i3*q^2+1//2*q*i3+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((1//2*q^2*i1-1//2*i1+i2*k1*q-i2*k1+1//2*q*i3+1//2*i3+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+1//2*i3*q^2+1//2*q*i3+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((1//2*q^2*i1-1//2*i1-i2*k1*q+i2*k1+1//2*q*i3+1//2*i3+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0))] [
	(2*q+4*q^5+4*q^3+3*q^2+q^8+4*q^4+1+2*q^7+3*q^6)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q^5+2*q^4+3*q^3+3*q^2+2*q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(2*q^4+5*q^3+4*q^2+2*q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q^3+2*q^2+2*q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q^3+3*q^2+2*q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(2*q^2+3*q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q^2+2*q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(3*q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	4*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^4+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^5+3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4+4*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3,
	2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3,
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+3*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+4*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4+2*e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^3+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4+2*e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^3+2*e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^3,
	e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1))),
	3*e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+2*e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+3*e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+2*e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i2*k1-2*i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+e2p((2*i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^3+2*e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+2*e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^3+e2p((2*i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-2*i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1-2*i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^2,
	2*e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))+2*e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+e2p((2*i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-2*i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-2*i1*k1+i1*k2+i2*k3)*S(1//(q-1))),
	e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+e2p((2*i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-2*i1*k1+i1*k2+i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((3*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((4*i2*k1-2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((3*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((4*i2*k1-2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1))),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((4*i2*k1-2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((4*i2*k1-2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1))),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((4*i2*k1-2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1))),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((4*i2*k1-2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2+2*q+1)*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	(q+1)*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	(q+1)*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((2*i1*k1+2*i1*k3+k3+1//2*q*k1+1//2*k1+i2*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+2*i1*k3+k3+1//2*q*k1+1//2*k1+i2*k2)*S(1//(q-1)))+e2p((2*i1*k1+k2+2*i1*k3+2*i1*k2+k3+1//2*q*k1+1//2*k1-i2*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+k2+2*i1*k3+2*i1*k2+k3+1//2*q*k1+1//2*k1-i2*k2)*S(1//(q-1))),
	e2p((2*i1*k1+2*i1*k3+k3+1//2*q*k1+1//2*k1+i2*k2)*S(1//(q-1)))+e2p((2*i1*k1+k2+2*i1*k3+2*i1*k2+k3+1//2*q*k1+1//2*k1-i2*k2)*S(1//(q-1))),
	e2p((2*i1*k1+2*i1*k3+k3+1//2*q*k1+1//2*k1+i2*k2)*S(1//(q-1)))+e2p((2*i1*k1+k2+2*i1*k3+2*i1*k2+k3+1//2*q*k1+1//2*k1-i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i3*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+i3*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((4*i3*k1-i1*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((3*i3*k1-i2*k1+i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k1+i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+i1*k1+i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((3*i3*k1-i2*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k1+i1*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+i1*k1+i2*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((3*i3*k1-i2*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((3*i3*k1-i2*k1+i1*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((3*i3*k1-i1*k1+i2*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i2*k1+i3*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((3*i3*k1-i1*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((4*i3*k1-i1*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q,
	e2p((3*i3*k1-i2*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+i1*k1+i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k1+i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((3*i3*k1-i2*k1+i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((4*i3*k1-i1*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+i3*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1-i2*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))+e2p((2*i1*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k1-i1*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1-i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i1*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i3*k1-i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-2*i1*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-i1*k1-i2*k1+i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))*q+e2p((i2*k1+i3*k1-i1*k1+i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1-i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1-i2*k1+i1*k1+i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+i3*k1-i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-2*i1*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i3*k1-i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-2*i1*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i1*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1-i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k1-i1*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1-i2*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))+e2p((2*i1*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-2*i1*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((-i1*k1+4*i2*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((-i1*k1+4*i2*k1+2*i2*k3+i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((-i1*k1+4*i2*k1+2*i2*k3+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1))),
	e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+i3*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1)))+e2p((i1*k1+i4*k1-i2*k1+i4*k2-i3*k2+i4*k3)*S(1//(q-1)))+e2p((i2*k1+i4*k1-i3*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i4*k1-i2*k1+i1*k2+i4*k3)*S(1//(q-1)))+e2p((2*i4*k1-i1*k1-i3*k1+i2*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i3*k1+i2*k2+i4*k3)*S(1//(q-1)))+e2p((i1*k1+i4*k1-i2*k1+i3*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i2*k1+i1*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i2*k1+i3*k2+i4*k3)*S(1//(q-1)))+e2p((2*i4*k1-i3*k1-i1*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i4*k1-i1*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i2*k1+i4*k2-i3*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i2*k1+i1*k2+i4*k3)*S(1//(q-1)))+e2p((2*i4*k1-i3*k1-i2*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1)))+e2p((2*i4*k1-i2*k1-i1*k1+i3*k2+i4*k3)*S(1//(q-1)))+e2p((2*i4*k1-i2*k1-i1*k1+i4*k2-i3*k2+i4*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i4*k2-i3*k2+i4*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i1*k1+i2*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i1*k1+i2*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i4*k1-i2*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1)))+e2p((2*i4*k1-i3*k1-i2*k1+i1*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i1*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i1*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i1*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1-i2*k2+i3*k3+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1-i2*k2+i3*k3+i3*k2)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i2*k2+i3*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q*(2*q+4*q^5+4*q^3+3*q^2+q^8+4*q^4+1+2*q^7+3*q^6)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	q*(q^5+2*q^4+3*q^3+3*q^2+2*q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	q*(3*q^3+4*q^2+2*q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	q*(q^3+2*q^2+2*q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	q*(2*q^2+2*q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	q*(q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	q*(q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q,
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^5+2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^4+2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3+2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^5+3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4+4*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+4*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^4+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3+2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+4*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	(q+1)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	2*e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+2*e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^3+e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4+2*e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^3+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^3+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^4+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^3+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^4+2*e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+2*e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q,
	3*e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+3*e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q,
	e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q,
	e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^3+e2p((2*i2*k1-2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^3+e2p((2*i2*k1-2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1-2*i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^3+e2p((2*i2*k1-2*i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+2*e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^3+e2p((2*i2*k1-2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+2*e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+2*e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^2+e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^3+e2p((2*i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^3+e2p((2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1-2*i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1))),
	2*e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))+2*e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-2*i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q,
	e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+2*e2p((i1*k1+i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+2*e2p((3*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((4*i2*k1-2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((4*i2*k1-2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((3*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q,
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1))),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((4*i2*k1-2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((3*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1))),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-(q^2+2*q+1)*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-(q+1)*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-(q+1)*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+2*i1*k3+k3+1//2*q*k1+1//2*k1+i2*k2)*S(1//(q-1)))*q^2-e2p((2*i1*k1+2*i1*k3+k3+1//2*q*k1+1//2*k1+i2*k2)*S(1//(q-1)))-e2p((2*i1*k1+k2+2*i1*k3+2*i1*k2+k3+1//2*q*k1+1//2*k1-i2*k2)*S(1//(q-1)))*q^2-e2p((2*i1*k1+k2+2*i1*k3+2*i1*k2+k3+1//2*q*k1+1//2*k1-i2*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+2*i1*k3+k3+1//2*q*k1+1//2*k1+i2*k2)*S(1//(q-1)))-e2p((2*i1*k1+k2+2*i1*k3+2*i1*k2+k3+1//2*q*k1+1//2*k1-i2*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+2*i1*k3+k3+1//2*q*k1+1//2*k1+i2*k2)*S(1//(q-1)))-e2p((2*i1*k1+k2+2*i1*k3+2*i1*k2+k3+1//2*q*k1+1//2*k1-i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i3*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+i3*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((4*i3*k1-i1*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((3*i3*k1-i2*k1+i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k1+i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+i1*k1+i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((3*i3*k1-i2*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k1+i1*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+i1*k1+i2*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((3*i3*k1-i2*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((3*i3*k1-i2*k1+i1*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((3*i3*k1-i1*k1+i2*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i2*k1+i3*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((3*i3*k1-i1*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((4*i3*k1-i1*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q,
	e2p((3*i3*k1-i2*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+i1*k1+i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k1+i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((3*i3*k1-i1*k1+i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((3*i3*k1-i2*k1+i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((4*i3*k1-i1*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+i3*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1))),
	e2p((i3*k1-i1*k1+i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1-i2*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k1-i1*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1-i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i1*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i3*k1-i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-i1*k1-i2*k1+i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1-i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-2*i1*k1+i2*k2+i3*k3)*S(1//(q-1)))*q+e2p((i2*k1+i3*k1-i1*k1+i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-2*i1*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1-i2*k1+i1*k1+i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+i3*k1-i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1))),
	e2p((i1*k1+i3*k1-i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i1*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1-i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k1-i1*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1-i2*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))-e2p((-i1*k1+4*i2*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q-e2p((-i1*k1+4*i2*k1+2*i2*k3+i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))-e2p((-i1*k1+4*i2*k1+2*i2*k3+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))*q-e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))-e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))*q-e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1))),
	-e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))-e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+i3*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1)))+e2p((i1*k1+i4*k1-i2*k1+i4*k2-i3*k2+i4*k3)*S(1//(q-1)))+e2p((i2*k1+i4*k1-i3*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i4*k1-i2*k1+i1*k2+i4*k3)*S(1//(q-1)))+e2p((2*i4*k1-i1*k1-i3*k1+i2*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i3*k1+i2*k2+i4*k3)*S(1//(q-1)))+e2p((i1*k1+i4*k1-i2*k1+i3*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i2*k1+i1*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i2*k1+i3*k2+i4*k3)*S(1//(q-1)))+e2p((2*i4*k1-i3*k1-i1*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i4*k1-i1*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i2*k1+i4*k2-i3*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i2*k1+i1*k2+i4*k3)*S(1//(q-1)))+e2p((2*i4*k1-i3*k1-i2*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1)))+e2p((2*i4*k1-i2*k1-i1*k1+i3*k2+i4*k3)*S(1//(q-1)))+e2p((2*i4*k1-i2*k1-i1*k1+i4*k2-i3*k2+i4*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i4*k2-i3*k2+i4*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i1*k1+i2*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i1*k1+i2*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i4*k1-i2*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1)))+e2p((2*i4*k1-i3*k1-i2*k1+i1*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i1*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i1*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((i1*k1+i2*k2+i3*k3)*S(1//(q-1)))-e2p((i1*k1-i2*k2+i3*k3+i3*k2)*S(1//(q-1)))-e2p((2*i3*k1-i1*k1-i2*k2+i3*k3+i3*k2)*S(1//(q-1)))-e2p((2*i3*k1-i1*k1+i2*k2+i3*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(2*q+4*q^5+4*q^3+3*q^2+q^8+4*q^4+1+2*q^7+3*q^6)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(2*q+2*q^5+4*q^3+3*q^2+3*q^4+1+q^6)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q^4+5*q^3+3*q^2+2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q^4+3*q^3+3*q^2+2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(2*q^3+3*q^2+2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q^2+2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(2*q^2+2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^4,
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3,
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3,
	3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^3+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^3+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^3+2*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4+2*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^3+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^3+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^2,
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^2,
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+3*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	(q^4+2*q^3+2*q^2+2*q+1)*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	(q^2+2*q+1)*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	(3*q+1)*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	(q+1)*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^3+2*e2p((i2*k1-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^2+2*e2p((i2*k1-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+2*e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+2*e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^2+e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^3,
	2*e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+2*e2p((i2*k1-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+2*e2p((i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+2*e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+2*e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q,
	e2p((i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1+i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+i1*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+i2*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))*q,
	e2p((i1*k1+i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1))),
	e2p((i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1-i2*k2+i3*k3+i3*k2)*S(1//(q-1)))+e2p((i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))*q+e2p((i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i2*k2+i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+i3*k3)*S(1//(q-1)))*q+e2p((i1*k1-i2*k2+i3*k3+i3*k2)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1-i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q,
	e2p((i1*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1-i2*k2+i3*k3+i3*k2)*S(1//(q-1)))+e2p((i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i3*k3)*S(1//(q-1))),
	e2p((i3*k1+i1*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1))),
	e2p((i3*k1+i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+i3*k3)*S(1//(q-1))),
	e2p((i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i3*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+i3*k2+i4*k3)*S(1//(q-1)))+e2p((i2*k1+i4*k2-i3*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i4*k2-i3*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i3*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i2*k2+i4*k3)*S(1//(q-1)))+e2p((i2*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i1*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i1*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i4*k2-i3*k2+i4*k3)*S(1//(q-1)))+e2p((i1*k1+i4*k2-i3*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i3*k2+i4*k3)*S(1//(q-1)))+e2p((i1*k1+i3*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i1*k2+i4*k3)*S(1//(q-1)))+e2p((i1*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i2*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i2*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1))),
	e2p((i4*k1-i1*k1+i2*k2+i4*k3)*S(1//(q-1)))+e2p((i2*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i1*k2+i4*k3)*S(1//(q-1)))+e2p((i1*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i4*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	q*(2*q+4*q^5+4*q^3+3*q^2+q^8+4*q^4+1+2*q^7+3*q^6)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	q*(q^4+2*q^3+2*q^2+2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	q*(4*q^3+4*q^2+3*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	q*(q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	q*(q^2+2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	2*q*(q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	q*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	2*q*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^5+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^4+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^5+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^5+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2,
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^4+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	q*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^3+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+2*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^3+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^3+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^4+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^4+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4+2*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^3+2*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^4+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q,
	2*e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+2*e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+2*e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+3*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+2*e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q,
	(q+1)*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-(q^4+2*q^3+2*q^2+2*q+1)*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-(q^2+2*q+1)*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-(3*q+1)*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-(q+1)*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^3+2*e2p((i2*k1-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^2+2*e2p((i2*k1-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+2*e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+2*e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^2+e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^3,
	2*e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+2*e2p((i2*k1-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+2*e2p((i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+2*e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q,
	e2p((i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2,
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-i1*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-i1*k1+i2*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+i1*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i2*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+i2*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1+i1*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+2*i3*k3)*S(1//(q-1)))*q,
	e2p((i3*k1+2*i3*k2-i2*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))+e2p((i3*k1+i2*k2+2*i3*k3)*S(1//(q-1))),
	e2p((i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1-i2*k2+i3*k3+i3*k2)*S(1//(q-1)))+e2p((i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))*q+e2p((i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i2*k2+i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+i3*k3)*S(1//(q-1)))*q+e2p((i1*k1-i2*k2+i3*k3+i3*k2)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1-i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q,
	e2p((i1*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1-i2*k2+i3*k3+i3*k2)*S(1//(q-1)))+e2p((i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i3*k3)*S(1//(q-1))),
	-e2p((i3*k1+i1*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((i3*k1+i1*k2+2*i3*k3)*S(1//(q-1)))-e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((i3*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((i3*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1))),
	-e2p((i3*k1+i1*k2+2*i3*k3)*S(1//(q-1)))-e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((i3*k1+2*i3*k2-i1*k2+2*i3*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q-e2p((i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))-e2p((i3*k1-i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))*q-e2p((i3*k1-i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))-e2p((i3*k1-i1*k1+i1*k2+i3*k3)*S(1//(q-1)))*q-e2p((i3*k1-i1*k1+i1*k2+i3*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+i3*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+i3*k3)*S(1//(q-1))),
	-e2p((i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))-e2p((i3*k1-i1*k1+i3*k2-i1*k2+i3*k3)*S(1//(q-1)))-e2p((i3*k1-i1*k1+i1*k2+i3*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+i3*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+i3*k2+i4*k3)*S(1//(q-1)))+e2p((i2*k1+i4*k2-i3*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i4*k2-i3*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i3*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i2*k2+i4*k3)*S(1//(q-1)))+e2p((i2*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i1*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i1*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i4*k2-i3*k2+i4*k3)*S(1//(q-1)))+e2p((i1*k1+i4*k2-i3*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i3*k2+i4*k3)*S(1//(q-1)))+e2p((i1*k1+i3*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i1*k2+i4*k3)*S(1//(q-1)))+e2p((i1*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i2*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i2*k2+i4*k3)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1)))+e2p((i3*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1))),
	-e2p((i4*k1-i1*k1+i2*k2+i4*k3)*S(1//(q-1)))-e2p((i2*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1)))-e2p((i1*k1+i2*k2+i4*k3)*S(1//(q-1)))-e2p((i4*k1-i2*k1+i4*k2-i1*k2+i4*k3)*S(1//(q-1)))-e2p((i4*k1-i2*k1+i1*k2+i4*k3)*S(1//(q-1)))-e2p((i1*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1)))-e2p((i4*k1-i1*k1+i4*k2-i2*k2+i4*k3)*S(1//(q-1)))-e2p((i2*k1+i1*k2+i4*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q^3+1+q^2+q^5)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(2*q^3+q^2+q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q^3+2*q^2+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q^3+q^2+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q^2+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^4-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^5,
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2,
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4+e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4,
	-e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-2*e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-2*e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^3-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q^3-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1))),
	-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1))),
	-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1))),
	e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((4*i2*k1-2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((4*i2*k1-2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((4*i2*k1-2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((4*i2*k1-2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((4*i2*k1-2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((4*i2*k1-2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-2*e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2,
	-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	(q-1)*(q+1)*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*(q-1),
	-(q+1)*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*q*i1*k1+2*i1*k1+k2*q+2*i1*k3*q+2*i1*k3+2*i1*k2*q+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((2*q*i1*k1+2*i1*k1+k2*q+2*i1*k3*q+2*i1*k3+2*i1*k2*q+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1+2*i1*k1+k2+2*i1*k3*q+2*i1*k3+2*i1*k2+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q^2-e2p((2*q*i1*k1+2*i1*k1+k2+2*i1*k3*q+2*i1*k3+2*i1*k2+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1+i2*k2*q-i2*k2)*S(1//(q^2-1))),
	-e2p((2*q*i1*k1+2*i1*k1+k2*q+2*i1*k3*q+2*i1*k3+2*i1*k2*q+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1+2*i1*k1+k2+2*i1*k3*q+2*i1*k3+2*i1*k2+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1+i2*k2*q-i2*k2)*S(1//(q^2-1))),
	-e2p((2*q*i1*k1+2*i1*k1+k2*q+2*i1*k3*q+2*i1*k3+2*i1*k2*q+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1+2*i1*k1+k2+2*i1*k3*q+2*i1*k3+2*i1*k2+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1+i2*k2*q-i2*k2)*S(1//(q^2-1))),
	e2p((i1*k1+2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((i1*k1+2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((4*i3*k1-i1*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((4*i3*k1-i1*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((2*i3*k1-i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1))),
	-e2p((i1*k1+2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((4*i3*k1-i1*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((2*i3*k1-i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+q*i1*k1+i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+q*i1*k1+i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+q*i1*k1+i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+q*i1*k1+i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1*q+3*i3*k1-i1*k1-q*i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1*q+3*i3*k1-i1*k1-q*i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1*q+3*i3*k1-i1*k1-q*i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1*q+3*i3*k1-i1*k1-q*i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+q*i1*k1+i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+q*i1*k1+i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1*q+3*i3*k1-i1*k1-q*i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1*q+3*i3*k1-i1*k1-q*i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((-i1*k1+4*i2*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q-e2p((-i1*k1+4*i2*k1+2*i2*k3+i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))-e2p((-i1*k1+4*i2*k1+2*i2*k3+i2*k2)*S(1//(q-1))),
	-e2p((i3*k2*q+i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((i3*k2*q+i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k2+i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((i3*k2+i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((2*q*i1*k1+2*i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k1-2*q*i1*k1-2*i1*k1+i3*k2*q-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((2*q*i1*k1+2*i1*k1+i3*k2*q-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k1-2*q*i1*k1-2*i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	-e2p((i3*k2*q+i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k2+i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((2*q*i1*k1+2*i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k1-2*q*i1*k1-2*i1*k1+i3*k2*q-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((2*q*i1*k1+2*i1*k1+i3*k2*q-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k1-2*q*i1*k1-2*i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))*q-e2p((i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q-e2p((i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1))),
	-e2p((i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-e2p((2*i4*k1*q+2*i4*k1-q*i1*k1-i1*k1+i4*k2-i2*k1*q-i2*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i4*k2*q+q*i1*k1+i1*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1-q*i1*k1-i1*k1+i4*k2*q+i2*k1*q+i2*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1-i2*k1*q-i2*k1+i4*k2+q*i1*k1+i1*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i4*k2+i4*k1*q+i4*k1-q*i1*k1-i1*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i4*k2+q*i1*k1+i1*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i4*k2*q+i4*k1*q+i4*k1-i2*k1*q-i2*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((2*i4*k1*q+2*i4*k1-q*i1*k1-i1*k1+i4*k2*q-i2*k1*q-i2*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1*k1+i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1-i1*k1+2*i3*k1*q+2*i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))-e2p((-q*i1*k1-i1*k1+2*i3*k1*q+2*i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*q*(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-q*(q^3+1+q^2+q^5)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*q*(q^2+q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-q*(q^3+2*q^2+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q,
	(q-1)*q*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-q*(q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q,
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^5-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^5+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^4-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4,
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2,
	-(q+1)*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4+e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4,
	-e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i1*k1+i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((3*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^4-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^4,
	-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q,
	-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q,
	-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^3+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q^3+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1))),
	e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1))),
	e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1))),
	e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((3*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i2*k1+i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((3*i1*k1+1//2*q*k1-1//2*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i2*k1+i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((4*i2*k1-2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((4*i2*k1-2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q,
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*(q-1),
	-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((4*i2*k1-2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q,
	-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-2*e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2,
	-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-(q-1)*(q+1)*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*(q-1),
	(q+1)*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*q*i1*k1+2*i1*k1+k2+2*i1*k3*q+2*i1*k3+2*i1*k2+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q^2+e2p((2*q*i1*k1+2*i1*k1+k2+2*i1*k3*q+2*i1*k3+2*i1*k2+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1+2*i1*k1+k2*q+2*i1*k3*q+2*i1*k3+2*i1*k2*q+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((2*q*i1*k1+2*i1*k1+k2*q+2*i1*k3*q+2*i1*k3+2*i1*k2*q+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((2*q*i1*k1+2*i1*k1+k2+2*i1*k3*q+2*i1*k3+2*i1*k2+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1+2*i1*k1+k2*q+2*i1*k3*q+2*i1*k3+2*i1*k2*q+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((2*q*i1*k1+2*i1*k1+k2+2*i1*k3*q+2*i1*k3+2*i1*k2+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1+2*i1*k1+k2*q+2*i1*k3*q+2*i1*k3+2*i1*k2*q+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((i1*k1+2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((i1*k1+2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((4*i3*k1-i1*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((4*i3*k1-i1*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((2*i3*k1-i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1))),
	-e2p((i1*k1+2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((4*i3*k1-i1*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((2*i3*k1-i1*k1+i2*k1+i3*k2+2*i3*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+q*i1*k1+i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+q*i1*k1+i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+q*i1*k1+i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+q*i1*k1+i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1*q+3*i3*k1-i1*k1-q*i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1*q+3*i3*k1-i1*k1-q*i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1*q+3*i3*k1-i1*k1-q*i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1*q+3*i3*k1-i1*k1-q*i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+q*i1*k1+i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+q*i1*k1+i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1*q+3*i3*k1-i1*k1-q*i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1*q+3*i3*k1-i1*k1-q*i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))-e2p((-i1*k1+4*i2*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((-i1*k1+4*i2*k1+2*i2*k3+i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((-i1*k1+4*i2*k1+2*i2*k3+i2*k2)*S(1//(q-1))),
	-e2p((i3*k2*q+i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((i3*k2*q+i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((2*q*i1*k1+2*i1*k1+i3*k2*q-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((2*i3*k1*q+2*i3*k1-2*q*i1*k1-2*i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((2*i3*k1*q+2*i3*k1-2*q*i1*k1-2*i1*k1+i3*k2*q-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((i3*k2+i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((i3*k2+i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((2*q*i1*k1+2*i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q,
	-e2p((i3*k2*q+i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k2+i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))+e2p((i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1))),
	e2p((i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))+e2p((i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-e2p((2*i4*k1*q+2*i4*k1-q*i1*k1-i1*k1+i4*k2-i2*k1*q-i2*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i4*k2*q+q*i1*k1+i1*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1-q*i1*k1-i1*k1+i4*k2*q+i2*k1*q+i2*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1-i2*k1*q-i2*k1+i4*k2+q*i1*k1+i1*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i4*k2+i4*k1*q+i4*k1-q*i1*k1-i1*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i4*k2+q*i1*k1+i1*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i4*k2*q+i4*k1*q+i4*k1-i2*k1*q-i2*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((2*i4*k1*q+2*i4*k1-q*i1*k1-i1*k1+i4*k2*q-i2*k1*q-i2*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-q*i1*k1-i1*k1+2*i3*k1*q+2*i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((-q*i1*k1-i1*k1+2*i3*k1*q+2*i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q^5+q^4+2*q^3+2*q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^4-q^3-q^2-1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q^3+2*q^2+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q^2+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q^2+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q^2+q+1+q^3)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q^2+q+1+q^3)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q^2+q+1+q^3)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(q-1)*(q^2+q+1+q^3)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))*q^3-e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^3-e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+i2*k2)*S(1//(q-1)))-e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+i2*k2)*S(1//(q-1)))-e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k2)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k2)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))*q^2-e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))-e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))*q^2-e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	-e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))-e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	-e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))-e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	-e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))*q^2-e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))-e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))*q^2-e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	-e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))-e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	-e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))-e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))*q-e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q-e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	-e2p((i1*k1+i3*k2)*S(1//(q-1)))-e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i2*k1*q+2*i2*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((2*i2*k1*q+2*i2*k1-q*i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	-e2p((2*i2*k1*q+2*i2*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))-e2p((2*i2*k1*q+2*i2*k1-q*i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1))),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))*q-e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q-e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	-e2p((i1*k1+i3*k2)*S(1//(q-1)))-e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	-e2p((q*i1*k1-i1*k1+i3*k2*q+i3*k2+i3*k1)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+i3*k2*q+i3*k2+i3*k1)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i3*k2*q+i3*k2+i3*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1*q+i3*k1-q*i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-e2p((i3*k1*q+i3*k1-q*i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*q*(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*(q^2+q+1+q^3)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-q*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	-2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*q*(q^2+q+1+q^3)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(q-1)*q*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-q*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*q*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*(q^2+q+1+q^3)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q-1)*(q^2+q+1+q^3)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))*q^3-e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^3-e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+i2*k2)*S(1//(q-1)))-e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+i2*k2)*S(1//(q-1)))-e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3+e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q^2-e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	-e2p((i1*k1+2*i2*k2)*S(1//(q-1)))*q-e2p((2*i2*k1-i1*k1+2*i2*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q^2-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	-e2p((q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))*q^2-e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))-e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))*q^2-e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	-e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))-e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	-e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))-e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))*q^2+e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))+e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))*q^2+e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))+e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))+e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))*q-e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q-e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	-e2p((i1*k1+i3*k2)*S(1//(q-1)))-e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i2*k1*q+2*i2*k1-i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q-e2p((2*i2*k1*q+2*i2*k1-q*i1*k1+2*i2*k2*q+2*i2*k2)*S(1//(q^2-1)))*q,
	(0)*e2p(S(0)),
	-e2p((i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2)*S(1//(q-1)))-e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2)*S(1//(q-1))),
	-e2p((q*i1*k1-i1*k1+i3*k2*q+i3*k2+i3*k1)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+i3*k2*q+i3*k2+i3*k1)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i3*k2*q+i3*k2+i3*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1*q+i3*k1-q*i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	e2p((i3*k1*q+i3*k1-i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1*q+i3*k1-q*i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1+i3*k2*q+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q^2+q^4+1+q^6)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(q^3+2*q^2+q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q^4-q^3-q^2-1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q^2+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(2*q^2+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^4+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4,
	-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3,
	-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3,
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^3-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^2+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^3-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2,
	e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1))),
	-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1))),
	-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1))),
	-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1))),
	-e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+q*i1*k1+i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+2*i3*k1*q+2*i3*k1-i1*k1-q*i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+2*i3*k1*q+2*i3*k1-i1*k1-q*i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+q*i1*k1+i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1))),
	-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+q*i1*k1+i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+2*i3*k1*q+2*i3*k1-i1*k1-q*i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+2*i3*k1*q+2*i3*k1-i1*k1-q*i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+q*i1*k1+i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k2+i3*k1*q+i3*k1-q*i1*k1-i1*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((i3*k2+i3*k1*q+i3*k1-q*i1*k1-i1*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k2*q+i3*k1*q+i3*k1-q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((i3*k2*q+i3*k1*q+i3*k1-q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))*q-e2p((q*i1*k1+i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((q*i1*k1+i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	-e2p((i3*k2+i3*k1*q+i3*k1-q*i1*k1-i1*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k2*q+i3*k1*q+i3*k1-q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))*q-e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1+i1*k2*q-i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q-e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1+i1*k2*q-i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1))),
	-e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1+i1*k2*q-i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1))),
	-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2)*S(1//(q^2-1))),
	-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i4*k2+i4*k1*q+i4*k1-q*i1*k1-i1*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k2+i4*k1*q+i4*k1-i2*k1*q-i2*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k2+i2*k1*q+i2*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k2*q+i2*k1*q+i2*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k2*q+i4*k1*q+i4*k1-q*i1*k1-i1*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k2*q+q*i1*k1+i1*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k2+q*i1*k1+i1*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k2*q+i4*k1*q+i4*k1-i2*k1*q-i2*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-e2p((i4*k2+i4*k1*q+i4*k1-q*i1*k1-i1*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k2*q+i4*k1*q+i4*k1-q*i1*k1-i1*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k2*q+q*i1*k1+i1*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k2+q*i1*k1+i1*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3+i4*k2*q)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1-q*i1*k1-i1*k1+i2*k2*q-i2*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1-q*i1*k1-i1*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3+i4*k2*q)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i2*k2*q-i2*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*q*(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-q*(q^4+2*q^2+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*q*(2*q^2+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-q*(2*q^3+2*q^2+q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-q*(q^2+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-2*q*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^5-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^5-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^5,
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^4-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3,
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q,
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2,
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q,
	-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^4-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^3+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^3+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4,
	-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q,
	e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*(q-1),
	-2*e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-2*e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q,
	-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^4-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^4,
	e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q,
	-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-2*e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-2*e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q,
	(q+1)*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	-e2p((2*i1*k1-i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q^2-e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q^2-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2,
	e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q-e2p((2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1))),
	-e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((i2*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((2*i3*k1-i2*k1+i3*k2+2*i3*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))*q+e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+2*i3*k1*q+2*i3*k1-i1*k1-q*i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+q*i1*k1+i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+2*i3*k1*q+2*i3*k1-i1*k1-q*i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+q*i1*k1+i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	e2p((i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3)*S(1//(q-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k2+i3*k1*q+i3*k1-q*i1*k1-i1*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((i3*k2+i3*k1*q+i3*k1-q*i1*k1-i1*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k2*q+i3*k1*q+i3*k1-q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((i3*k2*q+i3*k1*q+i3*k1-q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))*q-e2p((q*i1*k1+i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((q*i1*k1+i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	-e2p((i3*k2+i3*k1*q+i3*k1-q*i1*k1-i1*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k2*q+i3*k1*q+i3*k1-q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	-e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1+i1*k2*q-i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1+i1*k2*q-i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1))),
	e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1+i1*k2*q-i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1))),
	e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2)*S(1//(q^2-1))),
	e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i4*k2+i4*k1*q+i4*k1-q*i1*k1-i1*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k2+i4*k1*q+i4*k1-i2*k1*q-i2*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k2+i2*k1*q+i2*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k2*q+i2*k1*q+i2*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k2*q+i4*k1*q+i4*k1-q*i1*k1-i1*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k2*q+q*i1*k1+i1*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k2+q*i1*k1+i1*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k2*q+i4*k1*q+i4*k1-i2*k1*q-i2*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	e2p((i4*k2+q*i1*k1+i1*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k2*q+i4*k1*q+i4*k1-q*i1*k1-i1*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k2*q+q*i1*k1+i1*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k2+i4*k1*q+i4*k1-q*i1*k1-i1*k1+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1-q*i1*k1-i1*k1+i2*k2*q-i2*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+i2*k2*q-i2*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3+i4*k2*q)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1-q*i1*k1-i1*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3+i4*k2*q)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(q^4+q^3+2*q^2+q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q^3-2*q^2-1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(2*q^4+q^3-1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q^3-q^2-1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q^2+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^4-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^5+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4,
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^3-e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^3-e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1))),
	e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))-e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1))),
	2*e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+2*e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))-e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^4+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^4,
	-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^3-e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^3-e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1))),
	-e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))-e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1))),
	-e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))-e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-(q+1)*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*(q-1),
	-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q^2-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q^2-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q^2-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q^2-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1))),
	e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1))),
	-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1))),
	-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1))),
	-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1))),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((2*i1*k1+2*i1*k3+k3+1//2*q*k1+1//2*k1+i2*k2)*S(1//(q-1)))*q^2-e2p((2*i1*k1+2*i1*k3+k3+1//2*q*k1+1//2*k1+i2*k2)*S(1//(q-1)))-e2p((2*i1*k1+k2+2*i1*k3+2*i1*k2+k3+1//2*q*k1+1//2*k1-i2*k2)*S(1//(q-1)))*q^2-e2p((2*i1*k1+k2+2*i1*k3+2*i1*k2+k3+1//2*q*k1+1//2*k1-i2*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+2*i1*k3+k3+1//2*q*k1+1//2*k1+i2*k2)*S(1//(q-1)))-e2p((2*i1*k1+k2+2*i1*k3+2*i1*k2+k3+1//2*q*k1+1//2*k1-i2*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+2*i1*k3+k3+1//2*q*k1+1//2*k1+i2*k2)*S(1//(q-1)))-e2p((2*i1*k1+k2+2*i1*k3+2*i1*k2+k3+1//2*q*k1+1//2*k1-i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))*q-e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))*q-e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1))),
	-e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))-e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1))),
	e2p((i3*k1*q+3*i3*k1+2*i3*k3*q+2*i3*k3+i2*k1*q-i2*k1+i1*k2+i1*k2*q)*S(1//(q^2-1)))*q-e2p((i3*k1*q+3*i3*k1+2*i3*k3*q+2*i3*k3+i2*k1*q-i2*k1+i1*k2+i1*k2*q)*S(1//(q^2-1)))+e2p((i3*k1*q+3*i3*k1+2*i3*k3*q+2*i3*k3+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1-i1*k2*q-i1*k2)*S(1//(q^2-1)))*q-e2p((i3*k1*q+3*i3*k1+2*i3*k3*q+2*i3*k3+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1-i1*k2*q-i1*k2)*S(1//(q^2-1)))+e2p((i3*k1+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i1*k2+i1*k2*q-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i3*k1+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i1*k2+i1*k2*q-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i3*k1+2*i3*k3*q+2*i3*k3+2*i3*k2*q+2*i3*k2+3*i3*k1*q-i1*k2*q-i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i3*k1+2*i3*k3*q+2*i3*k3+2*i3*k2*q+2*i3*k2+3*i3*k1*q-i1*k2*q-i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	-e2p((i3*k1*q+3*i3*k1+2*i3*k3*q+2*i3*k3+i2*k1*q-i2*k1+i1*k2+i1*k2*q)*S(1//(q^2-1)))-e2p((i3*k1*q+3*i3*k1+2*i3*k3*q+2*i3*k3+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1-i1*k2*q-i1*k2)*S(1//(q^2-1)))-e2p((i3*k1+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i1*k2+i1*k2*q-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i3*k1+2*i3*k3*q+2*i3*k3+2*i3*k2*q+2*i3*k2+3*i3*k1*q-i1*k2*q-i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	-e2p((q*i1*k1-i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((q*i1*k1-i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))*q-e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))*q-e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))-e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1*q-i2*k2-i2*k2*q+i3*k3*q+i3*k3+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+2*i3*k1+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+2*i3*k1-i2*k2-i2*k2*q+i3*k3*q+i3*k3+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1*q+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	-e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))-e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))-e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1*q-i2*k2-i2*k2*q+i3*k3*q+i3*k3+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+2*i3*k1+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+2*i3*k1-i2*k2-i2*k2*q+i3*k3*q+i3*k3+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1*q+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	-e2p((2*i3*k1*q+2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1*q+2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+4*i3*k1*q-q*i1*k1+i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+4*i3*k1*q-q*i1*k1+i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((4*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q-e2p((4*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+2*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+2*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	-e2p((2*i3*k1*q+2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+4*i3*k1*q-q*i1*k1+i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((4*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+2*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1*k1-i1*k1+i3*k1*q+i3*k1-i2*k2-i2*k2*q+i3*k3*q+i3*k3+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k1+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k1-i2*k2-i2*k2*q+i3*k3*q+i3*k3+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i3*k1*q+i3*k1+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	-e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1+i4*k3*q+i4*k3-i1*k2-i1*k2*q+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((2*i4*k1*q-i2*k1*q+i2*k1+i4*k3*q+i4*k3+i1*k2*q+i1*k2-i3*k1*q+i3*k1)*S(1//(q^2-1)))-e2p((2*i4*k1*q+i4*k2*q+i4*k2-i2*k1*q+i2*k1+i4*k3*q+i4*k3-i1*k2-i1*k2*q-i3*k1*q+i3*k1)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1+i4*k3*q+i4*k3-i1*k2-i1*k2*q-i3*k1*q+i3*k1)*S(1//(q^2-1)))-e2p((2*i4*k1+i2*k1*q-i2*k1+i4*k3*q+i4*k3+i1*k2*q+i1*k2+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((2*i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1+i4*k3*q+i4*k3-i1*k2-i1*k2*q+i3*k1*q-i3*k1)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1+i2*k1*q-i2*k1+i4*k3*q+i4*k3+i1*k2*q+i1*k2-i3*k1*q+i3*k1)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1-i2*k1*q+i2*k1+i4*k3*q+i4*k3+i1*k2*q+i1*k2+i3*k1*q-i3*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*q*(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*q*(q^4+q^3+2*q^2+q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	q*(q^3-2*q^2-1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-q*(q^3+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q,
	-q*(q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*q*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q,
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^5+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^5-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^4+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3,
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2,
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*(q-1),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^4-e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^3+e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^3+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^4,
	e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q,
	-e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q,
	-e2p((2*i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^4-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^4,
	e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^3-e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^3-e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1))),
	-e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))-e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1))),
	-e2p((i2*k1+i1*k2+i2*k3)*S(1//(q-1)))-e2p((i2*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i2*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-(q+1)*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*(q-1),
	-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q^2+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q^2+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q^2+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q^2,
	e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1))),
	-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1))),
	e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1))),
	e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1))),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	(q+1)*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+2*i1*k3+k3+1//2*q*k1+1//2*k1+i2*k2)*S(1//(q-1)))*q^2-e2p((2*i1*k1+2*i1*k3+k3+1//2*q*k1+1//2*k1+i2*k2)*S(1//(q-1)))-e2p((2*i1*k1+k2+2*i1*k3+2*i1*k2+k3+1//2*q*k1+1//2*k1-i2*k2)*S(1//(q-1)))*q^2-e2p((2*i1*k1+k2+2*i1*k3+2*i1*k2+k3+1//2*q*k1+1//2*k1-i2*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+2*i1*k3+k3+1//2*q*k1+1//2*k1+i2*k2)*S(1//(q-1)))-e2p((2*i1*k1+k2+2*i1*k3+2*i1*k2+k3+1//2*q*k1+1//2*k1-i2*k2)*S(1//(q-1))),
	-e2p((2*i1*k1+2*i1*k3+k3+1//2*q*k1+1//2*k1+i2*k2)*S(1//(q-1)))-e2p((2*i1*k1+k2+2*i1*k3+2*i1*k2+k3+1//2*q*k1+1//2*k1-i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))*q-e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))*q-e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1))),
	-e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))-e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1))),
	-e2p((i3*k1+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i1*k2+i1*k2*q-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((i3*k1+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i1*k2+i1*k2*q-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i3*k1+2*i3*k3*q+2*i3*k3+2*i3*k2*q+2*i3*k2+3*i3*k1*q-i1*k2*q-i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((i3*k1+2*i3*k3*q+2*i3*k3+2*i3*k2*q+2*i3*k2+3*i3*k1*q-i1*k2*q-i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i3*k1*q+3*i3*k1+2*i3*k3*q+2*i3*k3+i2*k1*q-i2*k1+i1*k2+i1*k2*q)*S(1//(q^2-1)))*q+e2p((i3*k1*q+3*i3*k1+2*i3*k3*q+2*i3*k3+i2*k1*q-i2*k1+i1*k2+i1*k2*q)*S(1//(q^2-1)))-e2p((i3*k1*q+3*i3*k1+2*i3*k3*q+2*i3*k3+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1-i1*k2*q-i1*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+3*i3*k1+2*i3*k3*q+2*i3*k3+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1-i1*k2*q-i1*k2)*S(1//(q^2-1))),
	e2p((i3*k1+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i1*k2+i1*k2*q-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i3*k1+2*i3*k3*q+2*i3*k3+2*i3*k2*q+2*i3*k2+3*i3*k1*q-i1*k2*q-i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i3*k1*q+3*i3*k1+2*i3*k3*q+2*i3*k3+i2*k1*q-i2*k1+i1*k2+i1*k2*q)*S(1//(q^2-1)))+e2p((i3*k1*q+3*i3*k1+2*i3*k3*q+2*i3*k3+2*i3*k2*q+2*i3*k2+i2*k1*q-i2*k1-i1*k2*q-i1*k2)*S(1//(q^2-1))),
	-e2p((q*i1*k1-i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((q*i1*k1-i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))-e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))*q+e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))-e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1*q-i2*k2-i2*k2*q+i3*k3*q+i3*k3+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((2*q*i1*k1-2*i1*k1+2*i3*k1+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((2*q*i1*k1-2*i1*k1+2*i3*k1-i2*k2-i2*k2*q+i3*k3*q+i3*k3+i3*k2*q+i3*k2)*S(1//(q^2-1)))*q-e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1*q+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q,
	e2p((i3*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1))),
	e2p((4*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q+e2p((4*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+2*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+2*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+4*i3*k1*q-q*i1*k1+i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+4*i3*k1*q-q*i1*k1+i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((4*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+2*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+4*i3*k1*q-q*i1*k1+i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1*k1-i1*k1+i3*k1*q+i3*k1-i2*k2-i2*k2*q+i3*k3*q+i3*k3+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k1+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k1-i2*k2-i2*k2*q+i3*k3*q+i3*k3+i3*k2*q+i3*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i3*k1*q+i3*k1+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1+i4*k3*q+i4*k3-i1*k2-i1*k2*q-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((2*i4*k1+i2*k1*q-i2*k1+i4*k3*q+i4*k3+i1*k2*q+i1*k2+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((2*i4*k1*q-i2*k1*q+i2*k1+i4*k3*q+i4*k3+i1*k2*q+i1*k2-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1+i2*k1*q-i2*k1+i4*k3*q+i4*k3+i1*k2*q+i1*k2-i3*k1*q+i3*k1)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1+i4*k2*q+i4*k2-i2*k1*q+i2*k1+i4*k3*q+i4*k3-i1*k2-i1*k2*q+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((2*i4*k1+i4*k2*q+i4*k2+i2*k1*q-i2*k1+i4*k3*q+i4*k3-i1*k2-i1*k2*q+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1-i2*k1*q+i2*k1+i4*k3*q+i4*k3+i1*k2*q+i1*k2+i3*k1*q-i3*k1)*S(1//(q^2-1)))+e2p((2*i4*k1*q+i4*k2*q+i4*k2-i2*k1*q+i2*k1+i4*k3*q+i4*k3-i1*k2-i1*k2*q-i3*k1*q+i3*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)^2*(1+2*q^2+2*q^4+q^6)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*(q^4-q^3+2*q^2-q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*(q^2-q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(2*q^3-3*q^2+q-1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q^3-3*q^2+2*q-1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(2*q-1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)^2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(3*q-1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^4-2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3+2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^5-3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+4*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-4*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4,
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-3*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-4*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-2*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3-2*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+2*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^4-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3+e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^4-2*e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3+2*e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-2*e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-2*e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-3*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-3*e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^3+2*e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q-2*e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q+2*e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q^3+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q^2-e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^2-e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q^2-e2p((2*q*i1*k1-2*i1*k1+2*i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q-e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^2,
	-e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+2*i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))-2*e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))-2*e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1))),
	e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)^2*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*(q-1),
	-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*(q-1),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q^2-2*e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q^2-2*e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q^2-2*e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q^2-2*e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-2*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-2*e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-2*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((3*i2*k1+q*i1*k1-i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3+i2*k1*q)*S(1//(q^2-1)))*q^2-2*e2p((3*i2*k1+q*i1*k1-i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3+i2*k1*q)*S(1//(q^2-1)))*q+e2p((3*i2*k1+q*i1*k1-i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3+i2*k1*q)*S(1//(q^2-1)))+e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-2*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((3*i2*k1+q*i1*k1-i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3+i2*k1*q)*S(1//(q^2-1)))*q+e2p((3*i2*k1+q*i1*k1-i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3+i2*k1*q)*S(1//(q^2-1)))-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((3*i2*k1+q*i1*k1-i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3+i2*k1*q)*S(1//(q^2-1)))*q+e2p((3*i2*k1+q*i1*k1-i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3+i2*k1*q)*S(1//(q^2-1)))-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((3*i2*k1+q*i1*k1-i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3+i2*k1*q)*S(1//(q^2-1)))+e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*q*i1*k1+2*i1*k1+k2+2*i1*k3*q+2*i1*k3+2*i1*k2+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q^2+e2p((2*q*i1*k1+2*i1*k1+k2+2*i1*k3*q+2*i1*k3+2*i1*k2+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1+2*i1*k1+k2*q+2*i1*k3*q+2*i1*k3+2*i1*k2*q+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((2*q*i1*k1+2*i1*k1+k2*q+2*i1*k3*q+2*i1*k3+2*i1*k2*q+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((2*q*i1*k1+2*i1*k1+k2+2*i1*k3*q+2*i1*k3+2*i1*k2+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1+2*i1*k1+k2*q+2*i1*k3*q+2*i1*k3+2*i1*k2*q+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((2*q*i1*k1+2*i1*k1+k2+2*i1*k3*q+2*i1*k3+2*i1*k2+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1+2*i1*k1+k2*q+2*i1*k3*q+2*i1*k3+2*i1*k2*q+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1*k1-i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((q*i1*k1-i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((i3*k2*q+i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((i3*k2*q+i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k2+i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((i3*k2+i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	e2p((i3*k2*q+i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i3*k2+i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1+i1*k2*q-i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1+i1*k2*q-i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+3*i3*k1+q*i1*k1-i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+3*i3*k1+q*i1*k1-i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1-i2*k1*q+i2*k1-i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1-i2*k1*q+i2*k1-i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1+i3*k1*q-i1*k2*q+i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1+i3*k1*q-i1*k2*q+i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1+i3*k1*q+q*i1*k1-i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1+i3*k1*q+q*i1*k1-i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+4*i3*k1*q-q*i1*k1+i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+4*i3*k1*q-q*i1*k1+i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+2*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+2*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1+i3*k1*q+i1*k2*q-i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1+i3*k1*q+i1*k2*q-i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((4*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q+e2p((4*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1))),
	e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1+i1*k2*q-i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+3*i3*k1+q*i1*k1-i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1-i2*k1*q+i2*k1-i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1+i3*k1*q-i1*k2*q+i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1+i3*k1*q+q*i1*k1-i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+4*i3*k1*q-q*i1*k1+i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+2*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1+i3*k1*q+i1*k2*q-i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((4*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-q*i1*k1+i1*k1+2*i3*k1-i2*k1*q+i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i3*k1-i2*k1*q+i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k2+i3*k1+i3*k1*q+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k2+i3*k1+i3*k1*q+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((2*i3*k1*q+i2*k1*q-i2*k1+q*i1*k1-i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+i2*k1*q-i2*k1+q*i1*k1-i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))-e2p((2*i3*k1*q+q*i1*k1-i1*k1+i3*k2+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+q*i1*k1-i1*k1+i3*k2+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i3*k2+i3*k1+i3*k1*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((-i2*k1*q+i2*k1+i3*k2+i3*k1+i3*k1*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1+i2*k1*q-i2*k1-q*i1*k1+i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i3*k1+i2*k1*q-i2*k1-q*i1*k1+i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k2+2*i3*k1-i2*k1*q+i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k2+2*i3*k1-i2*k1*q+i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1+q*i1*k1-i1*k1-i2*k1*q+i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i3*k1+q*i1*k1-i1*k1-i2*k1*q+i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1+2*i3*k1*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1+2*i3*k1*q-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+2*i3*k1-i2*k1*q+i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k2+i3*k1+i3*k1*q+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((2*i3*k1*q+i2*k1*q-i2*k1+q*i1*k1-i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))+e2p((2*i3*k1*q+q*i1*k1-i1*k1+i3*k2+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i3*k2+i3*k1+i3*k1*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i3*k1*q+i3*k1+i2*k1*q-i2*k1-q*i1*k1+i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k2+2*i3*k1-i2*k1*q+i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i3*k1*q+i3*k1+q*i1*k1-i1*k1-i2*k1*q+i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1+2*i3*k1*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1+2*i3*k1*q-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i3*k1*q+i3*k1+i4*k1+i4*k1*q+i2*k1*q-i2*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-i3*k1*q+i3*k1+2*i4*k1-q*i1*k1+i1*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((2*i4*k1*q+i2*k1*q-i2*k1+i4*k2+i3*k1*q-i3*k1-i1*k2*q+i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i4*k2+i4*k1+i4*k1*q+i2*k1*q-i2*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i4*k1+i4*k1*q+i2*k1*q-i2*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i4*k2+i4*k1+i4*k1*q+i3*k1*q-i3*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i4*k2+2*i4*k1-q*i1*k1+i1*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1+q*i1*k1-i1*k1-i2*k1*q+i2*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+2*i4*k1-i3*k1*q+i3*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-i3*k1*q+i3*k1+i4*k2+i4*k1+i4*k1*q+q*i1*k1-i1*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((2*i4*k1*q+i2*k1*q-i2*k1+i3*k1*q-i3*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1+i3*k1*q-i3*k1+i4*k2-i2*k1*q+i2*k1-i1*k2*q+i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i4*k2+i4*k1+i4*k1*q+q*i1*k1-i1*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1+i2*k1*q-i2*k1+i4*k2-i3*k1*q+i3*k1-i1*k2*q+i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+2*i4*k1-q*i1*k1+i1*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((2*i4*k1*q+i2*k1*q-i2*k1+q*i1*k1-i1*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((2*i4*k1*q+q*i1*k1-i1*k1+i4*k2+i3*k1*q-i3*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1+i3*k1*q-i3*k1-q*i1*k1+i1*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1+q*i1*k1-i1*k1-i3*k1*q+i3*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i4*k2+2*i4*k1-i3*k1*q+i3*k1-i1*k2*q+i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i4*k2+2*i4*k1-i3*k1*q+i3*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((2*i4*k1*q+q*i1*k1-i1*k1+i3*k1*q-i3*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((2*i4*k1*q+q*i1*k1-i1*k1+i4*k2+i2*k1*q-i2*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i4*k1+i4*k1*q+i3*k1*q-i3*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)^2*q*(1+2*q^2+2*q^4+q^6)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*q*(q^4-q^3+2*q^2-q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*q*(q^2-q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*q*(3*q^2-q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	q*(2*q^2-2*q+1)*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*q*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*q*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q,
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3-2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^4+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^5+3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-4*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+4*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3-3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^5-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^4+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3-2*e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3-3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+4*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*(q-1),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((2*i1*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+3*e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((2*i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2+e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^4-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2+e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^4+2*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^4+2*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3-2*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+2*e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3-2*e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+2*e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^4,
	-e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2+e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2+e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+2*e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+2*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((2*i2*k1*q+2*i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((2*i2*k1*q+2*i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+3*e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+3*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^3-e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^2+2*e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^3+2*e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q-2*e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q^2+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q^3-e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^2+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q-e2p((2*q*i1*k1-2*i1*k1+2*i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q^2+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q^3+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q^3-e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q^2+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^3,
	2*e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))+2*e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+2*i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+2*i2*k1*q+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q,
	-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+i2*k2*q)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)^2*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*(q-1),
	-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*(q-1),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q^2+2*e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q^2+2*e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+2*e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q^2+2*e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q^2+2*e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q^2+2*e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1))),
	e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1))),
	e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))*q-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1))),
	-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1))),
	-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((3*i1*k1+q*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((3*q*i1*k1+i1*k1-i2*k1*q+i2*k1+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2+1//2*k1*q^2-1//2*k1)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+2*q*i1*k1+2*i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1))),
	-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+2*e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+2*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((3*i2*k1+q*i1*k1-i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3+i2*k1*q)*S(1//(q^2-1)))-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2+2*e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+2*e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((3*i2*k1+q*i1*k1-i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3+i2*k1*q)*S(1//(q^2-1)))*q^2+2*e2p((3*i2*k1+q*i1*k1-i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3+i2*k1*q)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2,
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((3*i2*k1+q*i1*k1-i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3+i2*k1*q)*S(1//(q^2-1)))*q-e2p((3*i2*k1+q*i1*k1-i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3+i2*k1*q)*S(1//(q^2-1)))+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((3*i2*k1+q*i1*k1-i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3+i2*k1*q)*S(1//(q^2-1)))*q-e2p((3*i2*k1+q*i1*k1-i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3+i2*k1*q)*S(1//(q^2-1)))+e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((-2*q*i1*k1+2*i1*k1+4*i2*k1*q+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+4*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	-e2p((2*i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((3*i2*k1+q*i1*k1-i1*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3+i2*k1*q)*S(1//(q^2-1)))-e2p((i2*k1*q+3*i2*k1+q*i1*k1-i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((3*i2*k1*q+i2*k1-q*i1*k1+i1*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*q*i1*k1+2*i1*k1+k2+2*i1*k3*q+2*i1*k3+2*i1*k2+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q^2+e2p((2*q*i1*k1+2*i1*k1+k2+2*i1*k3*q+2*i1*k3+2*i1*k2+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1+2*i1*k1+k2*q+2*i1*k3*q+2*i1*k3+2*i1*k2*q+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((2*q*i1*k1+2*i1*k1+k2*q+2*i1*k3*q+2*i1*k3+2*i1*k2*q+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((2*q*i1*k1+2*i1*k1+k2+2*i1*k3*q+2*i1*k3+2*i1*k2+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1+2*i1*k1+k2*q+2*i1*k3*q+2*i1*k3+2*i1*k2*q+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((2*q*i1*k1+2*i1*k1+k2+2*i1*k3*q+2*i1*k3+2*i1*k2+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1+2*i1*k1+k2*q+2*i1*k3*q+2*i1*k3+2*i1*k2*q+k3*q+k3+1//2*k1*q^2+q*k1+1//2*k1-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1*k1-i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((q*i1*k1-i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k1+2*i2*k3*q+2*i2*k3+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((i3*k2*q+i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((i3*k2*q+i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k2+i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((i3*k2+i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	e2p((i3*k2*q+i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i3*k2+i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((4*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q-e2p((4*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1-i2*k1*q+i2*k1-i1*k2*q+i1*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1-i2*k1*q+i2*k1-i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1*q+2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+2*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+2*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1+i3*k1*q+i1*k2*q-i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1+i3*k1*q+i1*k2*q-i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+3*i3*k1+q*i1*k1-i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+3*i3*k1+q*i1*k1-i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1+i3*k1*q+q*i1*k1-i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1+i3*k1*q+q*i1*k1-i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+4*i3*k1*q-q*i1*k1+i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+4*i3*k1*q-q*i1*k1+i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1+i1*k2*q-i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1+i1*k2*q-i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1+i3*k1*q-i1*k2*q+i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1+i3*k1*q-i1*k2*q+i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((4*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+i2*k1*q-i2*k1+q*i1*k1-i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1-i2*k1*q+i2*k1-i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k1*q+2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2-q*i1*k1+i1*k1+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1+2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+2*i3*k1*q+q*i1*k1-i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1+i3*k1*q+i1*k2*q-i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+3*i3*k1+q*i1*k1-i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1+i3*k1*q+q*i1*k1-i1*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k3+i3*k2*q+i3*k2+4*i3*k1*q-q*i1*k1+i1*k1-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1+i1*k2*q-i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1+i3*k1*q-i1*k2*q+i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+3*i3*k1*q+i3*k1-q*i1*k1+i1*k1-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*q*i1*k1-2*i1*k1+2*i3*k1*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-2*i1*k1+2*i3*k1*q-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))*q+e2p((-2*q*i1*k1+2*i1*k1+2*i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i3*k1+q*i1*k1-i1*k1-i2*k1*q+i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k2+i3*k1+i3*k1*q+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i3*k1+i2*k1*q-i2*k1-q*i1*k1+i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+2*i3*k1-i2*k1*q+i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+i2*k1*q-i2*k1+q*i1*k1-i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((-i2*k1*q+i2*k1+i3*k2+i3*k1+i3*k1*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+q*i1*k1-i1*k1+i3*k2+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k2+2*i3*k1-i2*k1*q+i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((i3*k1*q+i3*k1+q*i1*k1-i1*k1-i2*k1*q+i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k2+i3*k1+i3*k1*q+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1+i2*k1*q-i2*k1-q*i1*k1+i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i3*k1-i2*k1*q+i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((2*i3*k1*q+i2*k1*q-i2*k1+q*i1*k1-i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i3*k2+i3*k1+i3*k1*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((2*i3*k1*q+q*i1*k1-i1*k1+i3*k2+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k2+2*i3*k1-i2*k1*q+i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	-e2p((i3*k1*q+i3*k1+q*i1*k1-i1*k1-i2*k1*q+i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k2+i3*k1+i3*k1*q+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1+i2*k1*q-i2*k1-q*i1*k1+i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+2*i3*k1-i2*k1*q+i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((2*i3*k1*q+i2*k1*q-i2*k1+q*i1*k1-i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i3*k2+i3*k1+i3*k1*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((2*i3*k1*q+q*i1*k1-i1*k1+i3*k2+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k2+2*i3*k1-i2*k1*q+i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i3*k1*q+i3*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1*q+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-q*i1*k1+i1*k1+i4*k2+2*i4*k1-i3*k1*q+i3*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((2*i4*k1*q+q*i1*k1-i1*k1+i3*k1*q-i3*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((2*i4*k1*q+q*i1*k1-i1*k1+i4*k2+i2*k1*q-i2*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k1+i4*k1*q+i3*k1*q-i3*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1+i3*k1*q-i3*k1-q*i1*k1+i1*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((2*i4*k1*q+i2*k1*q-i2*k1+q*i1*k1-i1*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k2+i4*k1+i4*k1*q+i3*k1*q-i3*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+2*i4*k1-i3*k1*q+i3*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+2*i4*k1-q*i1*k1+i1*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1+q*i1*k1-i1*k1-i2*k1*q+i2*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k1+i4*k1*q+i2*k1*q-i2*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-i3*k1*q+i3*k1+2*i4*k1-q*i1*k1+i1*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-i3*k1*q+i3*k1+i4*k1+i4*k1*q+i2*k1*q-i2*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1+i2*k1*q-i2*k1+i4*k2-i3*k1*q+i3*k1-i1*k2*q+i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k2+i4*k1+i4*k1*q+i2*k1*q-i2*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((2*i4*k1*q+i2*k1*q-i2*k1+i4*k2+i3*k1*q-i3*k1-i1*k2*q+i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((2*i4*k1*q+i2*k1*q-i2*k1+i3*k1*q-i3*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k2+2*i4*k1-q*i1*k1+i1*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k2+i4*k1+i4*k1*q+q*i1*k1-i1*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-i3*k1*q+i3*k1+i4*k2+i4*k1+i4*k1*q+q*i1*k1-i1*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1+q*i1*k1-i1*k1-i3*k1*q+i3*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k2+2*i4*k1-i3*k1*q+i3*k1-i1*k2*q+i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((2*i4*k1*q+q*i1*k1-i1*k1+i4*k2+i3*k1*q-i3*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1+i3*k1*q-i3*k1+i4*k2-i2*k1*q+i2*k1-i1*k2*q+i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)^2*(1+2*q^2+2*q^4+q^6)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)^2*(q^4+2*q^2+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(-2*q^2+q-1+q^3)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q^4-5*q^3+3*q^2-2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*(2*q^2-q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)^2*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(2*q^2-2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(2*q-1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(2*q-1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^4+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)^2*(q^2+1)*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	(q-1)^2*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*(q-1),
	-(3*q-1)*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4-2*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^3+2*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-2*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-2*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-3*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))+e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))-2*e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q+2*e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^2-e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^3+2*e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))*q^2-2*e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))*q^3-e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))*q^3+2*e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))*q^2-2*e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^3+2*e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^2-2*e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q,
	-2*e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))-2*e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))-2*e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))-2*e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1))),
	e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))+e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((i1*k2*q+i1*k2+2*i1*k1+2*i1*k3*q+2*i1*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((i1*k2*q+i1*k2+2*i1*k1+2*i1*k3*q+2*i1*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((2*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((i1*k2*q+i1*k2+2*q*i1*k1+2*i1*k3*q+2*i1*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((i1*k2*q+i1*k2+2*q*i1*k1+2*i1*k3*q+2*i1*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*q*i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((i1*k2*q+i1*k2+2*i1*k1+2*i1*k3*q+2*i1*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((2*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((i1*k2*q+i1*k2+2*q*i1*k1+2*i1*k3*q+2*i1*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((i1*k2*q+i1*k2+2*i1*k1+2*i1*k3*q+2*i1*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((i1*k2*q+i1*k2+2*i1*k1+2*i1*k3*q+2*i1*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((i1*k2*q+i1*k2+2*q*i1*k1+2*i1*k3*q+2*i1*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((i1*k2*q+i1*k2+2*q*i1*k1+2*i1*k3*q+2*i1*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((i1*k2*q+i1*k2+2*i1*k1+2*i1*k3*q+2*i1*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((i1*k2*q+i1*k2+2*q*i1*k1+2*i1*k3*q+2*i1*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*q*i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((i1*k2*q+i1*k2+2*i1*k1+2*i1*k3*q+2*i1*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))+e2p((i1*k2*q+i1*k2+2*q*i1*k1+2*i1*k3*q+2*i1*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((2*i2*k2+i1*k2*q-i1*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((2*i2*k2+i1*k2*q-i1*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((-i1*k2*q+i1*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((-i1*k2*q+i1*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((-i1*k2*q+i1*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((-i1*k2*q+i1*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((2*i2*k2+i1*k2*q-i1*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((2*i2*k2+i1*k2*q-i1*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-2*e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-2*e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-2*e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-2*e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	e2p((2*i2*k2+i1*k2*q-i1*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((-i1*k2*q+i1*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((-i1*k2*q+i1*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((2*i2*k2+i1*k2*q-i1*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((2*i2*k2+i1*k2*q-i1*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((2*i2*k2+i1*k2*q-i1*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((-i1*k2*q+i1*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((-i1*k2*q+i1*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((-i1*k2*q+i1*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((-i1*k2*q+i1*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((2*i2*k2+i1*k2*q-i1*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((2*i2*k2+i1*k2*q-i1*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	e2p((2*i2*k2+i1*k2*q-i1*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((-i1*k2*q+i1*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((-i1*k2*q+i1*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((2*i2*k2+i1*k2*q-i1*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k1*q+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k1+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((2*i3*k1*q+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*i3*k1+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1+i1*k2*q-i1*k2+q*i1*k1-i1*k1+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1+i1*k2*q-i1*k2+q*i1*k1-i1*k1+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((-i1*k2*q+i1*k2-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((-i1*k2*q+i1*k2-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i1*k2*q-i1*k2-q*i1*k1+i1*k1+i3*k1*q+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((i1*k2*q-i1*k2-q*i1*k1+i1*k1+i3*k1*q+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1-i1*k2*q+i1*k2+q*i1*k1-i1*k1+i3*k2*q+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((i3*k1-i1*k2*q+i1*k2+q*i1*k1-i1*k1+i3*k2*q+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	e2p((i3*k1+i1*k2*q-i1*k2+q*i1*k1-i1*k1+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((-i1*k2*q+i1*k2-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i1*k2*q-i1*k2-q*i1*k1+i1*k1+i3*k1*q+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1-i1*k2*q+i1*k2+q*i1*k1-i1*k1+i3*k2*q+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k1*q+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k1+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k3*q+2*i3*k3-i2*k2*q+i2*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k2*q+2*i3*k3*q+2*i3*k3-i2*k2*q+i2*k2+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k3*q+2*i3*k3-i1*k2*q+i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k2*q+2*i3*k3*q+2*i3*k3-i1*k2*q+i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k3*q+2*i3*k3+2*i3*k2+i2*k2*q-i2*k2+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k3*q+2*i3*k3+2*i3*k2+i2*k2*q-i2*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k3*q+2*i3*k3+2*i3*k2+i1*k2*q-i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k3*q+2*i3*k3+2*i3*k2+i1*k2*q-i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k3+2*i3*k1*q+i3*k2*q+i3*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k3+2*i3*k1*q+i3*k2*q+i3*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k3+2*i3*k1+i3*k2*q+i3*k2+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k3+2*i3*k1+i3*k2*q+i3*k2+q*i1*k1-i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2)*S(1//(q^2-1))),
	e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((2*i3*k1*q+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*i3*k1+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k3*q+2*i3*k3-i2*k2*q+i2*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k2*q+2*i3*k3*q+2*i3*k3-i2*k2*q+i2*k2+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k3*q+2*i3*k3-i1*k2*q+i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k2*q+2*i3*k3*q+2*i3*k3-i1*k2*q+i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k3*q+2*i3*k3+2*i3*k2+i2*k2*q-i2*k2+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k3*q+2*i3*k3+2*i3*k2+i2*k2*q-i2*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+2*i3*k3*q+2*i3*k3+2*i3*k2+i1*k2*q-i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k1+2*i3*k3*q+2*i3*k3+2*i3*k2+i1*k2*q-i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k3+2*i3*k1*q+i3*k2*q+i3*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k3+2*i3*k1+i3*k2*q+i3*k2+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-q*i1*k1+i1*k1+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i3*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((-i2*k1*q+i2*k1+i3*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+i2*k1*q-i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i2*k1*q-i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i3*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((-i2*k1*q+i2*k1+i3*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1))),
	e2p((-q*i1*k1+i1*k1+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i3*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1*q+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1*q+i2*k1*q-i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i3*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i3*k1*q+q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i4*k1-i2*k2*q+i2*k2+i3*k1*q-i3*k1+i4*k2*q+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-i3*k2*q+i3*k2-i2*k1*q+i2*k1+i4*k1*q+i4*k2*q+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i2*k2*q-i2*k2-i3*k1*q+i3*k1+i4*k1*q+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((i3*k2*q-i3*k2-i2*k1*q+i2*k1+i4*k1*q+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((i4*k1+i2*k2*q-i2*k2+i3*k1*q-i3*k1+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((-i2*k2*q+i2*k2-i3*k1*q+i3*k1+i4*k1*q+i4*k2*q+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k1-i3*k2*q+i3*k2+i2*k1*q-i2*k1+i4*k2*q+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k1+i3*k2*q-i3*k2+i2*k1*q-i2*k1+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i4*k1*q+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((i4*k1*q+i3*k1*q-i3*k1-i1*k2*q+i1*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i4*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k1*q+i3*k1*q-i3*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i4*k1-i1*k2*q+i1*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i4*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((-i3*k1*q+i3*k1+i4*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((i4*k1*q+q*i1*k1-i1*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((i4*k1*q+i2*k1*q-i2*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i4*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((i4*k1*q+q*i1*k1-i1*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k1*q+q*i1*k1-i1*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k1*q+i2*k1*q-i2*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((i4*k1*q+i3*k1*q-i3*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-i3*k1*q+i3*k1+i4*k1-i1*k2*q+i1*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i4*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i4*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k1*q+q*i1*k1-i1*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((-i3*k1*q+i3*k1+i4*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k1*q+i2*k1*q-i2*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k1*q+i3*k1*q-i3*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-i3*k1*q+i3*k1+i4*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)^2*q*(1+2*q^2+2*q^4+q^6)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)^2*q*(q^2+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*q*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-q*(4*q^3-4*q^2+3*q-1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)^2*q*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-2*(q-1)*q*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	q*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	2*q*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^5-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^5-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^4+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^5-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^4+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^3-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^4+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^3-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	-(q-1)*q*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2,
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)^2*(q^2+1)*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	(q-1)^2*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*(q-1),
	-(3*q-1)*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^4+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^4+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^4-2*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4+2*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^3-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^4+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^3-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q,
	-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q,
	e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*(q-1),
	3*e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1)))+2*e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+2*e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+2*e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+2*e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q,
	-e2p((i2*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))-e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))+2*e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q-2*e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^3+2*e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-2*e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))*q^3+2*e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q-2*e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^2+e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^3+2*e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-2*e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))*q^2+e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))*q^3,
	2*e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))+2*e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))+2*e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))+2*e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((i1*k2*q+i1*k2+2*q*i1*k1+2*i1*k3*q+2*i1*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2+e2p((i1*k2*q+i1*k2+2*q*i1*k1+2*i1*k3*q+2*i1*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q-e2p((2*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q^2+e2p((2*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q-e2p((2*q*i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q^2+e2p((2*q*i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q^2+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2+e2p((i1*k2*q+i1*k2+2*i1*k1+2*i1*k3*q+2*i1*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((i1*k2*q+i1*k2+2*i1*k1+2*i1*k3*q+2*i1*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q^2,
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k2*q+i1*k2+2*i1*k1+2*i1*k3*q+2*i1*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q+e2p((i1*k2*q+i1*k2+2*q*i1*k1+2*i1*k3*q+2*i1*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q+e2p((2*q*i1*k1-i2*k1*q+i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((2*i1*k1+i2*k1*q-i2*k1+1//2*k2*q^2-1//2*k2+2*i1*k3*q+2*i1*k3+i1*k2*q+i1*k2)*S(1//(q^2-1)))*q,
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	2*e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+2*e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+2*e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+2*e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2+e2p((-i1*k2*q+i1*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((-i1*k2*q+i1*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2+e2p((2*i2*k2+i1*k2*q-i1*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k2+i1*k2*q-i1*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((-i1*k2*q+i1*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2+e2p((-i1*k2*q+i1*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((2*i2*k2+i1*k2*q-i1*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k2+i1*k2*q-i1*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2,
	e2p((2*i2*k2+i1*k2*q-i1*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((-i1*k2*q+i1*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((2*i2*k2+i1*k2*q-i1*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((-i1*k2*q+i1*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k1*q+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k1+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((2*i3*k1*q+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))+e2p((2*i3*k1+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1+i1*k2*q-i1*k2+q*i1*k1-i1*k1+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1+i1*k2*q-i1*k2+q*i1*k1-i1*k1+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((-i1*k2*q+i1*k2-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((-i1*k2*q+i1*k2-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i1*k2*q-i1*k2-q*i1*k1+i1*k1+i3*k1*q+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((i1*k2*q-i1*k2-q*i1*k1+i1*k1+i3*k1*q+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1-i1*k2*q+i1*k2+q*i1*k1-i1*k1+i3*k2*q+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((i3*k1-i1*k2*q+i1*k2+q*i1*k1-i1*k1+i3*k2*q+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	e2p((i3*k1+i1*k2*q-i1*k2+q*i1*k1-i1*k1+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((-i1*k2*q+i1*k2-q*i1*k1+i1*k1+i3*k1*q+i3*k2*q+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i1*k2*q-i1*k2-q*i1*k1+i1*k1+i3*k1*q+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1-i1*k2*q+i1*k2+q*i1*k1-i1*k1+i3*k2*q+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	e2p((2*i3*k1*q+2*i3*k3*q+2*i3*k3+2*i3*k2+i2*k2*q-i2*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+2*i3*k3*q+2*i3*k3+2*i3*k2+i1*k2*q-i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k3+2*i3*k1*q+i3*k2*q+i3*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k1+2*i3*k2*q+2*i3*k3*q+2*i3*k3-i1*k2*q+i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+2*i3*k2*q+2*i3*k3*q+2*i3*k3-i2*k2*q+i2*k2+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k3+2*i3*k1+i3*k2*q+i3*k2+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+2*i3*k3*q+2*i3*k3+2*i3*k2+i2*k2*q-i2*k2+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k3*q+2*i3*k3-i2*k2*q+i2*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+2*i3*k3*q+2*i3*k3+2*i3*k2+i1*k2*q-i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1*q+2*i3*k2*q+2*i3*k3*q+2*i3*k3-i1*k2*q+i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2)*S(1//(q^2-1)))*q-e2p((2*i3*k3*q+2*i3*k3+2*i3*k1*q+i3*k2*q+i3*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k3+2*i3*k1+i3*k2*q+i3*k2+q*i1*k1-i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k1*q+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k1+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k1+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))*q+e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))*q,
	-e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k3+2*i3*k1+i3*k2*q+i3*k2+q*i1*k1-i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k1+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k1*q+i3*k2*q+i3*k2+2*i3*k3*q+2*i3*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k2+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+i2*k2*q-i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k2*q+2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1-i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k3+2*i3*k1*q+i3*k2*q+i3*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k3+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1*q+i2*k1*q-i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((i3*k1*q+i2*k1*q-i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i3*k1*q+q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q-e2p((i3*k1*q+q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i3*k1*q+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q-e2p((i3*k1*q+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i3*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((-i2*k1*q+i2*k1+i3*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((-i2*k1*q+i2*k1+i3*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q-e2p((-i2*k1*q+i2*k1+i3*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i3*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q-e2p((i3*k1*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1))),
	-e2p((i3*k1*q+i2*k1*q-i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i3*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i3*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i4*k1-i2*k2*q+i2*k2+i3*k1*q-i3*k1+i4*k2*q+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((-i3*k2*q+i3*k2-i2*k1*q+i2*k1+i4*k1*q+i4*k2*q+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i2*k2*q-i2*k2-i3*k1*q+i3*k1+i4*k1*q+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((i3*k2*q-i3*k2-i2*k1*q+i2*k1+i4*k1*q+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((i4*k1+i2*k2*q-i2*k2+i3*k1*q-i3*k1+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))+e2p((-i2*k2*q+i2*k2-i3*k1*q+i3*k1+i4*k1*q+i4*k2*q+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k1-i3*k2*q+i3*k2+i2*k1*q-i2*k1+i4*k2*q+i4*k3*q+i4*k3)*S(1//(q^2-1)))+e2p((i4*k1+i3*k2*q-i3*k2+i2*k1*q-i2*k1+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-q*i1*k1+i1*k1+i4*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i3*k1*q-i3*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-i3*k1*q+i3*k1+i4*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k1*q+q*i1*k1-i1*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))-e2p((-i3*k1*q+i3*k1+i4*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))-e2p((-i3*k1*q+i3*k1+i4*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k1*q+i3*k1*q-i3*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k1*q+q*i1*k1-i1*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-i3*k1*q+i3*k1+i4*k1-i1*k2*q+i1*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+q*i1*k1-i1*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i2*k1*q-i2*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k1*q+i3*k1*q-i3*k1-i1*k2*q+i1*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i3*k1*q-i3*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k1-i2*k2*q+i2*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i2*k1*q-i2*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k1-i1*k2*q+i1*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+q*i1*k1-i1*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((i4*k1*q+i2*k1*q-i2*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i4*k3)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k1-i3*k2*q+i3*k2+i4*k3*q+i4*k3+i4*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)^2*(1+2*q^4+2*q^2+2*q+2*q^3+q^6+2*q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*(q^5+q^4+q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q^3-q-1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q^4+q^3-q^2+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)^2*(q^2+2*q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)^2*(q^2+2*q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)^2*(q^2+2*q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(q-1)^2*(q^2+2*q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))-e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))*q^2+e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))-e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))*q^2,
	e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))+e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))+e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))-e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))*q^2+e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))-e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))*q^2,
	e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))+e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))+e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-q*i1*k1+i1*k1+2*i2*k1*q^2+2*i2*k2*q^2+2*i2*k2)*S(1//((q-1)*(q^2+1))))+e2p((2*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q^2+2*i2*k2)*S(1//((q-1)*(q^2+1))))+e2p((-2*i2*k1*q+2*i2*k1-i1*k1*q^2+q*i1*k1+2*i2*k1*q^2+2*i2*k2*q^2+2*i2*k2)*S(1//((q-1)*(q^2+1))))+e2p((2*i2*k1*q+i1*k1*q^2-q*i1*k1+2*i2*k2*q^2+2*i2*k2)*S(1//((q-1)*(q^2+1)))),
	e2p((-q*i1*k1+i1*k1+2*i2*k1*q^2+2*i2*k2*q^2+2*i2*k2)*S(1//((q-1)*(q^2+1))))+e2p((2*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q^2+2*i2*k2)*S(1//((q-1)*(q^2+1))))+e2p((-2*i2*k1*q+2*i2*k1-i1*k1*q^2+q*i1*k1+2*i2*k1*q^2+2*i2*k2*q^2+2*i2*k2)*S(1//((q-1)*(q^2+1))))+e2p((2*i2*k1*q+i1*k1*q^2-q*i1*k1+2*i2*k2*q^2+2*i2*k2)*S(1//((q-1)*(q^2+1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k2*q^2+i3*k2+i3*k1+i2*k1*q-i2*k1)*S(1//((q-1)*(q^2+1))))+e2p((i3*k1*q^2-i3*k1*q+i3*k1+i3*k2*q^2+i3*k2-i2*k1*q^2+i2*k1*q)*S(1//((q-1)*(q^2+1))))+e2p((i3*k1*q^2+i3*k2*q^2+i3*k2-i2*k1*q+i2*k1)*S(1//((q-1)*(q^2+1))))+e2p((i3*k1*q+i2*k1*q^2-i2*k1*q+i3*k2*q^2+i3*k2)*S(1//((q-1)*(q^2+1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((q*i1*k1-i1*k1+i3*k1+i3*k2*q^2+i3*k2)*S(1//((q-1)*(q^2+1))))+e2p((-i1*k1*q^2+q*i1*k1+i3*k1*q^2-i3*k1*q+i3*k1+i3*k2*q^2+i3*k2)*S(1//((q-1)*(q^2+1))))+e2p((i1*k1*q^2-q*i1*k1+i3*k1*q+i3*k2*q^2+i3*k2)*S(1//((q-1)*(q^2+1))))+e2p((-q*i1*k1+i1*k1+i3*k1*q^2+i3*k2*q^2+i3*k2)*S(1//((q-1)*(q^2+1)))),
	(0)*e2p(S(0))] [
	(q-1)^2*q*(1+2*q^4+2*q^2+2*q+2*q^3+q^6+2*q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*q*(q^2+q+1+q^3)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*q*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	q*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*q*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	2*e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(q-1)^2*q*(q^2+2*q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-(q-1)*q*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*q*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	q*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)^2*(q^2+2*q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-(q-1)^2*(q^2+2*q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2)*S(1//(q-1)))*(q-1),
	-(q+1)*e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	-e2p((i2*k1+2*i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))-e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))*q^2+e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))-e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))*q^2,
	e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))+e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))+e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))*q^2-e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))+e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))*q^2-e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	-e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))-e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	-e2p((2*k2+k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1))))-e2p((2*k2+q*k1+2*i1*k1+4*i1*k2)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-q*i1*k1+i1*k1+2*i2*k1*q^2+2*i2*k2*q^2+2*i2*k2)*S(1//((q-1)*(q^2+1))))*q+e2p((2*i2*k1+q*i1*k1-i1*k1+2*i2*k2*q^2+2*i2*k2)*S(1//((q-1)*(q^2+1))))*q+e2p((-2*i2*k1*q+2*i2*k1-i1*k1*q^2+q*i1*k1+2*i2*k1*q^2+2*i2*k2*q^2+2*i2*k2)*S(1//((q-1)*(q^2+1))))*q+e2p((2*i2*k1*q+i1*k1*q^2-q*i1*k1+2*i2*k2*q^2+2*i2*k2)*S(1//((q-1)*(q^2+1))))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k2*q^2+i3*k2+i3*k1+i2*k1*q-i2*k1)*S(1//((q-1)*(q^2+1))))+e2p((i3*k1*q^2-i3*k1*q+i3*k1+i3*k2*q^2+i3*k2-i2*k1*q^2+i2*k1*q)*S(1//((q-1)*(q^2+1))))+e2p((i3*k1*q^2+i3*k2*q^2+i3*k2-i2*k1*q+i2*k1)*S(1//((q-1)*(q^2+1))))+e2p((i3*k1*q+i2*k1*q^2-i2*k1*q+i3*k2*q^2+i3*k2)*S(1//((q-1)*(q^2+1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1*k1-i1*k1+i3*k1+i3*k2*q^2+i3*k2)*S(1//((q-1)*(q^2+1))))-e2p((-i1*k1*q^2+q*i1*k1+i3*k1*q^2-i3*k1*q+i3*k1+i3*k2*q^2+i3*k2)*S(1//((q-1)*(q^2+1))))-e2p((i1*k1*q^2-q*i1*k1+i3*k1*q+i3*k2*q^2+i3*k2)*S(1//((q-1)*(q^2+1))))-e2p((-q*i1*k1+i1*k1+i3*k1*q^2+i3*k2*q^2+i3*k2)*S(1//((q-1)*(q^2+1)))),
	(0)*e2p(S(0))] [
	(3*q+8*q^5+7*q^3+5*q^2+3*q^8+8*q^4+1+q^9+5*q^7+7*q^6)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	(3*q+3*q^5+6*q^3+5*q^2+5*q^4+1+q^6)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	(5*q^4+9*q^3+6*q^2+3*q+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	(q^4+3*q^3+4*q^2+3*q+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	(3*q^3+5*q^2+3*q+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	(3*q^2+4*q+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	(2*q^2+3*q+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	(4*q+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	(2*q+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+3*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^5+3*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^4+4*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^3+4*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^4+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^5+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^4+4*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^3+4*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+4*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^3+4*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^5,
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^4+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^4+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^4+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^3+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^3+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2,
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+3*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^3+3*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^3+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^3+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2,
	3*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+4*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+4*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+4*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	3*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^4+e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^4+2*e2p((i2*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q^3+2*e2p((i2*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^4+2*e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^3+2*e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2+2*e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+2*e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q^4+2*e2p((i2*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q^3+2*e2p((i2*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q+2*e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2+2*e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^4+2*e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q^4+2*e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^3+2*e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^3,
	e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2+2*e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2+2*e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q,
	3*e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+3*e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+3*e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+3*e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+3*e2p((i2*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+3*e2p((i2*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1))),
	e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1))),
	e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((i2*k1-i1*k1+i1*k2+i1*k3+i2*k4)*S(1//(q-1)))*q^2+2*e2p((i2*k1-i1*k1+i1*k2+i1*k3+i2*k4)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))*q^3+2*e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))*q^2+2*e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+i1*k3+i2*k4)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i1*k2+i1*k3+i2*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+i1*k3+i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2-i1*k2+i1*k3+i2*k4)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i2*k2-i1*k2+i1*k3+i2*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i2*k2-i1*k2+i1*k3+i2*k4)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2-i1*k2+i1*k3+i2*k4)*S(1//(q-1)))*q^3+2*e2p((i2*k1-i1*k1+i2*k2-i1*k2+i1*k3+i2*k4)*S(1//(q-1)))*q^2+2*e2p((i2*k1-i1*k1+i2*k2-i1*k2+i1*k3+i2*k4)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))*q^3+2*e2p((i2*k1-i1*k1+i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))*q^2+2*e2p((i2*k1-i1*k1+i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2-i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i2*k2-i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i2*k2-i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i1*k2+i1*k3+i2*k4)*S(1//(q-1)))*q^3+e2p((i1*k1+i2*k2-i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i1*k2+i1*k3+i2*k4)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2-i1*k2+i1*k3+i2*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2-i1*k2+i1*k3+i2*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i1*k3+i2*k4)*S(1//(q-1))),
	2*e2p((i2*k1-i1*k1+i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))+2*e2p((i1*k1+i2*k2-i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2-i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))+2*e2p((i2*k1-i1*k1+i1*k2+i1*k3+i2*k4)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i1*k2+i1*k3+i2*k4)*S(1//(q-1)))+2*e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))+2*e2p((i1*k1+i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))+2*e2p((i1*k1+i1*k2+i1*k3+i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+i1*k3+i2*k4)*S(1//(q-1)))+2*e2p((i1*k1+i2*k2-i1*k2+i1*k3+i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2-i1*k2+i1*k3+i2*k4)*S(1//(q-1)))+2*e2p((i2*k1-i1*k1+i2*k2-i1*k2+i1*k3+i2*k4)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2-i1*k2+i1*k3+i2*k4)*S(1//(q-1))),
	e2p((i2*k1-i1*k1+i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2-i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i1*k2+i1*k3+i2*k4)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i2*k3-i1*k3+i2*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i1*k3+i2*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2-i1*k2+i1*k3+i2*k4)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2-i1*k2+i1*k3+i2*k4)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3-i2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3-i2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3-i2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i2*k3+2*i1*k4)*S(1//(q-1)))*q+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3-i2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i2*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i2*k3+2*i1*k4)*S(1//(q-1)))*q+2*e2p((i1*k1+i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+2*e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+2*e2p((i1*k1+2*i1*k2-i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+2*e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+2*e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2-i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3-i2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2-i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3-i2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3-i2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2-i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3-i2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3-i2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3-i2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2-i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3-i2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+2*i1*k2-i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3-i2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3-i2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3-i2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2-i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3-i2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2-i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3-i2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i2*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3-i2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2-i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3-i2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i2*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i2*k1+2*i2*k2-i1*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q^2+e2p((2*i2*k1-i1*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q+2*e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q^2+2*e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q^2+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q^2+2*e2p((i2*k1+i1*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q+2*e2p((i2*k1+i1*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q+2*e2p((2*i2*k1-i1*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q+2*e2p((i2*k1+2*i2*k2-i1*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2+2*e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q+2*e2p((i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+2*e2p((2*i2*k1-i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q,
	e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q,
	e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))*q,
	e2p((i2*k1+2*i2*k2-i1*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+2*i2*k3-i1*k3+2*i2*k4)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i3*k2+2*i3*k3-i2*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3-i2*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2-i2*k2+2*i3*k3-i1*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((i3*k1+i1*k2+2*i3*k3-i2*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((i3*k1+i1*k2+i2*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((2*i3*k1-i1*k1+2*i3*k2-i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((2*i3*k1-i1*k1+i3*k2+i2*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1+i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2+i2*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2-i1*k2+i2*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((i3*k1+i1*k2+i2*k3+2*i3*k4)*S(1//(q-1)))+e2p((i1*k1+i3*k2+2*i3*k3-i2*k3+2*i3*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3-i2*k3+2*i3*k4)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2-i2*k2+2*i3*k3-i1*k3+2*i3*k4)*S(1//(q-1)))+e2p((i2*k1+i3*k2+i1*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+i3*k2+2*i3*k3-i1*k3+2*i3*k4)*S(1//(q-1)))+e2p((i1*k1+i3*k2+i2*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+2*i3*k2-i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+2*i3*k2-i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((i3*k1+i1*k2+2*i3*k3-i2*k3+2*i3*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2-i2*k2+i1*k3+2*i3*k4)*S(1//(q-1)))+e2p((i1*k1+2*i3*k2-i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((i3*k1+i2*k2+2*i3*k3-i1*k3+2*i3*k4)*S(1//(q-1)))+e2p((i2*k1+i3*k2+2*i3*k3-i1*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i3*k2+i2*k3+2*i3*k4)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2-i1*k2+2*i3*k3-i2*k3+2*i3*k4)*S(1//(q-1)))+e2p((i3*k1+i2*k2+i1*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+i3*k2+i1*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2-i1*k2+i2*k3+2*i3*k4)*S(1//(q-1)))+e2p((i2*k1+2*i3*k2-i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((i2*k1+i3*k2+2*i3*k3-i1*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((i3*k1+i2*k2+2*i3*k3-i1*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((2*i3*k1-i1*k1+i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((i2*k1+2*i3*k2-i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2-i1*k2+2*i3*k3-i2*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1+i3*k2+2*i3*k3-i1*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((i3*k1+2*i3*k2-i2*k2+i1*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((i3*k1+i2*k2+i1*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((i2*k1+i3*k2+i1*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1+2*i3*k2-i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((i1*k1+2*i3*k2-i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))*q+e2p((2*i3*k1-i2*k1+i3*k2+i1*k3+2*i3*k4)*S(1//(q-1)))*q,
	e2p((i3*k1+i1*k2+i2*k3+2*i3*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((i1*k1+i3*k2+2*i3*k3-i2*k3+2*i3*k4)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2-i2*k2+2*i3*k3-i1*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i3*k2+2*i3*k3-i2*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+i3*k2+2*i3*k3-i1*k3+2*i3*k4)*S(1//(q-1)))+e2p((i2*k1+i3*k2+i1*k3+2*i3*k4)*S(1//(q-1)))+e2p((i1*k1+i3*k2+i2*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+2*i3*k2-i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+2*i3*k2-i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((i3*k1+i1*k2+2*i3*k3-i2*k3+2*i3*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2-i2*k2+i1*k3+2*i3*k4)*S(1//(q-1)))+e2p((i3*k1+i2*k2+2*i3*k3-i1*k3+2*i3*k4)*S(1//(q-1)))+e2p((i1*k1+2*i3*k2-i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i3*k2+i2*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((i2*k1+i3*k2+2*i3*k3-i1*k3+2*i3*k4)*S(1//(q-1)))+e2p((i3*k1+i2*k2+i1*k3+2*i3*k4)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2-i1*k2+2*i3*k3-i2*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+i3*k2+i1*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((i2*k1+2*i3*k2-i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((i3*k1+2*i3*k2-i1*k2+i2*k3+2*i3*k4)*S(1//(q-1))),
	e2p((i3*k1-i2*k1+i3*k2-i1*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i1*k2+i2*k3+i3*k4)*S(1//(q-1)))+e2p((i2*k1+i3*k2-i1*k2+i1*k3+i3*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i1*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i1*k2+i1*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i2*k2+i1*k3+i3*k4)*S(1//(q-1)))+e2p((i1*k1+i3*k2-i2*k2+i1*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i1*k2+i3*k3-i2*k3+i3*k4)*S(1//(q-1)))+e2p((i1*k1+i3*k2-i1*k2+i3*k3-i2*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i2*k2+i1*k3+i3*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i1*k2+i2*k3+i3*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i3*k3-i2*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i3*k2-i1*k2+i1*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i2*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i2*k3+i3*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))+e2p((i2*k1+i3*k2-i1*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i1*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i1*k2+i3*k3-i2*k3+i3*k4)*S(1//(q-1)))+e2p((i1*k1+i3*k2-i1*k2+i2*k3+i3*k4)*S(1//(q-1)))+e2p((i1*k1+i3*k2-i2*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i3*k2-i1*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i1*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i2*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i1*k2+i3*k3-i2*k3+i3*k4)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i2*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i2*k2+i1*k3+i3*k4)*S(1//(q-1)))*q+e2p((i3*k1-i2*k1+i3*k2-i1*k2+i1*k3+i3*k4)*S(1//(q-1)))*q+e2p((i3*k1-i2*k1+i1*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+i2*k3+i3*k4)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i3*k2-i2*k2+i1*k3+i3*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i1*k3+i3*k4)*S(1//(q-1)))*q+e2p((i2*k1+i3*k2-i1*k2+i1*k3+i3*k4)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i1*k2+i2*k3+i3*k4)*S(1//(q-1)))*q+e2p((i3*k1-i2*k1+i1*k2+i1*k3+i3*k4)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i3*k2-i1*k2+i3*k3-i2*k3+i3*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+i1*k3+i3*k4)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i3*k2-i1*k2+i2*k3+i3*k4)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2-i2*k2+i1*k3+i3*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))*q+e2p((i3*k1-i1*k1+i3*k2-i2*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2-i1*k2+i3*k3-i2*k3+i3*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+i3*k3-i2*k3+i3*k4)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2-i2*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))*q+e2p((i1*k1+i3*k2-i1*k2+i2*k3+i3*k4)*S(1//(q-1)))*q+e2p((i2*k1+i3*k2-i1*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))*q,
	e2p((i3*k1-i1*k1+i1*k2+i2*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i1*k2+i1*k3+i3*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i1*k3+i3*k4)*S(1//(q-1)))+e2p((i2*k1+i3*k2-i1*k2+i1*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i1*k2+i3*k3-i2*k3+i3*k4)*S(1//(q-1)))+e2p((i1*k1+i3*k2-i2*k2+i1*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i2*k2+i1*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i2*k2+i1*k3+i3*k4)*S(1//(q-1)))+e2p((i1*k1+i3*k2-i1*k2+i3*k3-i2*k3+i3*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i3*k3-i2*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i1*k2+i2*k3+i3*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i2*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i3*k2-i1*k2+i1*k3+i3*k4)*S(1//(q-1)))+e2p((i2*k1+i3*k2-i1*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i2*k3+i3*k4)*S(1//(q-1)))+e2p((i1*k1+i3*k2-i2*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))+e2p((i1*k1+i3*k2-i1*k2+i2*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i1*k2+i3*k3-i2*k3+i3*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i1*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i1*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i3*k2-i1*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i2*k2+i3*k3-i1*k3+i3*k4)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i4*k1-i1*k1+i2*k2+i3*k3+i4*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i4*k3-i3*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i4*k2-i2*k2+i4*k3-i1*k3+i4*k4)*S(1//(q-1)))+e2p((i2*k1+i4*k2-i1*k2+i3*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i4*k2-i1*k2+i3*k3+i4*k4)*S(1//(q-1)))+e2p((i2*k1+i4*k2-i1*k2+i4*k3-i3*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i4*k2-i1*k2+i4*k3-i3*k3+i4*k4)*S(1//(q-1)))+e2p((i1*k1+i3*k2+i2*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i4*k2-i3*k2+i4*k3-i1*k3+i4*k4)*S(1//(q-1)))+e2p((i1*k1+i4*k2-i3*k2+i2*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i1*k2+i2*k3+i4*k4)*S(1//(q-1)))+e2p((i3*k1+i1*k2+i2*k3+i4*k4)*S(1//(q-1)))+e2p((i3*k1+i4*k2-i2*k2+i4*k3-i1*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i4*k2-i2*k2+i4*k3-i3*k3+i4*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i4*k3-i3*k3+i4*k4)*S(1//(q-1)))+e2p((i1*k1+i4*k2-i2*k2+i3*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i1*k2+i4*k3-i3*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i1*k2+i3*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i3*k2+i1*k3+i4*k4)*S(1//(q-1)))+e2p((i3*k1+i4*k2-i2*k2+i1*k3+i4*k4)*S(1//(q-1)))+e2p((i1*k1+i4*k2-i3*k2+i4*k3-i2*k3+i4*k4)*S(1//(q-1)))+e2p((i1*k1+i3*k2+i4*k3-i2*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i1*k2+i4*k3-i2*k3+i4*k4)*S(1//(q-1)))+e2p((i3*k1+i1*k2+i4*k3-i2*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i3*k2+i4*k3-i1*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i4*k2-i2*k2+i1*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i2*k1+i4*k2-i3*k2+i1*k3+i4*k4)*S(1//(q-1)))+e2p((i1*k1+i4*k2-i2*k2+i4*k3-i3*k3+i4*k4)*S(1//(q-1)))+e2p((i3*k1+i2*k2+i1*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i2*k2+i1*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i4*k2-i2*k2+i3*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i4*k2-i1*k2+i4*k3-i2*k3+i4*k4)*S(1//(q-1)))+e2p((i2*k1+i3*k2+i1*k3+i4*k4)*S(1//(q-1)))+e2p((i3*k1+i4*k2-i1*k2+i4*k3-i2*k3+i4*k4)*S(1//(q-1)))+e2p((i2*k1+i3*k2+i4*k3-i1*k3+i4*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i3*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i4*k2-i3*k2+i2*k3+i4*k4)*S(1//(q-1)))+e2p((i2*k1+i4*k2-i3*k2+i1*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i4*k2-i3*k2+i4*k3-i2*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i2*k2+i4*k3-i1*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i3*k1+i4*k2-i1*k2+i2*k3+i4*k4)*S(1//(q-1)))+e2p((i2*k1+i4*k2-i3*k2+i4*k3-i1*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i3*k2+i4*k3-i2*k3+i4*k4)*S(1//(q-1)))+e2p((i3*k1+i4*k2-i1*k2+i2*k3+i4*k4)*S(1//(q-1)))+e2p((i3*k1+i2*k2+i4*k3-i1*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i3*k2+i2*k3+i4*k4)*S(1//(q-1)))+e2p((i4*k1-i1*k1+i2*k2+i4*k3-i3*k3+i4*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i3*k3+i4*k4)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*(2*q+4*q^5+4*q^3+3*q^2+q^8+4*q^4+1+2*q^7+3*q^6)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-(q+q^5+2*q^3+q^2+q^4+1+q^6)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	(q-1)*(3*q^3+2*q^2+2*q+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-(q^4+3*q^3+2*q^2+q+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-(q^2+q+1+q^3)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-(2*q^2+q+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-(2*q+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^5+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^4-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^5+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^4+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^5+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^4-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q,
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^4+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^4-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^4-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^3,
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^3-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^3-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^3,
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2,
	-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2,
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^4+e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^4+e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^4+e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^4,
	-e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2-e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2-e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2-e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2-e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1))),
	e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q-e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q-e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q-e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q-e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1))),
	-e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q-e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q-e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q-e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q-e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1))),
	-e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((i2*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((i2*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1))),
	-e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^4-2*e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^3-2*e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2-2*e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^4-2*e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^3-2*e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2-2*e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q,
	-2*e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2-2*e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2,
	-3*e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-3*e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1))),
	-e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1))),
	-e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2-e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2-i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2-i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2,
	-e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+2*i1*k2-i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2-i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2-i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+2*i1*k2-i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2-i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+2*i1*k2-i2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+2*i1*k2-i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+i2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2-e2p((2*i2*k1-i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2-e2p((i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2-e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q-e2p((i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q-e2p((2*i2*k1-i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q-e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q-e2p((i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q-e2p((2*i2*k1-i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q-e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((i1*k1+i1*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+2*i2*k2-i1*k2+i2*k3+2*i2*k4)*S(1//(q-1))),
	-2*e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q^2-2*e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q^2-2*e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q^2-2*e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q^2,
	-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1))),
	-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1))),
	-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1))),
	-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))*q-e2p((i1*k1+i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+2*i3*k2-i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))*q-e2p((2*i3*k1-i1*k1+2*i3*k2-i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+2*i3*k2-i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))*q-e2p((2*i3*k1-i2*k1+2*i3*k2-i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))*q-e2p((i2*k1+i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((i1*k1+2*i3*k2-i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))*q-e2p((i1*k1+2*i3*k2-i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i2*k1+i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))*q-e2p((2*i3*k1-i2*k1+i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((2*i3*k1-i1*k1+i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))*q-e2p((2*i3*k1-i1*k1+i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))+e2p((i2*k1+2*i3*k2-i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))*q-e2p((i2*k1+2*i3*k2-i1*k2+i3*k3+2*i3*k4)*S(1//(q-1))),
	-e2p((i1*k1+i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))-e2p((2*i3*k1-i1*k1+2*i3*k2-i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))-e2p((2*i3*k1-i2*k1+2*i3*k2-i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))-e2p((i2*k1+i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))-e2p((i1*k1+2*i3*k2-i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))-e2p((2*i3*k1-i2*k1+i1*k2+i3*k3+2*i3*k4)*S(1//(q-1)))-e2p((2*i3*k1-i1*k1+i2*k2+i3*k3+2*i3*k4)*S(1//(q-1)))-e2p((i2*k1+2*i3*k2-i1*k2+i3*k3+2*i3*k4)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q+2*i3*k2-i1*k2-i1*k2*q+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q+2*i3*k2-i1*k2-i1*k2*q+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k1+i3*k2*q+i3*k2-i1*k1-q*i1*k1-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k1+i3*k2*q+i3*k2-i1*k1-q*i1*k1-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k1+i3*k2*q+i3*k2-i1*k1-q*i1*k1+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k1+i3*k2*q+i3*k2-i1*k1-q*i1*k1+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+i1*k2*q+i1*k2-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+i1*k2*q+i1*k2-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q+2*i3*k2-i1*k2-i1*k2*q-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q+2*i3*k2-i1*k2-i1*k2*q-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+i1*k2*q+i1*k2+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+i1*k2*q+i1*k2+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k2*q+i3*k2+q*i1*k1+i1*k1-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k2*q+i3*k2+q*i1*k1+i1*k1-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k2*q+i3*k2+q*i1*k1+i1*k1+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k2*q+i3*k2+q*i1*k1+i1*k1+i2*k3*q-i2*k3)*S(1//(q^2-1))),
	-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q+2*i3*k2-i1*k2-i1*k2*q+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k1+i3*k2*q+i3*k2-i1*k1-q*i1*k1-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k1+i3*k2*q+i3*k2-i1*k1-q*i1*k1+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+i1*k2*q+i1*k2-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q+2*i3*k2-i1*k2-i1*k2*q-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+i1*k2*q+i1*k2+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k2*q+i3*k2+q*i1*k1+i1*k1-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k2*q+i3*k2+q*i1*k1+i1*k1+i2*k3*q-i2*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1*q+i3*k1-q*i1*k1-i1*k1+i3*k3*q+i1*k2*q+i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q-e2p((i3*k1*q+i3*k1-q*i1*k1-i1*k1+i3*k3*q+i1*k2*q+i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-q*i1*k1-i1*k1+i3*k3+i3*k2*q+i3*k2-i1*k2*q-i1*k2+i2*k3*q-i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q-e2p((i3*k1*q+i3*k1-q*i1*k1-i1*k1+i3*k3+i3*k2*q+i3*k2-i1*k2*q-i1*k2+i2*k3*q-i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i3*k3*q+i3*k2*q+i3*k2-i1*k2*q-i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q-e2p((q*i1*k1+i1*k1+i3*k3*q+i3*k2*q+i3*k2-i1*k2*q-i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i3*k3*q+i1*k2*q+i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q-e2p((q*i1*k1+i1*k1+i3*k3*q+i1*k2*q+i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i3*k3+i3*k2*q+i3*k2-i1*k2*q-i1*k2+i2*k3*q-i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q-e2p((q*i1*k1+i1*k1+i3*k3+i3*k2*q+i3*k2-i1*k2*q-i1*k2+i2*k3*q-i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i3*k3+i1*k2*q+i1*k2+i2*k3*q-i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q-e2p((q*i1*k1+i1*k1+i3*k3+i1*k2*q+i1*k2+i2*k3*q-i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-q*i1*k1-i1*k1+i3*k3+i1*k2*q+i1*k2+i2*k3*q-i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q-e2p((i3*k1*q+i3*k1-q*i1*k1-i1*k1+i3*k3+i1*k2*q+i1*k2+i2*k3*q-i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-q*i1*k1-i1*k1+i3*k3*q+i3*k2*q+i3*k2-i1*k2*q-i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q-e2p((i3*k1*q+i3*k1-q*i1*k1-i1*k1+i3*k3*q+i3*k2*q+i3*k2-i1*k2*q-i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1))),
	-e2p((i3*k1*q+i3*k1-q*i1*k1-i1*k1+i3*k3*q+i1*k2*q+i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-q*i1*k1-i1*k1+i3*k3+i3*k2*q+i3*k2-i1*k2*q-i1*k2+i2*k3*q-i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i3*k3*q+i3*k2*q+i3*k2-i1*k2*q-i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i3*k3*q+i1*k2*q+i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i3*k3+i3*k2*q+i3*k2-i1*k2*q-i1*k2+i2*k3*q-i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i3*k3+i1*k2*q+i1*k2+i2*k3*q-i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-q*i1*k1-i1*k1+i3*k3+i1*k2*q+i1*k2+i2*k3*q-i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-q*i1*k1-i1*k1+i3*k3*q+i3*k2*q+i3*k2-i1*k2*q-i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1*k1+i1*k1+i4*k3+i2*k2*q+i2*k2+i3*k3*q-i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1-q*i1*k1-i1*k1+i4*k3*q+i2*k2*q+i2*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i4*k3*q+i2*k2*q+i2*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i4*k3*q+i4*k2*q+i4*k2-i1*k2*q-i1*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i4*k3+i4*k2*q+i4*k2-i2*k2*q-i2*k2+i3*k3*q-i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1-q*i1*k1-i1*k1+i4*k3+i2*k2*q+i2*k2+i3*k3*q-i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1-i2*k1*q-i2*k1+i4*k3+i1*k2*q+i1*k2+i3*k3*q-i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i4*k3*q+i4*k2*q+i4*k2-i2*k2*q-i2*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i4*k3+i4*k2*q+i4*k2-i1*k2*q-i1*k2+i3*k3*q-i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i4*k3+i1*k2*q+i1*k2+i3*k3*q-i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1-i2*k1*q-i2*k1+i4*k3*q+i1*k2*q+i1*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i4*k3*q+i1*k2*q+i1*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1-q*i1*k1-i1*k1+i4*k3*q+i4*k2*q+i4*k2-i2*k2*q-i2*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1-q*i1*k1-i1*k1+i4*k3+i4*k2*q+i4*k2-i2*k2*q-i2*k2+i3*k3*q-i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1-i2*k1*q-i2*k1+i4*k3+i4*k2*q+i4*k2-i1*k2*q-i1*k2+i3*k3*q-i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+i4*k1-i2*k1*q-i2*k1+i4*k3*q+i4*k2*q+i4*k2-i1*k2*q-i1*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)*(2*q+4*q^5+4*q^3+3*q^2+q^8+4*q^4+1+2*q^7+3*q^6)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(q^5+2*q^4+3*q^3+3*q^2+2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q^4-q^3-2*q^2-q-1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(q^3+2*q^2+2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q^3-q^2-q-1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q^2+2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(q^4+2*q^3+2*q^2+2*q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(q^2+q+1+q^3)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(q^2+2*q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q^2+2*q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*(q-1),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))-e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^4+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^4,
	e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))-e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))+e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i2*k1+i1*k2+2*i2*k3)*S(1//(q-1)))-e2p((i2*k1+2*i2*k2-i1*k2+2*i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^3-e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))-e2p((i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))-e2p((i2*k1-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))-e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^3+e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q^3+e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))*q^3,
	-e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))-e2p((i2*k1-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))-e2p((i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))-e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))-e2p((i2*k1-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))-e2p((i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1)))-e2p((i2*k1-i1*k1+i2*k2-i1*k2+i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-2*e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2,
	-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((2*i2*k2+2*k3+k1+2*i1*k1+4*i1*k3)*S(1//(2*(q-1))))*q^2-e2p((2*i2*k2+2*k3+k1+2*i1*k1+4*i1*k3)*S(1//(2*(q-1))))-e2p((2*k2-2*i2*k2+2*k3+k1+2*i1*k1+4*i1*k2+4*i1*k3)*S(1//(2*(q-1))))*q^2-e2p((2*k2-2*i2*k2+2*k3+k1+2*i1*k1+4*i1*k2+4*i1*k3)*S(1//(2*(q-1))))-e2p((2*i2*k2+2*k3+q*k1+2*i1*k1+4*i1*k3)*S(1//(2*(q-1))))*q^2-e2p((2*i2*k2+2*k3+q*k1+2*i1*k1+4*i1*k3)*S(1//(2*(q-1))))-e2p((2*k2-2*i2*k2+2*k3+q*k1+2*i1*k1+4*i1*k2+4*i1*k3)*S(1//(2*(q-1))))*q^2-e2p((2*k2-2*i2*k2+2*k3+q*k1+2*i1*k1+4*i1*k2+4*i1*k3)*S(1//(2*(q-1)))),
	-e2p((2*i2*k2+2*k3+k1+2*i1*k1+4*i1*k3)*S(1//(2*(q-1))))-e2p((2*k2-2*i2*k2+2*k3+k1+2*i1*k1+4*i1*k2+4*i1*k3)*S(1//(2*(q-1))))-e2p((2*i2*k2+2*k3+q*k1+2*i1*k1+4*i1*k3)*S(1//(2*(q-1))))-e2p((2*k2-2*i2*k2+2*k3+q*k1+2*i1*k1+4*i1*k2+4*i1*k3)*S(1//(2*(q-1)))),
	-e2p((2*i2*k2+2*k3+k1+2*i1*k1+4*i1*k3)*S(1//(2*(q-1))))-e2p((2*k2-2*i2*k2+2*k3+k1+2*i1*k1+4*i1*k2+4*i1*k3)*S(1//(2*(q-1))))-e2p((2*i2*k2+2*k3+q*k1+2*i1*k1+4*i1*k3)*S(1//(2*(q-1))))-e2p((2*k2-2*i2*k2+2*k3+q*k1+2*i1*k1+4*i1*k2+4*i1*k3)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i2*k2+i3*k3)*S(1//(q-1)))*q-e2p((i1*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i1*k1-i2*k2+i3*k3+i3*k2)*S(1//(q-1)))*q-e2p((i1*k1-i2*k2+i3*k3+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))*q-e2p((i3*k1-i1*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k1+i2*k2+i3*k3)*S(1//(q-1)))*q-e2p((i3*k1-i1*k1+i2*k2+i3*k3)*S(1//(q-1))),
	-e2p((i1*k1+i2*k2+i3*k3)*S(1//(q-1)))-e2p((i1*k1-i2*k2+i3*k3+i3*k2)*S(1//(q-1)))-e2p((i3*k1-i1*k1+i3*k2-i2*k2+i3*k3)*S(1//(q-1)))-e2p((i3*k1-i1*k1+i2*k2+i3*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((2*i2*k1*q+2*i2*k1-q*i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k1*q+2*i2*k1-q*i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((2*i2*k1*q+2*i2*k1-i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((2*i2*k1*q+2*i2*k1-i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((q*i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((q*i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((2*i2*k1*q+2*i2*k1-q*i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((2*i2*k1*q+2*i2*k1-i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((q*i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1*k1-i1*k1+i3*k1+i3*k2*q+i3*k2-i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+i3*k1+i3*k2*q+i3*k2-i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q-q*i1*k1+i1*k1+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((i3*k1*q-q*i1*k1+i1*k1+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q-q*i1*k1+i1*k1+i3*k2*q+i3*k2-i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((i3*k1*q-q*i1*k1+i1*k1+i3*k2*q+i3*k2-i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i3*k1+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+i3*k1+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	-e2p((q*i1*k1-i1*k1+i3*k1+i3*k2*q+i3*k2-i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q-q*i1*k1+i1*k1+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q-q*i1*k1+i1*k1+i3*k2*q+i3*k2-i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i3*k1+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1*q+i3*k1-q*i1*k1+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-i1*k1+i3*k2*q+i3*k2-i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-i1*k1+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i1*k1+i3*k2*q+i3*k2-i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-q*i1*k1+i3*k2*q+i3*k2-i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i1*k1+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((q*i1*k1+i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((q*i1*k1+i3*k2*q+i3*k2-i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)^2*(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	(q-1)^2*(q^4+q^3+2*q^2+q+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	(q-1)*(q^3-2*q^2-1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-(3*q^4+q^3+q-1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-(q-1)*(q^2+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	(2*q^2-q+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-(2*q-1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^4+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^5-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^4-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^5+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^5-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^4-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q,
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^4-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^4+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^4,
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^3+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q,
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-3*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2,
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-3*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^4-2*e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2-2*e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^4-2*e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^3+2*e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2-2*e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1))),
	e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2-2*e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q^2-2*e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1))),
	-e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1))),
	-3*e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))-3*e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1))),
	e2p((i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+i2*k3+2*i2*k4)*S(1//(q-1))),
	e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^4-e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^4-e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^4-e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^4+e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1))),
	e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2+e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2+e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2+e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2+e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1))),
	-e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1))),
	e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1))),
	e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2-2*e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2-2*e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2-2*e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((2*i1*k1-i2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((-i2*k2*q+i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q-i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))+e2p((-i2*k2*q+i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))+e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q-i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q^2-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q^2-e2p((-i2*k2*q+i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q^2-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k2*q-i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q^2-e2p((-i2*k2*q+i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q^2-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q^2-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q^2+e2p((i2*k2*q-i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1))),
	-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q+e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((-i2*k2*q+i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q+e2p((-i2*k2*q+i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))-e2p((i2*k2*q-i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q+e2p((i2*k2*q-i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((-i2*k2*q+i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q+e2p((-i2*k2*q+i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q+e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q-i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q+e2p((i2*k2*q-i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1))),
	e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q+e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))+e2p((-i2*k2*q+i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q+e2p((-i2*k2*q+i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))+e2p((i2*k2*q-i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q+e2p((i2*k2*q-i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((-i2*k2*q+i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q+e2p((-i2*k2*q+i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))+e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q+e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q-i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q+e2p((i2*k2*q-i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1))),
	e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))+e2p((-i2*k2*q+i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))+e2p((i2*k2*q-i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((-i2*k2*q+i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))+e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q-i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1))),
	e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))+e2p((-i2*k2*q+i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))+e2p((i2*k2*q-i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((-i2*k2*q+i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))+e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q-i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1))),
	e2p((2*i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2+e2p((2*i2*k2*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2+e2p((2*i2*k2+i1*k2*q-i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2+i1*k2*q-i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2+e2p((2*i2*k2+i1*k2*q-i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2+i1*k2*q-i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2,
	e2p((2*i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i2*k2*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2+i1*k2*q-i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i2*k2+i1*k2*q-i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2+i1*k2*q-i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i2*k2+i1*k2*q-i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1))),
	-e2p((2*i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i2*k2*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2+i1*k2*q-i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i2*k2+i1*k2*q-i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2+i1*k2*q-i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i2*k2+i1*k2*q-i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1))),
	e2p((2*i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2+i1*k2*q-i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2+i1*k2*q-i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k1+i3*k2*q+i3*k2-i1*k1-q*i1*k1+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k1+i3*k2*q+i3*k2-i1*k1-q*i1*k1+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k2*q-i2*k2*q+i2*k2+q*i1*k1+i1*k1)*S(1//(q^2-1)))*q+e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k2*q-i2*k2*q+i2*k2+q*i1*k1+i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k1+i3*k2*q+i3*k2-i1*k1-q*i1*k1-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k1+i3*k2*q+i3*k2-i1*k1-q*i1*k1-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k2*q+i3*k2+q*i1*k1+i1*k1+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k2*q+i3*k2+q*i1*k1+i1*k1+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k1+2*i3*k2+i2*k2*q-i2*k2-i1*k1-q*i1*k1)*S(1//(q^2-1)))*q+e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k1+2*i3*k2+i2*k2*q-i2*k2-i1*k1-q*i1*k1)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k1+2*i3*k2*q-i2*k2*q+i2*k2-i1*k1-q*i1*k1)*S(1//(q^2-1)))*q+e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k1+2*i3*k2*q-i2*k2*q+i2*k2-i1*k1-q*i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k2*q+i3*k2+q*i1*k1+i1*k1-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k2*q+i3*k2+q*i1*k1+i1*k1-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k2+i2*k2*q-i2*k2+q*i1*k1+i1*k1)*S(1//(q^2-1)))*q+e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k2+i2*k2*q-i2*k2+q*i1*k1+i1*k1)*S(1//(q^2-1))),
	e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k1+i3*k2*q+i3*k2-i1*k1-q*i1*k1+i2*k3*q-i2*k3)*S(1//(q^2-1)))+e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k2*q-i2*k2*q+i2*k2+q*i1*k1+i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k1+i3*k2*q+i3*k2-i1*k1-q*i1*k1-i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k2*q+i3*k2+q*i1*k1+i1*k1+i2*k3*q-i2*k3)*S(1//(q^2-1)))+e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k1+2*i3*k2+i2*k2*q-i2*k2-i1*k1-q*i1*k1)*S(1//(q^2-1)))+e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k1+2*i3*k2*q-i2*k2*q+i2*k2-i1*k1-q*i1*k1)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k2*q+i3*k2+q*i1*k1+i1*k1-i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k2+i2*k2*q-i2*k2+q*i1*k1+i1*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1+i3*k3+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1+i3*k3+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i3*k3-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2*q)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1+i3*k3-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2*q)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i3*k3*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2*q)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1+i3*k3*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2*q)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1+i3*k3*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2*q)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1+i3*k3*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2*q)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i3*k3*q+i1*k2*q-i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1+i3*k3*q+i1*k2*q-i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1+i3*k3*q+i1*k2*q-i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1+i3*k3*q+i1*k2*q-i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i3*k3+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1+i3*k3+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1+i3*k3-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2*q)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1+i3*k3-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2*q)*S(1//(q^2-1))),
	e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1+i3*k3+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1+i3*k3-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2*q)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1+i3*k3*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2*q)*S(1//(q^2-1)))+e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1+i3*k3*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2*q)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1+i3*k3*q+i1*k2*q-i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1+i3*k3*q+i1*k2*q-i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1+i3*k3+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))+e2p((i3*k1*q+i3*k1-i2*k1*q-i2*k1+i3*k3-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2*q)*S(1//(q^2-1))),
	e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i2*k2*q-i2*k2+i1*k3*q-i1*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i2*k2*q-i2*k2+i1*k3*q-i1*k3)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2-i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i2*k2*q+i2*k2+i1*k3*q-i1*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i2*k2*q+i2*k2+i1*k3*q-i1*k3)*S(1//(q^2-1)))+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2+i2*k3*q-i2*k3)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i2*k2*q-i2*k2-i1*k3*q+i1*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i2*k2*q-i2*k2-i1*k3*q+i1*k3)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2-i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i2*k2*q+i2*k2-i1*k3*q+i1*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i2*k2*q+i2*k2-i1*k3*q+i1*k3)*S(1//(q^2-1)))+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2+i2*k3*q-i2*k3)*S(1//(q^2-1))),
	e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i2*k2*q-i2*k2+i1*k3*q-i1*k3)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2-i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i2*k2*q+i2*k2+i1*k3*q-i1*k3)*S(1//(q^2-1)))+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2+i2*k3*q-i2*k3)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i2*k2*q-i2*k2-i1*k3*q+i1*k3)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2-i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i2*k2*q+i2*k2-i1*k3*q+i1*k3)*S(1//(q^2-1)))+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2+i2*k3*q-i2*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i4*k1*q+i4*k1-q*i1*k1-i1*k1+i4*k3-i3*k2*q+i3*k2+i2*k3*q-i2*k3+i4*k4*q+i4*k4+i4*k2*q)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+i4*k3+i3*k2*q-i3*k2+i2*k3*q-i2*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1-q*i1*k1-i1*k1+i4*k3+i3*k2*q-i3*k2+i2*k3*q-i2*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+i4*k3-i3*k2*q+i3*k2+i2*k3*q-i2*k3+i4*k4*q+i4*k4+i4*k2*q)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1-q*i1*k1-i1*k1+i4*k3+i2*k2*q-i2*k2+i3*k3*q-i3*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1-q*i1*k1-i1*k1+i4*k3*q-i2*k2*q+i2*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4+i4*k2*q)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+i4*k3*q+i3*k2*q-i3*k2-i2*k3*q+i2*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+i4*k3+i2*k2*q-i2*k2+i3*k3*q-i3*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+i4*k3*q+i2*k2*q-i2*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+i4*k3-i2*k2*q+i2*k2+i3*k3*q-i3*k3+i4*k4*q+i4*k4+i4*k2*q)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1-q*i1*k1-i1*k1+i4*k3*q+i2*k2*q-i2*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1-q*i1*k1-i1*k1+i4*k3-i2*k2*q+i2*k2+i3*k3*q-i3*k3+i4*k4*q+i4*k4+i4*k2*q)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1-q*i1*k1-i1*k1+i4*k3*q-i3*k2*q+i3*k2-i2*k3*q+i2*k3+i4*k4*q+i4*k4+i4*k2*q)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+i4*k3*q-i3*k2*q+i3*k2-i2*k3*q+i2*k3+i4*k4*q+i4*k4+i4*k2*q)*S(1//(q^2-1)))+e2p((i4*k1*q+i4*k1-q*i1*k1-i1*k1+i4*k3*q+i3*k2*q-i3*k2-i2*k3*q+i2*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+i4*k3*q-i2*k2*q+i2*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4+i4*k2*q)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)^2*(1+2*q^4+2*q^2+q+q^7+2*q^3+q^6+2*q^5)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*(q^3+1+q^2+q^5)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*(q^3+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*(q^3+2*q^2+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q^3+q^2-q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)^2*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(2*q-1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)^2*(q^2+q+1+q^3)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*(q^2+q+1+q^3)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)^2*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*(q-1)^2,
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*(q-1),
	-(q-1)*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*(q-1),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^4+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^4,
	e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2,
	e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))+e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))*q^3+e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^3+e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))*q^3+e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))*q^3,
	e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))+e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1))),
	e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1)))+e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^2-2*e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2-2*e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2,
	-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+2*i2*k1*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+2*i2*k1+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((k2*q-i2*k2*q+i2*k2+k3*q+k3+1//2*k1*q^2+1//2*q*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3)*S(1//(q^2-1)))*q^2+e2p((k2*q-i2*k2*q+i2*k2+k3*q+k3+1//2*k1*q^2+1//2*q*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+1//2*q*k1+1//2*k1+2*i1*k2*q+k2*q-i2*k2*q+i2*k2+2*i1*k3*q+2*i1*k3+k3*q+k3)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1+i1*k1+1//2*q*k1+1//2*k1+2*i1*k2*q+k2*q-i2*k2*q+i2*k2+2*i1*k3*q+2*i1*k3+k3*q+k3)*S(1//(q^2-1)))+e2p((k2+i2*k2*q-i2*k2+k3*q+k3+1//2*k1*q^2+1//2*q*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3)*S(1//(q^2-1)))*q^2+e2p((k2+i2*k2*q-i2*k2+k3*q+k3+1//2*k1*q^2+1//2*q*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+1//2*q*k1+1//2*k1+2*i1*k2+k2+i2*k2*q-i2*k2+2*i1*k3*q+2*i1*k3+k3*q+k3)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1+i1*k1+1//2*q*k1+1//2*k1+2*i1*k2+k2+i2*k2*q-i2*k2+2*i1*k3*q+2*i1*k3+k3*q+k3)*S(1//(q^2-1))),
	e2p((k2*q-i2*k2*q+i2*k2+k3*q+k3+1//2*k1*q^2+1//2*q*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+1//2*q*k1+1//2*k1+2*i1*k2*q+k2*q-i2*k2*q+i2*k2+2*i1*k3*q+2*i1*k3+k3*q+k3)*S(1//(q^2-1)))+e2p((k2+i2*k2*q-i2*k2+k3*q+k3+1//2*k1*q^2+1//2*q*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+1//2*q*k1+1//2*k1+2*i1*k2+k2+i2*k2*q-i2*k2+2*i1*k3*q+2*i1*k3+k3*q+k3)*S(1//(q^2-1))),
	e2p((k2*q-i2*k2*q+i2*k2+k3*q+k3+1//2*k1*q^2+1//2*q*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+1//2*q*k1+1//2*k1+2*i1*k2*q+k2*q-i2*k2*q+i2*k2+2*i1*k3*q+2*i1*k3+k3*q+k3)*S(1//(q^2-1)))+e2p((k2+i2*k2*q-i2*k2+k3*q+k3+1//2*k1*q^2+1//2*q*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+1//2*q*k1+1//2*k1+2*i1*k2+k2+i2*k2*q-i2*k2+2*i1*k3*q+2*i1*k3+k3*q+k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i2*k1*q+2*i2*k1-i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((2*i2*k1*q+2*i2*k1-i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((q*i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((q*i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((2*i2*k1*q+2*i2*k1-q*i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q+e2p((2*i2*k1*q+2*i2*k1-q*i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	e2p((2*i2*k1*q+2*i2*k1-i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((q*i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((2*i2*k1*q+2*i2*k1-q*i1*k1+i2*k2*q+i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((i3*k2+i3*k1*q+i3*k1-q*i1*k1-i1*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((i3*k2+i3*k1*q+i3*k1-q*i1*k1-i1*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((i3*k2*q+i3*k1*q+i3*k1-q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((i3*k2*q+i3*k1*q+i3*k1-q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))*q+e2p((q*i1*k1+i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((q*i1*k1+i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	e2p((i3*k2+i3*k1*q+i3*k1-q*i1*k1-i1*k1+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i3*k2*q+i3*k1*q+i3*k1-q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2*q)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1*q+q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))*q+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	e2p((i3*k1*q+q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i3*k3+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1*q+i3*k1-i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((q*i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i3*k1*q+i3*k1-q*i1*k1+i3*k2*q-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i1*k1+i3*k2*q-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i3*k1*q+i3*k1-i1*k1+i3*k2*q-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((q*i1*k1+i3*k2*q-i2*k2*q+i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1)))+e2p((i3*k1*q+i3*k1-q*i1*k1+i3*k2+i2*k2*q-i2*k2+i3*k3*q+i3*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)^2*(1+4*q^4+4*q^2+3*q+q^7+4*q^3+3*q^6+4*q^5)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*(q^5+2*q^4+q^3+q^2+2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(q^3-2*q-1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q^4+q^3+q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*(q^2+2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)^2*(q^3+3*q^2+3*q+1)*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)^2*(q^2+2*q+1)*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*(q^2+2*q+1)*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	(q^2+2*q+1)*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	(q+1)*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1)))*(q-1),
	(q+1)*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^4-2*e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^4-2*e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q^2+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q^2,
	-e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))-e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1)))*q+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	e2p((i1*k1+2*i2*k3+i2*k2)*S(1//(q-1)))+e2p((2*i2*k1-i1*k1+i2*k2+2*i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((k2+2*k3+2*i1*k2+4*i1*k3+2*i2*k1)*S(1//(2*(q-1))))-e2p((k2+2*k3+2*i1*k2+4*i1*k3+2*i2*k1)*S(1//(2*(q-1))))*q^2+e2p((k2+2*k3+2*k1+4*i1*k1+2*i1*k2+4*i1*k3-2*i2*k1)*S(1//(2*(q-1))))-e2p((k2+2*k3+2*k1+4*i1*k1+2*i1*k2+4*i1*k3-2*i2*k1)*S(1//(2*(q-1))))*q^2+e2p((k2*q+2*k3+2*k1+4*i1*k1+2*i1*k2+4*i1*k3-2*i2*k1)*S(1//(2*(q-1))))-e2p((k2*q+2*k3+2*k1+4*i1*k1+2*i1*k2+4*i1*k3-2*i2*k1)*S(1//(2*(q-1))))*q^2+e2p((k2*q+2*k3+2*i1*k2+4*i1*k3+2*i2*k1)*S(1//(2*(q-1))))-e2p((k2*q+2*k3+2*i1*k2+4*i1*k3+2*i2*k1)*S(1//(2*(q-1))))*q^2,
	e2p((k2+2*k3+2*i1*k2+4*i1*k3+2*i2*k1)*S(1//(2*(q-1))))+e2p((k2+2*k3+2*k1+4*i1*k1+2*i1*k2+4*i1*k3-2*i2*k1)*S(1//(2*(q-1))))+e2p((k2*q+2*k3+2*k1+4*i1*k1+2*i1*k2+4*i1*k3-2*i2*k1)*S(1//(2*(q-1))))+e2p((k2*q+2*k3+2*i1*k2+4*i1*k3+2*i2*k1)*S(1//(2*(q-1)))),
	e2p((k2+2*k3+2*i1*k2+4*i1*k3+2*i2*k1)*S(1//(2*(q-1))))+e2p((k2+2*k3+2*k1+4*i1*k1+2*i1*k2+4*i1*k3-2*i2*k1)*S(1//(2*(q-1))))+e2p((k2*q+2*k3+2*k1+4*i1*k1+2*i1*k2+4*i1*k3-2*i2*k1)*S(1//(2*(q-1))))+e2p((k2*q+2*k3+2*i1*k2+4*i1*k3+2*i2*k1)*S(1//(2*(q-1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i2*k2+i1*k2*q-i1*k2+2*i2*k3*q^2+2*i2*k3+i2*k1*q^2+i2*k1)*S(1//((q-1)*(q^2+1))))*q+e2p((2*i2*k2+i1*k2*q-i1*k2+2*i2*k3*q^2+2*i2*k3+i2*k1*q^2+i2*k1)*S(1//((q-1)*(q^2+1))))+e2p((2*i2*k2*q^2-2*i2*k2*q+2*i2*k2-i1*k2*q^2+i1*k2*q+2*i2*k3*q^2+2*i2*k3+i2*k1*q^2+i2*k1)*S(1//((q-1)*(q^2+1))))*q+e2p((2*i2*k2*q^2-2*i2*k2*q+2*i2*k2-i1*k2*q^2+i1*k2*q+2*i2*k3*q^2+2*i2*k3+i2*k1*q^2+i2*k1)*S(1//((q-1)*(q^2+1))))+e2p((2*i2*k2*q^2-i1*k2*q+i1*k2+2*i2*k3*q^2+2*i2*k3+i2*k1*q^2+i2*k1)*S(1//((q-1)*(q^2+1))))*q+e2p((2*i2*k2*q^2-i1*k2*q+i1*k2+2*i2*k3*q^2+2*i2*k3+i2*k1*q^2+i2*k1)*S(1//((q-1)*(q^2+1))))+e2p((2*i2*k2*q+i1*k2*q^2-i1*k2*q+2*i2*k3*q^2+2*i2*k3+i2*k1*q^2+i2*k1)*S(1//((q-1)*(q^2+1))))*q+e2p((2*i2*k2*q+i1*k2*q^2-i1*k2*q+2*i2*k3*q^2+2*i2*k3+i2*k1*q^2+i2*k1)*S(1//((q-1)*(q^2+1)))),
	e2p((2*i2*k2+i1*k2*q-i1*k2+2*i2*k3*q^2+2*i2*k3+i2*k1*q^2+i2*k1)*S(1//((q-1)*(q^2+1))))+e2p((2*i2*k2*q^2-2*i2*k2*q+2*i2*k2-i1*k2*q^2+i1*k2*q+2*i2*k3*q^2+2*i2*k3+i2*k1*q^2+i2*k1)*S(1//((q-1)*(q^2+1))))+e2p((2*i2*k2*q^2-i1*k2*q+i1*k2+2*i2*k3*q^2+2*i2*k3+i2*k1*q^2+i2*k1)*S(1//((q-1)*(q^2+1))))+e2p((2*i2*k2*q+i1*k2*q^2-i1*k2*q+2*i2*k3*q^2+2*i2*k3+i2*k1*q^2+i2*k1)*S(1//((q-1)*(q^2+1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k3*q^2+i3*k3+i3*k2*q+i2*k2*q^2-i2*k2*q+i1*k1*q^2+i1*k1)*S(1//((q-1)*(q^2+1))))+e2p((-i1*k1+i3*k1-i3*k2*q+i2*k2*q+i3*k3-i1*k1*q^2-i2*k2*q^2+i3*k2+i3*k1*q^2+i3*k2*q^2+i3*k3*q^2)*S(1//((q-1)*(q^2+1))))+e2p((i1*k1*q^2+i1*k1+i3*k2*q^2-i3*k2*q+i3*k2-i2*k2*q^2+i2*k2*q+i3*k3*q^2+i3*k3)*S(1//((q-1)*(q^2+1))))+e2p((i3*k3*q^2+i3*k3+i3*k2*q^2-i2*k2*q+i2*k2+i1*k1*q^2+i1*k1)*S(1//((q-1)*(q^2+1))))+e2p((-i1*k1+i3*k1+i2*k2-i2*k2*q+i3*k3-i1*k1*q^2+i3*k1*q^2+i3*k2*q^2+i3*k3*q^2)*S(1//((q-1)*(q^2+1))))+e2p((i3*k3*q^2+i3*k3+i3*k1*q^2+i3*k1+i3*k2+i2*k2*q-i2*k2-i1*k1*q^2-i1*k1)*S(1//((q-1)*(q^2+1))))+e2p((i3*k3*q^2+i3*k3+i3*k2+i2*k2*q-i2*k2+i1*k1*q^2+i1*k1)*S(1//((q-1)*(q^2+1))))+e2p((-i1*k1+i3*k1+i3*k2*q-i2*k2*q+i3*k3-i1*k1*q^2+i2*k2*q^2+i3*k1*q^2+i3*k3*q^2)*S(1//((q-1)*(q^2+1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)^2*(1+3*q^4+2*q^2+2*q+q^7+3*q^3+2*q^6+2*q^5)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)^2*(q^4+2*q^3+2*q^2+2*q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*(q^2+q+1+q^3)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)^2*(q^2+2*q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))*q^3-e2p((i1*k1+i2*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^3-e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q^2-e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))-e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1*q^2+i2*k1*q+i2*k1-i1*k1*q^2+i2*k2*q^2+i2*k2*q+i2*k2)*S(1//(q^3-1)))+e2p((i1*k1*q^2+i2*k2*q^2+i2*k2*q+i2*k2)*S(1//(q^3-1)))+e2p((i1*k1+i2*k2*q^2+i2*k2*q+i2*k2)*S(1//(q^3-1)))+e2p((i2*k1*q^2+i2*k1*q+i2*k1-q*i1*k1+i2*k2*q^2+i2*k2*q+i2*k2)*S(1//(q^3-1)))+e2p((q*i1*k1+i2*k2*q^2+i2*k2*q+i2*k2)*S(1//(q^3-1)))+e2p((i2*k1*q^2+i2*k1*q+i2*k1-i1*k1+i2*k2*q^2+i2*k2*q+i2*k2)*S(1//(q^3-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)^3*(1+2*q^2+2*q^4+q^6)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-(q-1)^2*(q^4-q^3+2*q^2-q+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-(q-1)^2*(q^2-q+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-(q-1)*(5*q^3-4*q^2+2*q-1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	(q-1)*(3*q^2-2*q+1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-(q-1)*(3*q-1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-(q-1)*(2*q-1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	(4*q-1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	(2*q-1)*e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^5-3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^4+4*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^3+e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^5-3*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^4+4*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^3-4*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+3*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^5-3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^4+4*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^3-4*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-4*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2,
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^4+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^3-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^4+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^3-2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^4+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^3-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2,
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^3-3*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+3*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^3-3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^3-3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-3*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+4*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+4*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+4*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q^2+2*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	3*e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))+3*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1)))*q-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+i1*k3+1//2*k3*q-1//2*k3+2*i1*k4)*S(1//(q-1)))-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+1//2*k2*q-1//2*k2+i1*k3+2*i1*k4)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2-2*e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+2*e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))+2*e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q^3+2*e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^3-2*e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q^2+2*e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q^4+2*e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^3-e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+2*e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+2*e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^3-e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^4-2*e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^4+2*e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^3-2*e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2-e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^4-e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^4-e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q^4-2*e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q+2*e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q^3,
	-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q^2+2*e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1))),
	e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1))),
	3*e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))+3*e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+3*e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+3*e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+3*e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+3*e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1))),
	-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2*q-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i2*k3+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))-e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k3+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))-e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i2*k3+i2*k1+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))-e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))-e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k3+i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))+e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))*q^3+2*e2p((q*i1*k1-i1*k1+i2*k3+i2*k1+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+i2*k3+i2*k1+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))*q^3+e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))*q^3-2*e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))*q^2+2*e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))*q+2*e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))*q-2*e2p((q*i1*k1-i1*k1+i2*k3+i2*k1+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))*q^2+e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))*q^3-2*e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))*q^2+2*e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k3+i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))*q+e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k3+i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))*q^3-2*e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k3+i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))*q^2+e2p((q*i1*k1-i1*k1+i2*k3+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))*q^3-2*e2p((q*i1*k1-i1*k1+i2*k3+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))*q^2+2*e2p((q*i1*k1-i1*k1+i2*k3+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))*q+e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k3+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))*q^3-2*e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k3+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))*q^2+2*e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k3+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))*q-2*e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))*q^2+2*e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))*q+e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))*q^3+2*e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))*q-2*e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))*q^2,
	2*e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))+2*e2p((q*i1*k1-i1*k1+i2*k3+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+i2*k3+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))+2*e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k3+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k3+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))+2*e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k3+i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))*q-e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k3+i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))+2*e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))*q-e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))+2*e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))+2*e2p((q*i1*k1-i1*k1+i2*k3+i2*k1+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))*q-e2p((q*i1*k1-i1*k1+i2*k3+i2*k1+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))+2*e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1))),
	-e2p((q*i1*k1-i1*k1+i2*k1+i1*k2*q-i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i2*k3+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))-e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k3+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))-e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k3+i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))-e2p((i2*k1*q-q*i1*k1+i1*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i2*k1+i2*k2*q-i1*k2*q+i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4)*S(1//(q^2-1)))-e2p((q*i1*k1-i1*k1+i2*k3+i2*k1+i1*k2*q-i1*k2+i1*k3*q-i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1)))-e2p((i2*k1*q-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q-i1*k3*q+i1*k3+i2*k4*q+i2*k4+i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((1//2*k2*q^2-1//2*k2+2*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((1//2*k3*q^2-1//2*k3+2*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((1//2*k2*q^2-1//2*k2+2*q*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((1//2*k3*q^2-1//2*k3+2*q*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((1//2*k3*q^2-1//2*k3+2*q*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((1//2*k3*q^2-1//2*k3+2*q*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((1//2*k2*q^2-1//2*k2+2*q*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((1//2*k2*q^2-1//2*k2+2*q*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((1//2*k2*q^2-1//2*k2+2*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((1//2*k2*q^2-1//2*k2+2*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((1//2*k3*q^2-1//2*k3+2*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((1//2*k3*q^2-1//2*k3+2*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q-i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))-e2p((-i2*k2*q+i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))-e2p((i2*k2*q-i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))-e2p((-i2*k2*q+i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q-i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q^2-e2p((-i2*k2*q+i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q^2-e2p((i2*k2*q-i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q^2-e2p((-i2*k2*q+i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q^2-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))+2*e2p((i2*k2*q-i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q+2*e2p((i2*k2*q-i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q+2*e2p((-i2*k2*q+i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q+2*e2p((-i2*k2*q+i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q^2+2*e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q^2+2*e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q^2+2*e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q^2+2*e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q,
	e2p((-i2*k2*q+i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q-e2p((-i2*k2*q+i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))+e2p((1//2*k2*q^2-1//2*k2+2*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((1//2*k2*q^2-1//2*k2+2*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((1//2*k3*q^2-1//2*k3+2*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((1//2*k3*q^2-1//2*k3+2*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((-i2*k2*q+i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q-e2p((-i2*k2*q+i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q-i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q-e2p((i2*k2*q-i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))+e2p((1//2*k3*q^2-1//2*k3+2*q*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((1//2*k3*q^2-1//2*k3+2*q*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))+e2p((1//2*k2*q^2-1//2*k2+2*q*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((1//2*k2*q^2-1//2*k2+2*q*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i2*k2*q-i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q-e2p((i2*k2*q-i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1))),
	e2p((-i2*k2*q+i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q-e2p((-i2*k2*q+i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))+e2p((1//2*k2*q^2-1//2*k2+2*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((1//2*k2*q^2-1//2*k2+2*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((1//2*k3*q^2-1//2*k3+2*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q-e2p((1//2*k3*q^2-1//2*k3+2*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4+i2*k1*q-i2*k1)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))+e2p((-i2*k2*q+i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q-e2p((-i2*k2*q+i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))+e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))+e2p((i2*k2*q-i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q-e2p((i2*k2*q-i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))+e2p((1//2*k3*q^2-1//2*k3+2*q*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((1//2*k3*q^2-1//2*k3+2*q*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))+e2p((1//2*k2*q^2-1//2*k2+2*q*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((1//2*k2*q^2-1//2*k2+2*q*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4-i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((i2*k2*q-i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))*q-e2p((i2*k2*q-i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1))),
	-e2p((-i2*k2*q+i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))-e2p((1//2*k2*q^2-1//2*k2+2*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((1//2*k3*q^2-1//2*k3+2*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((-i2*k2*q+i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q-i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))-e2p((1//2*k3*q^2-1//2*k3+2*q*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((1//2*k2*q^2-1//2*k2+2*q*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q-i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1))),
	-e2p((-i2*k2*q+i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))-e2p((1//2*k2*q^2-1//2*k2+2*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((1//2*k3*q^2-1//2*k3+2*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3*q+2*i1*k4*q+2*i1*k4-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((-i2*k2*q+i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2*q+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))-e2p((1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((i2*k2*q-i2*k2+1//2*k3*q^2-1//2*k3+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1)))-e2p((1//2*k3*q^2-1//2*k3+2*q*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((1//2*k2*q^2-1//2*k2+q*i1*k1+i1*k1+i1*k2*q+i1*k2+2*i1*k3+2*i1*k4*q+2*i1*k4+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((1//2*k2*q^2-1//2*k2+2*q*i1*k1+i1*k2*q+i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q-i2*k2+1//2*k1*q^2-1//2*k1+q*i1*k1+i1*k1+2*i1*k2+i1*k3*q+i1*k3+2*i1*k4*q+2*i1*k4)*S(1//(q^2-1))),
	-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))-e2p((2*i2*k2+q*i1*k1-i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))-e2p((2*i2*k2*q-q*i1*k1+i1*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))-e2p((2*i2*k2*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q^2-e2p((2*i2*k2*q-q*i1*k1+i1*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q^2+2*e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q^2-e2p((2*i2*k2+q*i1*k1-i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((2*i2*k2+q*i1*k1-i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q+2*e2p((2*i2*k2-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q-e2p((2*i2*k2-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q^2+2*e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((2*i2*k2*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q+2*e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((2*i2*k2*q-q*i1*k1+i1*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q-e2p((2*i2*k2+i1*k2*q-i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2+i1*k2*q-i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2-e2p((2*i2*k2+i1*k2*q-i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2-e2p((2*i2*k2+i1*k2*q-i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2-e2p((2*i2*k2*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q^2+2*e2p((2*i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+2*e2p((2*i2*k2*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+2*e2p((2*i2*k2+i1*k2*q-i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+2*e2p((2*i2*k2+i1*k2*q-i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q,
	e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2+i1*k2*q-i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2+i1*k2*q-i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2+i1*k2*q-i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2+i1*k2*q-i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2*q-q*i1*k1+i1*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q-e2p((2*i2*k2*q-q*i1*k1+i1*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))+e2p((2*i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2+q*i1*k1-i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2+q*i1*k1-i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q-e2p((2*i2*k2-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1))),
	e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2+i1*k2*q-i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2+i1*k2*q-i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2+i1*k2*q-i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2+i1*k2*q-i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2*q-q*i1*k1+i1*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q-e2p((2*i2*k2*q-q*i1*k1+i1*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))+e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))+e2p((2*i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2+q*i1*k1-i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))*q-e2p((2*i2*k2+q*i1*k1-i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))+e2p((2*i2*k2-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))*q-e2p((2*i2*k2-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1))),
	-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2+q*i1*k1-i1*k1+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2*q-i1*k2*q+i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2+i1*k2*q-i1*k2-i1*k3*q+i1*k3+2*i2*k3*q+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2+i1*k2*q-i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2*q-q*i1*k1+i1*k1-i1*k2*q+i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))-e2p((i2*k2*q+i2*k2-q*i1*k1+i1*k1+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1)))-e2p((2*i2*k2*q-i1*k2*q+i1*k2+i1*k3*q-i1*k3+2*i2*k3+2*i2*k4*q+2*i2*k4+i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2+q*i1*k1-i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1)*S(1//(q^2-1)))-e2p((2*i2*k2-q*i1*k1+i1*k1+i1*k2*q-i1*k2+i2*k3*q+i2*k3+2*i2*k4*q+2*i2*k4+2*i2*k1*q)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+2*i3*k1+i3*k2*q+i3*k2+q*i1*k1-i1*k1-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1+i3*k2*q+i3*k2+q*i1*k1-i1*k1+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k2+i2*k2*q-i2*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+2*i3*k1*q+i3*k2*q+i3*k2-i1*k3*q+i1*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1+2*i3*k2*q-i2*k2*q+i2*k2+q*i1*k1-i1*k1)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1+2*i3*k2+i2*k2*q-i2*k2+q*i1*k1-i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1+i3*k2*q+i3*k2+i1*k3*q-i1*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+2*i3*k1*q+i3*k2*q+i3*k2-q*i1*k1+i1*k1-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1+2*i3*k2+i1*k2*q-i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k2*q-i2*k2*q+i2*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+i3*k2*q+i3*k2+i1*k3*q-i1*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k2+i1*k2*q-i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k2*q-i1*k2*q+i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+2*i3*k1+i3*k2*q+i3*k2-i1*k3*q+i1*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1+2*i3*k2*q-i1*k2*q+i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+i3*k2*q+i3*k2-q*i1*k1+i1*k1+i2*k3*q-i2*k3)*S(1//(q^2-1)))+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+i3*k2*q+i3*k2-q*i1*k1+i1*k1+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+i3*k2*q+i3*k2+i1*k3*q-i1*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k2+i1*k2*q-i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k2*q-i1*k2*q+i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1+i3*k2*q+i3*k2+q*i1*k1-i1*k1+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+2*i3*k1+i3*k2*q+i3*k2+q*i1*k1-i1*k1-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q+e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1+2*i3*k2*q-i1*k2*q+i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+2*i3*k1+i3*k2*q+i3*k2-i1*k3*q+i1*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k2+i2*k2*q-i2*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+2*i3*k1*q+i3*k2*q+i3*k2-i1*k3*q+i1*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))*q+e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1+2*i3*k2+i2*k2*q-i2*k2+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1+i3*k2*q+i3*k2+i1*k3*q-i1*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+2*i3*k1*q+i3*k2*q+i3*k2-q*i1*k1+i1*k1-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q+e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1+2*i3*k2+i1*k2*q-i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))*q+e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1+2*i3*k2*q-i2*k2*q+i2*k2+q*i1*k1-i1*k1)*S(1//(q^2-1)))*q+e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k2*q-i2*k2*q+i2*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))*q+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i2*k2*q-i2*k2+i1*k3*q-i1*k3)*S(1//(q^2-1)))*q-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i2*k2*q+i2*k2-i1*k3*q+i1*k3)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i2*k2*q-i2*k2+i1*k3*q-i1*k3)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i2*k2*q+i2*k2+i1*k3*q-i1*k3)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i2*k2*q-i2*k2-i1*k3*q+i1*k3)*S(1//(q^2-1)))+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i2*k2*q+i2*k2+i1*k3*q-i1*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i2*k2*q-i2*k2-i1*k3*q+i1*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2-i2*k3*q+i2*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i2*k2*q+i2*k2-i1*k3*q+i1*k3)*S(1//(q^2-1)))*q+e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2+i2*k3*q-i2*k3)*S(1//(q^2-1)))*q,
	-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1+i3*k2*q+i3*k2+q*i1*k1-i1*k1+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+2*i3*k1+i3*k2*q+i3*k2+q*i1*k1-i1*k1-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i2*k2*q-i2*k2-i1*k3*q+i1*k3)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k2+i1*k2*q-i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k2*q-i1*k2*q+i1*k2-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i2*k2*q-i2*k2+i1*k3*q-i1*k3)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+i3*k2*q+i3*k2+i1*k3*q-i1*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i2*k2*q+i2*k2-i1*k3*q+i1*k3)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k2*q-i2*k2*q+i2*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i1*k2*q+i1*k2+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2+i1*k2*q-i1*k2+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+2*i3*k1*q+i3*k2*q+i3*k2-q*i1*k1+i1*k1-i2*k3*q+i2*k3)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1+2*i3*k2+i1*k2*q-i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1+2*i3*k2*q-i2*k2*q+i2*k2+q*i1*k1-i1*k1)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1+2*i3*k2+i2*k2*q-i2*k2+q*i1*k1-i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1+i3*k2*q+i3*k2+i1*k3*q-i1*k3+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+2*i3*k2+i2*k2*q-i2*k2-q*i1*k1+i1*k1)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+2*i3*k1*q+i3*k2*q+i3*k2-i1*k3*q+i1*k3-i2*k1*q+i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+i3*k1*q+i3*k1+2*i3*k2*q-i2*k2*q+i2*k2+i1*k3*q-i1*k3)*S(1//(q^2-1)))-e2p((2*i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1*q+i3*k2*q+i3*k2-q*i1*k1+i1*k1+i2*k3*q-i2*k3)*S(1//(q^2-1)))-e2p((i3*k3*q+i3*k3+2*i3*k4*q+2*i3*k4+2*i3*k1+2*i3*k2*q-i1*k2*q+i1*k2+i2*k1*q-i2*k1)*S(1//(q^2-1)))-e2p((2*i3*k3*q+2*i3*k4*q+2*i3*k4+2*i3*k1+i3*k2*q+i3*k2-i1*k3*q+i1*k3+i2*k1*q-i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k3-i1*k2*q+i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i3*k1-i1*k2*q+i1*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+i2*k1*q-i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i2*k3*q-i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1-i1*k2*q+i1*k2+i3*k3*q+i2*k3*q-i2*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k3-i2*k2*q+i2*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k3+i3*k1+i3*k2*q+i1*k2*q-i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i2*k3*q-i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i3*k3*q+i2*k3*q-i2*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))*q+e2p((-i2*k1*q+i2*k1+i3*k1-i1*k2*q+i1*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i2*k1*q-i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i2*k3*q-i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k3-i2*k2*q+i2*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k1-i1*k2*q+i1*k2+i3*k3*q+i2*k3*q-i2*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k3+i3*k1-i1*k2*q+i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i2*k1*q-i2*k1+i3*k3-i1*k2*q+i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i3*k3*q+i2*k3*q-i2*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i2*k1*q-i2*k1+i3*k3+i3*k2*q+i1*k2*q-i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q+e2p((i3*k1*q+q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))*q+e2p((-i2*k1*q+i2*k1+i3*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k3+i3*k1+i3*k2*q+i2*k2*q-i2*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k3+i3*k1-i2*k2*q+i2*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))*q+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k3+i3*k2*q+i1*k2*q-i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k3+i3*k2*q+i2*k2*q-i2*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q+e2p((-i2*k1*q+i2*k1+i3*k3+i3*k1-i1*k2*q+i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))*q+e2p((-i2*k1*q+i2*k1+i3*k3+i3*k1+i3*k2*q+i1*k2*q-i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i2*k3*q-i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q+e2p((-q*i1*k1+i1*k1+i3*k3+i3*k1+i3*k2*q+i1*k2*q-i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))*q+e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k3-i1*k2*q+i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))*q-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k3+i3*k2*q+i2*k2*q-i2*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k3+i3*k1-i1*k2*q+i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+i2*k1*q-i2*k1+i3*k3-i1*k2*q+i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k3+i3*k1-i2*k2*q+i2*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+i2*k1*q-i2*k1+i3*k3+i3*k2*q+i1*k2*q-i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i3*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k3+i3*k2*q+i1*k2*q-i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k3+i3*k1+i3*k2*q+i2*k2*q-i2*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i3*k3+i3*k1+i3*k2*q+i1*k2*q-i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i3*k3+i3*k1-i1*k2*q+i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1))),
	-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((i3*k1*q+i2*k1*q-i2*k1+i3*k3-i1*k2*q+i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k3+i3*k1-i1*k2*q+i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1-i2*k2*q+i2*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i3*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((i3*k1*q+i2*k1*q-i2*k1+i3*k3+i3*k2*q+i1*k2*q-i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k3+i3*k1-i2*k2*q+i2*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k3+i3*k1+i3*k2*q+i2*k2*q-i2*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k3+i3*k2*q+i1*k2*q-i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i2*k2*q-i2*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((i3*k1*q+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i3*k3+i3*k1-i1*k2*q+i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i3*k3+i3*k1+i3*k2*q+i1*k2*q-i1*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k3+i3*k2*q+i2*k2*q-i2*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1-i1*k2*q+i1*k2+i3*k3*q+i2*k3*q-i2*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i2*k3*q-i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k3+i3*k1+i3*k2*q+i1*k2*q-i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1-i1*k2*q+i1*k2+i3*k3*q+i2*k3*q-i2*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k3-i2*k2*q+i2*k2-i1*k3*q+i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i2*k3*q-i2*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((i3*k1*q+i2*k1*q-i2*k1+i3*k2*q+i1*k2*q-i1*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i3*k1-i2*k2*q+i2*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i3*k1-i1*k2*q+i1*k2+i3*k3*q+i1*k3*q-i1*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1)))-e2p((i3*k1*q+q*i1*k1-i1*k1+i3*k3-i1*k2*q+i1*k2-i2*k3*q+i2*k3+i3*k4*q+i3*k4+i3*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i4*k1*q+i2*k1*q-i2*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i1*k3*q-i1*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+q*i1*k1-i1*k1+i4*k3+i4*k2*q+i2*k2*q-i2*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k3+i4*k1+i4*k2*q+i3*k2*q-i3*k2-i1*k3*q+i1*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+q*i1*k1-i1*k1-i3*k2*q+i3*k2+i4*k3*q+i2*k3*q-i2*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i3*k1*q-i3*k1+i4*k3-i1*k2*q+i1*k2-i2*k3*q+i2*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k3+i4*k1+i4*k2*q+i1*k2*q-i1*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+i3*k1*q-i3*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i1*k3*q-i1*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i3*k3*q-i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((-i3*k1*q+i3*k1+i4*k1-i1*k2*q+i1*k2+i4*k3*q+i2*k3*q-i2*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k3+i4*k1+i4*k2*q+i2*k2*q-i2*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+i2*k1*q-i2*k1-i1*k2*q+i1*k2+i4*k3*q+i3*k3*q-i3*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i1*k3*q-i1*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((-i3*k1*q+i3*k1+i4*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i1*k3*q-i1*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k3+i4*k1+i4*k2*q+i3*k2*q-i3*k2-i2*k3*q+i2*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+q*i1*k1-i1*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i3*k3*q-i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+q*i1*k1-i1*k1+i4*k3-i3*k2*q+i3*k2-i2*k3*q+i2*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i2*k1*q-i2*k1-i3*k2*q+i3*k2+i4*k3*q+i1*k3*q-i1*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i2*k1*q-i2*k1+i4*k3-i1*k2*q+i1*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i3*k1*q-i3*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i2*k3*q-i2*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i2*k3*q-i2*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+i3*k1*q-i3*k1+i4*k3+i4*k2*q+i2*k2*q-i2*k2-i1*k3*q+i1*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k3+i4*k1-i2*k2*q+i2*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i2*k1*q-i2*k1+i4*k3+i4*k2*q+i3*k2*q-i3*k2-i1*k3*q+i1*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((-i3*k1*q+i3*k1+i4*k3+i4*k1+i4*k2*q+i2*k2*q-i2*k2-i1*k3*q+i1*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+i2*k1*q-i2*k1+i4*k3+i4*k2*q+i1*k2*q-i1*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k1-i2*k2*q+i2*k2+i4*k3*q+i3*k3*q-i3*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i2*k1*q-i2*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i3*k3*q-i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+i3*k1*q-i3*k1+i4*k3+i4*k2*q+i1*k2*q-i1*k2-i2*k3*q+i2*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k1-i1*k2*q+i1*k2+i4*k3*q+i3*k3*q-i3*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k1-i3*k2*q+i3*k2+i4*k3*q+i1*k3*q-i1*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k3+i4*k1-i3*k2*q+i3*k2-i1*k3*q+i1*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((-i3*k1*q+i3*k1+i4*k1+i4*k2*q+i1*k2*q-i1*k2+i4*k3*q+i2*k3*q-i2*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((-i3*k1*q+i3*k1+i4*k1-i2*k2*q+i2*k2+i4*k3*q+i1*k3*q-i1*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+q*i1*k1-i1*k1+i4*k2*q+i3*k2*q-i3*k2+i4*k3*q+i2*k3*q-i2*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((-i3*k1*q+i3*k1+i4*k3+i4*k1-i1*k2*q+i1*k2-i2*k3*q+i2*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((-i2*k1*q+i2*k1+i4*k3+i4*k1-i1*k2*q+i1*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+q*i1*k1-i1*k1+i4*k3+i4*k2*q+i3*k2*q-i3*k2-i2*k3*q+i2*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+q*i1*k1-i1*k1+i4*k3-i2*k2*q+i2*k2-i3*k3*q+i3*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k3+i4*k1-i3*k2*q+i3*k2-i2*k3*q+i2*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k1+i4*k2*q+i2*k2*q-i2*k2+i4*k3*q+i3*k3*q-i3*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+i3*k1*q-i3*k1-i2*k2*q+i2*k2+i4*k3*q+i1*k3*q-i1*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i4*k1-i3*k2*q+i3*k2+i4*k3*q+i2*k3*q-i2*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i3*k1*q-i3*k1-i1*k2*q+i1*k2+i4*k3*q+i2*k3*q-i2*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i2*k1*q-i2*k1+i4*k3-i3*k2*q+i3*k2-i1*k3*q+i1*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((-i3*k1*q+i3*k1+i4*k3+i4*k1-i2*k2*q+i2*k2-i1*k3*q+i1*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((i4*k1*q+i3*k1*q-i3*k1+i4*k3-i2*k2*q+i2*k2-i1*k3*q+i1*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1)))-e2p((-i3*k1*q+i3*k1+i4*k3+i4*k1+i4*k2*q+i1*k2*q-i1*k2-i2*k3*q+i2*k3+i4*k4*q+i4*k4)*S(1//(q^2-1)))-e2p((i4*k1*q+q*i1*k1-i1*k1-i2*k2*q+i2*k2+i4*k3*q+i3*k3*q-i3*k3+i4*k4*q+i4*k4+i4*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q-1)^3*(1+2*q^4+2*q^2+2*q+2*q^3+q^6+2*q^5)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)^3*(q^3+2*q^2+2*q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)^2*(q^2+q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)*(q^3+2*q^2-1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)^2*(q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(2*q-1)*e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)^3*(q^2+2*q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)^2*(q^2+2*q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-(q-1)^2*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*(q-1)^2,
	(q-1)*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*(q-1),
	(q-1)*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1)))*(q-1),
	-(q+1)*e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	-e2p((i1*k1+1//2*q*k1-1//2*k1+i1*k2+2*i1*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^4+2*e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^4+2*e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q^2-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))+e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))*q-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	-e2p((i2*k1*q+i2*k1-i1*k2*q+i1*k2+2*i2*k2*q+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1)))-e2p((i2*k1*q+i2*k1+i1*k2*q-i1*k2+2*i2*k2+2*i2*k3*q+2*i2*k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((k2+i2*k2*q-i2*k2+k3*q+k3+1//2*k1*q^2+1//2*q*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3)*S(1//(q^2-1)))*q^2-e2p((k2+i2*k2*q-i2*k2+k3*q+k3+1//2*k1*q^2+1//2*q*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+1//2*q*k1+1//2*k1+2*i1*k2+k2+i2*k2*q-i2*k2+2*i1*k3*q+2*i1*k3+k3*q+k3)*S(1//(q^2-1)))*q^2-e2p((q*i1*k1+i1*k1+1//2*q*k1+1//2*k1+2*i1*k2+k2+i2*k2*q-i2*k2+2*i1*k3*q+2*i1*k3+k3*q+k3)*S(1//(q^2-1)))+e2p((k2*q-i2*k2*q+i2*k2+k3*q+k3+1//2*k1*q^2+1//2*q*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3)*S(1//(q^2-1)))*q^2-e2p((k2*q-i2*k2*q+i2*k2+k3*q+k3+1//2*k1*q^2+1//2*q*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3)*S(1//(q^2-1)))+e2p((q*i1*k1+i1*k1+1//2*q*k1+1//2*k1+2*i1*k2*q+k2*q-i2*k2*q+i2*k2+2*i1*k3*q+2*i1*k3+k3*q+k3)*S(1//(q^2-1)))*q^2-e2p((q*i1*k1+i1*k1+1//2*q*k1+1//2*k1+2*i1*k2*q+k2*q-i2*k2*q+i2*k2+2*i1*k3*q+2*i1*k3+k3*q+k3)*S(1//(q^2-1))),
	-e2p((k2+i2*k2*q-i2*k2+k3*q+k3+1//2*k1*q^2+1//2*q*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+1//2*q*k1+1//2*k1+2*i1*k2+k2+i2*k2*q-i2*k2+2*i1*k3*q+2*i1*k3+k3*q+k3)*S(1//(q^2-1)))-e2p((k2*q-i2*k2*q+i2*k2+k3*q+k3+1//2*k1*q^2+1//2*q*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+1//2*q*k1+1//2*k1+2*i1*k2*q+k2*q-i2*k2*q+i2*k2+2*i1*k3*q+2*i1*k3+k3*q+k3)*S(1//(q^2-1))),
	-e2p((k2+i2*k2*q-i2*k2+k3*q+k3+1//2*k1*q^2+1//2*q*k1+q*i1*k1+i1*k1+2*i1*k2+2*i1*k3*q+2*i1*k3)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+1//2*q*k1+1//2*k1+2*i1*k2+k2+i2*k2*q-i2*k2+2*i1*k3*q+2*i1*k3+k3*q+k3)*S(1//(q^2-1)))-e2p((k2*q-i2*k2*q+i2*k2+k3*q+k3+1//2*k1*q^2+1//2*q*k1+q*i1*k1+i1*k1+2*i1*k2*q+2*i1*k3*q+2*i1*k3)*S(1//(q^2-1)))-e2p((q*i1*k1+i1*k1+1//2*q*k1+1//2*k1+2*i1*k2*q+k2*q-i2*k2*q+i2*k2+2*i1*k3*q+2*i1*k3+k3*q+k3)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k2*q^2+i2*k2+i1*k1*q^2-q*i1*k1+2*i2*k3*q^2+2*i2*k3+2*i2*k1*q)*S(1//((q-1)*(q^2+1))))*q-e2p((i2*k2*q^2+i2*k2+i1*k1*q^2-q*i1*k1+2*i2*k3*q^2+2*i2*k3+2*i2*k1*q)*S(1//((q-1)*(q^2+1))))+e2p((i2*k2*q^2+i2*k2-q*i1*k1+i1*k1+2*i2*k3*q^2+2*i2*k3+2*i2*k1*q^2)*S(1//((q-1)*(q^2+1))))*q-e2p((i2*k2*q^2+i2*k2-q*i1*k1+i1*k1+2*i2*k3*q^2+2*i2*k3+2*i2*k1*q^2)*S(1//((q-1)*(q^2+1))))+e2p((i2*k2*q^2+i2*k2+q*i1*k1-i1*k1+2*i2*k3*q^2+2*i2*k3+2*i2*k1)*S(1//((q-1)*(q^2+1))))*q-e2p((i2*k2*q^2+i2*k2+q*i1*k1-i1*k1+2*i2*k3*q^2+2*i2*k3+2*i2*k1)*S(1//((q-1)*(q^2+1))))+e2p((i2*k2*q^2+i2*k2-i1*k1*q^2+q*i1*k1+2*i2*k3*q^2+2*i2*k3+2*i2*k1*q^2-2*i2*k1*q+2*i2*k1)*S(1//((q-1)*(q^2+1))))*q-e2p((i2*k2*q^2+i2*k2-i1*k1*q^2+q*i1*k1+2*i2*k3*q^2+2*i2*k3+2*i2*k1*q^2-2*i2*k1*q+2*i2*k1)*S(1//((q-1)*(q^2+1)))),
	-e2p((i2*k2*q^2+i2*k2+i1*k1*q^2-q*i1*k1+2*i2*k3*q^2+2*i2*k3+2*i2*k1*q)*S(1//((q-1)*(q^2+1))))-e2p((i2*k2*q^2+i2*k2-q*i1*k1+i1*k1+2*i2*k3*q^2+2*i2*k3+2*i2*k1*q^2)*S(1//((q-1)*(q^2+1))))-e2p((i2*k2*q^2+i2*k2+q*i1*k1-i1*k1+2*i2*k3*q^2+2*i2*k3+2*i2*k1)*S(1//((q-1)*(q^2+1))))-e2p((i2*k2*q^2+i2*k2-i1*k1*q^2+q*i1*k1+2*i2*k3*q^2+2*i2*k3+2*i2*k1*q^2-2*i2*k1*q+2*i2*k1)*S(1//((q-1)*(q^2+1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i1*k1+i3*k1+i2*k2+i3*k2*q+i3*k1*q-i2*k2*q+i3*k3*q+i3*k3+i1*k1*q^2+i2*k2*q^2-i2*k2*q^3+i3*k2*q^3+i3*k3*q^3+i3*k3*q^2)*S(1//(q^4-1)))-e2p((-q*i1*k1+i2*k2+i3*k2*q+i3*k1*q-i2*k2*q+i3*k3*q+i3*k3+i2*k2*q^2+i3*k1*q^2+i1*k1*q^3-i2*k2*q^3+i3*k2*q^3+i3*k3*q^3+i3*k3*q^2)*S(1//(q^4-1)))-e2p((q*i1*k1+i3*k1-i2*k2+i2*k2*q+i3*k3*q+i3*k3-i2*k2*q^2+i3*k2+i3*k2*q^2+i3*k1*q^3-i1*k1*q^3+i2*k2*q^3+i3*k3*q^3+i3*k3*q^2)*S(1//(q^4-1)))-e2p((q*i1*k1+i3*k1+i2*k2+i3*k2*q-i2*k2*q+i3*k3*q+i3*k3+i2*k2*q^2+i3*k1*q^3-i1*k1*q^3-i2*k2*q^3+i3*k2*q^3+i3*k3*q^3+i3*k3*q^2)*S(1//(q^4-1)))-e2p((-i1*k1+i3*k1-i2*k2+i3*k1*q+i2*k2*q+i3*k3*q+i3*k3+i1*k1*q^2-i2*k2*q^2+i3*k2+i3*k2*q^2+i2*k2*q^3+i3*k3*q^3+i3*k3*q^2)*S(1//(q^4-1)))-e2p((-q*i1*k1-i2*k2+i3*k1*q+i2*k2*q+i3*k3*q+i3*k3-i2*k2*q^2+i3*k2+i3*k1*q^2+i3*k2*q^2+i1*k1*q^3+i2*k2*q^3+i3*k3*q^3+i3*k3*q^2)*S(1//(q^4-1)))-e2p((i1*k1+i2*k2+i3*k2*q-i2*k2*q+i3*k3*q+i3*k3-i1*k1*q^2+i2*k2*q^2+i3*k1*q^2+i3*k1*q^3-i2*k2*q^3+i3*k2*q^3+i3*k3*q^3+i3*k3*q^2)*S(1//(q^4-1)))-e2p((i1*k1-i2*k2+i2*k2*q+i3*k3*q+i3*k3-i1*k1*q^2-i2*k2*q^2+i3*k2+i3*k1*q^2+i3*k2*q^2+i3*k1*q^3+i2*k2*q^3+i3*k3*q^3+i3*k3*q^2)*S(1//(q^4-1))),
	(0)*e2p(S(0))] [
	(q-1)^3*(3*q+3*q^5+6*q^3+5*q^2+5*q^4+1+q^6)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)^2*(q^4+2*q^3+2*q^2+2*q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-(q-1)^2*(q^2+2*q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q^2+q+1+q^3)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(q-1)*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	(q-1)*(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	e2p((i1*k1+2*i1*k2)*S(1//(q-1)))*(q-1),
	-(q+1)*e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	-e2p((i1*k1+2*i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3+e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^3+e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q^2-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1)))*q-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	-e2p((i2*k1+q*i1*k1-i1*k1+i2*k2*q+i2*k2)*S(1//(q^2-1)))-e2p((-q*i1*k1+i1*k1+i2*k1*q+i2*k2*q+i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i2*k2*q^3+i2*k2-q*i1*k1+i1*k1+i2*k1*q^3)*S(1//((q-1)*(q^3+1))))-e2p((i2*k1+i2*k2+i1*k1*q^2-i2*k1*q^2-i1*k1*q^3+i2*k2*q^3+i2*k1*q^3)*S(1//((q-1)*(q^3+1))))-e2p((i2*k2*q^3+i2*k2+q*i1*k1-i1*k1+i2*k1)*S(1//((q-1)*(q^3+1))))-e2p((i2*k2-i1*k1*q^2+i2*k1*q^2+i1*k1*q^3+i2*k2*q^3)*S(1//((q-1)*(q^3+1))))-e2p((q*i1*k1+i2*k1-i2*k1*q+i2*k2-i1*k1*q^2+i2*k2*q^3+i2*k1*q^3)*S(1//((q-1)*(q^3+1))))-e2p((i2*k2*q^3+i2*k2+i1*k1*q^2-q*i1*k1+i2*k1*q)*S(1//((q-1)*(q^3+1))))]]
classinfo = Vector{Any}[
	["",[1,0],"C_3","h_1(i_1)"],
	["",[1,1],"C_3","h_1(i_1)u_9(1)"],
	["",[1,2],"C_3","h_1(i_1)u_8(1)"],
	["",[1,3],"C_3","h_1(i_1)u_7(1)u_9(-\\alpha)"],
	["",[1,4],"C_3","h_1(i_1)u_6(1)u_7(1)"],
	["",[1,5],"C_3","h_1(i_1)u_3(1)u_5(1)"],
	["",[1,6],"C_3","h_1(i_1)u_3(1)u_4(1)"],
	["",[1,7],"C_3","h_1(i_1)u_3(1)u_4(1)u_7(1)"],
	["",[1,8],"C_3","h_1(i_1)u_3(1)u_4(\\alpha)u_7(1)"],
	["",[1,9],"C_3","h_1(i_1)u_1(1)u_2(1)u_4(1)"],
	["",[2,0],"\\tilde{A}_1+C_2","h_2(i_1)"],
	["",[2,1],"\\tilde{A}_1+C_2","h_2(i_1)u_9(1)"],
	["",[2,2],"\\tilde{A}_1+C_2","h_2(i_1)u_7(1)"],
	["",[2,3],"\\tilde{A}_1+C_2","h_2(i_1)u_5(1)"],
	["",[2,4],"\\tilde{A}_1+C_2","h_2(i_1)u_4(1)u_7(-\\alpha)"],
	["",[2,5],"\\tilde{A}_1+C_2","h_2(i_1)u_2(1)u_4(1)"],
	["",[2,6],"\\tilde{A}_1+C_2","h_2(i_1)u_7(1)u_9(1)"],
	["",[2,7],"\\tilde{A}_1+C_2","h_2(i_1)u_7(1)u_9(\\alpha)"],
	["",[2,8],"\\tilde{A}_1+C_2","h_2(i_1)u_5(1)u_9(1)"],
	["",[2,9],"\\tilde{A}_1+C_2","h_2(i_1)u_4(1)u_7(-\\alpha)u_9(1)"],
	["",[2,10],"\\tilde{A}_1+C_2","h_2(i_1)u_2(1)u_4(1)u_9(1)"],
	["",[2,11],"\\tilde{A}_1+C_2","h_2(i_1)u_2(1)u_4(1)u_9(\\alpha)"],
	["",[3,0],"C_2","h_3(i_1,i_2)"],
	["",[3,1],"C_2","h_3(i_1,i_2)u_7(1)"],
	["",[3,2],"C_2","h_3(i_1,i_2)u_5(1)"],
	["",[3,3],"C_2","h_3(i_1,i_2)u_4(1)u_7(-\\alpha)"],
	["",[3,4],"C_2","h_3(i_1,i_2)u_2(1)u_4(1)"],
	["",[4,0],"C_2","h_4(i_1,i_2)"],
	["",[4,1],"C_2","h_4(i_1,i_2)u_7(1)"],
	["",[4,2],"C_2","h_4(i_1,i_2)u_5(1)"],
	["",[4,3],"C_2","h_4(i_1,i_2)u_4(1)u_7(-\\alpha)"],
	["",[4,4],"C_2","h_4(i_1,i_2)u_2(1)u_4(1)"],
	["",[5,0],"A_2","h_5(i_1,i_2)"],
	["",[5,1],"A_2","h_5(i_1,i_2)u_2(1)"],
	["",[5,2],"A_2","h_5(i_1,i_2)u_2(1)u_1(1)"],
	["",[6,0],"^2A_2","h_6(i_1,i_2)"],
	["",[6,1],"^2A_2","h_6(i_1,i_2)u_2(1)"],
	["",[6,2],"^2A_2","h_6(i_1,i_2)u_2(1)u_1(1)"],
	["",[7,0],"2\\tilde{A}_1","h_7(i_1,i_2)"],
	["",[7,1],"2\\tilde{A}_1","h_7(i_1,i_2)u_4(1)"],
	["",[7,2],"2\\tilde{A}_1","h_7(i_1,i_2)u_9(1)"],
	["",[7,3],"2\\tilde{A}_1","h_7(i_1,i_2)u_4(1)u_9(1)"],
	["",[7,4],"2\\tilde{A}_1","h_7(i_1,i_2)u_4(1)u_9(\\alpha)"],
	["",[8,0],"A_1+\\tilde{A}_1","h_8(i_1,i_2)"],
	["",[8,1],"A_1+\\tilde{A}_1","h_8(i_1,i_2)u_1(1)"],
	["",[8,2],"A_1+\\tilde{A}_1","h_8(i_1,i_2)u_4(1)"],
	["",[8,3],"A_1+\\tilde{A}_1","h_8(i_1,i_2)u_1(1)u_4(1)"],
	["",[9,0],"2\\tilde{A}_1","h_9(i_1,i_2)"],
	["",[9,1],"2\\tilde{A}_1","h_9(i_1,i_2)u_4(1)"],
	["",[9,2],"2\\tilde{A}_1","h_9(i_1,i_2)u_9(1)"],
	["",[9,3],"2\\tilde{A}_1","h_9(i_1,i_2)u_4(1)u_9(1)"],
	["",[9,4],"2\\tilde{A}_1","h_9(i_1,i_2)u_4(1)u_9(\\alpha)"],
	["",[10,0],"A_1+\\tilde{A}_1","h_{10}(i_1,i_2)"],
	["",[10,1],"A_1+\\tilde{A}_1","h_{10}(i_1,i_2)u_1(1)"],
	["",[10,2],"A_1+\\tilde{A}_1","h_{10}(i_1,i_2)u_4(1)"],
	["",[10,3],"A_1+\\tilde{A}_1","h_{10}(i_1,i_2)u_1(1)u_4(1)"],
	["",[11,0],"^2(2\\tilde{A}_1)","h_{11}(i_1,i_2)"],
	["",[11,1],"^2(2\\tilde{A}_1)","h_{11}(i_1,i_2)u_4(1)u_9(1)"],
	["",[11,2],"^2(2\\tilde{A}_1)","h_{11}(i_1,i_2)u_4(\\gamma)u_9(\\gamma^q)"],
	["",[12,0],"^2(2\\tilde{A}_1)","h_{12}(i_1,i_2)"],
	["",[12,1],"^2(2\\tilde{A}_1)","h_{12}(i_1,i_2)u_4(1)u_9(1)"],
	["",[12,2],"^2(2\\tilde{A}_1)","h_{12}(i_1,i_2)u_4(\\gamma)u_9(\\gamma^q)"],
	["",[13,0],"\\tilde{A}_1","h_{13}(i_1,i_2,i_3)"],
	["",[13,1],"\\tilde{A}_1","h_{13}(i_1,i_2,i_3)u_4(1)"],
	["",[14,0],"A_1","h_{14}(i_1,i_2,i_3)"],
	["",[14,1],"A_1","h_{14}(i_1,i_2,i_3)u_1(1)"],
	["",[15,0],"\\tilde{A}_1","h_{15}(i_1,i_2,i_3)"],
	["",[15,1],"\\tilde{A}_1","h_{15}(i_1,i_2,i_3)u_4(1)"],
	["",[16,0],"\\tilde{A}_1","h_{16}(i_1,i_2)"],
	["",[16,1],"\\tilde{A}_1","h_{16}(i_1,i_2)u_4(1)"],
	["",[17,0],"A_1","h_{17}(i_1,i_2,i_3)"],
	["",[17,1],"A_1","h_{17}(i_1,i_2,i_3)u_1(1)"],
	["",[18,0],"A_1","h_{18}(i_1,i_2,i_3)"],
	["",[18,1],"A_1","h_{18}(i_1,i_2,i_3)u_1(1)"],
	["",[19,0],"\\tilde{A}_1","h_{19}(i_1,i_2,i_3)"],
	["",[19,1],"\\tilde{A}_1","h_{19}(i_1,i_2,i_3)u_4(1)"],
	["",[20,0],"\\tilde{A}_1","h_{20}(i_1,i_2)"],
	["",[20,1],"\\tilde{A}_1","h_{20}(i_1,i_2)u_4(1)"],
	["",[21,0],"A_1","h_{21}(i_1,i_2,i_3)"],
	["",[21,1],"A_1","h_{21}(i_1,i_2,i_3)u_1(1)"],
	["",[22,0],"A_0","h_{22}(i_1,i_2,i_3,i_4)"],
	["",[23,0],"A_0","h_{23}(i_1,i_2,i_3,i_4)"],
	["",[24,0],"A_0","h_{24}(i_1,i_2,i_3)"],
	["",[25,0],"A_0","h_{25}(i_1,i_2,i_3,i_4)"],
	["",[26,0],"A_0","h_{26}(i_1,i_2,i_3)"],
	["",[27,0],"A_0","h_{27}(i_1,i_2,i_3)"],
	["",[28,0],"A_0","h_{28}(i_1,i_2)"],
	["",[29,0],"A_0","h_{29}(i_1,i_2,i_3,i_4)"],
	["",[30,0],"A_0","h_{30}(i_1,i_2,i_3)"],
	["",[31,0],"A_0","h_{31}(i_1,i_2)"]]
classlength = R.([
	1,
	(q-1)*(q+1)*(q^2+q+1)*(q^2-q+1),
	1//2*q*(q-1)*(q^2+q+1)*(q^2-q+1)*(q+1)^2*(q^2+1),
	1//2*q*(q+1)*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	q^2*(q+1)^2*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	q^4*(q+1)^2*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	q^4*(q+1)^2*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	1//2*q^4*(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2-q+1)*(q^2+1),
	1//2*q^4*(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2-q+1)*(q^2+1),
	q^6*(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2-q+1)*(q^2+1),
	(q^2-q+1)*(q^2+q+1)*q^4,
	(q-1)*(q+1)*(q^2+q+1)*(q^2-q+1)*q^4,
	q^4*(q+1)*(q^2+q+1)*(q^2-q+1)*(q-1)*(q^2+1),
	1//2*q^5*(q-1)*(q^2-q+1)*(q^2+q+1)*(q+1)^2*(q^2+1),
	1//2*q^5*(q+1)*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	q^6*(q+1)^2*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	1//2*q^4*(q+1)^2*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	1//2*q^4*(q+1)^2*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	1//2*(q-1)^2*(q+1)^3*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^5,
	1//2*(q-1)^3*(q+1)^2*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^5,
	1//2*q^6*(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2-q+1)*(q^2+1),
	1//2*q^6*(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2-q+1)*(q^2+1),
	(q+1)*(q^2+q+1)*(q^2-q+1)*q^5,
	q^5*(q-1)*(q^2-q+1)*(q^2+q+1)*(q+1)^2*(q^2+1),
	1//2*(q+1)^3*(q^2+q+1)*(q^2-q+1)*q^6*(q^2+1)*(q-1),
	1//2*q^6*(q+1)^2*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	(q-1)^2*(q+1)^3*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^7,
	(q-1)*(q^2-q+1)*(q^2+q+1)*q^5,
	q^5*(q+1)*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	1//2*q^6*(q+1)^2*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	1//2*q^6*(q-1)^3*(q^2-q+1)*(q^2+q+1)*(q^2+1)*(q+1),
	(q-1)^3*(q+1)^2*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^7,
	(q+1)^2*(q^2+1)*q^6*(q^2-q+1),
	(q+1)^3*(q^2+q+1)*(q^2-q+1)*q^6*(q^2+1)*(q-1),
	(q-1)^2*(q+1)^3*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^7,
	(q-1)^2*(q^2+1)*(q^2+q+1)*q^6,
	q^6*(q-1)^3*(q^2-q+1)*(q^2+q+1)*(q^2+1)*(q+1),
	(q-1)^3*(q+1)^2*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^7,
	q^7*(q+1)*(q^2+q+1)*(q^2-q+1)*(q^2+1),
	q^7*(q-1)*(q^2-q+1)*(q^2+q+1)*(q+1)^2*(q^2+1),
	q^7*(q-1)*(q^2-q+1)*(q^2+q+1)*(q+1)^2*(q^2+1),
	1//2*(q-1)^2*(q+1)^3*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^7,
	1//2*(q-1)^2*(q+1)^3*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^7,
	q^7*(q+1)*(q^2+q+1)*(q^2-q+1)*(q^2+1),
	q^7*(q-1)*(q^2-q+1)*(q^2+q+1)*(q+1)^2*(q^2+1),
	q^7*(q-1)*(q^2-q+1)*(q^2+q+1)*(q+1)^2*(q^2+1),
	(q-1)^2*(q+1)^3*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^7,
	q^7*(q^2-q+1)*(q^2+q+1)*(q-1)*(q^2+1),
	q^7*(q+1)*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	q^7*(q+1)*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	1//2*(q-1)^3*(q+1)^2*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^7,
	1//2*(q-1)^3*(q+1)^2*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^7,
	q^7*(q^2-q+1)*(q^2+q+1)*(q-1)*(q^2+1),
	q^7*(q+1)*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	q^7*(q+1)*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	(q-1)^3*(q+1)^2*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^7,
	(q-1)*(q+1)^2*(q^2+q+1)*(q^2-q+1)*q^7,
	1//2*(q-1)^2*(q+1)^3*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^7,
	1//2*(q-1)^2*(q+1)^3*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^7,
	(q-1)^2*(q+1)*(q^2+q+1)*(q^2-q+1)*q^7,
	1//2*(q-1)^3*(q+1)^2*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^7,
	1//2*(q-1)^3*(q+1)^2*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^7,
	(q+1)^2*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^8,
	(q+1)^3*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^8*(q-1),
	(q+1)^2*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^8,
	(q+1)^3*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^8*(q-1),
	(q-1)*(q+1)*q^8*(q^2-q+1)*(q^2+q+1)*(q^2+1),
	q^8*(q+1)^2*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	(q-1)*(q+1)*q^8*(q^2-q+1)*(q^2+q+1)*(q^2+1),
	q^8*(q+1)^2*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	(q-1)*(q+1)*q^8*(q^2-q+1)*(q^2+q+1)*(q^2+1),
	q^8*(q+1)^2*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	(q-1)*(q+1)*q^8*(q^2-q+1)*(q^2+q+1)*(q^2+1),
	q^8*(q+1)^2*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	q^8*(q^2-q+1)*(q^2+q+1)*(q-1)^2*(q^2+1),
	q^8*(q-1)^3*(q^2-q+1)*(q^2+q+1)*(q^2+1)*(q+1),
	(q-1)^2*(q+1)^2*(q^2+q+1)*(q^2-q+1)*q^8,
	(q-1)^3*(q+1)^3*(q^2+q+1)*(q^2-q+1)*q^8,
	q^8*(q^2-q+1)*(q^2+q+1)*(q-1)^2*(q^2+1),
	q^8*(q-1)^3*(q^2-q+1)*(q^2+q+1)*(q^2+1)*(q+1),
	q^9*(q+1)^3*(q^2+q+1)*(q^2-q+1)*(q^2+1),
	q^9*(q-1)*(q^2-q+1)*(q^2+q+1)*(q+1)^2*(q^2+1),
	q^9*(q-1)*(q^2-q+1)*(q^2+q+1)*(q+1)^2*(q^2+1),
	(q+1)*(q^2+q+1)*(q^2-q+1)*q^9*(q-1)^2*(q^2+1),
	(q+1)*(q^2+q+1)*(q^2-q+1)*q^9*(q-1)^2*(q^2+1),
	(q+1)^3*(q^2+q+1)*(q^2-q+1)*q^9*(q-1)^2,
	(q+1)^3*(q^2-q+1)*q^9*(q-1)^2*(q^2+1),
	(q-1)^3*(q^2-q+1)*(q^2+q+1)*q^9*(q^2+1),
	q^9*(q-1)^3*(q^2-q+1)*(q^2+q+1)*(q+1)^2,
	q^9*(q-1)^3*(q^2+q+1)*(q+1)^2*(q^2+1)])
charinfo = Vector{Any}[
	[1,[1,1]],
	[2,[1,2]],
	[3,[1,3]],
	[4,[1,4]],
	[5,[1,5]],
	[6,[1,6]],
	[7,[1,7]],
	[8,[1,8]],
	[9,[1,9]],
	[10,[1,10]],
	[11,[1,11]],
	[12,[1,12]],
	[13,[2,1]],
	[14,[2,2]],
	[15,[2,3]],
	[16,[2,4]],
	[17,[2,5]],
	[18,[3,1]],
	[19,[3,2]],
	[20,[3,3]],
	[21,[3,4]],
	[22,[3,5]],
	[23,[4,1]],
	[24,[4,2]],
	[25,[4,3]],
	[26,[4,4]],
	[27,[4,5]],
	[28,[4,6]],
	[29,[4,7]],
	[30,[4,8]],
	[31,[5,1]],
	[32,[5,2]],
	[33,[5,3]],
	[34,[5,4]],
	[35,[6,1]],
	[36,[6,2]],
	[37,[6,3]],
	[38,[6,4]],
	[39,[6,5]],
	[40,[6,6]],
	[41,[7,1]],
	[42,[7,2]],
	[43,[7,3]],
	[44,[7,4]],
	[45,[7,5]],
	[46,[7,6]],
	[47,[8,1]],
	[48,[8,2]],
	[49,[8,3]],
	[50,[9,1]],
	[51,[9,2]],
	[52,[9,3]],
	[53,[10,1]],
	[54,[10,2]],
	[55,[10,3]],
	[56,[10,4]],
	[57,[11,1]],
	[58,[11,2]],
	[59,[11,3]],
	[60,[11,4]],
	[61,[12,1]],
	[62,[12,2]],
	[63,[12,3]],
	[64,[12,4]],
	[65,[13,1]],
	[66,[13,2]],
	[67,[13,3]],
	[68,[13,4]],
	[69,[14,1]],
	[70,[14,2]],
	[71,[15,1]],
	[72,[15,2]],
	[73,[16,1]],
	[74,[16,2]],
	[75,[17,1]],
	[76,[17,2]],
	[77,[18,1]],
	[78,[18,2]],
	[79,[19,1]],
	[80,[19,2]],
	[81,[20,1]],
	[82,[20,2]],
	[83,[21,1]],
	[84,[21,2]],
	[85,[22,1]],
	[86,[22,2]],
	[87,[23,1]],
	[88,[23,2]],
	[89,[24,1]],
	[90,[24,2]],
	[91,[25,1]],
	[92,[26,1]],
	[93,[27,1]],
	[94,[28,1]],
	[95,[29,1]],
	[96,[30,1]],
	[97,[31,1]],
	[98,[32,1]],
	[99,[33,1]],
	[100,[34,1]]]
chardegree = R.([
	1,
	1//2*q*(q^2+q+1)*(q^2+1),
	1//2*q*(q^2-q+1)*(q^2+1),
	1//2*q*(q^2-q+1)*(q+1)^2,
	1//2*(q-1)^2*q*(q^2+q+1),
	q^2*(q^2-q+1)*(q^2+q+1),
	q^3*(q^2-q+1)*(q^2+q+1),
	1//2*q^4*(q^2+1)*(q^2+q+1),
	1//2*q^4*(q^2-q+1)*(q+1)^2,
	1//2*q^4*(q^2-q+1)*(q^2+1),
	1//2*(q-1)^2*q^4*(q^2+q+1),
	q^9,
	(q+1)*(q^2-q+1),
	q*(q+1)*(q^2+q+1)*(q^2-q+1),
	q^2*(q+1)*(q^2-q+1)*(q^2+1),
	q^3*(q+1)*(q^2-q+1)*(q^2+q+1),
	q^6*(q+1)*(q^2-q+1),
	(q-1)*(q^2+q+1),
	(q-1)*q*(q^2-q+1)*(q^2+q+1),
	(q-1)*q^2*(q^2+q+1)*(q^2+1),
	(q-1)*q^3*(q^2+q+1)*(q^2-q+1),
	(q-1)*q^6*(q^2+q+1),
	(q^2-q+1)*(q^2+1)*(q^2+q+1),
	q*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	q*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	q*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	q^2*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	q^2*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	q^2*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	q^3*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)*(q+1)*(q^2-q+1)*(q^2+q+1),
	(q-1)*q*(q+1)*(q^2+q+1)*(q^2-q+1),
	(q-1)*q^2*(q+1)*(q^2+q+1)*(q^2-q+1),
	(q-1)*q^3*(q+1)*(q^2+q+1)*(q^2-q+1),
	(q+1)*(q^2+q+1)*(q^2-q+1),
	1//2*q*(q^2-q+1)*(q^2+q+1)*(q+1)^3,
	1//2*q*(q+1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	1//2*q*(q+1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	1//2*(q-1)^2*q*(q+1)*(q^2+q+1)*(q^2-q+1),
	q^4*(q+1)*(q^2+q+1)*(q^2-q+1),
	(q-1)*(q^2-q+1)*(q^2+q+1),
	1//2*(q-1)*q*(q^2-q+1)*(q^2+q+1)*(q+1)^2,
	1//2*(q-1)*q*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	1//2*(q-1)*q*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	1//2*(q-1)^3*q*(q^2+q+1)*(q^2-q+1),
	(q-1)*q^4*(q^2+q+1)*(q^2-q+1),
	(q+1)^2*(q^2+1)*(q^2-q+1),
	q*(q^2+1)*(q^2-q+1)*(q+1)^3,
	q^3*(q+1)^2*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q^2+q+1)*(q^2+1),
	(q-1)^3*q*(q^2+1)*(q^2+q+1),
	(q-1)^2*q^3*(q^2+q+1)*(q^2+1),
	(q+1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	q*(q+1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	q*(q+1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	q^2*(q+1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q+1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	q*(q+1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	q*(q+1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	q^2*(q+1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)*q*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)*q*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)*q^2*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)*q*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)*q*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)*q^2*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)*(q^2-q+1)*(q^2+q+1)*(q+1)^2,
	(q-1)*q^2*(q^2-q+1)*(q^2+q+1)*(q+1)^2,
	(q-1)^2*(q+1)*(q^2+q+1)*(q^2-q+1),
	(q-1)^2*q^2*(q+1)*(q^2+q+1)*(q^2-q+1),
	(q^2-q+1)*(q^2+1)*(q^2+q+1)*(q+1)^2,
	q*(q^2-q+1)*(q^2+1)*(q^2+q+1)*(q+1)^2,
	(q^2-q+1)*(q^2+1)*(q^2+q+1)*(q+1)^2,
	q*(q^2-q+1)*(q^2+1)*(q^2+q+1)*(q+1)^2,
	(q-1)*(q+1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)*q*(q+1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)*(q+1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)*q*(q+1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)*(q+1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)*q*(q+1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)*(q+1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)*q*(q+1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)^2*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)^2*q*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)^2*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)^2*q*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q-1)^2*(q^2+q+1)*(q^2-q+1)*(q+1)^2,
	(q-1)^2*q*(q^2-q+1)*(q^2+q+1)*(q+1)^2,
	(q+1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)*(q+1)^2*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)*(q+1)^2*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q+1)*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q+1)*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q+1)^3*(q^2+q+1)*(q^2-q+1),
	(q-1)^2*(q+1)^3*(q^2+1)*(q^2-q+1),
	(q-1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^3*(q+1)^2*(q^2+q+1)*(q^2-q+1),
	(q-1)^3*(q+1)^2*(q^2+q+1)*(q^2+1)])

classsums=[
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, i1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [i2+1//2*q-1//2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//2*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [i2+1//2*q-1//2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//2*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [i2+1//2*q-1//2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//2*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [i2+1//2*q-1//2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//2*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [i2+1//2*q-1//2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//2*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [i2+1//2*q+1//2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//2*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [i2+1//2*q+1//2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//2*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [i2+1//2*q+1//2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//2*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [i2+1//2*q+1//2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//2*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [i2+1//2*q+1//2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//2*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i11])
	s2=eesubs(tt, [i1], [i11+1//2*q-1//2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i2], [2*i11])
	zw1,e2=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	zw2,e3=nesum(tt, i1, 0, q-2, congruence)
	zw2=eesubs(zw2, [i2], [2*i11+1])
	zw2,e4=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//2*zw1+1//2*zw2, union(e1,e2,e3,e4))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i11])
	s2=eesubs(tt, [i1], [i11+1//2*q-1//2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i2], [2*i11])
	zw1,e2=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	zw2,e3=nesum(tt, i1, 0, q-2, congruence)
	zw2=eesubs(zw2, [i2], [2*i11+1])
	zw2,e4=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//2*zw1+1//2*zw2, union(e1,e2,e3,e4))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i11])
	s2=eesubs(tt, [i1], [i11+1//2*q-1//2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i2], [2*i11])
	zw1,e2=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	zw2,e3=nesum(tt, i1, 0, q-2, congruence)
	zw2=eesubs(zw2, [i2], [2*i11+1])
	zw2,e4=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//2*zw1+1//2*zw2, union(e1,e2,e3,e4))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i11])
	s2=eesubs(tt, [i1], [i11+1//2*q+1//2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i2], [2*i11])
	zw1,e2=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	zw2,e3=nesum(tt, i1, 0, q, congruence)
	zw2=eesubs(zw2, [i2], [2*i11+1])
	zw2,e4=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//2*zw1+1//2*zw2, union(e1,e2,e3,e4))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i11])
	s2=eesubs(tt, [i1], [i11+1//2*q+1//2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i2], [2*i11])
	zw1,e2=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	zw2,e3=nesum(tt, i1, 0, q, congruence)
	zw2=eesubs(zw2, [i2], [2*i11+1])
	zw2,e4=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//2*zw1+1//2*zw2, union(e1,e2,e3,e4))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i11])
	s2=eesubs(tt, [i1], [i11+1//2*q+1//2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i2], [2*i11])
	zw1,e2=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	zw2,e3=nesum(tt, i1, 0, q, congruence)
	zw2=eesubs(zw2, [i2], [2*i11+1])
	zw2,e4=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//2*zw1+1//2*zw2, union(e1,e2,e3,e4))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i2], [i1])
	s2=eesubs(tt, [i2], [i1+1//2*q-1//2])
	zw1,e1=nesum(tt, i2, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i1, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i2], [i1])
	s2=eesubs(tt, [i2], [i1+1//2*q-1//2])
	zw1,e1=nesum(tt, i2, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i1, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i2], [i1])
	s2=eesubs(tt, [i2], [i1+1//2*q-1//2])
	zw1,e1=nesum(tt, i2, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i1, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i2], [i1])
	s2=eesubs(tt, [i2], [i1+1//2*q-1//2])
	zw1,e1=nesum(tt, i2, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i1, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i2], [i1])
	s2=eesubs(tt, [i2], [i1+1//2*q-1//2])
	zw1,e1=nesum(tt, i2, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i1, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [i2+1//2*q-1//2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//2*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [i2+1//2*q-1//2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//2*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [i2+1//2*q-1//2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//2*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [i2+1//2*q-1//2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//2*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i2], [i1])
	s2=eesubs(tt, [i2], [i1+1//2*q+1//2])
	zw1,e1=nesum(tt, i2, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i1, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i2], [i1])
	s2=eesubs(tt, [i2], [i1+1//2*q+1//2])
	zw1,e1=nesum(tt, i2, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i1, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i2], [i1])
	s2=eesubs(tt, [i2], [i1+1//2*q+1//2])
	zw1,e1=nesum(tt, i2, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i1, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i2], [i1])
	s2=eesubs(tt, [i2], [i1+1//2*q+1//2])
	zw1,e1=nesum(tt, i2, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i1, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i2], [i1])
	s2=eesubs(tt, [i2], [i1+1//2*q+1//2])
	zw1,e1=nesum(tt, i2, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i1, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [i2+1//2*q+1//2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//2*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [i2+1//2*q+1//2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//2*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [i2+1//2*q+1//2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//2*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [i2+1//2*q+1//2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//2*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i2, 0, q-2, congruence)
	zw1,e2=nesum(zw1, i1, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i2, 0, q-2, congruence)
	zw1,e2=nesum(zw1, i1, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i2, 0, q-2, congruence)
	zw1,e2=nesum(zw1, i1, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i2, 0, q, congruence)
	zw1,e2=nesum(zw1, i1, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i2, 0, q, congruence)
	zw1,e2=nesum(zw1, i1, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i2, 0, q, congruence)
	zw1,e2=nesum(zw1, i1, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i3])
	s2=eesubs(tt, [i1], [i3+1//2*q-1//2])
	s3=eesubs(tt, [i1], [i2])
	s4=eesubs(tt, [i1], [2*i3-i2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2-s3-s4
	s1=eesubs(zw1, [i2], [i3])
	s2=eesubs(zw1, [i2], [i3+1//2*q-1//2])
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e3=nesum(zw1, i3, 0, q-2, congruence)
	(1//8*zw1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i3])
	s2=eesubs(tt, [i1], [i3+1//2*q-1//2])
	s3=eesubs(tt, [i1], [i2])
	s4=eesubs(tt, [i1], [2*i3-i2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2-s3-s4
	s1=eesubs(zw1, [i2], [i3])
	s2=eesubs(zw1, [i2], [i3+1//2*q-1//2])
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e3=nesum(zw1, i3, 0, q-2, congruence)
	(1//8*zw1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i11])
	s2=eesubs(tt, [i1], [i11+1//2*q-1//2])
	s3=eesubs(tt, [i1], [i2])
	s4=eesubs(tt, [i1], [2*i11-i2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2-s3-s4
	s1=eesubs(zw1, [i2], [i11])
	s2=eesubs(zw1, [i2], [i11+1//2*q-1//2])
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i3], [2*i11])
	zw1,e3=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [2*i11+1-i2])
	zw2,e4=nesum(tt, i1, 0, q-2, congruence)
	zw2=zw2-s1-s2
	zw2,e5=nesum(zw2, i2, 0, q-2, congruence)
	zw2=eesubs(zw2, [i3], [2*i11+1])
	zw2,e6=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//4*zw1+1//4*zw2, union(e1,e2,e3,e4,e5,e6))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i11])
	s2=eesubs(tt, [i1], [i11+1//2*q-1//2])
	s3=eesubs(tt, [i1], [i2])
	s4=eesubs(tt, [i1], [2*i11-i2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2-s3-s4
	s1=eesubs(zw1, [i2], [i11])
	s2=eesubs(zw1, [i2], [i11+1//2*q-1//2])
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i3], [2*i11])
	zw1,e3=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [2*i11+1-i2])
	zw2,e4=nesum(tt, i1, 0, q-2, congruence)
	zw2=zw2-s1-s2
	zw2,e5=nesum(zw2, i2, 0, q-2, congruence)
	zw2=eesubs(zw2, [i3], [2*i11+1])
	zw2,e6=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//4*zw1+1//4*zw2, union(e1,e2,e3,e4,e5,e6))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i3])
	s2=eesubs(tt, [i1], [i3+1//2*q-1//2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	s1=eesubs(zw1, [i2], [i3])
	s2=eesubs(zw1, [i2], [i3+1//2*q+1//2])
	zw1,e2=nesum(zw1, i2, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1,e3=nesum(zw1, i3, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i3])
	s2=eesubs(tt, [i1], [i3+1//2*q-1//2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	s1=eesubs(zw1, [i2], [i3])
	s2=eesubs(zw1, [i2], [i3+1//2*q+1//2])
	zw1,e2=nesum(zw1, i2, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1,e3=nesum(zw1, i3, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i1*(q+1)])
	s2=eesubs(tt, [i1], [2*i2+i1*(q-1)])
	s3=eesubs(tt, [i1], [i2*(q+1)])
	s4=eesubs(tt, [i1], [i2*(q+1)+1//2*q^2-1//2])
	s1,e1=nesum(s1, i1, 0, q-2, congruence)
	s2,e2=nesum(s2, i1, 0, q, congruence)
	zw1,e3=nesum(tt, i1, 0, q^2-2, congruence)
	zw1=zw1-s1-s2+s3+s4
	zw1,e4=nesum(zw1, i2, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2,e3,e4))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i1*(q+1)])
	s2=eesubs(tt, [i1], [2*i2+i1*(q-1)])
	s3=eesubs(tt, [i1], [i2*(q+1)])
	s4=eesubs(tt, [i1], [i2*(q+1)+1//2*q^2-1//2])
	s1,e1=nesum(s1, i1, 0, q-2, congruence)
	s2,e2=nesum(s2, i1, 0, q, congruence)
	zw1,e3=nesum(tt, i1, 0, q^2-2, congruence)
	zw1=zw1-s1-s2+s3+s4
	zw1,e4=nesum(zw1, i2, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2,e3,e4))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i11])
	s2=eesubs(tt, [i1], [i11+1//2*q-1//2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	s1=eesubs(zw1, [i2], [i11])
	s2=eesubs(zw1, [i2], [i11+1//2*q+1//2])
	zw1,e2=nesum(zw1, i2, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i3], [2*i11])
	zw1,e3=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	zw2,e4=nesum(tt, i1, 0, q-2, congruence)
	zw2,e5=nesum(zw2, i2, 0, q, congruence)
	zw2=eesubs(zw2, [i3], [2*i11+1])
	zw2,e6=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//4*zw1+1//4*zw2, union(e1,e2,e3,e4,e5,e6))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i11])
	s2=eesubs(tt, [i1], [i11+1//2*q-1//2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	s1=eesubs(zw1, [i2], [i11])
	s2=eesubs(zw1, [i2], [i11+1//2*q+1//2])
	zw1,e2=nesum(zw1, i2, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i3], [2*i11])
	zw1,e3=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	zw2,e4=nesum(tt, i1, 0, q-2, congruence)
	zw2,e5=nesum(zw2, i2, 0, q, congruence)
	zw2=eesubs(zw2, [i3], [2*i11+1])
	zw2,e6=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//4*zw1+1//4*zw2, union(e1,e2,e3,e4,e5,e6))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i11])
	s2=eesubs(tt, [i1], [i11+1//2*q+1//2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2
	s1=eesubs(zw1, [i2], [i11])
	s2=eesubs(zw1, [i2], [i11+1//2*q-1//2])
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i3], [2*i11])
	zw1,e3=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	zw2,e4=nesum(tt, i1, 0, q, congruence)
	zw2,e5=nesum(zw2, i2, 0, q-2, congruence)
	zw2=eesubs(zw2, [i3], [2*i11+1])
	zw2,e6=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//4*zw1+1//4*zw2, union(e1,e2,e3,e4,e5,e6))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i11])
	s2=eesubs(tt, [i1], [i11+1//2*q+1//2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2
	s1=eesubs(zw1, [i2], [i11])
	s2=eesubs(zw1, [i2], [i11+1//2*q-1//2])
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i3], [2*i11])
	zw1,e3=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	zw2,e4=nesum(tt, i1, 0, q, congruence)
	zw2,e5=nesum(zw2, i2, 0, q-2, congruence)
	zw2=eesubs(zw2, [i3], [2*i11+1])
	zw2,e6=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//4*zw1+1//4*zw2, union(e1,e2,e3,e4,e5,e6))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i3])
	s2=eesubs(tt, [i1], [i3+1//2*q+1//2])
	s3=eesubs(tt, [i1], [i2])
	s4=eesubs(tt, [i1], [2*i3-i2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2-s3-s4
	s1=eesubs(zw1, [i2], [i3])
	s2=eesubs(zw1, [i2], [i3+1//2*q+1//2])
	zw1,e2=nesum(zw1, i2, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1,e3=nesum(zw1, i3, 0, q-2, congruence)
	(1//8*zw1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i3])
	s2=eesubs(tt, [i1], [i3+1//2*q+1//2])
	s3=eesubs(tt, [i1], [i2])
	s4=eesubs(tt, [i1], [2*i3-i2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2-s3-s4
	s1=eesubs(zw1, [i2], [i3])
	s2=eesubs(zw1, [i2], [i3+1//2*q+1//2])
	zw1,e2=nesum(zw1, i2, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1,e3=nesum(zw1, i3, 0, q-2, congruence)
	(1//8*zw1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2*(q+1)])
	s2=eesubs(tt, [i1], [i2*(q+1)+1//2*q^2+1//2])
	zw1,e1=nesum(tt, i1, 0, q^2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2*(q+1)])
	s2=eesubs(tt, [i1], [i2*(q+1)+1//2*q^2+1//2])
	zw1,e1=nesum(tt, i1, 0, q^2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [-i11])
	s2=eesubs(tt, [i1], [-i11+1//2*q+1//2])
	s3=eesubs(tt, [i1], [i2])
	s4=eesubs(tt, [i1], [-i3-i2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2-s3-s4
	s1=eesubs(zw1, [i2], [-i11])
	s2=eesubs(zw1, [i2], [-i11+1//2*q+1//2])
	zw1,e2=nesum(zw1, i2, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i3], [2*i11])
	zw1,e3=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [-i3-i2])
	zw2,e4=nesum(tt, i1, 0, q, congruence)
	zw2=zw2-s1-s2
	zw2,e5=nesum(zw2, i2, 0, q, congruence)
	zw2=eesubs(zw2, [i3], [2*i11+1])
	zw2,e6=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//4*zw1+1//4*zw2, union(e1,e2,e3,e4,e5,e6))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [-i11])
	s2=eesubs(tt, [i1], [-i11+1//2*q+1//2])
	s3=eesubs(tt, [i1], [i2])
	s4=eesubs(tt, [i1], [-i3-i2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2-s3-s4
	s1=eesubs(zw1, [i2], [-i11])
	s2=eesubs(zw1, [i2], [-i11+1//2*q+1//2])
	zw1,e2=nesum(zw1, i2, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i3], [2*i11])
	zw1,e3=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [-i3-i2])
	zw2,e4=nesum(tt, i1, 0, q, congruence)
	zw2=zw2-s1-s2
	zw2,e5=nesum(zw2, i2, 0, q, congruence)
	zw2=eesubs(zw2, [i3], [2*i11+1])
	zw2,e6=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//4*zw1+1//4*zw2, union(e1,e2,e3,e4,e5,e6))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i3], [i11])
	s2=eesubs(tt, [i3], [i11+1//2*q-1//2])
	s3=eesubs(tt, [i3], [i1])
	s4=eesubs(tt, [i3], [2*i11-i1])
	s5=eesubs(tt, [i3], [i2])
	s6=eesubs(tt, [i3], [2*i11-i2])
	zw1,e1=nesum(tt, i3, 0, q-2, congruence)
	zw1=zw1-s1-s2-s3-s4-s5-s6
	s1=eesubs(zw1, [i2], [i11])
	s2=eesubs(zw1, [i2], [i11+1//2*q-1//2])
	s3=eesubs(zw1, [i2], [i1])
	s4=eesubs(zw1, [i2], [2*i11-i1])
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	zw1=zw1-s1-s2-s3-s4
	s1=eesubs(zw1, [i1], [i11])
	s2=eesubs(zw1, [i1], [i11+1//2*q-1//2])
	zw1,e3=nesum(zw1, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i4], [2*i11])
	zw1,e4=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	s1=eesubs(tt, [i3], [i1])
	s2=eesubs(tt, [i3], [2*i11+1-i1])
	s3=eesubs(tt, [i3], [i2])
	s4=eesubs(tt, [i3], [2*i11+1-i2])
	zw2,e5=nesum(tt, i3, 0, q-2, congruence)
	zw2=zw2-s1-s2-s3-s4
	s1=eesubs(zw2, [i2], [i1])
	s2=eesubs(zw2, [i2], [2*i11+1-i1])
	zw2,e6=nesum(zw2, i2, 0, q-2, congruence)
	zw2=zw2-s1-s2
	zw2,e7=nesum(zw2, i1, 0, q-2, congruence)
	zw2=eesubs(zw2, [i4], [2*i11+1])
	zw2,e8=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//48*zw1+1//48*zw2, union(e1,e2,e3,e4,e5,e6,e7,e8))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i11])
	s2=eesubs(tt, [i1], [i11+1//2*q-1//2])
	s3=eesubs(tt, [i1], [i2])
	s4=eesubs(tt, [i1], [2*i11-i2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2-s3-s4
	s1=eesubs(zw1, [i2], [i11])
	s2=eesubs(zw1, [i2], [i11+1//2*q-1//2])
	zw1,e2=nesum(zw1, i2, 0, q-2, congruence)
	zw1=zw1-s1-s2
	s1=eesubs(zw1, [i3], [i11])
	s2=eesubs(zw1, [i3], [i11+1//2*q+1//2])
	zw1,e3=nesum(zw1, i3, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i4], [2*i11])
	zw1,e4=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [2*i11+1-i2])
	zw2,e5=nesum(tt, i1, 0, q-2, congruence)
	zw2=zw2-s1-s2
	zw2,e6=nesum(zw2, i2, 0, q-2, congruence)
	zw2,e7=nesum(zw2, i3, 0, q, congruence)
	zw2=eesubs(zw2, [i4], [2*i11+1])
	zw2,e8=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//16*zw1+1//16*zw2, union(e1,e2,e3,e4,e5,e6,e7,e8))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i1*(q+1)])
	s2=eesubs(tt, [i1], [2*i11+i1*(q-1)])
	s3=eesubs(tt, [i1], [i11*(q+1)])
	s4=eesubs(tt, [i1], [i11*(q+1)+1//2*q^2-1//2])
	s1,e1=nesum(s1, i1, 0, q-2, congruence)
	s2,e2=nesum(s2, i1, 0, q, congruence)
	zw1,e3=nesum(tt, i1, 0, q^2-2, congruence)
	zw1=zw1-s1-s2+s3+s4
	s1=eesubs(zw1, [i2], [i11])
	s2=eesubs(zw1, [i2], [i11+1//2*q-1//2])
	zw1,e4=nesum(zw1, i2, 0, q-2, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i3], [2*i11])
	zw1,e5=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	s1=eesubs(tt, [i1], [i1*(q+1)])
	s2=eesubs(tt, [i1], [2*i11+1+i1*(q-1)])
	s3=eesubs(tt, [i1], [1//2*(2*i11+1)*(q+1)])
	s4=eesubs(tt, [i1], [1//2*(2*i11+1)*(q+1)+1//2*q^2-1//2])
	s1,e6=nesum(s1, i1, 0, q-2, congruence)
	s2,e7=nesum(s2, i1, 0, q, congruence)
	zw2,e8=nesum(tt, i1, 0, q^2-2, congruence)
	zw2=zw2-s1-s2-s3-s4
	zw2,e9=nesum(zw2, i2, 0, q-2, congruence)
	zw2=eesubs(zw2, [i3], [2*i11+1])
	zw2,e10=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//8*zw1+1//8*zw2, union(e1,e2,e3,e4,e5,e6,e7,e8,e9,e10))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i11])
	s2=eesubs(tt, [i1], [i11+1//2*q-1//2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	s1=eesubs(zw1, [i2], [i11])
	s2=eesubs(zw1, [i2], [i11+1//2*q+1//2])
	s3=eesubs(zw1, [i2], [i3])
	s4=eesubs(zw1, [i2], [i4-i3])
	zw1,e2=nesum(zw1, i2, 0, q, congruence)
	zw1=zw1-s1-s2-s3-s4
	s1=eesubs(zw1, [i3], [i11])
	s2=eesubs(zw1, [i3], [i11+1//2*q+1//2])
	zw1,e3=nesum(zw1, i3, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i4], [2*i11])
	zw1,e4=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	zw2,e5=nesum(tt, i1, 0, q-2, congruence)
	s1=eesubs(zw2, [i2], [i3])
	s2=eesubs(zw2, [i2], [i4-i3])
	zw2,e6=nesum(zw2, i2, 0, q, congruence)
	zw2=zw2-s1-s2
	zw2,e7=nesum(zw2, i3, 0, q, congruence)
	zw2=eesubs(zw2, [i4], [2*i11+1])
	zw2,e8=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//16*zw1+1//16*zw2, union(e1,e2,e3,e4,e5,e6,e7,e8))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i1*(q+1)])
	s2=eesubs(tt, [i1], [2*i11+i1*(q-1)])
	s3=eesubs(tt, [i1], [i11*(q+1)])
	s4=eesubs(tt, [i1], [i11*(q+1)+1//2*q^2-1//2])
	s1,e1=nesum(s1, i1, 0, q-2, congruence)
	s2,e2=nesum(s2, i1, 0, q, congruence)
	zw1,e3=nesum(tt, i1, 0, q^2-2, congruence)
	zw1=zw1-s1-s2+s3+s4
	s1=eesubs(zw1, [i2], [i11])
	s2=eesubs(zw1, [i2], [i11+1//2*q+1//2])
	zw1,e4=nesum(zw1, i2, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i3], [2*i11])
	zw1,e5=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	s1=eesubs(tt, [i1], [i1*(q+1)])
	s2=eesubs(tt, [i1], [2*i11+1+i1*(q-1)])
	s3=eesubs(tt, [i1], [1//2*(2*i11+1)*(q+1)])
	s4=eesubs(tt, [i1], [1//2*(2*i11+1)*(q+1)+1//2*q^2-1//2])
	s1,e6=nesum(s1, i1, 0, q-2, congruence)
	s2,e7=nesum(s2, i1, 0, q, congruence)
	zw2,e8=nesum(tt, i1, 0, q^2-2, congruence)
	zw2=zw2-s1-s2-s3-s4
	zw2,e9=nesum(zw2, i2, 0, q, congruence)
	zw2=eesubs(zw2, [i3], [2*i11+1])
	zw2,e10=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//8*zw1+1//8*zw2, union(e1,e2,e3,e4,e5,e6,e7,e8,e9,e10))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i11])
	s2=eesubs(tt, [i1], [i11+1//2*q-1//2])
	zw1,e1=nesum(tt, i1, 0, q-2, congruence)
	zw1=zw1-s1-s2
	s1=eesubs(zw1, [i2], [1//2*i3*(q+1)])
	s2=eesubs(zw1, [i2], [1//2*i3*(q+1)+1//2*q^2+1//2])
	zw1,e2=nesum(zw1, i2, 0, q^2, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i3], [2*i11])
	zw1,e3=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	zw2,e4=nesum(tt, i1, 0, q-2, congruence)
	s1=eesubs(zw2, [i2], [1//2*i3*(q+1)])
	s2=eesubs(zw2, [i2], [1//2*i3*(q+1)+1//2*q^2+1//2])
	zw2,e5=nesum(zw2, i2, 0, q^2, congruence)
	zw2=zw2-s1-s2
	zw2=eesubs(zw2, [i3], [2*i11+1])
	zw2,e6=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//8*zw1+1//8*zw2, union(e1,e2,e3,e4,e5,e6))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i1*(q^2+q+1)])
	s1,e1=nesum(s1, i1, 0, q-2, congruence)
	zw1,e2=nesum(tt, i1, 0, q^3-2, congruence)
	zw1=zw1-s1
	zw1,e3=nesum(zw1, i2, 0, q-2, congruence)
	(1//6*zw1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [-i11])
	s2=eesubs(tt, [i1], [-i11+1//2*q+1//2])
	s3=eesubs(tt, [i1], [i3])
	s4=eesubs(tt, [i1], [-i4-i3])
	s5=eesubs(tt, [i1], [i2])
	s6=eesubs(tt, [i1], [-i4-i2])
	zw1,e1=nesum(tt, i1, 0, q, congruence)
	zw1=zw1-s1-s2-s3-s4-s5-s6
	s1=eesubs(zw1, [i2], [-i11])
	s2=eesubs(zw1, [i2], [-i11+1//2*q+1//2])
	s3=eesubs(zw1, [i2], [i3])
	s4=eesubs(zw1, [i2], [-i4-i3])
	zw1,e2=nesum(zw1, i2, 0, q, congruence)
	zw1=zw1-s1-s2-s3-s4
	s1=eesubs(zw1, [i3], [-i11])
	s2=eesubs(zw1, [i3], [-i11+1//2*q+1//2])
	zw1,e3=nesum(zw1, i3, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i4], [2*i11])
	zw1,e4=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	s1=eesubs(tt, [i1], [i3])
	s2=eesubs(tt, [i1], [-i4-i3])
	s3=eesubs(tt, [i1], [i2])
	s4=eesubs(tt, [i1], [-i4-i2])
	zw2,e5=nesum(tt, i1, 0, q, congruence)
	zw2=zw2-s1-s2-s3-s4
	s1=eesubs(zw2, [i2], [i3])
	s2=eesubs(zw2, [i2], [-i4-i3])
	zw2,e6=nesum(zw2, i2, 0, q, congruence)
	zw2=zw2-s1-s2
	zw2,e7=nesum(zw2, i3, 0, q, congruence)
	zw2=eesubs(zw2, [i4], [2*i11+1])
	zw2,e8=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//48*zw1+1//48*zw2, union(e1,e2,e3,e4,e5,e6,e7,e8))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [1//2*i3*(q+1)])
	s2=eesubs(tt, [i1], [1//2*i3*(q+1)+1//2*q^2+1//2])
	zw1,e1=nesum(tt, i1, 0, q^2, congruence)
	zw1=zw1-s1-s2
	s1=eesubs(zw1, [i2], [i11])
	s2=eesubs(zw1, [i2], [i11+1//2*q+1//2])
	zw1,e2=nesum(zw1, i2, 0, q, congruence)
	zw1=zw1-s1-s2
	zw1=eesubs(zw1, [i3], [2*i11])
	zw1,e3=nesum(zw1, i11, 0, 1//2*q-3//2, congruence)
	s1=eesubs(tt, [i1], [1//2*i3*(q+1)])
	s2=eesubs(tt, [i1], [1//2*i3*(q+1)+1//2*q^2+1//2])
	zw2,e4=nesum(tt, i1, 0, q^2, congruence)
	zw2=zw2-s1-s2
	zw2,e5=nesum(zw2, i2, 0, q, congruence)
	zw2=eesubs(zw2, [i3], [2*i11+1])
	zw2,e6=nesum(zw2, i11, 0, 1//2*q-3//2, congruence)
	(1//8*zw1+1//8*zw2, union(e1,e2,e3,e4,e5,e6))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [q*i2+i1*(q^2-q+1)])
	s1,e1=nesum(s1, i1, 0, q, congruence)
	zw1,e2=nesum(tt, i1, 0, q^3, congruence)
	zw1=zw1-s1
	zw1,e3=nesum(zw1, i2, 0, q-2, congruence)
	(1//6*zw1, union(e1,e2,e3))
end
]

charsums=[
function (tt::Cyclotomic)
	nesum(tt, k1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, k1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, k1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, k1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, k1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, k1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, k1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, k1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, k1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, k1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, k1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	nesum(tt, k1, 0, q-2, congruence)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 0, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	s1,e2=nesum(s1, k2, 0, q-2, congruence)
	(1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	s1,e2=nesum(s1, k2, 0, q-2, congruence)
	(1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	s1,e2=nesum(s1, k2, 0, q-2, congruence)
	(1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	s1,e2=nesum(s1, k2, 0, q-2, congruence)
	(1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	s1,e2=nesum(s1, k2, 0, q-2, congruence)
	(1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	s1,e2=nesum(s1, k2, 0, q-2, congruence)
	(1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k2, 0, q-2, congruence)
	s1,e2=nesum(s1, k1, 1, q, congruence)
	(1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k2, 0, q-2, congruence)
	s1,e2=nesum(s1, k1, 1, q, congruence)
	(1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k2, 0, q-2, congruence)
	s1,e2=nesum(s1, k1, 1, q, congruence)
	(1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k2, 0, q-2, congruence)
	s1,e2=nesum(s1, k1, 1, q, congruence)
	(1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k2, 0, q-2, congruence)
	s1,e2=nesum(s1, k1, 1, q, congruence)
	(1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k2, 0, q-2, congruence)
	s1,e2=nesum(s1, k1, 1, q, congruence)
	(1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [1//2*q-1//2])
	s2,e1=nesum(tt, k1, 1, q-2, congruence)
	s1=s2-s1
	s1,e2=nesum(s1, k2, 0, q-2, congruence)
	(1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [1//2*q-1//2])
	s2,e1=nesum(tt, k1, 1, q-2, congruence)
	s1=s2-s1
	s1,e2=nesum(s1, k2, 0, q-2, congruence)
	(1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [1//2*q-1//2])
	s2,e1=nesum(tt, k1, 1, q-2, congruence)
	s1=s2-s1
	s1,e2=nesum(s1, k2, 0, q-2, congruence)
	(1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q+1//2])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	(1//2*s2-1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q+1//2])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	(1//2*s2-1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q+1//2])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	(1//2*s2-1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q-1//2])
	s2,e2=nesum(s2, k1, 1, q-2, congruence)
	(1//4*s2-1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q-1//2])
	s2,e2=nesum(s2, k1, 1, q-2, congruence)
	(1//4*s2-1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q-1//2])
	s2,e2=nesum(s2, k1, 1, q-2, congruence)
	(1//4*s2-1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q-1//2])
	s2,e2=nesum(s2, k1, 1, q-2, congruence)
	(1//4*s2-1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q-1//2])
	s2,e2=nesum(s2, k1, 1, q-2, congruence)
	(1//2*s2-1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q-1//2])
	s2,e2=nesum(s2, k1, 1, q-2, congruence)
	(1//2*s2-1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q-1//2])
	s2,e2=nesum(s2, k1, 1, q-2, congruence)
	(1//2*s2-1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q-1//2])
	s2,e2=nesum(s2, k1, 1, q-2, congruence)
	(1//2*s2-1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q+1//2])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	(1//4*s2-1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q+1//2])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	(1//4*s2-1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q+1//2])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	(1//4*s2-1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q+1//2])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	(1//4*s2-1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q+1//2])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	(1//2*s2-1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q+1//2])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	(1//2*s2-1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q+1//2])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	(1//2*s2-1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q+1//2])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	(1//2*s2-1//2*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q-1//2])
	s2,e2=nesum(s2, k1, 1, q-2, congruence)
	(1//4*s2-1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q-1//2])
	s2,e2=nesum(s2, k1, 1, q-2, congruence)
	(1//4*s2-1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q+1//2])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	(1//4*s2-1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q+1//2])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	(1//4*s2-1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s5,e1=nesum(tt, k3, 0, q-2, congruence)
	s1=eesubs(s5, [k1,k2], [1//2*q-1//2,1//2*q-1//2])
	s2=eesubs(s5, [k1], [k2])
	s3=eesubs(s5, [k1], [-k2])
	s4=eesubs(s5, [k1], [1//2*q-1//2])
	s5,e2=nesum(s5, k1, 1, q-2, congruence)
	s5=s5-s2-s3-s4
	s5,e3=nesum(s5, k2, 1, q-2, congruence)
	(1//4*s5+1//2*s1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s5,e1=nesum(tt, k3, 0, q-2, congruence)
	s1=eesubs(s5, [k1,k2], [1//2*q-1//2,1//2*q-1//2])
	s2=eesubs(s5, [k1], [k2])
	s3=eesubs(s5, [k1], [-k2])
	s4=eesubs(s5, [k1], [1//2*q-1//2])
	s5,e2=nesum(s5, k1, 1, q-2, congruence)
	s5=s5-s2-s3-s4
	s5,e3=nesum(s5, k2, 1, q-2, congruence)
	(1//4*s5+1//2*s1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s4,e1=nesum(tt, k3, 0, q-2, congruence)
	s1=eesubs(s4, [k1,k2], [1//2*q-1//2,1//2*q-1//2])
	s2=eesubs(s4, [k1], [k2])
	s3=eesubs(s4, [k1], [-k2])
	s4,e2=nesum(s4, k1, 1, q-2, congruence)
	s4=s4-s2-s3
	s4,e3=nesum(s4, k2, 1, q-2, congruence)
	(1//8*s4+1//8*s1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s4,e1=nesum(tt, k3, 0, q-2, congruence)
	s1=eesubs(s4, [k1,k2], [1//2*q-1//2,1//2*q-1//2])
	s2=eesubs(s4, [k1], [k2])
	s3=eesubs(s4, [k1], [-k2])
	s4,e2=nesum(s4, k1, 1, q-2, congruence)
	s4=s4-s2-s3
	s4,e3=nesum(s4, k2, 1, q-2, congruence)
	(1//8*s4+1//8*s1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k3, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q-1//2])
	s2,e2=nesum(s2, k1, 1, q-2, congruence)
	s1=s2-s1
	s1,e3=nesum(s1, k2, 1, q, congruence)
	(1//4*s1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k3, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q-1//2])
	s2,e2=nesum(s2, k1, 1, q-2, congruence)
	s1=s2-s1
	s1,e3=nesum(s1, k2, 1, q, congruence)
	(1//4*s1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s4,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s4, [k1], [1//2*q^2-1//2])
	s2=eesubs(s4, [k1], [k1*(q-1)])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	s3=eesubs(s4, [k1], [k1*(q+1)])
	s3,e3=nesum(s3, k1, 1, q-2, congruence)
	s4,e4=nesum(s4, k1, 1, q^2-2, congruence)
	(1//4*s4-1//4*s2-1//4*s3+1//4*s1, union(e1,e2,e3,e4))
end,
function (tt::Cyclotomic)
	s4,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s4, [k1], [1//2*q^2-1//2])
	s2=eesubs(s4, [k1], [k1*(q-1)])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	s3=eesubs(s4, [k1], [k1*(q+1)])
	s3,e3=nesum(s3, k1, 1, q-2, congruence)
	s4,e4=nesum(s4, k1, 1, q^2-2, congruence)
	(1//4*s4-1//4*s2-1//4*s3+1//4*s1, union(e1,e2,e3,e4))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k3, 0, q-2, congruence)
	s1=eesubs(s2, [k1,k2], [1//2*q-1//2,1//2*q+1//2])
	s2,e2=nesum(s2, k1, 1, q-2, congruence)
	s2,e3=nesum(s2, k2, 1, q, congruence)
	(1//4*s2-1//4*s1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k3, 0, q-2, congruence)
	s1=eesubs(s2, [k1,k2], [1//2*q-1//2,1//2*q+1//2])
	s2,e2=nesum(s2, k1, 1, q-2, congruence)
	s2,e3=nesum(s2, k2, 1, q, congruence)
	(1//4*s2-1//4*s1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k3, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q+1//2])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	s1=s2-s1
	s1,e3=nesum(s1, k2, 1, q-2, congruence)
	(1//4*s1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k3, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q+1//2])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	s1=s2-s1
	s1,e3=nesum(s1, k2, 1, q-2, congruence)
	(1//4*s1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s5,e1=nesum(tt, k3, 0, q-2, congruence)
	s1=eesubs(s5, [k1,k2], [1//2*q+1//2,1//2*q+1//2])
	s2=eesubs(s5, [k1], [k2])
	s3=eesubs(s5, [k1], [-k2])
	s4=eesubs(s5, [k1], [1//2*q+1//2])
	s5,e2=nesum(s5, k1, 1, q, congruence)
	s5=s5-s2-s3-s4
	s5,e3=nesum(s5, k2, 1, q, congruence)
	(1//4*s5+1//2*s1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s5,e1=nesum(tt, k3, 0, q-2, congruence)
	s1=eesubs(s5, [k1,k2], [1//2*q+1//2,1//2*q+1//2])
	s2=eesubs(s5, [k1], [k2])
	s3=eesubs(s5, [k1], [-k2])
	s4=eesubs(s5, [k1], [1//2*q+1//2])
	s5,e2=nesum(s5, k1, 1, q, congruence)
	s5=s5-s2-s3-s4
	s5,e3=nesum(s5, k2, 1, q, congruence)
	(1//4*s5+1//2*s1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s4,e1=nesum(tt, k3, 0, q-2, congruence)
	s1=eesubs(s4, [k1,k2], [1//2*q+1//2,1//2*q+1//2])
	s2=eesubs(s4, [k1], [k2])
	s3=eesubs(s4, [k1], [-k2])
	s4,e2=nesum(s4, k1, 1, q, congruence)
	s4=s4-s2-s3
	s4,e3=nesum(s4, k2, 1, q, congruence)
	(1//8*s4+1//8*s1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s4,e1=nesum(tt, k3, 0, q-2, congruence)
	s1=eesubs(s4, [k1,k2], [1//2*q+1//2,1//2*q+1//2])
	s2=eesubs(s4, [k1], [k2])
	s3=eesubs(s4, [k1], [-k2])
	s4,e2=nesum(s4, k1, 1, q, congruence)
	s4=s4-s2-s3
	s4,e3=nesum(s4, k2, 1, q, congruence)
	(1//8*s4+1//8*s1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q^2+1//2])
	s2,e2=nesum(s2, k1, 1, q^2, congruence)
	(1//4*s2-1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q^2+1//2])
	s2,e2=nesum(s2, k1, 1, q^2, congruence)
	(1//4*s2-1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s7,e1=nesum(tt, k4, 0, q-2, congruence)
	s1=eesubs(s7, [k1,k2], [1//2*q-1//2,1//2*q-1//2])
	s2=eesubs(s7, [k1], [k2])
	s3=eesubs(s7, [k1], [-k2])
	s4=eesubs(s7, [k1], [k3])
	s5=eesubs(s7, [k1], [-k3])
	s6,e2=nesum(s7, k1, 1, q-2, congruence)
	s6=s6-s5-s4-s3-s2
	s2=eesubs(s6, [k2], [k3])
	s3=eesubs(s6, [k2], [-k3])
	s6,e3=nesum(s6, k2, 1, q-2, congruence)
	s6=s6-s2-s3+s1
	s2=eesubs(s6, [k3], [1//2*q-1//2])
	s6,e4=nesum(s6, k3, 1, q-2, congruence)
	zw1=s6-s2
	s1=eesubs(s7, [k1], [k2])
	s2=eesubs(s7, [k1], [-k2])
	s3=eesubs(s7, [k1], [1//2*q-1//2])
	s4,e5=nesum(s7, k1, 1, q-2, congruence)
	s4=s4-s3-s2-s1
	s1=eesubs(s4, [k2], [1//2*q-1//2])
	s4,e6=nesum(s4, k2, 1, q-2, congruence)
	s4=s4-s1
	zw2=eesubs(s4, [k3], [1//2*q-1//2])
	(1//48*zw1+1//48*zw2, union(e1,e2,e3,e4,e5,e6))
end,
function (tt::Cyclotomic)
	s5,e1=nesum(tt, k4, 0, q-2, congruence)
	s1=eesubs(s5, [k1,k2], [1//2*q-1//2,1//2*q-1//2])
	s2=eesubs(s5, [k1], [k2])
	s3=eesubs(s5, [k1], [-k2])
	s4,e2=nesum(s5, k1, 1, q-2, congruence)
	s4=s4-s3-s2
	s4,e3=nesum(s4, k2, 1, q-2, congruence)
	s4=s4+s1
	s2=eesubs(s4, [k3], [1//2*q+1//2])
	s4,e4=nesum(s4, k3, 1, q, congruence)
	zw1=s4-s2
	s1=eesubs(s5, [k1], [k2])
	s2=eesubs(s5, [k1], [-k2])
	s3=eesubs(s5, [k1], [1//2*q-1//2])
	s4,e5=nesum(s5, k1, 1, q-2, congruence)
	s4=s4-s3-s2-s1
	s1=eesubs(s4, [k2], [1//2*q-1//2])
	s4,e6=nesum(s4, k2, 1, q-2, congruence)
	s4=s4-s1
	zw2=eesubs(s4, [k3], [1//2*q+1//2])
	(1//16*zw1+1//16*zw2, union(e1,e2,e3,e4,e5,e6))
end,
function (tt::Cyclotomic)
	s4,e1=nesum(tt, k3, 0, q-2, congruence)
	s1=eesubs(s4, [k1], [1//2*q^2-1//2])
	s2=eesubs(s4, [k1], [k1*(q-1)])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	s3=eesubs(s4, [k1], [k1*(q+1)])
	s3,e3=nesum(s3, k1, 1, q-2, congruence)
	s4,e4=nesum(s4, k1, 1, q^2-2, congruence)
	s4=s4-s2-s3+s1
	s4,e5=nesum(s4, k2, 1, q-2, congruence)
	(1//8*s4, union(e1,e2,e3,e4,e5))
end,
function (tt::Cyclotomic)
	s5,e1=nesum(tt, k4, 0, q-2, congruence)
	s1=eesubs(s5, [k1,k2], [1//2*q-1//2,1//2*q+1//2])
	s2,e2=nesum(s5, k1, 1, q-2, congruence)
	s3=eesubs(s2, [k2], [k3])
	s4=eesubs(s2, [k2], [-k3])
	s2,e3=nesum(s2, k2, 1, q, congruence)
	s2=s2-s3-s4-s1
	s3=eesubs(s2, [k3], [1//2*q+1//2])
	s2,e4=nesum(s2, k3, 1, q, congruence)
	zw1=s2-s3
	s1=eesubs(s5, [k1], [1//2*q-1//2])
	s2,e5=nesum(s5, k1, 1, q-2, congruence)
	s1=s2-s1
	s2=eesubs(s1, [k2], [1//2*q+1//2])
	s1,e6=nesum(s1, k2, 1, q, congruence)
	s1=s1-s2
	zw2=eesubs(s1, [k3], [1//2*q+1//2])
	(1//16*zw1+1//16*zw2, union(e1,e2,e3,e4,e5,e6))
end,
function (tt::Cyclotomic)
	s4,e1=nesum(tt, k3, 0, q-2, congruence)
	s1=eesubs(s4, [k1], [1//2*q^2-1//2])
	s2=eesubs(s4, [k1], [k1*(q-1)])
	s2,e2=nesum(s2, k1, 1, q, congruence)
	s3=eesubs(s4, [k1], [k1*(q+1)])
	s3,e3=nesum(s3, k1, 1, q-2, congruence)
	s4,e4=nesum(s4, k1, 1, q^2-2, congruence)
	s4=s4-s2-s3+s1
	s4,e5=nesum(s4, k2, 1, q, congruence)
	(1//8*s4, union(e1,e2,e3,e4,e5))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k3, 0, q-2, congruence)
	s1,e2=nesum(s2, k1, 1, q-2, congruence)
	s2=eesubs(s1, [k2], [1//2*q^2+1//2])
	s1,e3=nesum(s1, k2, 1, q^2, congruence)
	(1//8*s1-1//8*s2, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [(q^2+q+1)*k1])
	s1,e2=nesum(s1, k1, 0, q-2, congruence)
	s2,e3=nesum(s2, k1, 0, q^3-2, congruence)
	(1//6*s2-1//6*s1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s7,e1=nesum(tt, k4, 0, q-2, congruence)
	s1=eesubs(s7, [k1,k2], [1//2*q+1//2,1//2*q+1//2])
	s2=eesubs(s7, [k1], [k2])
	s3=eesubs(s7, [k1], [-k2])
	s4=eesubs(s7, [k1], [k3])
	s5=eesubs(s7, [k1], [-k3])
	s6,e2=nesum(s7, k1, 1, q, congruence)
	s6=s6-s5-s4-s3-s2
	s2=eesubs(s6, [k2], [k3])
	s3=eesubs(s6, [k2], [-k3])
	s6,e3=nesum(s6, k2, 1, q, congruence)
	s6=s6-s2-s3+s1
	s2=eesubs(s6, [k3], [1//2*q+1//2])
	s6,e4=nesum(s6, k3, 1, q, congruence)
	zw1=s6-s2
	s1=eesubs(s7, [k1], [k2])
	s2=eesubs(s7, [k1], [-k2])
	s3=eesubs(s7, [k1], [1//2*q+1//2])
	s4,e5=nesum(s7, k1, 1, q, congruence)
	s4=s4-s3-s2-s1
	s1=eesubs(s4, [k2], [1//2*q+1//2])
	s4,e6=nesum(s4, k2, 1, q, congruence)
	s4=s4-s1
	zw2=eesubs(s4, [k3], [1//2*q+1//2])
	(1//48*zw1+1//48*zw2, union(e1,e2,e3,e4,e5,e6))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k3, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [1//2*q^2+1//2])
	s2,e2=nesum(s2, k1, 1, q^2, congruence)
	s2=s2-s1
	s2,e3=nesum(s2, k2, 1, q, congruence)
	(1//8*s2, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s2,e1=nesum(tt, k2, 0, q-2, congruence)
	s1=eesubs(s2, [k1], [(q^2-q+1)*k1])
	s1,e2=nesum(s1, k1, 0, q, congruence)
	s2,e3=nesum(s2, k1, 0, q^3, congruence)
	(1//6*s2-1//6*s1, union(e1,e2,e3))
end
]

classparams=[
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((2*i1-i2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((2*i1-i2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((2*i1-i2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q-1)], [ParameterException((2*i1-i2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q-1)], [ParameterException((2*i1-i2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q-1)], [ParameterException((2*i1-i2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q+1)], [ParameterException((i1-i2)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q+1)], [ParameterException((i1-i2)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q+1)], [ParameterException((i1-i2)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q+1)], [ParameterException((i1-i2)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q+1)], [ParameterException((i1-i2)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q+1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q+1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q+1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1), Parameter(i3, q-1)], [ParameterException((i2-i3)*1//((q-1)*1//2)),
ParameterException((i1-i3)*1//((q-1)*1//2)), ParameterException((i1-i2)*1//(q-1)), ParameterException((i1+i2-2*i3)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1), Parameter(i3, q-1)], [ParameterException((i2-i3)*1//((q-1)*1//2)),
ParameterException((i1-i3)*1//((q-1)*1//2)), ParameterException((i1-i2)*1//(q-1)), ParameterException((i1+i2-2*i3)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1), Parameter(i3, q-1)], [ParameterException((2*i2-i3)*1//(q-1)),
ParameterException((2*i1-i3)*1//(q-1)), ParameterException((i1-i2)*1//(q-1)), ParameterException((i1+i2-i3)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1), Parameter(i3, q-1)], [ParameterException((2*i2-i3)*1//(q-1)),
ParameterException((2*i1-i3)*1//(q-1)), ParameterException((i1-i2)*1//(q-1)), ParameterException((i1+i2-i3)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q+1), Parameter(i3, q-1)], [ParameterException((i2-i3)*1//((q+1)*1//2)),
ParameterException((i1-i3)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q+1), Parameter(i3, q-1)], [ParameterException((i2-i3)*1//((q+1)*1//2)),
ParameterException((i1-i3)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^2-1), Parameter(i2, q-1)], [ParameterException((i1)*1//(q+1)), ParameterException((i1-2*i2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^2-1), Parameter(i2, q-1)], [ParameterException((i1)*1//(q+1)), ParameterException((i1-2*i2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q+1), Parameter(i3, q-1)], [ParameterException((2*i2-i3)*1//(q+1)),
ParameterException((2*i1-i3)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q+1), Parameter(i3, q-1)], [ParameterException((2*i2-i3)*1//(q+1)),
ParameterException((2*i1-i3)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q-1), Parameter(i3, q-1)], [ParameterException((2*i2-i3)*1//(q-1)),
ParameterException((2*i1-i3)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q-1), Parameter(i3, q-1)], [ParameterException((2*i2-i3)*1//(q-1)),
ParameterException((2*i1-i3)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q+1), Parameter(i3, q-1)], [ParameterException((2*i2-i3)*1//(q+1)),
ParameterException((2*i1-i3)*1//(q+1)), ParameterException((i1-i2)*1//(q+1)), ParameterException((i1+i2-2*i3)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q+1), Parameter(i3, q-1)], [ParameterException((2*i2-i3)*1//(q+1)),
ParameterException((2*i1-i3)*1//(q+1)), ParameterException((i1-i2)*1//(q+1)), ParameterException((i1+i2-2*i3)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^2+1), Parameter(i2, q-1)], [ParameterException((2*i1-2*(q+1)*i2)*1//(q^2+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^2+1), Parameter(i2, q-1)], [ParameterException((2*i1-2*(q+1)*i2)*1//(q^2+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q+1), Parameter(i3, q-1)], [ParameterException((2*i2+i3)*1//(q+1)),
ParameterException((2*i1+i3)*1//(q+1)), ParameterException((i1-i2)*1//(q+1)), ParameterException((i1+i2+i3)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q+1), Parameter(i3, q-1)], [ParameterException((2*i2+i3)*1//(q+1)),
ParameterException((2*i1+i3)*1//(q+1)), ParameterException((i1-i2)*1//(q+1)), ParameterException((i1+i2+i3)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1), Parameter(i3, q-1), Parameter(i4, q-1)], [ParameterException((2*i3-i4)*1//(q-1)), ParameterException((2*i2-i4)*1//(q-1)), ParameterException((2*i1-i4)*1//(q-1)),
ParameterException((i2-i3)*1//(q-1)), ParameterException((i2+i3-i4)*1//(q-1)),
ParameterException((i1-i3)*1//(q-1)), ParameterException((i1+i3-i4)*1//(q-1)),
ParameterException((i1-i2)*1//(q-1)), ParameterException((i1+i2-i4)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1), Parameter(i3, q+1), Parameter(i4, q-1)], [ParameterException((2*i3-i4)*1//(q+1)), ParameterException((2*i2-i4)*1//(q-1)), ParameterException((2*i1-i4)*1//(q-1)),
ParameterException((i1-i2)*1//(q-1)), ParameterException((i1+i2-i4)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^2-1), Parameter(i2, q-1), Parameter(i3, q-1)], [ParameterException((2*i2-i3)*1//(q-1)),
ParameterException((i1)*1//(q+1)), ParameterException((i1-i3)*1//(q-1)),
ParameterException((2*i1-(q+1)*i3)*1//(q^2-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q+1), Parameter(i3, q+1), Parameter(i4, q-1)], [ParameterException((2*i3-i4)*1//(q+1)), ParameterException((2*i2-i4)*1//(q+1)), ParameterException((2*i1-i4)*1//(q-1)),
ParameterException((i2-i3)*1//(q+1)), ParameterException((i2+i3-i4)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^2-1), Parameter(i2, q+1), Parameter(i3, q-1)], [ParameterException((2*i2-i3)*1//(q+1)),
ParameterException((i1)*1//(q+1)), ParameterException((i1-i3)*1//(q-1)),
ParameterException((2*i1-(q+1)*i3)*1//(q^2-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q^2+1), Parameter(i3, q-1)], [ParameterException((2*i1-i3)*1//(q-1)),
ParameterException((2*i2-(q+1)*i3)*1//(q^2+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^3-1), Parameter(i2, q-1)], [ParameterException((i1)*1//(q^2+q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q+1), Parameter(i3, q+1), Parameter(i4, q-1)], [ParameterException((2*i3+i4)*1//(q+1)), ParameterException((2*i2+i4)*1//(q+1)), ParameterException((2*i1+i4)*1//(q+1)),
ParameterException((i2-i3)*1//(q+1)), ParameterException((i2+i3+i4)*1//(q+1)),
ParameterException((i1-i3)*1//(q+1)), ParameterException((i1+i3+i4)*1//(q+1)),
ParameterException((i1-i2)*1//(q+1)), ParameterException((i1+i2+i4)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^2+1), Parameter(i2, q+1), Parameter(i3, q-1)], [ParameterException((2*i2-i3)*1//(q+1)),
ParameterException((2*i1-(q+1)*i3)*1//(q^2+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^3+1), Parameter(i2, q-1)], [ParameterException((i1-q*i2)*1//(q^2-q+1))], ParameterSubstitution{QQPolyRingElem}[])
]

charparams=[
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1), Parameter(k3, q-1)], [ParameterException((k2)*1//(q-1)), ParameterException((k1)*1//((q-1)*1//2)),
ParameterException((k1-k2)*1//(q-1)), ParameterException((k1+k2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1), Parameter(k3, q-1)], [ParameterException((k1)*1//((q-1)*1//2)),
ParameterException((k1-k2)*1//(q-1)), ParameterException((k1+k2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1), Parameter(k3, q-1)], [ParameterException((k2)*1//(q-1)), ParameterException((k1)*1//(q-1)),
ParameterException((k1-k2)*1//(q-1)), ParameterException((k1+k2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1), Parameter(k3, q-1)], [ParameterException((k2)*1//(q-1)), ParameterException((k1)*1//(q-1)),
ParameterException((k1-k2)*1//(q-1)), ParameterException((k1+k2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q+1), Parameter(k3, q-1)], [ParameterException((k2)*1//(q+1)), ParameterException((k1)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q+1), Parameter(k3, q-1)], [ParameterException((k2)*1//(q+1)), ParameterException((k1)*1//((q-1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q^2-1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q-1)), ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q^2-1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q-1)), ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q+1), Parameter(k3, q-1)], [ParameterException(((q+1)*k1-(q-1)*k2)*1//(q^2-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q+1), Parameter(k3, q-1)], [ParameterException(((q+1)*k1-(q-1)*k2)*1//(q^2-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1), Parameter(k3, q-1)], [ParameterException((k2)*1//(q-1)), ParameterException((k1)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1), Parameter(k3, q-1)], [ParameterException((k2)*1//(q-1)), ParameterException((k1)*1//((q+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q+1), Parameter(k3, q-1)], [ParameterException((k2)*1//(q+1)), ParameterException((k1)*1//((q+1)*1//2)),
ParameterException((k1-k2)*1//(q+1)), ParameterException((k1+k2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q+1), Parameter(k3, q-1)], [ParameterException((k2)*1//(q+1)), ParameterException((k1)*1//((q+1)*1//2)),
ParameterException((k1-k2)*1//(q+1)), ParameterException((k1+k2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q+1), Parameter(k3, q-1)], [ParameterException((k2)*1//(q+1)), ParameterException((k1)*1//(q+1)),
ParameterException((k1-k2)*1//(q+1)), ParameterException((k1+k2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q+1), Parameter(k3, q-1)], [ParameterException((k2)*1//(q+1)), ParameterException((k1)*1//(q+1)),
ParameterException((k1-k2)*1//(q+1)), ParameterException((k1+k2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q^2+1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q^2+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q^2+1), Parameter(k2, q-1)], [ParameterException((k1)*1//((q^2+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1), Parameter(k3, q-1), Parameter(k4, q-1)], [ParameterException((k3)*1//(q-1)), ParameterException((k2)*1//(q-1)), ParameterException((k1)*1//(q-1)),
ParameterException((k2-k3)*1//(q-1)), ParameterException((k2+k3)*1//(q-1)),
ParameterException((k1-k2)*1//(q-1)), ParameterException((k1+k2)*1//(q-1)),
ParameterException((k1-k3)*1//(q-1)), ParameterException((k1+k3)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1), Parameter(k3, q+1), Parameter(k4, q-1)], [ParameterException((k3)*1//(q+1)), ParameterException((k2)*1//(q-1)), ParameterException((k1)*1//(q-1)),
ParameterException((k1-k2)*1//(q-1)), ParameterException((k1+k2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q^2-1), Parameter(k2, q-1), Parameter(k3, q-1)], [ParameterException((k1)*1//(q-1)), ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q+1), Parameter(k3, q+1), Parameter(k4, q-1)], [ParameterException((k3)*1//(q+1)), ParameterException((k2)*1//(q+1)), ParameterException((k1)*1//(q-1)),
ParameterException((k2-k3)*1//(q+1)), ParameterException((k2+k3)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q^2-1), Parameter(k2, q+1), Parameter(k3, q-1)], [ParameterException((k1)*1//(q-1)), ParameterException((k1)*1//(q+1)),
ParameterException((k2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q^2+1), Parameter(k3, q-1)], [ParameterException((k1)*1//(q-1)), ParameterException((k2)*1//((q^2+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q^3-1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q^2+q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q+1), Parameter(k3, q+1), Parameter(k4, q-1)], [ParameterException((k3)*1//(q+1)), ParameterException((k2)*1//(q+1)), ParameterException((k1)*1//(q+1)),
ParameterException((k2-k3)*1//(q+1)), ParameterException((k2+k3)*1//(q+1)),
ParameterException((k1-k2)*1//(q+1)), ParameterException((k1+k2)*1//(q+1)),
ParameterException((k1-k3)*1//(q+1)), ParameterException((k1+k3)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q^2+1), Parameter(k2, q+1), Parameter(k3, q-1)], [ParameterException((k2)*1//(q+1)), ParameterException((k1)*1//((q^2+1)*1//2))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q^3+1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q^2-q+1))], ParameterSubstitution{QQPolyRingElem}[])
]

classparamindex=var_index.([i1,i2,i3,i4])
charparamindex=var_index.([k1,k2,k3,k4])
congruence=R.((1,2))

information = "Information about the generic character table of \$CSp_6(q)\$, \$q\$ odd

- CHEVIE-name of the table: ``CSp6.1``

- The computation of this table is explained in:
  {\\sc F.Lübeck}, Charaktertafeln für die Gruppen
  \$CSp_6(q)\$ mit ungeradem \$q\$ und \$Sp_6(q)\$ mit geradem \$q\$,
  Dissertation, Heidelberg (1993)

- This table is very big. The best way to work with it
  is to produce one time a file in ``Maple-internal-format``
  (in a new cheviem-session say:
> GenCharTab(``CSp6.1``);save ``CSp6_1.m``;quit;
  and ask your system-administrator to copy  the file
  CSp6_1.m into the CHEVIE-directory tables/C3/CSp6_1.m).
  Now you can read in this table with the CHEVIE-command
> GenCharTab(``CSp6_1.m``);
  This is much faster and uses much less memory.

- The first twelve character types contain the unipotent characters.
  Specialize  the parameter kK1 to a multiple of q-1 e.g., kK1=0.
  If you are *only* interested in the unipotent characters, you can
  use the table ``uniCSp6.1``, which allows faster calculations.
"

TABLE=CharTable(order,ExtendableMatrix(permutedims(table)),classinfo,classlength,charinfo,chardegree,
	classsums,charsums,classparamindex,charparamindex,classparams,charparams,congruence,R,S,information)
