using ..GenericCharacterTables
import ..GenericCharacterTables: Cyclotomic, Parameters, Parameter, ParameterException, ParameterSubstitution, ExtendableMatrix, CharTable
using Oscar
R, q = polynomial_ring(QQ, "q")
Q = fraction_field(R)
S = UniversalPolynomialRing(Q, cached=false)
i1,i2,i3,k1,k2,k3, _...=gens(S, ["i1", "i2", "i3", "k1", "k2", "k3", "i11", "i21", "i31", "k11", "k21", "k31", "i12", "i22", "i32", "k12", "k22", "k32", "i13", "i23", "i33", "k13", "k23", "k33", "i1t1", "i2t1", "i3t1", "k1t1", "k2t1", "k3t1", "i1t2", "i2t2", "i3t2", "k1t2", "k2t2", "k3t2"])

order = q^9*(q^6-1)*(q^4-1)*(q^2-1)
table = Cyclotomic{QQPolyRingElem}[[
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0))] [
	(1//2*q^5+1//2*q^4+q^3+1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^4+1//2*q^3+1//2*q^2+1//2*q)*e2p(S(0)),
	(q^3+1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^3+1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q-1//2*q^2)*e2p(S(0)),
	(q^2+1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(q^2+1//2*q^3+1//2*q+1)*e2p(S(0)),
	(1//2*q^2+1//2*q+1)*e2p(S(0)),
	(1//2*q^2+1//2*q+1)*e2p(S(0)),
	(1//2*q+1)*e2p(S(0)),
	(1//2*q+1)*e2p(S(0)),
	(1-1//2*q)*e2p(S(0)),
	(1//2*q^3+1//2*q)*e2p(S(0)),
	(1//2*q-1//2*q^2)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(q^2+q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(2*q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q+2)*e2p(S(0)),
	(2)*e2p(S(0)),
	(q+2)*e2p(S(0)),
	(2)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(3)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0))] [
	(1//2*q^5-1//2*q^4+q^3-1//2*q^2+1//2*q)*e2p(S(0)),
	(-1//2*q^4-1//2*q^2+1//2*q^3+1//2*q)*e2p(S(0)),
	(q^3-1//2*q^2+1//2*q)*e2p(S(0)),
	(-1//2*q^2+1//2*q^3+1//2*q)*e2p(S(0)),
	(1//2*q-1//2*q^2)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q-1//2*q^2)*e2p(S(0)),
	(1//2*q-q^2)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q^3+1//2*q)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q-1//2*q^2)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-q^2+1//2*q^3+1//2*q-1)*e2p(S(0)),
	(-1//2*q^2+1//2*q-1)*e2p(S(0)),
	(-1//2*q^2+1//2*q-1)*e2p(S(0)),
	(1//2*q-1)*e2p(S(0)),
	(1//2*q-1)*e2p(S(0)),
	(-1-1//2*q)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-q^2+q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(2*q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-2)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-2)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//2*q^5+1//2*q^4+1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^4+1//2*q^3+1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^3+1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q-1//2*q^2)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(q^2+1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q^3+1//2*q+1)*e2p(S(0)),
	(-1//2*q^2+1//2*q+1)*e2p(S(0)),
	(1//2*q^2+1//2*q+1)*e2p(S(0)),
	(1//2*q+1)*e2p(S(0)),
	(1-1//2*q)*e2p(S(0)),
	(1//2*q+1)*e2p(S(0)),
	(q^2+1//2*q^3+1//2*q)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(2)*e2p(S(0)),
	(2)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(2)*e2p(S(0)),
	(2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(-1//2*q^2+1//2*q+1//2*q^5-1//2*q^4)*e2p(S(0)),
	(-1//2*q^4-1//2*q^2+1//2*q^3+1//2*q)*e2p(S(0)),
	(1//2*q-1//2*q^2)*e2p(S(0)),
	(-1//2*q^2+1//2*q^3+1//2*q)*e2p(S(0)),
	(1//2*q-1//2*q^2)*e2p(S(0)),
	(1//2*q-1//2*q^2)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q-q^2)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(-q^2+1//2*q^3+1//2*q)*e2p(S(0)),
	(1//2*q-1//2*q^2)*e2p(S(0)),
	(1//2*q-1//2*q^2)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(-1+1//2*q^3+1//2*q)*e2p(S(0)),
	(1//2*q^2-1+1//2*q)*e2p(S(0)),
	(-1//2*q^2+1//2*q-1)*e2p(S(0)),
	(1//2*q-1)*e2p(S(0)),
	(-1-1//2*q)*e2p(S(0)),
	(1//2*q-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(1)*e2p(S(0))] [
	(q^6+q^4+q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^4+q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3+q^2+q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^3+q^2-q)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2+q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^2-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^2+q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^2-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q+2)*e2p(S(0)),
	(2)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-q+2)*e2p(S(0)),
	(2)*e2p(S(0)),
	(3)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(3)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^7+q^5+q^3)*e2p(S(0)),
	(q^5+q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3+q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3-q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(-q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3+q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3-q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2+q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-q^2+q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q+2)*e2p(S(0)),
	(2)*e2p(S(0)),
	(2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q-2)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(2*q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(3)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-3)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//2*q^8+1//2*q^7+q^6+1//2*q^5+1//2*q^4)*e2p(S(0)),
	(1//2*q^4+1//2*q^6)*e2p(S(0)),
	(1//2*q^5+1//2*q^4)*e2p(S(0)),
	(1//2*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//2*q^3)*e2p(S(0)),
	(-1//2*q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4+q^2+1//2*q^3+1//2*q)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(-1//2*q^3-1//2*q)*e2p(S(0)),
	(-1//2*q^2-1//2*q)*e2p(S(0)),
	(1//2*q^2-1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(q^3+q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2+2*q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(3)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0))] [
	(1//2*q^8+1//2*q^7+1//2*q^5+1//2*q^4)*e2p(S(0)),
	(-1//2*q^6+1//2*q^4)*e2p(S(0)),
	(1//2*q^5+1//2*q^4)*e2p(S(0)),
	(1//2*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//2*q^3)*e2p(S(0)),
	(1//2*q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4+1//2*q^3+1//2*q)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q-1//2*q^2)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-q^2-1//2*q^3-1//2*q)*e2p(S(0)),
	(-1//2*q^2-1//2*q)*e2p(S(0)),
	(-1//2*q^2-1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(2*q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(2)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(-1//2*q^7+q^6-1//2*q^5+1//2*q^4+1//2*q^8)*e2p(S(0)),
	(1//2*q^4+1//2*q^6)*e2p(S(0)),
	(-1//2*q^5+1//2*q^4)*e2p(S(0)),
	(1//2*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1//2*q^3)*e2p(S(0)),
	(1//2*q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//2*q^3+1//2*q)*e2p(S(0)),
	(1//2*q-1//2*q^2)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(q^4+q^2-1//2*q^3-1//2*q)*e2p(S(0)),
	(1//2*q^2-1//2*q)*e2p(S(0)),
	(1//2*q^2-1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^3+q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2-2*q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//2*q^8-1//2*q^7-1//2*q^5+1//2*q^4)*e2p(S(0)),
	(-1//2*q^6+1//2*q^4)*e2p(S(0)),
	(-1//2*q^5+1//2*q^4)*e2p(S(0)),
	(1//2*q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1//2*q^3)*e2p(S(0)),
	(-1//2*q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^2+1//2*q^3+1//2*q)*e2p(S(0)),
	(1//2*q-1//2*q^2)*e2p(S(0)),
	(1//2*q-1//2*q^2)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(q^4-1//2*q^3-1//2*q)*e2p(S(0)),
	(1//2*q^2-1//2*q)*e2p(S(0)),
	(-1//2*q^2-1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-2*q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(2)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0))] [
	(q^9)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0))] [
	(q^5+q^4+q^3+q^2+q+1)*e2p(S(0)),
	(q^4+q^3+q^2+q+1)*e2p(S(0)),
	(q^3+q+q^2+1)*e2p(S(0)),
	(q^3+q+q^2+1)*e2p(S(0)),
	(q^2+q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(q^2+q+1)*e2p(S(0)),
	(q^2+q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q^3+q+q^2+1,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q+1,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q^2+q+1,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q+1,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+1,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+1,
	(q^3+q+q^2+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(q^2+q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^2+q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q+1,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q+1,
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+1,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+1,
	(q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q+1+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+1+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q+1,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+1,
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i3*k1)*S(1//(q-1)))+e2p((-i3*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//2*q^8+3//2*q^7+2*q^6+2*q^5+2*q^4+2*q^3+3//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^6+q^4+q^5+3//2*q^3+3//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^5+2*q^3+3//2*q^4+3//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^4+3//2*q^3+3//2*q^2+1//2*q)*e2p(S(0)),
	(q^3+3//2*q^2+1//2*q)*e2p(S(0)),
	(3//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(q^2+1//2*q^3+1//2*q)*e2p(S(0)),
	(1//2*q-1//2*q^3)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1)*S(1//(q-1)))*q^3+1//2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((-i1*k1)*S(1//(q-1)))*q^3+1//2*q*e2p((-i1*k1)*S(1//(q-1)))+q^4+2*q^2+2*q^3+2*q+1,
	1//2*e2p((i1*k1)*S(1//(q-1)))*q^2+1//2*q*e2p((i1*k1)*S(1//(q-1)))+1//2*e2p((-i1*k1)*S(1//(q-1)))*q^2+1//2*q*e2p((-i1*k1)*S(1//(q-1)))+q^2+2*q+1,
	1//2*e2p((i1*k1)*S(1//(q-1)))*q^2+1//2*q*e2p((i1*k1)*S(1//(q-1)))+1//2*e2p((-i1*k1)*S(1//(q-1)))*q^2+1//2*q*e2p((-i1*k1)*S(1//(q-1)))+q^2+2*q+1,
	1//2*q*e2p((i1*k1)*S(1//(q-1)))+1//2*q*e2p((-i1*k1)*S(1//(q-1)))+2*q+1,
	1//2*q*e2p((i1*k1)*S(1//(q-1)))+1//2*q*e2p((-i1*k1)*S(1//(q-1)))+1,
	-1//2*q*e2p((i1*k1)*S(1//(q-1)))-1//2*q*e2p((-i1*k1)*S(1//(q-1)))+1,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^3+2*e2p((i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^3+2*e2p((-i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q^2+2*q+1,
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q+1,
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q+1,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+1,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+2*q+2+e2p((i2*k1)*S(1//(q-1)))*q+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1)))*q+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+2+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	2*q*e2p((i1*k1)*S(1//(q-1)))+2*e2p((i1*k1)*S(1//(q-1)))+2*q*e2p((-i1*k1)*S(1//(q-1)))+2*e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))*q+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1)))*q+e2p((-i2*k1)*S(1//(q-1))),
	2*e2p((i1*k1)*S(1//(q-1)))+2*e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((i1*k1)*S(1//(q-1)))+2*e2p((-i1*k1)*S(1//(q-1)))+2*e2p((i3*k1)*S(1//(q-1)))+2*e2p((-i3*k1)*S(1//(q-1)))+2*e2p((i2*k1)*S(1//(q-1)))+2*e2p((-i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//2*q^8+1//2*q^7+q^6+q^5+q^4+q^3+1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^6+q^4+q^5+3//2*q^3+1//2*q^2+1//2*q)*e2p(S(0)),
	(-1//2*q^5+q^3+1//2*q^4+1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^4+3//2*q^3+1//2*q^2+1//2*q)*e2p(S(0)),
	(q^3+1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q-1//2*q^2)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q-1//2*q^3)*e2p(S(0)),
	(q^2+1//2*q^3+1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	1//2*e2p((i1*k1)*S(1//(q-1)))*q^3+1//2*q*e2p((i1*k1)*S(1//(q-1)))+1//2*e2p((-i1*k1)*S(1//(q-1)))*q^3+1//2*q*e2p((-i1*k1)*S(1//(q-1)))+q^3+q+q^2+1,
	1//2*q*e2p((i1*k1)*S(1//(q-1)))-1//2*e2p((i1*k1)*S(1//(q-1)))*q^2+1//2*q*e2p((-i1*k1)*S(1//(q-1)))-1//2*e2p((-i1*k1)*S(1//(q-1)))*q^2+q+1,
	1//2*e2p((i1*k1)*S(1//(q-1)))*q^2+1//2*q*e2p((i1*k1)*S(1//(q-1)))+1//2*e2p((-i1*k1)*S(1//(q-1)))*q^2+1//2*q*e2p((-i1*k1)*S(1//(q-1)))+q^2+q+1,
	1//2*q*e2p((i1*k1)*S(1//(q-1)))+1//2*q*e2p((-i1*k1)*S(1//(q-1)))+q+1,
	-1//2*q*e2p((i1*k1)*S(1//(q-1)))-1//2*q*e2p((-i1*k1)*S(1//(q-1)))+1,
	1//2*q*e2p((i1*k1)*S(1//(q-1)))+1//2*q*e2p((-i1*k1)*S(1//(q-1)))+1,
	(q^4+q^2+q^3+q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^3+e2p((i1*k1)*S(1//(q-1)))*q^2+q*e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^3+e2p((-i1*k1)*S(1//(q-1)))*q^2+q*e2p((-i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q^2+q,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(-q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q+1+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+1+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))*q+e2p((-i2*k1)*S(1//(q-1)))*q,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+q+1,
	(1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i2*k1)*S(1//(q-1)))-e2p((-i2*k1)*S(1//(q-1))),
	-e2p((i2*k1)*S(1//(q-1)))-e2p((-i2*k1)*S(1//(q-1))),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i3*k1)*S(1//(q-1)))+e2p((-i3*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	-e2p((i2*k1)*S(1//(q-1)))-e2p((-i2*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//2*q^8+1//2*q^7+q^6+q^5+q^4+q^3+1//2*q^2+1//2*q)*e2p(S(0)),
	(-1//2*q^6+1//2*q^3+1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^5+q^3+3//2*q^4+1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^4+1//2*q^3+1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(3//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q-q^2-1//2*q^3)*e2p(S(0)),
	(1//2*q^3+1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	1//2*e2p((i1*k1)*S(1//(q-1)))*q^3+1//2*q*e2p((i1*k1)*S(1//(q-1)))+1//2*e2p((-i1*k1)*S(1//(q-1)))*q^3+1//2*q*e2p((-i1*k1)*S(1//(q-1)))+q^4+q^2+q^3+q,
	1//2*e2p((i1*k1)*S(1//(q-1)))*q^2+1//2*q*e2p((i1*k1)*S(1//(q-1)))+1//2*e2p((-i1*k1)*S(1//(q-1)))*q^2+1//2*q*e2p((-i1*k1)*S(1//(q-1)))+q^2+q,
	1//2*q*e2p((i1*k1)*S(1//(q-1)))-1//2*e2p((i1*k1)*S(1//(q-1)))*q^2+1//2*q*e2p((-i1*k1)*S(1//(q-1)))-1//2*e2p((-i1*k1)*S(1//(q-1)))*q^2+q,
	1//2*q*e2p((i1*k1)*S(1//(q-1)))+1//2*q*e2p((-i1*k1)*S(1//(q-1)))+q,
	-1//2*q*e2p((i1*k1)*S(1//(q-1)))-1//2*q*e2p((-i1*k1)*S(1//(q-1))),
	1//2*q*e2p((i1*k1)*S(1//(q-1)))+1//2*q*e2p((-i1*k1)*S(1//(q-1))),
	(-q^2-q^3-q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-q^2-q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^2+q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^2+q*e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+q*e2p((-i1*k1)*S(1//(q-1)))+q+1,
	q*e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+q+1,
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+q+1+e2p((i2*k1)*S(1//(q-1)))*q+e2p((-i2*k1)*S(1//(q-1)))*q,
	(1)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))-q-1,
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))-1,
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	-q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1)))*q+e2p((-i2*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i3*k1)*S(1//(q-1)))+e2p((-i3*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))-e2p((i2*k1)*S(1//(q-1)))-e2p((-i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//2*q^8-1//2*q^7-1//2*q^2+1//2*q)*e2p(S(0)),
	(-1//2*q^6-1//2*q^2+1//2*q+1//2*q^3)*e2p(S(0)),
	(1//2*q-1//2*q^2-1//2*q^5+1//2*q^4)*e2p(S(0)),
	(1//2*q^4+1//2*q-1//2*q^2+1//2*q^3)*e2p(S(0)),
	(1//2*q-1//2*q^2)*e2p(S(0)),
	(1//2*q-1//2*q^2)*e2p(S(0)),
	(1//2*q^2+1//2*q)*e2p(S(0)),
	(1//2*q^3+1//2*q)*e2p(S(0)),
	(1//2*q-q^2-1//2*q^3)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((i1*k1)*S(1//(q-1)))*q^3+1//2*q*e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))*q^2+1//2*e2p((-i1*k1)*S(1//(q-1)))*q^3+1//2*q*e2p((-i1*k1)*S(1//(q-1))),
	1//2*q*e2p((i1*k1)*S(1//(q-1)))-1//2*e2p((i1*k1)*S(1//(q-1)))*q^2+1//2*q*e2p((-i1*k1)*S(1//(q-1)))-1//2*e2p((-i1*k1)*S(1//(q-1)))*q^2,
	1//2*q*e2p((i1*k1)*S(1//(q-1)))-1//2*e2p((i1*k1)*S(1//(q-1)))*q^2+1//2*q*e2p((-i1*k1)*S(1//(q-1)))-1//2*e2p((-i1*k1)*S(1//(q-1)))*q^2,
	1//2*q*e2p((i1*k1)*S(1//(q-1)))+1//2*q*e2p((-i1*k1)*S(1//(q-1))),
	1//2*q*e2p((i1*k1)*S(1//(q-1)))+1//2*q*e2p((-i1*k1)*S(1//(q-1))),
	-1//2*q*e2p((i1*k1)*S(1//(q-1)))-1//2*q*e2p((-i1*k1)*S(1//(q-1))),
	(q^4-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1)*S(1//(q-1)))*q-e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1)))*q-e2p((-i2*k1)*S(1//(q-1))),
	-e2p((i2*k1)*S(1//(q-1)))-e2p((-i2*k1)*S(1//(q-1))),
	(-2*q-2)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((i1*k1)*S(1//(q-1)))-2*e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9+q^8+q^7+q^6+q^5+q^4)*e2p(S(0)),
	(q^4)*e2p(S(0)),
	(q^5+q^4)*e2p(S(0)),
	(q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^4*e2p((i1*k1)*S(1//(q-1)))+q^4*e2p((-i1*k1)*S(1//(q-1)))+q^4+q^2+q^3+q,
	(q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^4-q^2-q^3-q)*e2p(S(0)),
	(-q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^3+e2p((i1*k1)*S(1//(q-1)))*q^2+q*e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^3+e2p((-i1*k1)*S(1//(q-1)))*q^2+q*e2p((-i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^2+q*e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+q*e2p((-i1*k1)*S(1//(q-1)))+q^2+q,
	q*e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1))),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^2-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+q+1+e2p((i2*k1)*S(1//(q-1)))*q+e2p((-i2*k1)*S(1//(q-1)))*q,
	(1)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))*q+e2p((-i2*k1)*S(1//(q-1)))*q,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	-q*e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))-q-1,
	(-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i2*k1)*S(1//(q-1)))*q-e2p((-i2*k1)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i3*k1)*S(1//(q-1)))+e2p((-i3*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))-e2p((i2*k1)*S(1//(q-1)))-e2p((-i2*k1)*S(1//(q-1))),
	-e2p((i2*k1)*S(1//(q-1)))-e2p((-i2*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^3-q^2+q-1+q^5-q^4)*e2p(S(0)),
	(-q^4+q^3-q^2+q-1)*e2p(S(0)),
	(q^3+q-q^2-1)*e2p(S(0)),
	(q^3+q-q^2-1)*e2p(S(0)),
	(-q^2+q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-q^2+q-1)*e2p(S(0)),
	(-q^2+q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q^3+q-q^2-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-q^2+q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	q^3+q-q^2-1-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	q-1-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-q^2+q-1-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	q-1-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-1-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-1-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q+1)))*q^2+q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	q-1+q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	q-1-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-1+q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-1-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q-1-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	-1-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	q-1-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	-1-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	-e2p((-i3*k1)*S(1//(q+1)))-e2p((i3*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))-e2p((-i3*k1)*S(1//(q+1)))-e2p((i3*k1)*S(1//(q+1))),
	-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))-e2p((-i3*k1)*S(1//(q+1)))-e2p((i3*k1)*S(1//(q+1))),
	-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0))] [
	(1//2*q^8+1//2*q^7-1//2*q^2-1//2*q)*e2p(S(0)),
	(-1//2*q^6-1//2*q^3-1//2*q^2-1//2*q)*e2p(S(0)),
	(1//2*q^5+1//2*q^4-1//2*q^2-1//2*q)*e2p(S(0)),
	(1//2*q^4-1//2*q^3-1//2*q^2-1//2*q)*e2p(S(0)),
	(-1//2*q^2-1//2*q)*e2p(S(0)),
	(1//2*q^2-1//2*q)*e2p(S(0)),
	(-1//2*q^2-1//2*q)*e2p(S(0)),
	(-1//2*q^3-1//2*q)*e2p(S(0)),
	(-q^2-1//2*q+1//2*q^3)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(q^4-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q+1)))*q^2-1//2*e2p((i1*k1)*S(1//(q+1)))*q^3-1//2*q*e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2-1//2*e2p((-i1*k1)*S(1//(q+1)))*q^3-1//2*q*e2p((-i1*k1)*S(1//(q+1))),
	-1//2*e2p((i1*k1)*S(1//(q+1)))*q^2-1//2*q*e2p((i1*k1)*S(1//(q+1)))-1//2*e2p((-i1*k1)*S(1//(q+1)))*q^2-1//2*q*e2p((-i1*k1)*S(1//(q+1))),
	-1//2*e2p((i1*k1)*S(1//(q+1)))*q^2-1//2*q*e2p((i1*k1)*S(1//(q+1)))-1//2*e2p((-i1*k1)*S(1//(q+1)))*q^2-1//2*q*e2p((-i1*k1)*S(1//(q+1))),
	-1//2*q*e2p((-i1*k1)*S(1//(q+1)))-1//2*q*e2p((i1*k1)*S(1//(q+1))),
	-1//2*q*e2p((-i1*k1)*S(1//(q+1)))-1//2*q*e2p((i1*k1)*S(1//(q+1))),
	1//2*q*e2p((-i1*k1)*S(1//(q+1)))+1//2*q*e2p((i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(2*q-2)*e2p(S(0)),
	(-2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i2*k1)*S(1//(q+1)))*q-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))*q-e2p((i2*k1)*S(1//(q+1))),
	-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i2*k1)*S(1//(q+1)))*q-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))*q-e2p((i2*k1)*S(1//(q+1))),
	-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((-i3*k1)*S(1//(q+1)))-2*e2p((i3*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0))] [
	(1//2*q^8-1//2*q^7+q^6-q^3+1//2*q^2-1//2*q-q^5+q^4)*e2p(S(0)),
	(-1//2*q^6-1//2*q^3+1//2*q^2-1//2*q)*e2p(S(0)),
	(-1//2*q^5-q^3+3//2*q^4+1//2*q^2-1//2*q)*e2p(S(0)),
	(1//2*q^4-1//2*q^3+1//2*q^2-1//2*q)*e2p(S(0)),
	(1//2*q^2-1//2*q)*e2p(S(0)),
	(1//2*q^2-1//2*q)*e2p(S(0)),
	(-1//2*q+3//2*q^2)*e2p(S(0)),
	(-q^2-1//2*q+1//2*q^3)*e2p(S(0)),
	(-1//2*q^3-1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(q^3+q-q^2-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-q^2+q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	q^4+q^2-q^3-q-1//2*e2p((i1*k1)*S(1//(q+1)))*q^3-1//2*q*e2p((i1*k1)*S(1//(q+1)))-1//2*e2p((-i1*k1)*S(1//(q+1)))*q^3-1//2*q*e2p((-i1*k1)*S(1//(q+1))),
	q^2-q+1//2*e2p((i1*k1)*S(1//(q+1)))*q^2-1//2*q*e2p((i1*k1)*S(1//(q+1)))+1//2*e2p((-i1*k1)*S(1//(q+1)))*q^2-1//2*q*e2p((-i1*k1)*S(1//(q+1))),
	-q-1//2*e2p((i1*k1)*S(1//(q+1)))*q^2-1//2*q*e2p((i1*k1)*S(1//(q+1)))-1//2*e2p((-i1*k1)*S(1//(q+1)))*q^2-1//2*q*e2p((-i1*k1)*S(1//(q+1))),
	-q-1//2*q*e2p((i1*k1)*S(1//(q+1)))-1//2*q*e2p((-i1*k1)*S(1//(q+1))),
	1//2*q*e2p((-i1*k1)*S(1//(q+1)))+1//2*q*e2p((i1*k1)*S(1//(q+1))),
	-1//2*q*e2p((-i1*k1)*S(1//(q+1)))-1//2*q*e2p((i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q+1)))*q^2-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	(q^2-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q+1+e2p((i1*k1)*S(1//(q+1)))*q^2-q*e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2-q*e2p((-i1*k1)*S(1//(q+1))),
	-q+1-q*e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1))),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q-1-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	-1-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	-e2p((-i2*k1)*S(1//(q+1)))*q-e2p((i2*k1)*S(1//(q+1)))*q,
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-q+1-q*e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i2*k1)*S(1//(q+1)))*q-e2p((i2*k1)*S(1//(q+1)))*q,
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	-e2p((-i3*k1)*S(1//(q+1)))-e2p((i3*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))-e2p((-i3*k1)*S(1//(q+1)))-e2p((i3*k1)*S(1//(q+1))),
	e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1)))+e2p((-i3*k1)*S(1//(q+1)))+e2p((i3*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//2*q^8-1//2*q^7+q^6-q^3+1//2*q^2-1//2*q-q^5+q^4)*e2p(S(0)),
	(1//2*q^6-q^5+q^4-3//2*q^3+1//2*q^2-1//2*q)*e2p(S(0)),
	(1//2*q^5-q^3+1//2*q^4+1//2*q^2-1//2*q)*e2p(S(0)),
	(1//2*q^4-3//2*q^3+1//2*q^2-1//2*q)*e2p(S(0)),
	(-q^3-1//2*q+1//2*q^2)*e2p(S(0)),
	(1//2*q^2-1//2*q)*e2p(S(0)),
	(-1//2*q^2-1//2*q)*e2p(S(0)),
	(-1//2*q+1//2*q^3)*e2p(S(0)),
	(q^2-1//2*q-1//2*q^3)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(q^4+q^2-q^3-q)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q^3-q+q^2+1-1//2*e2p((i1*k1)*S(1//(q+1)))*q^3-1//2*q*e2p((i1*k1)*S(1//(q+1)))-1//2*e2p((-i1*k1)*S(1//(q+1)))*q^3-1//2*q*e2p((-i1*k1)*S(1//(q+1))),
	-q+1-1//2*e2p((i1*k1)*S(1//(q+1)))*q^2-1//2*q*e2p((i1*k1)*S(1//(q+1)))-1//2*e2p((-i1*k1)*S(1//(q+1)))*q^2-1//2*q*e2p((-i1*k1)*S(1//(q+1))),
	q^2-q+1+1//2*e2p((i1*k1)*S(1//(q+1)))*q^2-1//2*q*e2p((i1*k1)*S(1//(q+1)))+1//2*e2p((-i1*k1)*S(1//(q+1)))*q^2-1//2*q*e2p((-i1*k1)*S(1//(q+1))),
	-q+1-1//2*q*e2p((i1*k1)*S(1//(q+1)))-1//2*q*e2p((-i1*k1)*S(1//(q+1))),
	1+1//2*q*e2p((i1*k1)*S(1//(q+1)))+1//2*q*e2p((-i1*k1)*S(1//(q+1))),
	1-1//2*q*e2p((i1*k1)*S(1//(q+1)))-1//2*q*e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q+1)))*q^3+e2p((i1*k1)*S(1//(q+1)))*q^2-q*e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^3+e2p((-i1*k1)*S(1//(q+1)))*q^2-q*e2p((-i1*k1)*S(1//(q+1))),
	-q*e2p((-i1*k1)*S(1//(q+1)))-q*e2p((i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	q^2-q-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	-q-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q+1-e2p((-i2*k1)*S(1//(q+1)))*q-e2p((i2*k1)*S(1//(q+1)))*q,
	(1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	-q+1+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1))),
	1+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))-e2p((-i2*k1)*S(1//(q+1)))*q-e2p((i2*k1)*S(1//(q+1)))*q,
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	-e2p((-i3*k1)*S(1//(q+1)))-e2p((i3*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1)))+e2p((-i3*k1)*S(1//(q+1)))+e2p((i3*k1)*S(1//(q+1))),
	-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1)))+e2p((-i3*k1)*S(1//(q+1)))+e2p((i3*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(1//2*q^8-3//2*q^7+2*q^6-2*q^3+3//2*q^2-1//2*q-2*q^5+2*q^4)*e2p(S(0)),
	(1//2*q^6-q^5+q^4+3//2*q^2-1//2*q-3//2*q^3)*e2p(S(0)),
	(-2*q^3+3//2*q^2-1//2*q-1//2*q^5+3//2*q^4)*e2p(S(0)),
	(1//2*q^4+3//2*q^2-1//2*q-3//2*q^3)*e2p(S(0)),
	(-q^3+3//2*q^2-1//2*q)*e2p(S(0)),
	(1//2*q^2-1//2*q)*e2p(S(0)),
	(-1//2*q+3//2*q^2)*e2p(S(0)),
	(q^2-1//2*q-1//2*q^3)*e2p(S(0)),
	(-1//2*q+1//2*q^3)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(1//2*q)*e2p(S(0)),
	(-1//2*q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^4+2*q^2-2*q^3-2*q+1+e2p((i1*k1)*S(1//(q+1)))*q^2-1//2*q*e2p((i1*k1)*S(1//(q+1)))-1//2*e2p((i1*k1)*S(1//(q+1)))*q^3+e2p((-i1*k1)*S(1//(q+1)))*q^2-1//2*q*e2p((-i1*k1)*S(1//(q+1)))-1//2*e2p((-i1*k1)*S(1//(q+1)))*q^3,
	q^2-2*q+1+1//2*e2p((i1*k1)*S(1//(q+1)))*q^2-1//2*q*e2p((i1*k1)*S(1//(q+1)))+1//2*e2p((-i1*k1)*S(1//(q+1)))*q^2-1//2*q*e2p((-i1*k1)*S(1//(q+1))),
	q^2-2*q+1+1//2*e2p((i1*k1)*S(1//(q+1)))*q^2-1//2*q*e2p((i1*k1)*S(1//(q+1)))+1//2*e2p((-i1*k1)*S(1//(q+1)))*q^2-1//2*q*e2p((-i1*k1)*S(1//(q+1))),
	-2*q+1-1//2*q*e2p((i1*k1)*S(1//(q+1)))-1//2*q*e2p((-i1*k1)*S(1//(q+1))),
	1-1//2*q*e2p((i1*k1)*S(1//(q+1)))-1//2*q*e2p((-i1*k1)*S(1//(q+1))),
	1+1//2*q*e2p((i1*k1)*S(1//(q+1)))+1//2*q*e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q+1)))*q^3+2*e2p((i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^3+2*e2p((-i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	-2*q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-2*q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^2-2*q+1+e2p((i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	-q+1-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	-q+1-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	1+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*q+2-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))-e2p((-i2*k1)*S(1//(q+1)))*q+e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))*q+e2p((i2*k1)*S(1//(q+1))),
	2+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1))),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-2*q*e2p((i1*k1)*S(1//(q+1)))+2*e2p((i1*k1)*S(1//(q+1)))-2*q*e2p((-i1*k1)*S(1//(q+1)))+2*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i2*k1)*S(1//(q+1)))*q+e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))*q+e2p((i2*k1)*S(1//(q+1))),
	2*e2p((i1*k1)*S(1//(q+1)))+2*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((i1*k1)*S(1//(q+1)))+2*e2p((-i1*k1)*S(1//(q+1)))+2*e2p((-i2*k1)*S(1//(q+1)))+2*e2p((i2*k1)*S(1//(q+1)))+2*e2p((-i3*k1)*S(1//(q+1)))+2*e2p((i3*k1)*S(1//(q+1))),
	-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0))] [
	(q^9-q^8+q^7-q^6+q^5-q^4)*e2p(S(0)),
	(-q^4)*e2p(S(0)),
	(q^5-q^4)*e2p(S(0)),
	(-q^4)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4+q^2-q^3-q)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q^4-q^2+q^3+q-q^4*e2p((i1*k1)*S(1//(q+1)))-q^4*e2p((-i1*k1)*S(1//(q+1))),
	(-q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q+1)))*q^3-e2p((i1*k1)*S(1//(q+1)))*q^2+q*e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^3-e2p((-i1*k1)*S(1//(q+1)))*q^2+q*e2p((-i1*k1)*S(1//(q+1))),
	q*e2p((-i1*k1)*S(1//(q+1)))+q*e2p((i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q^2+q-e2p((i1*k1)*S(1//(q+1)))*q^2+q*e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2+q*e2p((-i1*k1)*S(1//(q+1))),
	q*e2p((-i1*k1)*S(1//(q+1)))+q*e2p((i1*k1)*S(1//(q+1))),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q+1-e2p((-i2*k1)*S(1//(q+1)))*q-e2p((i2*k1)*S(1//(q+1)))*q,
	(1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	-e2p((-i2*k1)*S(1//(q+1)))*q-e2p((i2*k1)*S(1//(q+1)))*q,
	(0)*e2p(S(0)),
	-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	q-1+q*e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i2*k1)*S(1//(q+1)))*q+e2p((i2*k1)*S(1//(q+1)))*q,
	(-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))+e2p((-i2*k1)*S(1//(q+1)))*q+e2p((i2*k1)*S(1//(q+1)))*q,
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	-e2p((-i3*k1)*S(1//(q+1)))-e2p((i3*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1)))+e2p((-i3*k1)*S(1//(q+1)))+e2p((i3*k1)*S(1//(q+1))),
	e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))-e2p((-i3*k1)*S(1//(q+1)))-e2p((i3*k1)*S(1//(q+1))),
	-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0))] [
	(q^6+q^5+q^4+2*q^3+q^2+q+1)*e2p(S(0)),
	(q^3+q+q^2+1)*e2p(S(0)),
	(2*q^3+q^4+q^2+q+1)*e2p(S(0)),
	(q^3+q+q^2+1)*e2p(S(0)),
	(q^2+q+1)*e2p(S(0)),
	(2*q^2+q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^3+q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))*q^2+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^3+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))*q^2+q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^2+q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-3*i1*k1)*S(1//(q-1)))+e2p((3*i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-3*i1*k1)*S(1//(q-1)))+e2p((3*i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-3*i1*k1)*S(1//(q-1)))+e2p((3*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^2+2*q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1))),
	q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1))),
	q+1+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1))),
	1+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1))),
	(q^2+2*q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))*q+e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1)*S(1//(q-1))),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1-i2*k1)*S(1//(q-1)))+e2p((-2*i1*k1-i2*k1)*S(1//(q-1)))+e2p((2*i1*k1+i2*k1)*S(1//(q-1)))+e2p((-2*i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))*q+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1)))*q+e2p((-i2*k1)*S(1//(q-1))),
	e2p((2*i1*k1-i2*k1)*S(1//(q-1)))+e2p((-2*i1*k1-i2*k1)*S(1//(q-1)))+e2p((2*i1*k1+i2*k1)*S(1//(q-1)))+e2p((-2*i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1)*S(1//(q-1)))*q+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1)))*q+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+i1*k1-i3*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k1)*S(1//(q-1)))+e2p((i3*k1+i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1+i3*k1-i1*k1)*S(1//(q-1)))+e2p((-i3*k1-i2*k1+i1*k1)*S(1//(q-1)))+e2p((-i1*k1+i3*k1+i2*k1)*S(1//(q-1)))+e2p((-i3*k1+i2*k1-i1*k1)*S(1//(q-1)))+e2p((-i3*k1-i2*k1-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^8+2*q^7+2*q^6+3*q^5+3*q^4+2*q^3+2*q^2+q)*e2p(S(0)),
	(2*q^4+q^5+2*q^3+2*q^2+q)*e2p(S(0)),
	(2*q^4+q^5+2*q^3+2*q^2+q)*e2p(S(0)),
	(q^4+2*q^3+2*q^2+q)*e2p(S(0)),
	(q^3+2*q^2+q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^4*e2p((i1*k1)*S(1//(q-1)))+2*e2p((i1*k1)*S(1//(q-1)))*q^2+2*e2p((i1*k1)*S(1//(q-1)))*q^3+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q^4*e2p((-i1*k1)*S(1//(q-1)))+2*e2p((-i1*k1)*S(1//(q-1)))*q^2+2*e2p((-i1*k1)*S(1//(q-1)))*q^3+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^3+2*e2p((i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^3+2*e2p((-i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-3*i1*k1)*S(1//(q-1)))*q^2+e2p((-3*i1*k1)*S(1//(q-1)))*q+e2p((3*i1*k1)*S(1//(q-1)))*q^2+e2p((3*i1*k1)*S(1//(q-1)))*q,
	2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-3*i1*k1)*S(1//(q-1)))*q+e2p((3*i1*k1)*S(1//(q-1)))*q,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*q^2+4*q+2+e2p((-2*i1*k1)*S(1//(q-1)))*q^2+2*e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))*q^2+2*e2p((2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1))),
	2*q+2+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1))),
	2*q+2+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1))),
	2+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((i1*k1-i2*k1)*S(1//(q-1)))*q+2*e2p((i1*k1-i2*k1)*S(1//(q-1)))+2*e2p((-i2*k1-i1*k1)*S(1//(q-1)))*q+2*e2p((-i2*k1-i1*k1)*S(1//(q-1)))+2*e2p((i1*k1+i2*k1)*S(1//(q-1)))*q+2*e2p((i1*k1+i2*k1)*S(1//(q-1)))+2*e2p((i2*k1-i1*k1)*S(1//(q-1)))*q+2*e2p((i2*k1-i1*k1)*S(1//(q-1))),
	2*e2p((i1*k1-i2*k1)*S(1//(q-1)))+2*e2p((-i2*k1-i1*k1)*S(1//(q-1)))+2*e2p((i1*k1+i2*k1)*S(1//(q-1)))+2*e2p((i2*k1-i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1-i2*k1)*S(1//(q-1)))*q+e2p((2*i1*k1-i2*k1)*S(1//(q-1)))+e2p((-2*i1*k1-i2*k1)*S(1//(q-1)))*q+e2p((-2*i1*k1-i2*k1)*S(1//(q-1)))+e2p((2*i1*k1+i2*k1)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k1)*S(1//(q-1)))+e2p((-2*i1*k1+i2*k1)*S(1//(q-1)))*q+e2p((-2*i1*k1+i2*k1)*S(1//(q-1)))+2*e2p((i2*k1)*S(1//(q-1)))*q+2*e2p((i2*k1)*S(1//(q-1)))+2*e2p((-i2*k1)*S(1//(q-1)))*q+2*e2p((-i2*k1)*S(1//(q-1))),
	e2p((2*i1*k1-i2*k1)*S(1//(q-1)))+e2p((-2*i1*k1-i2*k1)*S(1//(q-1)))+e2p((2*i1*k1+i2*k1)*S(1//(q-1)))+e2p((-2*i1*k1+i2*k1)*S(1//(q-1)))+2*e2p((i2*k1)*S(1//(q-1)))+2*e2p((-i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((i2*k1+i1*k1-i3*k1)*S(1//(q-1)))+2*e2p((i1*k1+i2*k1+i3*k1)*S(1//(q-1)))+2*e2p((i3*k1+i1*k1-i2*k1)*S(1//(q-1)))+2*e2p((-i2*k1+i3*k1-i1*k1)*S(1//(q-1)))+2*e2p((-i3*k1-i2*k1+i1*k1)*S(1//(q-1)))+2*e2p((-i1*k1+i3*k1+i2*k1)*S(1//(q-1)))+2*e2p((-i3*k1+i2*k1-i1*k1)*S(1//(q-1)))+2*e2p((-i3*k1-i2*k1-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9+q^8+q^7+2*q^6+q^5+q^4+q^3)*e2p(S(0)),
	(q^6+q^4+q^5+q^3)*e2p(S(0)),
	(q^3+q^4)*e2p(S(0)),
	(q^3+q^4)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^4*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))*q^2+e2p((i1*k1)*S(1//(q-1)))*q^3+q*e2p((i1*k1)*S(1//(q-1)))+q^4*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+e2p((-i1*k1)*S(1//(q-1)))*q^3+q*e2p((-i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))*q^2+q*e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+q*e2p((-i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^3+e2p((i1*k1)*S(1//(q-1)))*q^2+q*e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^3+e2p((-i1*k1)*S(1//(q-1)))*q^2+q*e2p((-i1*k1)*S(1//(q-1)))+q^3*e2p((-3*i1*k1)*S(1//(q-1)))+q^3*e2p((3*i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^2+2*q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q^2+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1)))*q^2+e2p((2*i1*k1)*S(1//(q-1)))*q,
	(q+1)*e2p(S(0)),
	q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1)))*q,
	(1)*e2p(S(0)),
	(-q^2-2*q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))*q+e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1)*S(1//(q-1))),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1))),
	e2p((2*i1*k1-i2*k1)*S(1//(q-1)))*q+e2p((-2*i1*k1-i2*k1)*S(1//(q-1)))*q+e2p((2*i1*k1+i2*k1)*S(1//(q-1)))*q+e2p((-2*i1*k1+i2*k1)*S(1//(q-1)))*q+e2p((i2*k1)*S(1//(q-1)))*q+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1)))*q+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i2*k1)*S(1//(q-1)))*q-e2p((i2*k1)*S(1//(q-1)))-e2p((-i2*k1)*S(1//(q-1)))*q-e2p((-i2*k1)*S(1//(q-1))),
	-e2p((i2*k1)*S(1//(q-1)))-e2p((-i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1+i1*k1-i3*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k1)*S(1//(q-1)))+e2p((i3*k1+i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1+i3*k1-i1*k1)*S(1//(q-1)))+e2p((-i3*k1-i2*k1+i1*k1)*S(1//(q-1)))+e2p((-i1*k1+i3*k1+i2*k1)*S(1//(q-1)))+e2p((-i3*k1+i2*k1-i1*k1)*S(1//(q-1)))+e2p((-i3*k1-i2*k1-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((i1*k1-i2*k1)*S(1//(q-1)))-e2p((-i2*k1-i1*k1)*S(1//(q-1)))-e2p((i1*k1+i2*k1)*S(1//(q-1)))-e2p((i2*k1-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^6+q^4-q^5-2*q^3-q+q^2+1)*e2p(S(0)),
	(-q^3-q+q^2+1)*e2p(S(0)),
	(-2*q^3+q^4+q^2-q+1)*e2p(S(0)),
	(-q^3-q+q^2+1)*e2p(S(0)),
	(q^2-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(2*q^2-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q+1)))*q^3-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))*q^2+e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^3-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))*q^2-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q+1)))*q^2-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((3*i1*k1)*S(1//(q+1)))+e2p((-3*i1*k1)*S(1//(q+1))),
	-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((3*i1*k1)*S(1//(q+1)))+e2p((-3*i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((3*i1*k1)*S(1//(q+1)))+e2p((-3*i1*k1)*S(1//(q+1))),
	(q^2-2*q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	q^2-2*q+1-e2p((2*i1*k1)*S(1//(q+1)))*q+e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1)))*q+e2p((-2*i1*k1)*S(1//(q+1))),
	-q+1-e2p((2*i1*k1)*S(1//(q+1)))*q+e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1)))*q+e2p((-2*i1*k1)*S(1//(q+1))),
	-q+1+e2p((2*i1*k1)*S(1//(q+1)))+e2p((-2*i1*k1)*S(1//(q+1))),
	1+e2p((2*i1*k1)*S(1//(q+1)))+e2p((-2*i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	-e2p((-i2*k1)*S(1//(q+1)))*q+e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))*q+e2p((i2*k1)*S(1//(q+1))),
	e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i2*k1-i1*k1)*S(1//(q+1)))*q+e2p((-i2*k1-i1*k1)*S(1//(q+1)))-e2p((i1*k1+i2*k1)*S(1//(q+1)))*q+e2p((i1*k1+i2*k1)*S(1//(q+1)))-e2p((i1*k1-i2*k1)*S(1//(q+1)))*q+e2p((i1*k1-i2*k1)*S(1//(q+1)))-e2p((i2*k1-i1*k1)*S(1//(q+1)))*q+e2p((i2*k1-i1*k1)*S(1//(q+1))),
	e2p((-i2*k1-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i2*k1)*S(1//(q+1)))+e2p((i1*k1-i2*k1)*S(1//(q+1)))+e2p((i2*k1-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i1*k1+i2*k1)*S(1//(q+1)))+e2p((-2*i1*k1-i2*k1)*S(1//(q+1)))+e2p((-2*i1*k1+i2*k1)*S(1//(q+1)))+e2p((2*i1*k1-i2*k1)*S(1//(q+1)))-e2p((-i2*k1)*S(1//(q+1)))*q+e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))*q+e2p((i2*k1)*S(1//(q+1))),
	e2p((2*i1*k1+i2*k1)*S(1//(q+1)))+e2p((-2*i1*k1-i2*k1)*S(1//(q+1)))+e2p((-2*i1*k1+i2*k1)*S(1//(q+1)))+e2p((2*i1*k1-i2*k1)*S(1//(q+1)))+e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i2*k1-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i2*k1)*S(1//(q+1)))+e2p((i1*k1-i2*k1)*S(1//(q+1)))+e2p((i2*k1-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1+i1*k1-i2*k1)*S(1//(q+1)))+e2p((i1*k1+i2*k1+i3*k1)*S(1//(q+1)))+e2p((-i2*k1+i3*k1-i1*k1)*S(1//(q+1)))+e2p((-i3*k1-i2*k1-i1*k1)*S(1//(q+1)))+e2p((-i3*k1-i2*k1+i1*k1)*S(1//(q+1)))+e2p((-i1*k1+i3*k1+i2*k1)*S(1//(q+1)))+e2p((-i3*k1+i2*k1-i1*k1)*S(1//(q+1)))+e2p((i2*k1+i1*k1-i3*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))] [
	(q^8-2*q^7+2*q^6-3*q^5+3*q^4-2*q^3+2*q^2-q)*e2p(S(0)),
	(-q^5+2*q^4-2*q^3+2*q^2-q)*e2p(S(0)),
	(-q^5+2*q^4-2*q^3+2*q^2-q)*e2p(S(0)),
	(q^4-2*q^3+2*q^2-q)*e2p(S(0)),
	(-q^3+2*q^2-q)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^4*e2p((i1*k1)*S(1//(q+1)))+2*e2p((i1*k1)*S(1//(q+1)))*q^2-2*e2p((i1*k1)*S(1//(q+1)))*q^3-2*q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+q^4*e2p((-i1*k1)*S(1//(q+1)))+2*e2p((-i1*k1)*S(1//(q+1)))*q^2-2*e2p((-i1*k1)*S(1//(q+1)))*q^3-2*q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	-2*q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-2*q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q+1)))*q^3+2*e2p((i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^3+2*e2p((-i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((3*i1*k1)*S(1//(q+1)))*q^2-e2p((3*i1*k1)*S(1//(q+1)))*q+e2p((-3*i1*k1)*S(1//(q+1)))*q^2-e2p((-3*i1*k1)*S(1//(q+1)))*q,
	-2*q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-2*q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))-e2p((3*i1*k1)*S(1//(q+1)))*q-e2p((-3*i1*k1)*S(1//(q+1)))*q,
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*q^2-4*q+2+e2p((2*i1*k1)*S(1//(q+1)))*q^2-2*e2p((2*i1*k1)*S(1//(q+1)))*q+e2p((2*i1*k1)*S(1//(q+1)))+e2p((-2*i1*k1)*S(1//(q+1)))*q^2-2*e2p((-2*i1*k1)*S(1//(q+1)))*q+e2p((-2*i1*k1)*S(1//(q+1))),
	-2*q+2-e2p((2*i1*k1)*S(1//(q+1)))*q+e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1)))*q+e2p((-2*i1*k1)*S(1//(q+1))),
	-2*q+2-e2p((2*i1*k1)*S(1//(q+1)))*q+e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1)))*q+e2p((-2*i1*k1)*S(1//(q+1))),
	2+e2p((2*i1*k1)*S(1//(q+1)))+e2p((-2*i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-2*e2p((-i2*k1-i1*k1)*S(1//(q+1)))*q+2*e2p((-i2*k1-i1*k1)*S(1//(q+1)))-2*e2p((i1*k1+i2*k1)*S(1//(q+1)))*q+2*e2p((i1*k1+i2*k1)*S(1//(q+1)))-2*e2p((i1*k1-i2*k1)*S(1//(q+1)))*q+2*e2p((i1*k1-i2*k1)*S(1//(q+1)))-2*e2p((i2*k1-i1*k1)*S(1//(q+1)))*q+2*e2p((i2*k1-i1*k1)*S(1//(q+1))),
	2*e2p((-i2*k1-i1*k1)*S(1//(q+1)))+2*e2p((i1*k1+i2*k1)*S(1//(q+1)))+2*e2p((i1*k1-i2*k1)*S(1//(q+1)))+2*e2p((i2*k1-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((2*i1*k1+i2*k1)*S(1//(q+1)))*q+e2p((2*i1*k1+i2*k1)*S(1//(q+1)))-e2p((-2*i1*k1-i2*k1)*S(1//(q+1)))*q+e2p((-2*i1*k1-i2*k1)*S(1//(q+1)))-e2p((-2*i1*k1+i2*k1)*S(1//(q+1)))*q+e2p((-2*i1*k1+i2*k1)*S(1//(q+1)))-e2p((2*i1*k1-i2*k1)*S(1//(q+1)))*q+e2p((2*i1*k1-i2*k1)*S(1//(q+1)))-2*e2p((-i2*k1)*S(1//(q+1)))*q+2*e2p((-i2*k1)*S(1//(q+1)))-2*e2p((i2*k1)*S(1//(q+1)))*q+2*e2p((i2*k1)*S(1//(q+1))),
	e2p((2*i1*k1+i2*k1)*S(1//(q+1)))+e2p((-2*i1*k1-i2*k1)*S(1//(q+1)))+e2p((-2*i1*k1+i2*k1)*S(1//(q+1)))+e2p((2*i1*k1-i2*k1)*S(1//(q+1)))+2*e2p((-i2*k1)*S(1//(q+1)))+2*e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	2*e2p((i3*k1+i1*k1-i2*k1)*S(1//(q+1)))+2*e2p((i1*k1+i2*k1+i3*k1)*S(1//(q+1)))+2*e2p((-i2*k1+i3*k1-i1*k1)*S(1//(q+1)))+2*e2p((-i3*k1-i2*k1-i1*k1)*S(1//(q+1)))+2*e2p((-i3*k1-i2*k1+i1*k1)*S(1//(q+1)))+2*e2p((-i1*k1+i3*k1+i2*k1)*S(1//(q+1)))+2*e2p((-i3*k1+i2*k1-i1*k1)*S(1//(q+1)))+2*e2p((i2*k1+i1*k1-i3*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))] [
	(q^9-q^8+q^7-2*q^6+q^5-q^4+q^3)*e2p(S(0)),
	(-q^6+q^5-q^4+q^3)*e2p(S(0)),
	(q^3-q^4)*e2p(S(0)),
	(q^3-q^4)*e2p(S(0)),
	(q^3)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q^4*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))*q^2+e2p((i1*k1)*S(1//(q+1)))*q^3+q*e2p((i1*k1)*S(1//(q+1)))-q^4*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2+e2p((-i1*k1)*S(1//(q+1)))*q^3+q*e2p((-i1*k1)*S(1//(q+1))),
	q*e2p((-i1*k1)*S(1//(q+1)))+q*e2p((i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))*q^2+q*e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2+q*e2p((-i1*k1)*S(1//(q+1))),
	q*e2p((-i1*k1)*S(1//(q+1)))+q*e2p((i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q+1)))*q^3-e2p((i1*k1)*S(1//(q+1)))*q^2+q*e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^3-e2p((-i1*k1)*S(1//(q+1)))*q^2+q*e2p((-i1*k1)*S(1//(q+1)))+q^3*e2p((3*i1*k1)*S(1//(q+1)))+q^3*e2p((-3*i1*k1)*S(1//(q+1))),
	q*e2p((-i1*k1)*S(1//(q+1)))+q*e2p((i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(q^2-2*q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	-q^2+2*q-1-e2p((2*i1*k1)*S(1//(q+1)))*q^2+e2p((2*i1*k1)*S(1//(q+1)))*q-e2p((-2*i1*k1)*S(1//(q+1)))*q^2+e2p((-2*i1*k1)*S(1//(q+1)))*q,
	(q-1)*e2p(S(0)),
	q-1+e2p((2*i1*k1)*S(1//(q+1)))*q+e2p((-2*i1*k1)*S(1//(q+1)))*q,
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	-e2p((-i2*k1)*S(1//(q+1)))*q+e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))*q+e2p((i2*k1)*S(1//(q+1))),
	e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i2*k1-i1*k1)*S(1//(q+1)))*q-e2p((-i2*k1-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i2*k1)*S(1//(q+1)))*q-e2p((i1*k1+i2*k1)*S(1//(q+1)))+e2p((i1*k1-i2*k1)*S(1//(q+1)))*q-e2p((i1*k1-i2*k1)*S(1//(q+1)))+e2p((i2*k1-i1*k1)*S(1//(q+1)))*q-e2p((i2*k1-i1*k1)*S(1//(q+1))),
	-e2p((-i2*k1-i1*k1)*S(1//(q+1)))-e2p((i1*k1+i2*k1)*S(1//(q+1)))-e2p((i1*k1-i2*k1)*S(1//(q+1)))-e2p((i2*k1-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((2*i1*k1+i2*k1)*S(1//(q+1)))*q+e2p((-2*i1*k1-i2*k1)*S(1//(q+1)))*q+e2p((-2*i1*k1+i2*k1)*S(1//(q+1)))*q+e2p((2*i1*k1-i2*k1)*S(1//(q+1)))*q+e2p((-i2*k1)*S(1//(q+1)))*q-e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1)))*q-e2p((i2*k1)*S(1//(q+1))),
	-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i2*k1-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i2*k1)*S(1//(q+1)))+e2p((i1*k1-i2*k1)*S(1//(q+1)))+e2p((i2*k1-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1+i1*k1-i2*k1)*S(1//(q+1)))-e2p((i1*k1+i2*k1+i3*k1)*S(1//(q+1)))-e2p((-i2*k1+i3*k1-i1*k1)*S(1//(q+1)))-e2p((-i3*k1-i2*k1-i1*k1)*S(1//(q+1)))-e2p((-i3*k1-i2*k1+i1*k1)*S(1//(q+1)))-e2p((-i1*k1+i3*k1+i2*k1)*S(1//(q+1)))-e2p((-i3*k1+i2*k1-i1*k1)*S(1//(q+1)))-e2p((i2*k1+i1*k1-i3*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))] [
	(q^7+q^6+2*q^5+2*q^4+2*q^3+2*q^2+q+1)*e2p(S(0)),
	(q^4+q^5+2*q^3+2*q^2+q+1)*e2p(S(0)),
	(2*q^3+q^4+2*q^2+q+1)*e2p(S(0)),
	(2*q^3+2*q^2+q+1)*e2p(S(0)),
	(q^3+2*q^2+q+1)*e2p(S(0)),
	(q^2+q+1)*e2p(S(0)),
	(q^2+q+1)*e2p(S(0)),
	(q^2+q+1)*e2p(S(0)),
	(q^2+q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^3+q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))*q^2+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^3+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+e2p((-i1*k1)*S(1//(q-1)))+q^3+q+q^2+1,
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q^2+q+1,
	e2p((i1*k1)*S(1//(q-1)))*q^2+q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q+1,
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q+1,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+1,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+1,
	(q^3+q+q^2+1)*e2p(S(0)),
	(q^2+q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	q^3+2*q^2+2*q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q^2+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))*q^2+e2p((2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1))),
	2*q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1))),
	1+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1))),
	(q^3+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q+1+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+1+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q+1+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+1+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1))),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))*q+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1)))*q+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))*q+e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1)*S(1//(q-1)))+q+1+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1))),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))+1+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	q+1+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1))),
	1+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1))),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))+e2p((-i2*k1+i3*k1)*S(1//(q-1)))+e2p((-i3*k1-i2*k1)*S(1//(q-1)))+e2p((i3*k1+i2*k1)*S(1//(q-1)))+e2p((-i1*k1+i3*k1)*S(1//(q-1)))+e2p((-i3*k1+i2*k1)*S(1//(q-1)))+e2p((-i3*k1-i1*k1)*S(1//(q-1)))+e2p((-i3*k1+i1*k1)*S(1//(q-1)))+e2p((i3*k1+i1*k1)*S(1//(q-1))),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^8+q^7+2*q^6+2*q^5+2*q^4+2*q^3+q^2+q)*e2p(S(0)),
	(q^4+q^2+q^3+q)*e2p(S(0)),
	(q^5+2*q^3+2*q^4+q^2+q)*e2p(S(0)),
	(q^4+q^2+q^3+q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(2*q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^4*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))*q^2+e2p((i1*k1)*S(1//(q-1)))*q^3+q*e2p((i1*k1)*S(1//(q-1)))+q^4*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+e2p((-i1*k1)*S(1//(q-1)))*q^3+q*e2p((-i1*k1)*S(1//(q-1)))+q^3+q+q^2+1,
	e2p((i1*k1)*S(1//(q-1)))*q^2+q*e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+q*e2p((-i1*k1)*S(1//(q-1)))+q^2+q+1,
	q*e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+q+1,
	q*e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+q+1,
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-q^2-q^3-q-1)*e2p(S(0)),
	(-q^2-q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	q^3+2*q^2+2*q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q^2+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))*q^2+e2p((2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1))),
	2*q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1))),
	1+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1))),
	(-q^3-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q^2+q+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1)))*q,
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1)))*q,
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1-i2*k1)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1)*S(1//(q-1)))*q+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((i2*k1)*S(1//(q-1)))*q+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1)))*q+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))*q+e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1)*S(1//(q-1)))+q+1+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1))),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))+1+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1))),
	-q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q-1-e2p((-2*i1*k1)*S(1//(q-1)))-e2p((2*i1*k1)*S(1//(q-1))),
	-1-e2p((-2*i1*k1)*S(1//(q-1)))-e2p((2*i1*k1)*S(1//(q-1))),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))+e2p((-i2*k1+i3*k1)*S(1//(q-1)))+e2p((-i3*k1-i2*k1)*S(1//(q-1)))+e2p((i3*k1+i2*k1)*S(1//(q-1)))+e2p((-i1*k1+i3*k1)*S(1//(q-1)))+e2p((-i3*k1+i2*k1)*S(1//(q-1)))+e2p((-i3*k1-i1*k1)*S(1//(q-1)))+e2p((-i3*k1+i1*k1)*S(1//(q-1)))+e2p((i3*k1+i1*k1)*S(1//(q-1))),
	-e2p((i1*k1-i2*k1)*S(1//(q-1)))-e2p((-i2*k1-i1*k1)*S(1//(q-1)))-e2p((i1*k1+i2*k1)*S(1//(q-1)))-e2p((i2*k1-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^8+q^7+2*q^6+2*q^5+2*q^4+2*q^3+q^2+q)*e2p(S(0)),
	(q^6+2*q^4+q^5+2*q^3+q^2+q)*e2p(S(0)),
	(2*q^3+q^4+q^2+q)*e2p(S(0)),
	(2*q^3+q^4+q^2+q)*e2p(S(0)),
	(q^3+q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^3+q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))*q^2+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^3+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+e2p((-i1*k1)*S(1//(q-1)))+q^4+q^2+q^3+q,
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q,
	e2p((i1*k1)*S(1//(q-1)))*q^2+q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q^2+q,
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(q^4+q^2+q^3+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^3+2*q^2+2*q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q^3+e2p((-2*i1*k1)*S(1//(q-1)))*q^2+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1)))*q^3+e2p((2*i1*k1)*S(1//(q-1)))*q^2+e2p((2*i1*k1)*S(1//(q-1)))*q,
	2*q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1)))*q,
	(1)*e2p(S(0)),
	(-q^3-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1)))*q,
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+1,
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1)))*q,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+1,
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))*q+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1)))*q+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))*q+e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1)*S(1//(q-1)))+q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1)))*q,
	e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))+1,
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1)))*q,
	(1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))+e2p((-i2*k1+i3*k1)*S(1//(q-1)))+e2p((-i3*k1-i2*k1)*S(1//(q-1)))+e2p((i3*k1+i2*k1)*S(1//(q-1)))+e2p((-i1*k1+i3*k1)*S(1//(q-1)))+e2p((-i3*k1+i2*k1)*S(1//(q-1)))+e2p((-i3*k1-i1*k1)*S(1//(q-1)))+e2p((-i3*k1+i1*k1)*S(1//(q-1)))+e2p((i3*k1+i1*k1)*S(1//(q-1))),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9+q^8+2*q^7+2*q^6+2*q^5+2*q^4+q^3+q^2)*e2p(S(0)),
	(q^4+q^5+q^3+q^2)*e2p(S(0)),
	(q^5+q^3+2*q^4+q^2)*e2p(S(0)),
	(q^4+q^3+q^2)*e2p(S(0)),
	(q^3+q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^4*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))*q^2+e2p((i1*k1)*S(1//(q-1)))*q^3+q*e2p((i1*k1)*S(1//(q-1)))+q^4*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+e2p((-i1*k1)*S(1//(q-1)))*q^3+q*e2p((-i1*k1)*S(1//(q-1)))+q^4+q^2+q^3+q,
	e2p((i1*k1)*S(1//(q-1)))*q^2+q*e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+q*e2p((-i1*k1)*S(1//(q-1)))+q,
	q*e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+q^2+q,
	q*e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(-q^4-q^2-q^3-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(-q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^3+2*q^2+2*q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q^3+e2p((-2*i1*k1)*S(1//(q-1)))*q^2+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1)))*q^3+e2p((2*i1*k1)*S(1//(q-1)))*q^2+e2p((2*i1*k1)*S(1//(q-1)))*q,
	2*q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1)))*q,
	(1)*e2p(S(0)),
	(q^3+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q^2+q+e2p((-2*i1*k1)*S(1//(q-1)))*q^2+e2p((2*i1*k1)*S(1//(q-1)))*q^2,
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q,
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(-q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1-i2*k1)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1)*S(1//(q-1)))*q+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((i2*k1)*S(1//(q-1)))*q+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1)))*q+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1))),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))*q+e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1)*S(1//(q-1)))+q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1)))*q,
	e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))+1,
	-q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-q*e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-q-1-e2p((-2*i1*k1)*S(1//(q-1)))*q-e2p((2*i1*k1)*S(1//(q-1)))*q,
	(-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))+e2p((-i2*k1+i3*k1)*S(1//(q-1)))+e2p((-i3*k1-i2*k1)*S(1//(q-1)))+e2p((i3*k1+i2*k1)*S(1//(q-1)))+e2p((-i1*k1+i3*k1)*S(1//(q-1)))+e2p((-i3*k1+i2*k1)*S(1//(q-1)))+e2p((-i3*k1-i1*k1)*S(1//(q-1)))+e2p((-i3*k1+i1*k1)*S(1//(q-1)))+e2p((i3*k1+i1*k1)*S(1//(q-1))),
	-e2p((i1*k1-i2*k1)*S(1//(q-1)))-e2p((-i2*k1-i1*k1)*S(1//(q-1)))-e2p((i1*k1+i2*k1)*S(1//(q-1)))-e2p((i2*k1-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(-q^6-2*q^2-1+q^7+2*q^3+q+2*q^5-2*q^4)*e2p(S(0)),
	(q^5-2*q^2-1+2*q^3-q^4+q)*e2p(S(0)),
	(-2*q^2-1-q^4+2*q^3+q)*e2p(S(0)),
	(-2*q^2-1+2*q^3+q)*e2p(S(0)),
	(q^3-2*q^2-1+q)*e2p(S(0)),
	(-q^2+q-1)*e2p(S(0)),
	(-q^2+q-1)*e2p(S(0)),
	(-q^2+q-1)*e2p(S(0)),
	(-q^2+q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q^3+q-q^2-1)*e2p(S(0)),
	(-q^2+q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	q^3+q-q^2-1+e2p((i1*k1)*S(1//(q+1)))*q^3+q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))*q^2-e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^3+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2-e2p((-i1*k1)*S(1//(q+1))),
	-q^2+q-1+q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	q-1-e2p((i1*k1)*S(1//(q+1)))*q^2+q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	q-1+q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-1-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-1-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(q^3-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	q^3-2*q^2+2*q-1-e2p((2*i1*k1)*S(1//(q+1)))*q^2+e2p((2*i1*k1)*S(1//(q+1)))*q-e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1)))*q^2+e2p((-2*i1*k1)*S(1//(q+1)))*q-e2p((-2*i1*k1)*S(1//(q+1))),
	-1+2*q+e2p((2*i1*k1)*S(1//(q+1)))*q-e2p((2*i1*k1)*S(1//(q+1)))+e2p((-2*i1*k1)*S(1//(q+1)))*q-e2p((-2*i1*k1)*S(1//(q+1))),
	-1-e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1))),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	q-1-e2p((i1*k1)*S(1//(q+1)))*q^2+2*q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1))),
	-1+q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1))),
	q-1+q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1))),
	-1-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	e2p((-i2*k1)*S(1//(q+1)))*q-e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1)))*q-e2p((i2*k1)*S(1//(q+1))),
	-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	q-1-e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1))),
	-1-e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1))),
	-e2p((-i2*k1-i1*k1)*S(1//(q+1)))-e2p((i1*k1+i2*k1)*S(1//(q+1)))-e2p((i1*k1-i2*k1)*S(1//(q+1)))-e2p((i2*k1-i1*k1)*S(1//(q+1)))+q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))+e2p((-i2*k1)*S(1//(q+1)))*q-e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1)))*q-e2p((i2*k1)*S(1//(q+1))),
	-e2p((-i2*k1-i1*k1)*S(1//(q+1)))-e2p((i1*k1+i2*k1)*S(1//(q+1)))-e2p((i1*k1-i2*k1)*S(1//(q+1)))-e2p((i2*k1-i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i2*k1-i1*k1)*S(1//(q+1)))*q-e2p((-i2*k1-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i2*k1)*S(1//(q+1)))*q-e2p((i1*k1+i2*k1)*S(1//(q+1)))+e2p((i1*k1-i2*k1)*S(1//(q+1)))*q-e2p((i1*k1-i2*k1)*S(1//(q+1)))+q-1+e2p((i2*k1-i1*k1)*S(1//(q+1)))*q-e2p((i2*k1-i1*k1)*S(1//(q+1)))-e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1))),
	-e2p((-i2*k1-i1*k1)*S(1//(q+1)))-e2p((i1*k1+i2*k1)*S(1//(q+1)))-e2p((i1*k1-i2*k1)*S(1//(q+1)))-1-e2p((i2*k1-i1*k1)*S(1//(q+1)))-e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((-i3*k1+i2*k1)*S(1//(q+1)))-e2p((-i2*k1+i3*k1)*S(1//(q+1)))-e2p((-i3*k1-i2*k1)*S(1//(q+1)))-e2p((i3*k1+i2*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i2*k1-i1*k1)*S(1//(q+1)))-e2p((i1*k1+i2*k1)*S(1//(q+1)))-e2p((i1*k1-i2*k1)*S(1//(q+1)))-e2p((i2*k1-i1*k1)*S(1//(q+1)))-e2p((-i1*k1+i3*k1)*S(1//(q+1)))-e2p((-i3*k1-i1*k1)*S(1//(q+1)))-e2p((i3*k1+i1*k1)*S(1//(q+1)))-e2p((-i3*k1+i1*k1)*S(1//(q+1)))-e2p((-i3*k1+i2*k1)*S(1//(q+1)))-e2p((-i2*k1+i3*k1)*S(1//(q+1)))-e2p((-i3*k1-i2*k1)*S(1//(q+1)))-e2p((i3*k1+i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^8-q^7+2*q^6-2*q^3+q^2-q-2*q^5+2*q^4)*e2p(S(0)),
	(q^6+2*q^4-q-2*q^3-q^5+q^2)*e2p(S(0)),
	(-2*q^3-q+q^4+q^2)*e2p(S(0)),
	(-2*q^3-q+q^4+q^2)*e2p(S(0)),
	(-q^3+q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4+q^2-q^3-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^4+q^2-q^3-q-e2p((i1*k1)*S(1//(q+1)))*q^3-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))*q^2+e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^3-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2+e2p((-i1*k1)*S(1//(q+1))),
	-q-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	q^2-q+e2p((i1*k1)*S(1//(q+1)))*q^2-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	-q-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	(q^3-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-q^3+2*q^2-2*q+1-e2p((2*i1*k1)*S(1//(q+1)))*q^3+e2p((2*i1*k1)*S(1//(q+1)))*q^2-e2p((2*i1*k1)*S(1//(q+1)))*q-e2p((-2*i1*k1)*S(1//(q+1)))*q^3+e2p((-2*i1*k1)*S(1//(q+1)))*q^2-e2p((-2*i1*k1)*S(1//(q+1)))*q,
	-2*q+1-e2p((2*i1*k1)*S(1//(q+1)))*q-e2p((-2*i1*k1)*S(1//(q+1)))*q,
	(1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-q+1+e2p((i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))-e2p((2*i1*k1)*S(1//(q+1)))*q-e2p((-2*i1*k1)*S(1//(q+1)))*q,
	1-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	-q+1-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))-e2p((2*i1*k1)*S(1//(q+1)))*q-e2p((-2*i1*k1)*S(1//(q+1)))*q,
	1+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-e2p((-i2*k1)*S(1//(q+1)))*q+e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))*q+e2p((i2*k1)*S(1//(q+1))),
	e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-q+1-e2p((2*i1*k1)*S(1//(q+1)))*q-e2p((-2*i1*k1)*S(1//(q+1)))*q,
	(1)*e2p(S(0)),
	e2p((-i2*k1-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i2*k1)*S(1//(q+1)))+e2p((i1*k1-i2*k1)*S(1//(q+1)))+e2p((i2*k1-i1*k1)*S(1//(q+1)))-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))-e2p((-i2*k1)*S(1//(q+1)))*q+e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))*q+e2p((i2*k1)*S(1//(q+1))),
	e2p((-i2*k1-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i2*k1)*S(1//(q+1)))+e2p((i1*k1-i2*k1)*S(1//(q+1)))+e2p((i2*k1-i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i2*k1-i1*k1)*S(1//(q+1)))*q+e2p((-i2*k1-i1*k1)*S(1//(q+1)))-e2p((i1*k1+i2*k1)*S(1//(q+1)))*q+e2p((i1*k1+i2*k1)*S(1//(q+1)))-e2p((i1*k1-i2*k1)*S(1//(q+1)))*q+e2p((i1*k1-i2*k1)*S(1//(q+1)))-q+1-e2p((i2*k1-i1*k1)*S(1//(q+1)))*q+e2p((i2*k1-i1*k1)*S(1//(q+1)))-e2p((2*i1*k1)*S(1//(q+1)))*q-e2p((-2*i1*k1)*S(1//(q+1)))*q,
	e2p((-i2*k1-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i2*k1)*S(1//(q+1)))+e2p((i1*k1-i2*k1)*S(1//(q+1)))+1+e2p((i2*k1-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	e2p((-i3*k1+i2*k1)*S(1//(q+1)))+e2p((-i2*k1+i3*k1)*S(1//(q+1)))+e2p((-i3*k1-i2*k1)*S(1//(q+1)))+e2p((i3*k1+i2*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i2*k1-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i2*k1)*S(1//(q+1)))+e2p((i1*k1-i2*k1)*S(1//(q+1)))+e2p((i2*k1-i1*k1)*S(1//(q+1)))+e2p((-i1*k1+i3*k1)*S(1//(q+1)))+e2p((-i3*k1-i1*k1)*S(1//(q+1)))+e2p((i3*k1+i1*k1)*S(1//(q+1)))+e2p((-i3*k1+i1*k1)*S(1//(q+1)))+e2p((-i3*k1+i2*k1)*S(1//(q+1)))+e2p((-i2*k1+i3*k1)*S(1//(q+1)))+e2p((-i3*k1-i2*k1)*S(1//(q+1)))+e2p((i3*k1+i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^8-q^7+2*q^6-2*q^3+q^2-q-2*q^5+2*q^4)*e2p(S(0)),
	(q^4+q^2-q^3-q)*e2p(S(0)),
	(q^2-q^5+2*q^4-2*q^3-q)*e2p(S(0)),
	(q^4+q^2-q^3-q)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(2*q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3+q-q^2-1)*e2p(S(0)),
	(-q^2+q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-q^3-q+q^2+1+q^4*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))*q^2-e2p((i1*k1)*S(1//(q+1)))*q^3-q*e2p((i1*k1)*S(1//(q+1)))+q^4*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2-e2p((-i1*k1)*S(1//(q+1)))*q^3-q*e2p((-i1*k1)*S(1//(q+1))),
	q^2-q+1+e2p((i1*k1)*S(1//(q+1)))*q^2-q*e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2-q*e2p((-i1*k1)*S(1//(q+1))),
	-q+1-q*e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1))),
	-q+1-q*e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1))),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^3-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-q^3+2*q^2-2*q+1+e2p((2*i1*k1)*S(1//(q+1)))*q^2-e2p((2*i1*k1)*S(1//(q+1)))*q+e2p((2*i1*k1)*S(1//(q+1)))+e2p((-2*i1*k1)*S(1//(q+1)))*q^2-e2p((-2*i1*k1)*S(1//(q+1)))*q+e2p((-2*i1*k1)*S(1//(q+1))),
	-2*q+1-e2p((2*i1*k1)*S(1//(q+1)))*q+e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1)))*q+e2p((-2*i1*k1)*S(1//(q+1))),
	1+e2p((2*i1*k1)*S(1//(q+1)))+e2p((-2*i1*k1)*S(1//(q+1))),
	(q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^2-q+e2p((i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))-e2p((2*i1*k1)*S(1//(q+1)))*q-e2p((-2*i1*k1)*S(1//(q+1)))*q,
	-q-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))-e2p((2*i1*k1)*S(1//(q+1)))*q-e2p((-2*i1*k1)*S(1//(q+1)))*q,
	-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	e2p((-i2*k1)*S(1//(q+1)))*q-e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1)))*q-e2p((i2*k1)*S(1//(q+1))),
	-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	-q*e2p((-i1*k1)*S(1//(q+1)))-q*e2p((i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	q-1-e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1))),
	-1-e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1))),
	-e2p((-i2*k1-i1*k1)*S(1//(q+1)))*q-e2p((i1*k1+i2*k1)*S(1//(q+1)))*q-e2p((i1*k1-i2*k1)*S(1//(q+1)))*q-e2p((i2*k1-i1*k1)*S(1//(q+1)))*q-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))-e2p((-i2*k1)*S(1//(q+1)))*q+e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))*q+e2p((i2*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i2*k1-i1*k1)*S(1//(q+1)))*q+e2p((-i2*k1-i1*k1)*S(1//(q+1)))-e2p((i1*k1+i2*k1)*S(1//(q+1)))*q+e2p((i1*k1+i2*k1)*S(1//(q+1)))-e2p((i1*k1-i2*k1)*S(1//(q+1)))*q+e2p((i1*k1-i2*k1)*S(1//(q+1)))-q+1-e2p((i2*k1-i1*k1)*S(1//(q+1)))*q+e2p((i2*k1-i1*k1)*S(1//(q+1)))+e2p((2*i1*k1)*S(1//(q+1)))+e2p((-2*i1*k1)*S(1//(q+1))),
	e2p((-i2*k1-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i2*k1)*S(1//(q+1)))+e2p((i1*k1-i2*k1)*S(1//(q+1)))+1+e2p((i2*k1-i1*k1)*S(1//(q+1)))+e2p((2*i1*k1)*S(1//(q+1)))+e2p((-2*i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((-i3*k1+i2*k1)*S(1//(q+1)))-e2p((-i2*k1+i3*k1)*S(1//(q+1)))-e2p((-i3*k1-i2*k1)*S(1//(q+1)))-e2p((i3*k1+i2*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i2*k1-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i2*k1)*S(1//(q+1)))+e2p((i1*k1-i2*k1)*S(1//(q+1)))+e2p((i2*k1-i1*k1)*S(1//(q+1)))+e2p((-i1*k1+i3*k1)*S(1//(q+1)))+e2p((-i3*k1-i1*k1)*S(1//(q+1)))+e2p((i3*k1+i1*k1)*S(1//(q+1)))+e2p((-i3*k1+i1*k1)*S(1//(q+1)))+e2p((-i3*k1+i2*k1)*S(1//(q+1)))+e2p((-i2*k1+i3*k1)*S(1//(q+1)))+e2p((-i3*k1-i2*k1)*S(1//(q+1)))+e2p((i3*k1+i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9+2*q^7+q^3-q^8-2*q^6-q^2+2*q^5-2*q^4)*e2p(S(0)),
	(-q^4+q^3+q^5-q^2)*e2p(S(0)),
	(q^3+q^5-2*q^4-q^2)*e2p(S(0)),
	(-q^4+q^3-q^2)*e2p(S(0)),
	(q^3-q^2)*e2p(S(0)),
	(-q^2)*e2p(S(0)),
	(-q^2)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4+q^2-q^3-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q^4-q^2+q^3+q-q^4*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))*q^2+e2p((i1*k1)*S(1//(q+1)))*q^3+q*e2p((i1*k1)*S(1//(q+1)))-q^4*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2+e2p((-i1*k1)*S(1//(q+1)))*q^3+q*e2p((-i1*k1)*S(1//(q+1))),
	q-e2p((i1*k1)*S(1//(q+1)))*q^2+q*e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2+q*e2p((-i1*k1)*S(1//(q+1))),
	-q^2+q+q*e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1))),
	q+q*e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^3-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	q^3-2*q^2+2*q-1+e2p((2*i1*k1)*S(1//(q+1)))*q^3-e2p((2*i1*k1)*S(1//(q+1)))*q^2+e2p((2*i1*k1)*S(1//(q+1)))*q+e2p((-2*i1*k1)*S(1//(q+1)))*q^3-e2p((-2*i1*k1)*S(1//(q+1)))*q^2+e2p((-2*i1*k1)*S(1//(q+1)))*q,
	-1+2*q+e2p((2*i1*k1)*S(1//(q+1)))*q+e2p((-2*i1*k1)*S(1//(q+1)))*q,
	(-1)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q^2+q-e2p((i1*k1)*S(1//(q+1)))*q^2+2*q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((2*i1*k1)*S(1//(q+1)))*q^2-e2p((-2*i1*k1)*S(1//(q+1)))*q^2,
	q+q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-e2p((-i2*k1)*S(1//(q+1)))*q+e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))*q+e2p((i2*k1)*S(1//(q+1))),
	e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1))),
	-q*e2p((-i1*k1)*S(1//(q+1)))-q*e2p((i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	-q+1-e2p((2*i1*k1)*S(1//(q+1)))*q-e2p((-2*i1*k1)*S(1//(q+1)))*q,
	(1)*e2p(S(0)),
	e2p((-i2*k1-i1*k1)*S(1//(q+1)))*q+e2p((i1*k1+i2*k1)*S(1//(q+1)))*q+e2p((i1*k1-i2*k1)*S(1//(q+1)))*q+e2p((i2*k1-i1*k1)*S(1//(q+1)))*q+q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))+e2p((-i2*k1)*S(1//(q+1)))*q-e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1)))*q-e2p((i2*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i2*k1-i1*k1)*S(1//(q+1)))*q-e2p((-i2*k1-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i2*k1)*S(1//(q+1)))*q-e2p((i1*k1+i2*k1)*S(1//(q+1)))+e2p((i1*k1-i2*k1)*S(1//(q+1)))*q-e2p((i1*k1-i2*k1)*S(1//(q+1)))+q-1+e2p((i2*k1-i1*k1)*S(1//(q+1)))*q-e2p((i2*k1-i1*k1)*S(1//(q+1)))+e2p((2*i1*k1)*S(1//(q+1)))*q+e2p((-2*i1*k1)*S(1//(q+1)))*q,
	-e2p((-i2*k1-i1*k1)*S(1//(q+1)))-e2p((i1*k1+i2*k1)*S(1//(q+1)))-e2p((i1*k1-i2*k1)*S(1//(q+1)))-1-e2p((i2*k1-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	e2p((-i3*k1+i2*k1)*S(1//(q+1)))+e2p((-i2*k1+i3*k1)*S(1//(q+1)))+e2p((-i3*k1-i2*k1)*S(1//(q+1)))+e2p((i3*k1+i2*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i2*k1-i1*k1)*S(1//(q+1)))-e2p((i1*k1+i2*k1)*S(1//(q+1)))-e2p((i1*k1-i2*k1)*S(1//(q+1)))-e2p((i2*k1-i1*k1)*S(1//(q+1)))-e2p((-i1*k1+i3*k1)*S(1//(q+1)))-e2p((-i3*k1-i1*k1)*S(1//(q+1)))-e2p((i3*k1+i1*k1)*S(1//(q+1)))-e2p((-i3*k1+i1*k1)*S(1//(q+1)))-e2p((-i3*k1+i2*k1)*S(1//(q+1)))-e2p((-i2*k1+i3*k1)*S(1//(q+1)))-e2p((-i3*k1-i2*k1)*S(1//(q+1)))-e2p((i3*k1+i2*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^8+2*q^7+3*q^6+4*q^5+4*q^4+4*q^3+3*q^2+2*q+1)*e2p(S(0)),
	(2*q^4+q^5+3*q^3+3*q^2+2*q+1)*e2p(S(0)),
	(q^5+4*q^3+3*q^4+3*q^2+2*q+1)*e2p(S(0)),
	(q^4+3*q^3+3*q^2+2*q+1)*e2p(S(0)),
	(q^3+3*q^2+2*q+1)*e2p(S(0)),
	(3*q^2+2*q+1)*e2p(S(0)),
	(q^2+2*q+1)*e2p(S(0)),
	(q^2+2*q+1)*e2p(S(0)),
	(q^2+2*q+1)*e2p(S(0)),
	(2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	q^4*e2p((i1*k1)*S(1//(q-1)))+2*e2p((i1*k1)*S(1//(q-1)))*q^2+2*e2p((i1*k1)*S(1//(q-1)))*q^3+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q^4*e2p((-i1*k1)*S(1//(q-1)))+2*e2p((-i1*k1)*S(1//(q-1)))*q^2+2*e2p((-i1*k1)*S(1//(q-1)))*q^3+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q^3+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))*q^2+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k2)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q^2+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1))),
	2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i1*k2)*S(1//(q-1)))*q^3+2*e2p((-i1*k2)*S(1//(q-1)))*q^2+2*e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q^3+2*e2p((i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))+e2p((2*i1*k1-i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1-i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2)*S(1//(q-1)))+e2p((-2*i1*k1+i1*k2)*S(1//(q-1)))*q^2+e2p((-2*i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-2*i1*k1+i1*k2)*S(1//(q-1)))+e2p((-2*i1*k1-i1*k2)*S(1//(q-1)))*q^2+e2p((-2*i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-2*i1*k1-i1*k2)*S(1//(q-1))),
	2*e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+2*e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))+e2p((2*i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1-i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2)*S(1//(q-1)))+e2p((-2*i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-2*i1*k1+i1*k2)*S(1//(q-1)))+e2p((-2*i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-2*i1*k1-i1*k2)*S(1//(q-1))),
	e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))+e2p((2*i1*k1-i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+i1*k2)*S(1//(q-1)))+e2p((-2*i1*k1+i1*k2)*S(1//(q-1)))+e2p((-2*i1*k1-i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^2+2*q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((i1*k1-i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q^2+2*e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q^2+2*e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	q+1+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	1+e2p((-2*i1*k1)*S(1//(q-1)))+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	(q^2+2*q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))*q+e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i2*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))*q+e2p((i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i1*k2)*S(1//(q-1)))+e2p((-2*i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k2)*S(1//(q-1)))*q+e2p((i2*k2)*S(1//(q-1)))+e2p((-i2*k2)*S(1//(q-1)))*q+e2p((-i2*k2)*S(1//(q-1)))+e2p((-2*i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1-i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i2*k1+i1*k2)*S(1//(q-1)))+e2p((2*i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i2*k1+i1*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k1+i1*k2)*S(1//(q-1)))+e2p((-2*i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k2)*S(1//(q-1)))+e2p((-i2*k2)*S(1//(q-1)))+e2p((-2*i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1-i1*k2)*S(1//(q-1)))+e2p((2*i1*k1+i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k1+i1*k2)*S(1//(q-1)))+e2p((2*i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k1+i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k2)*S(1//(q-1)))*q+e2p((i2*k2)*S(1//(q-1)))+e2p((-i2*k2)*S(1//(q-1)))*q+e2p((-i2*k2)*S(1//(q-1))),
	e2p((i2*k2)*S(1//(q-1)))+e2p((-i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i2*k1+i1*k1-i3*k2)*S(1//(q-1)))+e2p((-i2*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k1-i3*k2)*S(1//(q-1)))+e2p((-i3*k1-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1-i3*k2)*S(1//(q-1)))+e2p((-i3*k1+i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i3*k1-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i3*k1+i1*k1+i2*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i3*k1+i2*k1-i1*k2)*S(1//(q-1)))+e2p((i3*k1+i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i3*k1-i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1-i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i3*k1+i2*k2)*S(1//(q-1)))+e2p((-i3*k1-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((-i2*k1+i3*k1-i1*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i3*k1+i1*k1-i2*k2)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9+2*q^8+3*q^7+4*q^6+4*q^5+4*q^4+3*q^3+2*q^2+q)*e2p(S(0)),
	(q^6+3*q^4+2*q^5+3*q^3+2*q^2+q)*e2p(S(0)),
	(q^5+3*q^3+3*q^4+2*q^2+q)*e2p(S(0)),
	(2*q^4+3*q^3+2*q^2+q)*e2p(S(0)),
	(2*q^3+2*q^2+q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^4*e2p((i1*k1)*S(1//(q-1)))+2*e2p((i1*k1)*S(1//(q-1)))*q^2+2*e2p((i1*k1)*S(1//(q-1)))*q^3+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q^4*e2p((-i1*k1)*S(1//(q-1)))+2*e2p((-i1*k1)*S(1//(q-1)))*q^2+2*e2p((-i1*k1)*S(1//(q-1)))*q^3+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q^4+e2p((-i1*k2)*S(1//(q-1)))*q^2+e2p((-i1*k2)*S(1//(q-1)))*q^3+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))*q^4+e2p((i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k2)*S(1//(q-1)))*q,
	e2p((i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))*q,
	e2p((i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q^2+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k2)*S(1//(q-1)))*q,
	2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))*q,
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i1*k2)*S(1//(q-1)))*q^3+2*e2p((-i1*k2)*S(1//(q-1)))*q^2+2*e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q^3+2*e2p((i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))+e2p((2*i1*k1-i1*k2)*S(1//(q-1)))*q^3+e2p((2*i1*k1-i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2)*S(1//(q-1)))*q^3+e2p((2*i1*k1+i1*k2)*S(1//(q-1)))*q^2+e2p((2*i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-2*i1*k1+i1*k2)*S(1//(q-1)))*q^3+e2p((-2*i1*k1+i1*k2)*S(1//(q-1)))*q^2+e2p((-2*i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-2*i1*k1-i1*k2)*S(1//(q-1)))*q^3+e2p((-2*i1*k1-i1*k2)*S(1//(q-1)))*q^2+e2p((-2*i1*k1-i1*k2)*S(1//(q-1)))*q,
	2*e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+2*e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))+e2p((2*i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((2*i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-2*i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-2*i1*k1-i1*k2)*S(1//(q-1)))*q,
	e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^2+2*q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q^2+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))*q^2+e2p((2*i1*k1)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q^2+2*e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q^2+2*e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	q+1+e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	q+1+e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	1+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	(-q^2-2*q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))*q+e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))*q+e2p((i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i2*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))*q+e2p((i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k1+i1*k2)*S(1//(q-1)))+q*e2p((-2*i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k2)*S(1//(q-1)))*q+e2p((i2*k2)*S(1//(q-1)))+e2p((-i2*k2)*S(1//(q-1)))*q+e2p((-i2*k2)*S(1//(q-1)))+q*e2p((-2*i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k1-i1*k2)*S(1//(q-1)))+q*e2p((2*i1*k1+i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i2*k1+i1*k2)*S(1//(q-1)))+q*e2p((2*i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i2*k1+i1*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k2)*S(1//(q-1)))+e2p((-i2*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k1+i1*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k1+i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i2*k2)*S(1//(q-1)))*q-e2p((i2*k2)*S(1//(q-1)))-e2p((-i2*k2)*S(1//(q-1)))*q-e2p((-i2*k2)*S(1//(q-1))),
	-e2p((i2*k2)*S(1//(q-1)))-e2p((-i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i2*k1+i1*k1-i3*k2)*S(1//(q-1)))+e2p((-i2*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k1+i3*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k1-i3*k2)*S(1//(q-1)))+e2p((-i3*k1-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k1-i3*k2)*S(1//(q-1)))+e2p((-i3*k1+i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i3*k1-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i3*k1+i1*k1+i2*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i3*k1+i2*k1-i1*k2)*S(1//(q-1)))+e2p((i3*k1+i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i3*k1-i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1-i3*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i3*k1+i2*k2)*S(1//(q-1)))+e2p((-i3*k1-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k1+i3*k2)*S(1//(q-1)))+e2p((-i2*k1+i3*k1-i1*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i3*k1+i1*k1-i2*k2)*S(1//(q-1)))+e2p((i3*k1-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k1+i3*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	-e2p((i1*k1+i2*k2)*S(1//(q-1)))-e2p((-i1*k1-i2*k2)*S(1//(q-1)))-e2p((i1*k1-i2*k2)*S(1//(q-1)))-e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^8+2*q^7+3*q^6+4*q^5+4*q^4+4*q^3+3*q^2+2*q+1)*e2p(S(0)),
	(q^6+3*q^4+2*q^5+4*q^3+3*q^2+2*q+1)*e2p(S(0)),
	(4*q^3+2*q^4+3*q^2+2*q+1)*e2p(S(0)),
	(q^4+4*q^3+3*q^2+2*q+1)*e2p(S(0)),
	(2*q^3+3*q^2+2*q+1)*e2p(S(0)),
	(q^2+2*q+1)*e2p(S(0)),
	(q^2+2*q+1)*e2p(S(0)),
	(2*q^2+2*q+1)*e2p(S(0)),
	(2*q^2+2*q+1)*e2p(S(0)),
	(2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^3+q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))*q^2+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^3+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+e2p((-i1*k1)*S(1//(q-1)))+q^4+2*q^2+2*q^3+2*q+1+e2p((-i1*k2)*S(1//(q-1)))*q^3+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))*q^2+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k2)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q^2+2*q+1+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))*q^2+q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+q^2+2*q+1+e2p((-i1*k2)*S(1//(q-1)))*q^2+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+2*q+1+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+1+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+1+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1))),
	(q^4+2*q^2+2*q^3+2*q+1)*e2p(S(0)),
	(q^2+2*q+1)*e2p(S(0)),
	(q^2+2*q+1)*e2p(S(0)),
	(2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((i1*k1-i1*k2)*S(1//(q-1)))*q^3+2*e2p((i1*k1-i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q^3+2*e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q^2+2*e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q^3+2*e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q^2+2*e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	2*e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))+2*e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+2*e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))+2*e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q^2+2*e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))+e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))+e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))*q+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1)))*q+e2p((-i2*k1)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k2)*S(1//(q-1)))*q+e2p((i2*k2)*S(1//(q-1)))+e2p((-i2*k2)*S(1//(q-1)))*q+e2p((-i2*k2)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k2)*S(1//(q-1)))+e2p((-i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i2*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))*q+e2p((i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1-i3*k2)*S(1//(q-1)))+e2p((-i3*k1+i1*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k2)*S(1//(q-1)))+e2p((-i2*k1+i3*k2)*S(1//(q-1)))+e2p((-i3*k1-i2*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k2)*S(1//(q-1)))+e2p((-i3*k1+i2*k2)*S(1//(q-1)))+e2p((-i3*k1-i1*k2)*S(1//(q-1)))+e2p((-i2*k1-i3*k2)*S(1//(q-1)))+e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i2*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1)))+e2p((-i1*k1-i3*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1-i3*k2)*S(1//(q-1)))+e2p((-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9+2*q^8+3*q^7+4*q^6+4*q^5+4*q^4+3*q^3+2*q^2+q)*e2p(S(0)),
	(2*q^4+q^5+2*q^3+2*q^2+q)*e2p(S(0)),
	(2*q^5+3*q^3+4*q^4+2*q^2+q)*e2p(S(0)),
	(2*q^4+2*q^3+2*q^2+q)*e2p(S(0)),
	(q^3+2*q^2+q)*e2p(S(0)),
	(3*q^2+q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^4*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))*q^2+e2p((i1*k1)*S(1//(q-1)))*q^3+q*e2p((i1*k1)*S(1//(q-1)))+q^4*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+e2p((-i1*k1)*S(1//(q-1)))*q^3+q*e2p((-i1*k1)*S(1//(q-1)))+q^4+2*q^2+2*q^3+2*q+1+e2p((-i1*k2)*S(1//(q-1)))*q^4+e2p((-i1*k2)*S(1//(q-1)))*q^2+e2p((-i1*k2)*S(1//(q-1)))*q^3+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))*q^4+e2p((i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k2)*S(1//(q-1)))*q,
	e2p((i1*k1)*S(1//(q-1)))*q^2+q*e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+q*e2p((-i1*k1)*S(1//(q-1)))+q^2+2*q+1+e2p((-i1*k2)*S(1//(q-1)))*q^2+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k2)*S(1//(q-1)))*q,
	q*e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+q^2+2*q+1+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))*q,
	q*e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+2*q+1+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))*q,
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-q^4-2*q^2-2*q^3-2*q-1)*e2p(S(0)),
	(-q^2-2*q-1)*e2p(S(0)),
	(-q^2-2*q-1)*e2p(S(0)),
	(-2*q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	e2p((i1*k1-i1*k2)*S(1//(q-1)))*q^3+2*e2p((i1*k1-i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q^3+2*e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q^2+2*e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q^3+2*e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q^2+2*e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	2*e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))+2*e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+2*e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))+2*e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q^2+2*e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))+e2p((i1*k1-i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q^2+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q^2+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q,
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))+e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q,
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))*q+e2p((i2*k1)*S(1//(q-1)))*q+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1)))*q+e2p((-i2*k1)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))*q+e2p((-i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i2*k2)*S(1//(q-1)))*q+e2p((i2*k2)*S(1//(q-1)))+e2p((-i2*k2)*S(1//(q-1)))*q+e2p((-i2*k2)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1)))+e2p((i2*k2)*S(1//(q-1)))+e2p((-i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i2*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))*q+e2p((i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	-q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k2)*S(1//(q-1)))*q-e2p((-i1*k2)*S(1//(q-1)))-e2p((i1*k2)*S(1//(q-1)))*q-e2p((i1*k2)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k2)*S(1//(q-1)))-e2p((i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1-i1*k2)*S(1//(q-1)))*q-e2p((i1*k1-i1*k2)*S(1//(q-1)))-e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q-e2p((-i1*k1-i1*k2)*S(1//(q-1)))-e2p((i1*k1+i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2)*S(1//(q-1)))-e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q-e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	-e2p((i1*k1-i1*k2)*S(1//(q-1)))-e2p((-i1*k1-i1*k2)*S(1//(q-1)))-e2p((i1*k1+i1*k2)*S(1//(q-1)))-e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1-i3*k2)*S(1//(q-1)))+e2p((-i3*k1+i1*k2)*S(1//(q-1)))+e2p((i3*k1+i1*k2)*S(1//(q-1)))+e2p((-i2*k1+i3*k2)*S(1//(q-1)))+e2p((-i3*k1-i2*k2)*S(1//(q-1)))+e2p((i3*k1-i1*k2)*S(1//(q-1)))+e2p((-i3*k1+i2*k2)*S(1//(q-1)))+e2p((-i3*k1-i1*k2)*S(1//(q-1)))+e2p((-i2*k1-i3*k2)*S(1//(q-1)))+e2p((i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1-i2*k2)*S(1//(q-1)))+e2p((i2*k1+i3*k2)*S(1//(q-1)))+e2p((-i1*k1-i3*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1-i3*k2)*S(1//(q-1)))+e2p((-i1*k1+i3*k2)*S(1//(q-1)))+e2p((i3*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+i2*k2)*S(1//(q-1)))-e2p((-i2*k1-i1*k2)*S(1//(q-1)))-e2p((i2*k1+i1*k2)*S(1//(q-1)))-e2p((-i1*k1-i2*k2)*S(1//(q-1)))-e2p((i1*k1-i2*k2)*S(1//(q-1)))-e2p((-i2*k1+i1*k2)*S(1//(q-1)))-e2p((i2*k1-i1*k2)*S(1//(q-1)))-e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^8+q^6-q^2-1)*e2p(S(0)),
	(-q^5-q^3-q^2-1)*e2p(S(0)),
	(q^5+q^4-q^2-1)*e2p(S(0)),
	(q^4-q^3-q^2-1)*e2p(S(0)),
	(-q^3-q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-q^2-1)*e2p(S(0)),
	(-q^2-1)*e2p(S(0)),
	(-q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	q^4*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))+q^4*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))*q^2-e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))*q^2-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))*q^2-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((-i1*k2)*S(1//(q+1)))*q^2-e2p((-i1*k2)*S(1//(q+1)))*q^3-e2p((-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q^2-e2p((i1*k2)*S(1//(q+1)))*q^3-e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1))),
	-e2p((-i1*k2)*S(1//(q+1)))*q^2-e2p((-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q^2-e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1))),
	-e2p((-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1))),
	-e2p((-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1))),
	-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1))),
	-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i1*k2)*S(1//(q+1)))*q^3-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q^3-e2p((i1*k2)*S(1//(q+1))),
	-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1))),
	-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1))),
	q^2-1+e2p((-2*i1*k1)*S(1//(q-1)))*q-e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))*q-e2p((2*i1*k1)*S(1//(q-1))),
	q-1+e2p((-2*i1*k1)*S(1//(q-1)))*q-e2p((-2*i1*k1)*S(1//(q-1)))+e2p((2*i1*k1)*S(1//(q-1)))*q-e2p((2*i1*k1)*S(1//(q-1))),
	-q-1-e2p((-2*i1*k1)*S(1//(q-1)))-e2p((2*i1*k1)*S(1//(q-1))),
	-1-e2p((-2*i1*k1)*S(1//(q-1)))-e2p((2*i1*k1)*S(1//(q-1))),
	(q^2-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))*q-e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))*q-e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))*q-e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))*q-e2p((i2*k1-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1-i2*k1)*S(1//(q-1)))-e2p((-i2*k1-i1*k1)*S(1//(q-1)))-e2p((i1*k1+i2*k1)*S(1//(q-1)))-e2p((i2*k1-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))*q-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))*q-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))*q-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))*q-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1))),
	-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1))),
	q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((q*i2*k2-i2*k2+2*i1*k1*q+2*i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2+2*i1*k1*q+2*i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2-2*i1*k1*q-2*i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2-2*i1*k1*q-2*i1*k1)*S(1//(q^2-1)))-e2p((i2*k2)*S(1//(q+1)))*q-e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1)))*q-e2p((-i2*k2)*S(1//(q+1))),
	-e2p((q*i2*k2-i2*k2+2*i1*k1*q+2*i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2+2*i1*k1*q+2*i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2-2*i1*k1*q-2*i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2-2*i1*k1*q-2*i1*k1)*S(1//(q^2-1)))-e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i2*k2)*S(1//(q+1)))*q-e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1)))*q-e2p((-i2*k2)*S(1//(q+1))),
	-e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	-e2p((-i3*k2*q+i3*k2-i1*k1*q-q*i2*k1-i1*k1-i2*k1)*S(1//(q^2-1)))-e2p((i3*k2*q-i3*k2+q*i2*k1-i1*k1*q+i2*k1-i1*k1)*S(1//(q^2-1)))-e2p((i3*k2*q-i3*k2+i1*k1*q+q*i2*k1+i1*k1+i2*k1)*S(1//(q^2-1)))-e2p((-i3*k2*q+i3*k2+i1*k1*q-q*i2*k1+i1*k1-i2*k1)*S(1//(q^2-1)))-e2p((-i3*k2*q+i3*k2+i1*k1*q+q*i2*k1+i1*k1+i2*k1)*S(1//(q^2-1)))-e2p((-i3*k2*q+i3*k2+q*i2*k1-i1*k1*q+i2*k1-i1*k1)*S(1//(q^2-1)))-e2p((i3*k2*q-i3*k2-q*i2*k1+i1*k1*q-i2*k1+i1*k1)*S(1//(q^2-1)))-e2p((i3*k2*q-i3*k2-q*i2*k1-i1*k1*q-i2*k1-i1*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9+q^7-q^3-q)*e2p(S(0)),
	(-q^6-q^4-q^3-q)*e2p(S(0)),
	(q^5-q^3+q^4-q)*e2p(S(0)),
	(-q^3-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(-q^2-q)*e2p(S(0)),
	(-q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^4*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))+q^4*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))*q^2-e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))*q^2-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))*q^2-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((-i1*k2)*S(1//(q+1)))*q^4-e2p((-i1*k2)*S(1//(q+1)))*q^2-e2p((-i1*k2)*S(1//(q+1)))*q^3-e2p((-i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1)))*q^4-e2p((i1*k2)*S(1//(q+1)))*q^2-e2p((i1*k2)*S(1//(q+1)))*q^3-e2p((i1*k2)*S(1//(q+1)))*q,
	-e2p((-i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1)))*q,
	-e2p((-i1*k2)*S(1//(q+1)))*q^2-e2p((-i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1)))*q^2-e2p((i1*k2)*S(1//(q+1)))*q,
	-e2p((-i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i1*k2)*S(1//(q+1)))*q^3+e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))*q^3+e2p((i1*k2)*S(1//(q+1))),
	e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1))),
	e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1))),
	q^2-1+e2p((-2*i1*k1)*S(1//(q-1)))*q^2-e2p((-2*i1*k1)*S(1//(q-1)))*q+e2p((2*i1*k1)*S(1//(q-1)))*q^2-e2p((2*i1*k1)*S(1//(q-1)))*q,
	(q-1)*e2p(S(0)),
	-q-1-e2p((-2*i1*k1)*S(1//(q-1)))*q-e2p((2*i1*k1)*S(1//(q-1)))*q,
	(-1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((i1*k1-i2*k1)*S(1//(q-1)))*q-e2p((i1*k1-i2*k1)*S(1//(q-1)))+e2p((-i2*k1-i1*k1)*S(1//(q-1)))*q-e2p((-i2*k1-i1*k1)*S(1//(q-1)))+e2p((i1*k1+i2*k1)*S(1//(q-1)))*q-e2p((i1*k1+i2*k1)*S(1//(q-1)))+e2p((i2*k1-i1*k1)*S(1//(q-1)))*q-e2p((i2*k1-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1-i2*k1)*S(1//(q-1)))-e2p((-i2*k1-i1*k1)*S(1//(q-1)))-e2p((i1*k1+i2*k1)*S(1//(q-1)))-e2p((i2*k1-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))*q-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))*q-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))*q-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))*q-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1))),
	-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1))),
	-q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	-q*e2p((-q*i2*k2+i2*k2+2*i1*k1*q+2*i1*k1)*S(1//(q^2-1)))-q*e2p((q*i2*k2-i2*k2+2*i1*k1*q+2*i1*k1)*S(1//(q^2-1)))-q*e2p((q*i2*k2-i2*k2-2*i1*k1*q-2*i1*k1)*S(1//(q^2-1)))-q*e2p((-q*i2*k2+i2*k2-2*i1*k1*q-2*i1*k1)*S(1//(q^2-1)))-e2p((i2*k2)*S(1//(q+1)))*q-e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1)))*q-e2p((-i2*k2)*S(1//(q+1))),
	-e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k2)*S(1//(q+1)))*q+e2p((i2*k2)*S(1//(q+1)))+e2p((-i2*k2)*S(1//(q+1)))*q+e2p((-i2*k2)*S(1//(q+1))),
	e2p((i2*k2)*S(1//(q+1)))+e2p((-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	-e2p((-i3*k2*q+i3*k2-i1*k1*q-q*i2*k1-i1*k1-i2*k1)*S(1//(q^2-1)))-e2p((i3*k2*q-i3*k2+q*i2*k1-i1*k1*q+i2*k1-i1*k1)*S(1//(q^2-1)))-e2p((i3*k2*q-i3*k2+i1*k1*q+q*i2*k1+i1*k1+i2*k1)*S(1//(q^2-1)))-e2p((-i3*k2*q+i3*k2+i1*k1*q-q*i2*k1+i1*k1-i2*k1)*S(1//(q^2-1)))-e2p((-i3*k2*q+i3*k2+i1*k1*q+q*i2*k1+i1*k1+i2*k1)*S(1//(q^2-1)))-e2p((-i3*k2*q+i3*k2+q*i2*k1-i1*k1*q+i2*k1-i1*k1)*S(1//(q^2-1)))-e2p((i3*k2*q-i3*k2-q*i2*k1+i1*k1*q-i2*k1+i1*k1)*S(1//(q^2-1)))-e2p((i3*k2*q-i3*k2-q*i2*k1-i1*k1*q-i2*k1-i1*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))+e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^8+q^6-q^2-1)*e2p(S(0)),
	(q^6+q^4-q^2-1)*e2p(S(0)),
	(-q^2-1)*e2p(S(0)),
	(q^4-q^2-1)*e2p(S(0)),
	(-q^2-1)*e2p(S(0)),
	(-q^2-1)*e2p(S(0)),
	(-q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q^4-1)*e2p(S(0)),
	(-q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(q^4-1)*e2p(S(0)),
	(-q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^3-e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^3-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q+1)))*q^3-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^3-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i1*k1*q)*S(1//(q^2-1)))-e2p((i1*k1)*S(1//(q^2-1)))-e2p((-i1*k1)*S(1//(q^2-1)))-e2p((i1*k1*q)*S(1//(q^2-1))),
	-e2p((-i1*k1*q)*S(1//(q^2-1)))-e2p((i1*k1)*S(1//(q^2-1)))-e2p((-i1*k1)*S(1//(q^2-1)))-e2p((i1*k1*q)*S(1//(q^2-1))),
	q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i1*k1*q)*S(1//(q^2-1)))-e2p((i1*k1)*S(1//(q^2-1)))-e2p((-i1*k1)*S(1//(q^2-1)))-e2p((i1*k1*q)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-e2p((-i1*k1*q)*S(1//(q^2-1)))-e2p((i1*k1)*S(1//(q^2-1)))-e2p((-i1*k1)*S(1//(q^2-1)))-e2p((i1*k1*q)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9+q^7-q^3-q)*e2p(S(0)),
	(q^5-q)*e2p(S(0)),
	(-q^3-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(q^3-q)*e2p(S(0)),
	(-q^2-q)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4-1)*e2p(S(0)),
	(-q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-q^4+1)*e2p(S(0)),
	(q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^3-e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^3-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q+1)))*q^3+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^3+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q-1)))*q^2-q*e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2-q*e2p((-i1*k1)*S(1//(q-1))),
	-q*e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q+1)))*q^2-q*e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2-q*e2p((-i1*k1)*S(1//(q+1))),
	-q*e2p((-i1*k1)*S(1//(q+1)))-q*e2p((i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*e2p((-i1*k1*q)*S(1//(q^2-1)))-q*e2p((i1*k1)*S(1//(q^2-1)))-q*e2p((-i1*k1)*S(1//(q^2-1)))-q*e2p((i1*k1*q)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	-q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i1*k1*q)*S(1//(q^2-1)))-e2p((i1*k1)*S(1//(q^2-1)))-e2p((-i1*k1)*S(1//(q^2-1)))-e2p((i1*k1*q)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	e2p((-i1*k1*q)*S(1//(q^2-1)))+e2p((i1*k1)*S(1//(q^2-1)))+e2p((-i1*k1)*S(1//(q^2-1)))+e2p((i1*k1*q)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^8+q^6-q^2-1)*e2p(S(0)),
	(-q^6-q^4-q^2-1)*e2p(S(0)),
	(2*q^4-q^2-1)*e2p(S(0)),
	(q^4-q^2-1)*e2p(S(0)),
	(-q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-2*q^2-1)*e2p(S(0)),
	(-2*q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^3+q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))*q^2-e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^3+q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))*q^2-e2p((-i1*k1)*S(1//(q-1)))+q^4-1,
	q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))+q^2-1,
	-e2p((i1*k1)*S(1//(q-1)))*q^2+q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))*q^2+q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))-q^2-1,
	q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))-1,
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))-1,
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))-1,
	q^4-1-e2p((-i1*k2)*S(1//(q+1)))*q^2-e2p((-i1*k2)*S(1//(q+1)))*q^3-e2p((-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q^2-e2p((i1*k2)*S(1//(q+1)))*q^3-e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1))),
	q^2-1-e2p((-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1))),
	-q^2-1-e2p((-i1*k2)*S(1//(q+1)))*q^2-e2p((-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q^2-e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1))),
	-1-e2p((-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1))),
	-1-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1))),
	-1-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^2-e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2-e2p((-i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	e2p((-i1*k2)*S(1//(q+1)))*q^2-e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))*q^2-e2p((i1*k2)*S(1//(q+1))),
	-e2p((-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1))),
	e2p((-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1))),
	-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1))),
	q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))*q-e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1)))*q-e2p((-i2*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))-e2p((i2*k1)*S(1//(q-1)))-e2p((-i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((i2*k2)*S(1//(q+1)))*q-e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1)))*q-e2p((-i2*k2)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))*q-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))*q-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))*q-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))*q-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1))),
	-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1))),
	e2p((q*i1*k2-i1*k2-q*i2*k1-i2*k1)*S(1//(q^2-1)))*q-e2p((q*i1*k2-i1*k2-q*i2*k1-i2*k1)*S(1//(q^2-1)))+e2p((q*i1*k2-i1*k2+q*i2*k1+i2*k1)*S(1//(q^2-1)))*q-e2p((q*i1*k2-i1*k2+q*i2*k1+i2*k1)*S(1//(q^2-1)))+e2p((-q*i1*k2+i1*k2-q*i2*k1-i2*k1)*S(1//(q^2-1)))*q-e2p((-q*i1*k2+i1*k2-q*i2*k1-i2*k1)*S(1//(q^2-1)))+e2p((-q*i1*k2+i1*k2+q*i2*k1+i2*k1)*S(1//(q^2-1)))*q-e2p((-q*i1*k2+i1*k2+q*i2*k1+i2*k1)*S(1//(q^2-1))),
	-e2p((q*i1*k2-i1*k2-q*i2*k1-i2*k1)*S(1//(q^2-1)))-e2p((q*i1*k2-i1*k2+q*i2*k1+i2*k1)*S(1//(q^2-1)))-e2p((-q*i1*k2+i1*k2-q*i2*k1-i2*k1)*S(1//(q^2-1)))-e2p((-q*i1*k2+i1*k2+q*i2*k1+i2*k1)*S(1//(q^2-1))),
	-e2p((-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1)))-e2p((i2*k2)*S(1//(q+1)))*q-e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1)))*q-e2p((-i2*k2)*S(1//(q+1))),
	-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))-e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k2*q-i3*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((i3*k2*q-i3*k2-q*i2*k1-i2*k1)*S(1//(q^2-1)))-e2p((-i3*k2*q+i3*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((i3*k2*q-i3*k2+q*i2*k1+i2*k1)*S(1//(q^2-1)))-e2p((i3*k2*q-i3*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-i3*k2*q+i3*k2+q*i2*k1+i2*k1)*S(1//(q^2-1)))-e2p((-i3*k2*q+i3*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-i3*k2*q+i3*k2-q*i2*k1-i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	-e2p((i3*k2*q-i3*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((-i3*k2*q+i3*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((i3*k2*q-i3*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-i3*k2*q+i3*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9+q^7-q^3-q)*e2p(S(0)),
	(-q^5-2*q^3-q)*e2p(S(0)),
	(2*q^5-q^3-q)*e2p(S(0)),
	(-2*q^3-q)*e2p(S(0)),
	(-q^3-q)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(-q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^4*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))*q^2-e2p((i1*k1)*S(1//(q-1)))*q^3-q*e2p((i1*k1)*S(1//(q-1)))+q^4*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2-e2p((-i1*k1)*S(1//(q-1)))*q^3-q*e2p((-i1*k1)*S(1//(q-1)))+q^4-1,
	e2p((i1*k1)*S(1//(q-1)))*q^2-q*e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2-q*e2p((-i1*k1)*S(1//(q-1)))+q^2-1,
	-q*e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))-q^2-1,
	-q*e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))-1,
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-q^4+1-e2p((-i1*k2)*S(1//(q+1)))*q^4-e2p((-i1*k2)*S(1//(q+1)))*q^2-e2p((-i1*k2)*S(1//(q+1)))*q^3-e2p((-i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1)))*q^4-e2p((i1*k2)*S(1//(q+1)))*q^2-e2p((i1*k2)*S(1//(q+1)))*q^3-e2p((i1*k2)*S(1//(q+1)))*q,
	-q^2+1-e2p((-i1*k2)*S(1//(q+1)))*q^2-e2p((-i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1)))*q^2-e2p((i1*k2)*S(1//(q+1)))*q,
	q^2+1-e2p((-i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1)))*q,
	1-e2p((-i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1)))*q,
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^2-e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2-e2p((-i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((-i1*k2)*S(1//(q+1)))*q^2+e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q^2+e2p((i1*k2)*S(1//(q+1))),
	e2p((-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1))),
	-e2p((-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1))),
	e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1))),
	q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))+e2p((i2*k1)*S(1//(q-1)))*q-e2p((i2*k1)*S(1//(q-1)))+e2p((-i2*k1)*S(1//(q-1)))*q-e2p((-i2*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))-e2p((i2*k1)*S(1//(q-1)))-e2p((-i2*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))*q-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))*q-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))*q-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))*q-e2p((i2*k2)*S(1//(q+1)))*q-e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1)))*q-e2p((-i2*k2)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))-e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))*q-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))*q-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))*q-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))*q-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1))),
	-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1))),
	-e2p((q*i1*k2-i1*k2-q*i2*k1-i2*k1)*S(1//(q^2-1)))*q+e2p((q*i1*k2-i1*k2-q*i2*k1-i2*k1)*S(1//(q^2-1)))-e2p((q*i1*k2-i1*k2+q*i2*k1+i2*k1)*S(1//(q^2-1)))*q+e2p((q*i1*k2-i1*k2+q*i2*k1+i2*k1)*S(1//(q^2-1)))-e2p((-q*i1*k2+i1*k2-q*i2*k1-i2*k1)*S(1//(q^2-1)))*q+e2p((-q*i1*k2+i1*k2-q*i2*k1-i2*k1)*S(1//(q^2-1)))-e2p((-q*i1*k2+i1*k2+q*i2*k1+i2*k1)*S(1//(q^2-1)))*q+e2p((-q*i1*k2+i1*k2+q*i2*k1+i2*k1)*S(1//(q^2-1))),
	e2p((q*i1*k2-i1*k2-q*i2*k1-i2*k1)*S(1//(q^2-1)))+e2p((q*i1*k2-i1*k2+q*i2*k1+i2*k1)*S(1//(q^2-1)))+e2p((-q*i1*k2+i1*k2-q*i2*k1-i2*k1)*S(1//(q^2-1)))+e2p((-q*i1*k2+i1*k2+q*i2*k1+i2*k1)*S(1//(q^2-1))),
	e2p((-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1)))+e2p((i2*k2)*S(1//(q+1)))*q+e2p((i2*k2)*S(1//(q+1)))+e2p((-i2*k2)*S(1//(q+1)))*q+e2p((-i2*k2)*S(1//(q+1))),
	e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))+e2p((i2*k2)*S(1//(q+1)))+e2p((-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k2*q-i3*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((i3*k2*q-i3*k2-q*i2*k1-i2*k1)*S(1//(q^2-1)))-e2p((-i3*k2*q+i3*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((i3*k2*q-i3*k2+q*i2*k1+i2*k1)*S(1//(q^2-1)))-e2p((i3*k2*q-i3*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-i3*k2*q+i3*k2+q*i2*k1+i2*k1)*S(1//(q^2-1)))-e2p((-i3*k2*q+i3*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-i3*k2*q+i3*k2-q*i2*k1-i2*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	e2p((i3*k2*q-i3*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))+e2p((-i3*k2*q+i3*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))+e2p((i3*k2*q-i3*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((-i3*k2*q+i3*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))+e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))+e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^8+q^6-q^2-1)*e2p(S(0)),
	(q^5-q^2-1+q^3)*e2p(S(0)),
	(-q^2-1-q^5+q^4)*e2p(S(0)),
	(q^4-q^2-1+q^3)*e2p(S(0)),
	(q^3-q^2-1)*e2p(S(0)),
	(-q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-q^2-1)*e2p(S(0)),
	(-q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	e2p((-i1*k2)*S(1//(q-1)))*q^3+e2p((-i1*k2)*S(1//(q-1)))*q-e2p((-i1*k2)*S(1//(q-1)))*q^2-e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q^3+e2p((i1*k2)*S(1//(q-1)))*q-e2p((i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k2)*S(1//(q-1))),
	-e2p((-i1*k2)*S(1//(q-1)))*q^2+e2p((-i1*k2)*S(1//(q-1)))*q-e2p((-i1*k2)*S(1//(q-1)))-e2p((i1*k2)*S(1//(q-1)))*q^2+e2p((i1*k2)*S(1//(q-1)))*q-e2p((i1*k2)*S(1//(q-1))),
	e2p((-i1*k2)*S(1//(q-1)))*q-e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q-e2p((i1*k2)*S(1//(q-1))),
	e2p((-i1*k2)*S(1//(q-1)))*q-e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q-e2p((i1*k2)*S(1//(q-1))),
	-e2p((-i1*k2)*S(1//(q-1)))-e2p((i1*k2)*S(1//(q-1))),
	-e2p((-i1*k2)*S(1//(q-1)))-e2p((i1*k2)*S(1//(q-1))),
	q^4*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q^4*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))*q^2-e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))*q^2-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	e2p((-i1*k2)*S(1//(q-1)))*q^3-e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q^3-e2p((i1*k2)*S(1//(q-1))),
	-e2p((-i1*k2)*S(1//(q-1)))-e2p((i1*k2)*S(1//(q-1))),
	-e2p((-i1*k2)*S(1//(q-1)))-e2p((i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	q^2-1-e2p((2*i1*k1)*S(1//(q+1)))*q-e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1)))*q-e2p((-2*i1*k1)*S(1//(q+1))),
	-q-1-e2p((2*i1*k1)*S(1//(q+1)))*q-e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1)))*q-e2p((-2*i1*k1)*S(1//(q+1))),
	q-1-e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1))),
	-1-e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k2)*S(1//(q-1)))*q-e2p((i2*k2)*S(1//(q-1)))+e2p((-i2*k2)*S(1//(q-1)))*q-e2p((-i2*k2)*S(1//(q-1))),
	-e2p((i2*k2)*S(1//(q-1)))-e2p((-i2*k2)*S(1//(q-1))),
	e2p((-q*i2*k1+i2*k1-q*i1*k2-i1*k2)*S(1//(q^2-1)))*q-e2p((-q*i2*k1+i2*k1-q*i1*k2-i1*k2)*S(1//(q^2-1)))+e2p((-q*i2*k1+i2*k1+q*i1*k2+i1*k2)*S(1//(q^2-1)))*q-e2p((-q*i2*k1+i2*k1+q*i1*k2+i1*k2)*S(1//(q^2-1)))+e2p((q*i2*k1-i2*k1-q*i1*k2-i1*k2)*S(1//(q^2-1)))*q-e2p((q*i2*k1-i2*k1-q*i1*k2-i1*k2)*S(1//(q^2-1)))+e2p((q*i2*k1-i2*k1+q*i1*k2+i1*k2)*S(1//(q^2-1)))*q-e2p((q*i2*k1-i2*k1+q*i1*k2+i1*k2)*S(1//(q^2-1))),
	-e2p((-q*i2*k1+i2*k1-q*i1*k2-i1*k2)*S(1//(q^2-1)))-e2p((-q*i2*k1+i2*k1+q*i1*k2+i1*k2)*S(1//(q^2-1)))-e2p((q*i2*k1-i2*k1-q*i1*k2-i1*k2)*S(1//(q^2-1)))-e2p((q*i2*k1-i2*k1+q*i1*k2+i1*k2)*S(1//(q^2-1))),
	-q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-2*i1*k1*q+2*i1*k1+q*i2*k2+i2*k2)*S(1//(q^2-1)))-e2p((2*i1*k1*q-2*i1*k1+q*i2*k2+i2*k2)*S(1//(q^2-1)))-e2p((2*i1*k1*q-2*i1*k1-q*i2*k2-i2*k2)*S(1//(q^2-1)))-e2p((-2*i1*k1*q+2*i1*k1-q*i2*k2-i2*k2)*S(1//(q^2-1)))+e2p((i2*k2)*S(1//(q-1)))*q-e2p((i2*k2)*S(1//(q-1)))+e2p((-i2*k2)*S(1//(q-1)))*q-e2p((-i2*k2)*S(1//(q-1))),
	-e2p((-2*i1*k1*q+2*i1*k1+q*i2*k2+i2*k2)*S(1//(q^2-1)))-e2p((2*i1*k1*q-2*i1*k1+q*i2*k2+i2*k2)*S(1//(q^2-1)))-e2p((2*i1*k1*q-2*i1*k1-q*i2*k2-i2*k2)*S(1//(q^2-1)))-e2p((-2*i1*k1*q+2*i1*k1-q*i2*k2-i2*k2)*S(1//(q^2-1)))-e2p((i2*k2)*S(1//(q-1)))-e2p((-i2*k2)*S(1//(q-1))),
	-e2p((-i2*k1-i1*k1)*S(1//(q+1)))*q-e2p((-i2*k1-i1*k1)*S(1//(q+1)))-e2p((i1*k1+i2*k1)*S(1//(q+1)))*q-e2p((i1*k1+i2*k1)*S(1//(q+1)))-e2p((i1*k1-i2*k1)*S(1//(q+1)))*q-e2p((i1*k1-i2*k1)*S(1//(q+1)))-e2p((i2*k1-i1*k1)*S(1//(q+1)))*q-e2p((i2*k1-i1*k1)*S(1//(q+1))),
	-e2p((-i2*k1-i1*k1)*S(1//(q+1)))-e2p((i1*k1+i2*k1)*S(1//(q+1)))-e2p((i1*k1-i2*k1)*S(1//(q+1)))-e2p((i2*k1-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1*q-i1*k1-q*i2*k2-i2*k2)*S(1//(q^2-1)))-e2p((i1*k1*q-i1*k1+q*i2*k2+i2*k2)*S(1//(q^2-1)))-e2p((-i1*k1*q+i1*k1+q*i2*k2+i2*k2)*S(1//(q^2-1)))-e2p((-i1*k1*q+i1*k1-q*i2*k2-i2*k2)*S(1//(q^2-1))),
	-e2p((-q*i3*k1+i3*k1-q*i2*k1+i2*k1+q*i1*k2+i1*k2)*S(1//(q^2-1)))-e2p((-q*i3*k1+i3*k1-q*i2*k1+i2*k1-q*i1*k2-i1*k2)*S(1//(q^2-1)))-e2p((-q*i2*k1+i2*k1+q*i3*k1-i3*k1+q*i1*k2+i1*k2)*S(1//(q^2-1)))-e2p((q*i2*k1-i2*k1+q*i3*k1-i3*k1+q*i1*k2+i1*k2)*S(1//(q^2-1)))-e2p((q*i2*k1-i2*k1+q*i3*k1-i3*k1-q*i1*k2-i1*k2)*S(1//(q^2-1)))-e2p((q*i2*k1-i2*k1-q*i3*k1+i3*k1-q*i1*k2-i1*k2)*S(1//(q^2-1)))-e2p((q*i2*k1-i2*k1-q*i3*k1+i3*k1+q*i1*k2+i1*k2)*S(1//(q^2-1)))-e2p((-q*i2*k1+i2*k1+q*i3*k1-i3*k1-q*i1*k2-i1*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9+q^7-q^3-q)*e2p(S(0)),
	(q^6+q^4-q-q^3)*e2p(S(0)),
	(-q^3-q+q^5-q^4)*e2p(S(0)),
	(-q^3-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(-q^2-q)*e2p(S(0)),
	(-q^2-q)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(q^2-q)*e2p(S(0)),
	(-q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i1*k2)*S(1//(q-1)))*q^4+e2p((-i1*k2)*S(1//(q-1)))*q^2-e2p((-i1*k2)*S(1//(q-1)))*q^3-e2p((-i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))*q^4+e2p((i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k2)*S(1//(q-1)))*q^3-e2p((i1*k2)*S(1//(q-1)))*q,
	-e2p((-i1*k2)*S(1//(q-1)))*q-e2p((i1*k2)*S(1//(q-1)))*q,
	e2p((-i1*k2)*S(1//(q-1)))*q^2-e2p((-i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k2)*S(1//(q-1)))*q,
	-e2p((-i1*k2)*S(1//(q-1)))*q-e2p((i1*k2)*S(1//(q-1)))*q,
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q^4*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q^4*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))*q^2+e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))*q^2+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((-i1*k2)*S(1//(q-1)))*q^3-e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q^3-e2p((i1*k2)*S(1//(q-1))),
	-e2p((-i1*k2)*S(1//(q-1)))-e2p((i1*k2)*S(1//(q-1))),
	-e2p((-i1*k2)*S(1//(q-1)))-e2p((i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	-q^2+1-e2p((2*i1*k1)*S(1//(q+1)))*q^2-e2p((2*i1*k1)*S(1//(q+1)))*q-e2p((-2*i1*k1)*S(1//(q+1)))*q^2-e2p((-2*i1*k1)*S(1//(q+1)))*q,
	(q+1)*e2p(S(0)),
	-q+1-e2p((2*i1*k1)*S(1//(q+1)))*q-e2p((-2*i1*k1)*S(1//(q+1)))*q,
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k2)*S(1//(q-1)))*q-e2p((i2*k2)*S(1//(q-1)))+e2p((-i2*k2)*S(1//(q-1)))*q-e2p((-i2*k2)*S(1//(q-1))),
	-e2p((i2*k2)*S(1//(q-1)))-e2p((-i2*k2)*S(1//(q-1))),
	-e2p((-q*i2*k1+i2*k1-q*i1*k2-i1*k2)*S(1//(q^2-1)))*q+e2p((-q*i2*k1+i2*k1-q*i1*k2-i1*k2)*S(1//(q^2-1)))-e2p((-q*i2*k1+i2*k1+q*i1*k2+i1*k2)*S(1//(q^2-1)))*q+e2p((-q*i2*k1+i2*k1+q*i1*k2+i1*k2)*S(1//(q^2-1)))-e2p((q*i2*k1-i2*k1-q*i1*k2-i1*k2)*S(1//(q^2-1)))*q+e2p((q*i2*k1-i2*k1-q*i1*k2-i1*k2)*S(1//(q^2-1)))-e2p((q*i2*k1-i2*k1+q*i1*k2+i1*k2)*S(1//(q^2-1)))*q+e2p((q*i2*k1-i2*k1+q*i1*k2+i1*k2)*S(1//(q^2-1))),
	e2p((-q*i2*k1+i2*k1-q*i1*k2-i1*k2)*S(1//(q^2-1)))+e2p((-q*i2*k1+i2*k1+q*i1*k2+i1*k2)*S(1//(q^2-1)))+e2p((q*i2*k1-i2*k1-q*i1*k2-i1*k2)*S(1//(q^2-1)))+e2p((q*i2*k1-i2*k1+q*i1*k2+i1*k2)*S(1//(q^2-1))),
	-q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*e2p((-2*i1*k1*q+2*i1*k1+q*i2*k2+i2*k2)*S(1//(q^2-1)))-q*e2p((2*i1*k1*q-2*i1*k1+q*i2*k2+i2*k2)*S(1//(q^2-1)))-q*e2p((2*i1*k1*q-2*i1*k1-q*i2*k2-i2*k2)*S(1//(q^2-1)))-q*e2p((-2*i1*k1*q+2*i1*k1-q*i2*k2-i2*k2)*S(1//(q^2-1)))-e2p((i2*k2)*S(1//(q-1)))*q+e2p((i2*k2)*S(1//(q-1)))-e2p((-i2*k2)*S(1//(q-1)))*q+e2p((-i2*k2)*S(1//(q-1))),
	e2p((i2*k2)*S(1//(q-1)))+e2p((-i2*k2)*S(1//(q-1))),
	e2p((-i2*k1-i1*k1)*S(1//(q+1)))*q+e2p((-i2*k1-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i2*k1)*S(1//(q+1)))*q+e2p((i1*k1+i2*k1)*S(1//(q+1)))+e2p((i1*k1-i2*k1)*S(1//(q+1)))*q+e2p((i1*k1-i2*k1)*S(1//(q+1)))+e2p((i2*k1-i1*k1)*S(1//(q+1)))*q+e2p((i2*k1-i1*k1)*S(1//(q+1))),
	e2p((-i2*k1-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i2*k1)*S(1//(q+1)))+e2p((i1*k1-i2*k1)*S(1//(q+1)))+e2p((i2*k1-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1*q-i1*k1-q*i2*k2-i2*k2)*S(1//(q^2-1)))-e2p((i1*k1*q-i1*k1+q*i2*k2+i2*k2)*S(1//(q^2-1)))-e2p((-i1*k1*q+i1*k1+q*i2*k2+i2*k2)*S(1//(q^2-1)))-e2p((-i1*k1*q+i1*k1-q*i2*k2-i2*k2)*S(1//(q^2-1))),
	e2p((-q*i3*k1+i3*k1-q*i2*k1+i2*k1+q*i1*k2+i1*k2)*S(1//(q^2-1)))+e2p((-q*i3*k1+i3*k1-q*i2*k1+i2*k1-q*i1*k2-i1*k2)*S(1//(q^2-1)))+e2p((-q*i2*k1+i2*k1+q*i3*k1-i3*k1+q*i1*k2+i1*k2)*S(1//(q^2-1)))+e2p((q*i2*k1-i2*k1+q*i3*k1-i3*k1+q*i1*k2+i1*k2)*S(1//(q^2-1)))+e2p((q*i2*k1-i2*k1+q*i3*k1-i3*k1-q*i1*k2-i1*k2)*S(1//(q^2-1)))+e2p((q*i2*k1-i2*k1-q*i3*k1+i3*k1-q*i1*k2-i1*k2)*S(1//(q^2-1)))+e2p((q*i2*k1-i2*k1-q*i3*k1+i3*k1+q*i1*k2+i1*k2)*S(1//(q^2-1)))+e2p((-q*i2*k1+i2*k1+q*i3*k1-i3*k1-q*i1*k2-i1*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^8-2*q^7-4*q^3+3*q^6+3*q^2-2*q+1-4*q^5+4*q^4)*e2p(S(0)),
	(-q^5+2*q^4+3*q^2-2*q+1-3*q^3)*e2p(S(0)),
	(-4*q^3-2*q+3*q^2+1-q^5+3*q^4)*e2p(S(0)),
	(q^4-2*q+3*q^2+1-3*q^3)*e2p(S(0)),
	(-q^3+3*q^2-2*q+1)*e2p(S(0)),
	(q^2-2*q+1)*e2p(S(0)),
	(3*q^2-2*q+1)*e2p(S(0)),
	(q^2-2*q+1)*e2p(S(0)),
	(q^2-2*q+1)*e2p(S(0)),
	(-2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q^4*e2p((i1*k1)*S(1//(q+1)))+2*e2p((i1*k1)*S(1//(q+1)))*q^2-2*e2p((i1*k1)*S(1//(q+1)))*q^3-2*q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+q^4*e2p((-i1*k1)*S(1//(q+1)))+2*e2p((-i1*k1)*S(1//(q+1)))*q^2-2*e2p((-i1*k1)*S(1//(q+1)))*q^3-2*q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))*q^3-e2p((-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))*q^2+e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q^3-e2p((i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1)))*q^2+e2p((i1*k2)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))*q^2-e2p((-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))*q^2-e2p((i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1))),
	-2*q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-2*q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-2*i1*k1+i1*k2)*S(1//(q+1)))*q^2-e2p((-2*i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((-2*i1*k1+i1*k2)*S(1//(q+1)))+e2p((2*i1*k1-i1*k2)*S(1//(q+1)))*q^2-e2p((2*i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((2*i1*k1-i1*k2)*S(1//(q+1)))+e2p((-2*i1*k1-i1*k2)*S(1//(q+1)))*q^2-e2p((-2*i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((-2*i1*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))*q^3+2*e2p((-i1*k2)*S(1//(q+1)))*q^2-2*e2p((-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q^3+2*e2p((i1*k2)*S(1//(q+1)))*q^2-2*e2p((i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1)))+e2p((2*i1*k1+i1*k2)*S(1//(q+1)))*q^2-e2p((2*i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((2*i1*k1+i1*k2)*S(1//(q+1))),
	-e2p((-2*i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((-2*i1*k1+i1*k2)*S(1//(q+1)))-e2p((2*i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((2*i1*k1-i1*k2)*S(1//(q+1)))-e2p((-2*i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((-2*i1*k1-i1*k2)*S(1//(q+1)))-2*e2p((-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))-2*e2p((i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1)))-e2p((2*i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((2*i1*k1+i1*k2)*S(1//(q+1))),
	e2p((-2*i1*k1+i1*k2)*S(1//(q+1)))+e2p((2*i1*k1-i1*k2)*S(1//(q+1)))+e2p((-2*i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))+e2p((2*i1*k1+i1*k2)*S(1//(q+1))),
	(q^2-2*q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	q^2-2*q+1+e2p((i1*k1+i1*k2)*S(1//(q+1)))*q^2-2*e2p((i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((i1*k1+i1*k2)*S(1//(q+1)))+e2p((i1*k1-i1*k2)*S(1//(q+1)))*q^2-2*e2p((i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q^2-2*e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q^2-2*e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q+1)))-e2p((2*i1*k1)*S(1//(q+1)))*q+e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1)))*q+e2p((-2*i1*k1)*S(1//(q+1))),
	-q+1-e2p((i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((i1*k1+i1*k2)*S(1//(q+1)))-e2p((i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((i1*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q+1)))-e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q+1)))-e2p((2*i1*k1)*S(1//(q+1)))*q+e2p((2*i1*k1)*S(1//(q+1)))-e2p((-2*i1*k1)*S(1//(q+1)))*q+e2p((-2*i1*k1)*S(1//(q+1))),
	-q+1-e2p((i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((i1*k1+i1*k2)*S(1//(q+1)))-e2p((i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((i1*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q+1)))-e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q+1)))+e2p((2*i1*k1)*S(1//(q+1)))+e2p((-2*i1*k1)*S(1//(q+1))),
	1+e2p((i1*k1+i1*k2)*S(1//(q+1)))+e2p((i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1-i1*k2)*S(1//(q+1)))+e2p((2*i1*k1)*S(1//(q+1)))+e2p((-2*i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i2*k2)*S(1//(q+1)))*q+e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1)))*q+e2p((-i2*k2)*S(1//(q+1))),
	e2p((i2*k2)*S(1//(q+1)))+e2p((-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i2*k1-i1*k1)*S(1//(q+1)))*q+e2p((-i2*k1-i1*k1)*S(1//(q+1)))-e2p((i1*k1+i2*k1)*S(1//(q+1)))*q+e2p((i1*k1+i2*k1)*S(1//(q+1)))-e2p((i1*k1-i2*k1)*S(1//(q+1)))*q+e2p((i1*k1-i2*k1)*S(1//(q+1)))-e2p((-i1*k1-i2*k2)*S(1//(q+1)))*q+e2p((-i1*k1-i2*k2)*S(1//(q+1)))-e2p((i1*k1+i2*k2)*S(1//(q+1)))*q+e2p((i1*k1+i2*k2)*S(1//(q+1)))-e2p((-i1*k1+i2*k2)*S(1//(q+1)))*q+e2p((-i1*k1+i2*k2)*S(1//(q+1)))-e2p((i1*k1-i2*k2)*S(1//(q+1)))*q+e2p((i1*k1-i2*k2)*S(1//(q+1)))-e2p((i2*k1-i1*k1)*S(1//(q+1)))*q+e2p((i2*k1-i1*k1)*S(1//(q+1)))-e2p((i2*k1+i1*k2)*S(1//(q+1)))*q+e2p((i2*k1+i1*k2)*S(1//(q+1)))-e2p((-i2*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i2*k1-i1*k2)*S(1//(q+1)))-e2p((i2*k1-i1*k2)*S(1//(q+1)))*q+e2p((i2*k1-i1*k2)*S(1//(q+1)))-e2p((-i2*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i2*k1+i1*k2)*S(1//(q+1))),
	e2p((-i2*k1-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i2*k1)*S(1//(q+1)))+e2p((i1*k1-i2*k1)*S(1//(q+1)))+e2p((-i1*k1-i2*k2)*S(1//(q+1)))+e2p((i1*k1+i2*k2)*S(1//(q+1)))+e2p((-i1*k1+i2*k2)*S(1//(q+1)))+e2p((i1*k1-i2*k2)*S(1//(q+1)))+e2p((i2*k1-i1*k1)*S(1//(q+1)))+e2p((i2*k1+i1*k2)*S(1//(q+1)))+e2p((-i2*k1-i1*k2)*S(1//(q+1)))+e2p((i2*k1-i1*k2)*S(1//(q+1)))+e2p((-i2*k1+i1*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1+i2*k1+i1*k2)*S(1//(q+1)))*q+e2p((i1*k1+i2*k1+i1*k2)*S(1//(q+1)))-e2p((-i1*k1+i2*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1+i2*k1+i1*k2)*S(1//(q+1)))+e2p((2*i1*k1+i2*k2)*S(1//(q+1)))-e2p((-i1*k1+i2*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1+i2*k1-i1*k2)*S(1//(q+1)))+e2p((-2*i1*k1+i2*k2)*S(1//(q+1)))-e2p((-i1*k1-i2*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1-i2*k1-i1*k2)*S(1//(q+1)))+e2p((-2*i1*k1-i2*k2)*S(1//(q+1)))-e2p((i1*k1-i2*k1-i1*k2)*S(1//(q+1)))*q+e2p((i1*k1-i2*k1-i1*k2)*S(1//(q+1)))-e2p((i1*k1-i2*k1+i1*k2)*S(1//(q+1)))*q+e2p((i1*k1-i2*k1+i1*k2)*S(1//(q+1)))-e2p((i2*k1+i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((i2*k1+i1*k1-i1*k2)*S(1//(q+1)))+e2p((2*i1*k1-i2*k2)*S(1//(q+1)))-e2p((-i1*k1-i2*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1-i2*k1+i1*k2)*S(1//(q+1)))-e2p((i2*k2)*S(1//(q+1)))*q+e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1)))*q+e2p((-i2*k2)*S(1//(q+1))),
	e2p((i1*k1+i2*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i2*k1+i1*k2)*S(1//(q+1)))+e2p((2*i1*k1+i2*k2)*S(1//(q+1)))+e2p((-i1*k1+i2*k1-i1*k2)*S(1//(q+1)))+e2p((-2*i1*k1+i2*k2)*S(1//(q+1)))+e2p((-i1*k1-i2*k1-i1*k2)*S(1//(q+1)))+e2p((-2*i1*k1-i2*k2)*S(1//(q+1)))+e2p((i1*k1-i2*k1-i1*k2)*S(1//(q+1)))+e2p((i1*k1-i2*k1+i1*k2)*S(1//(q+1)))+e2p((i2*k1+i1*k1-i1*k2)*S(1//(q+1)))+e2p((2*i1*k1-i2*k2)*S(1//(q+1)))+e2p((-i1*k1-i2*k1+i1*k2)*S(1//(q+1)))+e2p((i2*k2)*S(1//(q+1)))+e2p((-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i1*k1-i2*k2)*S(1//(q+1)))+e2p((i1*k1+i2*k2)*S(1//(q+1)))+e2p((-i1*k1+i2*k2)*S(1//(q+1)))+e2p((i1*k1-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1-i1*k1-i2*k2)*S(1//(q+1)))+e2p((-i3*k1-i1*k1-i2*k2)*S(1//(q+1)))+e2p((i1*k1-i2*k1+i3*k2)*S(1//(q+1)))+e2p((-i1*k1-i2*k1-i3*k2)*S(1//(q+1)))+e2p((-i2*k1-i1*k1+i3*k2)*S(1//(q+1)))+e2p((i1*k1+i2*k1+i3*k2)*S(1//(q+1)))+e2p((i2*k1+i1*k1-i3*k2)*S(1//(q+1)))+e2p((i3*k1+i2*k1+i1*k2)*S(1//(q+1)))+e2p((i2*k1-i1*k1+i3*k2)*S(1//(q+1)))+e2p((-i3*k1+i2*k1+i1*k2)*S(1//(q+1)))+e2p((i2*k1+i3*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i3*k1+i2*k2)*S(1//(q+1)))+e2p((-i3*k1-i1*k1+i2*k2)*S(1//(q+1)))+e2p((-i2*k1+i1*k1-i3*k2)*S(1//(q+1)))+e2p((-i3*k1+i2*k1-i1*k2)*S(1//(q+1)))+e2p((i3*k1+i1*k1+i2*k2)*S(1//(q+1)))+e2p((-i2*k1+i3*k1-i1*k2)*S(1//(q+1)))+e2p((-i3*k1+i1*k1+i2*k2)*S(1//(q+1)))+e2p((-i3*k1-i2*k1-i1*k2)*S(1//(q+1)))+e2p((i2*k1-i1*k1-i3*k2)*S(1//(q+1)))+e2p((-i3*k1+i1*k1-i2*k2)*S(1//(q+1)))+e2p((-i3*k1-i2*k1+i1*k2)*S(1//(q+1)))+e2p((i3*k1-i2*k1+i1*k2)*S(1//(q+1)))+e2p((i3*k1+i1*k1-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9-2*q^8+3*q^7+3*q^3-4*q^6-2*q^2+q+4*q^5-4*q^4)*e2p(S(0)),
	(-q^6+2*q^5-3*q^4-2*q^2+q+3*q^3)*e2p(S(0)),
	(3*q^3+q-2*q^2+q^5-3*q^4)*e2p(S(0)),
	(-2*q^4+q-2*q^2+3*q^3)*e2p(S(0)),
	(2*q^3-2*q^2+q)*e2p(S(0)),
	(-q^2+q)*e2p(S(0)),
	(-q^2+q)*e2p(S(0)),
	(-q^2+q)*e2p(S(0)),
	(-q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q^4*e2p((i1*k1)*S(1//(q+1)))-2*e2p((i1*k1)*S(1//(q+1)))*q^2+2*e2p((i1*k1)*S(1//(q+1)))*q^3+2*q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-q^4*e2p((-i1*k1)*S(1//(q+1)))-2*e2p((-i1*k1)*S(1//(q+1)))*q^2+2*e2p((-i1*k1)*S(1//(q+1)))*q^3+2*q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))*q^4-e2p((-i1*k2)*S(1//(q+1)))*q^2+e2p((-i1*k2)*S(1//(q+1)))*q^3+e2p((-i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1)))*q^4-e2p((i1*k2)*S(1//(q+1)))*q^2+e2p((i1*k2)*S(1//(q+1)))*q^3+e2p((i1*k2)*S(1//(q+1)))*q,
	-e2p((i1*k1)*S(1//(q+1)))*q^2+2*q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1)))*q,
	-e2p((i1*k1)*S(1//(q+1)))*q^2+2*q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))*q^2+e2p((-i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1)))*q^2+e2p((i1*k2)*S(1//(q+1)))*q,
	-e2p((i1*k1)*S(1//(q+1)))+2*q*e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))+2*q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1)))*q,
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-2*i1*k1+i1*k2)*S(1//(q+1)))*q^3-e2p((-2*i1*k1+i1*k2)*S(1//(q+1)))*q^2+e2p((-2*i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((2*i1*k1-i1*k2)*S(1//(q+1)))*q^3-e2p((2*i1*k1-i1*k2)*S(1//(q+1)))*q^2+e2p((2*i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((-2*i1*k1-i1*k2)*S(1//(q+1)))*q^3-e2p((-2*i1*k1-i1*k2)*S(1//(q+1)))*q^2+e2p((-2*i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))*q^3-2*e2p((-i1*k2)*S(1//(q+1)))*q^2+2*e2p((-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))*q^3-2*e2p((i1*k2)*S(1//(q+1)))*q^2+2*e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1)))+e2p((2*i1*k1+i1*k2)*S(1//(q+1)))*q^3-e2p((2*i1*k1+i1*k2)*S(1//(q+1)))*q^2+e2p((2*i1*k1+i1*k2)*S(1//(q+1)))*q,
	e2p((-2*i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((2*i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((-2*i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))+2*e2p((-i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1)))+2*e2p((i1*k2)*S(1//(q+1)))*q+e2p((2*i1*k1+i1*k2)*S(1//(q+1)))*q,
	-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1))),
	(q^2-2*q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	-q^2+2*q-1-e2p((i1*k1+i1*k2)*S(1//(q+1)))*q^2+2*e2p((i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((i1*k1+i1*k2)*S(1//(q+1)))-e2p((i1*k1-i1*k2)*S(1//(q+1)))*q^2+2*e2p((i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((i1*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q^2+2*e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1+i1*k2)*S(1//(q+1)))-e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q^2+2*e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1-i1*k2)*S(1//(q+1)))-e2p((2*i1*k1)*S(1//(q+1)))*q^2+e2p((2*i1*k1)*S(1//(q+1)))*q-e2p((-2*i1*k1)*S(1//(q+1)))*q^2+e2p((-2*i1*k1)*S(1//(q+1)))*q,
	q-1+e2p((i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((i1*k1+i1*k2)*S(1//(q+1)))+e2p((i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1-i1*k2)*S(1//(q+1))),
	q-1+e2p((i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((i1*k1+i1*k2)*S(1//(q+1)))+e2p((i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1-i1*k2)*S(1//(q+1)))+e2p((2*i1*k1)*S(1//(q+1)))*q+e2p((-2*i1*k1)*S(1//(q+1)))*q,
	-1-e2p((i1*k1+i1*k2)*S(1//(q+1)))-e2p((i1*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k1+i1*k2)*S(1//(q+1)))-e2p((-i1*k1-i1*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i2*k2)*S(1//(q+1)))*q+e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1)))*q+e2p((-i2*k2)*S(1//(q+1))),
	e2p((i2*k2)*S(1//(q+1)))+e2p((-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i2*k1-i1*k1)*S(1//(q+1)))*q-e2p((-i2*k1-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i2*k1)*S(1//(q+1)))*q-e2p((i1*k1+i2*k1)*S(1//(q+1)))+e2p((i1*k1-i2*k1)*S(1//(q+1)))*q-e2p((i1*k1-i2*k1)*S(1//(q+1)))+e2p((-i1*k1-i2*k2)*S(1//(q+1)))*q-e2p((-i1*k1-i2*k2)*S(1//(q+1)))+e2p((i1*k1+i2*k2)*S(1//(q+1)))*q-e2p((i1*k1+i2*k2)*S(1//(q+1)))+e2p((-i1*k1+i2*k2)*S(1//(q+1)))*q-e2p((-i1*k1+i2*k2)*S(1//(q+1)))+e2p((i1*k1-i2*k2)*S(1//(q+1)))*q-e2p((i1*k1-i2*k2)*S(1//(q+1)))+e2p((i2*k1-i1*k1)*S(1//(q+1)))*q-e2p((i2*k1-i1*k1)*S(1//(q+1)))+e2p((i2*k1+i1*k2)*S(1//(q+1)))*q-e2p((i2*k1+i1*k2)*S(1//(q+1)))+e2p((-i2*k1-i1*k2)*S(1//(q+1)))*q-e2p((-i2*k1-i1*k2)*S(1//(q+1)))+e2p((i2*k1-i1*k2)*S(1//(q+1)))*q-e2p((i2*k1-i1*k2)*S(1//(q+1)))+e2p((-i2*k1+i1*k2)*S(1//(q+1)))*q-e2p((-i2*k1+i1*k2)*S(1//(q+1))),
	-e2p((-i2*k1-i1*k1)*S(1//(q+1)))-e2p((i1*k1+i2*k1)*S(1//(q+1)))-e2p((i1*k1-i2*k1)*S(1//(q+1)))-e2p((-i1*k1-i2*k2)*S(1//(q+1)))-e2p((i1*k1+i2*k2)*S(1//(q+1)))-e2p((-i1*k1+i2*k2)*S(1//(q+1)))-e2p((i1*k1-i2*k2)*S(1//(q+1)))-e2p((i2*k1-i1*k1)*S(1//(q+1)))-e2p((i2*k1+i1*k2)*S(1//(q+1)))-e2p((-i2*k1-i1*k2)*S(1//(q+1)))-e2p((i2*k1-i1*k2)*S(1//(q+1)))-e2p((-i2*k1+i1*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i2*k1+i1*k2)*S(1//(q+1)))*q-e2p((i1*k1+i2*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i2*k1+i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1+i2*k1+i1*k2)*S(1//(q+1)))+q*e2p((2*i1*k1+i2*k2)*S(1//(q+1)))+e2p((-i1*k1+i2*k1-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1+i2*k1-i1*k2)*S(1//(q+1)))+q*e2p((-2*i1*k1+i2*k2)*S(1//(q+1)))+e2p((-i1*k1-i2*k1-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1-i2*k1-i1*k2)*S(1//(q+1)))+q*e2p((-2*i1*k1-i2*k2)*S(1//(q+1)))+e2p((i1*k1-i2*k1-i1*k2)*S(1//(q+1)))*q-e2p((i1*k1-i2*k1-i1*k2)*S(1//(q+1)))+e2p((i1*k1-i2*k1+i1*k2)*S(1//(q+1)))*q-e2p((i1*k1-i2*k1+i1*k2)*S(1//(q+1)))+e2p((i2*k1+i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((i2*k1+i1*k1-i1*k2)*S(1//(q+1)))+q*e2p((2*i1*k1-i2*k2)*S(1//(q+1)))+e2p((-i1*k1-i2*k1+i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1-i2*k1+i1*k2)*S(1//(q+1)))+e2p((i2*k2)*S(1//(q+1)))*q-e2p((i2*k2)*S(1//(q+1)))+e2p((-i2*k2)*S(1//(q+1)))*q-e2p((-i2*k2)*S(1//(q+1))),
	-e2p((i1*k1+i2*k1+i1*k2)*S(1//(q+1)))-e2p((-i1*k1+i2*k1+i1*k2)*S(1//(q+1)))-e2p((-i1*k1+i2*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k1-i2*k1-i1*k2)*S(1//(q+1)))-e2p((i1*k1-i2*k1-i1*k2)*S(1//(q+1)))-e2p((i1*k1-i2*k1+i1*k2)*S(1//(q+1)))-e2p((i2*k1+i1*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k1-i2*k1+i1*k2)*S(1//(q+1)))-e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i1*k1-i2*k2)*S(1//(q+1)))+e2p((i1*k1+i2*k2)*S(1//(q+1)))+e2p((-i1*k1+i2*k2)*S(1//(q+1)))+e2p((i1*k1-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1-i1*k1-i2*k2)*S(1//(q+1)))-e2p((-i3*k1-i1*k1-i2*k2)*S(1//(q+1)))-e2p((i1*k1-i2*k1+i3*k2)*S(1//(q+1)))-e2p((-i1*k1-i2*k1-i3*k2)*S(1//(q+1)))-e2p((-i2*k1-i1*k1+i3*k2)*S(1//(q+1)))-e2p((i1*k1+i2*k1+i3*k2)*S(1//(q+1)))-e2p((i2*k1+i1*k1-i3*k2)*S(1//(q+1)))-e2p((i3*k1+i2*k1+i1*k2)*S(1//(q+1)))-e2p((i2*k1-i1*k1+i3*k2)*S(1//(q+1)))-e2p((-i3*k1+i2*k1+i1*k2)*S(1//(q+1)))-e2p((i2*k1+i3*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k1+i3*k1+i2*k2)*S(1//(q+1)))-e2p((-i3*k1-i1*k1+i2*k2)*S(1//(q+1)))-e2p((-i2*k1+i1*k1-i3*k2)*S(1//(q+1)))-e2p((-i3*k1+i2*k1-i1*k2)*S(1//(q+1)))-e2p((i3*k1+i1*k1+i2*k2)*S(1//(q+1)))-e2p((-i2*k1+i3*k1-i1*k2)*S(1//(q+1)))-e2p((-i3*k1+i1*k1+i2*k2)*S(1//(q+1)))-e2p((-i3*k1-i2*k1-i1*k2)*S(1//(q+1)))-e2p((i2*k1-i1*k1-i3*k2)*S(1//(q+1)))-e2p((-i3*k1+i1*k1-i2*k2)*S(1//(q+1)))-e2p((-i3*k1-i2*k1+i1*k2)*S(1//(q+1)))-e2p((i3*k1-i2*k1+i1*k2)*S(1//(q+1)))-e2p((i3*k1+i1*k1-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^8-2*q^7-4*q^3+3*q^6+3*q^2-2*q+1-4*q^5+4*q^4)*e2p(S(0)),
	(q^6+3*q^4-2*q^5-4*q^3-2*q+3*q^2+1)*e2p(S(0)),
	(-4*q^3+2*q^4+3*q^2-2*q+1)*e2p(S(0)),
	(q^4-4*q^3+3*q^2-2*q+1)*e2p(S(0)),
	(-2*q^3-2*q+3*q^2+1)*e2p(S(0)),
	(q^2-2*q+1)*e2p(S(0)),
	(q^2-2*q+1)*e2p(S(0)),
	(2*q^2-2*q+1)*e2p(S(0)),
	(2*q^2-2*q+1)*e2p(S(0)),
	(-2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^4+2*q^2-2*q^3-2*q+1)*e2p(S(0)),
	(q^2-2*q+1)*e2p(S(0)),
	(q^2-2*q+1)*e2p(S(0)),
	(-2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	q^4+2*q^2-2*q^3-2*q+1-e2p((i1*k1)*S(1//(q+1)))*q^3-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))*q^2+e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^3-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2+e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))*q^3-e2p((-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))*q^2+e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q^3-e2p((i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1)))*q^2+e2p((i1*k2)*S(1//(q+1))),
	q^2-2*q+1-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1))),
	q^2-2*q+1+e2p((i1*k1)*S(1//(q+1)))*q^2-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))*q^2-e2p((-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))*q^2-e2p((i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1))),
	-2*q+1-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1))),
	1+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1))),
	1+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1+i1*k2)*S(1//(q+1)))*q^3+2*e2p((i1*k1+i1*k2)*S(1//(q+1)))*q^2-2*e2p((i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((i1*k1+i1*k2)*S(1//(q+1)))-e2p((i1*k1-i1*k2)*S(1//(q+1)))*q^3+2*e2p((i1*k1-i1*k2)*S(1//(q+1)))*q^2-2*e2p((i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((i1*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q^3+2*e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q^2-2*e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q+1)))-e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q^3+2*e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q^2-2*e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q+1))),
	-2*e2p((i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((i1*k1+i1*k2)*S(1//(q+1)))-2*e2p((i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((i1*k1-i1*k2)*S(1//(q+1)))-2*e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q+1)))-2*e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q+1))),
	e2p((i1*k1+i1*k2)*S(1//(q+1)))+e2p((i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1-i1*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))-e2p((i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((i1*k1+i1*k2)*S(1//(q+1)))-e2p((i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((i1*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q+1)))-e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))*q^2-2*e2p((-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))*q^2-2*e2p((i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1))),
	-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i1*k2)*S(1//(q+1)))+e2p((i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1))),
	-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))-e2p((i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((i1*k1+i1*k2)*S(1//(q+1)))-e2p((i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((i1*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q+1)))-e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i1*k2)*S(1//(q+1)))+e2p((i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i2*k1)*S(1//(q+1)))*q+e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))*q+e2p((i2*k1)*S(1//(q+1)))-e2p((i2*k2)*S(1//(q+1)))*q+e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1)))*q+e2p((-i2*k2)*S(1//(q+1))),
	e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1)))+e2p((i2*k2)*S(1//(q+1)))+e2p((-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((i1*k1+i1*k2)*S(1//(q+1)))-e2p((i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((i1*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q+1)))-e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q+1))),
	e2p((i1*k1+i1*k2)*S(1//(q+1)))+e2p((i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1-i1*k2)*S(1//(q+1))),
	e2p((-i1*k1-i2*k2)*S(1//(q+1)))+e2p((i1*k1+i2*k2)*S(1//(q+1)))+e2p((-i1*k1+i2*k2)*S(1//(q+1)))+e2p((i1*k1-i2*k2)*S(1//(q+1)))-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))-e2p((-i2*k1)*S(1//(q+1)))*q+e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))*q+e2p((i2*k1)*S(1//(q+1)))+e2p((i2*k1+i1*k2)*S(1//(q+1)))+e2p((-i2*k1-i1*k2)*S(1//(q+1)))+e2p((i2*k1-i1*k2)*S(1//(q+1)))+e2p((-i2*k1+i1*k2)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1)))-e2p((i2*k2)*S(1//(q+1)))*q+e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1)))*q+e2p((-i2*k2)*S(1//(q+1))),
	e2p((-i1*k1-i2*k2)*S(1//(q+1)))+e2p((i1*k1+i2*k2)*S(1//(q+1)))+e2p((-i1*k1+i2*k2)*S(1//(q+1)))+e2p((i1*k1-i2*k2)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))+e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1)))+e2p((i2*k1+i1*k2)*S(1//(q+1)))+e2p((-i2*k1-i1*k2)*S(1//(q+1)))+e2p((i2*k1-i1*k2)*S(1//(q+1)))+e2p((-i2*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))+e2p((i2*k2)*S(1//(q+1)))+e2p((-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i1*k1-i2*k2)*S(1//(q+1)))*q+e2p((-i1*k1-i2*k2)*S(1//(q+1)))-e2p((i1*k1+i2*k2)*S(1//(q+1)))*q+e2p((i1*k1+i2*k2)*S(1//(q+1)))-e2p((-i1*k1+i2*k2)*S(1//(q+1)))*q+e2p((-i1*k1+i2*k2)*S(1//(q+1)))-e2p((i1*k1-i2*k2)*S(1//(q+1)))*q+e2p((i1*k1-i2*k2)*S(1//(q+1)))-e2p((i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((i1*k1+i1*k2)*S(1//(q+1)))-e2p((i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((i1*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q+1)))-e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q+1)))-e2p((i2*k1+i1*k2)*S(1//(q+1)))*q+e2p((i2*k1+i1*k2)*S(1//(q+1)))-e2p((-i2*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i2*k1-i1*k2)*S(1//(q+1)))-e2p((i2*k1-i1*k2)*S(1//(q+1)))*q+e2p((i2*k1-i1*k2)*S(1//(q+1)))-e2p((-i2*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i2*k1+i1*k2)*S(1//(q+1))),
	e2p((-i1*k1-i2*k2)*S(1//(q+1)))+e2p((i1*k1+i2*k2)*S(1//(q+1)))+e2p((-i1*k1+i2*k2)*S(1//(q+1)))+e2p((i1*k1-i2*k2)*S(1//(q+1)))+e2p((i1*k1+i1*k2)*S(1//(q+1)))+e2p((i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1-i1*k2)*S(1//(q+1)))+e2p((i2*k1+i1*k2)*S(1//(q+1)))+e2p((-i2*k1-i1*k2)*S(1//(q+1)))+e2p((i2*k1-i1*k2)*S(1//(q+1)))+e2p((-i2*k1+i1*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1+i2*k2)*S(1//(q+1)))+e2p((-i3*k1-i2*k2)*S(1//(q+1)))+e2p((-i2*k1+i3*k2)*S(1//(q+1)))+e2p((i2*k1+i3*k2)*S(1//(q+1)))+e2p((-i3*k1+i2*k2)*S(1//(q+1)))+e2p((-i2*k1-i3*k2)*S(1//(q+1)))+e2p((i3*k1-i2*k2)*S(1//(q+1)))+e2p((i2*k1-i3*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1+i2*k2)*S(1//(q+1)))+e2p((-i3*k1-i2*k2)*S(1//(q+1)))+e2p((-i2*k1+i3*k2)*S(1//(q+1)))+e2p((i2*k1+i3*k2)*S(1//(q+1)))+e2p((-i1*k1-i2*k2)*S(1//(q+1)))+e2p((i1*k1+i2*k2)*S(1//(q+1)))+e2p((-i1*k1+i2*k2)*S(1//(q+1)))+e2p((i1*k1-i2*k2)*S(1//(q+1)))+e2p((-i1*k1+i3*k2)*S(1//(q+1)))+e2p((-i3*k1+i1*k2)*S(1//(q+1)))+e2p((i3*k1+i1*k2)*S(1//(q+1)))+e2p((i3*k1-i1*k2)*S(1//(q+1)))+e2p((i1*k1-i3*k2)*S(1//(q+1)))+e2p((i1*k1+i3*k2)*S(1//(q+1)))+e2p((-i3*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1-i3*k2)*S(1//(q+1)))+e2p((i2*k1+i1*k2)*S(1//(q+1)))+e2p((-i2*k1-i1*k2)*S(1//(q+1)))+e2p((i2*k1-i1*k2)*S(1//(q+1)))+e2p((-i2*k1+i1*k2)*S(1//(q+1)))+e2p((-i3*k1+i2*k2)*S(1//(q+1)))+e2p((-i2*k1-i3*k2)*S(1//(q+1)))+e2p((i3*k1-i2*k2)*S(1//(q+1)))+e2p((i2*k1-i3*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9-2*q^8+3*q^7+3*q^3-4*q^6-2*q^2+q+4*q^5-4*q^4)*e2p(S(0)),
	(-2*q^4+q^5+2*q^3+q-2*q^2)*e2p(S(0)),
	(2*q^5+3*q^3-4*q^4-2*q^2+q)*e2p(S(0)),
	(-2*q^4+2*q^3-2*q^2+q)*e2p(S(0)),
	(q^3+q-2*q^2)*e2p(S(0)),
	(-q^2+q)*e2p(S(0)),
	(-3*q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4+2*q^2-2*q^3-2*q+1)*e2p(S(0)),
	(q^2-2*q+1)*e2p(S(0)),
	(q^2-2*q+1)*e2p(S(0)),
	(-2*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	-q^4-2*q^2+2*q^3+2*q-1-q^4*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))*q^2+e2p((i1*k1)*S(1//(q+1)))*q^3+q*e2p((i1*k1)*S(1//(q+1)))-q^4*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2+e2p((-i1*k1)*S(1//(q+1)))*q^3+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))*q^4-e2p((-i1*k2)*S(1//(q+1)))*q^2+e2p((-i1*k2)*S(1//(q+1)))*q^3+e2p((-i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1)))*q^4-e2p((i1*k2)*S(1//(q+1)))*q^2+e2p((i1*k2)*S(1//(q+1)))*q^3+e2p((i1*k2)*S(1//(q+1)))*q,
	-q^2+2*q-1-e2p((i1*k1)*S(1//(q+1)))*q^2+q*e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))*q^2+e2p((-i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1)))*q^2+e2p((i1*k2)*S(1//(q+1)))*q,
	-q^2+2*q-1+q*e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1)))*q,
	-1+2*q+q*e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))*q+e2p((i1*k2)*S(1//(q+1)))*q,
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i1*k2)*S(1//(q+1)))*q^3-2*e2p((i1*k1+i1*k2)*S(1//(q+1)))*q^2+2*e2p((i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((i1*k1+i1*k2)*S(1//(q+1)))+e2p((i1*k1-i1*k2)*S(1//(q+1)))*q^3-2*e2p((i1*k1-i1*k2)*S(1//(q+1)))*q^2+2*e2p((i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q^3-2*e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q^2+2*e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q^3-2*e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q^2+2*e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1-i1*k2)*S(1//(q+1))),
	-e2p((i1*k1+i1*k2)*S(1//(q+1)))+2*e2p((i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((i1*k1-i1*k2)*S(1//(q+1)))+2*e2p((i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1+i1*k2)*S(1//(q+1)))+2*e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1-i1*k2)*S(1//(q+1)))+2*e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q,
	-e2p((i1*k1+i1*k2)*S(1//(q+1)))-e2p((i1*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k1+i1*k2)*S(1//(q+1)))-e2p((-i1*k1-i1*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q+1)))*q^2+2*q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((i1*k1+i1*k2)*S(1//(q+1)))*q^2+e2p((i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((i1*k1-i1*k2)*S(1//(q+1)))*q^2+e2p((i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q^2+e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q^2+e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))*q^2+2*e2p((-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q^2+2*e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1))),
	q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))+e2p((i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1))),
	q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i2*k1)*S(1//(q+1)))*q+e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))*q+e2p((i2*k1)*S(1//(q+1)))-e2p((i2*k2)*S(1//(q+1)))*q+e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1)))*q+e2p((-i2*k2)*S(1//(q+1))),
	e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1)))+e2p((i2*k2)*S(1//(q+1)))+e2p((-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((i1*k1+i1*k2)*S(1//(q+1)))-e2p((i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((i1*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q+1)))-e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q+1))),
	e2p((i1*k1+i1*k2)*S(1//(q+1)))+e2p((i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1-i1*k2)*S(1//(q+1))),
	e2p((-i1*k1-i2*k2)*S(1//(q+1)))*q+e2p((i1*k1+i2*k2)*S(1//(q+1)))*q+e2p((-i1*k1+i2*k2)*S(1//(q+1)))*q+e2p((i1*k1-i2*k2)*S(1//(q+1)))*q+q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))+e2p((-i2*k1)*S(1//(q+1)))*q-e2p((-i2*k1)*S(1//(q+1)))+e2p((i2*k1)*S(1//(q+1)))*q-e2p((i2*k1)*S(1//(q+1)))+e2p((i2*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i2*k1-i1*k2)*S(1//(q+1)))*q+e2p((i2*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i2*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1)))+e2p((i2*k2)*S(1//(q+1)))*q-e2p((i2*k2)*S(1//(q+1)))+e2p((-i2*k2)*S(1//(q+1)))*q-e2p((-i2*k2)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((-i2*k1)*S(1//(q+1)))-e2p((i2*k1)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))-e2p((i2*k2)*S(1//(q+1)))-e2p((-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i1*k1-i2*k2)*S(1//(q+1)))*q-e2p((-i1*k1-i2*k2)*S(1//(q+1)))+e2p((i1*k1+i2*k2)*S(1//(q+1)))*q-e2p((i1*k1+i2*k2)*S(1//(q+1)))+e2p((-i1*k1+i2*k2)*S(1//(q+1)))*q-e2p((-i1*k1+i2*k2)*S(1//(q+1)))+e2p((i1*k1-i2*k2)*S(1//(q+1)))*q-e2p((i1*k1-i2*k2)*S(1//(q+1)))+e2p((i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((i1*k1+i1*k2)*S(1//(q+1)))+e2p((i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1-i1*k2)*S(1//(q+1)))+e2p((i2*k1+i1*k2)*S(1//(q+1)))*q-e2p((i2*k1+i1*k2)*S(1//(q+1)))+e2p((-i2*k1-i1*k2)*S(1//(q+1)))*q-e2p((-i2*k1-i1*k2)*S(1//(q+1)))+e2p((i2*k1-i1*k2)*S(1//(q+1)))*q-e2p((i2*k1-i1*k2)*S(1//(q+1)))+e2p((-i2*k1+i1*k2)*S(1//(q+1)))*q-e2p((-i2*k1+i1*k2)*S(1//(q+1))),
	-e2p((-i1*k1-i2*k2)*S(1//(q+1)))-e2p((i1*k1+i2*k2)*S(1//(q+1)))-e2p((-i1*k1+i2*k2)*S(1//(q+1)))-e2p((i1*k1-i2*k2)*S(1//(q+1)))-e2p((i1*k1+i1*k2)*S(1//(q+1)))-e2p((i1*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k1+i1*k2)*S(1//(q+1)))-e2p((-i1*k1-i1*k2)*S(1//(q+1)))-e2p((i2*k1+i1*k2)*S(1//(q+1)))-e2p((-i2*k1-i1*k2)*S(1//(q+1)))-e2p((i2*k1-i1*k2)*S(1//(q+1)))-e2p((-i2*k1+i1*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i3*k1+i2*k2)*S(1//(q+1)))+e2p((-i3*k1-i2*k2)*S(1//(q+1)))+e2p((-i2*k1+i3*k2)*S(1//(q+1)))+e2p((i2*k1+i3*k2)*S(1//(q+1)))+e2p((-i3*k1+i2*k2)*S(1//(q+1)))+e2p((-i2*k1-i3*k2)*S(1//(q+1)))+e2p((i3*k1-i2*k2)*S(1//(q+1)))+e2p((i2*k1-i3*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i3*k1+i2*k2)*S(1//(q+1)))-e2p((-i3*k1-i2*k2)*S(1//(q+1)))-e2p((-i2*k1+i3*k2)*S(1//(q+1)))-e2p((i2*k1+i3*k2)*S(1//(q+1)))-e2p((-i1*k1-i2*k2)*S(1//(q+1)))-e2p((i1*k1+i2*k2)*S(1//(q+1)))-e2p((-i1*k1+i2*k2)*S(1//(q+1)))-e2p((i1*k1-i2*k2)*S(1//(q+1)))-e2p((-i1*k1+i3*k2)*S(1//(q+1)))-e2p((-i3*k1+i1*k2)*S(1//(q+1)))-e2p((i3*k1+i1*k2)*S(1//(q+1)))-e2p((i3*k1-i1*k2)*S(1//(q+1)))-e2p((i1*k1-i3*k2)*S(1//(q+1)))-e2p((i1*k1+i3*k2)*S(1//(q+1)))-e2p((-i3*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k1-i3*k2)*S(1//(q+1)))-e2p((i2*k1+i1*k2)*S(1//(q+1)))-e2p((-i2*k1-i1*k2)*S(1//(q+1)))-e2p((i2*k1-i1*k2)*S(1//(q+1)))-e2p((-i2*k1+i1*k2)*S(1//(q+1)))-e2p((-i3*k1+i2*k2)*S(1//(q+1)))-e2p((-i2*k1-i3*k2)*S(1//(q+1)))-e2p((i3*k1-i2*k2)*S(1//(q+1)))-e2p((i2*k1-i3*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^8-q^6-q^2+1)*e2p(S(0)),
	(-q^6+q^4-q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(q^4-q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^4-2*q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(q^4-2*q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q^2+1)))+e2p((-i1*k1*q)*S(1//(q^2+1)))+e2p((i1*k1*q)*S(1//(q^2+1)))+e2p((-i1*k1)*S(1//(q^2+1))),
	e2p((i1*k1)*S(1//(q^2+1)))+e2p((-i1*k1*q)*S(1//(q^2+1)))+e2p((i1*k1*q)*S(1//(q^2+1)))+e2p((-i1*k1)*S(1//(q^2+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((q*i2*k1)*S(1//(q^2+1)))+e2p((-q*i2*k1)*S(1//(q^2+1)))+e2p((i2*k1)*S(1//(q^2+1)))+e2p((-i2*k1)*S(1//(q^2+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q^2+1)))+e2p((-i1*k1*q)*S(1//(q^2+1)))+e2p((i1*k1*q)*S(1//(q^2+1)))+e2p((-i1*k1)*S(1//(q^2+1))),
	(0)*e2p(S(0))] [
	(q^9-q^7-q^3+q)*e2p(S(0)),
	(-q^5+q)*e2p(S(0)),
	(-q^3+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(-q^3+q)*e2p(S(0)),
	(-q^2+q)*e2p(S(0)),
	(q^2+q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(q)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(q^4-2*q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(-q^4+2*q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q^2+1)))+q*e2p((-i1*k1*q)*S(1//(q^2+1)))+q*e2p((i1*k1*q)*S(1//(q^2+1)))+q*e2p((-i1*k1)*S(1//(q^2+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((q*i2*k1)*S(1//(q^2+1)))+e2p((-q*i2*k1)*S(1//(q^2+1)))+e2p((i2*k1)*S(1//(q^2+1)))+e2p((-i2*k1)*S(1//(q^2+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q^2+1)))-e2p((-i1*k1*q)*S(1//(q^2+1)))-e2p((i1*k1*q)*S(1//(q^2+1)))-e2p((-i1*k1)*S(1//(q^2+1))),
	(0)*e2p(S(0))] [
	(q^9+3*q^8+5*q^7+7*q^6+8*q^5+8*q^4+7*q^3+5*q^2+3*q+1)*e2p(S(0)),
	(q^6+5*q^4+3*q^5+6*q^3+5*q^2+3*q+1)*e2p(S(0)),
	(2*q^5+7*q^3+6*q^4+5*q^2+3*q+1)*e2p(S(0)),
	(3*q^4+6*q^3+5*q^2+3*q+1)*e2p(S(0)),
	(3*q^3+5*q^2+3*q+1)*e2p(S(0)),
	(4*q^2+3*q+1)*e2p(S(0)),
	(2*q^2+3*q+1)*e2p(S(0)),
	(2*q^2+3*q+1)*e2p(S(0)),
	(2*q^2+3*q+1)*e2p(S(0)),
	(3*q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k3)*S(1//(q-1)))+e2p((i1*k3)*S(1//(q-1)))*q^4+2*e2p((i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k3)*S(1//(q-1)))*q^3+e2p((-i1*k2)*S(1//(q-1)))*q^4+e2p((-i1*k3)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k3)*S(1//(q-1)))*q^4+2*e2p((-i1*k3)*S(1//(q-1)))*q^3+2*e2p((-i1*k3)*S(1//(q-1)))*q+2*e2p((-i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k3)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))*q^4+2*e2p((i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k2)*S(1//(q-1)))*q+2*e2p((-i1*k2)*S(1//(q-1)))*q^2+2*e2p((-i1*k2)*S(1//(q-1)))*q+2*e2p((-i1*k2)*S(1//(q-1)))*q^3+e2p((-i1*k1)*S(1//(q-1)))+2*q*e2p((-i1*k1)*S(1//(q-1)))+2*e2p((i1*k1)*S(1//(q-1)))*q^2+2*e2p((-i1*k1)*S(1//(q-1)))*q^2+2*e2p((-i1*k1)*S(1//(q-1)))*q^3+2*e2p((i1*k1)*S(1//(q-1)))*q^3+q^4*e2p((i1*k1)*S(1//(q-1)))+q^4*e2p((-i1*k1)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))+2*e2p((i1*k2)*S(1//(q-1)))*q^3,
	e2p((i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q^2+2*e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))+e2p((i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k3)*S(1//(q-1)))*q+e2p((i1*k3)*S(1//(q-1)))+e2p((-i1*k3)*S(1//(q-1)))*q^2+2*e2p((-i1*k3)*S(1//(q-1)))*q+e2p((-i1*k3)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q^2+2*e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))+e2p((i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k3)*S(1//(q-1)))*q+e2p((i1*k3)*S(1//(q-1)))+e2p((-i1*k3)*S(1//(q-1)))*q^2+2*e2p((-i1*k3)*S(1//(q-1)))*q+e2p((-i1*k3)*S(1//(q-1))),
	2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+2*e2p((-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k2)*S(1//(q-1)))+2*e2p((i1*k2)*S(1//(q-1)))*q+e2p((i1*k2)*S(1//(q-1)))+2*e2p((i1*k3)*S(1//(q-1)))*q+e2p((i1*k3)*S(1//(q-1)))+2*e2p((-i1*k3)*S(1//(q-1)))*q+e2p((-i1*k3)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))+e2p((i1*k3)*S(1//(q-1)))+e2p((-i1*k3)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))+e2p((i1*k3)*S(1//(q-1)))+e2p((-i1*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i1*k1-i1*k2+i1*k3)*S(1//(q-1)))+e2p((i1*k1-i1*k2+i1*k3)*S(1//(q-1)))+e2p((-i1*k1+i1*k2-i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i1*k3)*S(1//(q-1)))+e2p((-i1*k1+i1*k2+i1*k3)*S(1//(q-1)))+e2p((i1*k1-i1*k2-i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2-i1*k3)*S(1//(q-1)))+e2p((-i1*k1-i1*k2-i1*k3)*S(1//(q-1)))+2*e2p((-i1*k1+i1*k2+i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2-i1*k3)*S(1//(q-1)))*q+2*e2p((-i1*k1+i1*k2+i1*k3)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2+i1*k3)*S(1//(q-1)))*q^3+2*e2p((-i1*k1-i1*k2-i1*k3)*S(1//(q-1)))*q+2*e2p((-i1*k1-i1*k2-i1*k3)*S(1//(q-1)))*q^2+e2p((-i1*k1-i1*k2+i1*k3)*S(1//(q-1)))*q^3+2*e2p((-i1*k1-i1*k2+i1*k3)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2-i1*k3)*S(1//(q-1)))*q^3+e2p((i1*k1+i1*k2-i1*k3)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i1*k2-i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1-i1*k2-i1*k3)*S(1//(q-1)))*q^3+2*e2p((i1*k1-i1*k2-i1*k3)*S(1//(q-1)))*q^2+2*e2p((-i1*k1+i1*k2-i1*k3)*S(1//(q-1)))*q+2*e2p((i1*k1+i1*k2+i1*k3)*S(1//(q-1)))*q+2*e2p((i1*k1-i1*k2+i1*k3)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2+i1*k3)*S(1//(q-1)))*q^3+e2p((-i1*k1-i1*k2-i1*k3)*S(1//(q-1)))*q^3+e2p((i1*k1+i1*k2+i1*k3)*S(1//(q-1)))*q^3+2*e2p((i1*k1+i1*k2+i1*k3)*S(1//(q-1)))*q^2+2*e2p((-i1*k1+i1*k2-i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1-i1*k2+i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1-i1*k2-i1*k3)*S(1//(q-1)))*q+2*e2p((-i1*k1-i1*k2+i1*k3)*S(1//(q-1)))*q^2,
	2*e2p((i1*k1+i1*k2+i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+i1*k3)*S(1//(q-1)))+2*e2p((-i1*k1+i1*k2-i1*k3)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2-i1*k3)*S(1//(q-1)))+2*e2p((i1*k1-i1*k2+i1*k3)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2+i1*k3)*S(1//(q-1)))+2*e2p((-i1*k1-i1*k2+i1*k3)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2+i1*k3)*S(1//(q-1)))+2*e2p((-i1*k1-i1*k2-i1*k3)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2-i1*k3)*S(1//(q-1)))+2*e2p((i1*k1+i1*k2-i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2-i1*k3)*S(1//(q-1)))+2*e2p((i1*k1-i1*k2-i1*k3)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2-i1*k3)*S(1//(q-1)))+2*e2p((-i1*k1+i1*k2+i1*k3)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2+i1*k3)*S(1//(q-1))),
	e2p((i1*k1+i1*k2+i1*k3)*S(1//(q-1)))+e2p((-i1*k1+i1*k2-i1*k3)*S(1//(q-1)))+e2p((i1*k1-i1*k2+i1*k3)*S(1//(q-1)))+e2p((-i1*k1-i1*k2+i1*k3)*S(1//(q-1)))+e2p((-i1*k1-i1*k2-i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2-i1*k3)*S(1//(q-1)))+e2p((i1*k1-i1*k2-i1*k3)*S(1//(q-1)))+e2p((-i1*k1+i1*k2+i1*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q^2+2*e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q^2+2*e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))*q^2+2*e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((i1*k2-i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k3)*S(1//(q-1)))+e2p((i1*k1-i1*k3)*S(1//(q-1)))+e2p((-i1*k1+i1*k3)*S(1//(q-1)))+e2p((i1*k2+i1*k3)*S(1//(q-1)))+e2p((-i1*k2-i1*k3)*S(1//(q-1)))+e2p((-i1*k2+i1*k3)*S(1//(q-1)))+e2p((-i1*k1-i1*k3)*S(1//(q-1)))+2*e2p((i1*k2+i1*k3)*S(1//(q-1)))*q+2*e2p((-i1*k1+i1*k3)*S(1//(q-1)))*q+e2p((i1*k1-i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1-i1*k3)*S(1//(q-1)))*q+e2p((i1*k2+i1*k3)*S(1//(q-1)))*q^2+2*e2p((-i1*k1-i1*k3)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k3)*S(1//(q-1)))*q^2+e2p((i1*k1+i1*k3)*S(1//(q-1)))*q^2+e2p((-i1*k1+i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k1+i1*k3)*S(1//(q-1)))*q+e2p((i1*k2-i1*k3)*S(1//(q-1)))*q^2+2*e2p((i1*k2-i1*k3)*S(1//(q-1)))*q+2*e2p((-i1*k2-i1*k3)*S(1//(q-1)))*q+2*e2p((-i1*k2+i1*k3)*S(1//(q-1)))*q+e2p((-i1*k2-i1*k3)*S(1//(q-1)))*q^2+e2p((-i1*k2+i1*k3)*S(1//(q-1)))*q^2,
	e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k3)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1)))+e2p((i1*k2-i1*k3)*S(1//(q-1)))*q+e2p((i1*k2-i1*k3)*S(1//(q-1)))+e2p((-i1*k1+i1*k3)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k3)*S(1//(q-1)))+e2p((i1*k1-i1*k3)*S(1//(q-1)))*q+e2p((i1*k1-i1*k3)*S(1//(q-1)))+e2p((-i1*k2-i1*k3)*S(1//(q-1)))*q+e2p((-i1*k2-i1*k3)*S(1//(q-1)))+e2p((i1*k2+i1*k3)*S(1//(q-1)))*q+e2p((i1*k2+i1*k3)*S(1//(q-1)))+e2p((-i1*k1-i1*k3)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k3)*S(1//(q-1)))+e2p((-i1*k2+i1*k3)*S(1//(q-1)))*q+e2p((-i1*k2+i1*k3)*S(1//(q-1))),
	e2p((i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k3)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2)*S(1//(q-1)))+e2p((i1*k2-i1*k3)*S(1//(q-1)))*q+e2p((i1*k2-i1*k3)*S(1//(q-1)))+e2p((-i1*k1+i1*k3)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k3)*S(1//(q-1)))+e2p((i1*k1-i1*k3)*S(1//(q-1)))*q+e2p((i1*k1-i1*k3)*S(1//(q-1)))+e2p((-i1*k2-i1*k3)*S(1//(q-1)))*q+e2p((-i1*k2-i1*k3)*S(1//(q-1)))+e2p((i1*k2+i1*k3)*S(1//(q-1)))*q+e2p((i1*k2+i1*k3)*S(1//(q-1)))+e2p((-i1*k1-i1*k3)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k3)*S(1//(q-1)))+e2p((-i1*k2+i1*k3)*S(1//(q-1)))*q+e2p((-i1*k2+i1*k3)*S(1//(q-1))),
	e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k3)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))+e2p((i1*k2-i1*k3)*S(1//(q-1)))+e2p((-i1*k1+i1*k3)*S(1//(q-1)))+e2p((i1*k1-i1*k3)*S(1//(q-1)))+e2p((-i1*k2-i1*k3)*S(1//(q-1)))+e2p((i1*k2+i1*k3)*S(1//(q-1)))+e2p((-i1*k1-i1*k3)*S(1//(q-1)))+e2p((-i1*k2+i1*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))*q+e2p((i1*k1-i2*k2)*S(1//(q-1)))*q+e2p((-i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((i2*k1-i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k2)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2)*S(1//(q-1)))*q+e2p((-i1*k1-i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k3)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k3)*S(1//(q-1)))*q+e2p((i2*k2+i1*k3)*S(1//(q-1)))*q+e2p((i2*k1-i1*k3)*S(1//(q-1)))*q+e2p((-i2*k2-i1*k3)*S(1//(q-1)))*q+e2p((-i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i2*k2-i1*k3)*S(1//(q-1)))*q+e2p((-i2*k2+i1*k3)*S(1//(q-1)))*q+e2p((i1*k2-i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k3)*S(1//(q-1)))*q+e2p((-i1*k2-i2*k3)*S(1//(q-1)))*q+e2p((-i2*k1+i1*k3)*S(1//(q-1)))*q+e2p((i1*k1-i2*k3)*S(1//(q-1)))*q+e2p((-i1*k1+i2*k3)*S(1//(q-1)))*q+e2p((i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((-i1*k2-i2*k3)*S(1//(q-1)))+e2p((-i2*k1+i1*k3)*S(1//(q-1)))+e2p((i2*k2+i1*k3)*S(1//(q-1)))+e2p((-i2*k1-i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k3)*S(1//(q-1)))+e2p((-i1*k1-i2*k3)*S(1//(q-1)))+e2p((i1*k2+i2*k3)*S(1//(q-1)))+e2p((-i1*k2+i2*k3)*S(1//(q-1)))+e2p((-i2*k2-i1*k3)*S(1//(q-1)))+e2p((i2*k1-i1*k3)*S(1//(q-1)))+e2p((-i1*k1+i2*k3)*S(1//(q-1)))+e2p((i1*k1-i2*k3)*S(1//(q-1)))+e2p((-i2*k2+i1*k3)*S(1//(q-1)))+e2p((i2*k2-i1*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k3)*S(1//(q-1)))+e2p((i1*k2-i2*k3)*S(1//(q-1))),
	e2p((i1*k2+i2*k3)*S(1//(q-1)))+e2p((-i1*k1-i2*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k3)*S(1//(q-1)))+e2p((-i2*k1-i1*k3)*S(1//(q-1)))+e2p((i2*k2+i1*k3)*S(1//(q-1)))+e2p((-i2*k1+i1*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k3)*S(1//(q-1)))+e2p((-i1*k1+i2*k3)*S(1//(q-1)))+e2p((i2*k1-i1*k3)*S(1//(q-1)))+e2p((-i2*k2-i1*k3)*S(1//(q-1)))+e2p((-i1*k2+i2*k3)*S(1//(q-1)))+e2p((i2*k2-i1*k3)*S(1//(q-1)))+e2p((-i2*k2+i1*k3)*S(1//(q-1)))+e2p((i1*k2-i2*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2)*S(1//(q-1)))+e2p((i1*k1+i2*k3)*S(1//(q-1)))+e2p((-i1*k2-i2*k3)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	e2p((-i2*k1+i1*k2-i1*k3)*S(1//(q-1)))+e2p((-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i2*k1-i1*k2-i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2-i1*k3)*S(1//(q-1)))+e2p((-i2*k1-i1*k2-i1*k3)*S(1//(q-1)))+e2p((-i1*k1-i2*k2-i1*k3)*S(1//(q-1)))+e2p((i1*k1-i2*k2-i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((-i1*k1-i1*k2+i2*k3)*S(1//(q-1)))+e2p((-i1*k1+i2*k2-i1*k3)*S(1//(q-1)))+e2p((i1*k1-i1*k2-i2*k3)*S(1//(q-1)))+e2p((i1*k1-i1*k2-i2*k3)*S(1//(q-1)))*q+e2p((-i1*k1+i2*k2-i1*k3)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((-i1*k1-i2*k2-i1*k3)*S(1//(q-1)))*q+e2p((i1*k1-i2*k2-i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((i2*k1-i1*k2-i1*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2-i1*k3)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k2-i1*k3)*S(1//(q-1)))*q+e2p((-i2*k1+i1*k2-i1*k3)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((-i1*k1+i2*k2+i1*k3)*S(1//(q-1)))*q+e2p((-i1*k1-i1*k2-i2*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2+i1*k3)*S(1//(q-1)))*q+e2p((i1*k1-i1*k2+i2*k3)*S(1//(q-1)))*q+e2p((-i1*k1-i2*k2+i1*k3)*S(1//(q-1)))*q+e2p((i1*k1-i2*k2+i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i1*k2-i2*k3)*S(1//(q-1)))*q+e2p((-i2*k1-i1*k2+i1*k3)*S(1//(q-1)))*q+e2p((-i1*k1+i1*k2-i2*k3)*S(1//(q-1)))*q+e2p((i2*k1+i1*k2+i1*k3)*S(1//(q-1)))*q+e2p((-i2*k1+i1*k2+i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2-i1*k3)*S(1//(q-1)))*q+e2p((i2*k1-i1*k2+i1*k3)*S(1//(q-1)))*q+e2p((i1*k1+i2*k2-i1*k3)*S(1//(q-1)))+e2p((i2*k1-i1*k2+i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i1*k3)*S(1//(q-1)))+e2p((-i2*k1+i1*k2+i1*k3)*S(1//(q-1)))+e2p((-i1*k1+i2*k2+i1*k3)*S(1//(q-1)))+e2p((-i2*k1-i1*k2+i1*k3)*S(1//(q-1)))+e2p((-i1*k1+i1*k2-i2*k3)*S(1//(q-1)))+e2p((i1*k1-i2*k2+i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2-i2*k3)*S(1//(q-1)))+e2p((i1*k1-i1*k2+i2*k3)*S(1//(q-1)))+e2p((-i1*k1-i2*k2+i1*k3)*S(1//(q-1)))+e2p((-i1*k1-i1*k2-i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i1*k3)*S(1//(q-1))),
	e2p((i1*k1-i1*k2-i2*k3)*S(1//(q-1)))+e2p((-i1*k1+i2*k2-i1*k3)*S(1//(q-1)))+e2p((-i1*k1-i1*k2+i2*k3)*S(1//(q-1)))+e2p((-i1*k1-i2*k2-i1*k3)*S(1//(q-1)))+e2p((i1*k1-i2*k2-i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i2*k1-i1*k2-i1*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2-i1*k3)*S(1//(q-1)))+e2p((-i2*k1-i1*k2-i1*k3)*S(1//(q-1)))+e2p((-i2*k1+i1*k2-i1*k3)*S(1//(q-1)))+e2p((-i1*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((-i1*k1+i2*k2+i1*k3)*S(1//(q-1)))+e2p((-i1*k1-i1*k2-i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i1*k3)*S(1//(q-1)))+e2p((i1*k1-i1*k2+i2*k3)*S(1//(q-1)))+e2p((-i1*k1-i2*k2+i1*k3)*S(1//(q-1)))+e2p((i1*k1-i2*k2+i1*k3)*S(1//(q-1)))+e2p((i1*k1+i1*k2-i2*k3)*S(1//(q-1)))+e2p((-i2*k1-i1*k2+i1*k3)*S(1//(q-1)))+e2p((-i1*k1+i1*k2-i2*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i1*k3)*S(1//(q-1)))+e2p((-i2*k1+i1*k2+i1*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2-i1*k3)*S(1//(q-1)))+e2p((i2*k1-i1*k2+i1*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i2*k1-i3*k2-i1*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k2+i1*k3)*S(1//(q-1)))+e2p((i2*k1+i3*k2-i1*k3)*S(1//(q-1)))+e2p((i1*k1-i3*k2+i2*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k2+i2*k3)*S(1//(q-1)))+e2p((-i1*k1-i3*k2+i2*k3)*S(1//(q-1)))+e2p((i2*k1-i1*k2-i3*k3)*S(1//(q-1)))+e2p((i3*k1+i2*k2-i1*k3)*S(1//(q-1)))+e2p((-i2*k1-i1*k2-i3*k3)*S(1//(q-1)))+e2p((-i1*k1+i2*k2-i3*k3)*S(1//(q-1)))+e2p((-i2*k1-i3*k2-i1*k3)*S(1//(q-1)))+e2p((-i3*k1-i2*k2+i1*k3)*S(1//(q-1)))+e2p((-i1*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((i2*k1-i1*k2+i3*k3)*S(1//(q-1)))+e2p((-i2*k1+i3*k2+i1*k3)*S(1//(q-1)))+e2p((-i2*k1+i3*k2-i1*k3)*S(1//(q-1)))+e2p((i1*k1+i3*k2+i2*k3)*S(1//(q-1)))+e2p((i3*k1-i2*k2+i1*k3)*S(1//(q-1)))+e2p((i1*k1+i3*k2-i2*k3)*S(1//(q-1)))+e2p((i3*k1+i1*k2-i2*k3)*S(1//(q-1)))+e2p((-i3*k1+i1*k2-i2*k3)*S(1//(q-1)))+e2p((i1*k1-i3*k2-i2*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2-i3*k3)*S(1//(q-1)))+e2p((i3*k1+i2*k2+i1*k3)*S(1//(q-1)))+e2p((i1*k1-i2*k2+i3*k3)*S(1//(q-1)))+e2p((-i3*k1+i2*k2-i1*k3)*S(1//(q-1)))+e2p((-i2*k1+i1*k2-i3*k3)*S(1//(q-1)))+e2p((i1*k1-i2*k2-i3*k3)*S(1//(q-1)))+e2p((i3*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i2*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((-i2*k1-i1*k2+i3*k3)*S(1//(q-1)))+e2p((-i3*k1-i1*k2+i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2+i3*k3)*S(1//(q-1)))+e2p((-i1*k1+i3*k2-i2*k3)*S(1//(q-1)))+e2p((-i1*k1-i2*k2+i3*k3)*S(1//(q-1)))+e2p((i3*k1-i2*k2-i1*k3)*S(1//(q-1)))+e2p((-i2*k1-i3*k2+i1*k3)*S(1//(q-1)))+e2p((-i2*k1+i1*k2+i3*k3)*S(1//(q-1)))+e2p((-i1*k1-i2*k2-i3*k3)*S(1//(q-1)))+e2p((i2*k1-i3*k2+i1*k3)*S(1//(q-1)))+e2p((-i3*k1-i2*k2-i1*k3)*S(1//(q-1)))+e2p((-i3*k1-i1*k2-i2*k3)*S(1//(q-1)))+e2p((-i1*k1-i3*k2-i2*k3)*S(1//(q-1)))+e2p((i1*k1+i2*k2-i3*k3)*S(1//(q-1)))+e2p((-i3*k1+i2*k2+i1*k3)*S(1//(q-1)))+e2p((-i3*k1+i1*k2+i2*k3)*S(1//(q-1)))+e2p((i3*k1-i1*k2-i2*k3)*S(1//(q-1)))+e2p((-i1*k1+i3*k2+i2*k3)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9+q^8+q^7+q^6-q^3-q^2-q-1)*e2p(S(0)),
	(-q^6-q^5-q^4-2*q^3-q^2-q-1)*e2p(S(0)),
	(2*q^5-q^3+2*q^4-q^2-q-1)*e2p(S(0)),
	(q^4-2*q^3-q^2-q-1)*e2p(S(0)),
	(-q^2-q^3-q-1)*e2p(S(0)),
	(2*q^2-q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-2*q^2-q-1)*e2p(S(0)),
	(-2*q^2-q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	q^4*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))+q^4*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q^4-e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q^4-e2p((i1*k2)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))*q^2-e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2-e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k2)*S(1//(q-1)))*q^2-e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k2)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))*q^2-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))*q^2-e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k2)*S(1//(q-1)))*q^2-e2p((-i1*k2)*S(1//(q-1)))-e2p((i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k2)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k2)*S(1//(q-1)))-e2p((i1*k2)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k2)*S(1//(q-1)))-e2p((i1*k2)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k2)*S(1//(q-1)))-e2p((i1*k2)*S(1//(q-1))),
	-e2p((i1*k3)*S(1//(q+1)))*q^4-2*e2p((i1*k3)*S(1//(q+1)))*q^2-2*e2p((i1*k3)*S(1//(q+1)))*q^3-2*e2p((i1*k3)*S(1//(q+1)))*q-e2p((i1*k3)*S(1//(q+1)))-e2p((-i1*k3)*S(1//(q+1)))*q^4-2*e2p((-i1*k3)*S(1//(q+1)))*q^2-2*e2p((-i1*k3)*S(1//(q+1)))*q^3-2*e2p((-i1*k3)*S(1//(q+1)))*q-e2p((-i1*k3)*S(1//(q+1))),
	-e2p((i1*k3)*S(1//(q+1)))*q^2-2*e2p((i1*k3)*S(1//(q+1)))*q-e2p((i1*k3)*S(1//(q+1)))-e2p((-i1*k3)*S(1//(q+1)))*q^2-2*e2p((-i1*k3)*S(1//(q+1)))*q-e2p((-i1*k3)*S(1//(q+1))),
	-e2p((i1*k3)*S(1//(q+1)))*q^2-2*e2p((i1*k3)*S(1//(q+1)))*q-e2p((i1*k3)*S(1//(q+1)))-e2p((-i1*k3)*S(1//(q+1)))*q^2-2*e2p((-i1*k3)*S(1//(q+1)))*q-e2p((-i1*k3)*S(1//(q+1))),
	-2*e2p((i1*k3)*S(1//(q+1)))*q-e2p((i1*k3)*S(1//(q+1)))-2*e2p((-i1*k3)*S(1//(q+1)))*q-e2p((-i1*k3)*S(1//(q+1))),
	-e2p((i1*k3)*S(1//(q+1)))-e2p((-i1*k3)*S(1//(q+1))),
	-e2p((i1*k3)*S(1//(q+1)))-e2p((-i1*k3)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1-i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q^2-e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q^2-e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	e2p((i1*k1-i1*k2)*S(1//(q-1)))*q-e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q-e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q-e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	-e2p((i1*k1-i1*k2)*S(1//(q-1)))*q-e2p((i1*k1-i1*k2)*S(1//(q-1)))-e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q-e2p((-i1*k1-i1*k2)*S(1//(q-1)))-e2p((i1*k1+i1*k2)*S(1//(q-1)))*q-e2p((i1*k1+i1*k2)*S(1//(q-1)))-e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q-e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	-e2p((i1*k1-i1*k2)*S(1//(q-1)))-e2p((-i1*k1-i1*k2)*S(1//(q-1)))-e2p((i1*k1+i1*k2)*S(1//(q-1)))-e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i2*k1-i1*k2)*S(1//(q-1)))*q-e2p((-i2*k1-i1*k2)*S(1//(q-1)))+e2p((i2*k1+i1*k2)*S(1//(q-1)))*q-e2p((i2*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))*q-e2p((-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))*q-e2p((i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i2*k1+i1*k2)*S(1//(q-1)))*q-e2p((-i2*k1+i1*k2)*S(1//(q-1)))+e2p((i2*k1-i1*k2)*S(1//(q-1)))*q-e2p((i2*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k2)*S(1//(q-1)))*q-e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+i2*k2)*S(1//(q-1)))-e2p((-i2*k1-i1*k2)*S(1//(q-1)))-e2p((i2*k1+i1*k2)*S(1//(q-1)))-e2p((-i1*k1-i2*k2)*S(1//(q-1)))-e2p((i1*k1-i2*k2)*S(1//(q-1)))-e2p((-i2*k1+i1*k2)*S(1//(q-1)))-e2p((i2*k1-i1*k2)*S(1//(q-1)))-e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i2*k3*q+i2*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))*q-e2p((-i2*k3*q+i2*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((i2*k3*q-i2*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))*q-e2p((i2*k3*q-i2*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((-i2*k3*q+i2*k3-q*i1*k2-i1*k2)*S(1//(q^2-1)))*q-e2p((-i2*k3*q+i2*k3-q*i1*k2-i1*k2)*S(1//(q^2-1)))-e2p((-i2*k3*q+i2*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))*q-e2p((-i2*k3*q+i2*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((i2*k3*q-i2*k3+q*i1*k2+i1*k2)*S(1//(q^2-1)))*q-e2p((i2*k3*q-i2*k3+q*i1*k2+i1*k2)*S(1//(q^2-1)))-e2p((i2*k3*q-i2*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))*q-e2p((i2*k3*q-i2*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((i2*k3*q-i2*k3-q*i1*k2-i1*k2)*S(1//(q^2-1)))*q-e2p((i2*k3*q-i2*k3-q*i1*k2-i1*k2)*S(1//(q^2-1)))-e2p((-i2*k3*q+i2*k3+q*i1*k2+i1*k2)*S(1//(q^2-1)))*q-e2p((-i2*k3*q+i2*k3+q*i1*k2+i1*k2)*S(1//(q^2-1))),
	-e2p((-i2*k3*q+i2*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((i2*k3*q-i2*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((-i2*k3*q+i2*k3-q*i1*k2-i1*k2)*S(1//(q^2-1)))-e2p((-i2*k3*q+i2*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((i2*k3*q-i2*k3+q*i1*k2+i1*k2)*S(1//(q^2-1)))-e2p((i2*k3*q-i2*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((i2*k3*q-i2*k3-q*i1*k2-i1*k2)*S(1//(q^2-1)))-e2p((-i2*k3*q+i2*k3+q*i1*k2+i1*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i2*k3*q+i2*k3-i1*k1*q+q*i1*k2-i1*k1+i1*k2)*S(1//(q^2-1)))*q-e2p((-i2*k3*q+i2*k3-i1*k1*q+q*i1*k2-i1*k1+i1*k2)*S(1//(q^2-1)))-e2p((-i2*k3*q+i2*k3+i1*k1*q-q*i1*k2+i1*k1-i1*k2)*S(1//(q^2-1)))*q-e2p((-i2*k3*q+i2*k3+i1*k1*q-q*i1*k2+i1*k1-i1*k2)*S(1//(q^2-1)))-e2p((i2*k3*q-i2*k3-i1*k1*q-q*i1*k2-i1*k1-i1*k2)*S(1//(q^2-1)))*q-e2p((i2*k3*q-i2*k3-i1*k1*q-q*i1*k2-i1*k1-i1*k2)*S(1//(q^2-1)))-e2p((i2*k3*q-i2*k3-i1*k1*q+q*i1*k2-i1*k1+i1*k2)*S(1//(q^2-1)))*q-e2p((i2*k3*q-i2*k3-i1*k1*q+q*i1*k2-i1*k1+i1*k2)*S(1//(q^2-1)))-e2p((i2*k3*q-i2*k3+i1*k1*q+q*i1*k2+i1*k1+i1*k2)*S(1//(q^2-1)))*q-e2p((i2*k3*q-i2*k3+i1*k1*q+q*i1*k2+i1*k1+i1*k2)*S(1//(q^2-1)))-e2p((-i2*k3*q+i2*k3+i1*k1*q+q*i1*k2+i1*k1+i1*k2)*S(1//(q^2-1)))*q-e2p((-i2*k3*q+i2*k3+i1*k1*q+q*i1*k2+i1*k1+i1*k2)*S(1//(q^2-1)))-e2p((i2*k3*q-i2*k3+i1*k1*q-q*i1*k2+i1*k1-i1*k2)*S(1//(q^2-1)))*q-e2p((i2*k3*q-i2*k3+i1*k1*q-q*i1*k2+i1*k1-i1*k2)*S(1//(q^2-1)))-e2p((-i2*k3*q+i2*k3-i1*k1*q-q*i1*k2-i1*k1-i1*k2)*S(1//(q^2-1)))*q-e2p((-i2*k3*q+i2*k3-i1*k1*q-q*i1*k2-i1*k1-i1*k2)*S(1//(q^2-1))),
	-e2p((-i2*k3*q+i2*k3-i1*k1*q+q*i1*k2-i1*k1+i1*k2)*S(1//(q^2-1)))-e2p((-i2*k3*q+i2*k3+i1*k1*q-q*i1*k2+i1*k1-i1*k2)*S(1//(q^2-1)))-e2p((i2*k3*q-i2*k3-i1*k1*q-q*i1*k2-i1*k1-i1*k2)*S(1//(q^2-1)))-e2p((i2*k3*q-i2*k3-i1*k1*q+q*i1*k2-i1*k1+i1*k2)*S(1//(q^2-1)))-e2p((i2*k3*q-i2*k3+i1*k1*q+q*i1*k2+i1*k1+i1*k2)*S(1//(q^2-1)))-e2p((-i2*k3*q+i2*k3+i1*k1*q+q*i1*k2+i1*k1+i1*k2)*S(1//(q^2-1)))-e2p((i2*k3*q-i2*k3+i1*k1*q-q*i1*k2+i1*k1-i1*k2)*S(1//(q^2-1)))-e2p((-i2*k3*q+i2*k3-i1*k1*q-q*i1*k2-i1*k1-i1*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i3*k3*q+i3*k3+q*i2*k1+q*i1*k2+i2*k1+i1*k2)*S(1//(q^2-1)))-e2p((-i3*k3*q+i3*k3-i1*k1*q-q*i2*k2-i1*k1-i2*k2)*S(1//(q^2-1)))-e2p((-i3*k3*q+i3*k3+q*i2*k1-q*i1*k2+i2*k1-i1*k2)*S(1//(q^2-1)))-e2p((-i3*k3*q+i3*k3-i1*k1*q+q*i2*k2-i1*k1+i2*k2)*S(1//(q^2-1)))-e2p((i3*k3*q-i3*k3-q*i2*k1-q*i1*k2-i2*k1-i1*k2)*S(1//(q^2-1)))-e2p((i3*k3*q-i3*k3-i1*k1*q+q*i2*k2-i1*k1+i2*k2)*S(1//(q^2-1)))-e2p((i3*k3*q-i3*k3-i1*k1*q-q*i2*k2-i1*k1-i2*k2)*S(1//(q^2-1)))-e2p((i3*k3*q-i3*k3+q*i2*k1+q*i1*k2+i2*k1+i1*k2)*S(1//(q^2-1)))-e2p((i3*k3*q-i3*k3+q*i2*k1-q*i1*k2+i2*k1-i1*k2)*S(1//(q^2-1)))-e2p((-i3*k3*q+i3*k3-q*i2*k1+q*i1*k2-i2*k1+i1*k2)*S(1//(q^2-1)))-e2p((i3*k3*q-i3*k3-q*i2*k1+q*i1*k2-i2*k1+i1*k2)*S(1//(q^2-1)))-e2p((-i3*k3*q+i3*k3+i1*k1*q+q*i2*k2+i1*k1+i2*k2)*S(1//(q^2-1)))-e2p((-i3*k3*q+i3*k3+i1*k1*q-q*i2*k2+i1*k1-i2*k2)*S(1//(q^2-1)))-e2p((i3*k3*q-i3*k3+i1*k1*q+q*i2*k2+i1*k1+i2*k2)*S(1//(q^2-1)))-e2p((-i3*k3*q+i3*k3-q*i2*k1-q*i1*k2-i2*k1-i1*k2)*S(1//(q^2-1)))-e2p((i3*k3*q-i3*k3+i1*k1*q-q*i2*k2+i1*k1-i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9+q^8+q^7+q^6-q^3-q^2-q-1)*e2p(S(0)),
	(q^6+q^4+q^5-q-q^2-1)*e2p(S(0)),
	(-q^2-q^3-q-1)*e2p(S(0)),
	(q^4-q-q^2-1)*e2p(S(0)),
	(q^3-q^2-q-1)*e2p(S(0)),
	(-2*q^2-q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	e2p((-i1*k2)*S(1//(q-1)))*q^4-e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q^4-e2p((i1*k2)*S(1//(q-1))),
	-e2p((-i1*k2)*S(1//(q-1)))*q^2-e2p((-i1*k2)*S(1//(q-1)))-e2p((i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k2)*S(1//(q-1))),
	e2p((-i1*k2)*S(1//(q-1)))*q^2-e2p((-i1*k2)*S(1//(q-1)))+e2p((i1*k2)*S(1//(q-1)))*q^2-e2p((i1*k2)*S(1//(q-1))),
	-e2p((-i1*k2)*S(1//(q-1)))-e2p((i1*k2)*S(1//(q-1))),
	-e2p((-i1*k2)*S(1//(q-1)))-e2p((i1*k2)*S(1//(q-1))),
	-e2p((-i1*k2)*S(1//(q-1)))-e2p((i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1-i1*k2)*S(1//(q-1)))*q^3-e2p((i1*k1-i1*k2)*S(1//(q-1)))+e2p((-i1*k1-i1*k2)*S(1//(q-1)))*q^3-e2p((-i1*k1-i1*k2)*S(1//(q-1)))+e2p((i1*k1+i1*k2)*S(1//(q-1)))*q^3-e2p((i1*k1+i1*k2)*S(1//(q-1)))+e2p((-i1*k1+i1*k2)*S(1//(q-1)))*q^3-e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	-e2p((i1*k1-i1*k2)*S(1//(q-1)))-e2p((-i1*k1-i1*k2)*S(1//(q-1)))-e2p((i1*k1+i1*k2)*S(1//(q-1)))-e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	-e2p((i1*k1-i1*k2)*S(1//(q-1)))-e2p((-i1*k1-i1*k2)*S(1//(q-1)))-e2p((i1*k1+i1*k2)*S(1//(q-1)))-e2p((-i1*k1+i1*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^2-e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2-e2p((-i1*k1)*S(1//(q-1))),
	-q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	q*e2p((i1*k1)*S(1//(q-1)))-e2p((i1*k1)*S(1//(q-1)))+q*e2p((-i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2-2*q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i2*k2)*S(1//(q-1)))*q-e2p((i1*k1+i2*k2)*S(1//(q-1)))+e2p((-i1*k1-i2*k2)*S(1//(q-1)))*q-e2p((-i1*k1-i2*k2)*S(1//(q-1)))+e2p((i1*k1-i2*k2)*S(1//(q-1)))*q-e2p((i1*k1-i2*k2)*S(1//(q-1)))+e2p((-i1*k1+i2*k2)*S(1//(q-1)))*q-e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	-e2p((i1*k1+i2*k2)*S(1//(q-1)))-e2p((-i1*k1-i2*k2)*S(1//(q-1)))-e2p((i1*k1-i2*k2)*S(1//(q-1)))-e2p((-i1*k1+i2*k2)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*e2p((-i1*k1*q)*S(1//(q^2-1)))-e2p((-i1*k1*q)*S(1//(q^2-1)))-q*e2p((i1*k1)*S(1//(q^2-1)))-e2p((i1*k1)*S(1//(q^2-1)))-q*e2p((-i1*k1)*S(1//(q^2-1)))-e2p((-i1*k1)*S(1//(q^2-1)))-q*e2p((i1*k1*q)*S(1//(q^2-1)))-e2p((i1*k1*q)*S(1//(q^2-1))),
	-e2p((-i1*k1*q)*S(1//(q^2-1)))-e2p((i1*k1)*S(1//(q^2-1)))-e2p((-i1*k1)*S(1//(q^2-1)))-e2p((i1*k1*q)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1*q-i1*k1-q*i2*k2-i2*k2)*S(1//(q^2-1)))*q-e2p((i1*k1*q-i1*k1-q*i2*k2-i2*k2)*S(1//(q^2-1)))-e2p((-i1*k1*q+i1*k1-q*i2*k2-i2*k2)*S(1//(q^2-1)))*q-e2p((-i1*k1*q+i1*k1-q*i2*k2-i2*k2)*S(1//(q^2-1)))-e2p((-i1*k1*q+i1*k1+q*i2*k2+i2*k2)*S(1//(q^2-1)))*q-e2p((-i1*k1*q+i1*k1+q*i2*k2+i2*k2)*S(1//(q^2-1)))-e2p((i1*k1*q-i1*k1+q*i2*k2+i2*k2)*S(1//(q^2-1)))*q-e2p((i1*k1*q-i1*k1+q*i2*k2+i2*k2)*S(1//(q^2-1))),
	-e2p((i1*k1*q-i1*k1-q*i2*k2-i2*k2)*S(1//(q^2-1)))-e2p((i1*k1*q-i1*k1+q*i2*k2+i2*k2)*S(1//(q^2-1)))-e2p((-i1*k1*q+i1*k1+q*i2*k2+i2*k2)*S(1//(q^2-1)))-e2p((-i1*k1*q+i1*k1-q*i2*k2-i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i1*k1+q*i2*k2+i2*k2)*S(1//(q^2-1)))-e2p((-i1*k1*q-q*i2*k2-i2*k2)*S(1//(q^2-1)))-e2p((i1*k1-q*i2*k2-i2*k2)*S(1//(q^2-1)))-e2p((i1*k1*q-q*i2*k2-i2*k2)*S(1//(q^2-1)))-e2p((-i1*k1-q*i2*k2-i2*k2)*S(1//(q^2-1)))-e2p((i1*k1*q+q*i2*k2+i2*k2)*S(1//(q^2-1)))-e2p((-i1*k1*q+q*i2*k2+i2*k2)*S(1//(q^2-1)))-e2p((i1*k1+q*i2*k2+i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9-q^8+q^7-q^3-q^6+q^2-q+1)*e2p(S(0)),
	(q^6+q^4-q^5-2*q^3-q+q^2+1)*e2p(S(0)),
	(2*q^5-q^3-2*q^4+q^2-q+1)*e2p(S(0)),
	(-q^4-2*q^3+q^2-q+1)*e2p(S(0)),
	(-q^3-q+q^2+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(-2*q^2-q+1)*e2p(S(0)),
	(2*q^2-q+1)*e2p(S(0)),
	(2*q^2-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	q^4*e2p((i1*k1)*S(1//(q-1)))+2*e2p((i1*k1)*S(1//(q-1)))*q^2-2*e2p((i1*k1)*S(1//(q-1)))*q^3-2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+q^4*e2p((-i1*k1)*S(1//(q-1)))+2*e2p((-i1*k1)*S(1//(q-1)))*q^2-2*e2p((-i1*k1)*S(1//(q-1)))*q^3-2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))*q^2-2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2-2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))*q^2-2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2-2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	-2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))-2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k3)*S(1//(q+1)))*q^4+e2p((i1*k3)*S(1//(q+1)))-e2p((-i1*k3)*S(1//(q+1)))*q^4+e2p((-i1*k3)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))*q^4+e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q^4+e2p((i1*k2)*S(1//(q+1))),
	-e2p((i1*k3)*S(1//(q+1)))*q^2+e2p((i1*k3)*S(1//(q+1)))-e2p((-i1*k3)*S(1//(q+1)))*q^2+e2p((-i1*k3)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))*q^2+e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q^2+e2p((i1*k2)*S(1//(q+1))),
	e2p((i1*k3)*S(1//(q+1)))*q^2+e2p((i1*k3)*S(1//(q+1)))+e2p((-i1*k3)*S(1//(q+1)))*q^2+e2p((-i1*k3)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))*q^2+e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))*q^2+e2p((i1*k2)*S(1//(q+1))),
	e2p((i1*k3)*S(1//(q+1)))+e2p((-i1*k3)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1))),
	e2p((i1*k3)*S(1//(q+1)))+e2p((-i1*k3)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1))),
	e2p((i1*k3)*S(1//(q+1)))+e2p((-i1*k3)*S(1//(q+1)))+e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k2-i1*k3)*S(1//(q+1)))*q^2+e2p((i1*k2-i1*k3)*S(1//(q+1)))-e2p((-i1*k2+i1*k3)*S(1//(q+1)))*q^2+e2p((-i1*k2+i1*k3)*S(1//(q+1)))-e2p((-i1*k2-i1*k3)*S(1//(q+1)))*q^2+e2p((-i1*k2-i1*k3)*S(1//(q+1)))-e2p((i1*k2+i1*k3)*S(1//(q+1)))*q^2+e2p((i1*k2+i1*k3)*S(1//(q+1))),
	e2p((i1*k2-i1*k3)*S(1//(q+1)))*q+e2p((i1*k2-i1*k3)*S(1//(q+1)))+e2p((-i1*k2+i1*k3)*S(1//(q+1)))*q+e2p((-i1*k2+i1*k3)*S(1//(q+1)))+e2p((-i1*k2-i1*k3)*S(1//(q+1)))*q+e2p((-i1*k2-i1*k3)*S(1//(q+1)))+e2p((i1*k2+i1*k3)*S(1//(q+1)))*q+e2p((i1*k2+i1*k3)*S(1//(q+1))),
	-e2p((i1*k2-i1*k3)*S(1//(q+1)))*q+e2p((i1*k2-i1*k3)*S(1//(q+1)))-e2p((-i1*k2+i1*k3)*S(1//(q+1)))*q+e2p((-i1*k2+i1*k3)*S(1//(q+1)))-e2p((-i1*k2-i1*k3)*S(1//(q+1)))*q+e2p((-i1*k2-i1*k3)*S(1//(q+1)))-e2p((i1*k2+i1*k3)*S(1//(q+1)))*q+e2p((i1*k2+i1*k3)*S(1//(q+1))),
	e2p((i1*k2-i1*k3)*S(1//(q+1)))+e2p((-i1*k2+i1*k3)*S(1//(q+1)))+e2p((-i1*k2-i1*k3)*S(1//(q+1)))+e2p((i1*k2+i1*k3)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i2*k3*q-i2*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))*q+e2p((i2*k3*q-i2*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))*q+e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((-i2*k3*q+i2*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))*q+e2p((-i2*k3*q+i2*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-i2*k3*q+i2*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))*q+e2p((-i2*k3*q+i2*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((i2*k3*q-i2*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))*q+e2p((i2*k3*q-i2*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))*q+e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))*q+e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))*q+e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1))),
	e2p((i2*k3*q-i2*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))+e2p((-i2*k3*q+i2*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((-i2*k3*q+i2*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))+e2p((i2*k3*q-i2*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))+e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((q*i1*k2-i1*k2-i1*k3*q+i1*k3-q*i2*k1-i2*k1)*S(1//(q^2-1)))*q+e2p((q*i1*k2-i1*k2-i1*k3*q+i1*k3-q*i2*k1-i2*k1)*S(1//(q^2-1)))-e2p((-q*i1*k2+i1*k2+i1*k3*q-i1*k3+q*i2*k1+i2*k1)*S(1//(q^2-1)))*q+e2p((-q*i1*k2+i1*k2+i1*k3*q-i1*k3+q*i2*k1+i2*k1)*S(1//(q^2-1)))-e2p((q*i1*k2-i1*k2+i1*k3*q-i1*k3+q*i2*k1+i2*k1)*S(1//(q^2-1)))*q+e2p((q*i1*k2-i1*k2+i1*k3*q-i1*k3+q*i2*k1+i2*k1)*S(1//(q^2-1)))-e2p((-q*i1*k2+i1*k2-i1*k3*q+i1*k3-q*i2*k1-i2*k1)*S(1//(q^2-1)))*q+e2p((-q*i1*k2+i1*k2-i1*k3*q+i1*k3-q*i2*k1-i2*k1)*S(1//(q^2-1)))-e2p((q*i1*k2-i1*k2+i1*k3*q-i1*k3-q*i2*k1-i2*k1)*S(1//(q^2-1)))*q+e2p((q*i1*k2-i1*k2+i1*k3*q-i1*k3-q*i2*k1-i2*k1)*S(1//(q^2-1)))-e2p((q*i1*k2-i1*k2-i1*k3*q+i1*k3+q*i2*k1+i2*k1)*S(1//(q^2-1)))*q+e2p((q*i1*k2-i1*k2-i1*k3*q+i1*k3+q*i2*k1+i2*k1)*S(1//(q^2-1)))-e2p((-q*i1*k2+i1*k2+i1*k3*q-i1*k3-q*i2*k1-i2*k1)*S(1//(q^2-1)))*q+e2p((-q*i1*k2+i1*k2+i1*k3*q-i1*k3-q*i2*k1-i2*k1)*S(1//(q^2-1)))-e2p((-q*i1*k2+i1*k2-i1*k3*q+i1*k3+q*i2*k1+i2*k1)*S(1//(q^2-1)))*q+e2p((-q*i1*k2+i1*k2-i1*k3*q+i1*k3+q*i2*k1+i2*k1)*S(1//(q^2-1))),
	e2p((q*i1*k2-i1*k2-i1*k3*q+i1*k3-q*i2*k1-i2*k1)*S(1//(q^2-1)))+e2p((-q*i1*k2+i1*k2+i1*k3*q-i1*k3+q*i2*k1+i2*k1)*S(1//(q^2-1)))+e2p((q*i1*k2-i1*k2+i1*k3*q-i1*k3+q*i2*k1+i2*k1)*S(1//(q^2-1)))+e2p((-q*i1*k2+i1*k2-i1*k3*q+i1*k3-q*i2*k1-i2*k1)*S(1//(q^2-1)))+e2p((q*i1*k2-i1*k2+i1*k3*q-i1*k3-q*i2*k1-i2*k1)*S(1//(q^2-1)))+e2p((q*i1*k2-i1*k2-i1*k3*q+i1*k3+q*i2*k1+i2*k1)*S(1//(q^2-1)))+e2p((-q*i1*k2+i1*k2+i1*k3*q-i1*k3-q*i2*k1-i2*k1)*S(1//(q^2-1)))+e2p((-q*i1*k2+i1*k2-i1*k3*q+i1*k3+q*i2*k1+i2*k1)*S(1//(q^2-1))),
	e2p((i1*k2-i2*k3)*S(1//(q+1)))*q+e2p((i1*k2-i2*k3)*S(1//(q+1)))+e2p((i2*k2+i1*k3)*S(1//(q+1)))*q+e2p((i2*k2+i1*k3)*S(1//(q+1)))+e2p((-i1*k2-i2*k3)*S(1//(q+1)))*q+e2p((-i1*k2-i2*k3)*S(1//(q+1)))+e2p((i1*k2+i2*k3)*S(1//(q+1)))*q+e2p((i1*k2+i2*k3)*S(1//(q+1)))+e2p((-i2*k2-i1*k3)*S(1//(q+1)))*q+e2p((-i2*k2-i1*k3)*S(1//(q+1)))+e2p((-i1*k2+i2*k3)*S(1//(q+1)))*q+e2p((-i1*k2+i2*k3)*S(1//(q+1)))+e2p((i2*k2-i1*k3)*S(1//(q+1)))*q+e2p((i2*k2-i1*k3)*S(1//(q+1)))+e2p((-i2*k2+i1*k3)*S(1//(q+1)))*q+e2p((-i2*k2+i1*k3)*S(1//(q+1))),
	e2p((i1*k2-i2*k3)*S(1//(q+1)))+e2p((i2*k2+i1*k3)*S(1//(q+1)))+e2p((-i1*k2-i2*k3)*S(1//(q+1)))+e2p((i1*k2+i2*k3)*S(1//(q+1)))+e2p((-i2*k2-i1*k3)*S(1//(q+1)))+e2p((-i1*k2+i2*k3)*S(1//(q+1)))+e2p((i2*k2-i1*k3)*S(1//(q+1)))+e2p((-i2*k2+i1*k3)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i3*k2*q+i3*k2-i2*k3*q+i2*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((-i3*k2*q+i3*k2+i2*k3*q-i2*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))+e2p((i3*k2*q-i3*k2-i2*k3*q+i2*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((-i3*k2*q+i3*k2+i2*k3*q-i2*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((i3*k2*q-i3*k2+i2*k3*q-i2*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))+e2p((-i3*k2*q+i3*k2-i2*k3*q+i2*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))+e2p((q*i2*k2-i2*k2-i3*k3*q+i3*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((-q*i2*k2+i2*k2-i3*k3*q+i3*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))+e2p((i3*k2*q-i3*k2+i2*k3*q-i2*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((q*i2*k2-i2*k2-i3*k3*q+i3*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))+e2p((q*i2*k2-i2*k2+i3*k3*q-i3*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))+e2p((-q*i2*k2+i2*k2-i3*k3*q+i3*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((q*i2*k2-i2*k2+i3*k3*q-i3*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((-q*i2*k2+i2*k2+i3*k3*q-i3*k3+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((i3*k2*q-i3*k2-i2*k3*q+i2*k3-i1*k1*q-i1*k1)*S(1//(q^2-1)))+e2p((-q*i2*k2+i2*k2+i3*k3*q-i3*k3-i1*k1*q-i1*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9-q^8+q^7-q^3-q^6+q^2-q+1)*e2p(S(0)),
	(-q^6+q^5-q^4+q^2-q+1)*e2p(S(0)),
	(-q^3-q+q^2+1)*e2p(S(0)),
	(-q^4-q+q^2+1)*e2p(S(0)),
	(q^3+q^2-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(2*q^2-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(-q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i1*k2)*S(1//(q+1)))*q^4+e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q^4+e2p((i1*k2)*S(1//(q+1))),
	e2p((-i1*k2)*S(1//(q+1)))*q^2+e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))*q^2+e2p((i1*k2)*S(1//(q+1))),
	-e2p((-i1*k2)*S(1//(q+1)))*q^2+e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q^2+e2p((i1*k2)*S(1//(q+1))),
	e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1))),
	e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1))),
	e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+i1*k2)*S(1//(q+1)))*q^3+e2p((i1*k1+i1*k2)*S(1//(q+1)))+e2p((i1*k1-i1*k2)*S(1//(q+1)))*q^3+e2p((i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q^3+e2p((-i1*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q^3+e2p((-i1*k1-i1*k2)*S(1//(q+1))),
	e2p((i1*k1+i1*k2)*S(1//(q+1)))+e2p((i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1-i1*k2)*S(1//(q+1))),
	e2p((i1*k1+i1*k2)*S(1//(q+1)))+e2p((i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1-i1*k2)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q-1)))*q^2-2*q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^2-2*q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	-q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	-q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q+1)))*q^2+e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2+e2p((-i1*k1)*S(1//(q+1))),
	-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))+q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q*e2p((-i1*k1*q)*S(1//(q^2-1)))+e2p((-i1*k1*q)*S(1//(q^2-1)))-q*e2p((i1*k1)*S(1//(q^2-1)))+e2p((i1*k1)*S(1//(q^2-1)))-q*e2p((-i1*k1)*S(1//(q^2-1)))+e2p((-i1*k1)*S(1//(q^2-1)))-q*e2p((i1*k1*q)*S(1//(q^2-1)))+e2p((i1*k1*q)*S(1//(q^2-1))),
	e2p((-i1*k1*q)*S(1//(q^2-1)))+e2p((i1*k1)*S(1//(q^2-1)))+e2p((-i1*k1)*S(1//(q^2-1)))+e2p((i1*k1*q)*S(1//(q^2-1))),
	-e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))*q+e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))*q+e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))*q+e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))-e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))*q+e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1))),
	e2p((-q*i2*k2+i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1)))+e2p((q*i2*k2-i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((-q*i2*k2+i2*k2+i1*k1*q+i1*k1)*S(1//(q^2-1)))+e2p((q*i2*k2-i2*k2-i1*k1*q-i1*k1)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-i1*k1-i2*k2)*S(1//(q+1)))*q+e2p((-i1*k1-i2*k2)*S(1//(q+1)))+e2p((i1*k1+i2*k2)*S(1//(q+1)))*q+e2p((i1*k1+i2*k2)*S(1//(q+1)))+e2p((-i1*k1+i2*k2)*S(1//(q+1)))*q+e2p((-i1*k1+i2*k2)*S(1//(q+1)))+e2p((i1*k1-i2*k2)*S(1//(q+1)))*q+e2p((i1*k1-i2*k2)*S(1//(q+1))),
	e2p((-i1*k1-i2*k2)*S(1//(q+1)))+e2p((i1*k1+i2*k2)*S(1//(q+1)))+e2p((-i1*k1+i2*k2)*S(1//(q+1)))+e2p((i1*k1-i2*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1+q*i2*k2-i2*k2)*S(1//(q^2-1)))+e2p((-i1*k1+q*i2*k2-i2*k2)*S(1//(q^2-1)))+e2p((-i1*k1*q-q*i2*k2+i2*k2)*S(1//(q^2-1)))+e2p((-i1*k1-q*i2*k2+i2*k2)*S(1//(q^2-1)))+e2p((i1*k1*q+q*i2*k2-i2*k2)*S(1//(q^2-1)))+e2p((-i1*k1*q+q*i2*k2-i2*k2)*S(1//(q^2-1)))+e2p((i1*k1-q*i2*k2+i2*k2)*S(1//(q^2-1)))+e2p((i1*k1*q-q*i2*k2+i2*k2)*S(1//(q^2-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9+q^8-q^7-q^6-q^3-q^2+q+1)*e2p(S(0)),
	(-q^6-q^5+q^4-q^2+q+1)*e2p(S(0)),
	(-q^3+q-q^2+1)*e2p(S(0)),
	(q^4+q-q^2+1)*e2p(S(0)),
	(-q^3+q-q^2+1)*e2p(S(0)),
	(-2*q^2+q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(q+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	q^4*e2p((i1*k1)*S(1//(q-1)))-2*e2p((i1*k1)*S(1//(q-1)))*q^2+e2p((i1*k1)*S(1//(q-1)))+q^4*e2p((-i1*k1)*S(1//(q-1)))-2*e2p((-i1*k1)*S(1//(q-1)))*q^2+e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))*q^2+e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))*q^2+e2p((-i1*k1)*S(1//(q-1))),
	-e2p((i1*k1)*S(1//(q-1)))*q^2+e2p((i1*k1)*S(1//(q-1)))-e2p((-i1*k1)*S(1//(q-1)))*q^2+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k2)*S(1//(q^2+1)))*q+e2p((i1*k2)*S(1//(q^2+1)))+e2p((q*i1*k2)*S(1//(q^2+1)))*q+e2p((q*i1*k2)*S(1//(q^2+1)))+e2p((-q*i1*k2)*S(1//(q^2+1)))*q+e2p((-q*i1*k2)*S(1//(q^2+1)))+e2p((-i1*k2)*S(1//(q^2+1)))*q+e2p((-i1*k2)*S(1//(q^2+1))),
	e2p((i1*k2)*S(1//(q^2+1)))+e2p((q*i1*k2)*S(1//(q^2+1)))+e2p((-q*i1*k2)*S(1//(q^2+1)))+e2p((-i1*k2)*S(1//(q^2+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((-q*i2*k2+i2*k2+i1*k1*q^2+i1*k1)*S(1//((q-1)*(q^2+1))))+e2p((i2*k2*q^2-q*i2*k2-i1*k1*q^2-i1*k1)*S(1//((q-1)*(q^2+1))))+e2p((q*i2*k2-i2*k2-i1*k1*q^2-i1*k1)*S(1//((q-1)*(q^2+1))))+e2p((-q*i2*k2+i2*k2-i1*k1*q^2-i1*k1)*S(1//((q-1)*(q^2+1))))+e2p((-i2*k2*q^2+q*i2*k2+i1*k1*q^2+i1*k1)*S(1//((q-1)*(q^2+1))))+e2p((q*i2*k2-i2*k2+i1*k1*q^2+i1*k1)*S(1//((q-1)*(q^2+1))))+e2p((-i2*k2*q^2+q*i2*k2-i1*k1*q^2-i1*k1)*S(1//((q-1)*(q^2+1))))+e2p((i2*k2*q^2-q*i2*k2+i1*k1*q^2+i1*k1)*S(1//((q-1)*(q^2+1)))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9-q^7+q^6-q^5-q^4+q^3-q^2+1)*e2p(S(0)),
	(q^6-q^4-q^2+1)*e2p(S(0)),
	(-q^5+q^3-q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(-q^2+1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q-1)))*q^3-e2p((i1*k1)*S(1//(q-1)))*q^2-q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1)))*q^3-e2p((-i1*k1)*S(1//(q-1)))*q^2-q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	-q*e2p((i1*k1)*S(1//(q-1)))+e2p((i1*k1)*S(1//(q-1)))-q*e2p((-i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	e2p((i1*k1)*S(1//(q-1)))+e2p((-i1*k1)*S(1//(q-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1*q^2)*S(1//(q^3-1)))+e2p((-i1*k1*q)*S(1//(q^3-1)))+e2p((i1*k1)*S(1//(q^3-1)))+e2p((-i1*k1)*S(1//(q^3-1)))+e2p((-i1*k1*q^2)*S(1//(q^3-1)))+e2p((i1*k1*q)*S(1//(q^3-1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9-3*q^8+5*q^7-7*q^6+8*q^5-8*q^4+7*q^3-5*q^2+3*q-1)*e2p(S(0)),
	(-q^6+3*q^5-5*q^4+6*q^3-5*q^2+3*q-1)*e2p(S(0)),
	(2*q^5+7*q^3-6*q^4-5*q^2+3*q-1)*e2p(S(0)),
	(-3*q^4+6*q^3-5*q^2+3*q-1)*e2p(S(0)),
	(3*q^3-5*q^2+3*q-1)*e2p(S(0)),
	(-2*q^2+3*q-1)*e2p(S(0)),
	(-4*q^2+3*q-1)*e2p(S(0)),
	(-2*q^2+3*q-1)*e2p(S(0)),
	(-2*q^2+3*q-1)*e2p(S(0)),
	(3*q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-q^4*e2p((i1*k1)*S(1//(q+1)))-q^4*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-2*e2p((i1*k1)*S(1//(q+1)))*q^2-2*e2p((-i1*k1)*S(1//(q+1)))*q^2+2*e2p((-i1*k1)*S(1//(q+1)))*q^3+2*e2p((i1*k1)*S(1//(q+1)))*q^3-e2p((-i1*k2)*S(1//(q+1)))+2*e2p((i1*k2)*S(1//(q+1)))*q^3-2*e2p((i1*k2)*S(1//(q+1)))*q^2-2*e2p((-i1*k2)*S(1//(q+1)))*q^2+2*e2p((-i1*k2)*S(1//(q+1)))*q^3+2*e2p((-i1*k2)*S(1//(q+1)))*q+2*e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1)))*q^4-e2p((-i1*k2)*S(1//(q+1)))*q^4-e2p((i1*k2)*S(1//(q+1)))+2*e2p((-i1*k3)*S(1//(q+1)))*q^3+2*e2p((-i1*k3)*S(1//(q+1)))*q+2*e2p((i1*k3)*S(1//(q+1)))*q-e2p((-i1*k3)*S(1//(q+1)))*q^4-2*e2p((-i1*k3)*S(1//(q+1)))*q^2-e2p((i1*k3)*S(1//(q+1)))*q^4-2*e2p((i1*k3)*S(1//(q+1)))*q^2+2*e2p((i1*k3)*S(1//(q+1)))*q^3-e2p((-i1*k3)*S(1//(q+1)))-e2p((i1*k3)*S(1//(q+1)))+2*q*e2p((-i1*k1)*S(1//(q+1)))+2*q*e2p((i1*k1)*S(1//(q+1))),
	-e2p((i1*k3)*S(1//(q+1)))*q^2+2*e2p((i1*k3)*S(1//(q+1)))*q-e2p((i1*k3)*S(1//(q+1)))-e2p((-i1*k3)*S(1//(q+1)))*q^2+2*e2p((-i1*k3)*S(1//(q+1)))*q-e2p((-i1*k3)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))*q^2+2*q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))*q^2+2*e2p((-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q^2+2*e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1))),
	-e2p((i1*k3)*S(1//(q+1)))*q^2+2*e2p((i1*k3)*S(1//(q+1)))*q-e2p((i1*k3)*S(1//(q+1)))-e2p((-i1*k3)*S(1//(q+1)))*q^2+2*e2p((-i1*k3)*S(1//(q+1)))*q-e2p((-i1*k3)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))*q^2+2*q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))*q^2+2*q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))*q^2+2*e2p((-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q^2+2*e2p((i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1))),
	-e2p((i1*k3)*S(1//(q+1)))+2*e2p((i1*k3)*S(1//(q+1)))*q-e2p((-i1*k3)*S(1//(q+1)))+2*e2p((-i1*k3)*S(1//(q+1)))*q-e2p((i1*k1)*S(1//(q+1)))+2*q*e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))+2*q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))+2*e2p((-i1*k2)*S(1//(q+1)))*q-e2p((i1*k2)*S(1//(q+1)))+2*e2p((i1*k2)*S(1//(q+1)))*q,
	-e2p((i1*k3)*S(1//(q+1)))-e2p((-i1*k3)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1))),
	-e2p((i1*k3)*S(1//(q+1)))-e2p((-i1*k3)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i1*k1-i1*k2+i1*k3)*S(1//(q+1)))-e2p((i1*k1+i1*k2+i1*k3)*S(1//(q+1)))-2*e2p((-i1*k1-i1*k2+i1*k3)*S(1//(q+1)))*q^2+e2p((-i1*k1-i1*k2+i1*k3)*S(1//(q+1)))*q^3+2*e2p((i1*k1-i1*k2-i1*k3)*S(1//(q+1)))*q-2*e2p((i1*k1-i1*k2-i1*k3)*S(1//(q+1)))*q^2+e2p((i1*k1-i1*k2-i1*k3)*S(1//(q+1)))*q^3+2*e2p((-i1*k1+i1*k2+i1*k3)*S(1//(q+1)))*q-2*e2p((-i1*k1+i1*k2+i1*k3)*S(1//(q+1)))*q^2+e2p((-i1*k1+i1*k2+i1*k3)*S(1//(q+1)))*q^3+2*e2p((-i1*k1+i1*k2-i1*k3)*S(1//(q+1)))*q-2*e2p((-i1*k1+i1*k2-i1*k3)*S(1//(q+1)))*q^2+e2p((-i1*k1+i1*k2-i1*k3)*S(1//(q+1)))*q^3+2*e2p((i1*k1-i1*k2+i1*k3)*S(1//(q+1)))*q-2*e2p((i1*k1-i1*k2+i1*k3)*S(1//(q+1)))*q^2+e2p((i1*k1-i1*k2+i1*k3)*S(1//(q+1)))*q^3+2*e2p((i1*k1+i1*k2-i1*k3)*S(1//(q+1)))*q-2*e2p((i1*k1+i1*k2-i1*k3)*S(1//(q+1)))*q^2+e2p((i1*k1+i1*k2-i1*k3)*S(1//(q+1)))*q^3+2*e2p((-i1*k1-i1*k2-i1*k3)*S(1//(q+1)))*q-2*e2p((-i1*k1-i1*k2-i1*k3)*S(1//(q+1)))*q^2+2*e2p((i1*k1+i1*k2+i1*k3)*S(1//(q+1)))*q-2*e2p((i1*k1+i1*k2+i1*k3)*S(1//(q+1)))*q^2+e2p((i1*k1+i1*k2+i1*k3)*S(1//(q+1)))*q^3+e2p((-i1*k1-i1*k2-i1*k3)*S(1//(q+1)))*q^3+2*e2p((-i1*k1-i1*k2+i1*k3)*S(1//(q+1)))*q-e2p((i1*k1-i1*k2-i1*k3)*S(1//(q+1)))-e2p((-i1*k1+i1*k2+i1*k3)*S(1//(q+1)))-e2p((i1*k1-i1*k2+i1*k3)*S(1//(q+1)))-e2p((-i1*k1+i1*k2-i1*k3)*S(1//(q+1)))-e2p((-i1*k1-i1*k2-i1*k3)*S(1//(q+1)))-e2p((i1*k1+i1*k2-i1*k3)*S(1//(q+1))),
	-e2p((-i1*k1-i1*k2-i1*k3)*S(1//(q+1)))+2*e2p((-i1*k1-i1*k2-i1*k3)*S(1//(q+1)))*q-e2p((i1*k1+i1*k2-i1*k3)*S(1//(q+1)))+2*e2p((i1*k1+i1*k2-i1*k3)*S(1//(q+1)))*q-e2p((i1*k1-i1*k2+i1*k3)*S(1//(q+1)))+2*e2p((i1*k1-i1*k2+i1*k3)*S(1//(q+1)))*q-e2p((-i1*k1+i1*k2-i1*k3)*S(1//(q+1)))+2*e2p((-i1*k1+i1*k2-i1*k3)*S(1//(q+1)))*q-e2p((-i1*k1+i1*k2+i1*k3)*S(1//(q+1)))+2*e2p((-i1*k1+i1*k2+i1*k3)*S(1//(q+1)))*q-e2p((i1*k1-i1*k2-i1*k3)*S(1//(q+1)))+2*e2p((i1*k1-i1*k2-i1*k3)*S(1//(q+1)))*q-e2p((-i1*k1-i1*k2+i1*k3)*S(1//(q+1)))+2*e2p((-i1*k1-i1*k2+i1*k3)*S(1//(q+1)))*q-e2p((i1*k1+i1*k2+i1*k3)*S(1//(q+1)))+2*e2p((i1*k1+i1*k2+i1*k3)*S(1//(q+1)))*q,
	-e2p((-i1*k1-i1*k2-i1*k3)*S(1//(q+1)))-e2p((i1*k1+i1*k2-i1*k3)*S(1//(q+1)))-e2p((i1*k1-i1*k2+i1*k3)*S(1//(q+1)))-e2p((-i1*k1+i1*k2-i1*k3)*S(1//(q+1)))-e2p((-i1*k1+i1*k2+i1*k3)*S(1//(q+1)))-e2p((i1*k1-i1*k2-i1*k3)*S(1//(q+1)))-e2p((-i1*k1-i1*k2+i1*k3)*S(1//(q+1)))-e2p((i1*k1+i1*k2+i1*k3)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i1*k1+i1*k3)*S(1//(q+1)))-e2p((i1*k1+i1*k3)*S(1//(q+1)))-e2p((-i1*k1-i1*k3)*S(1//(q+1)))-e2p((i1*k1-i1*k3)*S(1//(q+1)))-e2p((i1*k1-i1*k2)*S(1//(q+1)))-e2p((i1*k1+i1*k2)*S(1//(q+1)))+2*e2p((i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((i1*k1-i1*k2)*S(1//(q+1)))*q^2+2*e2p((i1*k1-i1*k2)*S(1//(q+1)))*q+2*e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q^2+2*e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q^2-e2p((i1*k1+i1*k2)*S(1//(q+1)))*q^2-e2p((-i1*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k1+i1*k2)*S(1//(q+1)))-e2p((-i1*k1-i1*k3)*S(1//(q+1)))*q^2+2*e2p((i1*k1+i1*k3)*S(1//(q+1)))*q+2*e2p((-i1*k1-i1*k3)*S(1//(q+1)))*q-e2p((i1*k1-i1*k3)*S(1//(q+1)))*q^2+2*e2p((-i1*k1+i1*k3)*S(1//(q+1)))*q-e2p((i1*k1+i1*k3)*S(1//(q+1)))*q^2-e2p((-i1*k1+i1*k3)*S(1//(q+1)))*q^2+2*e2p((i1*k1-i1*k3)*S(1//(q+1)))*q-e2p((-i1*k2+i1*k3)*S(1//(q+1)))-e2p((i1*k2-i1*k3)*S(1//(q+1)))-e2p((i1*k2-i1*k3)*S(1//(q+1)))*q^2-e2p((-i1*k2+i1*k3)*S(1//(q+1)))*q^2-e2p((-i1*k2-i1*k3)*S(1//(q+1)))*q^2-e2p((i1*k2+i1*k3)*S(1//(q+1)))*q^2-e2p((i1*k2+i1*k3)*S(1//(q+1)))-e2p((-i1*k2-i1*k3)*S(1//(q+1)))+2*e2p((i1*k2+i1*k3)*S(1//(q+1)))*q+2*e2p((i1*k2-i1*k3)*S(1//(q+1)))*q+2*e2p((-i1*k2-i1*k3)*S(1//(q+1)))*q+2*e2p((-i1*k2+i1*k3)*S(1//(q+1)))*q,
	e2p((-i1*k1+i1*k3)*S(1//(q+1)))*q-e2p((-i1*k1+i1*k3)*S(1//(q+1)))+e2p((i1*k1+i1*k3)*S(1//(q+1)))*q-e2p((i1*k1+i1*k3)*S(1//(q+1)))+e2p((i1*k1-i1*k3)*S(1//(q+1)))*q-e2p((i1*k1-i1*k3)*S(1//(q+1)))+e2p((-i1*k1-i1*k3)*S(1//(q+1)))*q-e2p((-i1*k1-i1*k3)*S(1//(q+1)))+e2p((i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((i1*k1+i1*k2)*S(1//(q+1)))+e2p((i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1-i1*k2)*S(1//(q+1)))+e2p((i1*k2-i1*k3)*S(1//(q+1)))*q-e2p((i1*k2-i1*k3)*S(1//(q+1)))+e2p((-i1*k2+i1*k3)*S(1//(q+1)))*q-e2p((-i1*k2+i1*k3)*S(1//(q+1)))+e2p((-i1*k2-i1*k3)*S(1//(q+1)))*q-e2p((-i1*k2-i1*k3)*S(1//(q+1)))+e2p((i1*k2+i1*k3)*S(1//(q+1)))*q-e2p((i1*k2+i1*k3)*S(1//(q+1))),
	e2p((-i1*k1+i1*k3)*S(1//(q+1)))*q-e2p((-i1*k1+i1*k3)*S(1//(q+1)))+e2p((i1*k1+i1*k3)*S(1//(q+1)))*q-e2p((i1*k1+i1*k3)*S(1//(q+1)))+e2p((i1*k1-i1*k3)*S(1//(q+1)))*q-e2p((i1*k1-i1*k3)*S(1//(q+1)))+e2p((-i1*k1-i1*k3)*S(1//(q+1)))*q-e2p((-i1*k1-i1*k3)*S(1//(q+1)))+e2p((i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((i1*k1+i1*k2)*S(1//(q+1)))+e2p((i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((i1*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1+i1*k2)*S(1//(q+1)))+e2p((-i1*k1-i1*k2)*S(1//(q+1)))*q-e2p((-i1*k1-i1*k2)*S(1//(q+1)))+e2p((i1*k2-i1*k3)*S(1//(q+1)))*q-e2p((i1*k2-i1*k3)*S(1//(q+1)))+e2p((-i1*k2+i1*k3)*S(1//(q+1)))*q-e2p((-i1*k2+i1*k3)*S(1//(q+1)))+e2p((-i1*k2-i1*k3)*S(1//(q+1)))*q-e2p((-i1*k2-i1*k3)*S(1//(q+1)))+e2p((i1*k2+i1*k3)*S(1//(q+1)))*q-e2p((i1*k2+i1*k3)*S(1//(q+1))),
	-e2p((-i1*k1+i1*k3)*S(1//(q+1)))-e2p((i1*k1+i1*k3)*S(1//(q+1)))-e2p((i1*k1-i1*k3)*S(1//(q+1)))-e2p((-i1*k1-i1*k3)*S(1//(q+1)))-e2p((i1*k1+i1*k2)*S(1//(q+1)))-e2p((i1*k1-i1*k2)*S(1//(q+1)))-e2p((-i1*k1+i1*k2)*S(1//(q+1)))-e2p((-i1*k1-i1*k2)*S(1//(q+1)))-e2p((i1*k2-i1*k3)*S(1//(q+1)))-e2p((-i1*k2+i1*k3)*S(1//(q+1)))-e2p((-i1*k2-i1*k3)*S(1//(q+1)))-e2p((i1*k2+i1*k3)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i1*k1-i2*k3)*S(1//(q+1)))-e2p((i2*k1-i1*k3)*S(1//(q+1)))-e2p((i2*k1+i1*k3)*S(1//(q+1)))-e2p((-i1*k1+i2*k3)*S(1//(q+1)))-e2p((i1*k1-i2*k3)*S(1//(q+1)))-e2p((-i2*k1+i1*k3)*S(1//(q+1)))-e2p((i1*k1+i2*k3)*S(1//(q+1)))-e2p((-i2*k1-i1*k3)*S(1//(q+1)))+e2p((-i1*k1+i2*k3)*S(1//(q+1)))*q+e2p((i1*k1-i2*k3)*S(1//(q+1)))*q+e2p((-i2*k1+i1*k3)*S(1//(q+1)))*q+e2p((i2*k1-i1*k3)*S(1//(q+1)))*q+e2p((-i1*k1-i2*k3)*S(1//(q+1)))*q+e2p((i2*k1+i1*k3)*S(1//(q+1)))*q+e2p((i1*k1+i2*k3)*S(1//(q+1)))*q+e2p((-i2*k1-i1*k3)*S(1//(q+1)))*q-e2p((i1*k1+i2*k2)*S(1//(q+1)))-e2p((-i1*k1-i2*k2)*S(1//(q+1)))-e2p((i2*k1+i1*k2)*S(1//(q+1)))-e2p((i1*k1-i2*k2)*S(1//(q+1)))-e2p((-i1*k1+i2*k2)*S(1//(q+1)))-e2p((-i2*k1+i1*k2)*S(1//(q+1)))-e2p((i2*k1-i1*k2)*S(1//(q+1)))-e2p((-i2*k1-i1*k2)*S(1//(q+1)))+e2p((-i1*k1+i2*k2)*S(1//(q+1)))*q+e2p((i1*k1-i2*k2)*S(1//(q+1)))*q+e2p((i2*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i2*k1-i1*k2)*S(1//(q+1)))*q+e2p((i2*k1-i1*k2)*S(1//(q+1)))*q+e2p((-i2*k1+i1*k2)*S(1//(q+1)))*q+e2p((-i1*k1-i2*k2)*S(1//(q+1)))*q+e2p((i1*k1+i2*k2)*S(1//(q+1)))*q-e2p((i1*k2-i2*k3)*S(1//(q+1)))-e2p((i1*k2+i2*k3)*S(1//(q+1)))-e2p((-i1*k2-i2*k3)*S(1//(q+1)))-e2p((i2*k2+i1*k3)*S(1//(q+1)))-e2p((-i2*k2+i1*k3)*S(1//(q+1)))-e2p((i2*k2-i1*k3)*S(1//(q+1)))-e2p((-i1*k2+i2*k3)*S(1//(q+1)))-e2p((-i2*k2-i1*k3)*S(1//(q+1)))+e2p((i1*k2-i2*k3)*S(1//(q+1)))*q+e2p((i2*k2+i1*k3)*S(1//(q+1)))*q+e2p((-i1*k2-i2*k3)*S(1//(q+1)))*q+e2p((i1*k2+i2*k3)*S(1//(q+1)))*q+e2p((-i2*k2-i1*k3)*S(1//(q+1)))*q+e2p((-i1*k2+i2*k3)*S(1//(q+1)))*q+e2p((i2*k2-i1*k3)*S(1//(q+1)))*q+e2p((-i2*k2+i1*k3)*S(1//(q+1)))*q,
	-e2p((-i1*k1-i2*k3)*S(1//(q+1)))-e2p((i2*k1+i1*k3)*S(1//(q+1)))-e2p((i2*k1-i1*k3)*S(1//(q+1)))-e2p((-i2*k1+i1*k3)*S(1//(q+1)))-e2p((i1*k1-i2*k3)*S(1//(q+1)))-e2p((-i1*k1+i2*k3)*S(1//(q+1)))-e2p((-i1*k1-i2*k2)*S(1//(q+1)))-e2p((i1*k1+i2*k2)*S(1//(q+1)))-e2p((-i1*k1+i2*k2)*S(1//(q+1)))-e2p((i1*k1-i2*k2)*S(1//(q+1)))-e2p((i1*k2-i2*k3)*S(1//(q+1)))-e2p((i2*k2+i1*k3)*S(1//(q+1)))-e2p((-i1*k2-i2*k3)*S(1//(q+1)))-e2p((i1*k2+i2*k3)*S(1//(q+1)))-e2p((-i2*k2-i1*k3)*S(1//(q+1)))-e2p((-i1*k2+i2*k3)*S(1//(q+1)))-e2p((i2*k2-i1*k3)*S(1//(q+1)))-e2p((-i2*k2+i1*k3)*S(1//(q+1)))-e2p((-i2*k1-i1*k3)*S(1//(q+1)))-e2p((i2*k1+i1*k2)*S(1//(q+1)))-e2p((-i2*k1-i1*k2)*S(1//(q+1)))-e2p((i2*k1-i1*k2)*S(1//(q+1)))-e2p((i1*k1+i2*k3)*S(1//(q+1)))-e2p((-i2*k1+i1*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1-i2*k2+i1*k3)*S(1//(q+1)))-e2p((-i2*k1-i1*k2+i1*k3)*S(1//(q+1)))+e2p((i1*k1-i2*k2-i1*k3)*S(1//(q+1)))*q+e2p((-i1*k1-i1*k2+i2*k3)*S(1//(q+1)))*q+e2p((-i1*k1-i1*k2-i2*k3)*S(1//(q+1)))*q+e2p((i1*k1+i2*k2+i1*k3)*S(1//(q+1)))*q+e2p((i1*k1-i1*k2-i2*k3)*S(1//(q+1)))*q+e2p((i2*k1-i1*k2+i1*k3)*S(1//(q+1)))*q+e2p((-i1*k1+i1*k2-i2*k3)*S(1//(q+1)))*q+e2p((i2*k1+i1*k2+i1*k3)*S(1//(q+1)))*q+e2p((i1*k1-i2*k2+i1*k3)*S(1//(q+1)))*q+e2p((-i2*k1-i1*k2+i1*k3)*S(1//(q+1)))*q+e2p((-i2*k1+i1*k2-i1*k3)*S(1//(q+1)))*q+e2p((i1*k1+i1*k2-i2*k3)*S(1//(q+1)))*q+e2p((-i2*k1-i1*k2-i1*k3)*S(1//(q+1)))*q+e2p((-i1*k1+i2*k2+i1*k3)*S(1//(q+1)))*q+e2p((-i1*k1-i2*k2+i1*k3)*S(1//(q+1)))*q+e2p((-i2*k1+i1*k2+i1*k3)*S(1//(q+1)))*q+e2p((i1*k1+i2*k2-i1*k3)*S(1//(q+1)))*q+e2p((i1*k1-i1*k2+i2*k3)*S(1//(q+1)))*q+e2p((i2*k1+i1*k2-i1*k3)*S(1//(q+1)))*q+e2p((i1*k1+i1*k2+i2*k3)*S(1//(q+1)))*q+e2p((-i1*k1+i2*k2-i1*k3)*S(1//(q+1)))*q+e2p((-i1*k1+i1*k2+i2*k3)*S(1//(q+1)))*q+e2p((i2*k1-i1*k2-i1*k3)*S(1//(q+1)))*q+e2p((-i1*k1-i2*k2-i1*k3)*S(1//(q+1)))*q-e2p((-i1*k1+i1*k2-i2*k3)*S(1//(q+1)))-e2p((i2*k1+i1*k2+i1*k3)*S(1//(q+1)))-e2p((i2*k1-i1*k2+i1*k3)*S(1//(q+1)))-e2p((i1*k1-i1*k2-i2*k3)*S(1//(q+1)))-e2p((i1*k1+i2*k2+i1*k3)*S(1//(q+1)))-e2p((-i1*k1+i2*k2+i1*k3)*S(1//(q+1)))-e2p((-i1*k1-i1*k2-i2*k3)*S(1//(q+1)))-e2p((-i1*k1-i1*k2+i2*k3)*S(1//(q+1)))-e2p((i1*k1-i2*k2-i1*k3)*S(1//(q+1)))-e2p((-i1*k1+i1*k2+i2*k3)*S(1//(q+1)))-e2p((-i1*k1-i2*k2-i1*k3)*S(1//(q+1)))-e2p((i2*k1-i1*k2-i1*k3)*S(1//(q+1)))-e2p((i1*k1+i1*k2+i2*k3)*S(1//(q+1)))-e2p((-i1*k1+i2*k2-i1*k3)*S(1//(q+1)))-e2p((i1*k1-i1*k2+i2*k3)*S(1//(q+1)))-e2p((i1*k1+i2*k2-i1*k3)*S(1//(q+1)))-e2p((i2*k1+i1*k2-i1*k3)*S(1//(q+1)))-e2p((-i1*k1-i2*k2+i1*k3)*S(1//(q+1)))-e2p((-i2*k1-i1*k2-i1*k3)*S(1//(q+1)))-e2p((-i2*k1+i1*k2+i1*k3)*S(1//(q+1)))-e2p((i1*k1+i1*k2-i2*k3)*S(1//(q+1)))-e2p((-i2*k1+i1*k2-i1*k3)*S(1//(q+1))),
	-e2p((i2*k1+i1*k2+i1*k3)*S(1//(q+1)))-e2p((-i1*k1+i1*k2-i2*k3)*S(1//(q+1)))-e2p((-i1*k1+i2*k2+i1*k3)*S(1//(q+1)))-e2p((i1*k1+i2*k2+i1*k3)*S(1//(q+1)))-e2p((i1*k1-i1*k2-i2*k3)*S(1//(q+1)))-e2p((i2*k1-i1*k2+i1*k3)*S(1//(q+1)))-e2p((i1*k1-i2*k2-i1*k3)*S(1//(q+1)))-e2p((-i1*k1-i1*k2+i2*k3)*S(1//(q+1)))-e2p((-i1*k1-i1*k2-i2*k3)*S(1//(q+1)))-e2p((i2*k1-i1*k2-i1*k3)*S(1//(q+1)))-e2p((-i1*k1-i2*k2-i1*k3)*S(1//(q+1)))-e2p((-i1*k1+i1*k2+i2*k3)*S(1//(q+1)))-e2p((i1*k1+i1*k2+i2*k3)*S(1//(q+1)))-e2p((-i1*k1+i2*k2-i1*k3)*S(1//(q+1)))-e2p((i1*k1+i2*k2-i1*k3)*S(1//(q+1)))-e2p((i1*k1-i1*k2+i2*k3)*S(1//(q+1)))-e2p((i2*k1+i1*k2-i1*k3)*S(1//(q+1)))-e2p((-i1*k1-i2*k2+i1*k3)*S(1//(q+1)))-e2p((-i2*k1+i1*k2+i1*k3)*S(1//(q+1)))-e2p((-i2*k1-i1*k2-i1*k3)*S(1//(q+1)))-e2p((-i2*k1+i1*k2-i1*k3)*S(1//(q+1)))-e2p((i1*k1+i1*k2-i2*k3)*S(1//(q+1)))-e2p((i1*k1-i2*k2+i1*k3)*S(1//(q+1)))-e2p((-i2*k1-i1*k2+i1*k3)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i2*k1+i1*k2+i3*k3)*S(1//(q+1)))-e2p((i2*k1-i1*k2+i3*k3)*S(1//(q+1)))-e2p((i3*k1-i1*k2-i2*k3)*S(1//(q+1)))-e2p((i3*k1+i2*k2+i1*k3)*S(1//(q+1)))-e2p((i1*k1-i3*k2+i2*k3)*S(1//(q+1)))-e2p((-i1*k1-i2*k2-i3*k3)*S(1//(q+1)))-e2p((-i3*k1-i2*k2-i1*k3)*S(1//(q+1)))-e2p((-i3*k1+i1*k2+i2*k3)*S(1//(q+1)))-e2p((-i3*k1-i1*k2-i2*k3)*S(1//(q+1)))-e2p((-i2*k1-i3*k2-i1*k3)*S(1//(q+1)))-e2p((i3*k1-i1*k2+i2*k3)*S(1//(q+1)))-e2p((i1*k1+i3*k2+i2*k3)*S(1//(q+1)))-e2p((i3*k1-i2*k2-i1*k3)*S(1//(q+1)))-e2p((i3*k1+i2*k2-i1*k3)*S(1//(q+1)))-e2p((i2*k1-i3*k2+i1*k3)*S(1//(q+1)))-e2p((-i1*k1-i3*k2-i2*k3)*S(1//(q+1)))-e2p((i2*k1+i1*k2-i3*k3)*S(1//(q+1)))-e2p((i3*k1+i1*k2+i2*k3)*S(1//(q+1)))-e2p((-i1*k1+i2*k2-i3*k3)*S(1//(q+1)))-e2p((i2*k1+i1*k2+i3*k3)*S(1//(q+1)))-e2p((-i1*k1-i2*k2+i3*k3)*S(1//(q+1)))-e2p((i3*k1+i1*k2-i2*k3)*S(1//(q+1)))-e2p((i1*k1+i3*k2-i2*k3)*S(1//(q+1)))-e2p((-i2*k1-i3*k2+i1*k3)*S(1//(q+1)))-e2p((-i2*k1+i1*k2-i3*k3)*S(1//(q+1)))-e2p((-i3*k1+i1*k2-i2*k3)*S(1//(q+1)))-e2p((-i2*k1+i3*k2-i1*k3)*S(1//(q+1)))-e2p((-i1*k1+i3*k2-i2*k3)*S(1//(q+1)))-e2p((i2*k1+i3*k2+i1*k3)*S(1//(q+1)))-e2p((-i3*k1+i2*k2+i1*k3)*S(1//(q+1)))-e2p((-i1*k1+i2*k2+i3*k3)*S(1//(q+1)))-e2p((-i3*k1-i1*k2+i2*k3)*S(1//(q+1)))-e2p((-i2*k1-i1*k2-i3*k3)*S(1//(q+1)))-e2p((-i3*k1-i2*k2+i1*k3)*S(1//(q+1)))-e2p((i1*k1+i2*k2-i3*k3)*S(1//(q+1)))-e2p((-i3*k1+i2*k2-i1*k3)*S(1//(q+1)))-e2p((-i1*k1+i3*k2+i2*k3)*S(1//(q+1)))-e2p((i2*k1-i3*k2-i1*k3)*S(1//(q+1)))-e2p((i3*k1-i2*k2+i1*k3)*S(1//(q+1)))-e2p((-i2*k1+i3*k2+i1*k3)*S(1//(q+1)))-e2p((-i1*k1-i3*k2+i2*k3)*S(1//(q+1)))-e2p((i2*k1+i3*k2-i1*k3)*S(1//(q+1)))-e2p((i1*k1-i2*k2+i3*k3)*S(1//(q+1)))-e2p((i1*k1-i2*k2-i3*k3)*S(1//(q+1)))-e2p((i2*k1-i1*k2-i3*k3)*S(1//(q+1)))-e2p((i1*k1-i3*k2-i2*k3)*S(1//(q+1)))-e2p((-i2*k1-i1*k2+i3*k3)*S(1//(q+1)))-e2p((i1*k1+i2*k2+i3*k3)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0))] [
	(q^9-q^8-q^7+q^6-q^3+q^2+q-1)*e2p(S(0)),
	(q^6-q^5-q^4+q^2+q-1)*e2p(S(0)),
	(-q^3+q^2+q-1)*e2p(S(0)),
	(-q^4+q^2+q-1)*e2p(S(0)),
	(-q^3+q^2+q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(2*q^2+q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(q-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((-i1*k2)*S(1//(q+1)))*q^4+2*e2p((-i1*k2)*S(1//(q+1)))*q^2-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1)))*q^4+2*e2p((i1*k2)*S(1//(q+1)))*q^2-e2p((i1*k2)*S(1//(q+1))),
	e2p((-i1*k2)*S(1//(q+1)))*q^2-e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))*q^2-e2p((i1*k2)*S(1//(q+1))),
	e2p((-i1*k2)*S(1//(q+1)))*q^2-e2p((-i1*k2)*S(1//(q+1)))+e2p((i1*k2)*S(1//(q+1)))*q^2-e2p((i1*k2)*S(1//(q+1))),
	-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1))),
	-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1))),
	-e2p((-i1*k2)*S(1//(q+1)))-e2p((i1*k2)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	q*e2p((i1*k1)*S(1//(q^2+1)))-e2p((i1*k1)*S(1//(q^2+1)))+q*e2p((-i1*k1*q)*S(1//(q^2+1)))-e2p((-i1*k1*q)*S(1//(q^2+1)))+q*e2p((i1*k1*q)*S(1//(q^2+1)))-e2p((i1*k1*q)*S(1//(q^2+1)))+q*e2p((-i1*k1)*S(1//(q^2+1)))-e2p((-i1*k1)*S(1//(q^2+1))),
	-e2p((i1*k1)*S(1//(q^2+1)))-e2p((-i1*k1*q)*S(1//(q^2+1)))-e2p((i1*k1*q)*S(1//(q^2+1)))-e2p((-i1*k1)*S(1//(q^2+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i2*k2*q^3+q*i2*k2-i1*k1*q^2-i2*k2*q^2-i2*k2+i1*k1)*S(1//(q^4-1)))-e2p((-i1*k1*q^3-i2*k2*q^3-q*i2*k2+i1*k1*q+i2*k2*q^2+i2*k2)*S(1//(q^4-1)))-e2p((i1*k1*q^3+i2*k2*q^3+q*i2*k2-i1*k1*q-i2*k2*q^2-i2*k2)*S(1//(q^4-1)))-e2p((-i2*k2*q^3-q*i2*k2-i1*k1*q^2+i2*k2*q^2+i2*k2+i1*k1)*S(1//(q^4-1)))-e2p((-i1*k1*q^3+i2*k2*q^3+q*i2*k2+i1*k1*q-i2*k2*q^2-i2*k2)*S(1//(q^4-1)))-e2p((-i2*k2*q^3-q*i2*k2+i1*k1*q^2+i2*k2*q^2+i2*k2-i1*k1)*S(1//(q^4-1)))-e2p((i2*k2*q^3+q*i2*k2+i1*k1*q^2-i2*k2*q^2-i2*k2-i1*k1)*S(1//(q^4-1)))-e2p((i1*k1*q^3-i2*k2*q^3-q*i2*k2-i1*k1*q+i2*k2*q^2+i2*k2)*S(1//(q^4-1))),
	(0)*e2p(S(0))] [
	(q^9-q^7-q^5-q^6+q^4+q^3+q^2-1)*e2p(S(0)),
	(-q^6+q^4+q^2-1)*e2p(S(0)),
	(-q^5+q^3+q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(q^2-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(-1)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	e2p((i1*k1)*S(1//(q+1)))*q^3-q*e2p((i1*k1)*S(1//(q+1)))+e2p((i1*k1)*S(1//(q+1)))*q^2-e2p((i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^3-q*e2p((-i1*k1)*S(1//(q+1)))+e2p((-i1*k1)*S(1//(q+1)))*q^2-e2p((-i1*k1)*S(1//(q+1))),
	-q*e2p((i1*k1)*S(1//(q+1)))-e2p((i1*k1)*S(1//(q+1)))-q*e2p((-i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	-e2p((i1*k1)*S(1//(q+1)))-e2p((-i1*k1)*S(1//(q+1))),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	(0)*e2p(S(0)),
	-e2p((i1*k1)*S(1//(q^3+1)))-e2p((-i1*k1)*S(1//(q^3+1)))-e2p((-i1*k1*q)*S(1//(q^3+1)))-e2p((i1*k1*q^2)*S(1//(q^3+1)))-e2p((-i1*k1*q^2)*S(1//(q^3+1)))-e2p((i1*k1*q)*S(1//(q^3+1)))]]
classinfo = Vector{Any}[
	["",[1,0],"C_3","h_1"],
	["",[1,1],"C_3","h_1u_9(1)"],
	["",[1,2],"C_3","h_1u_8(1)"],
	["",[1,3],"C_3","h_1u_8(1)u_9(1)"],
	["",[1,4],"C_3","h_1u_6(1)u_7(1)"],
	["",[1,5],"C_3","h_1u_3(1)u_5(1)"],
	["",[1,6],"C_3","h_1u_3(1)u_5(1)u_7(1)u_9(alpha)"],
	["",[1,7],"C_3","h_1u_3(1)u_4(1)"],
	["",[1,8],"C_3","h_1u_3(1)u_4(1)u_9(alpha)"],
	["",[1,9],"C_3","h_1u_3(1)u_4(1)u_7(1)"],
	["",[1,10],"C_3","h_1u_1(1)u_2(1)u_4(1)"],
	["",[1,11],"C_3","h_1u_1(1)u_2(1)u_4(1)u_7(alpha)"],
	["",[3,0],"C_2","h_3(i_1)"],
	["",[3,1],"C_2","h_3(i_1)u_7(1)"],
	["",[3,2],"C_2","h_3(i_1)u_5(1)"],
	["",[3,3],"C_2","h_3(i_1)u_5(1)u_7(1)"],
	["",[3,4],"C_2","h_3(i_1)u_2(1)u_4(1)"],
	["",[3,5],"C_2","h_3(i_1)u_2(1)u_4(1)u_7(alpha)"],
	["",[4,0],"C_2","h_4(i_1)"],
	["",[4,1],"C_2","h_4(i_1)u_7(1)"],
	["",[4,2],"C_2","h_4(i_1)u_5(1)"],
	["",[4,3],"C_2","h_4(i_1)u_5(1)u_7(1)"],
	["",[4,4],"C_2","h_4(i_1)u_2(1)u_4(1)"],
	["",[4,5],"C_2","h_4(i_1)u_2(1)u_4(1)u_7(alpha)"],
	["",[5,0],"A_2","h_5(i_1)"],
	["",[5,1],"A_2","h_5(i_1)u_2(1)"],
	["",[5,2],"A_2","h_5(i_1)u_2(1)u_1(1)"],
	["",[6,0],"^2A_2","h_6(i_1)"],
	["",[6,1],"^2A_2","h_6(i_1)u_2(1)"],
	["",[6,2],"^2A_2","h_6(i_1)u_2(1)u_1(1)"],
	["",[8,0],"A_1+\\tilde{A}_1","h_8(i_1)"],
	["",[8,1],"A_1+\\tilde{A}_1","h_8(i_1)u_1(1)"],
	["",[8,2],"A_1+\\tilde{A}_1","h_8(i_1)u_4(1)"],
	["",[8,3],"A_1+\\tilde{A}_1","h_8(i_1)u_1(1)u_4(1)"],
	["",[10,0],"A_1+\\tilde{A}_1","h_{10}(i_1)"],
	["",[10,1],"A_1+\\tilde{A}_1","h_{10}(i_1)u_1(1)"],
	["",[10,2],"A_1+\\tilde{A}_1","h_{10}(i_1)u_4(1)"],
	["",[10,3],"A_1+\\tilde{A}_1","h_{10}(i_1)u_1(1)u_4(1)"],
	["",[13,0],"\\tilde{A}_1","h_{13}(i_1,i_2)"],
	["",[13,1],"\\tilde{A}_1","h_{13}(i_1,i_2)u_4(1)"],
	["",[14,0],"A_1","h_{14}(i_1,i_2)"],
	["",[14,1],"A_1","h_{14}(i_1,i_2)u_1(1)"],
	["",[15,0],"\\tilde{A}_1","h_{15}(i_1,i_2)"],
	["",[15,1],"\\tilde{A}_1","h_{15}(i_1,i_2)u_4(1)"],
	["",[16,0],"\\tilde{A}_1","h_{16}(i_1,i_2)"],
	["",[16,1],"\\tilde{A}_1","h_{16}(i_1,i_2)u_4(1)"],
	["",[17,0],"A_1","h_{17}(i_1,i_2)"],
	["",[17,1],"A_1","h_{17}(i_1,i_2)u_1(1)"],
	["",[18,0],"A_1","h_{18}(i_1,i_2)"],
	["",[18,1],"A_1","h_{18}(i_1,i_2)u_1(1)"],
	["",[19,0],"\\tilde{A}_1","h_{19}(i_1,i_2)"],
	["",[19,1],"\\tilde{A}_1","h_{19}(i_1,i_2)u_4(1)"],
	["",[20,0],"\\tilde{A}_1","h_{20}(i_1)"],
	["",[20,1],"\\tilde{A}_1","h_{20}(i_1)u_4(1)"],
	["",[21,0],"A_1","h_{21}(i_1,i_2)"],
	["",[21,1],"A_1","h_{21}(i_1,i_2)u_1(1)"],
	["",[22,0],"A_0","h_{22}(i_1,i_2,i_3)"],
	["",[23,0],"A_0","h_{23}(i_1,i_2,i_3)"],
	["",[24,0],"A_0","h_{24}(i_1,i_2)"],
	["",[25,0],"A_0","h_{25}(i_1,i_2,i_3)"],
	["",[26,0],"A_0","h_{26}(i_1,i_2)"],
	["",[27,0],"A_0","h_{27}(i_1,i_2)"],
	["",[28,0],"A_0","h_{28}(i_1)"],
	["",[29,0],"A_0","h_{29}(i_1,i_2,i_3)"],
	["",[30,0],"A_0","h_{30}(i_1,i_2)"],
	["",[31,0],"A_0","h_{31}(i_1)"]]
classlength = R.([
	1,
	(q-1)*(q+1)*(q^2-q+1)*(q^2+q+1),
	(q+1)*(q^2-q+1)*(q^2+q+1)*(q-1)*(q^2+1),
	(q+1)^2*(q^2-q+1)*(q^2+q+1)*(q-1)^2*(q^2+1),
	q^2*(q+1)^2*(q^2-q+1)*(q^2+q+1)*(q-1)^2*(q^2+1),
	1//2*(q-1)^2*(q+1)^3*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^3,
	1//2*(q-1)^3*(q+1)^2*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^3,
	1//2*q^4*(q+1)^2*(q^2-q+1)*(q^2+q+1)*(q-1)^2*(q^2+1),
	1//2*q^4*(q+1)^2*(q^2-q+1)*(q^2+q+1)*(q-1)^2*(q^2+1),
	q^4*(q-1)^3*(q+1)^3*(q^2-q+1)*(q^2+q+1)*(q^2+1),
	1//2*q^6*(q-1)^3*(q+1)^3*(q^2-q+1)*(q^2+q+1)*(q^2+1),
	1//2*q^6*(q-1)^3*(q+1)^3*(q^2-q+1)*(q^2+q+1)*(q^2+1),
	(q+1)*(q^2-q+1)*(q^2+q+1)*q^5,
	q^5*(q+1)^2*(q^2-q+1)*(q^2+q+1)*(q^2+1)*(q-1),
	q^5*(q+1)^2*(q^2-q+1)*(q^2+q+1)*(q^2+1)*(q-1),
	(q-1)^2*(q+1)^3*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^5,
	1//2*(q-1)^2*(q+1)^3*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^7,
	1//2*(q-1)^2*(q+1)^3*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^7,
	(q-1)*(q^2-q+1)*(q^2+q+1)*q^5,
	q^5*(q+1)*(q^2-q+1)*(q^2+q+1)*(q-1)^2*(q^2+1),
	q^5*(q+1)*(q^2-q+1)*(q^2+q+1)*(q-1)^2*(q^2+1),
	(q-1)^3*(q+1)^2*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^5,
	1//2*(q-1)^3*(q+1)^2*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^7,
	1//2*(q-1)^3*(q+1)^2*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^7,
	q^6*(q+1)^2*(q^2-q+1)*(q^2+1),
	(q+1)^3*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^6*(q-1),
	(q-1)^2*(q+1)^3*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^7,
	(q-1)^2*(q^2+1)*(q^2+q+1)*q^6,
	q^6*(q-1)^3*(q^2+q+1)*(q^2-q+1)*(q^2+1)*(q+1),
	(q-1)^3*(q+1)^2*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^7,
	q^7*(q+1)*(q^2+q+1)*(q^2-q+1)*(q^2+1),
	q^7*(q+1)^2*(q^2+q+1)*(q^2-q+1)*(q^2+1)*(q-1),
	q^7*(q+1)^2*(q^2+q+1)*(q^2-q+1)*(q^2+1)*(q-1),
	(q-1)^2*(q+1)^3*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^7,
	q^7*(q^2+q+1)*(q^2-q+1)*(q-1)*(q^2+1),
	q^7*(q+1)*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	q^7*(q+1)*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	(q-1)^3*(q+1)^2*(q^2+1)*(q^2-q+1)*(q^2+q+1)*q^7,
	(q+1)^2*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^8,
	(q+1)^3*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^8*(q-1),
	(q+1)^2*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^8,
	(q+1)^3*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^8*(q-1),
	(q-1)*(q+1)*q^8*(q^2+q+1)*(q^2-q+1)*(q^2+1),
	q^8*(q+1)^2*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	(q-1)*(q+1)*q^8*(q^2+q+1)*(q^2-q+1)*(q^2+1),
	q^8*(q+1)^2*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	(q-1)*(q+1)*q^8*(q^2+q+1)*(q^2-q+1)*(q^2+1),
	q^8*(q+1)^2*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	(q-1)*(q+1)*q^8*(q^2+q+1)*(q^2-q+1)*(q^2+1),
	q^8*(q+1)^2*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	q^8*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	q^8*(q-1)^3*(q^2+q+1)*(q^2-q+1)*(q^2+1)*(q+1),
	(q-1)^2*(q+1)^2*(q^2+q+1)*(q^2-q+1)*q^8,
	(q-1)^3*(q+1)^3*(q^2-q+1)*(q^2+q+1)*q^8,
	q^8*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q^2+1),
	q^8*(q-1)^3*(q^2+q+1)*(q^2-q+1)*(q^2+1)*(q+1),
	q^9*(q+1)^3*(q^2+q+1)*(q^2-q+1)*(q^2+1),
	(q+1)^2*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^9*(q-1),
	(q+1)^2*(q^2+1)*(q^2+q+1)*(q^2-q+1)*q^9*(q-1),
	(q+1)*(q^2+q+1)*(q^2-q+1)*q^9*(q-1)^2*(q^2+1),
	(q+1)*(q^2+q+1)*(q^2-q+1)*q^9*(q-1)^2*(q^2+1),
	(q+1)^3*(q^2+q+1)*(q^2-q+1)*q^9*(q-1)^2,
	(q+1)^3*(q^2-q+1)*q^9*(q-1)^2*(q^2+1),
	q^9*(q-1)^3*(q^2+q+1)*(q^2-q+1)*(q^2+1),
	(q-1)^3*(q^2+q+1)*(q^2-q+1)*q^9*(q+1)^2,
	(q-1)^3*(q^2+q+1)*q^9*(q+1)^2*(q^2+1)])
charinfo = Vector{Any}[
	[1,[1,1]],
	[2,[1,2]],
	[3,[1,3]],
	[4,[1,4]],
	[5,[1,5]],
	[6,[1,6]],
	[7,[1,7]],
	[8,[1,8]],
	[9,[1,9]],
	[10,[1,10]],
	[11,[1,11]],
	[12,[1,12]],
	[13,[6,1]],
	[14,[6,2]],
	[15,[6,3]],
	[16,[6,4]],
	[17,[6,5]],
	[18,[6,6]],
	[19,[7,1]],
	[20,[7,2]],
	[21,[7,3]],
	[22,[7,4]],
	[23,[7,5]],
	[24,[7,6]],
	[25,[8,1]],
	[26,[8,2]],
	[27,[8,3]],
	[28,[9,1]],
	[29,[9,2]],
	[30,[9,3]],
	[31,[11,1]],
	[32,[11,2]],
	[33,[11,3]],
	[34,[11,4]],
	[35,[13,1]],
	[36,[13,2]],
	[37,[13,3]],
	[38,[13,4]],
	[39,[16,1]],
	[40,[16,2]],
	[41,[17,1]],
	[42,[17,2]],
	[43,[18,1]],
	[44,[18,2]],
	[45,[19,1]],
	[46,[19,2]],
	[47,[20,1]],
	[48,[20,2]],
	[49,[21,1]],
	[50,[21,2]],
	[51,[22,1]],
	[52,[22,2]],
	[53,[23,1]],
	[54,[23,2]],
	[55,[24,1]],
	[56,[24,2]],
	[57,[25,1]],
	[58,[26,1]],
	[59,[27,1]],
	[60,[28,1]],
	[61,[29,1]],
	[62,[30,1]],
	[63,[31,1]],
	[64,[32,1]],
	[65,[33,1]],
	[66,[34,1]]]
chardegree = R.([
	1,
	1//2*q*(q^2+1)*(q^2+q+1),
	1//2*q*(q^2+1)*(q^2-q+1),
	1//2*q*(q^2-q+1)*(q+1)^2,
	1//2*q*(q^2+q+1)*(q-1)^2,
	q^2*(q^2-q+1)*(q^2+q+1),
	q^3*(q^2-q+1)*(q^2+q+1),
	1//2*q^4*(q^2+1)*(q^2+q+1),
	1//2*q^4*(q^2-q+1)*(q+1)^2,
	1//2*q^4*(q^2-q+1)*(q^2+1),
	1//2*q^4*(q^2+q+1)*(q-1)^2,
	q^9,
	(q+1)*(q^2+q+1)*(q^2-q+1),
	1//2*q*(q^2+q+1)*(q^2-q+1)*(q+1)^3,
	1//2*q*(q+1)*(q^2+1)*(q^2+q+1)*(q^2-q+1),
	1//2*q*(q+1)*(q^2+1)*(q^2+q+1)*(q^2-q+1),
	1//2*q*(q+1)*(q^2+q+1)*(q^2-q+1)*(q-1)^2,
	q^4*(q+1)*(q^2+q+1)*(q^2-q+1),
	(q-1)*(q^2-q+1)*(q^2+q+1),
	1//2*q*(q-1)*(q^2-q+1)*(q^2+q+1)*(q+1)^2,
	1//2*q*(q-1)*(q^2+1)*(q^2+q+1)*(q^2-q+1),
	1//2*q*(q-1)*(q^2+1)*(q^2+q+1)*(q^2-q+1),
	1//2*q*(q^2+q+1)*(q^2-q+1)*(q-1)^3,
	q^4*(q-1)*(q^2-q+1)*(q^2+q+1),
	(q+1)^2*(q^2+1)*(q^2-q+1),
	q*(q^2+1)*(q^2-q+1)*(q+1)^3,
	q^3*(q+1)^2*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q^2+q+1)*(q^2+1),
	q*(q^2+1)*(q^2+q+1)*(q-1)^3,
	q^3*(q-1)^2*(q^2+q+1)*(q^2+1),
	(q+1)*(q^2+1)*(q^2-q+1)*(q^2+q+1),
	q*(q+1)*(q^2+1)*(q^2+q+1)*(q^2-q+1),
	q*(q+1)*(q^2+1)*(q^2+q+1)*(q^2-q+1),
	q^2*(q+1)*(q^2+1)*(q^2-q+1)*(q^2+q+1),
	(q-1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	q*(q-1)*(q^2+1)*(q^2+q+1)*(q^2-q+1),
	q*(q-1)*(q^2+1)*(q^2+q+1)*(q^2-q+1),
	q^2*(q-1)*(q^2-q+1)*(q^2+1)*(q^2+q+1),
	(q^2+1)*(q^2+q+1)*(q^2-q+1)*(q+1)^2,
	q*(q^2+1)*(q^2+q+1)*(q^2-q+1)*(q+1)^2,
	(q^2+1)*(q^2+q+1)*(q^2-q+1)*(q+1)^2,
	q*(q^2+1)*(q^2+q+1)*(q^2-q+1)*(q+1)^2,
	(q+1)*(q^2-q+1)*(q^2+q+1)*(q-1)*(q^2+1),
	q*(q+1)*(q^2-q+1)*(q^2+q+1)*(q-1)*(q^2+1),
	(q+1)*(q^2-q+1)*(q^2+q+1)*(q-1)*(q^2+1),
	q*(q+1)*(q^2-q+1)*(q^2+q+1)*(q-1)*(q^2+1),
	(q+1)*(q^2-q+1)*(q^2+q+1)*(q-1)*(q^2+1),
	q*(q+1)*(q^2-q+1)*(q^2+q+1)*(q-1)*(q^2+1),
	(q+1)*(q^2-q+1)*(q^2+q+1)*(q-1)*(q^2+1),
	q*(q+1)*(q^2-q+1)*(q^2+q+1)*(q-1)*(q^2+1),
	(q^2+1)*(q^2-q+1)*(q^2+q+1)*(q-1)^2,
	q*(q^2+1)*(q^2-q+1)*(q^2+q+1)*(q-1)^2,
	(q^2+1)*(q^2-q+1)*(q^2+q+1)*(q-1)^2,
	q*(q^2+1)*(q^2-q+1)*(q^2+q+1)*(q-1)^2,
	(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q+1)^2,
	q*(q^2+q+1)*(q^2-q+1)*(q-1)^2*(q+1)^2,
	(q+1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)*(q+1)^2*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)*(q+1)^2*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q+1)*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q+1)*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^2*(q+1)^3*(q^2+q+1)*(q^2-q+1),
	(q-1)^2*(q+1)^3*(q^2+1)*(q^2-q+1),
	(q-1)^3*(q^2+q+1)*(q^2+1)*(q^2-q+1),
	(q-1)^3*(q+1)^2*(q^2+q+1)*(q^2-q+1),
	(q-1)^3*(q+1)^2*(q^2+q+1)*(q^2+1)])

classsums=[
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	(1//2*zw1, e1)
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [-i2])
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 1, q-2, congruence)
	(1//8*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [-i2])
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 1, q-2, congruence)
	(1//8*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [-i2])
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 1, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [-i2])
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 1, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	zw1,e2=nesum(zw1, i2, 1, q, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	zw1,e2=nesum(zw1, i2, 1, q, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i1*(q+1)])
	s2=eesubs(tt, [i1], [i1*(q-1)])
	s1,e1=nesum(s1, i1, 1, q-2, congruence)
	s2,e2=nesum(s2, i1, 1, q, congruence)
	zw1,e3=nesum(tt, i1, 1, q^2-2, congruence)
	zw1=zw1-s1-s2
	(1//4*zw1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i1*(q+1)])
	s2=eesubs(tt, [i1], [i1*(q-1)])
	s1,e1=nesum(s1, i1, 1, q-2, congruence)
	s2,e2=nesum(s2, i1, 1, q, congruence)
	zw1,e3=nesum(tt, i1, 1, q^2-2, congruence)
	zw1=zw1-s1-s2
	(1//4*zw1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	zw1,e2=nesum(zw1, i2, 1, q, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	zw1,e2=nesum(zw1, i2, 1, q, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	zw1,e2=nesum(zw1, i2, 1, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	zw1,e2=nesum(zw1, i2, 1, q-2, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [-i2])
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 1, q, congruence)
	(1//8*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [-i2])
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 1, q, congruence)
	(1//8*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q^2, congruence)
	(1//4*zw1, e1)
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q^2, congruence)
	(1//4*zw1, e1)
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [-i2])
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 1, q, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [-i2])
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 1, q, congruence)
	(1//4*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i3], [i1])
	s2=eesubs(tt, [i3], [-i1])
	s3=eesubs(tt, [i3], [i2])
	s4=eesubs(tt, [i3], [-i2])
	zw1,e1=nesum(tt, i3, 1, q-2, congruence)
	zw1=zw1-s1-s2-s3-s4
	s1=eesubs(zw1, [i2], [i1])
	s2=eesubs(zw1, [i2], [-i1])
	zw1,e2=nesum(zw1, i2, 1, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e3=nesum(zw1, i1, 1, q-2, congruence)
	(1//48*zw1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i2])
	s2=eesubs(tt, [i1], [-i2])
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	zw1=zw1-s1-s2
	zw1,e2=nesum(zw1, i2, 1, q-2, congruence)
	zw1,e3=nesum(zw1, i3, 1, q, congruence)
	(1//16*zw1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i1*(q+1)])
	s2=eesubs(tt, [i1], [i1*(q-1)])
	s1,e1=nesum(s1, i1, 1, q-2, congruence)
	s2,e2=nesum(s2, i1, 1, q, congruence)
	zw1,e3=nesum(tt, i1, 1, q^2-2, congruence)
	zw1=zw1-s1-s2
	zw1,e4=nesum(zw1, i2, 1, q-2, congruence)
	(1//8*zw1, union(e1,e2,e3,e4))
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	s1=eesubs(zw1, [i2], [i3])
	s2=eesubs(zw1, [i2], [-i3])
	zw1,e2=nesum(zw1, i2, 1, q, congruence)
	zw1=zw1-s1-s2
	zw1,e3=nesum(zw1, i3, 1, q, congruence)
	(1//16*zw1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i1*(q+1)])
	s2=eesubs(tt, [i1], [i1*(q-1)])
	s1,e1=nesum(s1, i1, 1, q-2, congruence)
	s2,e2=nesum(s2, i1, 1, q, congruence)
	zw1,e3=nesum(tt, i1, 1, q^2-2, congruence)
	zw1=zw1-s1-s2
	zw1,e4=nesum(zw1, i2, 1, q, congruence)
	(1//8*zw1, union(e1,e2,e3,e4))
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q-2, congruence)
	zw1,e2=nesum(zw1, i2, 1, q^2, congruence)
	(1//8*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i1*(q^2+q+1)])
	s1,e1=nesum(s1, i1, 0, q-2, congruence)
	zw1,e2=nesum(tt, i1, 0, q^3-2, congruence)
	(1//6*zw1-1//6*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i3])
	s2=eesubs(tt, [i1], [-i3])
	s3=eesubs(tt, [i1], [i2])
	s4=eesubs(tt, [i1], [-i2])
	zw1,e1=nesum(tt, i1, 1, q, congruence)
	zw1=zw1-s1-s2-s3-s4
	s1=eesubs(zw1, [i2], [i3])
	s2=eesubs(zw1, [i2], [-i3])
	zw1,e2=nesum(zw1, i2, 1, q, congruence)
	zw1=zw1-s1-s2
	zw1,e3=nesum(zw1, i3, 1, q, congruence)
	(1//48*zw1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	zw1,e1=nesum(tt, i1, 1, q^2, congruence)
	zw1,e2=nesum(zw1, i2, 1, q, congruence)
	(1//8*zw1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [i1], [i1*(q^2-q+1)])
	s1,e1=nesum(s1, i1, 0, q, congruence)
	zw1,e2=nesum(tt, i1, 0, q^3, congruence)
	(1//6*zw1-1//6*s1, union(e1,e2))
end
]

charsums=[
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	(tt, Set{ParameterException{QQPolyRingElem}}())
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q, congruence)
	(1//2*s1, e1)
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [k2])
	s2=eesubs(tt, [k1], [-k2])
	s3,e1=nesum(tt, k1, 1, q-2, congruence)
	s3=s3-s2-s1
	s3,e2=nesum(s3, k2, 1, q-2, congruence)
	(1//4*s3, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [k2])
	s2=eesubs(tt, [k1], [-k2])
	s3,e1=nesum(tt, k1, 1, q-2, congruence)
	s3=s3-s2-s1
	s3,e2=nesum(s3, k2, 1, q-2, congruence)
	(1//4*s3, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [k2])
	s2=eesubs(tt, [k1], [-k2])
	s3,e1=nesum(tt, k1, 1, q-2, congruence)
	s3=s3-s2-s1
	s3,e2=nesum(s3, k2, 1, q-2, congruence)
	(1//8*s3, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [k2])
	s2=eesubs(tt, [k1], [-k2])
	s3,e1=nesum(tt, k1, 1, q-2, congruence)
	s3=s3-s2-s1
	s3,e2=nesum(s3, k2, 1, q-2, congruence)
	(1//8*s3, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	s1,e2=nesum(s1, k2, 1, q, congruence)
	(1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	s1,e2=nesum(s1, k2, 1, q, congruence)
	(1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [k1*(q-1)])
	s1,e1=nesum(s1, k1, 1, q, congruence)
	s2=eesubs(tt, [k1], [k1*(q+1)])
	s2,e2=nesum(s2, k1, 1, q-2, congruence)
	s3,e3=nesum(tt, k1, 1, q^2-2, congruence)
	s3=s3-s2-s1
	(1//4*s3, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [k1*(q-1)])
	s1,e1=nesum(s1, k1, 1, q, congruence)
	s2=eesubs(tt, [k1], [k1*(q+1)])
	s2,e2=nesum(s2, k1, 1, q-2, congruence)
	s3,e3=nesum(tt, k1, 1, q^2-2, congruence)
	s3=s3-s2-s1
	(1//4*s3, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	s1,e2=nesum(s1, k2, 1, q, congruence)
	(1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	s1,e2=nesum(s1, k2, 1, q, congruence)
	(1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q, congruence)
	s1,e2=nesum(s1, k2, 1, q-2, congruence)
	(1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q, congruence)
	s1,e2=nesum(s1, k2, 1, q-2, congruence)
	(1//4*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [k2])
	s2=eesubs(tt, [k1], [-k2])
	s3,e1=nesum(tt, k1, 1, q, congruence)
	s3=s3-s2-s1
	s3,e2=nesum(s3, k2, 1, q, congruence)
	(1//4*s3, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [k2])
	s2=eesubs(tt, [k1], [-k2])
	s3,e1=nesum(tt, k1, 1, q, congruence)
	s3=s3-s2-s1
	s3,e2=nesum(s3, k2, 1, q, congruence)
	(1//4*s3, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [k2])
	s2=eesubs(tt, [k1], [-k2])
	s3,e1=nesum(tt, k1, 1, q, congruence)
	s3=s3-s2-s1
	s3,e2=nesum(s3, k2, 1, q, congruence)
	(1//8*s3, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [k2])
	s2=eesubs(tt, [k1], [-k2])
	s3,e1=nesum(tt, k1, 1, q, congruence)
	s3=s3-s2-s1
	s3,e2=nesum(s3, k2, 1, q, congruence)
	(1//8*s3, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q^2, congruence)
	(1//4*s1, e1)
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q^2, congruence)
	(1//4*s1, e1)
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [k2])
	s2=eesubs(tt, [k1], [-k2])
	s3=eesubs(tt, [k1], [k3])
	s4=eesubs(tt, [k1], [-k3])
	s5,e1=nesum(tt, k1, 1, q-2, congruence)
	s5=s5-s4-s3-s2-s1
	s1=eesubs(s5, [k2], [k3])
	s2=eesubs(s5, [k2], [-k3])
	s3,e2=nesum(s5, k2, 1, q-2, congruence)
	s3=s3-s2-s1
	s3,e3=nesum(s3, k3, 1, q-2, congruence)
	(1//48*s3, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [k2])
	s2=eesubs(tt, [k1], [-k2])
	s3,e1=nesum(tt, k1, 1, q-2, congruence)
	s3=s3-s2-s1
	s3,e2=nesum(s3, k2, 1, q-2, congruence)
	s3,e3=nesum(s3, k3, 1, q, congruence)
	(1//16*s3, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [k1*(q-1)])
	s1,e1=nesum(s1, k1, 1, q, congruence)
	s2=eesubs(tt, [k1], [k1*(q+1)])
	s2,e2=nesum(s2, k1, 1, q-2, congruence)
	s3,e3=nesum(tt, k1, 1, q^2-2, congruence)
	s3=s3-s2-s1
	s3,e4=nesum(s3, k2, 1, q-2, congruence)
	(1//8*s3, union(e1,e2,e3,e4))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	s2=eesubs(s1, [k2], [k3])
	s3=eesubs(s1, [k2], [-k3])
	s1,e2=nesum(s1, k2, 1, q, congruence)
	s1=s1-s3-s2
	s1,e3=nesum(s1, k3, 1, q, congruence)
	(1//16*s1, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [k1*(q-1)])
	s1,e1=nesum(s1, k1, 1, q, congruence)
	s2=eesubs(tt, [k1], [k1*(q+1)])
	s2,e2=nesum(s2, k1, 1, q-2, congruence)
	s3,e3=nesum(tt, k1, 1, q^2-2, congruence)
	s3=s3-s2-s1
	s3,e4=nesum(s3, k2, 1, q, congruence)
	(1//8*s3, union(e1,e2,e3,e4))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q-2, congruence)
	s1,e2=nesum(s1, k2, 1, q^2, congruence)
	(1//8*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [(q^2+q+1)*k1])
	s1,e1=nesum(s1, k1, 0, q-2, congruence)
	s2,e2=nesum(tt, k1, 0, q^3-2, congruence)
	s2=s2-s1
	(1//6*s2, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [k2])
	s2=eesubs(tt, [k1], [-k2])
	s3=eesubs(tt, [k1], [k3])
	s4=eesubs(tt, [k1], [-k3])
	s5,e1=nesum(tt, k1, 1, q, congruence)
	s5=s5-s4-s3-s2-s1
	s1=eesubs(s5, [k2], [k3])
	s2=eesubs(s5, [k2], [-k3])
	s5,e2=nesum(s5, k2, 1, q, congruence)
	s5=s5-s2-s1
	s5,e3=nesum(s5, k3, 1, q, congruence)
	(1//48*s5, union(e1,e2,e3))
end,
function (tt::Cyclotomic)
	s1,e1=nesum(tt, k1, 1, q^2, congruence)
	s1,e2=nesum(s1, k2, 1, q, congruence)
	(1//8*s1, union(e1,e2))
end,
function (tt::Cyclotomic)
	s1=eesubs(tt, [k1], [(q^2-q+1)*k1])
	s1,e1=nesum(s1, k1, 0, q, congruence)
	s2,e2=nesum(tt, k1, 0, q^3, congruence)
	s2=s2-s1
	(1//6*s2, union(e1,e2))
end
]

classparams=[
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], [ParameterException((i1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], [ParameterException((i1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], [ParameterException((i1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], [ParameterException((i1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], [ParameterException((i1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], [ParameterException((i1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1)], [ParameterException((i1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1)], [ParameterException((i1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1)], [ParameterException((i1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1)], [ParameterException((i1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1)], [ParameterException((i1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1)], [ParameterException((i1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], [ParameterException((i1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], [ParameterException((i1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], [ParameterException((i1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1)], [ParameterException((i1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1)], [ParameterException((i1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1)], [ParameterException((i1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], [ParameterException((i1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], [ParameterException((i1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], [ParameterException((i1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1)], [ParameterException((i1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1)], [ParameterException((i1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1)], [ParameterException((i1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1)], [ParameterException((i1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1)], [ParameterException((i1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q-1))), ParameterException((i1+i2)*1//((q-1))), ParameterException((i1)*1//(q-1)), ParameterException((i2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q-1))), ParameterException((i1+i2)*1//((q-1))), ParameterException((i1)*1//(q-1)), ParameterException((i2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q-1))), ParameterException((i1+i2)*1//((q-1))), ParameterException((i1)*1//(q-1)), ParameterException((i2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1)], [ParameterException((i1-i2)*1//((q-1))), ParameterException((i1+i2)*1//((q-1))), ParameterException((i1)*1//(q-1)), ParameterException((i2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q+1)], [ParameterException((i1)*1//(q-1)), ParameterException((i2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q+1)], [ParameterException((i1)*1//(q-1)), ParameterException((i2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^2-1)], [ParameterException((i1)*1//(q+1)), ParameterException((i1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^2-1)], [ParameterException((i1)*1//(q+1)), ParameterException((i1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q+1)], [ParameterException((i1)*1//(q-1)), ParameterException((i2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q+1)], [ParameterException((i1)*1//(q-1)), ParameterException((i2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q-1)], [ParameterException((i1)*1//(q+1)), ParameterException((i2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q-1)], [ParameterException((i1)*1//(q+1)), ParameterException((i2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q+1)], [ParameterException((i1-i2)*1//((q+1))), ParameterException((i1+i2)*1//((q+1))), ParameterException((i1)*1//(q+1)), ParameterException((i2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q+1)], [ParameterException((i1-i2)*1//((q+1))), ParameterException((i1+i2)*1//((q+1))), ParameterException((i1)*1//(q+1)), ParameterException((i2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^2+1)], [ParameterException((i1)*1//(q^2+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^2+1)], [ParameterException((i1)*1//(q^2+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q+1)], [ParameterException((i1-i2)*1//((q+1))), ParameterException((i1+i2)*1//((q+1))), ParameterException((i1)*1//(q+1)), ParameterException((i2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q+1)], [ParameterException((i1-i2)*1//((q+1))), ParameterException((i1+i2)*1//((q+1))), ParameterException((i1)*1//(q+1)), ParameterException((i2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1), Parameter(i3, q-1)], [ParameterException((i1)*1//(q-1)), ParameterException((i2)*1//(q-1)), ParameterException((i3)*1//(q-1)), ParameterException((i1+i2)*1//(q-1)), ParameterException((i1+i3)*1//(q-1)), ParameterException((i2+i3)*1//(q-1)), ParameterException((i1-i2)*1//(q-1)), ParameterException((i1-i3)*1//(q-1)), ParameterException((i2-i3)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q-1), Parameter(i3, q+1)], [ParameterException((i1)*1//(q-1)), ParameterException((i2)*1//(q-1)), ParameterException((i3)*1//(q+1)), ParameterException((i1+i2)*1//(q-1)), ParameterException((i1-i2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^2-1), Parameter(i2, q-1)], [ParameterException((i1)*1//(q-1)), ParameterException((i1)*1//(q+1)), ParameterException((i2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q-1), Parameter(i2, q+1), Parameter(i3, q+1)], [ParameterException((i1)*1//(q-1)), ParameterException((i2)*1//(q+1)), ParameterException((i3)*1//(q+1)), ParameterException((i2+i3)*1//(q+1)), ParameterException((i2-i3)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^2-1), Parameter(i2, q+1)], [ParameterException((i1)*1//(q-1)), ParameterException((i1)*1//(q+1)), ParameterException((i2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^2+1), Parameter(i2, q-1)], [ParameterException((i1)*1//(q^2+1)), ParameterException((i2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^3-1)], [ParameterException((i1)*1//(q^2+q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q+1), Parameter(i2, q+1), Parameter(i3, q+1)], [ParameterException((i1)*1//(q+1)), ParameterException((i2)*1//(q+1)), ParameterException((i3)*1//(q+1)), ParameterException((i1+i2)*1//(q+1)), ParameterException((i1+i3)*1//(q+1)), ParameterException((i2+i3)*1//(q+1)), ParameterException((i1-i2)*1//(q+1)), ParameterException((i1-i3)*1//(q+1)), ParameterException((i2-i3)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^2+1), Parameter(i2, q+1)], [ParameterException((i1)*1//(q^2+1)), ParameterException((i2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(i1, q^3+1)], [ParameterException((i1)*1//(q^2-q+1))], ParameterSubstitution{QQPolyRingElem}[])
]

charparams=[
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters(Parameter{QQPolyRingElem}[], ParameterException{QQPolyRingElem}[], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1)], [ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1)], [ParameterException((k1)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1-k2)*1//((q-1))), ParameterException((k1+k2)*1//((q-1))), ParameterException((k1)*1//(q-1)), ParameterException((k2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1-k2)*1//((q-1))), ParameterException((k1+k2)*1//((q-1))), ParameterException((k1)*1//(q-1)), ParameterException((k2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1-k2)*1//((q-1))), ParameterException((k1+k2)*1//((q-1))), ParameterException((k1)*1//(q-1)), ParameterException((k2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1)], [ParameterException((k1-k2)*1//((q-1))), ParameterException((k1+k2)*1//((q-1))), ParameterException((k1)*1//(q-1)), ParameterException((k2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q+1)], [ParameterException((k1)*1//(q-1)), ParameterException((k2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q+1)], [ParameterException((k1)*1//(q-1)), ParameterException((k2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q^2-1)], [ParameterException((k1)*1//(q+1)), ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q^2-1)], [ParameterException((k1)*1//(q+1)), ParameterException((k1)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q+1)], [ParameterException((k1)*1//(q-1)), ParameterException((k2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q+1)], [ParameterException((k1)*1//(q-1)), ParameterException((k2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q+1)), ParameterException((k2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q+1)), ParameterException((k2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q+1)], [ParameterException((k1-k2)*1//((q+1))), ParameterException((k1+k2)*1//((q+1))), ParameterException((k1)*1//(q+1)), ParameterException((k2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q+1)], [ParameterException((k1-k2)*1//((q+1))), ParameterException((k1+k2)*1//((q+1))), ParameterException((k1)*1//(q+1)), ParameterException((k2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q+1)], [ParameterException((k1-k2)*1//((q+1))), ParameterException((k1+k2)*1//((q+1))), ParameterException((k1)*1//(q+1)), ParameterException((k2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q+1)], [ParameterException((k1-k2)*1//((q+1))), ParameterException((k1+k2)*1//((q+1))), ParameterException((k1)*1//(q+1)), ParameterException((k2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q^2+1)], [ParameterException((k1)*1//(q^2+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q^2+1)], [ParameterException((k1)*1//(q^2+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1), Parameter(k3, q-1)], [ParameterException((k1)*1//(q-1)), ParameterException((k2)*1//(q-1)), ParameterException((k3)*1//(q-1)), ParameterException((k1+k2)*1//(q-1)), ParameterException((k1+k3)*1//(q-1)), ParameterException((k2+k3)*1//(q-1)), ParameterException((k1-k2)*1//(q-1)), ParameterException((k1-k3)*1//(q-1)), ParameterException((k2-k3)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q-1), Parameter(k3, q+1)], [ParameterException((k1)*1//(q-1)), ParameterException((k2)*1//(q-1)), ParameterException((k3)*1//(q+1)), ParameterException((k1+k2)*1//(q-1)), ParameterException((k1-k2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q^2-1), Parameter(k2, q-1)], [ParameterException((k1)*1//(q-1)), ParameterException((k1)*1//(q+1)), ParameterException((k2)*1//(q-1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q+1), Parameter(k3, q+1)], [ParameterException((k1)*1//(q-1)), ParameterException((k2)*1//(q+1)), ParameterException((k3)*1//(q+1)), ParameterException((k2+k3)*1//(q+1)), ParameterException((k2-k3)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q^2-1), Parameter(k2, q+1)], [ParameterException((k1)*1//(q-1)), ParameterException((k1)*1//(q+1)), ParameterException((k2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q-1), Parameter(k2, q^2+1)], [ParameterException((k1)*1//(q-1)), ParameterException((k2)*1//(q^2+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q^3-1)], [ParameterException((k1)*1//(q^2+q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q+1), Parameter(k2, q+1), Parameter(k3, q+1)], [ParameterException((k1)*1//(q+1)), ParameterException((k2)*1//(q+1)), ParameterException((k3)*1//(q+1)), ParameterException((k1+k2)*1//(q+1)), ParameterException((k1+k3)*1//(q+1)), ParameterException((k2+k3)*1//(q+1)), ParameterException((k1-k2)*1//(q+1)), ParameterException((k1-k3)*1//(q+1)), ParameterException((k2-k3)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q^2+1), Parameter(k2, q+1)], [ParameterException((k1)*1//(q^2+1)), ParameterException((k2)*1//(q+1))], ParameterSubstitution{QQPolyRingElem}[]),
Parameters([Parameter(k1, q^3+1)], [ParameterException((k1)*1//(q^2-q+1))], ParameterSubstitution{QQPolyRingElem}[])
]

classparamindex=var_index.([i1,i2,i3])
charparamindex=var_index.([k1,k2,k3])
congruence=R.((0,2))

information = "Information about the generic character table of \$Sp_6(q)\$, \$q\$ even

- CHEVIE-name of the table: ``Sp6.0``

- The computation of this table is explained in:
  {\\sc F.~Lübeck}, Charaktertafeln für die Gruppen
  \$CSp_6(q)\$ mit ungeradem \$q\$ und \$Sp_6(q)\$ mit geradem \$q\$,
  Dissertation, Heidelberg (1993)

- The irreducible characters of \$Sp_6(q)\$ with even \$q\$ were already
  (independently) determined in:
  {\\sc J.~Looker}, The complex irreducible characters of \$Sp(6,q)\$,
  \$q\$ even, Ph. D. Thesis, Department of pure mathematics, University 
  of Sydney  (1977)

- This table is very big. The best way to work with it
  is to produce one time a file in ``Maple-internal-format``
  (in a new cheviem-session say:
> GenCharTab(``Sp6.0``);save ``Sp6_0.m``;quit;
  and ask your system-administrator to copy  the file
  Sp6_0.m into the CHEVIE-directory tables/C3/Sp6_0.m).
  Now you can read in this table with the CHEVIE-command
> GenCharTab(``Sp6_0.m``);
  This is much faster and uses much less memory.

- The first twelve character(type)s are the unipotent characters.
  If you are *only* interested in the unipotent characters, you can
  use the table ``uniSp6.0``, which allows faster calculations.
"

TABLE=CharTable(order,ExtendableMatrix(permutedims(table)),classinfo,classlength,charinfo,chardegree,
	classsums,charsums,classparamindex,charparamindex,classparams,charparams,congruence,R,S,information)
